
/* Drop Tables */

DROP TABLE IF EXISTS CFROOM_RESERVE_DATE;
DROP TABLE IF EXISTS CFROOM_RESERVE;
DROP TABLE IF EXISTS CFROOM_MANAGEMENT;
DROP TABLE IF EXISTS CMMCODE;
DROP TABLE IF EXISTS CMMCODEGEN;
DROP TABLE IF EXISTS COMTECOPSEQ;
DROP TABLE IF EXISTS COMTNFILEDETAIL;
DROP TABLE IF EXISTS COMTNFILE;
DROP TABLE IF EXISTS USER_ROLE_RELATION;
DROP TABLE IF EXISTS DS_USER;
DROP TABLE IF EXISTS DEPT;
DROP TABLE IF EXISTS DOC_EXAM;
DROP TABLE IF EXISTS DOC_OPER;
DROP TABLE IF EXISTS DOC_MANAGEMENT;
DROP TABLE IF EXISTS DS_ENV;
DROP TABLE IF EXISTS DUTY_ROLE_RELATION;
DROP TABLE IF EXISTS MENU_PROGRAM_RELATION;
DROP TABLE IF EXISTS MENU_ROLE_RELATION;
DROP TABLE IF EXISTS MENU;
DROP TABLE IF EXISTS PROCESS;
DROP TABLE IF EXISTS PROGRAM;
DROP TABLE IF EXISTS ROLE;
DROP TABLE IF EXISTS SC_APPROVAL;
DROP TABLE IF EXISTS SC_MAIN;
DROP TABLE IF EXISTS SR_ANSWER_EXAM;
DROP TABLE IF EXISTS SR_DB_EXAM;
DROP TABLE IF EXISTS SR_DB_RESULT;
DROP TABLE IF EXISTS SR_DEV_EXAM;
DROP TABLE IF EXISTS SR_DEV_PROG_EXAM;
DROP TABLE IF EXISTS SR_FINAL_EXAM;
DROP TABLE IF EXISTS SR_SERVICE_EXAM;
DROP TABLE IF EXISTS SR_HISTORY;
DROP TABLE IF EXISTS SR_MAIN;
DROP TABLE IF EXISTS TB_ARCHIVE;
DROP TABLE IF EXISTS TB_DIS_DTL;
DROP TABLE IF EXISTS TB_QA_EXAM_PROD_RQ;
DROP TABLE IF EXISTS TB_QA_EXAM_RQ;
DROP TABLE IF EXISTS TB_REAL_DIS_EXCT_CONF_RQ;
DROP TABLE IF EXISTS TB_REAL_DIS_RSTL;
DROP TABLE IF EXISTS TB_TEST_CONF_TC_RQ;
DROP TABLE IF EXISTS TB_TEST_DIS_EXCT_CONF_RQ;
DROP TABLE IF EXISTS TB_TEST_DIS_FNL_EXAM_RQ;
DROP TABLE IF EXISTS TB_TEST_DIS_RSTL;
DROP TABLE IF EXISTS TB_TEST_DIS_TC_EXAM_RQ;
DROP TABLE IF EXISTS TB_TEST_DIS_TC_RSTL;
DROP TABLE IF EXISTS TB_TEST_EXAM_CONF_RQ;
DROP TABLE IF EXISTS TB_TEST_TC_EXAM_RQ;
DROP TABLE IF EXISTS TB_DIS_HIS;
DROP TABLE IF EXISTS TB_DIS;
DROP TABLE IF EXISTS TB_FAQ;
DROP TABLE IF EXISTS TB_MSG_RECV;
DROP TABLE IF EXISTS TB_MSG;
DROP TABLE IF EXISTS TB_NOTICE;
DROP TABLE IF EXISTS weekly_report_detail;
DROP TABLE IF EXISTS weekly_report;
DROP TABLE IF EXISTS public.project_group;
DROP TABLE IF EXISTS public.project_assigs;
DROP TABLE IF EXISTS public.project_task;
DROP TABLE IF EXISTS public.project;



/* Drop Sequences */

DROP SEQUENCE IF EXISTS public.disno_seq;
DROP SEQUENCE IF EXISTS public.scno_seq;
DROP SEQUENCE IF EXISTS public.srno_seq;
DROP SEQUENCE IF EXISTS public.user_id_seq;
DROP SEQUENCE IF EXISTS public.user_role_id_seq;



/* Drop Tablespaces */

DROP TABLESPACE IF EXISTS TS_DSSDM;




/* Create Tablespaces */

CREATE TABLESPACE TS_DSSDM
 LOCATION 'null'
;



/* Create Sequences */

CREATE SEQUENCE public.disno_seq INCREMENT 1 MINVALUE 1 MAXVALUE 9999 START 137 CACHE 1 CYCLE;
CREATE SEQUENCE public.scno_seq INCREMENT 1 MINVALUE 1 MAXVALUE 9999 START 32 CACHE 1 CYCLE;
CREATE SEQUENCE public.srno_seq INCREMENT 1 MINVALUE 1 MAXVALUE 9999 START 34 CACHE 1;
CREATE SEQUENCE public.user_id_seq INCREMENT 1 MINVALUE 0 MAXVALUE 9999999999999 START 25 CACHE 1;
CREATE SEQUENCE public.user_role_id_seq INCREMENT 1 MINVALUE 0 MAXVALUE 99999999999999 START 112 CACHE 1;



/* Create Tables */

CREATE TABLE CFROOM_MANAGEMENT
(
	CF_NO int NOT NULL,
	CF_NAME varchar(255),
	CF_PERSON int,
	OPEN_STIME char(5),
	OPEN_ETIME char(5),
	CF_PLACE1 varchar(3),
	CF_PLACE2 varchar(255),
	REG_ID char(13),
	REG_DTTM date,
	DEL_YN char(1) NOT NULL,
	MOD_DTTM date,
	ADD_FILE_ID varchar(20),
	PRIMARY KEY (CF_NO)
) WITHOUT OIDS;


CREATE TABLE CFROOM_RESERVE
(
	RV_NO int NOT NULL,
	TITLE varchar(255) NOT NULL,
	CF_NO int,
	REPEAT char(3),
	SDATE date,
	EDATE date,
	ATTEND int,
	CONTENT varchar(1000) NOT NULL,
	RV_USERID char(13),
	RV_DTTM date,
	DEL_YN char(1),
	MOD_DTTM date,
	CF_NO int NOT NULL,
	PRIMARY KEY (RV_NO)
) WITHOUT OIDS;


CREATE TABLE CFROOM_RESERVE_DATE
(
	RV_NO int NOT NULL,
	DATE date NOT NULL,
	SDATETIME char(5) NOT NULL,
	EDATETIME char(5) NOT NULL,
	PRIMARY KEY (RV_NO, DATE, SDATETIME, EDATETIME)
) WITHOUT OIDS;


CREATE TABLE CMMCODE
(
	CODE_ID char(6) NOT NULL,
	CODE varchar(15) NOT NULL,
	CODE_CTN varchar(1000),
	CODE_SHTNM varchar(50),
	CODE_REM varchar(20),
	USE_YN char(1),
	SORT_ORDER char(2),
	DEL_YN char(1),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (CODE_ID, CODE)
) WITHOUT OIDS;


CREATE TABLE CMMCODEGEN
(
	CODE_ID char(6) NOT NULL,
	CODE_NM varchar(60),
	CODE_LEN int,
	CODE_USE_EXP varchar(100),
	CODE_USE_YN char(1),
	DEL_YN char(1),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (CODE_ID)
) WITHOUT OIDS;


CREATE TABLE COMTECOPSEQ
(
	TABLE_NAME char(16) NOT NULL,
	NEXT_ID numeric(30,0),
	PRIMARY KEY (TABLE_NAME)
) WITHOUT OIDS;


CREATE TABLE COMTNFILE
(
	ATCH_FILE_ID char(20) NOT NULL,
	CREAT_DT date,
	USE_AT char(1),
	PRIMARY KEY (ATCH_FILE_ID)
) WITHOUT OIDS;


CREATE TABLE COMTNFILEDETAIL
(
	ATCH_FILE_ID char(20) NOT NULL,
	FILE_SN varchar(10) NOT NULL,
	FILE_STRE_COURS varchar(2000),
	STRE_FILE_NM varchar(255),
	ORIGNL_FILE_NM varchar(255),
	FILE_EXTSN varchar(20),
	FILE_CN text,
	FILE_SIZE varchar(20),
	PRIMARY KEY (ATCH_FILE_ID, FILE_SN)
) WITHOUT OIDS;


CREATE TABLE DEPT
(
	DEPT_ID char(14) NOT NULL,
	DEPT_NAME varchar,
	UPPER_DEPT_ID char(14) NOT NULL,
	DEL_YN char(1),
	SORT_INDEX int,
	PRIMARY KEY (DEPT_ID)
) WITHOUT OIDS;


CREATE TABLE DOC_EXAM
(
	NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	GBN char(3) NOT NULL,
	OPI varchar(1000),
	REG_ID char(13),
	REG_DTTM date,
	complete char(1),
	PRIMARY KEY (NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE DOC_MANAGEMENT
(
	NO char(14) NOT NULL,
	JOB_CD char(14) NOT NULL,
	DOC_GBN char(3) NOT NULL,
	USER_ID char(13) NOT NULL,
	CHARGER char(13) NOT NULL,
	DATE date NOT NULL,
	SEND_GD varchar(100),
	RECEIVE_GD varchar(100),
	CONFERENCE_ATTENDEE varchar(100),
	CONFERENCE_AREA varchar(100),
	TITLE varchar(255) NOT NULL,
	CONTENT varchar(1000) NOT NULL,
	GBN char(3),
	REL_NO char(14),
	DOC_TYPE char(3)[],
	NOTES varchar(1000),
	ADD_FILE_ID varchar(20),
	OPER_YN char(1),
	REG_ID char(13),
	REG_DTTM date,
	MOD_ID char(13),
	MOD_DTTM date,
	DOC_NO varchar(50) NOT NULL,
	APPROVAL_YN char(1),
	STATUS char(3),
	OPER_ID char(13),
	OPER_DTTM date,
	PRIMARY KEY (NO)
) WITHOUT OIDS;


CREATE TABLE DOC_OPER
(
	NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	GBN char(3) NOT NULL,
	OPI varchar(1000),
	REG_ID char(13),
	REG_DTTM date,
	PRIMARY KEY (NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE DS_ENV
(
	ENV_NAME varchar(500) NOT NULL,
	ENV_VALUE varchar(1000),
	ENV_DESCRIPTION char(4000),
	SORT_INDEX int,
	PRIMARY KEY (ENV_NAME)
) WITHOUT OIDS;


CREATE TABLE DS_USER
(
	USER_ID char(13) NOT NULL UNIQUE,
	LOGIN_ID varchar(20),
	LOGIN_PASSWORD varchar(100),
	NAME varchar(50),
	DEPT_ID char(14),
	RANK_CD char(3),
	TEL varchar(20),
	HP varchar(20),
	EMAIL varchar(100),
	JOB_CD char(3)[],
	DUTY_CD char(3),
	JOIN_DATE date,
	APPROVE_YN char(1),
	APPROVE_DATE timestamp,
	DEL_YN char(1),
	WITHDRAW_DATE date,
	RESET_PASSWORD varchar(100),
	MOD_DTTM timestamp,
	MOD_ID varchar(14),
	BIRTH_YMD char(10),
	BIRTH_CALENDAR char(1),
	PRIMARY KEY (USER_ID)
) WITHOUT OIDS TABLESPACE TS_DSSDM;


CREATE TABLE DUTY_ROLE_RELATION
(
	DUTY_ROLE_ID char(14) NOT NULL,
	DUTY_CD char(3),
	ROLL_ID char(14),
	PRIMARY KEY (DUTY_ROLE_ID)
) WITHOUT OIDS TABLESPACE TS_DSSDM;


CREATE TABLE MENU
(
	MENU_ID char(13) NOT NULL,
	MENU_NAME varchar(100),
	MENU_COMMENT varchar(1000),
	UPPER_MENU_ID char(13) NOT NULL,
	DEL_YN char(1),
	SORT_INDEX int,
	PRIMARY KEY (MENU_ID)
) WITHOUT OIDS;


CREATE TABLE MENU_PROGRAM_RELATION
(
	MENU_PROGRAM_ID char(14) NOT NULL,
	MENU_ID char(13) NOT NULL,
	PROGRAM_ID char(13) NOT NULL,
	DEL_YN char(1),
	PRIMARY KEY (MENU_PROGRAM_ID)
) WITHOUT OIDS;


CREATE TABLE MENU_ROLE_RELATION
(
	MENU_ROLE_ID char(14) NOT NULL,
	MENU_ID char(13) NOT NULL,
	ROLE_ID char(10) NOT NULL,
	INSERT_YN char(1),
	READ_YN char(1),
	UPDATE_YN char(1),
	DELETE_YN char(1),
	DEL_YN char(1),
	PRIMARY KEY (MENU_ROLE_ID)
) WITHOUT OIDS;


CREATE TABLE PROCESS
(
	SDGBN varchar(5) NOT NULL,
	CURR_STEP char(3) NOT NULL,
	GBN char(3) NOT NULL,
	NEXT_STEP char(3),
	TB_NAME varchar(100),
	PAGE_URL varchar(2000),
	ROLE_ID char(10),
	PRIMARY KEY (SDGBN, CURR_STEP, GBN)
) WITHOUT OIDS;


CREATE TABLE PROGRAM
(
	PROGRAM_ID char(13) NOT NULL,
	PROGRAM_NAME varchar(200) NOT NULL,
	PROGRAM_COMMENT varchar(1000),
	PROGRAM_URL varchar(500),
	PROGRAM_POPUP_YN char(1),
	DEL_YN char(1),
	PRIMARY KEY (PROGRAM_ID)
) WITHOUT OIDS;


CREATE TABLE ROLE
(
	ROLE_ID char(10) NOT NULL,
	ROLE_NAME varchar(50),
	ROLE_COMMENT varchar(1000),
	UPPER_ROLE_ID char(10) NOT NULL,
	DEL_YN char(1),
	PRIMARY KEY (ROLE_ID)
) WITHOUT OIDS;


CREATE TABLE SC_APPROVAL
(
	SC_NO char(14) NOT NULL,
	STATUS char(3),
	OPI varchar(255),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (SC_NO)
) WITHOUT OIDS;


CREATE TABLE SC_MAIN
(
	SC_NO char(14) NOT NULL,
	SC_GBN char(3),
	SC_TIT varchar(255),
	SC_SDATE char(5),
	SC_EDATE char(5),
	SC_CONT varchar(1000),
	USER_ID char(13),
	REG_DTHR date,
	APPROVAL_YN char(1),
	MOD_ID char(13),
	MOD_DTTM timestamp,
	PRIMARY KEY (SC_NO)
) WITHOUT OIDS;


CREATE TABLE SR_ANSWER_EXAM
(
	SR_NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	-- 1. 승인
	-- 2. 반려
	GBN char(1),
	OPI varchar(1000),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (SR_NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE SR_DB_EXAM
(
	SR_NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	GBN char(1),
	OPI varchar(1000),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (SR_NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE SR_DB_RESULT
(
	SR_NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	RSTL varchar(1000),
	ADD_FILE_ID varchar(20),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (SR_NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE SR_DEV_EXAM
(
	SR_NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	GBN char(1),
	OPI varchar(1000),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (SR_NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE SR_DEV_PROG_EXAM
(
	SR_NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	GBN char(1),
	OPI varchar(1000),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (SR_NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE SR_FINAL_EXAM
(
	SR_NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	GBN char(1),
	OPI varchar(1000),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (SR_NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE SR_HISTORY
(
	SR_NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	STATUS char(3),
	USER_ID char(13),
	REG_DTHR timestamp,
	MOD_DTTM timestamp,
	MOD_ID char(13),
	PRIMARY KEY (SR_NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE SR_MAIN
(
	SR_NO char(14) NOT NULL,
	USER_ID varchar(14),
	TITLE varchar(255),
	CONTENT varchar(1000),
	LAST_STA char(3),
	ADD_FILE_ID varchar(20),
	DIS_DTTM_RQ date,
	ACCEPT_YN char(1),
	JOB_CD char(3),
	ACCEPT_DTTM date,
	hp char(20),
	DEPT_ID char(14),
	RETURN_YN char(1),
	OPEN_YN char(1),
	SR_TYPE char(3),
	SR_RCTYPE char(3),
	USER_ID char(13),
	ACCEPT_ID char(3),
	REL_NO char(14),
	complete_dttm date,
	PRIMARY KEY (SR_NO)
) WITHOUT OIDS;


CREATE TABLE SR_SERVICE_EXAM
(
	SR_NO char(14) NOT NULL,
	SEQ char(4) NOT NULL,
	-- 1. 개발필요건
	-- 2. 단순답변건
	GBN char(1),
	OPI varchar(1000),
	ADD_FILE_ID varchar(20),
	USER_ID char(13),
	REG_DTHR date,
	PRIMARY KEY (SR_NO, SEQ)
) WITHOUT OIDS;


CREATE TABLE TB_ARCHIVE
(
	SID varchar(12) NOT NULL,
	NT_SUBJ varchar(500),
	NT_CONT varchar(4000),
	ADD_FILE_ID varchar(20),
	REGR_ID varchar(14),
	MOD_ID varchar(14),
	REGR_DTTM date,
	MOD_DTTM date,
	DEL_YN char(1),
	PRIMARY KEY (SID)
) WITHOUT OIDS;


CREATE TABLE TB_DIS
(
	DIS_NO varchar(14) NOT NULL,
	DIS_USR char(14) NOT NULL,
	DIS_STAT char(3),
	PRIMARY KEY (DIS_NO)
) WITHOUT OIDS;


CREATE TABLE TB_DIS_DTL
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	JOB_CD varchar(3),
	DEPT_ID varchar(14),
	DIS_TYPE varchar(4),
	DIS_CAUSE varchar(4),
	SR_NO varchar(14),
	DIS_APP varchar(4),
	DIS_APP_CONT varchar(4000),
	DIS_APP_AP_EXP varchar(4000),
	DIS_APP_DB_EXP varchar(4000),
	DIS_APP_WEB_EXP varchar(4000),
	ADD_FILE_ID varchar(20),
	RQ_DTTM timestamp NOT NULL,
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_DIS_HIS
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	DIS_STAT char(3),
	REGR_ID char(14) NOT NULL,
	REGR_DTTM timestamp NOT NULL,
	MOD_DTTM timestamp,
	MOD_ID varchar(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_FAQ
(
	SID varchar(12) NOT NULL,
	NT_SUBJ varchar(500),
	NT_CONT varchar(4000),
	ADD_FILE_ID varchar(20),
	REGR_ID varchar(14),
	MOD_ID varchar(14),
	REGR_DTTM date,
	MOD_DTTM date,
	DEL_YN char(1),
	PRIMARY KEY (SID)
) WITHOUT OIDS;


CREATE TABLE TB_MSG
(
	MSG_ID char(14) NOT NULL,
	SENDER char(14) NOT NULL,
	CONT varchar(4000) NOT NULL,
	ADD_FILE_ID varchar(20),
	SEND_DTTM timestamp,
	TEMP_YN  DEFAULT N,
	DEL_YN char(1) DEFAULT 'N',
	PRIMARY KEY (MSG_ID)
) WITHOUT OIDS;


CREATE TABLE TB_MSG_RECV
(
	MSG_ID char(14) NOT NULL,
	RECEIVER char(14) NOT NULL,
	READ_YN char(1) DEFAULT 'N',
	READ_DTTM timestamp,
	DEL_YN  DEFAULT N,
	PRIMARY KEY (MSG_ID, RECEIVER)
) WITHOUT OIDS;


CREATE TABLE TB_NOTICE
(
	SID varchar(12) NOT NULL,
	NT_SUBJ varchar(500),
	NT_CONT varchar(4000),
	ADD_FILE_ID varchar(20),
	REGR_ID varchar(14),
	MOD_ID varchar(14),
	REGR_DTTM date,
	MOD_DTTM date,
	DISP_STRT_DTTM date,
	DISP_END_DTTM date,
	POP_YN char(1),
	DEL_YN char(1),
	PRIMARY KEY (SID)
) WITHOUT OIDS;


CREATE TABLE TB_QA_EXAM_PROD_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	ADD_FILE_ID varchar(20),
	PROD_TYPE varchar(4) NOT NULL,
	DIS_APP varchar(4),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq, PROD_TYPE)
) WITHOUT OIDS;


CREATE TABLE TB_QA_EXAM_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_REAL_DIS_EXCT_CONF_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_REAL_DIS_RSTL
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_TEST_CONF_TC_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	EXAM_RQ_CONT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_TEST_DIS_EXCT_CONF_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	EXAM_RQ_CONT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_TEST_DIS_FNL_EXAM_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_TEST_DIS_RSTL
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_TEST_DIS_TC_EXAM_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_TEST_DIS_TC_RSTL
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_TEST_EXAM_CONF_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE TB_TEST_TC_EXAM_RQ
(
	DIS_NO varchar(14) NOT NULL,
	seq numeric(4) NOT NULL,
	EXAM_RSTL char(3),
	CMMT varchar(1000),
	REGR_ID char(14),
	PRIMARY KEY (DIS_NO, seq)
) WITHOUT OIDS;


CREATE TABLE USER_ROLE_RELATION
(
	USER_ROLE_ID char(14) NOT NULL,
	USER_ID char(13) NOT NULL UNIQUE,
	ROLE_ID char(10) NOT NULL,
	DEL_YN char(1),
	PRIMARY KEY (USER_ROLE_ID)
) WITHOUT OIDS;


CREATE TABLE weekly_report
(
	week_rpt_id varchar(12) NOT NULL,
	job_cd char(14),
	week_seq int,
	start_time timestamp,
	end_time timestamp,
	USER_ID char(13),
	REGR_DTTM date,
	PRIMARY KEY (week_rpt_id)
) WITHOUT OIDS;


CREATE TABLE weekly_report_detail
(
	week_rpt_id varchar(12) NOT NULL,
	seq numeric(4) DEFAULT 1 NOT NULL,
	NT_SUBJ varchar(500),
	rq_org varchar(100),
	NT_CONT varchar(4000),
	progress int,
	complete_dttm date,
	comp_gbn char(1),
	NOTES varchar(1000),
	PRIMARY KEY (week_rpt_id, seq)
) WITHOUT OIDS;


CREATE TABLE public.project
(
	--  
	projectid varchar(14) NOT NULL,
	name varchar(255),
	user_id varchar(14),
	reg_dthr timestamp,
	del_yn char DEFAULT '''N''::bpchar',
	mod_id varchar(14),
	mod_dttm timestamp,
	CONSTRAINT pk_projectid PRIMARY KEY (projectid)
) WITHOUT OIDS;


CREATE TABLE public.project_assigs
(
	assigid int NOT NULL,
	--  
	projectid varchar(14) NOT NULL,
	taskid int NOT NULL,
	del_yn char DEFAULT '''N''::bpchar',
	sort_order int,
	userid char(3),
	CONSTRAINT project_assigs_pkey PRIMARY KEY (assigid, projectid, taskid)
) WITHOUT OIDS;


CREATE TABLE public.project_group
(
	groupnm varchar(20),
	sort_order int,
	reg_id char(13),
	reg_dttm timestamp,
	--  
	projectid varchar(14) NOT NULL,
	groupid char(3) NOT NULL,
	parentcd char(3),
	user_id char(13),
	del_yn char DEFAULT '''N''::bpchar',
	CONSTRAINT project_group_pkey PRIMARY KEY (projectid, groupid)
) WITHOUT OIDS;


CREATE TABLE public.project_task
(
	name varchar(255),
	progress int DEFAULT 0 NOT NULL,
	description varchar(255),
	code varchar(14),
	level int,
	status varchar(20),
	depends varchar(10),
	start_time timestamp,
	end_time timestamp,
	duration int,
	startismilestone boolean,
	endismilestone boolean,
	sort_order int,
	--  
	projectid varchar(14) NOT NULL,
	haschild boolean DEFAULT 'false',
	del_yn char DEFAULT '''N''::bpchar',
	taskid int NOT NULL,
	CONSTRAINT project_task_pkey PRIMARY KEY (projectid, taskid)
) WITHOUT OIDS;



/* Create Foreign Keys */

ALTER TABLE CFROOM_RESERVE
	ADD FOREIGN KEY (CF_NO)
	REFERENCES CFROOM_MANAGEMENT (CF_NO)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE CFROOM_RESERVE_DATE
	ADD FOREIGN KEY (RV_NO)
	REFERENCES CFROOM_RESERVE (RV_NO)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE CMMCODE
	ADD FOREIGN KEY (CODE_ID)
	REFERENCES CMMCODEGEN (CODE_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE COMTNFILEDETAIL
	ADD FOREIGN KEY (ATCH_FILE_ID)
	REFERENCES COMTNFILE (ATCH_FILE_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE DEPT
	ADD FOREIGN KEY (UPPER_DEPT_ID)
	REFERENCES DEPT (DEPT_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE DS_USER
	ADD FOREIGN KEY (DEPT_ID)
	REFERENCES DEPT (DEPT_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE DOC_EXAM
	ADD FOREIGN KEY (NO)
	REFERENCES DOC_MANAGEMENT (NO)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE DOC_OPER
	ADD FOREIGN KEY (NO)
	REFERENCES DOC_MANAGEMENT (NO)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE USER_ROLE_RELATION
	ADD FOREIGN KEY (USER_ID)
	REFERENCES DS_USER (USER_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE MENU
	ADD FOREIGN KEY (UPPER_MENU_ID)
	REFERENCES MENU (MENU_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE MENU_PROGRAM_RELATION
	ADD FOREIGN KEY (MENU_ID)
	REFERENCES MENU (MENU_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE MENU_ROLE_RELATION
	ADD FOREIGN KEY (MENU_ID)
	REFERENCES MENU (MENU_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE MENU_PROGRAM_RELATION
	ADD FOREIGN KEY (PROGRAM_ID)
	REFERENCES PROGRAM (PROGRAM_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE MENU_ROLE_RELATION
	ADD FOREIGN KEY (ROLE_ID)
	REFERENCES ROLE (ROLE_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE ROLE
	ADD FOREIGN KEY (UPPER_ROLE_ID)
	REFERENCES ROLE (ROLE_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE USER_ROLE_RELATION
	ADD FOREIGN KEY (ROLE_ID)
	REFERENCES ROLE (ROLE_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SC_APPROVAL
	ADD FOREIGN KEY (SC_NO)
	REFERENCES SC_MAIN (SC_NO)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SR_ANSWER_EXAM
	ADD FOREIGN KEY (SR_NO, SEQ)
	REFERENCES SR_HISTORY (SR_NO, SEQ)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SR_DB_EXAM
	ADD FOREIGN KEY (SR_NO, SEQ)
	REFERENCES SR_HISTORY (SR_NO, SEQ)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SR_DB_RESULT
	ADD FOREIGN KEY (SR_NO, SEQ)
	REFERENCES SR_HISTORY (SR_NO, SEQ)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SR_DEV_EXAM
	ADD FOREIGN KEY (SR_NO, SEQ)
	REFERENCES SR_HISTORY (SR_NO, SEQ)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SR_DEV_PROG_EXAM
	ADD FOREIGN KEY (SR_NO, SEQ)
	REFERENCES SR_HISTORY (SR_NO, SEQ)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SR_FINAL_EXAM
	ADD FOREIGN KEY (SR_NO, SEQ)
	REFERENCES SR_HISTORY (SR_NO, SEQ)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SR_SERVICE_EXAM
	ADD FOREIGN KEY (SR_NO, SEQ)
	REFERENCES SR_HISTORY (SR_NO, SEQ)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE SR_HISTORY
	ADD FOREIGN KEY (SR_NO)
	REFERENCES SR_MAIN (SR_NO)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_DIS_HIS
	ADD FOREIGN KEY (DIS_NO)
	REFERENCES TB_DIS (DIS_NO)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_DIS_DTL
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_QA_EXAM_PROD_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_QA_EXAM_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_REAL_DIS_EXCT_CONF_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_REAL_DIS_RSTL
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_TEST_CONF_TC_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_TEST_DIS_EXCT_CONF_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_TEST_DIS_FNL_EXAM_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_TEST_DIS_RSTL
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_TEST_DIS_TC_EXAM_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_TEST_DIS_TC_RSTL
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_TEST_EXAM_CONF_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_TEST_TC_EXAM_RQ
	ADD FOREIGN KEY (DIS_NO, seq)
	REFERENCES TB_DIS_HIS (DIS_NO, seq)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE TB_MSG_RECV
	ADD FOREIGN KEY (MSG_ID)
	REFERENCES TB_MSG (MSG_ID)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE weekly_report_detail
	ADD FOREIGN KEY (week_rpt_id)
	REFERENCES weekly_report (week_rpt_id)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE public.project_group
	ADD FOREIGN KEY (projectid)
	REFERENCES public.project (projectid)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE public.project_task
	ADD FOREIGN KEY (projectid)
	REFERENCES public.project (projectid)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;


ALTER TABLE public.project_assigs
	ADD FOREIGN KEY (projectid, taskid)
	REFERENCES public.project_task (projectid, taskid)
	ON UPDATE RESTRICT
	ON DELETE RESTRICT
;



/* Comments */

COMMENT ON COLUMN SR_ANSWER_EXAM.GBN IS '1. 승인
2. 반려';
COMMENT ON COLUMN SR_SERVICE_EXAM.GBN IS '1. 개발필요건
2. 단순답변건';
COMMENT ON COLUMN public.project.projectid IS ' ';
COMMENT ON COLUMN public.project_assigs.projectid IS ' ';
COMMENT ON COLUMN public.project_group.projectid IS ' ';
COMMENT ON COLUMN public.project_task.projectid IS ' ';



