/**
* Genesis CSR Portal 구축
*
* Copyright (c) 2012 KT
* Seoul, KOREA.
* All right reserved.
**
This software is the confidential and proprietary information of KT,
* Inc.
* ("Confidential Information"). You shall not disclose such Confidential Information and
* shall use it only in accordance with the terms of the license agreement you entered
* into with KT.
**
Revision History
* Author   Date   Description
* ------------------- ---------------- --------------------------
* kim tae ho 2012.11.26 초안
*/
package egovframework.rte.cmmn.helper;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.web.servlet.view.AbstractView;
import egovframework.rte.dsdsm.cmm.service.vo.*;
/**
 * @class JsonView
 * @brief [Mandatory] 이 클래스/인터페이스에 대한 설명을 한 줄로 기술한다.
 *
 * [Optional] 상세설명
 *
 * @brief [Mandatory] 클래스/인터페이스의 주요 기능
 *        [Mandatory] 모듈 수준의 인터페이스에 대한 설명
 *        [Mandatory] 실행 순서
 * @see  [Optional] 관련 정보
 * @version 0.1
 * @author  chuhongjae
 */
public class JsonView extends AbstractView {
	@Override
	protected void renderMergedOutputModel(Map<String, Object> model, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		ObjectMapper om = new ObjectMapper();
		
		StringBuffer gson = new StringBuffer(om.writeValueAsString(model));
		
		logger.debug(gson.toString());
		
		response.setContentType("application/json");
		response.setCharacterEncoding("utf-8");

		response.setHeader("Cache-Control", "no-cache");

		response.setContentLength(gson.toString().getBytes("utf-8").length);

		response.getWriter().print(gson.toString());
		response.flushBuffer();
		response = null;
		gson = null;
		om = null;
	
	}
}
