package egovframework.rte.cmmn.util;



/**
 *  Class Name : Constants.java
 *  Description : 상수값으로 사용할 값 정
 *  Modification Information
 * 
 *     수정일         수정자                   수정내용
 *   -------    --------    ---------------------------
 *   2009.11.16    이동훈          최초 생성
 *
 *  @author 이동훈
 *  @since 2009. 11. 16
 *  @version 1.0
 *  @see 
 * 
 */

public class Constants {
	
	/** 여부 상수 */
	public final static String YES = "Y";
	public final static String NO = "N";
	public final static String DIV_ADD = "A";
	public final static String DIV_UPDATE = "U";

	/** RETURN CODE */
	public static final int SUCCESS = 0;
	public static final int UNKNOWN_ERR = 1;
	public static final int NO_DATA_ERR = 2;
	public static final int INVALID_PARAM_ERR = 3;
	public static final int XML_PARSER_ERR = 4;
	public static final int DATABASE_ACCESS_ERR = 5;
	public static final int DATABASE_TRANSACTION_ERR = 6;
	public static final int BIZ_PROCESS_ERR = 7;
	public static final int ALREADY_EXISTED_ERR = 8;
	
	/** 파일 확장자 관련 */
	/** 제한 확장자 :  doc, xls, pdf, ppt, zip, tar, wsdl */
	public final static String[] UPFILE_EXTENSION_LIMIT = { "txt", 
															"doc",
															"docx",
															"xls",
															"xlsx",
															"pdf",
															"ppt",
															"pptx",
															"zip",
															"tar",
															"wsdl"};

	/** 제한 확장자 :  doc, xls, pdf, ppt, zip, tar, wsdl */
	public final static String[] IMG_UPFILE_EXTENSION_LIMIT = { "jpg",
															  	"jpeg",
															  	"gif",
															  	"png",
															  	"bmp"};
	

	/** 제한 확장자 :  이미지/비이미지 구분없이 모두 체크 */
	public final static String[] ALL_UPFILE_EXTENSION_LIMIT = { "txt", 
																"doc",
																"docx",
																"xls",
																"xlsx",
																"pdf",
																"ppt",
																"pptx",
																"zip",
																"tar",
																"wsdl",
																"jpg",
																"jpeg",
																"gif",
																"png",
																"bmp",
																"hwp"};
	
	
}
