package egovframework.rte.cmmn.util;

import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.context.request.RequestContextHolder;

/**
 *  Class Name : Constants.java
 *  Description : 세션에 관련된 유틸 
 *  Modification Information
 * 
 *     수정일         수정자                   수정내용
 *   -------    --------    ---------------------------
 *   2014.02.11    박상진          최초 생성
 *
 */


public class SessionUtil {
	 public static Object getAttribute(String name) throws Exception {
		  return (Object)RequestContextHolder.getRequestAttributes().getAttribute(name, RequestAttributes.SCOPE_SESSION);
	 }
	 public static void setAttribute(String name, Object object) throws Exception {
		  RequestContextHolder.getRequestAttributes().setAttribute(name, object, RequestAttributes.SCOPE_SESSION);
	 }
	 public static void removeAttribute(String name) throws Exception {
		  RequestContextHolder.getRequestAttributes().removeAttribute(name, RequestAttributes.SCOPE_SESSION);
	 }
}
