package egovframework.rte.dsdsm.cfroom.management.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import egovframework.rte.psl.dataaccess.util.EgovMap;

public interface CfManageService {
	
	/**
	 * 회의실 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> cfroomReg(HashMap h) throws Exception;
	
	/**
	 * 회의실 수정
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> cfroomEdit(HashMap h) throws Exception;
	
	/**
	 * 회의실 삭제
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> cfroomDel(HashMap h) throws Exception;
	
	/**
	 * 회의실 상세정보을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 회의실 상세정보
	 * @exception Exception
	 */
    public List getCfroomView(HashMap h) throws Exception;
    
    /**
	 * 회의실 목록 총 갯수
	 * @return int
	 * @exception Exception 
	*/
	public int getCfroomListCount(HashMap h) throws Exception;
    
	/**
	 * 회의실 목록을 불러온다
	 * @return 회의실 목록
	 * @exception Exception
	 */
    public List getCfroomList(HashMap h) throws Exception;
    
    /**
	 * 첨부파일을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 첨부파일을 불러온다
	 * @exception Exception
	 */
    public List selectAtchFileList(HashMap map ) throws Exception;
}