package egovframework.rte.dsdsm.cfroom.management.service.impl;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Repository("CfManageServiceDAO")
public class CfManageServiceDAO extends EgovAbstractDAO {
	
	/**
	 * 
	 * @return 회의실 등록
	 * @exception Exception 
	*/
	public Map<String,Object> cfroomReg(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("CfManageServiceDAO.cfroomReg", h));
		return result;
	}
	
	/**
	 * 
	 * @return 회의실 수정
	 * @exception Exception 
	*/
	public Map<String,Object> cfroomEdit(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("CfManageServiceDAO.cfroomEdit", h));
		return result;
	}
	
	/**
	 * 
	 * @return 회의실 삭제
	 * @exception Exception 
	*/
	public Map<String,Object> cfroomDel(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("CfManageServiceDAO.cfroomDel", h));
		return result;
	}
	
	/**
	 * 
	 * @return 회의실 상세정보
	 * @exception Exception 
	*/
	public List getCfroomView(HashMap h) throws Exception {
		return list("CfManageServiceDAO.getCfroomView", h);
	}
	
	/**
	 * 
	 * @return 회의실 목록 총 갯수
	 * @exception Exception 
	*/
	public int getCfroomListCount(HashMap h) throws Exception {
		return (Integer) select("CfManageServiceDAO.getCfroomListCount", h);		
	} 
	
	/**
	 * 
	 * @return 회의실 목록
	 * @exception Exception 
	*/
	public List getCfroomList(HashMap h) throws Exception {
		return list("CfManageServiceDAO.getCfroomList", h);
	}
	
	/**
	 * 
	 * @return 첨부파일을 불러온다
	 * @exception Exception 
	*/
	public List  selectAtchFileList(HashMap map) throws Exception {
		return  list("CfManageServiceDAO.selectAtchFileList", map);		
	}
}
