package egovframework.rte.dsdsm.cfroom.management.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import egovframework.rte.dsdsm.cfroom.management.service.CfManageService;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Service("CfManageService")
public class CfManageServiceImpl extends EgovAbstractServiceImpl implements CfManageService{
	
    @Resource(name="CfManageServiceDAO")
    private CfManageServiceDAO CfManageServiceDAO;
	
    /**
   	 * 회의실 등록
   	 * @exception Exception
   	 */
    public Map<String, Object> cfroomReg(HashMap h) throws Exception {
		Map <String,Object> result = CfManageServiceDAO.cfroomReg(h);
		
		int cnt = 0;
		cnt = (Integer) result.get("CNT");
		
		if(cnt>0){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
   	 * 회의실 수정
   	 * @exception Exception
   	 */
    public Map<String, Object> cfroomEdit(HashMap h) throws Exception {
		Map <String,Object> result = CfManageServiceDAO.cfroomEdit(h); //대분류ID 수정
		
		Integer cnt = (Integer)result.get("CNT");
		
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "회의실 수정이 완료되었습니다");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "회의실 수정에 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
   	 * 회의실 삭제
   	 * @exception Exception
   	 */
    public Map<String, Object> cfroomDel(HashMap h) throws Exception {
		Map <String,Object> result = CfManageServiceDAO.cfroomDel(h); //대분류코드 삭제x
		Integer cnt = (Integer)result.get("CNT");
		
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "회의실 삭제가 완료되었습니다");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "회의실 삭제에 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
   	 * 회의실 상세정보
   	 * @exception Exception
   	 */
    public List getCfroomView(HashMap h) throws Exception {
       return CfManageServiceDAO.getCfroomView(h);
    }
    
    /**
	 * 회의실 목록 총 갯수
	 * @exception Exception
	 */
    public int getCfroomListCount(HashMap h) throws Exception {
		return CfManageServiceDAO.getCfroomListCount(h);
	}
    
    /**
	 * 회의실 목록
	 * @exception Exception
	 */
    public List getCfroomList(HashMap h) throws Exception {
        return CfManageServiceDAO.getCfroomList(h);
    }
    
    /**
   	 * 첨부파일을 불러온다
   	 * @exception Exception
   	 */
    public List selectAtchFileList(HashMap map) throws Exception {
		return CfManageServiceDAO.selectAtchFileList(map);
	}
}
