package egovframework.rte.dsdsm.cfroom.management.web;

import java.net.URLDecoder;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovFileMngService;
import egovframework.rte.cmmn.util.EgovFileMngUtil;
import egovframework.rte.cmmn.vo.FileVO;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.service.vo.SearchVO;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.cfroom.management.service.CfManageService;

@Controller
public class CfManageController {
	
	@Resource(name = "CfManageService")
    private CfManageService CfManageService;
	
	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
	
	@Resource(name="DisFileMng")
	private  DisFileMng disFileMng;
	
	@RequestMapping(value="/cfroom/management/cfroomList.do")
    public String cfroomList() { 
    	return "/dsdsm/cfroom/management/cfroomList";
    }
	
	@RequestMapping(value="/cfroom/management/cfroomReg.do")
    public String cfroomReg(ModelMap model) throws Exception { 
		
		HashMap<Object, Object> map = new HashMap<Object, Object>();
		
		map.put("codeId", "CF1000");
		
		model.addAttribute("area",CmmService.getCmmDitcList(map));
		
    	return "/dsdsm/cfroom/management/cfroomReg";
    }
	
	/**
     * 회의실 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/cfroom/management/getCfroomList.do")
	public String getCfroomList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		int listCount = CfManageService.getCfroomListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = CfManageService.getCfroomList(param);	
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}
	
	/**
     * 회의실 편집
     * @throws Exception 
     */
    @RequestMapping(value="/cfroom/management/cfroomEdit.json")
    public String cfroomEditJ(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	
    	if("S".equals(param.get("gbn"))){
    		String _atchFileId = "";
    		_atchFileId = disFileMng.fileUpload("CFRM_",request);
    		param.put("disAddFileId", _atchFileId);	 
    		
    		result = CfManageService.cfroomReg(param);
    		param.put("cfno", result.get("CNT"));
    	} else if("U".equals(param.get("gbn"))){
    		disFileMng.fileDelete(request);
        	
        	String _atchFileId = "";
    		_atchFileId = disFileMng.fileUpload("CFRM_",request);
    		System.out.println(_atchFileId);
    		if (_atchFileId != null) {
    			param.put("disAddFileId", _atchFileId);
    		}
    		
    		result = CfManageService.cfroomEdit(param);
    	} else if("D".equals(param.get("gbn"))){
    		result = CfManageService.cfroomDel(param);
    	}
    	
    	map.put("result", result);
    	map.put("cfno", param.get("cfno"));
    	
    	return "jsonView";
    }
    
    /**
     * 회의실 상세보기화면으로 들어간다.
	 * @throws Exception 
     */
    @SuppressWarnings("unchecked")
	@RequestMapping(value="/cfroom/management/cfroomView.do")
    public String cfroomView(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	List list = CfManageService.getCfroomView(param);
    	
    	model.addAttribute("list",list);
    	model.addAttribute("fileList", CfManageService.selectAtchFileList(param));
    	
    	return "/dsdsm/cfroom/management/cfroomView";
    }
    
    /**
     * 회의실 수정화면으로 들어간다.
	 * @throws Exception 
     */
    @SuppressWarnings("unchecked")
	@RequestMapping(value="/cfroom/management/cfroomEdit.do")
    public String cfroomEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	List list = CfManageService.getCfroomView(param);
    	
    	model.addAttribute("list",list);
    	model.addAttribute("fileList", CfManageService.selectAtchFileList(param));
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
		
		map.put("codeId", "CF1000");
		
		model.addAttribute("area",CmmService.getCmmDitcList(map));
		
    	return "/dsdsm/cfroom/management/cfroomEdit";
    }
}
