package egovframework.rte.dsdsm.cfroom.reserve.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import egovframework.rte.psl.dataaccess.util.EgovMap;

public interface RvService {
	
	/**
	 * 회의실 예약 목록을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 목록
	 * @exception Exception
	 */
    public List getReserveList(HashMap h) throws Exception;

    /**
	 * 회의실 예약 상세정보
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 상세정보
	 * @exception Exception
	 */
    public List getReserveView(HashMap h) throws Exception;
    
    /**
	 * 회의실 예약 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> reserveRegist(HashMap h) throws Exception;
	
	/**
	 * 회의실 예약 수정
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> reserveEdit(HashMap h) throws Exception;

	/**
	 * 회의실 예약 취소
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> reserveDel(HashMap h) throws Exception;
	
	/**
	 * 회의실 예약 중복 갯수
	 * @return int
	 * @exception Exception 
	*/
	public int overlapCheck(HashMap h) throws Exception;
	
	/**
	 * 회의실 예약 등록(일자)
	 * @return int
	 * @exception Exception 
	*/
	public void reserveRegistDe(HashMap h) throws Exception;
	
	/**
	 * 회의실 예약 일자정보 삭제
	 * @return int
	 * @exception Exception 
	*/
	public void reserveDelDe(HashMap h) throws Exception;
	
	/**
	 * 회의실정보 가져오기
	 * @return 회의실정보
	 * @exception Exception 
	*/	
	public List<HashMap> getPlaceList(HashMap map) throws Exception;
}