package egovframework.rte.dsdsm.cfroom.reserve.service.impl;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Repository("RvServiceDAO")
public class RvServiceDAO extends EgovAbstractDAO {
	
	/**
	 * 
	 * @return 회의실 예약 목록
	 * @exception Exception 
	*/
	public List getReserveList(HashMap h) throws Exception {
		return list("RvServiceDAO.getReserveList", h);
	}
	
	/**
	 * 
	 * @return 회의실 예약 상세정보
	 * @exception Exception 
	*/
	public List getReserveView(HashMap h) throws Exception {
		return list("RvServiceDAO.getReserveView", h);
	}

	/**
	 * 
	 * @return 회의실 예약 등록
	 * @exception Exception 
	*/
	public Map<String,Object> reserveRegist(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("RvServiceDAO.reserveRegist", h));
		return result;
	}
	
	/**
	 * 
	 * @return 회의실 예약 수정
	 * @exception Exception 
	*/
	public Map<String,Object> reserveEdit(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("RvServiceDAO.reserveEdit", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 회의실 예약 삭제
	 * @exception Exception 
	*/
	public Map<String,Object> reserveDel(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("RvServiceDAO.reserveDel", h));
		return result;
	} 

	/**
	 * 
	 * @return 회의실 예약 중복 갯수
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int overlapCheck(HashMap h) throws Exception {
		return (Integer) select("RvServiceDAO.overlapCheck", h);
				
	}
	
	/**
	 * 
	 * @return 회의실 예약 등록(일자)
	 * @exception Exception 
	*/
	public void reserveRegistDe(HashMap h) throws Exception{
		insert("RvServiceDAO.reserveRegistDe", h);
	}
	
	/**
	 * 
	 * @return 회의실 예약 일자정보 삭제
	 * @exception Exception 
	*/
	public void reserveDelDe(HashMap h) throws Exception {
		delete("RvServiceDAO.reserveDelDe", h);
				
	}
	
	/**
	 * 회의실정보 가져오기
	 * @return 
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<HashMap> getPlaceList(HashMap map) throws Exception {
		System.out.println("MAP:::"+map.toString());
		return (List<HashMap>) list("RvServiceDAO.getPlaceList", map);
	}
}
