package egovframework.rte.dsdsm.cfroom.reserve.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import egovframework.rte.dsdsm.cfroom.reserve.service.RvService;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Service("RvService")
public class RvServiceImpl extends EgovAbstractServiceImpl implements RvService{
	
    @Resource(name="RvServiceDAO")
    private RvServiceDAO RvServiceDAO;

    /**
	 * 회의실 예약 목록
	 * @exception Exception 
	*/
    public List getReserveList(HashMap h) throws Exception {
        return RvServiceDAO.getReserveList(h);
    }
    
    /**
	 * 회의실 예약 상세정보
	 * @exception Exception 
	*/
    public List getReserveView(HashMap h) throws Exception {
        return RvServiceDAO.getReserveView(h);
    }
	
    /**
	 * 회의실 예약 등록
	 * @exception Exception 
	*/
    public Map<String, Object> reserveRegist(HashMap h) throws Exception {
		Map <String,Object> result = RvServiceDAO.reserveRegist(h);
		
		int cnt = (Integer) result.get("CNT");
		System.out.println(cnt);
		if(cnt>0){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
	 * 회의실 예약 수정
	 * @exception Exception 
	*/
    public Map<String, Object> reserveEdit(HashMap h) throws Exception {
		Map <String,Object> result = RvServiceDAO.reserveEdit(h);
		
		Integer cnt = (Integer) result.get("CNT");
		System.out.println(cnt);
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}

    /**
	 * 회의실 예약 삭제
	 * @exception Exception 
	*/
    public Map<String, Object> reserveDel(HashMap h) throws Exception {
		Map <String,Object> result = RvServiceDAO.reserveDel(h);
		
		int cnt = (Integer) result.get("CNT");
		if(cnt>0){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
	 * 회의실 예약 중복 갯수
	 * @exception Exception 
	*/
	public int overlapCheck(HashMap h) throws Exception {
		return RvServiceDAO.overlapCheck(h);
	}
	
    /**
	 * 회의실 예약 등록(일자)
	 * @exception Exception 
	 */
	public void reserveRegistDe(HashMap h) throws Exception{
		RvServiceDAO.reserveRegistDe(h);
	}
	
	/**
	 * 회의실 예약 일자정보 삭제
	 * @exception Exception 
	*/
    public void reserveDelDe(HashMap h) throws Exception {
    	RvServiceDAO.reserveDelDe(h);
	}
    
    /**
	 * 회의실정보 가져오기
	 * @return 회의실정보
	 * @exception Exception 
	*/
	public List<HashMap> getPlaceList(HashMap map) throws Exception {
		return RvServiceDAO.getPlaceList(map);
	}
	
}
