package egovframework.rte.dsdsm.cfroom.reserve.web;

import java.net.URLDecoder;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovFileMngService;
import egovframework.rte.cmmn.util.EgovFileMngUtil;
import egovframework.rte.cmmn.vo.FileVO;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.service.vo.SearchVO;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.cfroom.reserve.service.RvService;

@Controller
public class RvController {
	
	private Logger log = LogManager.getLogger();
	
	@Resource(name = "RvService")
    private RvService RvService;
	
	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
		
	@RequestMapping(value="/cfroom/reserve/reserveList.do")
    public String reserveList(ModelMap model) throws Exception {
		
    	return "/dsdsm/cfroom/reserve/reserveList";
    }
	/**
     * 일정 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/cfroom/reserve/getReserveList.do")
	public String getReserveList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		//System.out.println("목록");
		log.debug("목록");

 	  	if (param.get("nowYM") == null) { 
 	  	   Date d = new Date();
 	  	   SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
 	  	   String nowYM = sdf.format(d);
 	  	   
 	  	   param.put("nowYM", nowYM);
		}
 	  	
		List list = RvService.getReserveList(param);	
 	  	model.put("list",list);
		
		return "jsonView";
	}
	
	@RequestMapping(value="/cfroom/reserve/regReserve.do")
    public String regReserve(@RequestParam HashMap<Object,Object> param, ModelMap model) throws Exception { 

		model.put("date", param.get("date"));
		
		HashMap<Object, Object> map = new HashMap<Object, Object>();
		
		map.put("codeId", "SC2000");
		
		model.addAttribute("repeat",CmmService.getCmmDitcList(map));

		map.put("codeId", "CF1000");
		
		model.addAttribute("place",RvService.getPlaceList(map));
		
    	return "/dsdsm/cfroom/reserve/reserveRegModal";
    }
	
	@RequestMapping(value="/cfroom/reserve/viewReserve.do")
    public String viewReserve(@RequestParam HashMap<Object,Object> param, ModelMap model) throws Exception { 

		List list = RvService.getReserveView(param);	
 	  	model.put("list",list);
		
 	  	HashMap<Object, Object> map = new HashMap<Object, Object>();
		
		map.put("codeId", "SC2000");
		
		model.addAttribute("repeat",CmmService.getCmmDitcList(map));
		
		map.put("codeId", "CF1000");
		
		model.addAttribute("place",RvService.getPlaceList(map));
		
		map.put("roleId", "SYSMANAGER");
		model.addAttribute("authority", CmmService.getAuthority(map));
		
    	return "/dsdsm/cfroom/reserve/reserveViewModal";
    }
	
	/**
     * 회의실 예약 등록
     * @throws Exception 
     */
    @RequestMapping(value="/cfroom/reserve/reserveRegist.json")
    public String reserveRegist(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	System.out.println("등록 시작");
    	
    	if("100".equals(param.get("repeat"))){
    		param.put("edate", param.get("sdate"));
    	} else {
    		param.put("sdate", param.get("sdate1"));
    		param.put("edate", param.get("edate1"));
    	}
    	
    	Map<String, Object> result = RvService.reserveRegist(param);
    	
    	map.put("result", result);
    	System.out.println(result);
    	param.put("rvno", result.get("CNT"));    	
    	insertScDate(param);
    	
    	return "jsonView";
    }
    
    /**
     * 회의실 예약 수정
     * @throws Exception 
     */
    @RequestMapping(value="/cfroom/reserve/reserveEdit.json")
    public String reserveEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	System.out.println("수정 시작");
    	
    	if("100".equals(param.get("repeat"))){
    		param.put("edate", param.get("sdate"));
    	} else {
    		param.put("sdate", param.get("sdate1"));
    		param.put("edate", param.get("edate1"));
    	}
    	
    	Map<String, Object> result = RvService.reserveEdit(param);
    	RvService.reserveDelDe(param);
    	
    	map.put("result", result);
    	insertScDate(param);
    	
    	return "jsonView";
    }
    
    /**
     * 회의실 예약 취소
     * @throws Exception 
     */
    @RequestMapping(value="/cfroom/reserve/reserveDel.json")
    public String reserveDel(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	System.out.println("삭제 시작");
    	
    	Map<String, Object> result = RvService.reserveDel(param);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    /**
     * 회의실 예약 시간 중복체크
     * @throws Exception 
     */
    @RequestMapping(value="/cfroom/reserve/overlapCheck.json")
    public String overlapCheck(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	System.out.println("중복체크 시작");
    	
		int cfcnt = 0;
    	if("100".equals(param.get("repeat"))){
    		param.put("ndate", param.get("sdate"));
    		cfcnt = RvService.overlapCheck(param);
    	} else {
	    	DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
			Date eDate = df.parse((String) param.get("edate"));
			Date nDate = df.parse((String) param.get("sdate"));
			
			Calendar cal = Calendar.getInstance();
			int compare = 0;
			while(true){
				compare = nDate.compareTo(eDate);
				
				if( compare > 0 ) break;
				
				param.put("ndate", df.format(nDate));
				
				cfcnt = RvService.overlapCheck(param);
				if( cfcnt > 0 ) break;
				
				cal.setTime(nDate);
				cal.add(Calendar.DATE, 7);
				nDate = df.parse(df.format(cal.getTime()));
			}
    	}

		System.out.println(cfcnt);
		map.put("result", cfcnt);
    	
    	return "jsonView";
    }
    
    private void insertScDate(HashMap<Object,Object> param) throws Exception{
    	
		if("100".equals(param.get("repeat"))){
			param.put("ndate", param.get("sdate"));
			param.put("nSdatetime", param.get("sdatetime"));
	    	param.put("nEdatetime", param.get("edatetime"));
	    	
			RvService.reserveRegistDe(param);
		} else if("200".equals(param.get("repeat"))){
			param.put("nSdatetime", param.get("sdatetime1"));
	    	param.put("nEdatetime", param.get("edatetime1"));
	    	
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
			Date eDate = df.parse((String) param.get("edate1"));
			Date nDate = df.parse((String) param.get("sdate1"));

			Calendar cal = Calendar.getInstance();
			int compare = 0;
			while(true){
				compare = nDate.compareTo(eDate);
				if( compare > 0 ) break;
				param.put("ndate", df.format(nDate));
				
				RvService.reserveRegistDe(param);
				
				cal.setTime(nDate);
				cal.add(Calendar.DATE, 7);
				nDate = df.parse(df.format(cal.getTime()));
			}
		}
	}
}
