package egovframework.rte.dsdsm.cmm.handler;

import java.net.URLEncoder;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.handler.SimpleMappingExceptionResolver;

public class DssdmExceptionResolver extends SimpleMappingExceptionResolver {
	
	private Logger log = LogManager.getLogger();
	
	@SuppressWarnings("deprecation")
	@Override
	protected ModelAndView doResolveException(HttpServletRequest request, HttpServletResponse response,
			Object handler, Exception ex) {
		String viewName = null;
		Integer statusCode = null;
		
		String requestUri = request.getRequestURI();
		
		if(requestUri!=null && requestUri.indexOf(".json")>0){
			viewName = "/dsdsm/cmmn/jsonError";
			if(ex!=null && ex.getMessage()!=null){
				try{
					request.setAttribute("MESSAGE", URLEncoder.encode(ex.getMessage(),"utf-8"));
				}catch(Exception e){
					request.setAttribute("MESSAGE", URLEncoder.encode(ex.getMessage()));
				}
			}else{
				if(ex!=null){
					ex.printStackTrace();
				}else{
					System.out.println("exception 이 넘어오지 않았습니다.");
				}
				request.setAttribute("MESSAGE", "");
			}
		}else{
			// Expose ModelAndView for chosen error view.
			viewName = determineViewName(ex, request);
		}
		
		if (viewName != null) {
			// Apply HTTP status code for error views, if specified.
			// Only apply it if we're processing a top-level request.
			statusCode = determineStatusCode(request, viewName);
			if (statusCode != null) {
				applyStatusCodeIfPossible(request, response, statusCode);
			}
			return getModelAndView(viewName, ex, request);
		}else {
			return null;
		}
	}

}
