package egovframework.rte.dsdsm.cmm.handler;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

public class LoginCheckInterceptor extends HandlerInterceptorAdapter {
	
	Logger log = LogManager.getLogger();
	
	@Override
	public boolean preHandle(HttpServletRequest request,
			HttpServletResponse response, Object handler) throws Exception {
		
		boolean result = false;
		
		HttpSession session = request.getSession();
		
		String uri = request.getRequestURI();
		log.debug("request.uri : "+uri);
		
		response.setHeader("Cache-Control","no-store");
		response.setHeader("Pragma","no-cache");
		if (request.getProtocol().equals("HTTP/1.1")) response.setHeader("Cache-Control", "no-cache");
		
		@SuppressWarnings("rawtypes")
		Map userInfo = (Map)session.getAttribute("userInfo");
		if(userInfo!=null && userInfo.get("userId")!=null){
			result = true;
		}else{
			String contextPath = request.getContextPath();
			request.setAttribute("MESSAGE", "로그인 정보가 없습니다.");
			if(StringUtils.contains(uri, ".json")){
				//request.getRequestDispatcher("/cmm/jsonError.do").forward(request, response);
				response.sendRedirect(contextPath+"/cmm/jsonError.do");
			}else if(StringUtils.contains(uri, "/cmm/dssdmSiteData.do")){
				//request.getRequestDispatcher("/cmm/emptyView.do").forward(request, response);
				response.sendRedirect(contextPath+"/cmm/emptyView.do");
			}else{
				//request.getRequestDispatcher("/login/login.do").forward(request, response);
				response.sendRedirect(contextPath+"/login/login.do");
			}
		}
				
		return result;
	}

}
