package egovframework.rte.dsdsm.cmm.handler;

import java.sql.Array;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Types;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import com.ibatis.sqlmap.client.extensions.ParameterSetter;
import com.ibatis.sqlmap.client.extensions.ResultGetter;
import com.ibatis.sqlmap.client.extensions.TypeHandlerCallback;

public class VarcharArrayTypeMapper implements TypeHandlerCallback {

	final Logger log = LogManager.getLogger();
	@SuppressWarnings("resource")
	@Override
	public void setParameter(ParameterSetter setter, Object parameter)
			throws SQLException {
		log.debug("setParameter handling start");
		if(parameter == null){
			setter.setNull(Types.ARRAY);
		}else{
			Connection con = setter.getPreparedStatement().getConnection();
			// hack: if using poolable connection from dbcp must get inside true connection!
			if(con instanceof org.apache.commons.dbcp.PoolableConnection ) {
			    throw new UnsupportedOperationException("Not implemented");
			}else if(con instanceof org.apache.commons.dbcp.PoolingDataSource){
				throw new UnsupportedOperationException("Not implemented");
			}else if(con instanceof org.apache.commons.dbcp.DelegatingConnection){
				con =     ((org.apache.commons.dbcp.DelegatingConnection)con).getInnermostDelegate();
				if(con == null){
					log.error("accessToUnderlyingConnectionAllowed is false!!");
					throw new UnsupportedOperationException("Can't Access Delegation!!");
				}
			}else {
				throw new UnsupportedOperationException("Not implemented");
			}
			Array array = con.createArrayOf("varchar", (Object[])parameter);
			setter.setArray(array);
		}
	}

	@Override
	public Object getResult(ResultGetter getter) throws SQLException {
		log.debug("setParameter handling start");
		Array array = getter.getResultSet().getArray(getter.getColumnName());
		if (!getter.getResultSet().wasNull()) {
			return array.getArray();
		} else {
			return null;
		}
	}

	@Override
	public Object valueOf(String s) {
		throw new UnsupportedOperationException("Not implemented");
	}

}
