package egovframework.rte.dsdsm.cmm.service.impl;

import java.sql.Clob;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.springframework.stereotype.Repository;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.vo.cmmVO;
import egovframework.rte.dsdsm.cmm.util.StrUtil;
import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Repository("cmmServiceDAO")
public class CmmServiceDAO extends EgovAbstractDAO {
	private static String databaseType = StrUtil.NVL(EgovProperties.getProperty("Globals.DatabaseType"),"postgres");
	
	/**
	 * 공통코드 가져오기(그룹코드인것만)
	 * @return 
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<cmmVO> getCmmGrpList() throws Exception {
		return (List<cmmVO>) list("cmmServiceDAO.getCmmGrpList");
	}
	
	
	/**
	 * 공통코드 가져오기
	 * @return 
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<HashMap> getCmmDitcList(HashMap map) throws Exception {
		System.out.println("MAP:::"+map.toString());
		return (List<HashMap>) list("cmmServiceDAO.getCmmDitcList", map);
	}
	
	/**
	 * 권한보유 유무 가져오기
	 * @return 
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public String getAuthority(HashMap map) throws Exception {
		return (String) select("cmmServiceDAO.getAuthority", map);
	}
	
	/**
	 * 다음단계정보
	 * @return 
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<EgovMap> getNextstep(HashMap h) throws Exception {
		System.out.println("dao");
		return (List<EgovMap>) list("cmmServiceDAO.getNextstep", h);
	}
	
	
	public List selectBbsAddFileList(HashMap map) throws Exception {
		return list("BbsService.selectFaqAtchFileList", map);		
	}	
	
	/**
	 * FAQ
	 * @param map
	 * @return
	 * @throws Exception
	 */
	public String insertFaq(HashMap map) throws Exception {
		return (String)insert("BbsService.insertFaq", map);
	}
	
	public List selectFaqList(HashMap map) throws Exception {
		List list = list("BbsService.selectFaqList", map);
		
		// databaseType이 oracle인 경우 Clob 데이터 처리
		if("oracle".equals(databaseType)){
			for(int i=0; i < list.size(); i++){
				//Clob 데이터를 String 으로 변환 해주지 않으면.. json type로 변환시 에러남
				// 이에 clob 데이터를 String으로 전환하여 Map에 다시 input
				EgovMap dataMap = (EgovMap) list.get(i);
				Clob data = (Clob)dataMap.get("ntCont");
				String clobStr = StrUtil.clobToString(data);
				dataMap.put("ntCont", clobStr);
			}
		}
		
		return list;
	}
	
	public int selectFaqListCnt(HashMap map) throws Exception {
		return (Integer) select("BbsService.selectFaqListCnt", map);		
	}	
	
	public List selectFaqDtl(HashMap map) throws Exception {
		List list =  list("BbsService.selectFaqDtl", map);

		// databaseType이 oracle인 경우 Clob 데이터 처리
		if("oracle".equals(databaseType)){
			for(int i=0; i < list.size(); i++){
				//Clob 데이터를 String 으로 변환 해주지 않으면.. json type로 변환시 에러남
				// 이에 clob 데이터를 String으로 전환하여 Map에 다시 input
				EgovMap dataMap = (EgovMap) list.get(i);
				Clob data = (Clob)dataMap.get("ntCont");
				String clobStr = StrUtil.clobToString(data);
				dataMap.put("ntCont", clobStr);
			}
		}
		
		return list;
	}	
	 
	public int updateFaq(HashMap map) throws Exception {
		return update("BbsService.updateFaq", map);
				
	}	
	
	public int deleteFaq(HashMap map) throws Exception {
		return update("BbsService.deleteFaq", map);
		
	}	
	
	
	/**
	 * 공지사항
	 * @param map
	 * @return
	 * @throws Exception
	 */
	public String insertNotice(HashMap map) throws Exception {
		return (String)insert("BbsService.insertNotice", map);
	}
	
	public List selectNoticeList(HashMap map) throws Exception {
		List list = list("BbsService.selectNoticeList", map);
	
		// databaseType이 oracle인 경우 Clob 데이터 처리
		if("oracle".equals(databaseType)){
			if(list.size() > 0){
				for(int i=0;i<list.size();i++) {
					EgovMap dataMap = (EgovMap)list.get(i);
					//Clob 데이터를 String 으로 변환 해주지 않으면.. json type로 변환시 에러남
					// 이에 clob 데이터를 String으로 전환하여 Map에 다시 input
					Clob data = (Clob)dataMap.get("ntCont");
					String clobStr = StrUtil.clobToString(data);
					dataMap.put("ntCont", clobStr);
				}
			}
		}
		
		return list;
	}
	
	public int selectNoticeListCnt(HashMap map) throws Exception {
		return (Integer) select("BbsService.selectNoticeListCnt", map);		
	}	
	
	public List selectNoticeDtl(HashMap map) throws Exception {
		List list = list("BbsService.selectNoticeDtl", map);
		
		// databaseType이 oracle인 경우 Clob 데이터 처리
		if("oracle".equals(databaseType)){
			for(int i=0;i<list.size();i++) {
				EgovMap dataMap = (EgovMap)list.get(i);
				//Clob 데이터를 String 으로 변환 해주지 않으면.. json type로 변환시 에러남
				// 이에 clob 데이터를 String으로 전환하여 Map에 다시 input
				Clob data = (Clob)dataMap.get("ntCont");
				String clobStr = StrUtil.clobToString(data);
				dataMap.put("ntCont", clobStr);
			}
		}
		
		return list;
	}	
	 
	public int updateNotice(HashMap map) throws Exception {
		return update("BbsService.updateNotice", map);
				
	}	
	
	public int deleteNotice(HashMap map) throws Exception {
		return update("BbsService.deleteNotice", map);
		
	}	
	
	/**
	 * 자료실
	 * @param map
	 * @return
	 * @throws Exception
	 */
	public String insertArchive(HashMap map) throws Exception {
		return (String)insert("BbsService.insertArchive", map);
	}
	
	public List selectArchiveList(HashMap map) throws Exception {
		List list = list("BbsService.selectArchiveList", map);

		// databaseType이 oracle인 경우 Clob 데이터 처리
		if("oracle".equals(databaseType)){
			for(int i=0;i<list.size();i++) {
				EgovMap dataMap = (EgovMap)list.get(i);
				//Clob 데이터를 String 으로 변환 해주지 않으면.. json type로 변환시 에러남
				// 이에 clob 데이터를 String으로 전환하여 Map에 다시 input
				Clob data = (Clob)dataMap.get("ntCont");
				String clobStr = StrUtil.clobToString(data);
				dataMap.put("ntCont", clobStr);
			}
		}
		
		return list;
	}
	
	public int selectArchiveListCnt(HashMap map) throws Exception {
		return (Integer) select("BbsService.selectArchiveListCnt", map);		
	}	
	
	public List selectArchiveDtl(HashMap map) throws Exception {
		List list = list("BbsService.selectArchiveDtl", map);
		
		// databaseType이 oracle인 경우 Clob 데이터 처리
		if("oracle".equals(databaseType)){
			for(int i=0;i<list.size();i++) {
				EgovMap dataMap = (EgovMap)list.get(i);
				//Clob 데이터를 String 으로 변환 해주지 않으면.. json type로 변환시 에러남
				// 이에 clob 데이터를 String으로 전환하여 Map에 다시 input
				Clob data = (Clob)dataMap.get("ntCont");
				String clobStr = StrUtil.clobToString(data);
				dataMap.put("ntCont", clobStr);
			}
		}
		
		return list;
	}	
	
	public int updateArchive(HashMap map) throws Exception {
		return update("BbsService.updateArchive", map);
		
	}	
	
	public int deleteArchive(HashMap map) throws Exception {
		return update("BbsService.deleteArchive", map);
		
	}		
	
	
	
	
	
	
	
	/**
	 * 채팅방 첨부파일 조회
	 * @param map
	 * @return
	 * @throws Exception
	 */
	public List selectChatAddFileList(HashMap map) throws Exception {
		return list("BbsService.selectChatAtchFileList", map);		
	}	
	
	
	/**
	 * 쪽지
	 * @param map
	 * @return
	 * @throws Exception
	 */
	public String insertMsg(HashMap map) throws Exception {
		return (String)insert("MsgService.insertMsg", map);
	}
	public String insertMsgRecv(HashMap map) throws Exception {
		return (String)insert("MsgService.insertMsgRecv", map);
	}
	public List selectMsgDtl(HashMap map) throws Exception {
		return list("MsgService.selectMsgDtl", map);		
	}
	public List selectMsgDtlRecv(HashMap map) throws Exception {
		return list("MsgService.selectMsgDtlRecv", map);		
	}
	public int updateMsg(HashMap map) throws Exception {
		return update("MsgService.updateMsg", map);		
	}			
	public int updateMsgRead(HashMap map) throws Exception {
		return update("MsgService.updateMsgRead", map);		
	}			
	
	public List selectMsgList(HashMap map) throws Exception {
		return list("MsgService.selectMsgList", map);		
	}
	
	public int selectMsgListCnt(HashMap map) throws Exception {
		return (Integer) select("MsgService.selectMsgListCnt", map);		
	}
	
	public int deleteMsg(HashMap map) throws Exception {
		return update("MsgService.deleteMsg", map);		
	}			
	
	
	public List selectMsgAtchFileList(HashMap map) throws Exception {
		return list("MsgService.selectMsgAtchFileList", map);		
	}	
	public List selectUnreadCnt(HashMap map) throws Exception {
		return list("MsgService.selectUnreadCnt", map);		
	}	
	
	
	
	public List selectCmmJsonList(Map<String,Object> map){
		String sqlGbn =(String)map.get("sqlGbn");
		
		List list = list(sqlGbn, map);
		
		// databaseType이 oracle인 경우 Clob 데이터 처리
		if("oracle".equals(databaseType)){
			for(int i=0; i < list.size(); i++){
				//Clob 데이터를 String 으로 변환 해주지 않으면.. json type로 변환시 에러남
				// 이에 clob 데이터를 String으로 전환하여 Map에 다시 input
				EgovMap dataMap = (EgovMap) list.get(i);
				
	    		Set s = dataMap.keySet();
	    		Iterator info = s.iterator();
	    		while(info.hasNext()){
	    			String key =(String)info.next();
	    			if(key!=null){
	    				Object obj = dataMap.get(key); 
	    				if(obj!=null){
	    					if((obj.getClass().getName()).indexOf("CLOB")>-1){
		    					Clob data = (Clob)dataMap.get(key);
		    					String clobStr = StrUtil.clobToString(data);
		    					dataMap.put(key, clobStr);
	    					}
	    				}
	    			}
	    		}
			}
		}
		
		return list;
	}
	public int selectCmmJsonListCnt(Map<String,Object> map){
		String sqlGbn =(String)map.get("sqlGbn")+"Cnt";
		return (Integer) select(sqlGbn, map);
	}

	public int updateData(HashMap map) throws Exception {
		String sqlGbn =(String)map.get("sqlGbn");
		int result = update(sqlGbn, map);
		return result;
	}

	public int deleteData(HashMap map) throws Exception {
		String sqlGbn =(String)map.get("sqlGbn");
		int result = delete(sqlGbn, map);
		return result;
	}

	public String insertData(HashMap map) throws Exception {
		String sqlGbn =(String)map.get("sqlGbn");
		return (String)insert(sqlGbn, map);
	}
	
	public String writeHistory(HashMap map) throws Exception {
		return (String)insert("CommonData.insertLimsHis", map);
	}
}
