package egovframework.rte.dsdsm.cmm.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Service;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.vo.cmmVO;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Service("CmmService")
public class CmmServiceImpl extends EgovAbstractServiceImpl implements CmmService{
	
	/** tcpVisitDAO */
    @Resource(name="cmmServiceDAO")
    private CmmServiceDAO cmmServiceDAO;
    
    
    /**
	 * 공통코드 가져오기(그룹코드인것만0
	 * @return 
	 * @exception Exception 
	*/
	public List<cmmVO> getCmmGrpList() throws Exception {
		return cmmServiceDAO.getCmmGrpList();	
	} 
    
	
	/**
	 * 공통코드 가져오기
	 * @return 공통코드 가져오기
	 * @exception Exception 
	*/
	public List<HashMap> getCmmDitcList(HashMap map) throws Exception {
		return cmmServiceDAO.getCmmDitcList(map);
	}	
	
	/**
	 * 권한보유 유무 가져오기
	 * @return 권한보유 유무
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public String getAuthority(HashMap map) throws Exception {
		ServletRequestAttributes servletRequestAttribute = (ServletRequestAttributes) RequestContextHolder.currentRequestAttributes();
        HttpSession httpSession = servletRequestAttribute.getRequest().getSession(true);
        Map userInfo = (Map) httpSession.getAttribute("userInfo");
        map.put("userId",userInfo.get("userId"));
        
		return cmmServiceDAO.getAuthority(map);
	}	
	
	/**
	 * S/R,배포 다음단계정보 가져오기
	 * @return 다음단계정보
	 * @exception Exception 
	*/
	public List<EgovMap> getNextstep(String sdgbn,String curr,String gbn) throws Exception {
		System.out.println("sdgbn = " + sdgbn);
		
		HashMap<Object, Object> h = new HashMap<Object, Object>();
		
		h.put("sdgbn",sdgbn);
		h.put("curr",curr);
		h.put("gbn",gbn);
		
		return cmmServiceDAO.getNextstep(h);
	}	
    
	
	
   public List selectBbsAddFileList(HashMap map) throws Exception {
    	return cmmServiceDAO.selectBbsAddFileList(map);
    }
   
   public List selectChatAddFileList(HashMap map) throws Exception {
	   return cmmServiceDAO.selectChatAddFileList(map);
   }
	   
	/**
	 * FAQ
	 * @exception Exception 
	*/
	public String insertFaq(HashMap map) throws Exception {		
		return cmmServiceDAO.insertFaq(map);
	} 	
	
	public List selectFaqList(HashMap map) throws Exception {
		return cmmServiceDAO.selectFaqList(map);
	}
    public int selectFaqListCnt(HashMap map) throws Exception {
    	return cmmServiceDAO.selectFaqListCnt(map);
    }
     
    public List selectFaqDtl(HashMap map) throws Exception {
    	return cmmServiceDAO.selectFaqDtl(map);
    }
	
	public int updateFaq(HashMap map) throws Exception {
		return cmmServiceDAO.updateFaq(map);
	}
	
	public int deleteFaq(HashMap map) throws Exception {
		return cmmServiceDAO.deleteFaq(map);
	}
	
	
	/**
	 * 공지사항
	 * @exception Exception 
	*/
	public String insertNotice(HashMap map) throws Exception {		
		return cmmServiceDAO.insertNotice(map);
	} 	
	
	public List selectNoticeList(HashMap map) throws Exception {
		return cmmServiceDAO.selectNoticeList(map);
	}
    public int selectNoticeListCnt(HashMap map) throws Exception {
    	return cmmServiceDAO.selectNoticeListCnt(map);
    }
     
    public List selectNoticeDtl(HashMap map) throws Exception {
    	return cmmServiceDAO.selectNoticeDtl(map);
    }
	
	public int updateNotice(HashMap map) throws Exception {
		return cmmServiceDAO.updateNotice(map);
	}
	
	public int deleteNotice(HashMap map) throws Exception {
		return cmmServiceDAO.deleteNotice(map);
	}
	
	/**
	 * 자료실
	 * @exception Exception 
	*/
	public String insertArchive(HashMap map) throws Exception {		
		return cmmServiceDAO.insertArchive(map);
	} 	
	
	public List selectArchiveList(HashMap map) throws Exception {
		return cmmServiceDAO.selectArchiveList(map);
	}
    public int selectArchiveListCnt(HashMap map) throws Exception {
    	return cmmServiceDAO.selectArchiveListCnt(map);
    }
     
    public List selectArchiveDtl(HashMap map) throws Exception {
    	return cmmServiceDAO.selectArchiveDtl(map);
    }
	
	public int updateArchive(HashMap map) throws Exception {
		return cmmServiceDAO.updateArchive(map);
	}
	
	public int deleteArchive(HashMap map) throws Exception {
		return cmmServiceDAO.deleteArchive(map);
	}	
	 
	
	/**
	 * 쪽지 
	 * 
	 */
	public String insertMsg(HashMap map) throws Exception {		
		return cmmServiceDAO.insertMsg(map);
	} 	
	public String insertMsgRecv(HashMap map) throws Exception {		
		return cmmServiceDAO.insertMsgRecv(map);
	} 	
	public List selectMsgDtl(HashMap map) throws Exception {
		return cmmServiceDAO.selectMsgDtl(map);
	}
	public List selectMsgDtlRecv(HashMap map) throws Exception {
		return cmmServiceDAO.selectMsgDtlRecv(map);
	}
	public int updateMsg(HashMap map) throws Exception {
		return cmmServiceDAO.updateMsg(map);
	}
	public int updateMsgRead(HashMap map) throws Exception {
		return cmmServiceDAO.updateMsgRead(map);
	}	
	public List selectMsgList(HashMap map) throws Exception {
		return cmmServiceDAO.selectMsgList(map);
	}
	
    public int selectMsgListCnt(HashMap map) throws Exception {
    	return cmmServiceDAO.selectMsgListCnt(map);
    }
  
	public int deleteMsg(HashMap map) throws Exception {
		return cmmServiceDAO.deleteMsg(map);
	}	
	
	public List selectMsgAtchFileList(HashMap map) throws Exception {
		return cmmServiceDAO.selectMsgAtchFileList(map);
	}
	public List selectUnreadCnt(HashMap map) throws Exception {
		return cmmServiceDAO.selectUnreadCnt(map);
	}
	
	public List selectCmmJsonList(Map<String, Object> map) throws Exception{
		List result = cmmServiceDAO.selectCmmJsonList(map);
		return result;
	}
	public int selectCmmJsonListCnt(Map<String, Object> map) throws Exception{
		int result = cmmServiceDAO.selectCmmJsonListCnt(map);
		return result;
	}


	public int updateData(HashMap map) throws Exception {
		String[] sqls = ((String)map.get("sqlGbn")).split(",");
		
		int result = 0;
		for(String sql:sqls){
			map.put("sqlGbn",sql);
			result +=  cmmServiceDAO.updateData(map);
		}
		 
		return result;
	}


	public int deleteData(HashMap map) throws Exception {
		String[] sqls = ((String)map.get("sqlGbn")).split(",");
		int result = 0;
		for(String sql:sqls){
			map.put("sqlGbn",sql);
			result +=  cmmServiceDAO.deleteData(map);
		}
		
		return result;
	}


	public String insertData(HashMap map) throws Exception {
		
		String[] sqls = ((String)map.get("sqlGbn")).split(",");
		String result ="";
		for(String sql:sqls){
			map.put("sqlGbn",sql);
			result +=  cmmServiceDAO.insertData(map)+",";
			System.out.println("------------->  map : " + map);
		}
		
		result = result.substring(0 , result.lastIndexOf(","));
		
		return result;
	}


	@Override
	public String writeHistory(HashMap param) throws Exception {
		return  cmmServiceDAO.writeHistory(param);
	}


}
