package egovframework.rte.dsdsm.cmm.service.impl;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Service;

import egovframework.rte.dsdsm.cmm.service.CommonDataService;

@Service("CommonDataService")
public class CommonDataServiceImpl implements CommonDataService{
	
	@Resource(name="CommonDataDAO")
	private CommonDataDAO commonDataDAO;
	
	Logger log = LogManager.getLogger();

	@Override
	public Map<String, Object> getMenu(Map<String, Object> map)  throws Exception{

		
		return commonDataDAO.getMenu(map);
	}
	
	@Override
	public Map<String, Object> getCode(Map<String, Object> map)  throws Exception{

		
		return commonDataDAO.getCode(map);
	}
	
	@Override
	public Map<String, Object> getCodeWithshtnm(Map<String, Object> map)  throws Exception{

		
		return commonDataDAO.getCodeWithshtnm(map);
	}	
	
	@SuppressWarnings("rawtypes")	
	public List getDeptCode()  throws Exception{

		
		return commonDataDAO.getDeptCode();
	}
	
	@SuppressWarnings("rawtypes")
	public List getUserList()  throws Exception{

		
		return commonDataDAO.getUserList();
	}	
	
	@Override
	public Map<String, Object> getEnv(List<String> list) throws Exception {
		Map<String,Object> result = new HashMap<String,Object>();
		
		Map<String,Object> map = new HashMap<String,Object>();
		map.put("list", list);
		
		@SuppressWarnings("unchecked")
		List<Map<String,Object>> resultList = commonDataDAO.getEnv(map);
		
		for (Map<String,Object> row : resultList) {
			
			log.debug("ENV_NAME="+row.get("envName")+",ENV_VALUE="+row.get("envValue"));
			
			result.put((String)row.get("envName"),row.get("envValue"));
			
		}
		
		return result;
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List<Map<String, Object>> getEnvForModify() throws Exception {
		return commonDataDAO.getEnv(null);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List<Map<String, Object>> getPortlet() throws Exception {
		return commonDataDAO.getPortlet(null);
	}
	
	public void updateEnv(List<Map<String,Object>> list) throws Exception {
		commonDataDAO.updateEnv(list);
	}
	
	public void updatePortlet(Map<String,String> map) throws Exception {
		commonDataDAO.updatePortlet(map);
	}
	
	public void updateSrJob(Map<String,String> map) throws Exception {
		commonDataDAO.updateSrJob(map);
	}
}
