package egovframework.rte.dsdsm.cmm.util;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.psl.dataaccess.util.EgovMap;
import kr.dogfoot.hwplib.object.HWPFile;
import kr.dogfoot.hwplib.object.bodytext.Section;
import kr.dogfoot.hwplib.object.bodytext.control.Control;
import kr.dogfoot.hwplib.object.bodytext.control.ControlTable;
import kr.dogfoot.hwplib.object.bodytext.control.ControlType;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.CtrlHeaderGso;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.gso.HeightCriterion;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.gso.HorzRelTo;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.gso.ObjectNumberSort;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.gso.RelativeArrange;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.gso.TextFlowMethod;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.gso.TextHorzArrange;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.gso.VertRelTo;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.gso.WidthCriterion;
import kr.dogfoot.hwplib.object.bodytext.control.ctrlheader.sectiondefine.TextDirection;
import kr.dogfoot.hwplib.object.bodytext.control.gso.textbox.LineChange;
import kr.dogfoot.hwplib.object.bodytext.control.gso.textbox.TextVerticalAlignment;
import kr.dogfoot.hwplib.object.bodytext.control.table.Cell;
import kr.dogfoot.hwplib.object.bodytext.control.table.DivideAtPageBoundary;
import kr.dogfoot.hwplib.object.bodytext.control.table.ListHeaderForCell;
import kr.dogfoot.hwplib.object.bodytext.control.table.Row;
import kr.dogfoot.hwplib.object.bodytext.control.table.Table;
import kr.dogfoot.hwplib.object.bodytext.paragraph.Paragraph;
import kr.dogfoot.hwplib.object.bodytext.paragraph.charshape.ParaCharShape;
import kr.dogfoot.hwplib.object.bodytext.paragraph.header.ParaHeader;
import kr.dogfoot.hwplib.object.bodytext.paragraph.lineseg.LineSegItem;
import kr.dogfoot.hwplib.object.bodytext.paragraph.lineseg.ParaLineSeg;
import kr.dogfoot.hwplib.object.bodytext.paragraph.text.ParaText;
import kr.dogfoot.hwplib.object.docinfo.BorderFill;
import kr.dogfoot.hwplib.object.docinfo.CharShape;
import kr.dogfoot.hwplib.object.docinfo.FaceName;
import kr.dogfoot.hwplib.object.docinfo.borderfill.BackSlashDiagonalShape;
import kr.dogfoot.hwplib.object.docinfo.borderfill.BorderThickness;
import kr.dogfoot.hwplib.object.docinfo.borderfill.BorderType;
import kr.dogfoot.hwplib.object.docinfo.borderfill.SlashDiagonalShape;
import kr.dogfoot.hwplib.object.docinfo.borderfill.fillinfo.PatternFill;
import kr.dogfoot.hwplib.object.docinfo.borderfill.fillinfo.PatternType;
import kr.dogfoot.hwplib.object.docinfo.charshape.EmphasisSort;
import kr.dogfoot.hwplib.object.docinfo.charshape.OutterLineSort;
import kr.dogfoot.hwplib.object.docinfo.charshape.ShadowSort;
import kr.dogfoot.hwplib.object.docinfo.charshape.UnderLineSort;
import kr.dogfoot.hwplib.reader.HWPReader;
import kr.dogfoot.hwplib.tool.objectfinder.ControlFilter;
import kr.dogfoot.hwplib.tool.objectfinder.ControlFinder;
import kr.dogfoot.hwplib.writer.HWPWriter;

public class DataToHwpConverter {
	
	private HWPFile hwpFile;
	private ControlTable table;
	private Row row;
	private Cell cell;
	private int borderFillIDForCell;
	private  String hwpPath ="";
	
	private int charShapeIndexForNormal;
	private int charShapeIndexForBold;
	private int faceNameIndexForBatang;
	/*
	public static void main(String[] args) throws Exception {
		DataToHwpConverter converter = new DataToHwpConverter();
		boolean hwpFileCheck  = converter.tempFileCheck(); // 템플릿 파일이 있는지 확인한다. 
		if(!hwpFileCheck ){
			System.out.println("템플릿 파일을 서버에 업로드 해 주세요!!!");
		}else{
			converter.dataTohwp("");
		}
	}
	*/
	
	
	public String  weekReportTohwp(List data) throws Exception{

		
		String result = "";
		
		boolean hwpFileCheck  = tempFileCheck(); // 템플릿 파일이 있는지 확인한다.
		
		faceNameIndexForBatang = createFaceNameForBatang();
		charShapeIndexForNormal = createCharShape(false);
		charShapeIndexForBold = createCharShape(true);
		
		
		if(!hwpFileCheck ){
			result = "템플릿 파일을 서버에 업로드 해 주세요!!!";
		}else{
			
			//jsonStr = "[{\"weekRptId\":\"201902050210\", \"seq\":1, \"rqOrg\":\"국세청\", \"currSubj\":\"세금 계산 조정\", \"currCont\":\"변경된 세법에 맞추어 세금 계산 재조정\", \"currProgress\":0, \"nextSubj\":\"세금 계산 조정\", \"nextCont\":\"\", \"nextProgress\":100, \"compGbn\":\" \", \"compDttm\":\"2019-03-08\", \"notes\":\"\", \"regrDttm\":\"2019-02-28\", \"userId\":\"admin        \", \"sortIndex\":1, \"delGbn\":\"N\", \"jobName\":\"국세청업무\", \"weekSeq\":10, \"jobCd\":\"00000000000210\", \"reportDay\":\"2019년 03월 08일\"}]";
			//JSONArray data = toJson(jsonStr);

				hwpWriteTitle((EgovMap)data.get(0));
				makeTable();
				contentWriteCell(data);
				
				
				EgovMap jobData = (EgovMap)data.get(0);
				
				jobData.put("jobName", "전체 업무");
				
				saveAsWeekReport(jobData);
			
				System.out.println(data);
				
			result ="ok";
			
		}
		
		return result;
	}
	
	
	public String  dataTohwp(List data) throws Exception{
		

		
		String result = "";
		
		boolean hwpFileCheck  = tempFileCheck(); // 템플릿 파일이 있는지 확인한다.
		
		faceNameIndexForBatang = createFaceNameForBatang();
		charShapeIndexForNormal = createCharShape(false);
		charShapeIndexForBold = createCharShape(true);
		
		
		if(!hwpFileCheck ){
			result = "템플릿 파일을 서버에 업로드 해 주세요!!!";
		}else{
			
			//jsonStr = "[{\"weekRptId\":\"201902050210\", \"seq\":1, \"rqOrg\":\"국세청\", \"currSubj\":\"세금 계산 조정\", \"currCont\":\"변경된 세법에 맞추어 세금 계산 재조정\", \"currProgress\":0, \"nextSubj\":\"세금 계산 조정\", \"nextCont\":\"\", \"nextProgress\":100, \"compGbn\":\" \", \"compDttm\":\"2019-03-08\", \"notes\":\"\", \"regrDttm\":\"2019-02-28\", \"userId\":\"admin        \", \"sortIndex\":1, \"delGbn\":\"N\", \"jobName\":\"국세청업무\", \"weekSeq\":10, \"jobCd\":\"00000000000210\", \"reportDay\":\"2019년 03월 08일\"}]";
			//JSONArray data = toJson(jsonStr);
			
			hwpWriteTitle((EgovMap)data.get(0));
			makeTable();
			contentWriteCell(data);
			
			saveAs((EgovMap)data.get(0));
			
			result ="ok";
			
		}
		
		return result;
	}
	
	public DataToHwpConverter() {
		this.hwpPath = EgovProperties.getProperty("Globals.hwpTemplatePath");
	}
	
	private void saveAsWeekReport(EgovMap map) throws Exception{
		
		String jobCd   =  (String)map.get("jobCd") ;
		//String writePath = hwpPath+"WeekAll"+File.separator+ "WeeklyReportAll"+jobCd+".hwp";
		String writePath = hwpPath+"WeekAll"+File.separator+ "WeeklyReportAll.hwp";
		
		File oldHwpFile = new File(writePath);
		if(oldHwpFile.exists()){
			oldHwpFile.delete();
		}
		
		HWPWriter.toFile(hwpFile, writePath);
	}
	
	
	private void saveAs(EgovMap map) throws Exception{
		
		String jobCd   =  (String)map.get("jobCd") ;
		
		File savePath = new File(hwpPath+jobCd);
		
		if(!savePath.exists()){
			savePath.mkdir();
		}
		
		String writePath = hwpPath+jobCd+File.separator+ "WeeklyReport.hwp";
		
		File oldHwpFile = new File(writePath);
		if(oldHwpFile.exists()){
			oldHwpFile.delete();
		}
		HWPWriter.toFile(hwpFile, writePath);
	}
 
	
	// 한글 주간보고 템플릿이 서버에 업로드 되어 있는지 확인한다.
	private boolean tempFileCheck() throws Exception{
		boolean fileExist = false;
		File path = new File(hwpPath);
		
		if(!path.exists()){
			path.mkdir();
		}
		// 한글 주간보고 템플릿 파일.
		File hwpTemplate = new File(hwpPath+"report-format.hwp");
		if(hwpTemplate.exists()){
			fileExist = true;
			this.hwpFile   =  HWPReader.fromFile(hwpPath+"report-format.hwp");
		}
		return fileExist;
	}
	
	
    // 한글파일에 주간 보고 일자와 업무명을 기록한다.
	private void hwpWriteTitle(EgovMap map) throws UnsupportedEncodingException{
		
		int weekSeq   =  (int)map.get("weekSeq") ;
		String jobName   =  (String)map.get("jobName") ;
		String reportDay =  (String)map.get("reportDay") ;
		
		HwpTableFilter filter = new HwpTableFilter();
		ArrayList<Control> result = ControlFinder.find(hwpFile,  filter);
		
		ControlTable reportTargetTable =  (ControlTable)result.get(0);

		// HWP 파일에 보고 년 월 일 주차를 기록한다.
		Row firstRow = reportTargetTable.getRowList().get(0);
		Cell firstCell = firstRow.getCellList().get(0);
		Paragraph reportTitle =  firstCell.getParagraphList().getParagraph(0);
		reportTitle.getText().addString(reportDay+" [ "+reportDay.substring(0, 4)+"년 " +weekSeq+"주차 ]");
			
		// HWP 파일에 업무명을 기록한다.
		Row  secondRow  = reportTargetTable.getRowList().get(1);
		Cell secondCell = secondRow.getCellList().get(0);
		Paragraph workTitle =  secondCell.getParagraphList().getParagraph(0);
		workTitle.getText().addString(jobName);
		
		
	}

	// 주간보고를 기록할 테이블 속성을 셋팅한다.
    private void makeTable() {
    	//한글파일에 주간 보고 table 추가
		createTableControlAtFirstParagraph();
		setCtrlHeaderRecord(); 
		setTableRecordFor2By2Cells();
	}

    // 한글파일에 주간 보고 table 추가
	private void createTableControlAtFirstParagraph() {
		  
		ReportContentFilter filter = new ReportContentFilter();
		ArrayList<Control> result = ControlFinder.find(hwpFile,  filter);
		
		ControlTable reportTargetTable =  (ControlTable)result.get(0);

		Row firstRow = reportTargetTable.getRowList().get(0);
		Cell firstCell = firstRow.getCellList().get(0);
		Paragraph firstParagraph =  firstCell.getParagraphList().getParagraph(0);
		
		firstParagraph.deleteText();  // 안에 있는 글자 내용을 지워준다.
		firstParagraph.createText();  // 글자를 써넣기 위해 새로 생성한다.
		
				
		// 문단에서 표 컨트롤의 위치를 표현하기 위한 확장 문자를 넣는다.
		firstParagraph.getText().addExtendCharForTable();
		
		// 문단에 표 컨트롤 추가한다.
		table = (ControlTable) firstParagraph.addNewControl(ControlType.Table);
		
		
	}

	private void setCtrlHeaderRecord() {
		CtrlHeaderGso ctrlHeader = table.getHeader();
		ctrlHeader.getProperty().setLikeWord(false);
		ctrlHeader.getProperty().setApplyLineSpace(false);
		ctrlHeader.getProperty().setVertRelTo(VertRelTo.Para);
		ctrlHeader.getProperty().setVertRelativeArrange(RelativeArrange.TopOrLeft);
		ctrlHeader.getProperty().setHorzRelTo(HorzRelTo.Para);
		ctrlHeader.getProperty().setHorzRelativeArrange(RelativeArrange.TopOrLeft);
		ctrlHeader.getProperty().setVertRelToParaLimit(true);		
		ctrlHeader.getProperty().setAllowOverlap(false);
		ctrlHeader.getProperty().setWidthCriterion(WidthCriterion.Absolute);
        ctrlHeader.getProperty().setHeightCriterion(HeightCriterion.Absolute);
        ctrlHeader.getProperty().setProtectSize(false);
        ctrlHeader.getProperty().setTextFlowMethod(TextFlowMethod.Tight);
        ctrlHeader.getProperty().setTextHorzArrange(TextHorzArrange.BothSides);
        ctrlHeader.getProperty().setObjectNumberSort(ObjectNumberSort.Table);
        
        
 	}
	
	private long mmToHwp(double mm) {
		return (long)(mm * 72000.0f / 254.0f + 0.5f);
	}

	private void setTableRecordFor2By2Cells() {
		Table tableRecord = table.getTable();
		
		tableRecord.getProperty().setDivideAtPageBoundary(DivideAtPageBoundary.DivideByCell);
		tableRecord.getProperty().setAutoRepeatTitleRow(false);
		tableRecord.setRowCount(1);
		tableRecord.setColumnCount(2);
		tableRecord.setCellSpacing(0);
		tableRecord.setLeftInnerMargin(0); 
		tableRecord.setRightInnerMargin(0);
		tableRecord.setTopInnerMargin(0);
		tableRecord.setBottomInnerMargin(0);
		
		tableRecord.setBorderFillId(getBorderFillIDForTableOutterLine());
	}

	private int getBorderFillIDForTableOutterLine() {
		BorderFill bf =  hwpFile.getDocInfo().addNewBorderFill();
		
        bf.getProperty().set3DEffect(false);
        bf.getProperty().setShadowEffect(false);
        bf.getProperty().setSlashDiagonalShape(SlashDiagonalShape.None);
        bf.getProperty().setBackSlashDiagonalShape(BackSlashDiagonalShape.None);
        
        bf.getLeftBorder().setType(BorderType.Solid);
        bf.getLeftBorder().setThickness(BorderThickness.MM0_5);
        bf.getLeftBorder().getColor().setValue(0x0);
        
        bf.getRightBorder().setType(BorderType.None);
        bf.getRightBorder().setThickness(BorderThickness.MM0_5);
        bf.getRightBorder().getColor().setValue(0x2);
        
        bf.getTopBorder().setType(BorderType.None);
        bf.getTopBorder().setThickness(BorderThickness.MM0_5);
        bf.getTopBorder().getColor().setValue(0x3);
        
        bf.getBottomBorder().setType(BorderType.None);
        bf.getBottomBorder().setThickness(BorderThickness.MM0_5);
        bf.getBottomBorder().getColor().setValue(0x4);
        
        bf.setDiagonalSort(BorderType.None);
        bf.setDiagonalThickness(BorderThickness.MM0_5);
        bf.getDiagonalColor().setValue(0x0);
        
        bf.getFillInfo().getType().setPatternFill(true);
        bf.getFillInfo().createPatternFill();
        
        
        PatternFill pf = bf.getFillInfo().getPatternFill();
        pf.setPatternType(PatternType.None);
        pf.getBackColor().setValue(-1);
        pf.getPatternColor().setValue(0);
        
        
        return hwpFile.getDocInfo().getBorderFillList().size();
	}

	private void contentWriteCell(List data) {
		
		for(int i = 0; i < data.size() ; i++){
			//System.out.println( ((JSONObject)data.get(i)).get("weekRptId") );
			addRow(i ,  (EgovMap)data.get(i));
		}
	}

	private int getBorderFillIDForCellRight() {
		BorderFill bf =  hwpFile.getDocInfo().addNewBorderFill();
        
		bf.getProperty().set3DEffect(false);
        bf.getProperty().setShadowEffect(false);
        
        bf.getProperty().setSlashDiagonalShape(SlashDiagonalShape.None);
        bf.getProperty().setBackSlashDiagonalShape(BackSlashDiagonalShape.None);
        
        bf.getLeftBorder().setType(BorderType.None);
        bf.getLeftBorder().setThickness(BorderThickness.MM0_1);
        bf.getLeftBorder().getColor().setValue(0xA6A6A6);
        
        bf.getRightBorder().setType(BorderType.Solid);
        bf.getRightBorder().setThickness(BorderThickness.MM0_1);
        bf.getRightBorder().getColor().setValue(0xA6A6A6);
        
        bf.getTopBorder().setType(BorderType.Solid);
        bf.getTopBorder().setThickness(BorderThickness.MM0_1);
        bf.getTopBorder().getColor().setValue(0xA6A6A6);
        
        bf.getBottomBorder().setType(BorderType.Solid);
        bf.getBottomBorder().setThickness(BorderThickness.MM0_1);
        bf.getBottomBorder().getColor().setValue(0xA6A6A6);        
        
        bf.setDiagonalSort(BorderType.None);
        bf.setDiagonalThickness(BorderThickness.MM0_1);;
        bf.getDiagonalColor().setValue(0xA6A6A6);
        
        bf.getFillInfo().getType().setPatternFill(true);
        bf.getFillInfo().createPatternFill();
        
        
        PatternFill pf = bf.getFillInfo().getPatternFill();
        pf.setPatternType(PatternType.None);
        pf.getBackColor().setValue(-1);
        pf.getPatternColor().setValue(0);
        
        
        return hwpFile.getDocInfo().getBorderFillList().size();
	}
	
	private int getBorderFillIDForCellLeft() {
		BorderFill bf =  hwpFile.getDocInfo().addNewBorderFill();
        
		bf.getProperty().set3DEffect(false);
        bf.getProperty().setShadowEffect(false);
        
        bf.getProperty().setSlashDiagonalShape(SlashDiagonalShape.None);
        bf.getProperty().setBackSlashDiagonalShape(BackSlashDiagonalShape.None);
        
        bf.getLeftBorder().setType(BorderType.Solid);
        bf.getLeftBorder().setThickness(BorderThickness.MM0_1);
        bf.getLeftBorder().getColor().setValue(0xA6A6A6);
        
        bf.getRightBorder().setType(BorderType.Dot);
        bf.getRightBorder().setThickness(BorderThickness.MM0_1);
        bf.getRightBorder().getColor().setValue(0xA6A6A6);
        
        bf.getTopBorder().setType(BorderType.Solid);
        bf.getTopBorder().setThickness(BorderThickness.MM0_1);
        bf.getTopBorder().getColor().setValue(0xA6A6A6);
        
        bf.getBottomBorder().setType(BorderType.Solid);
        bf.getBottomBorder().setThickness(BorderThickness.MM0_1);
        bf.getBottomBorder().getColor().setValue(0xA6A6A6);        
        
        bf.setDiagonalSort(BorderType.None);
        bf.setDiagonalThickness(BorderThickness.MM0_1);;
        bf.getDiagonalColor().setValue(0xA6A6A6);
        
        bf.getFillInfo().getType().setPatternFill(true);
        bf.getFillInfo().createPatternFill();
        
        PatternFill pf = bf.getFillInfo().getPatternFill();
        pf.setPatternType(PatternType.None);
        pf.getBackColor().setValue(-1);
        pf.getPatternColor().setValue(0);
        
        return hwpFile.getDocInfo().getBorderFillList().size();
	}
	
	

	private void addRow(int index, EgovMap map) {
		row = table.addNewRow();
		
		borderFillIDForCell = getBorderFillIDForCellLeft();
		addLeftTopCell(index , map);
		
		borderFillIDForCell = getBorderFillIDForCellRight();
		addRightTopCell(index , map);
	}

	private void addLeftTopCell(int index , EgovMap map) {
		cell = row.addNewCell();
		
		// index번째 줄에 0번째 셀 => 0이 첫번째임
		setListHeaderForCell(0, index);
		
		String currSubj      = ((String)map.get("currSubj"));
		String rqOrg         = ((String)map.get("rqOrg"));
		String currCont      = ((String)map.get("currCont"));
		String compDttm      = ((String)map.get("compDttm"));
		int currProgress     = ((int)map.get("currProgress"));
		
		StringBuffer content = new StringBuffer();
		
		//replace(/(?:\r\n|\r|\n)/g, '<br/>&nbsp;&nbsp;&nbsp;ㆍ')
		
		if(!currSubj.equals("") ){
			content.append("\n☉ "+currSubj);
			content.append("\n - 요청처 : "+rqOrg);
			content.append("\n - 내용 :");
			content.append("\n  ⚬"+currCont.replaceAll("(?:\r\n|\r|\n)", "\n  ⚬"));
			content.append("\n - 완료 예정일 : "+compDttm+" [진행률 : "+currProgress+"%]");
			content.append("\n");
		}else{
			content.append("\n☉ 특이사항 없음");
			content.append("\n");
		}
		
		cell.getListHeader().getProperty().setTextVerticalAlignment(TextVerticalAlignment.Top);
		setParagraphForCell(content.toString());
	}
	
	
	private void addRightTopCell(int index , EgovMap map) {
		cell = row.addNewCell();
		
		setListHeaderForCell(1, index);
		
		//replace(/(?:\r\n|\r|\n)/g, '<br/>&nbsp;&nbsp;&nbsp;ㆍ')
		
		String nextSubj      = ((String)map.get("nextSubj"));
		String rqOrg         = ((String)map.get("rqOrg"));
		String nextCont      = ((String)map.get("nextCont"));
		String compDttm      = ((String)map.get("compDttm"));
		int nextProgress     = ((int)map.get("nextProgress"));
		
		String currSubj      = ((String)map.get("currSubj"));
		String currCont      = ((String)map.get("currCont"));
		
		
		StringBuffer content = new StringBuffer();
		
		if(!nextSubj.equals("") ){
			content.append("\n☉ "+nextSubj);
			if(currCont.equals("")  ){
				content.append("\n - 요청처 : "+rqOrg);
    		}
    		if( !nextCont.equals("") &&  currSubj.equals(nextSubj) ){
    			content.append("\n - 내용 :");
    			content.append("\n  ⚬"+nextCont.replaceAll("(?:\r\n|\r|\n)", "\n  ⚬"));
    		}
			content.append("\n - 예상 진행률 : "+nextProgress+"%");
			content.append("\n");
		}else{
			content.append("\n☉ 특이사항 없음");
			content.append("\n");
		}
		
		//content.append("\n☉ 복지 기준액 조정 요청");
		//content.append("\n - 예상 진행률 :100%");
		//content.append("\n");
		
		cell.getListHeader().getProperty().setTextVerticalAlignment(TextVerticalAlignment.Top);
		setParagraphForCell(content.toString());
	}
	

	private void setListHeaderForCell(int colIndex, int rowIndex) {
		ListHeaderForCell lh = cell.getListHeader();
        lh.setParaCount(1);
        lh.getProperty().setTextDirection(TextDirection.Horizontal);
        lh.getProperty().setLineChange(LineChange.Normal);
        lh.getProperty().setTextVerticalAlignment(TextVerticalAlignment.Center);
        lh.getProperty().setProtectCell(false);
        lh.getProperty().setEditableAtFormMode(false);
        lh.setColIndex(colIndex);
        lh.setRowIndex(rowIndex);
        lh.setColSpan(1);
        lh.setRowSpan(1);
        lh.setWidth(mmToHwp(82));
        //lh.setHeight(mmToHwp(30.0));
        lh.setLeftMargin(0);
        lh.setRightMargin(0);
        lh.setTopMargin(0);
        lh.setBottomMargin(0);        
        lh.setBorderFillId(borderFillIDForCell);
        lh.setTextWidth(mmToHwp(50.0));
        lh.setFieldName("");
        
        
       
	}

	private void setParagraphForCell(String text) {
		Paragraph p = cell.getParagraphList().addNewParagraph();
		setParaHeader(p);
		setParaText(p, text);
		setParaCharShape(p);
		setParaLineSeg(p);
		
	}

	private void setParaHeader(Paragraph p) {
		ParaHeader ph = p.getHeader();
		
		ph.setLastInList(true);
		// 셀의 문단 모양을 이미 만들어진 문단 모양으로 사용함
		
		ph.setParaShapeId(1);	
		// 셀의 스타일을이미 만들어진 스타일으로 사용함
		
		ph.setStyleId((short) 1);;
		ph.getDivideSort().setDivideSection(false);
		ph.getDivideSort().setDivideMultiColumn(false);
		ph.getDivideSort().setDividePage(false);
		ph.getDivideSort().setDivideColumn(false);
		ph.setCharShapeCount(1);
		ph.setRangeTagCount(0);
		ph.setLineAlignCount(1);
		ph.setInstanceID(0);
		ph.setIsMergedByTrack(0);
	}

	private void setParaText(Paragraph p, String text2) {
		p.createText();
		ParaText pt = p.getText();
		
		int paragraphStartPos = 0;
		
		p.createCharShape();

		ParaCharShape pcs = p.getCharShape();
		pcs.addParaCharShape(paragraphStartPos, createCharShape(false));
		
		try {
			pt.addString(text2);
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void setParaCharShape(Paragraph p) {
		//p.createCharShape();
	
		//ParaCharShape pcs = p.getCharShape();
		// 셀의 글자 모양을 이미 만들어진 글자 모양으로 사용함
		p.createCharShape();
		
		int paragraphStartPos = 0;
		
		ParaCharShape pcs = p.getCharShape();
		pcs.addParaCharShape(paragraphStartPos, charShapeIndexForNormal);
		
		//pcs.addParaCharShape(0, 1);
		
		
		
		
		
		//int boldStartPos = 20;
		//int boldEndPos = 28;
		//pcs.addParaCharShape(boldStartPos, charShapeIndexForBold);
		//pcs.addParaCharShape(boldEndPos, charShapeIndexForNormal);
	}


	private void setParaLineSeg(Paragraph p) {
		p.createLineSeg();
		
		ParaLineSeg pls = p.getLineSeg();
		LineSegItem lsi = pls.addNewLineSegItem();
		
		lsi.setTextStartPositon(0);
		lsi.setLineVerticalPosition(0);
		lsi.setLineHeight(ptToLineHeight(10.0));
		lsi.setTextPartHeight(ptToLineHeight(10.0));
		lsi.setDistanceBaseLineToLineVerticalPosition(ptToLineHeight(10.0 * 0.85));
		lsi.setLineSpace(ptToLineHeight(3.0));
		lsi.setStartPositionFromColumn(0);
		lsi.setSegmentWidth((int) mmToHwp(50.0));
		lsi.getTag().setFirstSegmentAtLine(true);
		lsi.getTag().setLastSegmentAtLine(true);
	}
	
	private int ptToLineHeight(double pt) {
		return (int) (pt * 100.0f);
	}
	// 테이블안에 "ReportContent"표기되어 있는부분에 주간보고서 내용을 작성하여 넣는다. 
	public class ReportContentFilter implements ControlFilter {
		@Override
		public boolean isMatched(Control control, Paragraph paragrpah,	Section section) {
			// 컨트롤이 테이블이고
			if (control.getType() == ControlType.Table) {
				ControlTable table = (ControlTable) control;
				Row firstRow = table.getRowList().get(0);
				Cell firstCell = firstRow.getCellList().get(0);
				try {
					if (firstCell.getParagraphList().getNormalString().startsWith("ReportContent")) {
						System.out.println("Report Target Table.....");
						return true;
					}
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return false;
		}
	}
	
	//  문서안에 테이블 필터링 
	public class HwpTableFilter implements ControlFilter {
		@Override
		public boolean isMatched(Control control, Paragraph paragrpah,	Section section) {
			// 컨트롤이 테이블이고
			if (control.getType() == ControlType.Table) {
				return true;
			}
			return false;
		}
	}
	
	
	private int createFaceNameForBatang() {
		FaceName fn;

		// 한글 부분을 위한 FaceName 객체를 생성한다. (create FaceName Object for hangul part.)
		fn = hwpFile.getDocInfo().addNewHangulFaceName();
		setFaceNameForBatang(fn);

		// 영어 부분을 위한 FaceName 객체를 생성한다. (create FaceName Object for english part.)
		fn = hwpFile.getDocInfo().addNewEnglishFaceName();
		setFaceNameForBatang(fn);

		// 한자 부분을 위한 FaceName 객체를 생성한다. (create FaceName Object for hanja(Chinese)
		// part.)
		fn = hwpFile.getDocInfo().addNewHanjaFaceName();
		setFaceNameForBatang(fn);

		// 일본어 부분을 위한 FaceName 객체를 생성한다.(create FaceName Object for japanse part.)
		fn = hwpFile.getDocInfo().addNewJapaneseFaceName();
		setFaceNameForBatang(fn);

		// 기타 문자 부분을 위한 FaceName 객체를 생성한다.(create FaceName Object for etc part.)
		fn = hwpFile.getDocInfo().addNewEtcFaceName();
		setFaceNameForBatang(fn);

		// 기호 문자 부분을 위한 FaceName 객체를 생성한다.(create FaceName Object for symbol part.)
		fn = hwpFile.getDocInfo().addNewSymbolFaceName();
		setFaceNameForBatang(fn);

		// 사용자 정의 문자 부분을 위한 FaceName 객체를 생성한다.(create FaceName Object for user part.)
		fn = hwpFile.getDocInfo().addNewUserFaceName();
		setFaceNameForBatang(fn);

		return hwpFile.getDocInfo().getHangulFaceNameList().size() - 1;
	}

	private void setFaceNameForBatang(FaceName fn) {
		String fontName = "맑은 고딕";
		fn.getProperty().setHasBaseFont(false);
		fn.getProperty().setHasFontInfo(false);
		fn.getProperty().setHasSubstituteFont(false);
		fn.setName(fontName);
	}
	
	private int createCharShape(boolean bold) {
		CharShape cs = hwpFile.getDocInfo().addNewCharShape();
		// 바탕 폰트를 위한 FaceName 객체를 링크한다. (link FaceName Object for 'Batang' font.)
		cs.getFaceNameIds().setForAll(faceNameIndexForBatang);

		cs.getRatios().setForAll((short) 100);
		cs.getCharSpaces().setForAll((byte) 0);
		cs.getRelativeSizes().setForAll((short) 100);
		cs.getCharOffsets().setForAll((byte) 0);
		cs.setBaseSize(ptToBaseSize(10));

		cs.getProperty().setItalic(false);
		cs.getProperty().setBold(bold);
		cs.getProperty().setUnderLineSort(UnderLineSort.None);
		cs.getProperty().setOutterLineSort(OutterLineSort.None);
		cs.getProperty().setShadowSort(ShadowSort.None);
		cs.getProperty().setEmboss(false);
		cs.getProperty().setEngrave(false);
		cs.getProperty().setSuperScript(false);
		cs.getProperty().setSubScript(false);
		cs.getProperty().setStrikeLine(false);
		cs.getProperty().setEmphasisSort(EmphasisSort.None);
		cs.getProperty().setUsingSpaceAppropriateForFont(false);
		cs.getProperty().setStrikeLineShape(BorderType.None);
		cs.getProperty().setKerning(false);

		cs.setShadowGap1((byte) 0);
		cs.setShadowGap2((byte) 0);
		cs.getCharColor().setValue(0x00000000);
		cs.getUnderLineColor().setValue(0x00000000);
		cs.getShadeColor().setValue(-1);
		cs.getShadowColor().setValue(0x00b2b2b2);
		cs.setBorderFillId(0);

		return hwpFile.getDocInfo().getCharShapeList().size() - 1;
	}
	

	private int ptToBaseSize(int pt) {
		return pt * 100;
	}

}
/*
private void addSecondRow() {
	row = table.addNewRow();
	addLeftBottomCell();
	addRightBottomCell();
}


private void addLeftBottomCell() {
	cell = row.addNewCell();
	setListHeaderForCell(0, 1);
	setParagraphForCell("왼쪽 아래 셀");		
}

private void addRightBottomCell() {
	cell = row.addNewCell();
	setListHeaderForCell(1, 1);
	setParagraphForCell("오른쪽 아래 셀");
}
*/