package egovframework.rte.dsdsm.cmm.web;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Row;
import org.json.simple.JSONArray;
import org.json.simple.JSONValue;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.util.FileCopyUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.cmm.util.StrUtil;
import egovframework.rte.dsdsm.messenger.util.MessengerUtil;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Controller("CmmController")
public class CmmController {

	@Resource(name="DisFileMng")
	private  DisFileMng disFileMng;
   
	@Resource(name="CmmService")
	private CmmService cmmService;
   
	@RequestMapping(value = "/download/downloadFile.do")
	public void downloadFile(
			@RequestParam(value = "requestedFile") String requestedFile,
			@RequestParam(value = "oriFilenm") String oriFilenm,
			HttpServletResponse response) throws Exception {
 
		String uploadPath = EgovProperties.getProperty("Globals.fileStorePath");
 
		File uFile = new File(uploadPath, requestedFile);
		int fSize = (int) uFile.length();
		
		System.out.println("fsize = " + fSize);
		
		if (fSize > 0) {
 
			BufferedInputStream in = new BufferedInputStream(
					new FileInputStream(uFile));
			String mimetype = "text/html";
 
			response.setBufferSize(fSize);
			response.setContentType(mimetype);
			response.setHeader("Content-Disposition", "attachment; filename=\""
					+ oriFilenm + "\"");
			response.setContentLength(fSize);
 
			FileCopyUtils.copy(in, response.getOutputStream());
			in.close();
			response.getOutputStream().flush();
			response.getOutputStream().close();
		} else {
			//setContentType을 프로젝트 환경에 맞추어 변경
			response.setContentType("application/x-msdownload");
			PrintWriter printwriter = response.getWriter();
			printwriter.println("<html>");
			printwriter.println("<br><br><br><h2>Could not get file name:<br>"
					+ requestedFile + "</h2>");
			printwriter
					.println("<br><br><br><center><h3><a href='javascript: history.go(-1)'>Back</a></h3></center>");
			printwriter.println("<br><br><br>&copy; webAccess");
			printwriter.println("</html>");
			printwriter.flush();
			printwriter.close();
		}
	}

   /**
	 * 공지사항 등록 화면으로 이동
	 * 
	 * @param response
	 *            , request, defaultVO, model
	 * @return dsacc/pas/pasList
	 * @exception Exception
	 */                      
	@RequestMapping(value = "/notice/noticeWrite.do")
	public ModelAndView noticeWrite(HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
    	ModelAndView mv = new ModelAndView();
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	String sid = request.getParameter("sid");
    	List<String> roleList =  (List<String>) session.getAttribute("ROLES");
    	mv.addObject("hasRole","N");
    	if(roleList != null) { 				
    		if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
    	}
    	
    	if(sid != null) {
			map.put("sid", sid);
	    	mv.addObject("result",cmmService.selectNoticeDtl(map));		    		
	    	mv.addObject("sid", sid);
    	}
    	
		mv.setViewName("dsdsm/bbs/noticeReg");
		return mv;
	}	 		

	
	/**
	 * 공지사항 등록
	 * @param request
	 * @param model
	 * @param session
	 * @return
	 * @throws Exception
	 */
	@RequestMapping(value = "/notice/noticeRegist.json")
	public String noticeRegist(HttpServletRequest request, Model model, HttpSession session) throws Exception {
		ModelAndView mv = new ModelAndView();
		
		String usrId 	        = request.getParameter("usrId");
		String ntSubj 	        = request.getParameter("ntSubj");
		String ntCont 	        = request.getParameter("ntCont");
		String popYn 	        = request.getParameter("popYn");
		String dispStartDate 	= request.getParameter("dispStartDate");
		String dispEndDate 	= request.getParameter("dispEndDate");
		String newYn 	= request.getParameter("newYn");
		String sid 	= request.getParameter("sid");
		String openYn 	= request.getParameter("openYn");
		
		
		/*		if(dispStartDate != null) dispStartDate = dispStartDate.replaceAll("-", "");
				if(dispEndDate != null) dispEndDate = dispEndDate.replaceAll("-", "");*/

		HashMap<Object, Object> map = new HashMap<Object, Object>();
		
		map.put("usrId", usrId);	
		map.put("ntSubj", ntSubj);	
		map.put("ntCont", ntCont); 
		map.put("popYn", popYn); 
		map.put("openYn", openYn); 
		map.put("dispStartDate", dispStartDate); 
		map.put("dispEndDate", dispEndDate); 
		
		if(newYn.equals("Y")) { //신규 등록
			String _atchFileId = "";
			//_atchFileId = disFileMng.fileUpload("NOT_",request);
			map.put("addFileId", _atchFileId);
			model.addAttribute("sid", cmmService.insertNotice(map));
		} else { //수정
			map.put("sid", sid);
			cmmService.updateNotice(map);
			model.addAttribute("sid",sid);
		}
		
		Map userInfos    = (Map)session.getAttribute("userInfo");
		String name      = (String)userInfos.get("name");
		
		String msg ="";
			msg +="\n  ▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒";
			msg +="\n  ▣ [시스템 알림 - 공지사항 게시판 ]";
			msg +="\n    제목 : "+ntSubj;
			msg +="\n    작성자 :"+ name;
			msg +="\n    내용 : ";
			msg +="\n    "+ntCont.replaceAll("<(/)?([a-zA-Z]*)(\\s[a-zA-Z]*=[^>]*)?(\\s)*(/)?>", "");
			msg +="\n  ▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒";
		
		//oepnfire server에  전체메시지 전달.
		MessengerUtil.sendAllUserMsg(msg);
		
    	return "jsonView";
	}			
	
	
	/* 공지사항 목록 화면으로 이동*/		 
	@RequestMapping(value = "/notice/noticeList.do")
	public ModelAndView noticeList(HttpServletResponse response,HttpServletRequest request, HttpSession session) throws Exception {			
		System.out.println("/notice/noticeList.do");
			
		ModelAndView mv = new ModelAndView();
 
	    List<String> roleList=  (List<String>) session.getAttribute("ROLES");
		mv.addObject("hasRole","N");
		if(roleList != null) { 				
			if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
		}
		
    	mv.setViewName("dsdsm/bbs/noticeList");
		return mv;
	}
	
	
	
	/* 공지사항 목록 조회*/
	@RequestMapping(value = "/notice/getNoticeList.do")
	public ModelAndView getNoticeList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
		ModelAndView mv = new ModelAndView();
		HashMap<Object, Object> map = new HashMap<Object, Object>();
		HashMap<Object, Object> pagingMap = new HashMap<Object, Object>();
		 
		String inqTitle = request.getParameter("inqTitle");
		String inqUserNm = request.getParameter("inqUserNm");
		
		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		  
		map.put("inqTitle", inqTitle);
		map.put("inqUserNm", inqUserNm);
		
		int listCount = cmmService.selectNoticeListCnt(map);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);				
		
		
		map.put("listCount" , listCount);
		map.put("start"     , (int) (pageNo-1)*pageSize+1);
		map.put("end"       , (int) pageNo*pageSize);

		List list = cmmService.selectNoticeList(map);
		
		pagingMap.put("pageNo",pageNo);
		pagingMap.put("pageSize",pageSize);
		pagingMap.put("pageCount",pageCount);
		pagingMap.put("listCount",listCount);
		
		
		model.addAttribute("list",list);
		model.addAttribute("page",pagingMap);

        mv.setView(new JsonView());
		return mv;
	}
	
	   /**
	 * 공지사항 상세 화면으로 이동
	 * 
	 * @param response
	 *            , request, defaultVO, model
	 * @return dsacc/pas/pasList
	 * @exception Exception
	 */                      
	@RequestMapping(value = "/notice/noticeView.do")
	public ModelAndView noticeView(HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
		
		ModelAndView mv = new ModelAndView();
		HashMap<Object, Object> map = new HashMap<Object, Object>();
		
		String sid    = request.getParameter("sid");
		String msgGbn = request.getParameter("msgGbn");
		System.out.println("★★★★ ### noticeView.do sid="+sid);
		
		 
    	List<String> roleList=  (List<String>) session.getAttribute("ROLES");
		mv.addObject("hasRole","N");
		if(roleList != null) { 				
			if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
		}
		
		map.put("sid", sid);
		
    	mv.addObject("sid"   , sid);
    	mv.addObject("msgGbn", msgGbn);
    	mv.addObject("result", cmmService.selectNoticeDtl(map));
    	//mv.addObject("addFileList", cmmService.selectBbsAddFileList(map));
    	
    	System.out.println("★"+mv.toString());
    	mv.setViewName("dsdsm/bbs/noticeView");
		return mv;
	}		
	
	/**
	 * 공지사항 삭제
	 * @param request
	 * @param model
	 * @param session
	 * @return
	 * @throws Exception
	 */
	@RequestMapping(value = "/notice/noticeDelete.json")
	public String noticeDelete(HttpServletRequest request, Model model, HttpSession session) throws Exception {
		ModelAndView mv = new ModelAndView();
		String sid 	= request.getParameter("sid");
		String usrId 	= request.getParameter("usrId");
		
		HashMap<Object, Object> map = new HashMap<Object, Object>();
		
		map.put("sid", sid);
		map.put("usrId", usrId);			
		
		//disFileMng.fileDelete(request);
  
			cmmService.deleteNotice(map);
			 
			return "jsonView";
	}					
	
	
	   /**
		 * FAQ 등록 화면으로 이동
		 * 
		 * @param response
		 *            , request, defaultVO, model
		 * @return dsacc/pas/pasList
		 * @exception Exception
		 */                      
		@RequestMapping(value = "/faq/faqWrite.do")
		public ModelAndView faqWrite(HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
	    	ModelAndView mv = new ModelAndView();
	    	HashMap<Object, Object> map = new HashMap<Object, Object>();
	    	String sid = request.getParameter("sid");
	    	List<String> roleList =  (List<String>) session.getAttribute("ROLES");
	    	mv.addObject("hasRole","N");
	    	if(roleList != null) { 				
	    		if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
	    	}
	    	
	    	if(sid != null) {
				map.put("sid", sid);
		    	mv.addObject("result",cmmService.selectFaqDtl(map));
		    	map.put("bbs", "faq");
		    	mv.addObject("addFileList", cmmService.selectBbsAddFileList(map));				    	
		    	mv.addObject("sid", sid);
	    	}
	    	
			mv.setViewName("dsdsm/bbs/faqReg");
			return mv;
		}	 		
	
		
		/**
		 * FAQ 등록
		 * @param request
		 * @param model
		 * @param session
		 * @return
		 * @throws Exception
		 */
		@RequestMapping(value = "/faq/faqRegist.json")
		public String faqRegist(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			
			System.out.println("###### faqRegist.do");
			 
			String usrId 	= request.getParameter("usrId");
			String ntSubj 	= request.getParameter("ntSubj");
			String ntCont 	= request.getParameter("ntCont");
			String newYn 	= request.getParameter("newYn");
			String sid 	= request.getParameter("sid");
			
			
/*				if(dispStartDate != null) dispStartDate = dispStartDate.replaceAll("-", "");
				if(dispEndDate != null) dispEndDate = dispEndDate.replaceAll("-", "");*/
			
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			map.put("usrId", usrId);	
			map.put("ntSubj", ntSubj);	
			map.put("ntCont", ntCont); 
			
			if(newYn.equals("Y")) { //신규 등록
				String _atchFileId = "";
				_atchFileId = disFileMng.fileUpload("FAQ_",request);
				map.put("addFileId", _atchFileId);
				model.addAttribute("sid", cmmService.insertFaq(map));
			} else { //수정
				disFileMng.fileDelete(request);
		    	String _atchFileId = "";
				_atchFileId = disFileMng.fileUpload("FAQ_",request);
				//if(_atchFileId != null) 
				
				System.out.println();
				map.put("addFileId", _atchFileId);
				
				map.put("sid", sid);
				cmmService.updateFaq(map);
				
				model.addAttribute("sid",sid);
			}
	    	return "jsonView";
		}			
		
		
		/* FAQ 목록 화면으로 이동*/		 
		@RequestMapping(value = "/faq/faqList.do")
		public ModelAndView faqList(HttpServletResponse response,HttpServletRequest request, HttpSession session) throws Exception {			
			System.out.println("/faq/faqList.do");
			
			ModelAndView mv = new ModelAndView();
 
	    	List<String> roleList=  (List<String>) session.getAttribute("ROLES");
			mv.addObject("hasRole","N");
			if(roleList != null) { 				
				if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
			}
			
	    	mv.setViewName("dsdsm/bbs/faqList");
			return mv;
		}
		
		/* FAQ 목록 조회*/
		@RequestMapping(value = "/faq/getFaqList.do")
		public ModelAndView getfaqList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			HashMap<Object, Object> pagingMap = new HashMap<Object, Object>();
			 
			String inqTitle = request.getParameter("inqTitle");
			String inqUserNm = request.getParameter("inqUserNm");
			
			float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
			float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
			
			  
			map.put("inqTitle", inqTitle);
			map.put("inqUserNm", inqUserNm);
			
			int listCount = cmmService.selectFaqListCnt(map);	
			
			int pageCount = (int) Math.ceil(listCount / pageSize);				
			
			map.put("start", (int) (pageNo-1)*pageSize+1);
			map.put("end", (int) pageNo*pageSize);

			List list = cmmService.selectFaqList(map);
			
			pagingMap.put("pageNo",pageNo);
			pagingMap.put("pageSize",pageSize);
			pagingMap.put("pageCount",pageCount);
			pagingMap.put("listCount",listCount);
			
			
			model.addAttribute("list",list);
			model.addAttribute("page",pagingMap);

	        mv.setView(new JsonView());
			return mv;
		}		
		
		   /**
		 * FAQ 상세 화면으로 이동
		 * 
		 * @param response
		 *            , request, defaultVO, model
		 * @return dsacc/pas/pasList
		 * @exception Exception
		 */                      
		@RequestMapping(value = "/faq/faqView.do")
		public ModelAndView faqView(HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
			
			ModelAndView mv = new ModelAndView();
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			String sid = request.getParameter("sid");
			System.out.println("★★★★ ### faqView.do sid="+sid);
			
			 
	    	List<String> roleList=  (List<String>) session.getAttribute("ROLES");
			mv.addObject("hasRole","N");
			if(roleList != null) { 				
				if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
			}
			
			map.put("sid", sid);
	    	mv.addObject("sid", sid);
	    	mv.addObject("result",cmmService.selectFaqDtl(map));
	    	map.put("bbs", "faq");
	    	mv.addObject("addFileList", cmmService.selectBbsAddFileList(map));
	    	System.out.println("★"+mv.toString());
	    	mv.setViewName("dsdsm/bbs/faqView");
			return mv;
		}		
		
		/**
		 * FAQ 삭제
		 * @param request
		 * @param model
		 * @param session
		 * @return
		 * @throws Exception
		 */
		@RequestMapping(value = "/faq/faqDelete.json")
		public String faqDelete(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			
			
			System.out.println("###### faqDelete.do");

			String sid 	= request.getParameter("sid");
			String usrId 	= request.getParameter("usrId");
			
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			map.put("sid", sid);
			map.put("usrId", usrId);			
			
			System.out.println("##########################################");
			System.out.println(map.toString());
			
			disFileMng.fileDelete(request);
  
			cmmService.deleteFaq(map);
			 
			return "jsonView";
		}					
				
	   /**
		 * 자료실 등록 화면으로 이동
		 * 
		 * @param response
		 *            , request, defaultVO, model
		 * @return dsacc/pas/pasList
		 * @exception Exception
		 */                      
		@RequestMapping(value = "/archive/archiveWrite.do")
		public ModelAndView archiveWrite(HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
	    	ModelAndView mv = new ModelAndView();
	    	HashMap<Object, Object> map = new HashMap<Object, Object>();
	    	String sid = request.getParameter("sid");
	    	List<String> roleList =  (List<String>) session.getAttribute("ROLES");
	    	mv.addObject("hasRole","N");
	    	if(roleList != null) { 				
	    		if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
	    	}
	    	
	    	if(sid != null) {		    	
				map.put("sid", sid);
		    	mv.addObject("result",cmmService.selectArchiveDtl(map));
		    	map.put("bbs", "archive");
		    	mv.addObject("addFileList", cmmService.selectBbsAddFileList(map));			    	
		    	mv.addObject("sid", sid);
	    	}
	    	
			mv.setViewName("dsdsm/bbs/archiveReg");
			return mv;
		}	 		
	
		
		/**
		 * 자료실 등록
		 * @param request
		 * @param model
		 * @param session
		 * @return
		 * @throws Exception
		 */
		@RequestMapping(value = "/archive/archiveRegist.json")
		public String archiveRegist(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();

			String usrId 	= request.getParameter("usrId");
			String ntSubj 	= request.getParameter("ntSubj");
			String ntCont 	= request.getParameter("ntCont");
			String newYn 	= request.getParameter("newYn");
			String sid 	= request.getParameter("sid");
			
/*				if(dispStartDate != null) dispStartDate = dispStartDate.replaceAll("-", "");
				if(dispEndDate != null) dispEndDate = dispEndDate.replaceAll("-", "");*/
			
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			map.put("usrId", usrId);	
			map.put("ntSubj", ntSubj);	
			map.put("ntCont", ntCont); 

			System.out.println(map.toString());
			 
			if(newYn.equals("Y")) { //신규 등록
				String _atchFileId = "";
				_atchFileId = disFileMng.fileUpload("NOT_",request);
				map.put("addFileId", _atchFileId);
				model.addAttribute("sid", cmmService.insertArchive(map));
			} else { //수정
				disFileMng.fileDelete(request);
		    	String _atchFileId = "";
				_atchFileId = disFileMng.fileUpload("ARC_",request);
				if(_atchFileId != null) 	map.put("addFileId", _atchFileId);
				
				map.put("sid", sid);
				cmmService.updateArchive(map);
				model.addAttribute("sid",sid);
			}
	    	return "jsonView";
		}			
		
		
		/* 자료실 목록 화면으로 이동*/		 
		@RequestMapping(value = "/archive/archiveList.do")
		public ModelAndView archiveList(HttpServletResponse response,HttpServletRequest request, HttpSession session) throws Exception {			
			System.out.println("/archive/archiveList.do");
			
			ModelAndView mv = new ModelAndView();
 
	    	List<String> roleList=  (List<String>) session.getAttribute("ROLES");
			mv.addObject("hasRole","N");
			if(roleList != null) { 				
				if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
			}
			
	    	mv.setViewName("dsdsm/bbs/archiveList");
			return mv;
		}
		
		
		
		/* 자료실 목록 조회*/
		@RequestMapping(value = "/archive/getArchiveList.do")
		public ModelAndView getarchiveList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			HashMap<Object, Object> pagingMap = new HashMap<Object, Object>();
			 
			String inqTitle = request.getParameter("inqTitle");
			String inqUserNm = request.getParameter("inqUserNm");
			
			float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
			float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
			
			  
			map.put("inqTitle", inqTitle);
			map.put("inqUserNm", inqUserNm);
			
			int listCount = cmmService.selectArchiveListCnt(map);	
			
			int pageCount = (int) Math.ceil(listCount / pageSize);				
			
			map.put("start", (int) (pageNo-1)*pageSize+1);
			map.put("end", (int) pageNo*pageSize);

			List list = cmmService.selectArchiveList(map);
			
			pagingMap.put("pageNo",pageNo);
			pagingMap.put("pageSize",pageSize);
			pagingMap.put("pageCount",pageCount);
			pagingMap.put("listCount",listCount);
			
			
			model.addAttribute("list",list);
			model.addAttribute("page",pagingMap);

	        mv.setView(new JsonView());
			return mv;
		}		
		
		   /**
		 * 자료실 상세 화면으로 이동
		 * 
		 * @param response
		 *            , request, defaultVO, model
		 * @return dsacc/pas/pasList
		 * @exception Exception
		 */                      
		@RequestMapping(value = "/archive/archiveView.do")
		public ModelAndView archiveView(HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
			
			ModelAndView mv = new ModelAndView();
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			String sid = request.getParameter("sid");
			 
	    	List<String> roleList=  (List<String>) session.getAttribute("ROLES");
			mv.addObject("hasRole","N");
			if(roleList != null) { 				
				if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
			}
			
			map.put("sid", sid);
	    	mv.addObject("sid", sid);
	    	mv.addObject("result",cmmService.selectArchiveDtl(map));
	    	map.put("bbs", "archive");
	    	mv.addObject("addFileList", cmmService.selectBbsAddFileList(map));

	    	mv.setViewName("dsdsm/bbs/archiveView");
			return mv;
		}		
		
		/**
		 * 자료실 삭제
		 * @param request
		 * @param model
		 * @param session
		 * @return
		 * @throws Exception
		 */
		@RequestMapping(value = "/archive/archiveDelete.json")
		public String archiveDelete(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			
			
			System.out.println("###### archiveDelete.do");

			String sid 	= request.getParameter("sid");
			String usrId 	= request.getParameter("usrId");
			
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			map.put("sid", sid);
			map.put("usrId", usrId);			
			
			System.out.println("##########################################");
			System.out.println(map.toString());
			
			disFileMng.fileDelete(request);
  
			cmmService.deleteArchive(map);
			 
			return "jsonView";
		}		
		
		/**
		 * 채팅방 파일 업로드
		 * @param request
		 * @param model
		 * @param session
		 * @return
		 * @throws Exception
		 */
		@RequestMapping(value = "/chat/uploadFile.json")
		public String uploadFile(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			
			System.out.println("######Chat uploadFile.do");
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			String atchFileId = "";
			atchFileId = disFileMng.fileUpload("CHT_",request);
			map.put("atchFileId", atchFileId);
			
			model.addAttribute("addFile", cmmService.selectChatAddFileList(map));
			return "jsonView";
		}
		
 
		/* 쪽지 목록 조회*/
		@RequestMapping(value = "/msg/getMsgList.do")
		public ModelAndView getMsgList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			HashMap<Object, Object> pagingMap = new HashMap<Object, Object>();
			 
			String inqFrom = request.getParameter("inqFrom");
			String inqTo   = request.getParameter("inqTo");
			
			
			float pageNo =   Integer.parseInt( (request.getParameter("pageNo")!=null?request.getParameter("pageNo"):"1").toString()) ;
			float pageSize = Integer.parseInt( (request.getParameter("pageSize")!=null?request.getParameter("pageSize"):"20").toString());
			
			Map userInfo = (Map) session.getAttribute("userInfo");
			map.put("userId", userInfo.get("userId"));
			
			map.put("inqSrchType", request.getParameter("inqSrchType"));
			map.put("inqUserNm", request.getParameter("inqUserNm"));
			map.put("inqCont", request.getParameter("inqCont"));
			map.put("inqRead", request.getParameter("inqRead"));
			
			if(inqFrom!=null) {
				map.put("inqFrom", inqFrom.replaceAll("-", ""));
			}
			if(inqTo!=null) {
			map.put("inqTo", inqTo.replaceAll("-", ""));
			}
			
			int listCount = cmmService.selectMsgListCnt(map);	
			int pageCount = (int) Math.ceil(listCount / pageSize);				
			
			map.put("start", (int) (pageNo-1)*pageSize+1);
			map.put("end", (int) pageNo*pageSize);

			List list = cmmService.selectMsgList(map);
			
			pagingMap.put("pageNo",pageNo);
			pagingMap.put("pageSize",pageSize);
			pagingMap.put("pageCount",pageCount);
			pagingMap.put("listCount",listCount);
			
			
			model.addAttribute("list",list);
			model.addAttribute("page",pagingMap);

	        mv.setView(new JsonView());
			return mv;
		}	
		
		/* 미확인 쪽지 개수 조회*/
		@RequestMapping(value = "/msg/getUnreadMsgCnt.json")
		public ModelAndView getUnreadMsgCnt(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			HashMap<Object, Object> map = new HashMap<Object, Object>();
		
			Map userInfo = (Map) session.getAttribute("userInfo");
			map.put("userId", userInfo.get("userId"));
			List result = cmmService.selectUnreadCnt(map);
			model.addAttribute("unreadCnt",result.get(0));
	        mv.setView(new JsonView());
			return mv;
		}	
		
		
		/* 쪽지 삭제 */
		@RequestMapping(value = "/msg/removeMsg.json")
		public ModelAndView removeMsg(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			Map userInfo = (Map) session.getAttribute("userInfo");
			map.put("userId", userInfo.get("userId"));
			map.put("msgId", request.getParameter("msgId"));
			mv.addObject("result", cmmService.deleteMsg(map));
	        mv.setView(new JsonView());
			return mv;
		}		
		
		/**
		 * 쪽지 등록
		 * @param request
		 * @param model
		 * @param session
		 * @return
		 * @throws Exception
		 */
		@RequestMapping(value = "/msg/sendMessage.json")
		public String sendMessage(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			Map userInfo = (Map) session.getAttribute("userInfo");
			System.out.println("###### sendMessage.json");			
			
			String msgCont 	= request.getParameter("msgCont");
			String tempYn 	= request.getParameter("tempYn");
			
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			map.put("userId", userInfo.get("userId"));
			map.put("msgCont", msgCont);	
			map.put("tempYn", tempYn);
			map.put("recvId", request.getParameterValues("recvId"));
			
			if(tempYn.equals("N")) { //전송
				String _atchFileId = "";
				_atchFileId = disFileMng.fileUpload("MSG_",request);
				map.put("addFileId", _atchFileId);
				String msgId = "";
				msgId = cmmService.insertMsg(map);
				map.put("msgId", msgId);
				System.out.println("###########MSGID### :"+map.toString());
				cmmService.insertMsgRecv(map);
				
			} else { //임시저장
		    	String _atchFileId = "";
				_atchFileId = disFileMng.fileUpload("MSG_",request);
				if(_atchFileId != null) 	map.put("addFileId", _atchFileId);
				cmmService.insertMsg(map);
			}
	    	return "jsonView";
		}		
		
		   /**
		 * 쪽지 상세화면
		 * 
		 * @param response
		 *            , request, model
		 * @return dsdsm/msg/popMsgView
		 * @exception Exception
		 */                      
		@RequestMapping(value = "/msg/msgView.do")
		public ModelAndView msgView(HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
			
			ModelAndView mv = new ModelAndView();
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			Map userInfo = (Map) session.getAttribute("userInfo");
			map.put("userId", userInfo.get("userId"));
			String msgId = request.getParameter("msgId");
			String srchType = request.getParameter("inqSrchType");
			System.out.println("★★★★/msg/msgView.do ="+msgId+srchType);
			
			map.put("msgId", msgId);
			map.put("srchType", srchType);
			if(srchType.equals("receive")) cmmService.updateMsgRead(map);
	    	mv.addObject("result",cmmService.selectMsgDtl(map));	    	
	    	mv.addObject("recvList",cmmService.selectMsgDtlRecv(map));
	    	mv.addObject("addFileList", cmmService.selectMsgAtchFileList(map));
	    	mv.addObject("srchType", srchType);
	    	System.out.println("★"+mv.toString());
	    	mv.setViewName("dsdsm/msg/popMsgView");
			return mv;
		}		
		
		
		
		@RequestMapping(value="/cmm/getCmmSelectList.do")
		public String selectCmmJsonList(HttpSession session, ModelMap model, @RequestParam Map<String,Object> param) throws Exception{
			
			HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();
	
			int pageNo   = Integer.parseInt((String)param.get("pageNo"));
			int pageSize = Integer.parseInt((String)param.get("pageSize"));
			int listCount = cmmService.selectCmmJsonListCnt(param);	
			int pageCount = (int) Math.ceil(listCount / pageSize);
			
			pageinMap.put("pageNo",pageNo);
			pageinMap.put("pageSize",pageSize);
			pageinMap.put("pageCount",pageCount);
			pageinMap.put("listCount",listCount);
			
			param.put("start", (int) (pageNo-1)*pageSize+1);
			param.put("end"  , (int) pageNo*pageSize);
			param.put("listCount",listCount);
			
    		System.out.println("########################## Param Start ###############################");
    		Set s = param.keySet();
    		Iterator info = s.iterator();
    		while(info.hasNext()){
    			String key =(String)info.next();
    			if(key.equals("JsonList")){
    				param.put(key, toJson( (String)param.get(key)) );
    			}
    			if(key.equals("arrayList")){
    				param.put(key,  ((String)param.get(key)).split("#") );
    			}
    			System.out.println( "["+key+"] : "+ param.get(key) );
    		}
    		System.out.println("########################## Param End   ###############################");
			
			
			Map userInfos = (Map)session.getAttribute("userInfo");
    		param.put("businessId", userInfos.get("businessId"));
    		
			System.out.println((pageNo-1)*pageSize+1);
			System.out.println(pageNo*pageSize);
			
			
			List list = cmmService.selectCmmJsonList(param);	
	 	  	model.put("list",list);
	 	  	model.put("page",pageinMap);
			return "jsonView";
		}
		
		
	   
	    
	    @RequestMapping(value="/cmm/updateData.do")
	    public String updateData(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
	    	
	    		@SuppressWarnings("rawtypes")
	    		Map userInfos = (Map)session.getAttribute("userInfo");
	    		ArrayList roloes = (ArrayList)session.getAttribute("ROLES");
	    		
	    		
	    		
	    		boolean roleExist = true;
	    		/*
	    		boolean roleExist = false;
	    		
	    		for(Object role: roloes){
	    			if(   ((String)role).equals("SYSMANAGER")   ){
	    				roleExist = true;
	    				break;
	    			}
	    		}
	    		*/
	    		
	    		param.put("businessId", userInfos.get("businessId"));
	    		
	    		System.out.println("########################## Param Start ###############################");
	    		Set s = param.keySet();
	    		Iterator info = s.iterator();
	    		while(info.hasNext()){
	    			String key =(String)info.next();
	    			if(key.equals("JsonList")){
	    				param.put(key, toJson( (String)param.get(key)) );
	    			}
	    			if(key.equals("arrayList")){
	    				param.put(key,  ((String)param.get(key)).split("#") );
	    			}
	    			System.out.println( "["+key+"] : "+ param.get(key) );
	    		}
	    		System.out.println("########################## Param End   ###############################");
	    		
	    		
	    		
	    		if( roleExist  ){
	    			int cnt = cmmService.updateData((HashMap)param);
	    			
	    			modelmap.put("result","ok");
	    			modelmap.put("cnt",cnt);
	    		}else{
	    			modelmap.put("result", "warning");
	    			modelmap.put("warningMsg","작성자, 수정권한이 있는 사람만 가능합니다.");
	    		}
				//proService.deleteLastHis((HashMap)param);
			    
			    //modelmap.put("owner", (String)reqMap.get("owner"));
			    //modelmap.put("tableNm", (String)reqMap.get("tableNm"));
			
				
			return "jsonView";
	    }
	    
	    
	    
	    @RequestMapping(value="/cmm/insertData.do")
	    public String insertData(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
	    	
	    		@SuppressWarnings("rawtypes")
	    		Map userInfos        = (Map)session.getAttribute("userInfo");
	    		String loginId       = (String)userInfos.get("loginId");
	    		String deptId        = (String)userInfos.get("deptId");
	    		String businessId    = (String)userInfos.get("businessId");
	    		String userId    = (String)userInfos.get("userId");
	    		
	    		param.put("loginId"    , loginId);
	    		param.put("userId"     , userId);
	    		param.put("deptId"     , deptId);
	    		param.put("businessId" , businessId);
	    		
	    		ArrayList roloes = (ArrayList)session.getAttribute("ROLES");
	    		
	    		boolean adminGbn = false;
	    		
	    		/*
	    		for(Object role: roloes){
	    			if(   ((String)role).equals("SYSMANAGER")  ){
	    				adminGbn = true;
	    				break;
	    			}
	    		}
	    		*/
	    		
	    		Set s = param.keySet();
	    		Iterator info = s.iterator();

	    		while(info.hasNext()){
	    			String key =(String)info.next();
	    			if(key.equals("JsonList")){
	    				param.put(key, toJson( (String)param.get(key)) );
	    			}
	    			if(key.equals("arrayList")){
	    				param.put(key,  ((String)param.get(key)).split("#") );
	    			}
	    			System.out.println( "["+key+"] : "+ param.get(key) );
	    			
	    		}

				String returnStr = cmmService.insertData((HashMap)param);
				
				modelmap.put("result" , returnStr);
				
			return "jsonView";
	    }
	    
	    
	    @RequestMapping(value="/cmm/deleteData.do")
	    public String deleteData(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
	    	
	    		@SuppressWarnings("rawtypes")
	    		Map userInfo    = (Map)session.getAttribute("userInfo");
	    		String loginId   = (String)userInfo.get("loginId");
	    		
	    		param.put("loginId", loginId);
	    		param.put("busniseId", userInfo.get("businessId"));
	    		
	    		ArrayList roloes = (ArrayList)session.getAttribute("ROLES");
	    		
	    		boolean adminGbn = false;
	    		
	    		/*
	    		for(Object role: roloes){
	    			if(   ((String)role).equals("SYSMANAGER")  ){
	    				adminGbn = true;
	    				break;
	    			}
	    		}
	    		*/

				int returnStr = cmmService.deleteData((HashMap)param);
				modelmap.put("result" , returnStr);
				
			return "jsonView";
	    }
	    
	    
		@RequestMapping(value="/cmm/getCmmJsonDetail.do")
		public String getCmmJsonDetail(HttpSession session, ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
			
			Map userInfo = (Map)session.getAttribute("userInfo");

			param.put("ROLES",session.getAttribute("ROLES"));
	    	param.put("deptId", userInfo.get("deptId"));
	    	param.put("userId", userInfo.get("userId"));
	    	param.put("loginId", userInfo.get("loginId"));
	    	param.put("busniseId", userInfo.get("businessId"));
	    	
	    	
	    	
			System.out.println("########################## Param Start ###############################");
			Set s = param.keySet();
			Iterator info = s.iterator();
			while(info.hasNext()){
				String key =(String)info.next();
				if(key.equals("JsonList")){
				}
				System.out.println( "["+key+"] : "+ param.get(key) );
			}
			System.out.println("########################## Param End ###############################");
			
			List cmmJsonList = cmmService.selectCmmJsonList(param);
			
			map.put("detail", cmmJsonList);
			map.put("result", "ok");
			map.put("msg", "");
			
			return "jsonView";
		}
		
	    @RequestMapping(value="/cmm/printPreView.do")
	    public String printPreview() throws Exception{
	    	return "/dsdsm/cmmn/printPreview";
	    }
	    
	    @RequestMapping(value="/cmm/deptManagement.do")
	    public String deptManagement(HttpServletRequest request,  Model model, HttpSession session) throws Exception {
	    	return "/dsdsm/cmmn/deptManagement";
	    }
	    
	    @RequestMapping(value="/cmm/roleManagement.do")
	    public 	String roleManagement(HttpServletRequest request,  Model model, HttpSession session) throws Exception {
	    	return "/dsdsm/cmmn/roleManagement";
	    }
	    
	    private JSONArray toJson(String jsonStr){
	    		System.out.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
	    		System.out.println(jsonStr);
	    		System.out.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
	         JSONArray lstJson = null;
		     if(jsonStr != null && !jsonStr.equals("")){
			      
			      try {

			          Object obj = JSONValue.parseWithException(jsonStr);
			          lstJson = (JSONArray)obj;

			      } catch (Exception e) {
			       e.printStackTrace();
			      }
		     }
	    	
	    	return  lstJson;
	    }
	    
	    @RequestMapping(value="/cmm/setMenuInfo.do")
	    public String setMenuInfo(HttpSession session, ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
	    	//System.out.println("param.get(menuId):"+param.get("menuId"));
	    	session.setAttribute("menuInfo", param.get("menuId"));
	    	return "jsonView";
	    }
	    
	    
	@RequestMapping(value = "/cmm/excelDownload.do")
	public String excelDownload(HttpSession session, ModelMap map, @RequestParam Map<String, Object> param)	throws Exception {
		
		// System.out.println("param.get(menuId):"+param.get("menuId"));
		session.setAttribute("menuInfo", param.get("menuId"));
		
		String sheetName = StrUtil.nvl((String)param.get("sheetName") , "New");
		String template  = StrUtil.nvl((String)param.get("template")  , "BlankTemplate");
		
		int startCellX = Integer.parseInt(StrUtil.nvl((String)param.get("startCellX") , "0"));
		int startCellY = Integer.parseInt(StrUtil.nvl((String)param.get("startCellY") , "0"));
		
		//System.out.println("########################################");
		//System.out.println(startCellX);
		//System.out.println(startCellY);
		
		
		//eduTitle="+$("#ntSubj").text()+"&eduPlace="+$("#eduPlace").text()"&eduTime="+$("#eduTime").text();
		List<EgovMap> list = cmmService.selectCmmJsonList(param);	
		
		System.out.println(list.toString());

		try {

			FileInputStream fileIn = new FileInputStream(EgovProperties.getProperty("Globals.excelTemplatePath")+template+".xls");// 파일 열어서 읽기
			HSSFWorkbook wb = new HSSFWorkbook(fileIn);

			// 1번째 시트(엑셀기준)
			HSSFSheet sheet = wb.getSheetAt(0);

			// 시트에 이름지정
			wb.setSheetName(0, sheetName);
			
			
			/*
			// 1번째 로우(엑셀기준)
			Row row1 = sheet.getRow(startCellY);
			//System.out.println("StartLinst:"+startPointY);
			System.out.println(row1.getCell(startCellX).getStringCellValue());
			 */
			
			Row eduTitleLine = sheet.getRow(1);
				eduTitleLine.getCell(3).setCellValue(" "+(String)param.get("eduTitle"));
			
			Row eduTimeLine  = sheet.getRow(2);
			eduTimeLine.getCell(3).setCellValue(" "+(String)param.get("eduTime"));
				
			Row eduPlaceLine = sheet.getRow(3);
				eduPlaceLine.getCell(3).setCellValue(" "+(String)param.get("eduPlace"));
			

			
			
			
			for(int i =0; i<list.size(); i++){
				// 기존에 데이터를 가져올 경우 getRow, getCell 새로운 줄 삽입은 create 사용.. create를 사용안하면 NullPointException 발생
				Row newRow = sheet.createRow(startCellY+i+2);
				EgovMap userMap = list.get(i);
				
				for(int idx=0;idx<userMap.size();idx++){
					
					//System.out.println(idx);
					newRow.createCell(startCellX+1).setCellValue(i+1);// 내용변경
					newRow.createCell(startCellX+2).setCellValue((String)userMap.get("deptName"));// 내용변경
					newRow.createCell(startCellX+3).setCellValue((String)userMap.get("name"));// 내용변경
				}
				
			}

			wb.setForceFormulaRecalculation(true); // 엑셀 수식 재계산
			String FileName = sheetName+".xls";
			FileOutputStream fileOut = new FileOutputStream(EgovProperties.getProperty("Globals.excelTemplatePath")+FileName, false); // 엑셀파일 저장경로
			wb.write(fileOut);// 파일에 저장
			fileOut.close();

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return "jsonView";
	}
	
    @RequestMapping(value="/cmm/excelImpoter.do")
    public String excelImporter(HttpSession session, ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
    	return "/dsdsm/cmmn/PmsExcelImporter";
    }
    
    @RequestMapping(value="/cmm/inetCmmJs.do")
    public String inetCmmjsPage(HttpSession session, ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
    	return "/js/inetCmmJs";
    }
    
    /**
     * 공통코트를 가져온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/cmmcode/getCmmCode.do")
	public String getCmmCode(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> map = new HashMap<Object, Object>();
		
		map.put("codeId", param.get("codeId"));

		model.addAttribute("cmmCode",cmmService.getCmmDitcList(map));
 	  	
		return "jsonView";
	}
	
	
	@RequestMapping(value = "/cmm/fileUpload.do")
	public String fileUpload(HttpServletRequest request, @RequestParam HashMap<Object,Object> param, ModelMap model, HttpSession session) throws Exception {
		

		
		Calendar cal = Calendar.getInstance();
		
		String yyyy  = cal.get(Calendar.YEAR)+"";
		String mm    = (cal.get(Calendar.MONTH)<10 ? "0"+cal.get(Calendar.MONTH):cal.get(Calendar.MONTH))  +"";
		String dd    = (cal.get(Calendar.DATE)<10?"0"+cal.get(Calendar.DATE):"")+"";
		String menuId = StrUtil.NVL((String)session.getAttribute("menuInfo"));
		String subDir = yyyy+mm+dd;
		String uploadPath = EgovProperties.getProperty("Globals.fileStorePath")+subDir+"/"+menuId+"/";
		
		File path = new File(uploadPath);
		
		if(!path.exists()){
			boolean mk = path.mkdirs();
		}

		String actionCmd = (String)param.get("actionCommand");

		if(actionCmd.equals("insert")) { //신규 등록
			String keyStr ="/"+subDir+"/"+menuId+"/";
			String atchFileId = disFileMng.fileUpload(keyStr,request);
			model.addAttribute("addFileId", atchFileId);
		}
	
    	return "jsonView";
	}		
	
	
	@RequestMapping(value = "/download/getFileInetType.do")
	public void getFileInetType(
			@RequestParam(value = "fileId") String fileId,
			@RequestParam(value = "fileSn") String fileSn,
			HttpServletResponse response) throws Exception {
 
		String uploadPath = EgovProperties.getProperty("Globals.fileStorePath");
 
		Map<String,Object> param = new HashMap();
		
		
		param.put("sqlGbn", "inet.selectFileInfo");
		param.put("atchFileId" , fileId);
		param.put("fileSn"     , fileSn);
		
		List fileData = cmmService.selectCmmJsonList(param);
		
		
		EgovMap fileInfo = (EgovMap)fileData.get(0);
		
		String requestedFile = (String)fileInfo.get("streFileNm");
		String oriFileNm     = (String)fileInfo.get("orignlFileNm");
		
		File uFile = new File(uploadPath, requestedFile);
		int fSize = (int) uFile.length();
		
		System.out.println("fsize = " + fSize);
		
		if (fSize > 0) {
 
			BufferedInputStream in = new BufferedInputStream(new FileInputStream(uFile));
			
			String mimetype = "text/html; charset=UTF-8" ;
				
			response.setBufferSize(fSize);
			response.setContentType(mimetype);
			response.setHeader("Content-Disposition", "attachment; filename=\""+ URLEncoder.encode(oriFileNm, "UTF-8") +"\"");
			response.setContentLength(fSize);
 
			FileCopyUtils.copy(in, response.getOutputStream());
			in.close();
			response.getOutputStream().flush();
			response.getOutputStream().close();
		} else {
			//setContentType을 프로젝트 환경에 맞추어 변경
			response.setContentType("application/x-msdownload");
			PrintWriter printwriter = response.getWriter();
			printwriter.println("<html>");
			printwriter.println("<br><br><br><h2>Could not get file name:<br>"
					+ requestedFile + "</h2>");
			printwriter
					.println("<br><br><br><center><h3><a href='javascript: history.go(-1)'>Back</a></h3></center>");
			printwriter.println("<br><br><br>&copy; webAccess");
			printwriter.println("</html>");
			printwriter.flush();
			printwriter.close();
		}
	}

}
