package egovframework.rte.dsdsm.cmm.web;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.FillPatternType;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.codehaus.jackson.annotate.JsonProperty;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.ibm.icu.math.BigDecimal;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.service.vo.Menu;
import egovframework.rte.dsdsm.cmm.util.CryptoUtil;
import egovframework.rte.dsdsm.cmm.util.StrUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;
import egovframework.rte.dsdsm.sr.service.SrService;

@Controller
public class CommonDataController {
	
	@Resource(name="CommonDataService")
	CommonDataService commonDataService;

	@Resource(name ="CodeService")
	private CodeService codeService;
	
	@Resource(name = "SrService")
    private SrService SrService;
	
	@Resource(name="cryptoUtil")
	CryptoUtil cryptoUtil;
	
	Logger log = LogManager.getLogger();
	
	
    @RequestMapping(value="/cmm/dssdmMenuData.do")
    public String getMenuData(HttpServletRequest request,HttpSession session)  throws Exception{
    	
    	String menuJsonStr = (String)session.getAttribute("MENU");
    	
    	//log.debug(">>>>> menuJsonStr : "+menuJsonStr);
    	
    	String contextName = request.getContextPath();

    	if( menuJsonStr==null || "".equals(menuJsonStr.trim())  ){
    		menuJsonStr = this.getMenuString(session.getAttribute("ROLES"), contextName);
    		session.setAttribute("MENU", menuJsonStr);
    		session.setAttribute("menuChgGbn", "N");
    		
    	}
    	
    	request.setAttribute("LIST", menuJsonStr);
    	
    	return "/dsdsm/cmmn/menuData";
    }
    
    public String getMenuString(Object roles,String contextName) throws Exception{
    	String resultStr = "";
    	
    	Map<String,Object> map = new HashMap<String,Object>();
		map.put("ROLES", roles);
		 
		Map<String,Object> result = commonDataService.getMenu(map);
 
		@SuppressWarnings("unchecked")
		List<Menu> list = parseList((List<Map<String,Object>>)result.get("LIST"), contextName); 
		ObjectMapper mapper = new ObjectMapper();
 
		try{ 
			resultStr = mapper.writeValueAsString(list);
		}catch(Exception e){ 
			e.printStackTrace();
		}
		
		return resultStr;
    }
    
    @RequestMapping(value="/cmm/dssdmSiteData.do")
    public String getSiteData()  throws Exception{
    	return "/dsdsm/cmmn/siteData";
    }
    
    @JsonProperty
    public List<Menu> parseList (List<Map<String,Object>> list, String contextName) throws Exception{
    	
    	List<Menu> result = new ArrayList<Menu>(); 
    	
    	for(int i=0;i<list.size();i++){ 
    		Menu one = new Menu();
    		Map<String,Object> temp = list.get(i); 
    		one.set_id((String)temp.get("menuId")); 
    		one.setLabel((String)temp.get("menuName")); 
    		if(temp.get("programUrl")==null){
    			one.setUrl("javascript:fcObj.menuMove('"+(String)temp.get("menuId")+"','#');");
    		}else{
    			String url =(String)temp.get("programUrl");
    			
    			if(url.indexOf("http") > -1){
    				one.setUrl("javascript:fcObj.menuMove('"+(String)temp.get("menuId")+"','"+url+"');");
    			}else{
    				one.setUrl("javascript:fcObj.menuMove('"+(String)temp.get("menuId")+"','"+contextName+url+"');");
    			}
    		} 
    		
    		String databaseType = StrUtil.NVL(EgovProperties.getProperty("Globals.DatabaseType"),"postgres");
    		Integer level=0;
    		
    		if(databaseType.equals("oracle")){ 
        		level = Integer.parseInt((String)temp.get("lv"));
    		} else { 
        		level = (Integer)temp.get("level");
    		} 
    		
    		if( new Integer(2).equals(level) ){
    			result.add(one);
    		}else if(new Integer(2).compareTo(level)<0){
    			addList(result,one,(String)temp.get("upperMenuId"));
    		} 
    	}
    	
    	//서브메뉴가 하나일때 메뉴에도 url 멥핑
    	//for(Menu menu : result){
    	//	List<Menu> submenus = menu.getCn();
    	//	if(submenus.size()>=1){
    	//		Menu submenu = submenus.get(0);
    	//		menu.setUrl(submenu.getUrl());
    	//	}
    	//}
    	
    	return result;
    }
    
    public boolean addList (List<Menu> list,Menu one,String upperMenuId){
    	
    	boolean isAdded=false;
    	
    	if(list.size()>0){
    		for(int i=0;i<list.size();i++){
    			Menu temp = list.get(i);
    			if(temp.get_id().equals(upperMenuId)){
    				List<Menu> templist = temp.getCn();
    				if (templist == null){
    					templist = new ArrayList<Menu>();
    				}
					templist.add(one);
					temp.setCn(templist);
					isAdded=true;
					break;
    			}else{
    				if(temp.getCn()!=null){
    					if(addList(temp.getCn(),one,upperMenuId)){
    						break;
    					};
    				}
    			}
    		}
    	}else{
    		list.add(one);
    	}
    	
    	return isAdded;
    	
    }
    
    ///cop/msg/websocketMessengerMain.do
    @RequestMapping(value="/msg/listUser.do")
    public String listUser(ModelMap map) throws Exception{
    	@SuppressWarnings("rawtypes")
		List deptCodes = commonDataService.getDeptCode();
    	List userList = commonDataService.getUserList();
    	
    	ObjectMapper mapper = new ObjectMapper();
   		String deptCodesJsonStr = mapper.writeValueAsString(deptCodes);
   		
   		map.put("DEPT_CODE", deptCodesJsonStr);
   		map.put("USER_LIST", userList);
   		
    	return "/dsdsm/msg/listUser";
    }
    
    @RequestMapping(value="/cmm/emptyView.do")
    public String emptyView(){
    	return "/dsdsm/cmmn/emptyView";
    }
    
    @RequestMapping(value="/cmm/jsonError.do")
    public String jsonError(ModelMap map){
    	
    	map.put("MESSAGE", "시간이 경과하여 로그아웃 되었습니다. 다시로그인후 이용바랍니다.");
    	return "/dsdsm/cmmn/jsonError";
    }
    
    @RequestMapping(value="/cmm/modifyEnv.do")
    public String modifyEnv(ModelMap map) throws Exception{
    	map.put("ENV", commonDataService.getEnvForModify());
    	map.put("PORTLET", commonDataService.getPortlet());
    	
    	return "/dsdsm/cmmn/modifyEnv";
    }
    
    @RequestMapping(value="/cmm/modifyRolePortlet.do")
    public String modifyRolePortlet(ModelMap map, @RequestParam Map<String,String> param) throws Exception{
    	map.put("sdgbn", param.get("sdgbn"));
    	return "/dsdsm/cmmn/modifyRolePortlet";
    }
    
    
    @RequestMapping(value="/cmm/modifyEnv.json")
    public String modifyEnvResult(@RequestParam Map<String,String> param,ModelMap map) throws Exception{
    	@SuppressWarnings("rawtypes")
		Iterator it = param.keySet().iterator();
    	
    	List<Map<String,Object>> tempList = new ArrayList<Map<String,Object>>();
    	
    	while(it.hasNext()){
    		String tempParamName = (String)it.next();
    		HashMap<String,Object> tempMap = new HashMap<String,Object>();
    		
    		if(tempParamName.endsWith("_PASSWORD")){
    			
    			String encryptedString = cryptoUtil.encrypt(param.get(tempParamName));
    			
    			if("Y".equals(param.get(tempParamName+"_ISCHANGED"))){
    				param.put(tempParamName, encryptedString);
    				
    				//log.debug("decryptedString:"+cryptoUtil.decrypt(encryptedString));
    			}
    			
    			
    		}
    		tempMap.put("envName", tempParamName);
    		tempMap.put("envValue", param.get(tempParamName));
    		tempList.add(tempMap);
    	}
    	
    	commonDataService.updateEnv(tempList);
    	
    	Map<String,Object> result = new HashMap<String,Object>();
    	result.put("SUCCESS", true);
		result.put("MESSAGE", "환경설정변경완료");
		
		map.put("result",result);
    	
    	return "jsonView";
    	
    }
    
    @RequestMapping(value="/cmm/modifyPortlet.json")
    public String modifyPortletResult(@RequestParam Map<String,String> param) throws Exception{
    	commonDataService.updatePortlet(param);
    	return "jsonView";
    }
    
    @RequestMapping(value="/cmm/getJobList.json")
    public String getJobList(@RequestParam Map<String,String> param, Model map) throws Exception{
    	@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();	    	
   		map.addAttribute("JOB_LIST", jobCds);
    	return "jsonView";
    }
    
    @RequestMapping(value="/cmm/setSrJobList.json")
    public String setSrJobList(@RequestParam Map<String,String> param, Model map) throws Exception{
    	commonDataService.updateSrJob(param);
    	
    	int seq = SrService.getSrJobseq(param); 
    	
    	param.put("seq",String.valueOf(seq));
    	param.put("aftchJobCd",param.get("jobCd"));
    	
    	SrService.regJobHistory(param);
    	
    	return "jsonView";
    }
    
    /**
     * 
     */
	@RequestMapping(value = "/cmm/excelDown.do")
	public void excelDown(HttpServletResponse response, @RequestParam Map<String,String> param) throws Exception {

		// 게시판 목록조회
		//List<BoardVO> list = boardService.selectBoardList();

		// 워크북 생성
		Workbook wb = new HSSFWorkbook();
		Sheet sheet = wb.createSheet("ExcelData");
		Row row     = null;
		Cell cell   = null;

		int rowNo = 0;

		// 테이블 헤더용 스타일
		CellStyle headStyle = wb.createCellStyle();

		// 가는 경계선을 가집니다.
		headStyle.setBorderTop(BorderStyle.THIN);
		headStyle.setBorderBottom(BorderStyle.THIN);
		headStyle.setBorderLeft(BorderStyle.THIN);
		headStyle.setBorderRight(BorderStyle.THIN);

		// 배경색은 노란색입니다.
		//headStyle.setFillForegroundColor(HSSFColorPredefined.YELLOW.getIndex());
		headStyle.setFillForegroundColor(HSSFColor.YELLOW.index);
		headStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);

		// 데이터는 가운데 정렬합니다.
		headStyle.setAlignment(HorizontalAlignment.CENTER);

		// 데이터용 경계 스타일 테두리만 지정
		CellStyle bodyStyle = wb.createCellStyle();
		bodyStyle.setBorderTop(BorderStyle.THIN);
		bodyStyle.setBorderBottom(BorderStyle.THIN);
		bodyStyle.setBorderLeft(BorderStyle.THIN);
		bodyStyle.setBorderRight(BorderStyle.THIN);

		// 헤더 생성
		row = sheet.createRow(rowNo++);
		cell = row.createCell(0);
		cell.setCellStyle(headStyle);
		cell.setCellValue("번호");
		cell = row.createCell(1);
		cell.setCellStyle(headStyle);
		cell.setCellValue("이름");
		cell = row.createCell(2);
		cell.setCellStyle(headStyle);
		cell.setCellValue("제목");
		

		// 데이터 부분 생성
		/*for (BoardVO vo : list) {
			row = sheet.createRow(rowNo++);
			cell = row.createCell(0);
			cell.setCellStyle(bodyStyle);
			cell.setCellValue(vo.getNum());
			cell = row.createCell(1);
			cell.setCellStyle(bodyStyle);
			cell.setCellValue(vo.getName());
			cell = row.createCell(2);
			cell.setCellStyle(bodyStyle);
			cell.setCellValue(vo.getTitle());
		}*/

		// 컨텐츠 타입과 파일명 지정
		response.setContentType("ms-vnd/excel");
		response.setHeader("Content-Disposition", "attachment;filename=test.xls");

		// 엑셀 출력
		wb.write(response.getOutputStream());
		wb.close();
	}



    
}
