package egovframework.rte.dsdsm.cmmcheck.util;

import java.io.Closeable;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.HashMap;
import java.util.Iterator;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import com.ibm.icu.text.SimpleDateFormat;

import egovframework.rte.cmmn.util.EgovFileMngService;
import egovframework.rte.cmmn.util.EgovFileMngUtil;
import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.cmmn.vo.FileVO;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;
import egovframework.rte.dsdsm.cmmcheck.service.CmmCheckSerive;
import egovframework.rte.dsdsm.cmmcheck.service.vo.CmmCheckVO;
import egovframework.rte.dsdsm.dis.service.DisService;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.codehaus.jackson.map.ObjectMapper;
import org.jfree.util.Log;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;



@Component("ParamInfoUtil")
public class ParamInfoUtil {

	@Resource(name ="CmmCheckSerive")
	private CmmCheckSerive CmmCheckSerive;
	
	private Logger log = LogManager.getLogger();

	private double rate;
	
	
    /**
     * request 정보출력
     * @throws Exception 
     */   
	public void rqt_print(HttpServletRequest request) throws Exception {
		
		Enumeration params = request.getParameterNames();
		log. debug("----------------------------");
		
		log.debug(" >>>>> ROLE PRINT 엔터 ");
		
		while (params.hasMoreElements()){
		    String name = (String)params.nextElement();
		    log.debug("@@@@@@@ request : "+name + " : " +request.getParameter(name));
		}
		log.debug("----------------------------");

	}
	
    /**
     * session 정보출력
     * @throws Exception 
     */   
	public void sst_print(HttpSession session) throws Exception {
		
    	Enumeration se = session.getAttributeNames();
    	log.debug("----------------------------");
    	while(se.hasMoreElements()){
    	   String getse = se.nextElement()+"";
    	   log.debug("@@@@@@@ session : "+getse+" : "+session.getAttribute(getse));
    	}
    	log.debug("----------------------------");
    	
	}
	
	public void mpaInfo_print(Map mapInfo){
		
        Iterator iter = mapInfo.entrySet().iterator();
        
        while (iter.hasNext()) {

            Map.Entry entry = (Map.Entry) iter.next();

            String strKey  =  (String) entry.getKey(); //이게 contant 일때
            String strValue = (String) entry.getValue(); //이부분을 잘라낼수도 있습니다.

            log.debug("--" + strKey + "--------->[" +  strValue + "]");

        }
	}
	
	
    /**
     * session 회원직책 정보 확인 
     * @throws Exception 
     */   
	public Map dutyCode(HttpSession session, String menuCn) throws Exception {
		
		String dutyCode = "";
		String menuCode = "";
		Map rtnVal = null;
		
		log.debug("ParamInfoUtil.dutyCode");
		
	
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");

    	dutyCode = (String)userInfos.get("dutyCd");
    	menuCode = menuCn;
    	
    	log.debug(dutyCode);
    	log.debug(menuCode);
    	
    	rtnVal = CmmCheckSerive.menuCrudConfireChek(dutyCode, menuCode);
    	
    	return rtnVal; 
	}
	
	
    /**
     * session 회원직책 정보 확인 
     * @throws Exception 
     */   
	public Map dutyUrlCode(HttpSession session, String menuCn) throws Exception {
		
		String dutyCode = "";
		String menuCode = "";
		Map rtnVal = null;
		
		log.debug("ParamInfoUtil.dutyUrlCode");
		
	
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");

    	dutyCode = (String)userInfos.get("dutyCd");
    	menuCode = menuCn;
    	
    	log.debug(dutyCode);
    	log.debug(menuCode);
    	
    	rtnVal = CmmCheckSerive.menuCrudConfireChekUrl(dutyCode, menuCode);
    	
    	return rtnVal; 
	}
	
    /**
     * 임시정보 확인 
     * @throws Exception 
     */   	
	public Map<String, Object> rtnUid(Map<String, String> map) throws Exception {
		
    	Map<String, Object> result = new HashMap<String,Object>();

		UUID one = UUID.randomUUID();
		String createId = one.toString().replace("-", "").substring(0, 10);
	    UUID two = UUID.randomUUID();

	    log.debug("UUID One: " + one.toString());		
		
		result.put("SUCCESS", true);
		result.put("crtId", createId);
		result.put("MESSAGE", "사업ID 생성되었습니다.");
		
		return result;
	} 	



	
	

   public void excelDownCheck(HttpServletRequest request, HttpServletResponse response) throws Exception {
	   
	   rqt_print(request);
	   
	   Date d = new Date();
	   SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HHmmss");
	   String dates = sdf.format(d);
       
       
       
	   String codeExcel     = request.getParameter("codeExcel");
	   String jobNmExcel    = request.getParameter("nameExcel");
	   String startExcel    = request.getParameter("startExcel");
	   String   endExcel    = request.getParameter("endExcel");
	   String durationExcel = request.getParameter("durationExcel");
	   String progressExcel = request.getParameter("progressExcel");
	   String dependsExcel  = request.getParameter("dependsExcel");
	   String projectId     = request.getParameter("projectidExcel");
	   
	   //String fileNm = "C:/dev/"+projectId+"Excel_"+dates+".xls";
	   String fileNm = ""+projectId+"Excel_"+dates+".xls";

	   
	   // 엑셀파일(샘플파일 위치)
	   String storePathString = EgovProperties.getProperty("Globals.fileGanttPath");
	   log.debug("[excelDownFila] :: "+storePathString);
	   FileInputStream  file = new FileInputStream (storePathString);

	   // Workbook 생성
	   HSSFWorkbook  workbook = new HSSFWorkbook(file); // Excel 2007 이전 버전

       // *** Sheet-------------------------------------------------
       // Sheet 생성
       HSSFSheet sheet1 = workbook.getSheetAt(0);


       Row row = null;
       Cell cell = null;
       //----------------------------------------------------------
        
       // 첫 번째 줄
       row = sheet1.createRow(0);
        
       // 첫 번째 줄에 Cell 설정하기-------------
        
       cell = row.createCell(1);
       cell.setCellValue("코드");

       cell = row.createCell(2);
       cell.setCellValue("작업명");

       
       cell = row.createCell(3);
       cell.setCellValue("시작일");

       
       cell = row.createCell(4);
       cell.setCellValue("종료일");

       
       cell = row.createCell(5);
       cell.setCellValue("진행기간");

       
       cell = row.createCell(6);
       cell.setCellValue("진행율");

       
       cell = row.createCell(7);
       cell.setCellValue("상위작업");


       // 두 번째 줄에 Cell 설정하기-------------
       String[] arrayCode     =  codeExcel.split(",");
       String[] arrayJobName  =  jobNmExcel.split(",");
       String[] arrayStartDay =  startExcel.split(",");
       String[] arrayEndDay   =  endExcel.split(",");
       String[] arrayDuration =  durationExcel.split(",");
       String[] arrayProgress =  progressExcel.split(",");
       String[] arrayDepends  =  dependsExcel.split(",");
       
       int rowIdx = 0;
       //log.debug(">>> [arrayCode]"+arrayCode.length);
       //log.debug(">>> [arrayJobName.length]"+arrayJobName.length);       
       //log.debug(">>> [arrayStartDay]"+arrayStartDay.length);
       //log.debug(">>> [arrayEndDay]"+arrayEndDay.length);
       //log.debug(">>> [arrayEndDay]"+arrayEndDay.length);
       //log.debug(">>> [arrayProgress]"+arrayProgress.length);
       //log.debug(">>> [arrayDepends]"+arrayDepends.length);
       
       for(int i=0;i<arrayJobName.length;i++) {
    	   
    	   // 행 생성
           row = sheet1.createRow(++rowIdx);    
           
           //log.debug(">>> [rowIdx]"+rowIdx);

           if(arrayCode.length > 0 && i < arrayCode.length){
	           cell = row.createCell(1);
	           cell.setCellValue(arrayCode[i]);
	           //log.debug(">>[arrayCode.length]"+arrayCode.length+"  [i] →"+i);
           }
            
           if(arrayJobName.length > 0 && i < arrayJobName.length){
	           cell = row.createCell(2);
	           cell.setCellValue(arrayJobName[i]);
           }
           
           if(arrayStartDay.length > 0 && i < arrayStartDay.length){
	           cell = row.createCell(3);
	           cell.setCellValue(arrayStartDay[i]);
           }
           
           if(arrayEndDay.length > 0 && i < arrayEndDay.length){
	           cell = row.createCell(4);
	           cell.setCellValue(arrayEndDay[i]);
           }
           
           if(arrayDuration.length > 0 && i < arrayDuration.length){
	           cell = row.createCell(5);
	           cell.setCellValue(arrayDuration[i]);
           }
           //setCellFormula
           
           if(arrayProgress.length > 0 && i < arrayProgress.length){
	           cell = row.createCell(6);
	           cell.setCellValue(arrayProgress[i]);           
           }
           
           if(arrayDepends.length > 0 && i < arrayDepends.length){
	           cell = row.createCell(7);
	           cell.setCellValue(arrayDepends[i]);           
           }           
           
           
           
       }
       //---------------------------------

       // excel 파일 저장
       try {
    	   response.setContentType("Application/Msexcel");
    	   response.setHeader("Content-Disposition", "ATTachment; Filename="+fileNm+".xls");
    	   //File xlsFile = new File(fileNm);
    	   OutputStream fileOut  = response.getOutputStream();
           //File xlsFile = new File(fileNm);
           //FileOutputStream fileOut = new FileOutputStream(xlsFile);
           workbook.write(fileOut);
           fileOut.close();
       } catch (FileNotFoundException e) {
           e.printStackTrace();
       } catch (IOException e) {
           e.printStackTrace();
       }
        
   }	   
	   

}
