package egovframework.rte.dsdsm.cmmcheck.web;

import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.codehaus.jackson.map.ObjectMapper;
import org.jfree.util.Log;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import com.ibm.icu.text.SimpleDateFormat;

import egovframework.rte.cmmn.helper.JsonView;
import ch.qos.logback.core.net.SyslogOutputStream;

import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.service.vo.SearchVO;
import egovframework.rte.dsdsm.cmmcheck.service.CmmCheckSerive;
import egovframework.rte.dsdsm.cmmcheck.util.ParamInfoUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;
import egovframework.rte.dsdsm.stats.sr.service.StatsSrService;


@Controller
public class CmmCheckController {
	
	@Resource(name="ParamInfoUtil")
	private  ParamInfoUtil paramInfoUtil;		

	@Resource(name ="CmmCheckSerive")
	private CmmCheckSerive CmmCheckSerive;
	
	@Resource(name = "StatsSrService")
    private StatsSrService StatsSrService;	
	
	private Logger log = LogManager.getLogger();
		
	
    /**
     * 메뉴권한 관리
     * @throws Exception 
     */    
    @RequestMapping(value="/docManagement/checkList.do")
    public String checkList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
    	
    	//paramInfoUtil.rqt_print(request);
    	//paramInfoUtil.sst_print(session);
    	
//    	Map checkInfoG = ParamInfoUtil.dutyCode(session, "0080010000000");
    	Map checkInfoG = CmmCheckSerive.menuCrudConfireChek("ssss", "0080010000000");
    	
        log.debug(">>>>> checkInfoG : "+checkInfoG.toString());

    	return "/dsdsm/docManagement/docList_product";
    }
    
    
    /**
     * 산출물  관리 목록화면으로 들어간다.
     * @throws Exception 
     */    
    @RequestMapping(value="/test/test3.do")
    public String docList_product(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
    	
    	
    	Date d = new Date();
    	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    	String date = sdf.format(d);
    	
    	if(param.get("sdate") == null || "undefined".equals(param.get("sdate"))){
    		param.put("sdate", date);
    	}
    	
    	if(param.get("edate") == null || "undefined".equals(param.get("edate"))){
    		param.put("edate", date);
    	}
    	
    	paramInfoUtil.mpaInfo_print(param);
    	
    	List<HashMap> grdList = StatsSrService.grdList(param);
    	
    	model.addAttribute("grdList", grdList);
    	model.addAttribute("sdate", param.get("sdate"));
    	model.addAttribute("edate", param.get("edate"));
    	model.addAttribute("gubun", param.get("gubun"));
    	model.addAttribute("form", param.get("form"));    	

    	return "/dsdsm/docManagement/docList_product";
    }
    
    
	@RequestMapping(value="/cmmUtil/CreateBnsId.json")
    public String checkBnsId(@RequestParam Map<String,String> param, ModelMap map) throws Exception {		
    	
/*    	
       Map<String, Object> result = null;
  
        String bnsId = paramInfoUtil.rtnUid(param);

    	log.debug(bnsId);
    	
    	result.put("SUCCESS", true);
    	result.put("bnsId", bnsId);
    	log.debug(result.toString());
*/		
		Map<String, Object> result = paramInfoUtil.rtnUid(param);		
    	
    	map.put("result", result);  
    	
    	log.debug(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"+map.toString());
    	
		return "jsonView";
    }
    
    
    @RequestMapping(value="/project/downGantt.json")
    public String downGantt(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session, HttpServletResponse response) throws Exception {
    	
    	log.debug("				 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> downGantt");
    	//paramInfoUtil.excelkDownGantt();
    	//paramInfoUtil.excelDownFila(session, "gantts");
    	paramInfoUtil.excelDownCheck(request, response);
    	
    	
       return "OK";
    }
    
    
    
 
    

}
