package egovframework.rte.dsdsm.cmmcode.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import egovframework.rte.psl.dataaccess.util.EgovMap;

public interface CodeService {
	
	/**
	 * 공통코트(대분류) 총 갯수
	 * @return int
	 * @exception Exception 
	*/
	public int getCodeGenListCount(HashMap h) throws Exception;
    
	/**
	 * 공통코드(대분류) 목록을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 공통코드(대분류) 목록
	 * @exception Exception
	 */
    public List getCodeGenList(HashMap h) throws Exception;
    
    /**
	 * 공통코드(대분류) 상세정보을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 공통코드(대분류) 상세정보
	 * @exception Exception
	 */
    public List getCodeGenView(HashMap h) throws Exception;
    
    /**
	 * 조회된 공통코트(대분류)의 세부코드 총 갯수
	 * @return int
	 * @exception Exception 
	*/
	public int getCodeGenDetailListCount(HashMap h) throws Exception;
    
	/**
	 * 조회된 공통코드(대분류)의 세부코드 목록을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 조회된 공통코드(대분류)의 세부코드 목록
	 * @exception Exception
	 */
    public List getCodeGenDetailList(HashMap h) throws Exception;
    
    /**
	 * 공통코트(소분류) 총 갯수
	 * @return int
	 * @exception Exception 
	*/
	public int getCodeListCount(HashMap h) throws Exception;
    
	/**
	 * 공통코드(소분류) 목록을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 공통코드(소분류) 목록
	 * @exception Exception
	 */
    public List getCodeList(HashMap h) throws Exception;
  
    /**
	 * 공통코드(소분류) 상세정보을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 공통코드(대분류) 상세정보
	 * @exception Exception
	 */
    public List getCodeView(HashMap h) throws Exception;
    
    /**
	 * 공통코드(대분류) ID 중복체크
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 공통코드(대분류) ID 중복체크
	 * @exception Exception
	 */
    public Map<String,Object> checkCodeId(Map<String, String> map) throws Exception;
    
    /**
	 * 공통코드(소분류) ID 중복체크
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 공통코드(대분류) ID 중복체크
	 * @exception Exception
	 */
    public Map<String,Object> checkCode(Map<String, String> map) throws Exception;
    
    /**
	 * 공통코드(대분류) 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> codeGenReg(HashMap h) throws Exception;
	
	/**
	 * 공통코드(대분류) 수정
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> codeGenEdit(HashMap h) throws Exception;
	
	/**
	 * 공통코드(대분류) 삭제
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> codeGenDel(HashMap h) throws Exception;
	
	/**
	 * 공통코드(소분류) 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> codeReg(HashMap h) throws Exception;
	
	/**
	 * 공통코드(소분류) 수정
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> codeEdit(HashMap h) throws Exception;
	
	/**
	 * 공통코드(소분류) 삭제
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> codeDel(HashMap h) throws Exception;
    
	
	/**
	 * 업무코드를 조회한다.
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 조회된 업무코드 목록
	 * @exception Exception
	 */
    public List getJobCdList() throws Exception;	
}