package egovframework.rte.dsdsm.cmmcode.service.impl;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Repository("CodeServiceDAO")
public class CodeServiceDAO extends EgovAbstractDAO {
	
	/**
	 * 
	 * @return 공통코드(대분류) 총 갯수
	 * @exception Exception 
	*/
	public int getCodeGenListCount(HashMap h) throws Exception {
		return (Integer) select("CodeServiceDAO.getCodeGenListCount", h);		
	} 
	
	/**
	 * 
	 * @return 공통코드(대분류) 목록
	 * @exception Exception 
	*/
	public List getCodeGenList(HashMap h) throws Exception {
		return list("CodeServiceDAO.getCodeGenList", h);
	}
	
	/**
	 * 
	 * @return 공통코드(대분류) 상세정보
	 * @exception Exception 
	*/
	public List getCodeGenView(HashMap h) throws Exception {
		return list("CodeServiceDAO.getCodeGenView", h);
	}
	
	/**
	 * 
	 * @return 조회된 공통코드(대분류)의 세부코드 총 갯수
	 * @exception Exception 
	*/
	public int getCodeGenDetailListCount(HashMap h) throws Exception {
		return (Integer) select("CodeServiceDAO.getCodeGenDetailListCount", h);		
	} 
	
	/**
	 * 
	 * @return 조회된 공통코드(대분류)의 세부코드 목록
	 * @exception Exception 
	*/
	public List getCodeGenDetailList(HashMap h) throws Exception {
		return list("CodeServiceDAO.getCodeGenDetailList", h);
	}
	
	/**
	 * 
	 * @return 공통코드(소분류) 총 갯수
	 * @exception Exception 
	*/
	public int getCodeListCount(HashMap h) throws Exception {
		return (Integer) select("CodeServiceDAO.getCodeListCount", h);		
	} 
	
	/**
	 * 
	 * @return 공통코드(소분류) 목록
	 * @exception Exception 
	*/
	public List getCodeList(HashMap h) throws Exception {
		return list("CodeServiceDAO.getCodeList", h);
	}
	
	/**
	 * 
	 * @return 공통코드(소분류) 상세정보
	 * @exception Exception 
	*/
	public List getCodeView(HashMap h) throws Exception {
		return list("CodeServiceDAO.getCodeView", h);
	}
	
	/**
	 * 
	 * @return 공통코드(대분류) ID 중복체크
	 * @exception Exception 
	*/
	public Map<String,Object> checkCodeId(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("ONE", select("CodeServiceDAO.checkCodeId", map));
		return result;
	}
	
	/**
	 * 
	 * @return 공통코드(소분류) ID 중복체크
	 * @exception Exception 
	*/
	public Map<String,Object> checkCode(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("ONE", select("CodeServiceDAO.checkCode", map));
		return result;
	}
	
	/**
	 * 
	 * @return 공통코드(대분류) 등록
	 * @exception Exception 
	*/
	public Map<String,Object> codeGenReg(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("CodeServiceDAO.codeGenReg", h));
		return result;
	}
	
	/**
	 * 
	 * @return 공통코드(대분류) 수정
	 * @exception Exception 
	*/
	public Map<String,Object> codeGenEdit(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("CodeServiceDAO.codeGenEdit", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 공통코드(대분류) 수정시 소분류코드의 부모ID 수정
	 * @exception Exception 
	*/
	public Map<String,Object> codeGenDtEdit(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("CodeServiceDAO.codeGenDtEdit", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 공통코드(대분류) 삭제
	 * @exception Exception 
	*/
	public Map<String,Object> codeGenDel(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("CodeServiceDAO.codeGenDel", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 공통코드(대분류) 삭제시 소분류코드 동시삭제
	 * @exception Exception 
	*/
	public Map<String,Object> codeGenDtDel(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("CodeServiceDAO.codeGenDtDel", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 공통코드(소분류) 등록
	 * @exception Exception 
	*/
	public Map<String,Object> codeReg(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("CodeServiceDAO.codeReg", h));
		return result;
	}
	
	/**
	 * 
	 * @return 공통코드(대분류) 수정
	 * @exception Exception 
	*/
	public Map<String,Object> codeEdit(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("CodeServiceDAO.codeEdit", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 공통코드(대분류) 삭제
	 * @exception Exception 
	*/
	public Map<String,Object> codeDel(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("CodeServiceDAO.codeDel", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 업무코드 목록
	 * @exception Exception 
	*/
	public List getJobCdList() throws Exception {
		return list("CodeServiceDAO.getJobCdList");		              
	}
		
}
