package egovframework.rte.dsdsm.cmmcode.web;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;

@Controller
public class CodeController {
	
	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	@Resource(name = "CodeService")
    private CodeService CodeService;
	
	@RequestMapping(value="/cmmcode/codeGenList.do")
    public String codeGenList() { 
    	return "/dsdsm/cmmcode/codeGenList";
    }
	
	@RequestMapping(value="/cmmcode/codeList.do")
    public String codeList() { 
    	return "/dsdsm/cmmcode/codeList";
    }
	
	@RequestMapping(value="/cmmcode/codeGenReg.do")
    public String codeGenReg() { 
    	return "/dsdsm/cmmcode/codeGenReg";
    }
	
	@RequestMapping(value="/cmmcode/codeReg.do")
    public String codeReg(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model) throws Exception { 
		
		int listCount = CodeService.getCodeGenListCount(param);	
		
		param.put("start", (int) 1);
		param.put("end", (int) listCount);
		
		List list = CodeService.getCodeGenList(param);	
		
		model.put("codeGenList",list);
		model.put("codeid", param.get("codeid"));
		
    	return "/dsdsm/cmmcode/codeReg";
    }
	
	/**
     * 공통코트(대분류) 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/cmmcode/getCodeGenList.do")
	public String getCodeGenList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		int listCount = CodeService.getCodeGenListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = CodeService.getCodeGenList(param);	
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}
	
	/**
     * 공통코드(대분류) 상세보기화면으로 들어간다.
	 * @throws Exception 
     */
	@RequestMapping(value="/cmmcode/codeGenView.do")
    public String codeGenView(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	List list = CodeService.getCodeGenView(param);
    	
    	model.addAttribute("list",list);
    	
    	return "/dsdsm/cmmcode/codeGenView";
    }
	
    /**
     * 선택된 공통코드(대분류)의 상세코드 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/cmmcode/getCodeGenDetailList.do")
	public String getCodeGenDetailList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		int listCount = CodeService.getCodeGenDetailListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = CodeService.getCodeGenDetailList(param);	
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}
	
	/**
     * 공통코트(소분류) 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/cmmcode/getCodeList.do")
	public String getCodeList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		//String codeid = request.getParameter("codeid").toString();
		
		int listCount = CodeService.getCodeListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = CodeService.getCodeList(param);	
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}
	
	/**
     * 공통코드(소분류) 상세보기화면으로 들어간다.
	 * @throws Exception 
     */
    @SuppressWarnings("unchecked")
	@RequestMapping(value="/cmmcode/codeView.do")
    public String codeView(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	List list = CodeService.getCodeView(param);
    	
    	model.addAttribute("list",list);
    	
    	return "/dsdsm/cmmcode/codeView";
    }
    
    @RequestMapping(value="/cmmcode/checkCodeId.json")
    public String checkCodeId(@RequestParam Map<String,String> param, ModelMap map) throws Exception {
    	
    	Map<String, Object> result = CodeService.checkCodeId(param);  
    	
    	map.put("result", result);
    	
    	return "jsonView";
    	
    }
    
    @RequestMapping(value="/cmmcode/checkCode.json")
    public String checkCode(@RequestParam Map<String,String> param, ModelMap map) throws Exception {
    	
    	Map<String, Object> result = CodeService.checkCode(param);  
    	
    	map.put("result", result);
    	
    	return "jsonView";
    	
    }
    
    /**
     * 공통코드(대분류) 편집
     * @throws Exception 
     */
    @RequestMapping(value="/cmmcode/codeGenEdit.json")
    public String codeGenEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	
    	if("S".equals(param.get("gbn"))){
    		result = CodeService.codeGenReg(param);
    	} else if("U".equals(param.get("gbn"))){
    		result = CodeService.codeGenEdit(param);
    	} else if("D".equals(param.get("gbn"))){
    		result = CodeService.codeGenDel(param);
    	}
    	
    	map.put("result", result);
    	map.put("codeid", param.get("codeid"));
    	
    	return "jsonView";
    }
    
    /**
     * 공통코드(소분류) 편집
     * @throws Exception 
     */
    @RequestMapping(value="/cmmcode/codeEdit.json")
    public String codeEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	
    	if("S".equals(param.get("gbn"))){
    		result = CodeService.codeReg(param);
    	} else if("U".equals(param.get("gbn"))){
    		result = CodeService.codeEdit(param);
    	} else if("D".equals(param.get("gbn"))){
    		result = CodeService.codeDel(param);
    	}
    	
    	map.put("result", result);
    	map.put("codeid", param.get("codeid"));
    	map.put("code", param.get("code"));
    	
    	return "jsonView";
    }
    
	/**
     * 업무 코드를 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/cmmcode/getJobCdList.json")
	public String getJobCdList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();
		 
		List list = CodeService.getJobCdList();	
 	  	model.put("list",list);
 	  	
		return "jsonView";
	}    
}
