package egovframework.rte.dsdsm.dis.web;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller; 
import org.springframework.ui.Model;
import org.springframework.util.FileCopyUtils;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
 
import egovframework.rte.psl.dataaccess.util.EgovMap;

import com.github.mustachejava.PragmaHandler;

import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovFileMngService;
import egovframework.rte.cmmn.util.EgovFileMngUtil;
import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.cmmn.vo.FileVO;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.vo.SearchVO;
import egovframework.rte.dsdsm.cmm.service.vo.cmmVO;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.cmm.util.StrUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;
import egovframework.rte.dsdsm.dis.service.DisService;
import egovframework.rte.dsdsm.dis.service.vo.DisVO;
import egovframework.rte.fdl.property.EgovPropertyService;
import egovframework.rte.psl.dataaccess.util.EgovMap;
import egovframework.rte.ptl.mvc.tags.ui.pagination.PaginationInfo;

@Controller
public class DisController {
	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	   @Resource(name = "DisService")
	   private DisService disService;
	   
	   
		@Resource(name = "CmmService")
	    private CmmService cmmService;
		
		@Resource(name ="CodeService")
		private CodeService codeService;
		
	   @Resource(name="EgovFileMngUtil")
	   private  EgovFileMngUtil fileUtil;
	   
	   @Resource(name="DisFileMng")
	   private  DisFileMng disFileMng;
	   
	   @Resource(name="EgovFileMngService")
	   private  EgovFileMngService fileMngService;
	   
		/** EgovPropertyService */
		@Resource(name = "propertiesService")
		protected EgovPropertyService propertiesService;	
		
		private Logger log = LogManager.getLogger();
		//private static final Logger LOGGER = LoggerFactory.getLogger(EgovComExcepHndlr.class);
		
		
	   /**
		 * 배포요청 화면으로 이동
		 * 
		 * @param response
		 *            , request, defaultVO, model
		 * @return dsacc/pas/pasList
		 * @exception Exception
		 */                      
		@RequestMapping(value = "/dis/disRequest.do")
		public ModelAndView disRequest(HttpServletResponse response,HttpServletRequest request, Model model/*, HttpSession session*/) throws Exception {			
	    	ModelAndView mv = new ModelAndView();
/*	    	EgovMap userInfo = new EgovMap();			
	    	List<String> roleList=  (List<String>) session.getAttribute("ROLES");*/
	    	 
	    	HashMap<Object, Object> map = new HashMap<Object, Object>();
	    	map.put("codeId", "DSTYPE");
			mv.addObject("disType", CmmService.getCmmDitcList(map));			
			map.put("codeId", "DSRESN");
			mv.addObject("disResn", CmmService.getCmmDitcList(map));	
			map.put("codeId", "DSAPPD");
			mv.addObject("disAppd", CmmService.getCmmDitcList(map));
			map.put("codeId", "LN1100");
			mv.addObject("disJob", CmmService.getCmmDitcList(map));
			
	    	@SuppressWarnings("rawtypes")
			List jobCds = codeService.getJobCdList();	    	
	    	ObjectMapper mapper = new ObjectMapper();
	   		String jobCdsJsonStr = mapper.writeValueAsString(jobCds);	   		
			mv.addObject("jobCdList", jobCdsJsonStr);
			
			mv.addObject("srNo",request.getParameter("srNo"));
			mv.addObject("jobCd",request.getParameter("jobCd"));
	    	
			mv.setViewName("dsdsm/dis/disRequest");
			
			return mv;
		}
		
		
		   /**
			 * 배포요청 목록 화면으로 이동
			 * 
			 * @param response
			 *            , request, defaultVO, model
			 * @return dsacc/pas/pasList
			 * @exception Exception
			 */                      
			@RequestMapping(value = "/dis/disList.do")
			public ModelAndView disRequestList(@ModelAttribute("searchVO") SearchVO searchVO, HttpServletResponse response,HttpServletRequest request, Model model) throws Exception {			
				System.out.println("/dis/disList.do");
				
				ModelAndView mv = new ModelAndView();
				HashMap<Object, Object> map = new HashMap<Object, Object>();
		    	map.put("codeId", "DSSTAT");
				mv.addObject("disStat", CmmService.getCmmDitcList(map));
				mv.addObject("pSDT", request.getParameter("pSDT"));
				mv.addObject("pEDT", request.getParameter("pEDT"));
				mv.addObject("pStat", request.getParameter("pStat"));
				mv.addObject("pPage", request.getParameter("pPage"));
				//mv.addObject("pReg", request.getParameter("pReg"));
				
		    	mv.setViewName("dsdsm/dis/disList");
				return mv;
			}

			
			/* 배포 목록 조회*/
			@RequestMapping(value = "/dis/getDisList.do")
			public ModelAndView getDisList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
				ModelAndView mv = new ModelAndView();
				HashMap<Object, Object> map = new HashMap<Object, Object>();
				HashMap<Object, Object> pagingMap = new HashMap<Object, Object>();
				 
				
				String inqTitle = request.getParameter("inqTitle");
				String inqUserNm = request.getParameter("inqUserNm");
				String inqStat = request.getParameter("inqStat");
				String inqFrom = request.getParameter("inqFrom");
				String inqTo = request.getParameter("inqTo");
				
				float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
				float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
				
				map.put("inqTitle", inqTitle);
				map.put("inqUserNm", inqUserNm);
				map.put("inqStat", inqStat);
				map.put("inqFrom", inqFrom.replaceAll("-", ""));
				map.put("inqTo", inqTo.replaceAll("-", ""));
				map.put("pStat", request.getParameter("pStat"));
				System.out.println("########################################");
				System.out.println(map.toString());
				
				int listCount = disService.selectDisListCnt(map);	
				
				int pageCount = (int) Math.ceil(listCount / pageSize);				
				
				map.put("start", (int) (pageNo-1)*pageSize+1);
				map.put("end", (int) pageNo*pageSize);

				List list = disService.selectDisList(map);
				
				pagingMap.put("pageNo",pageNo);
				pagingMap.put("pageSize",pageSize);
				pagingMap.put("pageCount",pageCount);
				pagingMap.put("listCount",listCount);
				
				
				model.addAttribute("list",list);
				model.addAttribute("page",pagingMap);

		        mv.setView(new JsonView());
				return mv;
			}
			
			
		    /**
		     * SR 목록 조회
		     */
		    @RequestMapping(value="/dis/SRlistPop.do")
		    public String SRlist(HttpServletRequest request, Model model) throws Exception {
				HashMap<Object, Object> map = new HashMap<Object, Object>();
		    	map.put("codeId", "SRSTAT");
				model.addAttribute("srStat", CmmService.getCmmDitcList(map));
				map.put("codeId", "LN1100");
				model.addAttribute("srgbn", CmmService.getCmmDitcList(map)); 
				
		    	@SuppressWarnings("rawtypes")
				List jobCds = codeService.getJobCdList();	    	
		    	ObjectMapper mapper = new ObjectMapper();
		   		String jobCdsJsonStr = mapper.writeValueAsString(jobCds);	   		
		   		model.addAttribute("JOB_LIST", jobCdsJsonStr);
				
		    	return "/dsdsm/dis/popSRlist";
		    }	
		    
		    /**
		     * SR 목록 조회
		     */
		    @RequestMapping(value="/dis/SRdetail.do")
		    public String SRdetail(HttpServletRequest request, Model model) throws Exception {
				HashMap<Object, Object> map = new HashMap<Object, Object>();
		    	map.put("sid", request.getParameter("sid"));
				
		    	return "/dsdsm/dis/popSrViewL";
		    }			    
			
			/**
			 * 배포 이력 조회
			 * @param request
			 * @param model
			 * @param session
			 * @return
			 * @throws Exception
			 */
			@RequestMapping(value = "/dis/getDisHisList.do")
			public ModelAndView getDisHisList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
				ModelAndView mv = new ModelAndView();
				HashMap<Object, Object> map = new HashMap<Object, Object>();
				String disNo = request.getParameter("disNo");
				String addYn = request.getParameter("addYn");
				System.out.println("### getDisHisList.do::"+disNo);
				
				map.put("disNo", disNo);				
				
				map.put("addYn", "N");
				List list = disService.selectDisHisList(map);
				
				map.put("addYn", "Y");
				
				List list2 = disService.selectDisHisList(map);

		 	  	mv.addObject("list", list);
		 	  	mv.addObject("list2", list2);
		        mv.setView(new JsonView());
				return mv;
			}
			
			
		
		   /**
			 * 배포 상세 화면으로 이동
			 * 
			 * @param response
			 *            , request, defaultVO, model
			 * @return dsacc/pas/pasList
			 * @exception Exception
			 */                      
			@RequestMapping(value = "/dis/disView.do")
			public ModelAndView disRequestDetail(@ModelAttribute("searchVO") SearchVO searchVO, HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
				System.out.println("/dis/disView.do");
				ModelAndView mv = new ModelAndView();
				HashMap<Object, Object> map = new HashMap<Object, Object>();
				
				String disNo = request.getParameter("disNo");
				//String isModal = request.getParameter("isModal");
				

				
				map.put("disNo", disNo);
				List<EgovMap> currStat = disService.selectDisCurrStat(map);

				String matchYn = "";
				
				System.out.println(currStat.get(0).toString());
				//System.out.println(StrUtil.nvl((String)currStat.get(0).get("hisDisstat")));
				//System.out.println(StrUtil.nvl((String)currStat.get(0).get("HISDISSTAT")));

				if(currStat.get(0).get("hisDisStat").equals(currStat.get(0).get("lastDisStat")) || currStat.get(0).get("lastDisStat").equals("230") ) { 
					matchYn = "Y";
				} else {
					matchYn = "N";
				}
				
		    	List<String> roleList=  (List<String>) session.getAttribute("ROLES");
		    	
		    	
		    	
		    	Map userInfo = (Map) session.getAttribute("userInfo");
		    	
		    	String[] jobList = (String[]) userInfo.get("jobCd");
		    	List<String> jList = Arrays.asList(jobList);
		    	System.out.println("#############################");
		    	System.out.println(currStat.get(0).get("jobCd"));
		    	System.out.println(jList.toString());
		    	
				//|| currStat.get(0).get("lastdisstat").equals("230")
				//System.out.println(currStat.get(0).toString());
				//mv.addObject("disNo",disNo);
				
		    	map.put("addYn", "N");
		    	System.out.println(1);
		    	mv.addObject("history", disService.selectDisHisList(map));
		    	System.out.println(2);
		    	
		    	System.out.println(mv.toString());
		    	
		    	mv.addObject("disProcStep", disService.selectDisProcStep());
		    	
		    	mv.addObject("pPage", request.getParameter("pPage"));
				mv.addObject("currDisNo", currStat.get(0).get("currDisNo"));
				mv.addObject("currDisStat", currStat.get(0).get("lastDisStat"));
				mv.addObject("currMaxSeq", currStat.get(0).get("maxSeq"));				
				mv.addObject("matchYn", matchYn);
				mv.addObject("hasRole","N");
				
				map.put("codeId", "DSPRDT");
				mv.addObject("disProd", cmmService.getCmmDitcList(map));
				
		
				
				if(roleList != null) {
					System.out.println("roleList@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
					System.out.println(roleList.toString());
					System.out.println("jList@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
					System.out.println(jList.toString());
					System.out.println("currrole>>"+currStat.get(0).get("currRole"));
					System.out.println("nextrole>>"+currStat.get(0).get("nextRole"));
					System.out.println("jobcd   >> "+currStat.get(0).get("jobCd"));
					
					if(matchYn.equals("Y")) {
						//if(roleList.contains(currStat.get(0).get("nextrole")) && jList.contains(currStat.get(0).get("jobcd"))) mv.addObject("hasRole","Y");					
						if(roleList.contains(currStat.get(0).get("nextRole"))) mv.addObject("hasRole","Y");					
					} else {
						//if(roleList.contains(currStat.get(0).get("currrole")) && jList.contains(currStat.get(0).get("jobcd"))) mv.addObject("hasRole","Y");
						if(roleList.contains(currStat.get(0).get("currRole"))) mv.addObject("hasRole","Y");
					}
				}
				

				
				
				String currDisStat = currStat.get(0).get("lastDisStat").toString();
				
				if(currDisStat.equals("100") || currDisStat.equals("150")) { //배포요청, 품질검토요청
					if(currDisStat.equals("150")) {
						map.put("disNo", currStat.get(0).get("currDisNo"));
						
						System.out.println("currDisStat.equals(100) || currDisStat.equals(150) >>> "+map);
						
						mv.addObject("disProdAtchList",disService.selectDisDtl(map));
					}
					mv.addObject("btnNm", "요청완료");
				} else {
					mv.addObject("btnNm", "검토완료");
				}
			 

/*		    	if(isModal != null && isModal.equals("Y")) {
		    		System.out.println("Modal Dis");
		    		//return "/dsdsm/dis/popSrViewL";
		    	} else {
		    		//return "/dsdsm/sr/srViewL";    		
		    		//mv.setViewName("dsdsm/dis/disView");		    	
		    	}
		    	mv.setViewName("dsdsm/dis/popDisView");*/		    	
		    	mv.setViewName("dsdsm/dis/disView");
				return mv;
			}
			
		   /**
			 * 배포 상세 화면 각 모듈 로드
			 * 
			 * @param response
			 *            , request, defaultVO, model
			 * @return dsacc/pas/pasList
			 * @exception Exception
			 */                      
			@RequestMapping(value = "/dis/disViewGetDetail.do")
			public ModelAndView disViewGetDetail(HttpServletResponse response,HttpServletRequest request, Model model, HttpSession session) throws Exception {			
				log.debug("/dis/disViewGetDetail.do");
				
				ModelAndView mv = new ModelAndView();
				HashMap<Object, Object> map = new HashMap<Object, Object>();

				String disNo = request.getParameter("disNo"); 
				String seq = request.getParameter("seq");  
				String stat = request.getParameter("stat");
				String pageUrl = request.getParameter("pageUrl");
				String lastChk = request.getParameter("lastChk");
				String addYn = request.getParameter("addYn");
				
				// log.debug(" >>>>>> "+pageUrl);
				
				map.put("disNo", disNo);
				map.put("seq", seq);
				map.put("disStat", stat);
				
				if(stat.equals("100") && addYn.equals("Y")) {
					map.put("seq",disService.getDisDtlReSeq(map));
					seq = "0";
				}
				 
				mv.addObject("result",disService.selectDisDtl(map));
				 
				System.out.println("######## MV::::"+mv.toString());
				if(stat.equals("100")) { //배포요청단계					
					HashMap<Object, Object> searchMap = new HashMap<Object, Object>();
					searchMap.put("codeId", "DSTYPE");
					mv.addObject("disType", CmmService.getCmmDitcList(searchMap));					
					searchMap.put("codeId", "DSRESN");
					mv.addObject("disResn", CmmService.getCmmDitcList(searchMap));	
					searchMap.put("codeId", "DSAPPD");
					mv.addObject("disAppd", CmmService.getCmmDitcList(searchMap));
					searchMap.put("codeId", "LN1100");
					mv.addObject("fileList", disService.selectAtchFileList(map));
					
					mv.addObject("disJob", CmmService.getCmmDitcList(searchMap));				 
					//업무코드
			    	@SuppressWarnings("rawtypes")
					List jobCds = codeService.getJobCdList();	    	
			    	ObjectMapper mapper = new ObjectMapper();
			   		String jobCdsJsonStr = mapper.writeValueAsString(jobCds);	   		
					mv.addObject("jobCdList", jobCdsJsonStr);					
				} else if (stat.equals("150")) { //품질검토 등록단계
					HashMap<Object, Object> searchMap = new HashMap<Object, Object>();
					map.put("codeId", "DSPRDT");
					mv.addObject("disProd", cmmService.getCmmDitcList(map));
					
					// 파일 목록은 등록단계에선 필요 없고 수정에서만 나와야함.
					//mv.addObject("fileList", disService.selectAtchFileList(map));
					
				} else if(stat.equals("220")) { //최종배포 확인단계에서 종료된 배포건인지 확인
					List<HashMap> currStat = disService.selectDisCurrStat(map);
					mv.addObject("disStat", currStat.get(0).get("lastDisStat"));
				} else if (stat.equals("120") || stat.equals("180") || stat.equals("210")) { //배포 검토요청 단계들
					mv.addObject("fileList", disService.selectAtchFileList(map));
				}
				mv.addObject("lastChk",lastChk);
				mv.addObject("disNo",disNo);
				mv.addObject("addYn",addYn);
				mv.addObject("seq", seq);
				
				
				List<EgovMap> currStat = disService.selectDisCurrStat(map);
				String matchYn = "";
				if(currStat.get(0).get("hisDisStat").equals(currStat.get(0).get("lastDisStat")) || currStat.get(0).get("lastDisStat").equals("230") ) { 
					matchYn = "Y";
				} else {
					matchYn = "N";
				}
				
		    	List<String> roleList=  (List<String>) session.getAttribute("ROLES");
				mv.addObject("matchYn", matchYn);
				mv.addObject("hasRole","N");
				
				if(roleList != null) {					
					if(roleList.contains(currStat.get(0).get("currRole"))) {
						mv.addObject("hasRole","Y");
					}
				}
				
				
		    	mv.setViewName(pageUrl);
				return mv;
			}			
			
			
			 
	   /**
	    * 배포요청 등록
	    */
		@RequestMapping(value = "/dis/disRegistRequest.json")
		public String disRegistRequest(HttpServletRequest request, Model model, HttpSession session) throws Exception {
			ModelAndView mv = new ModelAndView();
			
			System.out.println("###### disRegistRequest.do");
			
			String disNo 	= request.getParameter("disNo");
			String disUsrId 	= request.getParameter("disUsrId");
			//String disDeptCd 	= request.getParameter("disDeptCd");
			String disType 	= request.getParameter("disType");
			String disJob 	= request.getParameter("disJob");
			String disReason 	= request.getParameter("disReason");
			String disSrno 		= request.getParameter("disSrno");
			String[] disAppServer= request.getParameterValues("disAppServer");
			String disAppCont 	= request.getParameter("disAppCont");
			String disWebAppCont = request.getParameter("disWebAppCont");
			String disApAppCont = request.getParameter("disApAppCont"); 
			String disDBAppCont = request.getParameter("disDBAppCont");
			
			//String[] chkbox = request.getParameterValues("chkbox");
			 
			
			HashMap<Object, Object> map = new HashMap<Object, Object>();
			
			
			map.put("seq", "1");
			map.put("disUsrId", disUsrId);	
			map.put("disType", disType);	
			map.put("disJob", disJob);	
			map.put("disReason", disReason);	
			map.put("disSrno", disSrno);	
			map.put("disAppServer", disAppServer);	
			map.put("disAppCont", disAppCont);	
			map.put("disWebAppCont", disWebAppCont);	
			map.put("disApAppCont", disApAppCont);	
			map.put("disDBAppCont", disDBAppCont);
			map.put("disStat", "100");
			
	    	//배포요청번호 생성	    	
	    	int getno = 0;
	    	String getDisNo = "";
	    	
	    	
	    	if(disNo == null || disNo.equals("")){
	    		getno = disService.getDisNo();
	    		getDisNo = String.format("%04d", getno);
	    		getDisNo = "DS" + DateUtil.toYYYYMMDDDate(DateUtil.getDate()) + getDisNo;
	    	} else {
	    		getDisNo = disNo;
	    	}
	    	map.put("disNo", getDisNo);
	    	
			 
	    	String _atchFileId = "";
			_atchFileId = disFileMng.fileUpload("DISRQ_",request);
			map.put("disAddFileId", _atchFileId);

			
			disService.insertDisRequest(map);
			disService.insertDisRequestDtl(map);
			disService.insertDisHistory(map);
			
			model.addAttribute("disNo", getDisNo);
			return "jsonView";
		}
		
		
	/* 배포 내용 수정 */
	@RequestMapping(value = "/dis/disSave.json")
	public String disSave(HttpServletRequest request) throws Exception {
		System.out.println("disSave.do");

		
		HashMap<Object, Object> map = new HashMap<Object, Object>();
		Enumeration<?> enums = request.getParameterNames();

		while (enums.hasMoreElements()) {
			String paramName = (String) enums.nextElement();
			String[] parameters = request.getParameterValues(paramName);

			// Parameter가 배열일 경우
			if (parameters.length > 1) {
				map.put(paramName, parameters);
				// Parameter가 배열이 아닌 경우
			} else {
				if (paramName.equals("disAppServer")) {
					map.put(paramName, parameters);
				} else {
					map.put(paramName, parameters[0]);
				}
			}
		}
		System.out.println("saveMap##0"+map.toString());
		if (map.get("matchYn").equals("N")) {
			System.out.println("등록##");

			map.put("disNo", map.get("currDisNo"));
			map.put("disStat", map.get("currDisStat"));
			map.put("seq", disService.getDisSeq(map));

			if (map.get("currDisStat").equals("150")) { // 품질검토 요청일 경우
				String _atchFileId = "";
				MultipartHttpServletRequest mpRequest = (MultipartHttpServletRequest) request;
				final Map<String, MultipartFile> files = mpRequest.getFileMap();

				String[] qaFiles = map.get("addQaFileList").toString()
						.split(",");
				for (int i = 0; i < qaFiles.length; i++) {
					HashMap<String, MultipartFile> file = new HashMap<String, MultipartFile>();
					file.put(qaFiles[i], files.get(qaFiles[i]));
					_atchFileId = disFileMng.qaFileUpload("DISRQ_", request, file, i);
					if (_atchFileId != null) map.put("addFileId", _atchFileId);
					map.put("prodType", qaFiles[i].replace("qaFile", ""));
					if (i == 0)	disService.insertDisHistory(map);
					disService.insertDisByStep(map);
				}
		    	map.put("returnYn", "N");
				disService.updateDisMainReturnYn(map);

			} else {
				if(map.get("currDisStat").equals("100")) {
					disFileMng.fileDelete(request);
				}
				
				String _atchFileId = "";
				_atchFileId = disFileMng.fileUpload("DISRQ_", request);
				if (_atchFileId != null) {
					map.put("disAddFileId", _atchFileId);
				} else {
					map.put("disAddFileId", map.get("addFileId"));
				}

				disService.insertDisHistory(map);
				disService.insertDisByStep(map);
		    	map.put("returnYn", "N");
				disService.updateDisMainReturnYn(map);
			}
		} else {
			System.out.println("수정");

			if (map.get("currDisStat").equals("150")) { // 품질검토 요청일 경우

				disFileMng.qaFileDelete(request);

				String _atchFileId = "";

				map.put("disNo", map.get("currDisNo"));
				map.put("disStat", map.get("currDisStat"));
				map.put("seq", map.get("currMaxSeq"));

				MultipartHttpServletRequest mpRequest = (MultipartHttpServletRequest) request;
				final Map<String, MultipartFile> files = mpRequest.getFileMap();

				String[] qaFiles = map.get("addQaFileList").toString()
						.split(",");
				for (int i = 0; i < qaFiles.length; i++) {
					HashMap<String, MultipartFile> file = new HashMap<String, MultipartFile>();
					file.put(qaFiles[i], files.get(qaFiles[i]));
					_atchFileId = disFileMng.qaFileUpload("DISRQ_", request, file, i);
					if (_atchFileId != null) map.put("addFileId", _atchFileId);
					map.put("prodType", qaFiles[i].replace("qaFile", ""));
					disService.insertDisByStep(map);
				}

			} else {
				disFileMng.fileDelete(request);
				String _atchFileId = "";
				_atchFileId = disFileMng.fileUpload("DISRQ_", request);
				if (_atchFileId != null) map.put("disAddFileId", _atchFileId);
				disService.updateDisByStep(map);
			}
		}
		

		return "jsonView";
	}
		
		 /**
	     * 배포 다음단계로
	     * @throws Exception 
	     */
	    @RequestMapping(value="/dis/disNextStep.json")
	    public String disNextStep(HttpServletRequest request) throws Exception {
	    	System.out.println("/disNextStep.do");
	    	
	    	HashMap<Object, Object> map = new HashMap<Object, Object>();
	    	String currDisStat = request.getParameter("currDisStat");
	    	String currDisNo = request.getParameter("currDisNo");
	    	String examRstl = request.getParameter("examRstl");
			map.put("returnYn", "N");

//	    	if(currDisStat.equals("100")) { /* 배포요청단계일 경우 승인/반려가 없기 때문에 무조건 110으로 넘김 */
//	    		map.put("next", "110");
//	    	} 
//	    	else if (currDisStat.equals("150")) { /* 품질검토 요청 경우 승인/반려가 없기 때문에 무조건 160으로 넘김 */
//	    		map.put("next", "160");
//	    	} 
	    	if (currDisStat.equals("220") && examRstl.equals("001")) { /*배포 종료 처리*/
	    		map.put("disEndDttm", "Y");
	    		map.put("next", "230");
	    	} else {
	    		System.out.println("★★★★★★ " + examRstl);
		    	List<EgovMap> next = cmmService.getNextstep("DIS",currDisStat, examRstl);
		    	map.put("next", next.get(0).get("next"));

		    	log.debug("next : "+next.get(0).get("next"));
		    	log.debug("list : "+next.toString());
		    	
		    	if("002".equals(examRstl)) 	map.put("returnYn", "Y");
	    	}
	     
	    	map.put("currDisNo", currDisNo);
	     
	    	
	    	disService.updateDisMainStat(map);
	    	disSave(request);
	    	
			disService.updateDisMainReturnYn(map);
	    	return "jsonView";
	    }		
		
		
		/** 
		 * 파일 다운로드
		 * @param requestedFile
		 * @param response
		 * @throws Exception
		 */
/*		@Resource(name = "fileUploadProperties")
		Properties fileUploadProperties;*/
		@RequestMapping(value = "/dis/downloadFile.do")
		public void downloadFile(
				@RequestParam(value = "requestedFile") String requestedFile,
				@RequestParam(value = "reName") String reName,
				HttpServletResponse response) throws Exception {
			System.out.println("/dis/downloadFile.do");
			
			String uploadPath = EgovProperties.getProperty("Globals.fileStorePath");
						
			File uFile = new File(uploadPath, requestedFile); 		 
			int fSize = (int) uFile.length();
			System.out.println("fSize:::"+fSize);
			if (fSize > 0) {
	 
				BufferedInputStream in = new BufferedInputStream(
						new FileInputStream(uFile));
				// String mimetype = servletContext.getMimeType(requestedFile);
				String mimetype = "text/html";
	 
				response.setBufferSize(fSize);
				response.setContentType(mimetype);
				response.setHeader("Content-Disposition", "attachment; filename=\""
						+ reName + "\"");
				response.setContentLength(fSize);
	 
				FileCopyUtils.copy(in, response.getOutputStream());
				in.close();
				response.getOutputStream().flush();
				response.getOutputStream().close();
			} else {
				//setContentType을 프로젝트 환경에 맞추어 변경
				response.setContentType("text/html; charset=UTF-8");
				PrintWriter printwriter = response.getWriter();
				printwriter.println("<html>");					
				printwriter.println("<br><br><br><h2>파일이 존재하지 않습니다.<br>"
						+ reName + "</h2>");
				printwriter
						.println("<br><br><br><center><h3><a href='javascript:window.close();'>닫기</a></h3></center>");
				printwriter.println("<br><br><br>");
				printwriter.println("</html>");
				printwriter.flush();
				printwriter.close();
			}
		}	
		
	 
}
