package egovframework.rte.dsdsm.docManagement.service.impl;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Repository("DocServiceDAO")
public class DocServiceDAO extends EgovAbstractDAO {
	
	/**
	 * 
	 * @return 문서등록
	 * @exception Exception 
	*/
	public Map<String,Object> docReg(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		String[] docTypes = (String[]) h.get("doc_type");
		
		// 문서 등록
		result.put("CNT", insert("DocServiceDAO.docReg", h));
		
		// 문서유형 등록
		for(int i = 0; i < docTypes.length; i++){
			HashMap<String, String> hm = new HashMap<String, String>();
			hm.put("no", (String)h.get("no"));
			hm.put("doc_type", docTypes[i]);
			
			insert("DocServiceDAO.docTypeReg", hm);
		}

		return result;
	}
	
	/**
	 * 
	 * @return 문서번호 생성
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int getDocno(HashMap h) throws Exception {
		return (Integer) select("DocServiceDAO.getDocno", h);
				
	}
	
	/**
	 * 
	 * @return 문서 총 갯수
	 * @exception Exception 
	*/
	public int getListCnt(HashMap h) throws Exception {
		return (Integer) select("DocServiceDAO.getListCnt", h);
	}
	
	/**
	 * 
	 * @return 문서목록
	 * @exception Exception 
	*/
	public List getList(HashMap h) throws Exception {
		return list("DocServiceDAO.getList", h);
	}
	
	/**
	 * 
	 * @return 문서번호 중복체크
	 * @exception Exception 
	*/
	public Map<String,Object> checkDocNo(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("ONE", select("DocServiceDAO.checkDocNo", map));
		return result;
	}
	
	/**
	 * 
	 * @return 업무변경시 담당자 가져오기
	 * @exception Exception 
	*/
	public List getCharger(HashMap h){
		return list("DocServiceDAO.getCharger", h);
	}
	
	/**
	 * 
	 * @return 업무변경시 담당자 가져오기
	 * @exception Exception 
	*/
	public List getChargerSearch(HashMap h){
		return list("DocServiceDAO.getChargerSearch", h);
	}
	
	/**
	 * 
	 * @return 문서상세정보
	 * @exception Exception 
	*/
	public List getDocView(HashMap h) throws Exception {
		return list("DocServiceDAO.getDocView", h);
	}
	
	/**
	 * 
	 * @return 첨부파일을 불러온다
	 * @exception Exception 
	*/
	public List  selectAtchFileList(HashMap map) throws Exception {
		return  list("DocServiceDAO.selectAtchFileList", map);		
	}
	
	/**
	 * 
	 * @return 문서수정
	 * @exception Exception 
	*/
	public Map<String,Object> docEdit(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("DocServiceDAO.docEdit", h));
		return result;
	}
	
	/**
	 * 
	 * @return 문서 승인요청
	 * @exception Exception 
	*/
	public Map<String,Object> docNextStep(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("DocServiceDAO.docNextStep", h));
		return result;
	}
	
	/**
	 * 
	 * @return 문서 승인내용 수정
	 * @exception Exception 
	*/
	public Map<String,Object> docStepEdit(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("DocServiceDAO.docStepEdit", h));
		return result;
	}
	
	/**
	 * 
	 * @return 문서 승인검토 등록
	 * @exception Exception 
	*/
	public Map<String,Object> docStepReg(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("DocServiceDAO.docStepReg", h));
		return result;
	}

	/**
	 * 
	 * @return 문서 실행유무 수정(DOC_MANEGEMENT)
	 * @exception Exception 
	*/
	public Map<String,Object> docOperEdit(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("DocServiceDAO.docOperEdit", h));
		return result;
	}
	
	/**
	 * 
	 * @return 문서 실행유무 등록(DOC_OPER)
	 * @exception Exception 
	*/
	public Map<String,Object> docOperReg(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("DocServiceDAO.docOperReg", h));
		return result;
	}
	
	/**
	 * 
	 * @return 문서 승인검토 순번 가져오기
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int getDocSeq(HashMap h) throws Exception {
		return (Integer) select("DocServiceDAO.getDocSeq", h);
				
	}
	
	/**
	 * 
	 * @return 문서 실행유무 순번 가져오기
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int getOperSeq(HashMap h) throws Exception {
		return (Integer) select("DocServiceDAO.getOperSeq", h);
				
	}
	
	/**
	 * 
	 * @return 문서 승인정보
	 * @exception Exception 
	*/
	public List getDocApprList(HashMap h) throws Exception {
		return list("DocServiceDAO.getDocApprList", h);
	}
	
	/**
	 * 
	 * @return 문서 실행유무 변경 이력
	 * @exception Exception 
	 */
	public List getDocOperList(HashMap h) throws Exception {
		return list("DocServiceDAO.getDocOperList", h);
	}
	
	/**
	 * 
	 * @return 문서 총 갯수(popup)
	 * @exception Exception 
	*/
	public int getPopupListCount(HashMap h) throws Exception {
		return (Integer) select("DocServiceDAO.getPopupListCount", h);
				
	}	
	
	/**
	 * 
	 * @return 문서목록(popup)
	 * @exception Exception 
	*/
	public List getPopupList(HashMap h) throws Exception {
		return list("DocServiceDAO.getPopupList", h);
	}	
	
	
	/**
	 * 
   	 * 공문/법령/회의록  삭제처리
	 * @exception Exception 
	*/
	public Map<String,Object> docDelete(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", delete("DocServiceDAO.docDelete", h));
		return result;
	}
		
	
	/**
	 * 
   	 * 공문/법령/회의록 첨부파일 삭제처리
	 * @exception Exception 
	*/
	public Map<String,Object> docFileDelete(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", delete("DocServiceDAO.docFileDelete", h));
		return result;
	}
			
	
}
