package egovframework.rte.dsdsm.education.web;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.Writer;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.util.FileCopyUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.util.DataToHwpConverter;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;


@Controller
public class EduController {
	
	@Resource(name="DisFileMng")
	private  DisFileMng disFileMng;
   
	@Resource(name="CmmService")
	private CmmService cmmService;	
   
	 
	Logger log = LogManager.getLogger();


	/* 교육알림판 목록 화면으로 이동*/		 
	@RequestMapping(value = "/education/eduNoticeList.do")
	public String noticeList(ModelMap modelmap, HttpServletResponse response,HttpServletRequest request, HttpSession session) throws Exception {			
		
	    List<String> roleList=  (List<String>) session.getAttribute("ROLES");
		if(roleList != null) {
			System.out.println(roleList.contains("SYSMANAGER"));
			if(roleList.contains("SYSMANAGER")){
				modelmap.put("hasRole","Y");
			}else{
				modelmap.put("hasRole","N");
			}
		}
		
    	//mv.setViewName("dsdsm/education/eduNoticeList");
		return "dsdsm/education/eduNoticeList";
	}
	
	
	/* 교육알림판 등록 이동*/		 
	@RequestMapping(value = "/education/eduNoticeReg.do")
	public String eduNoticeReg(HttpServletResponse response,HttpServletRequest request, HttpSession session, ModelMap modelmap,@RequestParam Map<String, Object> param) throws Exception {			
		modelmap.put("command", param.get("command"));
		modelmap.put("sid"    , param.get("sid"));
    	return "dsdsm/education/eduNoticeReg";
	}
	
	/* 교육알림판 등록 이동*/		 
	@RequestMapping(value = "/education/eduNoticeMod.do")
	public String eduNoticeMod(HttpServletResponse response,HttpServletRequest request, HttpSession session, ModelMap modelmap, @RequestParam Map<String, Object> param) throws Exception {			
		modelmap.put("command", param.get("command"));
		modelmap.put("sid", param.get("sid"));
    	return "dsdsm/education/eduNoticeReg";
	}
	
	/* 교육알림판 조회*/
	@RequestMapping(value = "/education/getEduNoticeList.do")
	public ModelAndView getNoticeList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
		ModelAndView mv = new ModelAndView();
		HashMap<Object, Object> map = new HashMap<Object, Object>();
		HashMap<Object, Object> pagingMap = new HashMap<Object, Object>();
		 
		String inqTitle = request.getParameter("inqTitle");
		String inqUserNm = request.getParameter("inqUserNm");
		
		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		map.put("inqTitle", inqTitle);
		map.put("inqUserNm", inqUserNm);
		
		int listCount = cmmService.selectNoticeListCnt(map);	
		int pageCount = (int) Math.ceil(listCount / pageSize);				
		
		map.put("listCount" , listCount);
		map.put("start"     , (int) (pageNo-1)*pageSize+1);
		map.put("end"       , (int) pageNo*pageSize);

		List list = cmmService.selectNoticeList(map);
		
		pagingMap.put("pageNo",pageNo);
		pagingMap.put("pageSize",pageSize);
		pagingMap.put("pageCount",pageCount);
		pagingMap.put("listCount",listCount);
		
		
		model.addAttribute("list",list);
		model.addAttribute("page",pagingMap);

        mv.setView(new JsonView());
		return mv;
	}		
	
	 /**
	 * 교육알림판 상세 화면으로 이동
	 * 
	 * @param response , request, defaultVO, model
	 * @return dsacc/pas/pasList
	 * @exception Exception
	 */                      
	@RequestMapping(value = "/education/eduNoticeView.do")
    public String eduNoticeView(HttpServletRequest request,  Model model, ModelMap modelmap, HttpSession session, @RequestParam Map<String, Object> param) throws Exception {
		modelmap.put("sid", (String)param.get("sid"));
    	return "dsdsm/education/eduNoticeView";
    }

	
	
	/* 교육내용 목록 화면으로 이동*/		 
	@RequestMapping(value = "/education/eduInfoList.do")
	public ModelAndView eduInfoList(HttpServletResponse response,HttpServletRequest request, HttpSession session) throws Exception {			
		
		ModelAndView mv = new ModelAndView();
 
	    List<String> roleList=  (List<String>) session.getAttribute("ROLES");
		mv.addObject("hasRole","N");
		if(roleList != null) { 				
			if(roleList.contains("SYSMANAGER")) mv.addObject("hasRole","Y");	 
		}
		
    	mv.setViewName("dsdsm/education/eduInfoList");
		return mv;
	}
	
	/**
	* 교육내용 상세 화면으로 이동
	* 
	* @param response , request, defaultVO, model
	* @return dsacc/pas/pasList
	* @exception Exception
	*/                      
	@RequestMapping(value = "/education/eduInfoView.do")
   public String eduInfoView(HttpServletRequest request,  Model model, ModelMap modelmap, HttpSession session, @RequestParam Map<String, Object> param) throws Exception {
		modelmap.put("sid", (String)param.get("sid"));
   	return "dsdsm/education/eduInfoView";
   }
	
	/* 교육내용 등록 이동*/		 
	@RequestMapping(value = "/education/eduInfoReg.do")
	public String eduInfoReg(HttpServletResponse response,HttpServletRequest request, HttpSession session, ModelMap modelmap, @RequestParam Map<String, Object> param) throws Exception {			
		modelmap.put("command", param.get("command"));
		modelmap.put("sid", param.get("sid"));
    	return "dsdsm/education/eduInfoReg";
	}
	
	/* 사용자 팝업*/		 
	@RequestMapping(value = "/education/eduInfoUserList.do")
	public String eduInfoUserList(HttpServletResponse response,HttpServletRequest request, HttpSession session) throws Exception {			
    	return "dsdsm/education/eduInfoUserList";
	}
	
	 @RequestMapping(value = "/education/downloadExcelFile.do")
		public void downloadExcelFile(HttpSession session, HttpServletRequest request, @RequestParam Map<String, Object> param, HttpServletResponse response) throws Exception {
	    	
	    	
	    	Map userInfo = (Map)session.getAttribute("userInfo");

			param.put("ROLES",session.getAttribute("ROLES"));
	    	param.put("deptId", userInfo.get("deptId"));
	    	param.put("userId", userInfo.get("userId"));
	    	param.put("loginId", userInfo.get("loginId"));
			
	    	
	    	String excelPath   = EgovProperties.getProperty("Globals.excelTemplatePath");
	    	String filename    = "UserList.xls";
	    	
	    	boolean result = false;
	    	
	    	File excelFile = new File(excelPath+filename);
	    	
	    	
	    	System.out.println(excelFile.exists());
	    	
	    	if(excelFile.exists()){
	    		result = true;
	    		
	    	}
			
		    	if(result){
		    		
		    		File uFile = new File(excelPath, filename);
		    		
		    		int fSize = (int) uFile.length();
		     
		    		BufferedInputStream in = new BufferedInputStream(new FileInputStream(uFile));
		    		String mimetype = "text/html";
		    		
		    		response.setCharacterEncoding("UTF-8");
		    		response.setBufferSize(fSize);
		    		response.setContentType(mimetype);
		
		    		String header = request.getHeader("User-Agent");
		    		if (header.indexOf("edge") > -1 ) {
		    			//filename = URLEncoder.encode(filename, "UTF-8").replace("+", "%20");
		    			System.out.println("edge: "+filename);
		    			response.setHeader("Content-Disposition", "attachment;filename=" + filename + ";filename*= UTF-8''" + filename);
		    		} else if (header.indexOf("hrome") > -1) {
		    			System.out.println("chrome: "+filename);
		    			//filename = URLEncoder.encode(filename, "UTF-8").replace("+", " ");
		    			response.setHeader("Content-Disposition","attachment; filename=\"" + filename + "\"");
		    		} else {
		    			System.out.println("etc : "+filename);
		    			//filename = URLEncoder.encode(filename, "UTF-8");
		    			response.setHeader("Content-Disposition","attachment;filename=\"" + filename + "\"");
		    		}
		    		
		    		
		    		response.setContentLength(fSize);
		    		
		    		
		    		FileCopyUtils.copy(in, response.getOutputStream());
		    		in.close();
		    		response.getOutputStream().flush();
		    		response.getOutputStream().close();
		    		
		    		
		    		
		    		
		    	}else{
		    		Writer out = response.getWriter();
		    		out.append("<script>");
		    		out.append("alert('Excel 파일이 생성시 오류가 발생하였습니다!!');");
		    		out.append("</script>");
		    	}

		}

}
