package egovframework.rte.dsdsm.issues.service.impl;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Service;

import egovframework.rte.fdl.cmmn.AbstractServiceImpl;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;
import egovframework.rte.dsdsm.projectSchedule.service.ProjScService;
import egovframework.rte.dsdsm.issues.service.issuesService;
import egovframework.rte.dsdsm.taskOrder.service.taskOrderService;

@Service("issuesService")
public class issuesImpl extends EgovAbstractServiceImpl implements issuesService{		
	
    @Resource(name="issuesDAO")
    private issuesDAO issuesDAO;
    
	private Logger log = LogManager.getLogger();

	@Override
	public int getIssuesListCount(HashMap h) throws Exception {
		return issuesDAO.getIssuesListCount(h);
	}

	@Override
	public List getIssuesList(HashMap h) throws Exception {
        return issuesDAO.getIssuesList(h);
	}
	
    /**
	 * 이슈  테이블에 등록
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 이슈  테이블에 등록
	 * @exception Exception
	 */  	
    public Map<String, Object> issueskDBreg(HashMap h) throws Exception {    
    	

		Map <String,Object> issueskDBreg = issuesDAO.issueskDBreg(h);
		Map <String,Object> result = new HashMap<String, Object>();
		
		String issuesSno = (String)issueskDBreg.get("issuesSno");
		
		log.debug(issueskDBreg.toString());
		log.debug(issuesSno);
		HashMap<String, String> h2 = new HashMap<String, String>();
		h2.put("issuesSno", issuesSno);
		
		int cnt  = issuesDAO.issuesCheckCount(h2);
		 
		if(cnt > 0){
			result.put("SUCCESS", true);
			result.put("issuesSno", issuesSno);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
     }
    
    
    /**
	 * 이슈  테이블에 수정
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 이슈  테이블에 수정
	 * @exception Exception
	 */     	
    public Map<String, Object> issueskDBedt(HashMap h) throws Exception {    
    	

		Map <String,Object> result = issuesDAO.issueskDBedt(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
     }    
    
	@Override
	public List issuesView(HashMap h) throws Exception {
        return issuesDAO.issuesView(h);
	}  
	
	
    /**
	 * 이슈  테이블에 수정
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 이슈  테이블에 수정
	 * @exception Exception
	 */     	
    public Map<String, Object> issuesDelete(HashMap h) throws Exception {    
    	

		Map <String,Object> result = issuesDAO.issuesDelete(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
     }   	

}
