package egovframework.rte.dsdsm.issues.web;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFDataFormat;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.formula.functions.Replace;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.ibm.icu.text.SimpleDateFormat;

import egovframework.rte.cmmn.helper.JsonView;
import ch.qos.logback.core.net.SyslogOutputStream;

import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.issues.service.issuesService;


import egovframework.rte.dsdsm.cmmcheck.util.ParamInfoUtil;
import egovframework.rte.cmmn.util.StringUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;


/** Time and attendance management **/
@Controller
public class issuesController {
	
	@Resource(name="ParamInfoUtil")
	private  ParamInfoUtil paramInfoUtil;
	
	@Resource(name="StringUtil")
	private  StringUtil StringUtil;
	
	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
	
	@Resource(name ="CodeService")
	private CodeService codeService;
	
	@Resource(name = "issuesService")
    private issuesService issuesService;
	
	private Logger log = LogManager.getLogger();
	
	
	/**
     * 이슈 리스트
	 * @throws Exception 
     */
    @RequestMapping(value="/issues/issuesList.do")
    public String issuesList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	map.put("codeId", "isus01");
		model.addAttribute("isus01", CmmService.getCmmDitcList(map));
		
    	map.put("codeId", "isus02");
		model.addAttribute("isus02", CmmService.getCmmDitcList(map));
		
    	map.put("codeId", "sts010");
		model.addAttribute("sts010", CmmService.getCmmDitcList(map));	
    	
    	return "/dsdsm/issues/issuesList";
    }
    
    
    /**
     * 이슈 리스트 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/issues/getIssuesList.do")
	public String getIssuesList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		
    	//paramInfoUtil.mpaInfo_print(param);
		
		int listCount = issuesService.getIssuesListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = issuesService.getIssuesList(param);	
		
		log.debug(list.toString());
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}  	
	
	
	/**
     * 이슈 리스트 등록
	 * @throws Exception 
     */
    @RequestMapping(value="/issues/issuesReg.do")
    public String issuesReg(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	map.put("roleId", "MANAGER000");
		model.addAttribute("authority", CmmService.getAuthority(map));
		
		map.put("roleId", "SYSMANAGER");
		model.addAttribute("authority2", CmmService.getAuthority(map));
		
    	map.put("codeId", "isus01");
		model.addAttribute("isus01", CmmService.getCmmDitcList(map));
		
    	map.put("codeId", "isus02");
		model.addAttribute("isus02", CmmService.getCmmDitcList(map));
		
    	map.put("codeId", "sts010");
		model.addAttribute("sts010", CmmService.getCmmDitcList(map));		
    	
    	return "/dsdsm/issues/issues_reg";
    }
    
    
	/**
     * 이슈 리스트 등록
	 * @throws Exception 
     */
    @RequestMapping(value="/issues/issuesReg.json")
    public String issueskDBreg(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	log.debug(param.get("gbn"));
    	
    	//paramInfoUtil.mpaInfo_print(param);
  	
    	result = issuesService.issueskDBreg(param);
    	
    	result.put("issuesSno", param.get("issuesSno"));
    	log.debug(result.toString());
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }

    
	/**
     * 이슈 리스트 등록
	 * @throws Exception 
     */
    @RequestMapping(value="/issues/issuesEdit.do")
    public String issueskEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model,HttpSession session, ModelMap map) throws Exception {
    	
    	log.debug("/issues/issuesEdit.do");
    	
    	//paramInfoUtil.mpaInfo_print(param);
    	
    	map.put("codeId", "isus01");
		model.addAttribute("isus01", CmmService.getCmmDitcList(map));
		
    	map.put("codeId", "isus02");
		model.addAttribute("isus02", CmmService.getCmmDitcList(map));
		
    	map.put("codeId", "sts010");
		model.addAttribute("sts010", CmmService.getCmmDitcList(map));		
    	
    	List list = issuesService.issuesView(param);
		model.addAttribute("list",list);
		
		
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0130040000000");
    	
    	String dutyCd      = (String)userInfos.get("dutyCd");
    	String lolCheck    = (String)checkInfoG.get("lolId");
    	String insertCheck = (String)checkInfoG.get("insertYn");
    	String readCheck   = (String)checkInfoG.get("readYn");
    	String updateCheck = (String)checkInfoG.get("updateYn");
    	String deleteCheck = (String)checkInfoG.get("deleteYn");  		
		/*****/

    	model.addAttribute("regYn","");
    	
     return "/dsdsm/issues/issues_edit";	
   }
    
	/**
     * 이슈 리스트 등록
	 * @throws Exception 
     */
    @RequestMapping(value="/issues/issuesEdt.json")
    public String issueskDBedt(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	log.debug(param.get("gbn"));
    	
    	//paramInfoUtil.mpaInfo_print(param);
  	
    	result = issuesService.issueskDBedt(param);
    	
    	result.put("issuesSno", param.get("issuesSno"));
    	log.debug(result.toString());
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }    
    
    /**
     * 이슈 리스트 등록
	 * @throws Exception 
     */
    @RequestMapping(value="/issues/issuesView.do")
    public String issueskView(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model,HttpSession session, ModelMap map) throws Exception {
    	
    	log.debug("/issues/issuesView.do");
    	
    	//paramInfoUtil.mpaInfo_print(param);
    	
    	map.put("codeId", "isus01");
		model.addAttribute("isus01", CmmService.getCmmDitcList(map));
		
    	map.put("codeId", "isus02");
		model.addAttribute("isus02", CmmService.getCmmDitcList(map));
		
    	map.put("codeId", "sts010");
		model.addAttribute("sts010", CmmService.getCmmDitcList(map));		
    	
    	List list = issuesService.issuesView(param);
		model.addAttribute("list",list);
		
		
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0130040000000"); //0130040000000
    	
    	String dutyCd      = (String)userInfos.get("dutyCd");
    	String lolCheck    = (String)checkInfoG.get("lolId");
    	String insertCheck = (String)checkInfoG.get("insertYn");
    	String readCheck   = (String)checkInfoG.get("readYn");
    	String updateCheck = (String)checkInfoG.get("updateYn");
    	String deleteCheck = (String)checkInfoG.get("deleteYn");  		
		/*****/

    	model.addAttribute("regYn","");
    	
     return "/dsdsm/issues/issues_view";	
   }    
    
	/**
     * 이슈 리스트 등록
	 * @throws Exception 
     */
    @RequestMapping(value="/issues/issuesDelete.json")
    public String issuesDelete(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	log.debug(param.get("gbn"));
    	
    	//paramInfoUtil.mpaInfo_print(param);
  	
    	result = issuesService.issuesDelete(param);
    	
    	result.put("issuesSno", param.get("issuesSno"));
    	log.debug(result.toString());
    	
    	map.put("result", result);
    	
    	return "jsonView";
    } 
    
    
    
    
    @RequestMapping(value="/issues/issuesExcelDown.json")
    //public void excelDown(@RequestParam HashMap<Object,Object> param, HttpServletRequest request, HttpServletResponse response) throws Exception {
    public void issuesExcelDown(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, HttpServletResponse response, ModelMap model, HttpSession session) throws Exception {    	
  	   
        log.debug(":::::::::: issuesExcelDown");
     	
  	   Date d = new Date();
  	   SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HHmmss");
  	   String dates = sdf.format(d);
         
  	   String projectId     = "";
  	   
  	   HashMap<Object, Object> chgPrm = new HashMap<Object, Object>();
  	   String businessName       = (String)param.get("businessName");
  	   String taskOrderName      = (String)param.get("taskOrderName");
  	   String issuesTitle        = (String)param.get("issuesTitle");
  	   String issuesSeverasc     = (String)param.get("issuesSeverasc");
  	   String issuesImportanceSc = (String)param.get("issuesImportanceSc");
  	   String issuesStatusSc     = (String)param.get("issuesStatusSc");
  	   String isOcTime           = (String)param.get("isOcTime");
  	   String isEsime            = (String)param.get("isEsime");
  	   String isClTime           = (String)param.get("isClTime");

	   chgPrm.put("businessName",businessName);
	   chgPrm.put("taskOrderName",taskOrderName);
	   chgPrm.put("issuesTitle",issuesTitle);
	   chgPrm.put("issuesSeverasc",issuesSeverasc);
	   chgPrm.put("issuesImportanceSc",issuesImportanceSc);
	   chgPrm.put("issuesStatusSc",issuesStatusSc);
	   chgPrm.put("isOcTime",isOcTime);
	   chgPrm.put("isEsime",isEsime);
	   chgPrm.put("isClTime",isClTime);
  	   chgPrm.put("start", (int)1);
  	   chgPrm.put("end", (int)999);

  	   
  	   
  	   List list = issuesService.getIssuesList(chgPrm);
  	   
 	   
  	   //String fileNm = "C:/dev/"+projectId+"Excel_"+dates+".xls";
  	   String fileNm = "issuesList_Excel_"+dates+".xls";
  	   
  	   // Workbook 생성
  	   HSSFWorkbook  workbook = new HSSFWorkbook(); // Excel 2007 이전 버전 	   
  	   

 // *** Sheet-------------------------------------------------
         // Sheet 생성
         HSSFSheet sheet1 = workbook.createSheet("근태현황");
         
         // Data Format
         HSSFDataFormat df = workbook.createDataFormat();
      
         Row row = null;
         Cell cell = null;
         //----------------------------------------------------------
          
         // 첫 번째 줄
         row = sheet1.createRow(0);
          
         // 첫 번째 줄에 Cell 설정하기-------------
          
         cell = row.createCell(1);
         cell.setCellValue("번호");
         
         cell = row.createCell(2);
         cell.setCellValue("사업(요구사항)명칭");        

         cell = row.createCell(3);
         cell.setCellValue("요구사항");
         
         cell = row.createCell(4);
         cell.setCellValue("중요 Task");

         cell = row.createCell(5);
         cell.setCellValue("중요도");
         
         cell = row.createCell(6);
         cell.setCellValue("긴급성");
         
         cell = row.createCell(7);
         cell.setCellValue("진행여부");
         
         cell = row.createCell(8);
         cell.setCellValue("이슈 발생일자");
         
         cell = row.createCell(9);
         cell.setCellValue("이슈제목");         
         
         cell = row.createCell(10);
         cell.setCellValue("이슈발생내용");
         
         cell = row.createCell(11);
         cell.setCellValue("이슈 종료예정 일자");
         
         cell = row.createCell(12);
         cell.setCellValue("이슈 종료일자");
         
         cell = row.createCell(13);
         cell.setCellValue("해결 및 방안");         
         


         // 두 번째 줄에 Cell 설정하기-------------
         int rowIdx = 0;
         int sumNum = 2;

         //log.debug(">>> [arrayDepends]"+arrayDepends.length);

         for(int i=0;i<list.size();i++){
         	
         	@SuppressWarnings("unchecked")
             Map<Object,Object> listData = (Map<Object, Object>) list.get(i);
             row = sheet1.createRow(++rowIdx); 
             
 	        cell = row.createCell(1);
 	        cell.setCellValue((String)listData.get("sno").toString());
 	        
 	        cell = row.createCell(2);
      	    cell.setCellValue((String)listData.get("businessIdName"));
      	    
      	    cell = row.createCell(3);
 	        cell.setCellValue((String)listData.get("requirementsName")+"("+listData.get("businessTaskName")+")");  
 	        
  	        cell = row.createCell(4);
 	        cell.setCellValue((String)listData.get("projectName")+"("+listData.get("takeName")+")");
 	        
 	        cell = row.createCell(5);
 	        cell.setCellValue((String)listData.get("issuesSeveralNm"));	        
 	        
 	        cell = row.createCell(6);
 	        cell.setCellValue((String)listData.get("issuesImportanceNm"));	        
 	        
 	        cell = row.createCell(7);
 	        cell.setCellValue((String)listData.get("issuesStatusNm"));
 	        
 	        cell = row.createCell(8);
 	        cell.setCellValue((String)listData.get("issuesOccurrenceTime"));
 	        
 	        cell = row.createCell(9);
 	        cell.setCellValue((String)listData.get("issuesTitle"));
 	        
 	        cell = row.createCell(10);
 	        cell.setCellValue((String)listData.get("issuesDescriptionExcel").toString().replace("&nbsp;",""));
 	        
 	        cell = row.createCell(11);
 	        cell.setCellValue((String)listData.get("issuesEstimatedTime"));
 	        
 	        cell = row.createCell(12);
 	        cell.setCellValue((String)listData.get("issuesClosingTime")); 	        
 	        
 	        cell = row.createCell(13);
 	        cell.setCellValue((String)listData.get("issuesWorkaroundExcel").toString().replace("&nbsp;",""));
 	        
 	        sumNum++;
         }

         // excel 파일 저장
         try {
      	   response.setContentType("Application/Msexcel");
      	   response.setHeader("Content-Disposition", "ATTachment; Filename="+fileNm+".xls");
      	   OutputStream fileOut  = response.getOutputStream();
             workbook.write(fileOut);
             fileOut.close();
         } catch (FileNotFoundException e) {
             e.printStackTrace();
         } catch (IOException e) {
             e.printStackTrace();
         }
          
     }	     
        
	
	

}
