package egovframework.rte.dsdsm.lmrc.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import egovframework.rte.dsdsm.cmm.service.vo.usrVO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

public interface LmrcService {
	
	
	/**
	 * 공문/법령 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> docReg(HashMap h) throws Exception;
	
	/**
	 * 문서 고유번호 생성하기
	 * @return int
	 * @exception Exception 
	*/
	public int getDocno(HashMap h) throws Exception;
	
	/**
	 * 문서 총 갯수
	 * @return int
	 * @exception Exception 
	*/
	public int getListCount(HashMap h) throws Exception;
	
	/**
	 * 문서 목록을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return S/R 목록
	 * @exception Exception
	 */
    public List getList(HashMap h) throws Exception;
    
    /**
	 * 문서번호 중복체크
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 문서번호 중복체크
	 * @exception Exception
	 */
    public Map<String,Object> checkDocNo(Map<String, String> map) throws Exception;
    
    /**
	 * 업무 변경시 담당자 가져오기
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 업무 변경시 담당자 가져오기
	 * @exception Exception
	 */
    public List getCharger(HashMap h) throws Exception;

    /**
     * 담당자 가져오기
     * @param HashMap - 조회할 정보가 담긴 HashMap
     * @return 담당자 가져오기
     * @exception Exception
     */
    public List getChargerSearch(HashMap h) throws Exception;
    
    /**
	 * 문서 상세정보을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 문서 상세정보
	 * @exception Exception
	 */
    public List getDocView(HashMap h) throws Exception;
    
    /**
	 * 첨부파일을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 첨부파일을 불러온다
	 * @exception Exception
	 */
    public List selectAtchFileList(HashMap map ) throws Exception;
    
    /**
	 * 문서 수정
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> docEdit(HashMap h) throws Exception;
	
	/**
	 * 문서 승인요청
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> docNextStep(HashMap h) throws Exception;
	
	/**
	 * 문서 승인내용 수정
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> docStepEdit(HashMap h) throws Exception;
	
	/**
	 * 문서 승인검토 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> docStepReg(HashMap h) throws Exception;
	
	/**
	 * 문서 실행유무 수정(DOC_MANAGEMENT)
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> docOperEdit(HashMap h) throws Exception;
	
	/**
	 * 문서 실행유무 등록(DOC_OPER)
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> docOperReg(HashMap h) throws Exception;
	
	
	/**
	 * 문서 승인검토 순번 생성하기
	 * @return int
	 * @exception Exception 
	*/
	public int getDocSeq(HashMap h) throws Exception;
	
	/**
	 * 문서 실행유무 순번 생성하기
	 * @return int
	 * @exception Exception 
	*/
	public int getOperSeq(HashMap h) throws Exception;
	
	/**
	 * 문서 승인정보를 불러온다.
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 문서 승인정보
	 * @exception Exception
	 */
    public List getDocApprList(HashMap h) throws Exception;
    
    /**
	 * 문서 실행유무 변경 이력
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 문서 실행유무 변경 이력
	 * @exception Exception
	 */
    public List getDocOperList(HashMap h) throws Exception;
    
    
	/**
	 * 문서 총 갯수(popup)
	 * @return int
	 * @exception Exception 
	*/
	public int getPopupListCount(HashMap h) throws Exception;  
	
	
	/**
	 * 문서 목록을 불러온다(popup)
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return S/R 목록
	 * @exception Exception
	 */
    public List getPopupList(HashMap h) throws Exception;	
    
    /**
	 * 공문/법령/회의록 삭제처리
	 * @param HashMap - 결과 HashMap
	 * @return 첨부파일을 불러온다
	 * @exception Exception
	 */
    public Map<String,Object> docDelete(HashMap h) throws Exception;
    
    /**
	 * 공문/법령/회의록 첨부파일 삭제처리
	 * @param HashMap - 결과 HashMap
	 * @return 첨부파일을 불러온다
	 * @exception Exception
	 */
    public Map<String,Object> docFileDelete(HashMap h) throws Exception;    
    
    
}