package egovframework.rte.dsdsm.lmrc.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Service;

import egovframework.rte.dsdsm.lmrc.service.LmrcService;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Service("LmrcService")
public class LmrcServiceImpl extends EgovAbstractServiceImpl implements LmrcService{
	
    @Resource(name="LmrcServiceDAO")
    private LmrcServiceDAO LmrcServiceDAO;
    
	private Logger log = LogManager.getLogger();

    /**
	 * 문서등록
	 * @exception Exception 
	*/
    public Map<String, Object> docReg(HashMap h) throws Exception {
		Map <String,Object> result = LmrcServiceDAO.docReg(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
	 * 문서 고유번호 생성하기
	 * @exception Exception 
	*/
    public int getDocno(HashMap h) throws Exception {
		return LmrcServiceDAO.getDocno(h);
	}
    
    /**
	 * 문서 총 갯수
	 * @exception Exception
	 */
    public int getListCount(HashMap h) throws Exception {
		return LmrcServiceDAO.getListCount(h);
	}
    
    /**
	 * 문서목록
	 * @exception Exception
	 */
    public List getList(HashMap h) throws Exception {
        return LmrcServiceDAO.getList(h);
    }
    
    /**
   	 * 문서번호 중복체크
   	 * @exception Exception
   	 */
    @Override
	public Map<String, Object> checkDocNo(Map<String, String> map) throws Exception {
		
		Map <String,Object> result = LmrcServiceDAO.checkDocNo(map);
		
		@SuppressWarnings("unchecked")
		Map<String, Object> one = (Map<String, Object>)result.get("ONE");
		
		if(one==null){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "문서번호를 사용할 수 있습니다.");
		}else{
			result.put("SUCCESS", false);
			result.put("MESSAGE", "문서번호가 중복되었습니다.<br>다른 문서번호를 입력해주세요.");
		}
		
		return result;
	}
    
    /**
   	 * 업무 변경시 담당자 가져오기
   	 * @exception Exception
   	 */
    @Override
	public List getCharger(HashMap h) throws Exception {
    	return LmrcServiceDAO.getCharger(h);
	}
    
    /**
   	 * 담당자 가져오기
   	 * @exception Exception
   	 */
    @Override
	public List getChargerSearch(HashMap h) throws Exception {
    	return LmrcServiceDAO.getChargerSearch(h);
	}
    
    /**
   	 * 문서 상세정보
   	 * @exception Exception
   	 */
    public List getDocView(HashMap h) throws Exception {
       return LmrcServiceDAO.getDocView(h);
    }
    
    /**
   	 * 첨부파일을 불러온다
   	 * @exception Exception
   	 */
    public List selectAtchFileList(HashMap map) throws Exception {
		return LmrcServiceDAO.selectAtchFileList(map);
	}
    
    /**
   	 * 문서 수정
   	 * @exception Exception
   	 */
    public Map<String, Object> docEdit(HashMap h) throws Exception {
    	
    	Map <String,Object> result = LmrcServiceDAO.docEdit(h);
		
    	Integer cnt = (Integer)result.get("CNT");
    	
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "저장되었습니다.");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "저장에 실패하였습니다. 잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
   	 * 문서 승인요청
   	 * @exception Exception
   	 */
    public Map<String, Object> docNextStep(HashMap h) throws Exception {
    	
    	Map <String,Object> result = LmrcServiceDAO.docNextStep(h);
		
    	Integer cnt = (Integer)result.get("CNT");
    	
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "완료되었습니다.");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "실패하였습니다. 잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
   	 * 문서 승인내용 수정
   	 * @exception Exception
   	 */
    public Map<String, Object> docStepEdit(HashMap h) throws Exception {
    	
    	Map <String,Object> result = LmrcServiceDAO.docStepEdit(h);
		
    	Integer cnt = (Integer)result.get("CNT");
    	
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "완료되었습니다.");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "실패하였습니다. 잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
	 * 문서 승인검토 등록
	 * @exception Exception 
	*/
    public Map<String, Object> docStepReg(HashMap h) throws Exception {
		Map <String,Object> result = LmrcServiceDAO.docStepReg(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
   	 * 문서 실행유무 수정(DOC_MANEGEMENT)
   	 * @exception Exception
   	 */
    public Map<String, Object> docOperEdit(HashMap h) throws Exception {
    	
    	Map <String,Object> result = LmrcServiceDAO.docOperEdit(h);
		
    	Integer cnt = (Integer)result.get("CNT");
    	
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
		} else {
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
	 * 문서 실행유무 등록(DOC_OPER)
	 * @exception Exception 
	*/
    public Map<String, Object> docOperReg(HashMap h) throws Exception {
		Map <String,Object> result = LmrcServiceDAO.docOperReg(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
	 * 문서 승인검토 순번 가져오기
	 * @exception Exception 
	*/
	public int getDocSeq(HashMap h) throws Exception {
		return LmrcServiceDAO.getDocSeq(h);
	}
	
	/**
	 * 문서 실행유무 순번 가져오기
	 * @exception Exception 
	*/
	public int getOperSeq(HashMap h) throws Exception {
		return LmrcServiceDAO.getOperSeq(h);
	}
	
	/**
   	 * 문서 승인정보
   	 * @exception Exception
   	 */
    public List getDocApprList(HashMap h) throws Exception {
       return LmrcServiceDAO.getDocApprList(h);
    }
    
    /**
   	 * 문서 실행유무 변경 이력
   	 * @exception Exception
   	 */
    public List getDocOperList(HashMap h) throws Exception {
       return LmrcServiceDAO.getDocOperList(h);
    }
    
    /**
	 * 문서 총 갯수(popup)
	 * @exception Exception
	 */
    public int getPopupListCount(HashMap h) throws Exception {
		return LmrcServiceDAO.getPopupListCount(h);
	} 
    
    /**
	 * 문서목록(popup)
	 * @exception Exception
	 */
    public List getPopupList(HashMap h) throws Exception {
        return LmrcServiceDAO.getPopupList(h);
    }
    
    
    /**
   	 * 공문/법령/회의록 첨부파일 삭제처리
   	 * @exception Exception
   	 */
    public Map<String, Object> docDelete(HashMap h) throws Exception {
    	
    	Map <String,Object> result = LmrcServiceDAO.docDelete(h);
		
    	Integer cnt = (Integer)result.get("CNT");
    	
    	log.debug(cnt);
    	
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
		} else {
			result.put("SUCCESS", false);
		}
		
		return result;
	}   
    
    
    /**
   	 * 공문/법령/회의록 첨부파일 삭제처리
   	 * @exception Exception
   	 */
    public Map<String, Object> docFileDelete(HashMap h) throws Exception {
    	
    	Map <String,Object> result = LmrcServiceDAO.docFileDelete(h);
		
    	Integer cnt = (Integer)result.get("CNT");
    	
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
		} else {
			result.put("SUCCESS", false);
		}
		
		return result;
	}   
        
    
}
