package egovframework.rte.dsdsm.lmrc.web;

import java.io.File;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.codehaus.jackson.map.ObjectMapper;
import org.jfree.util.Log;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import ch.qos.logback.core.net.SyslogOutputStream;
import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovFileMngService;
import egovframework.rte.cmmn.util.EgovFileMngUtil;
import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.cmmn.util.StringUtil;
import egovframework.rte.cmmn.vo.FileVO;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.service.vo.SearchVO;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.cmmcheck.util.ParamInfoUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;
import egovframework.rte.dsdsm.lmrc.service.LmrcService;

@Controller
public class LmrcController {

	@Resource(name = "LmrcService")
    private LmrcService LmrcService;

	@Resource(name = "CmmService")
    private CmmService CmmService;

	@Resource(name ="CodeService")
	private CodeService codeService;

	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;

	@Resource(name="EgovFileMngUtil")
	private EgovFileMngUtil fileUtil;

	@Resource(name="DisFileMng")
	private  DisFileMng disFileMng;

	/** 추가 **/
	@Resource(name="ParamInfoUtil")
	private  ParamInfoUtil paramInfoUtil;

	@Resource(name="StringUtil")
	private  StringUtil StringUtil;


	@Resource(name="EgovFileMngService")
	private EgovFileMngService fileMngService;


	private Logger log = LogManager.getLogger();
	
	
	/**
     * 법령 관리 목록화면으로 들어간다.
     * @throws Exception
     */
    @RequestMapping(value="/lmrc/lmrcList.do")
    public String docList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	
    	log.debug("/lmrc/lmrcList.do");

    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");


    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");

    	String regYn = "N";
    	String manageYn = "N";
    	String implementedYn = "N";

    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0080040000000");


    	String dutyCd      = (String)userInfos.get("dutyCd");
    	String lolCheck    = (String)checkInfoG.get("lolId");
    	String insertCheck = (String)checkInfoG.get("insertYn");
    	String readCheck   = (String)checkInfoG.get("readYn");
    	String updateCheck = (String)checkInfoG.get("updateYn");
    	String deleteCheck = (String)checkInfoG.get("deleteYn");
    	String conformCheck = (String)checkInfoG.get("conformYn");
    	String implementedCheck = (String)checkInfoG.get("implementedYn");

    	
    	if("900".equals(dutyCd)){
    		regYn = "Y";
    		manageYn = "Y";
    	} else if("Y".equals(insertCheck)){
    		regYn = "Y";
    		manageYn = "N";
    	} else {
    		regYn = "N";
    		manageYn = "N";
        }

    	if("Y".equals(conformCheck)){
    		manageYn = "Y";
    	}

    	if("Y".equals(implementedCheck)){
    		implementedYn = "Y";
    	}

    	model.addAttribute("regYn",insertCheck);
    	model.addAttribute("manageYn",manageYn);
    	model.addAttribute("implementedYn",implementedYn);

    	HashMap<Object, Object> map = new HashMap<Object, Object>();

    	map.put("codeId", "DO1000");

		model.addAttribute("docGbn", CmmService.getCmmDitcList(map));

		model.addAttribute("charger", LmrcService.getChargerSearch(map));

		@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();
    	ObjectMapper mapper1 = new ObjectMapper();
   		String jobCdsJsonStr = mapper1.writeValueAsString(jobCds);

		model.addAttribute("JOB_LIST", jobCdsJsonStr);

    	return "/dsdsm/lmrc/lmrcList";
    }	
	
	
    /**
     * 문서목록을 불러온다.
     * @throws Exception
     */
	@RequestMapping(value = "/lmrc/getList.do")
	public String getList(@RequestParam(value="jobCd",required=false) String[] jobCd,@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		param.put("jobCd", jobCd);
		log.debug("jobCd ::: "+jobCd);

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		String  checkInfo =  (request.getParameter("checkPangInfo") != null) ? request.getParameter("checkPangInfo") : "";
		String  popYn =  (request.getParameter("popYn") != null) ? request.getParameter("popYn") : "";

	    log.debug("");
		log.debug(">>>>> param "+param.toString());
		log.debug("");


		int listCount = LmrcService.getListCount(param);


		int pageCount = (int) Math.ceil(listCount / pageSize);

		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);

		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);

		List list = LmrcService.getList(param);

 	  	model.put("list",list);
 	  	model.put("page",pageinMap);

		return "jsonView";
	}	
	
	

	/**
     * 법령 등록화면으로 들어간다.
	 * @throws Exception
     */
    @RequestMapping(value="/lmrc/lmrcRegist.do")
    public String officialReg(HttpServletRequest request, Model model) throws Exception {

    	HashMap<Object, Object> map = new HashMap<Object, Object>();

    	map.put("codeId", "DO1000");

		model.addAttribute("docGbn", CmmService.getCmmDitcList(map));

		map.put("codeId", "DO2000");

		model.addAttribute("docType", CmmService.getCmmDitcList(map));

		@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();
    	ObjectMapper mapper = new ObjectMapper();
   		String jobCdsJsonStr = mapper.writeValueAsString(jobCds);
   		model.addAttribute("JOB_LIST", jobCdsJsonStr);

		String gbn = request.getParameter("gbn");

		String returnValue = "";

		return "/dsdsm/lmrc/official/lmrcReg";

    }
    
    
    /**
     * 문서 등록
     * @throws Exception
     */
    @RequestMapping(value="/lmrc/lmrcReg.json")
    public String docReg(@RequestParam("doc_type") String[] doc_type,@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {

    	log.debug("문서 등록 시작");

    	String _atchFileId = "";
		_atchFileId = disFileMng.fileUpload("DORQ_",request);
		param.put("disAddFileId", _atchFileId);

    	int getno = 0;
    	String docno = "";

    	getno = LmrcService.getDocno(param);
    	docno = String.format("%04d", getno);

    	docno = "DO" + DateUtil.toYYYYMMDDDate(DateUtil.getDate()) + docno;
    	param.put("no",docno);
    	param.put("doc_type", doc_type);

    	if("".equals(param.get("doc_no")) || param.get("doc_no") == null){
    		param.put("doc_no", docno);
    	}

    	Map<String, Object> result = LmrcService.docReg(param);

    	map.put("result", result);
    	map.put("docNo",docno);
    	map.put("docGbn",param.get("doc_gbn"));

    	return "jsonView";
    }
    
    
    /**
     * 법령 상세보기화면으로 들어간다.
	 * @throws Exception
     */
    @SuppressWarnings("unchecked")
	@RequestMapping(value="/lmrc/lmrcView.do")
    public String docView(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {

    	log.debug(param.get("docNo"));
    	HashMap<Object, Object> map = new HashMap<Object, Object>();

    	map.put("codeId", "DO1000");

		model.addAttribute("docGbn", CmmService.getCmmDitcList(map));

		map.put("codeId", "DO2000");

		model.addAttribute("docType", CmmService.getCmmDitcList(map));

		map.put("codeId", "DO4000");

		model.addAttribute("operYn", CmmService.getCmmDitcList(map));

		List list = LmrcService.getDocView(param);

		model.addAttribute("list",list);
		model.addAttribute("fileList", LmrcService.selectAtchFileList(param));

    	String returnValue = "";

    	if("300".equals(param.get("docGbn"))){
    		returnValue = "/dsdsm/lmrc/conference/conferenceView";
    	} else {
    		returnValue = "/dsdsm/lmrc/official/lmrcView";
    	}

    	if(param.get("isModal") != null && "Y".equals(param.get("isModal"))) {
    		log.debug("MOdal");
    		returnValue = "/dsdsm/lmrc/lmrcViewPop";
    	}

    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");

/***
 * 메뉴권란 부분
 *
 * */

    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");

       	String regYn = "N";
    	String manageYn = "N";
    	String implementedYn = "N";

    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0080040000000"); // 법령관리 부분

    	String dutyCd      = (String)userInfos.get("dutyCd");
    	String lolCheck    = (String)checkInfoG.get("lolId");
    	String insertCheck = (String)checkInfoG.get("insertYn");
    	String readCheck   = (String)checkInfoG.get("readYn");
    	String updateCheck = (String)checkInfoG.get("updateYn");
    	String deleteCheck = (String)checkInfoG.get("deleteYn");
    	String conformCheck = (String)checkInfoG.get("conformYn");
    	String implementedCheck = (String)checkInfoG.get("implementedYn");

/*
    	if(ROLE.contains("DOREGISTOR")){
    		regYn = "Y";
		}

    	if(ROLE.contains("DOMANAGER0")){
    		manageYn = "Y";
		}

*/

    	if("900".equals(dutyCd)){
    		regYn = "Y";
    		manageYn = "Y";
    	} else if("Y".equals(insertCheck)){
    		regYn = "Y";
    		manageYn = "N";
    	} else {
    		regYn = "N";
    		manageYn = "N";
        }

    	if("Y".equals(conformCheck)){
    		manageYn = "Y";
    	}

    	if("Y".equals(implementedCheck)){
    		implementedYn = "Y";
    	}

    	model.addAttribute("regYn",insertCheck);
    	model.addAttribute("manageYn",manageYn);

    	model.addAttribute("implementedCheck",implementedCheck);
    	model.addAttribute("lolCheck",lolCheck);
    	model.addAttribute("insertCheck",insertCheck );
    	model.addAttribute("readCheck",readCheck);
    	model.addAttribute("updateCheck",updateCheck );
    	model.addAttribute("deleteCheck",deleteCheck );
    	model.addAttribute("conformCheck",conformCheck);

//********//

    	List apprList = LmrcService.getDocApprList(param);
    	List operList = LmrcService.getDocOperList(param);

    	model.addAttribute("apprList",apprList);
    	model.addAttribute("operList",operList);


    	return returnValue;
    }

    /**
     * 법령 수정화면으로 들어간다.
	 * @throws Exception
     */
    @SuppressWarnings("unchecked")
	@RequestMapping(value="/lmrc/lmrcEdit.do")
    public String docEditV(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {

    	HashMap<Object, Object> map = new HashMap<Object, Object>();

    	map.put("codeId", "DO1000");

		model.addAttribute("docGbn", CmmService.getCmmDitcList(map));

		map.put("codeId", "DO2000");

		model.addAttribute("docType", CmmService.getCmmDitcList(map));

		@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();
    	ObjectMapper mapper = new ObjectMapper();
   		String jobCdsJsonStr = mapper.writeValueAsString(jobCds);
   		model.addAttribute("JOB_LIST", jobCdsJsonStr);

		List list = LmrcService.getDocView(param);

		model.addAttribute("list",list);
		model.addAttribute("fileList", LmrcService.selectAtchFileList(param));

    	String returnValue = "";

   		returnValue = "/dsdsm/lmrc/official/lmrcEdit";

    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");

    	String regYn = "N";
    	String manageYn = "N";

    	if(ROLE.contains("DOREGISTOR")){
    		regYn = "Y";
		}

    	if(ROLE.contains("DOMANAGER0")){
    		manageYn = "Y";
		}

    	model.addAttribute("regYn",regYn);
    	model.addAttribute("manageYn",manageYn);

    	return returnValue;
    }
    

    /**
     * 문서 수정
     * @throws Exception
     */
    @RequestMapping(value="/lmrc/lmrcEdit.json")
    public String docEdit(@RequestParam("doc_type") String[] doc_type,@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {

    	log.debug("문서 수정 시작");

    	disFileMng.fileDelete(request);

    	String _atchFileId = "";
		_atchFileId = disFileMng.fileUpload("DOC_",request);
		log.debug(_atchFileId);
		if (_atchFileId != null) {
			param.put("disAddFileId", _atchFileId);
		}

    	param.put("doc_type", doc_type);

    	Map<String, Object> result = LmrcService.docEdit(param);

    	map.put("result", result);

    	return "jsonView";
    }

    /**
     * 법령 삭제처리
     * @throws Exception
     */
    @RequestMapping(value="/lmrc/lmrcDelete.json")
    public String docDelete(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {

    	log.debug("lmrcDelete.json");

    	String docNo = (String)request.getParameter("no");
    	param.put("docNo", docNo);

    	//log.debug(param.toString());

		List fileList = LmrcService.selectAtchFileList(param);

    	Map<String, Object> result = LmrcService.docDelete(param);

    	boolean check = (Boolean) result.get("SUCCESS");

    	//log.debug("<><<<<<<<<<<<<<<<<<<<<<<<<<"+check);

    	if(check){
        	String  storePathString = EgovProperties.getProperty("Globals.fileStorePath");

        	for (int i=0; i<fileList.size(); i++) {
        		Map<String, Object> fmap = (Map<String, Object>) fileList.get(i);
        		String  filePathAndname = storePathString+fmap.get("streFileNm");

        		File file = new File(filePathAndname);
                if( file.exists() ){
                    if(file.delete()){
                        log.debug("파일삭제 성공");
                    }else{
                    	log.debug("파일삭제 실패");
                    }
                }else{
                	log.debug("파일이 존재하지 않습니다.");
                }
        	}

        	LmrcService.docFileDelete(param);
    	}

    	map.put("result", result);

    	return "jsonView";
    }
    
    
    
    

    @RequestMapping(value="/lmrc/checkDocNo.json")
    public String checkDocNo(@RequestParam Map<String,String> param, ModelMap map) throws Exception {

    	Map<String, Object> result = LmrcService.checkDocNo(param);

    	map.put("result", result);

    	return "jsonView";

    }

    @RequestMapping(value="/lmrc/changeOperYn.do")
    public String changeOperYn(@RequestParam Map<String,String> param, Model model) throws Exception {

    	HashMap<Object, Object> map = new HashMap<Object, Object>();

    	map.put("codeId", "DO4000");

		model.addAttribute("operYn", CmmService.getCmmDitcList(map));

    	return "/dsdsm/lmrc/lmrcOperPop";

    }

    /**
     * 문서실행유무변경
     * @throws Exception
     */
    @RequestMapping(value="/lmrc/operYnEdit.json")
    public String operYnEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {

    	System.out.println("문서 실행유무변경 시작");

    	Map<String, Object> result = null;

    	int seq = LmrcService.getOperSeq(param);
    	param.put("seq", seq);

    	result = LmrcService.docOperReg(param);
    	map.put("result1", result);

    	result = LmrcService.docOperEdit(param);
    	map.put("result2", result);

    	return "jsonView";
    }

    @RequestMapping(value="/lmrc/getCharger.json")
    public String getCharger(@RequestParam HashMap<Object,Object> param, ModelMap map) throws Exception {


    	List reResult = null;
    	List result = LmrcService.getCharger(param);

    	log.debug(result);


    	map.put("options", result);

    	return "jsonView";

    }


    /**
     * 문서목록을 불러온다.
     * @throws Exception
     */
	@RequestMapping(value = "/lmrc/getPopupList.do")
	public String getPopupList(@RequestParam(value="jobCd",required=false) String[] jobCd,@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		param.put("jobCd", jobCd);
		log.debug("jobCd ::: "+jobCd);

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		String  checkInfo =  (request.getParameter("checkPangInfo") != null) ? request.getParameter("checkPangInfo") : "";
		String  popYn =  (request.getParameter("popYn") != null) ? request.getParameter("popYn") : "";

	    log.debug("");
		log.debug(">>>>> param "+param.toString());
		log.debug("");


		int listCount = LmrcService.getPopupListCount(param);


		int pageCount = (int) Math.ceil(listCount / pageSize);

		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);

		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);

		List list = LmrcService.getPopupList(param);

 	  	model.put("list",list);
 	  	model.put("page",pageinMap);

		return "jsonView";
	}


    

    /**
     * 법령 관리 목록화면 팝업창.
     * @throws Exception
     */
    @RequestMapping(value="/lmrc/docListPop.do")
    public String docListPop(HttpServletRequest request, Model model, HttpSession session) throws Exception {

    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");

    	String regYn = "N";
    	String manageYn = "N";

    	if(ROLE.contains("DOREGISTOR")){
    		regYn = "Y";
		}

    	if(ROLE.contains("DOMANAGER0")){
    		manageYn = "Y";
		}

    	model.addAttribute("regYn",regYn);
    	model.addAttribute("manageYn",manageYn);

    	HashMap<Object, Object> map = new HashMap<Object, Object>();

    	map.put("codeId", "DO1000");

		model.addAttribute("docGbn", CmmService.getCmmDitcList(map));

    	@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();
    	ObjectMapper mapper1 = new ObjectMapper();
   		String jobCdsJsonStr = mapper1.writeValueAsString(jobCds);

		model.addAttribute("JOB_LIST", jobCdsJsonStr);

		map.put("popYn","Y");

        Iterator iter = map.entrySet().iterator();

        while (iter.hasNext()) {

            Map.Entry entry = (Map.Entry) iter.next();

            String strKey  =  (String) entry.getKey(); //이게 contant 일때
            String strValue = (String) entry.getValue(); //이부분을 잘라낼수도 있습니다.

            log.debug("--" + strKey + "--------->[" +  strValue + "]");

        }


		model.addAttribute("srStat", LmrcService.getCharger(map));

    	return "/dsdsm/lmrc/lmrcListPop";
    }

 


    /**
     * 문서승인검토
     * @throws Exception
     */
    @RequestMapping(value="/lmrc/lmrcStep.json")
    public String docStep(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {

    	log.debug("문서 승인검토 시작");

    	Map<String, Object> result = null;

    	if("R".equals(param.get("type"))){
    		int seq = LmrcService.getDocSeq(param);
    		param.put("seq", seq);

    		result = LmrcService.docStepReg(param);
    	} else if("U".equals(param.get("type"))){
    		result = LmrcService.docStepEdit(param);
    	}

    	map.put("result", result);

    	return "jsonView";
    }

    /**
     * 문서승인요청
     * @throws Exception
     */
    @RequestMapping(value="/lmrc/lmrcNextStep.json")
    public String docNextStep(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {

    	System.out.println("문서 승인요청 시작");

    	if("100".equals(param.get("status"))){
    		param.put("next", "110");
    		param.put("approvalYn", "N");
    	} else {
    		if("001".equals(param.get("gbn"))){
    			param.put("next", "000");
    			param.put("approvalYn", "Y");
    		} else {
    			param.put("next", "100");
    			param.put("approvalYn", "N");
    		}

    		param.put("complete","0");

    		if("R".equals(param.get("type"))){
        		int seq = LmrcService.getDocSeq(param);
        		param.put("seq", seq);

        		LmrcService.docStepReg(param);
        	} else if("U".equals(param.get("type"))){
        		LmrcService.docStepEdit(param);
        	}
    	}

    	Map<String, Object> result = LmrcService.docNextStep(param);

    	map.put("result", result);

    	return "jsonView";
    }




}
