package egovframework.rte.dsdsm.login.service.impl;

import java.sql.Array;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.springframework.stereotype.Repository;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.util.StrUtil;
import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Repository("LoginDAO")
public class LoginDAO extends EgovAbstractDAO {
	
	public Map<String,Object> checkAccount(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("ONE", select("Login.checkAccount", map));
		return result;
	}
	
	public Map<String,Object> findId(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("ONE", select("Login.findId", map));
		return result;
	}
	
	public Map<String,Object> findUserId(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("ONE", select("Login.findUserId", map));
		return result;
	}
	
	public Map<String,Object> checkLoginId(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("ONE", select("Login.checkLoginId", map));
		return result;
	}
	
	public Map<String,Object> selectUserInfo(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		
		///////////////////////////////////////////////////////////////////////////////////////////////////////////
		// databaseType이 oracle일 경우  postgres 에서 사용된 dataType array에 맞추어 String[]을 추가한다.
		String databaseType = StrUtil.NVL(EgovProperties.getProperty("Globals.DatabaseType"),"postgres");
		EgovMap dbData = (EgovMap)select("Login.selectUserInfo", map);
		
		if(databaseType.equals("oracle")){
			String rolesStr = (String)dbData.get("rolesStr");
			String[] roles =rolesStr.split(",");
			dbData.put("roles", roles);
			//result.put("roles", roles);
			dbData.remove("rolesStr");
			
			String jobCdStr = (String)dbData.get("jobCdStr");
			String[] jobCds=jobCdStr.split(",");
			
			dbData.put("jobCd", jobCds);
			dbData.remove("jobCdStr");
		}
		///////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		result.put("ONE", dbData);
		return result;
	}
	
	public Map<String,Object> resetPassword(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("Login.updateTemporaryPassword", map));
		return result;
	}
	
	public Map<String,Object> signin(Map<String,Object> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("Login.signin", map));
		return result;
	}
	

}
