package egovframework.rte.dsdsm.login.service.impl;

import java.security.MessageDigest;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import javax.annotation.Resource;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Service;

import egovframework.rte.dsdsm.login.service.LoginService;

@Service("LoginService")
public class LoginServiceImpl implements LoginService {
	
	@Resource(name="LoginDAO")
	private LoginDAO loginDAO;
	
	private Logger log = LogManager.getLogger();

	@Override
	public Map<String, Object> checkAccount(Map<String, String> map) throws Exception{
		
		String password = map.get("password");
		
		map.put("password", cypherString(password));
		
		Map <String,Object> result = loginDAO.checkAccount(map);
		
		@SuppressWarnings("unchecked")
		Map<String, Object> one = (Map<String, Object>)result.get("ONE");
		
		if(one!=null && map.get("password").equals(one.get("loginPassword"))){
			
			if("Y".equals(one.get("approveYn"))){
				result.put("SUCCESS", true);
				result.put("MESSAGE", "로그인 성공");
				
				//유저정보가져오기
				Map<String,String> param = new HashMap<String,String>();
				param.put("userId", (String)one.get("userId"));
				
				Map<String,Object> userInfo = loginDAO.selectUserInfo(param);
				
				
				
				
				result.put("userInfo", userInfo.get("ONE"));
			}else{
				result.put("SUCCESS", false);
				result.put("MESSAGE", "승인되지 않은 아이디 입니다.");
			}
			
			
		}else{
			result.put("SUCCESS", false);
			if(one==null){
				result.put("MESSAGE", "id가 존재하지 않습니다. ");
			}else if(!map.get("password").equals(one.get("loginPassword"))){
				result.put("MESSAGE", "password가 틀렸습니다.");
			}
		}
		
		return result;
	}
	
	@Override
	public Map<String, Object> findId(Map<String, String> map) throws Exception {
		
		Map <String,Object> result = loginDAO.findId(map);
		
		@SuppressWarnings("unchecked")
		Map<String, Object> one = (Map<String, Object>)result.get("ONE");
		
		if(one!=null){
			if("Y".equals(one.get("approveYn"))){
				result.put("SUCCESS", true);
				result.put("MESSAGE", "아이디찾기 성공");
				result.put("FINDED_ID", one.get("loginId"));
			}else{
				result.put("SUCCESS", false);
				result.put("MESSAGE", "사용자("+one.get("loginId")+")는 승인대기 중 입니다.");
			}
		}else{
			result.put("SUCCESS", false);
			if(one==null){
				result.put("MESSAGE", "사용자를 찾을 수 없습니다.");
			}
		}
		
		return result;
	}
	
	@Override
	public Map<String, Object> checkLoginId(Map<String, String> map) throws Exception {
		
		Map <String,Object> result = loginDAO.checkLoginId(map);
		
		@SuppressWarnings("unchecked")
		Map<String, Object> one = (Map<String, Object>)result.get("ONE");
		
		if(one==null){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "아이디를 사용할 수 있습니다.");
		}else{
			result.put("SUCCESS", false);
			result.put("MESSAGE", "아이디 사용자가 이미 있습니다.");
		}
		
		return result;
	}
	
	@Override
	public Map<String, Object> resetPassword(Map<String, String> map) throws Exception {
		
		Random rd = new Random();
		
		int digit1 = rd.nextInt(10);
		int digit2 = rd.nextInt(10);
		int digit3 = rd.nextInt(10);
		int digit4 = rd.nextInt(10);
		int digit5 = rd.nextInt(10);
		
		String tempPass =  digit1+""+digit2+""+digit3+""+digit4+""+digit5;
		
		log.debug("temppass="+tempPass);
		
		Map <String,Object> result = loginDAO.findUserId(map);
		
		@SuppressWarnings("unchecked")
		Map <String,Object> one = (Map<String,Object>)result.get("ONE");
		
		if(one==null){
			result.put("SUCCESS", false);
			result.put("MESSAGE", "사용자를 찾을 수 없습니다.");
			
			return result;
		}else{
			if("0000000000001".equals(one.get("userId"))){
				result.put("SUCCESS", false);
				result.put("MESSAGE", "시스템관리자의 패스워드는 재설정할 수 없습니다.");
				
				return result;
			}
		}
		
		map.put("loginPassword", cypherString(tempPass));
		map.put("resetPassword", tempPass);
		map.put("userId", (String)one.get("userId"));
		
		result = loginDAO.resetPassword(map);
		
		Integer cnt = (Integer)result.get("CNT");
		
		if(cnt!=null){
			if(cnt.intValue()>0){
				result.put("SUCCESS", true);
				result.put("MESSAGE", "비밀번호 재설정 성공");
				result.put("TEMPPASS", tempPass);
			}else{
				result.put("SUCCESS", false);
				result.put("MESSAGE", "비밀번호 재설정 실패");
			}
		}
		
		return result;
	}
	
	@Override
	public Map<String, Object> signin(Map<String, Object> map) throws Exception {
		
		String plainPassword = (String)map.get("password");
		
		map.put("password",cypherString(plainPassword));
		
		Map <String,Object> result = loginDAO.signin(map);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt!=null){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "회원가입되었습니다.");
		}else{
			result.put("SUCCESS", false);
			result.put("MESSAGE", "회원가입에 실패하였습니다. 잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
	
	public String cypherString(String plain) throws Exception{
		String cypher = "";
		
		MessageDigest md = null;
		md = MessageDigest.getInstance("SHA-256");
		md.update(plain.getBytes());
		
		byte byteData[] = md.digest();
		StringBuffer sb = new StringBuffer();
		for(int i=0;i<byteData.length;i++){
			sb.append(Integer.toString((byteData[i]&0xff)+0x100,16).substring(1)); 
			//byte는 진수표현 함수없고 Integer의 유효숫자가 달라서 짤라줌
		}
		
		cypher = sb.toString();
		
		return cypher;
	}
	
/*	public static void main(String[] args) throws Exception{
		LoginServiceImpl lg = new LoginServiceImpl();
		String a = "1234567890";
		String plain = "";
		for(int i=0;;i++){
			plain = plain + a.indexOf(i%a.length());
			String cypher = lg.cypherString(plain);
			System.out.println("plain="+plain);
			System.out.println("cypher="+cypher);
			if(cypher.length()>100) break;
		}
	}*/

}
