package egovframework.rte.dsdsm.login.web;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpSession;

import org.apache.commons.mail.DefaultAuthenticator;
import org.apache.commons.mail.EmailException;
import org.apache.commons.mail.SimpleEmail;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.util.CryptoUtil;
import egovframework.rte.dsdsm.cmm.util.StrUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;
import egovframework.rte.dsdsm.login.service.LoginService;

@Controller
public class LoginController {
	
	org.apache.logging.log4j.Logger log = org.apache.logging.log4j.LogManager.getLogger();
	
	@Resource(name="LoginService")
	private LoginService loginService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
	
	@Resource(name ="CodeService")
	private CodeService codeService;
	
	@Resource(name="cryptoUtil")
	CryptoUtil cryptoUtil;
	
    @RequestMapping(value="/login/login.do")
    public String login(ModelMap map) throws Exception { 
    	map.put("ENV", commonDataService.getEnvForModify());
    	return "/dsdsm/login/login";
    }
    
    @RequestMapping(value="/help.do")
    public void help() { }
    
    @RequestMapping(value="/login/findId.do")
    public String findId() {
    	return "/dsdsm/login/findId";
    }
    
    @RequestMapping(value="/login/findId.json")
    public String findedIdResult(@RequestParam Map<String,String> param, ModelMap map) throws Exception {
    	
    	
    	log.debug("name="+param.get("name"));
        Map<String, Object> result = loginService.findId(param);  
        
        map.put("result", result);
        
        return "jsonView";

    }
    
    @RequestMapping(value="/login/checkLoginId.json")
    public String checkLoginId(@RequestParam Map<String,String> param, ModelMap map) throws Exception {
    	
    	
    	Map<String, Object> result = loginService.checkLoginId(param);  
    	
    	map.put("result", result);
    	
    	return "jsonView";
    	
    }
    
    @RequestMapping(value="/login/resetPassword.do")
    public String resetPassword() {
    	return "/dsdsm/login/resetPassword";
    }
    
    @RequestMapping(value="/login/resetPassword.json")
    public String resetPasswordResult(@RequestParam Map<String,String> param, ModelMap map) throws Exception {
    	
    	
    	Map<String, Object> result = loginService.resetPassword(param);  
    	
    	map.put("result", result);
    	if((Boolean)result.get("SUCCESS")){
    		
    		Map<String,Object> env = commonDataService.getEnv(Arrays.asList("EMAIL"));
    		
    		SimpleEmail email = new SimpleEmail();
    		// setHostName에 실제 메일서버정보
    		
    		email.setCharset("euc-kr"); // 한글 인코딩
    		email.setHostName((String)env.get("EMAIL_HOST")); // SMTP서버 설정 
    		email.setSmtpPort(new Integer((String)env.get("EMAIL_PORT")));
    		//email.setAuthentication((String)env.get("EMAIL_ID"), (String)env.get("EMAIL_PASSWORD"));
    		email.setAuthenticator(new DefaultAuthenticator((String)env.get("EMAIL_ID"),cryptoUtil.decrypt((String)env.get("EMAIL_PASSWORD"))));
    		//email.setSSLCheckServerIdentity(true);
    		try {
    			email.addTo(param.get("email"), param.get("name")); // 수신자 추가
    		} catch (EmailException e) {
    			e.printStackTrace();
    		}
    		try {
    			email.setFrom((String)env.get("EMAIL_SENDER"), (String)env.get("EMAIL_SENDER_NAME")); // 보내는 사람
    		} catch (EmailException e) {
    			e.printStackTrace();
    		}
    		email.setSubject("변경된 비밀번호 통보입니다."); // 메일 제목
    		email.setContent(result.get("TEMPPASS"), "text/plain; charset=euc-kr");
    		try {
    			email.send();
    		} catch (EmailException e) {
    			e.printStackTrace();
    		}
    		
    		result.remove("TEMPPASS");
    		result.put("EMAIL_SENDED","true");
    		
    	}
    	
    	return "jsonView";
    	
    }
    
    @RequestMapping(value="/login/signin.do")
    public String singin(ModelMap map)  throws Exception {
    	
    	Map<String, Object> param = null;
    	Map<String,Object> codeMap = null;
    	
    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1000");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
		List<Map<String,Object>> rankList = (List<Map<String,Object>>)codeMap.get("LIST");
    	
/*    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1100");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> jobList = (List<Map<String,Object>>)codeMap.get("LIST"); */
    	
    	@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();
 
    	
    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1200");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> dutyList = (List<Map<String,Object>>)codeMap.get("LIST");
    	
    	@SuppressWarnings("rawtypes")
		List deptCodes = commonDataService.getDeptCode();
    	
    	
    	ObjectMapper mapper = new ObjectMapper();
   		String deptCodesJsonStr = mapper.writeValueAsString(deptCodes);
   		String jobCdsJsonStr = mapper.writeValueAsString(jobCds);
    	
    	map.put("RANK_LIST", rankList);
    	map.put("JOB_LIST", jobCdsJsonStr);
    	map.put("DUTY_LIST", dutyList);
    	map.put("DEPT_CODE", deptCodesJsonStr);
    	
    	return "/dsdsm/login/signin";
    }
    
    @RequestMapping(value="/login/signin.json")
    public String singinResult(@RequestParam("jobCd") String[] jobCd, @RequestParam Map<String,Object> param, ModelMap map) throws Exception{
    	
    	param.put("jobCd", jobCd);
    	
    	log.debug("password="+param.get("password"));
    	
    	Map<String, Object> result = loginService.signin(param);
    	
    	map.put("result",result);
    	
    	return "jsonView";
    }
    
    /**
     * 로그인 한다.
     */
    @RequestMapping(value="/login/checkAccount.do")
    public String checkAccount(HttpSession session, @RequestParam Map<String,String> param, ModelMap map) throws Exception{
    	
    	String result = "/dsdsm/login/login";
    	String password = param.get("password");
    	String id = param.get("id").trim();
    	log.debug("password="+password+"("+(password!=null)+"),id="+id+"("+(id!=null)+")");
    	
    	if(password!=null && !"".equals(password) && id!=null && !"".equals(id)){
    		
    		Map<String,Object> sResult = loginService.checkAccount(param);
    		
    		if((Boolean)sResult.get("SUCCESS")){
    			
				@SuppressWarnings("rawtypes")
				
				Map userInfo = (Map)sResult.get("userInfo");
				
				List<String> roles = new ArrayList<String>();
				if(userInfo.get("roles")!=null){ 
					for(String role : (String[])userInfo.get("roles")){
						//log.debug(" >>>>>>>>>>>>>>>>> role : "+role);
						roles.add(role);
					}
				}
				userInfo.remove("roles");
				session.setAttribute("userInfo", userInfo);
				
				session.setAttribute("databaseType", StrUtil.nvl(EgovProperties.getProperty("Globals.DatabaseType"),""));
				
				
				//log.debug(" >>>>>>>>>>>>>>>>> userInfo : "+userInfo);
    			
    			//String[] list = new String[]{"CHARGER000" ,"RECEIPTOR0" ,"DEVELOPER0" ,"MANAGER000" ,"DBMANAGER0" ,"QAMANAGER0" ,"DTMANAGER0" ,"MEMBER0000" ,"NONMEMBER0" ,"REQUESTOR0" ,"SYSMANAGER"};
    		   	
    	    	//CHARGER000	담당자   
    	    	//RECEIPTOR0	접수자   
    	    	//DEVELOPER0	개발자   
    	    	//MANAGER000	승인권자  
    	    	//DBMANAGER0	DB조회승인
    	    	//QAMANAGER0	품질관리자 
    	    	//DTMANAGER0	배포담당자 
    	    	//MEMBER0000	회원    
    	    	//NONMEMBER0	비회원   
    	    	//REQUESTOR0	요청자   
    	    	//SYSMANAGER	시스템관리자
    	    	session.setAttribute("ROLES", roles);
    			
    			result = "redirect:/main/main.do";
    		}else{
    			map.put("ID", id);
    			map.put("MESSAGE", sResult.get("MESSAGE"));
    		}
    		
    	}else{
    		map.put("MESSAGE", "아이디와 패스워드를 모두 입력해야합니다.");
    	}
    	
    	map.put("ENV", commonDataService.getEnvForModify());
    	
    	return result;
    }
    
    @RequestMapping(value="/login/logout.do")
    public String logout(HttpSession session) {
    	session.invalidate();
    	return "redirect:/login/login.do";
    }
    
}
