package egovframework.rte.dsdsm.main.service.impl;

import java.util.List;

import org.springframework.stereotype.Repository;

import egovframework.rte.dsdsm.main.service.vo.infomationVO;
import egovframework.rte.dsdsm.main.service.vo.mainVO;
import egovframework.rte.psl.dataaccess.EgovAbstractDAO;

@Repository("mainServiceDAO")
public class mainServiceDAO extends EgovAbstractDAO {
	
	
	/**
	 * 
	 * @return 회사정보(기수)
	 * @exception Exception 
	*/
	public String selectGbn1(mainVO vo) throws Exception {
		
		return (String)getSqlMapClientTemplate().queryForObject("mainServiceDAO.selectGbn1", vo);
		
	}
	
	/**
	 * 
	 * @return 회사정보(시작일)
	 * @exception Exception 
	*/
	public String selectSdate(mainVO vo) throws Exception {
		
		return (String)getSqlMapClientTemplate().queryForObject("mainServiceDAO.selectSdate", vo);
		
	}
	
	/**
	 * 
	 * @return 회사정보(종료일)
	 * @exception Exception 
	*/
	public String selectEdate(mainVO vo) throws Exception {
		
		return (String)getSqlMapClientTemplate().queryForObject("mainServiceDAO.selectEdate", vo);
		
	}
	
	/**
	 * 주소 리스트
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 주소리스트
	 * @exception Exception
	 */
   @SuppressWarnings("unchecked")
public List<mainVO> selectAddr(mainVO vo) throws Exception {
   	return (List<mainVO>) list("mainServiceDAO.selectAddr", vo);
   }
   
   /**
	 * 
	 * @return 회사정보
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<mainVO> selectSetting(mainVO vo) throws Exception {
		
		return (List<mainVO>) list("mainServiceDAO.selectSetting", vo);
		
	}
	
	/**
	 * 계정 검색
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 주소리스트
	 * @exception Exception
	 */
   @SuppressWarnings("unchecked")		
   public List<mainVO> getAccount(mainVO vo) throws Exception {
   	return (List<mainVO>) list("mainServiceDAO.getAccount", vo);
   }
   
   /**
	 * 계정 검색
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 
	 * @exception Exception
	 */
   @SuppressWarnings("unchecked")		
   public List<mainVO> getAccountNm(mainVO vo) throws Exception {
  	 return (List<mainVO>) list("mainServiceDAO.getAccountNm", vo);
   }
   
	/**
	 * 기업코드 가져오기
	 * @return 전체 시도 목록
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<infomationVO> companyCode(infomationVO vo) throws Exception {
		
		return (List<infomationVO>) list("mainServiceDAO.companyCode", vo);
	}
	
	/**
	 * 로그인 정보 등록
	 * @return 리스트
	 * @exception Exception 
	*/
	public String loginSave(infomationVO vo) throws Exception {
		
		return (String)insert("mainServiceDAO.loginSave", vo);		
	}
	
	/**
	 * 회원 정보 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<infomationVO> getMember(infomationVO vo) throws Exception {
		return (List<infomationVO>) list("mainServiceDAO.getMember", vo);		
	}
	
	/**
	 * 회원 정보 비밀번호 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<infomationVO> getMemberPw(infomationVO vo) throws Exception {
		
		return (List<infomationVO>) list("mainServiceDAO.getMemberPw", vo);
	}
	
	/**
	 * 회원 정보 갯수 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public int getMemberCnt(infomationVO vo) throws Exception {
		return (Integer)getSqlMapClientTemplate().queryForObject("mainServiceDAO.getMemberCnt", vo);	
	}
	
	/**
	 * 부서명 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<infomationVO> getTeam(infomationVO vo) throws Exception {
		return (List<infomationVO>) list("mainServiceDAO.getTeam", vo);	
	}
}

