package egovframework.rte.dsdsm.main.service.impl;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import egovframework.rte.dsdsm.main.service.mainService;
import egovframework.rte.dsdsm.main.service.vo.infomationVO;
import egovframework.rte.dsdsm.main.service.vo.mainVO;
import egovframework.rte.fdl.cmmn.AbstractServiceImpl;

@Service("mainService")
public class mainServiceImpl extends AbstractServiceImpl implements mainService{
	
    @Resource(name="mainServiceDAO")
    private mainServiceDAO mainServiceDAO;	
    
    
    /**
	 * 회사정보 가져오기(기수)
	 * @return 존재유무
	 * @exception Exception 
	*/
	public String selectGbn1(mainVO vo) throws Exception {
		
		return mainServiceDAO.selectGbn1(vo);
	}
	
    /**
	 * 회사정보 가져오기(시작일)
	 * @return 존재유무
	 * @exception Exception 
	*/
	public String selectSdate(mainVO vo) throws Exception {
		
		return mainServiceDAO.selectSdate(vo);
	}
	
	/**
	 * 매입매출 전표 첫번째 번호
	 * @return 존재유무
	 * @exception Exception 
	*/
	public String selectEdate(mainVO vo) throws Exception {
		
		return mainServiceDAO.selectEdate(vo);
	}
   
	
	/**
	 * 주소 리스트
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 전표목록
	 * @exception Exception
	 */
    public List<mainVO> selectAddr(mainVO vo) throws Exception {
        return mainServiceDAO.selectAddr(vo);
    }
    
    /**
	 * 재무회계 환경설정
	 * @return 재무회계 환경설정
	 * @exception Exception 
	*/
    public List<mainVO> selectSetting(mainVO vo) throws Exception {
		
		return mainServiceDAO.selectSetting(vo);
	}
    
    /**
	 * 계정 검색
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 
	 * @exception Exception
	 */
    public List<mainVO> getAccount(mainVO vo) throws Exception {
        return mainServiceDAO.getAccount(vo);
    }
    
    /**
	 * 계정 검색
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 
	 * @exception Exception
	 */
    public List<mainVO> getAccountNm(mainVO vo) throws Exception {
        return mainServiceDAO.getAccountNm(vo);
    }
    
	/**
	 * 기업코드 가져오기
	 * @return 전체 시도 목록
	 * @exception Exception 
	*/
	public List<infomationVO> companyCode(infomationVO vo) throws Exception {
		return mainServiceDAO.companyCode(vo);	
	}
	
	/**
	 * 로그인 정보 등록
	 * @return 리스트
	 * @exception Exception 
	*/
	public String loginSave(infomationVO vo) throws Exception {
		return mainServiceDAO.loginSave(vo);		
	}
	
	/**
	 * 회원 정보 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public List<infomationVO> getMember(infomationVO vo) throws Exception {
		return mainServiceDAO.getMember(vo);		
	}
	
	/**
	 * 회원 정보 비밀번호 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public List<infomationVO> getMemberPw(infomationVO vo) throws Exception {
		return mainServiceDAO.getMemberPw(vo);
	}
	
	/**
	 * 회원 정보 갯수 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public int getMemberCnt(infomationVO vo) throws Exception {
		return mainServiceDAO.getMemberCnt(vo);
	}
	
	/**
	 * 부서명 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public List<infomationVO> getTeam(infomationVO vo) throws Exception {
		return mainServiceDAO.getTeam(vo);		
	}
}
