package egovframework.rte.dsdsm.main.service;


import java.util.List;

import egovframework.rte.dsdsm.main.service.vo.infomationVO;
import egovframework.rte.dsdsm.main.service.vo.mainVO;

public interface mainService {
	
	
	/**
	 * 회사정보 가져오기(기수)
	 * @return 존재유무
	 * @exception Exception 
	*/
	public String selectGbn1(mainVO vo) throws Exception;
	
	/**
	 * 회사정보 가져오기(시작일)
	 * @return 존재유무
	 * @exception Exception 
	*/
	public String selectSdate(mainVO vo) throws Exception;
	
	/**
	 * 회사정보 가져오기(종료일)
	 * @return 존재유무
	 * @exception Exception 
	*/
	public String selectEdate(mainVO vo) throws Exception;
	
	/**
	 * 주소 검색
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 전표목록
	 * @exception Exception
	 */
    public List<mainVO> selectAddr(mainVO vo) throws Exception;
    
    /**
	 * 재무회계 환경설정
	 * @return 리스트
	 * @exception Exception 
	*/
	public List<mainVO> selectSetting(mainVO vo) throws Exception;
	
	/**
	 * 계정 검색
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 
	 * @exception Exception
	 */
    public List<mainVO> getAccount(mainVO vo) throws Exception;
    
    /**
	 * 계정 검색
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 
	 * @exception Exception
	 */
    public List<mainVO> getAccountNm(mainVO vo) throws Exception;
    
	/**
	 * 기업코드 가져오기
	 * @return 전체 시도 목록
	 * @exception Exception 
	*/
	public List<infomationVO> companyCode(infomationVO vo) throws Exception;
	
	/**
	 * 로그인 정보 등록
	 * @return 리스트
	 * @exception Exception 
	*/
	public String loginSave(infomationVO vo) throws Exception;
	
	/**
	 * 회원 정보 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public List<infomationVO> getMember(infomationVO vo) throws Exception;
	
	/**
	 * 회원 정보 비밀번호 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public List<infomationVO> getMemberPw(infomationVO vo) throws Exception;
	
	/**
	 * 회원 정보 갯수 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public int getMemberCnt(infomationVO vo) throws Exception;
	
	/**
	 * 부서명 가져오기
	 * @return 리스트
	 * @exception Exception 
	*/
	public List<infomationVO> getTeam(infomationVO vo) throws Exception;
}
