package egovframework.rte.dsdsm.main.web;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import egovframework.rte.dsdsm.main.service.MainViewService;

@Controller
public class MainViewController {
	
	org.apache.logging.log4j.Logger log = org.apache.logging.log4j.LogManager.getLogger();
	
	@Resource(name="MainViewService")
	private MainViewService mainViewService;
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/main.do")
    public String main(HttpSession session,ModelMap map,HttpServletRequest request) throws Exception{
    	Map<String,Object> param = new HashMap<String,Object>();
    	
    	param.put("ROLES",session.getAttribute("ROLES"));
    	
    	Map userInfo = (Map)session.getAttribute("userInfo"); 
    	
    	param.put("roleId",userInfo.get("role"));
    	param.put("busniseId", userInfo.get("businessId"));
    	
    	List<String> widgetPermision = new ArrayList<String>(); 
    	
    	List sdgbnList = mainViewService.selectSdgbnList(param);
    	
    	String permission ="";
    	
    	for(Object one : sdgbnList){
    		widgetPermision.add((String)((Map)one).get("sdgbn"));
    		permission+="|"+(String)((Map)one).get("sdgbn");
    	}
    	
    	//widgetPermision.add("SC");
    	//widgetPermision.add("NT");
    	
    	map.put("WIDGET_PERMISSION", widgetPermision);
    	map.put("permission", permission);
    	
    	return "main";
    }
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getSrSummary.json")
    public String getSrSummary(HttpSession session,ModelMap map) throws Exception{
    	Map userInfo = (Map)session.getAttribute("userInfo");
    	Map<String,Object> param = new HashMap<String,Object>();
    	
    	param.put("ROLES",session.getAttribute("ROLES"));
    	param.put("jobCd", userInfo.get("jobCd"));
    	param.put("busniseId", userInfo.get("businessId"));
    	
    	List srGroupList = mainViewService.selectSrGroup(param);
    	
    	map.put("tree", srGroupList);
    	map.put("result", "ok");
    	map.put("msg", "");
    	
    	return "/dsdsm/main/jsonData";
    	//return "jsonView";
    }
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getSrSummaryList.json")
	public String getSrSummaryList(HttpSession session,ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
		Map userInfo = (Map)session.getAttribute("userInfo");
		param.put("jobCd", userInfo.get("jobCd"));
		param.put("busniseId", userInfo.get("businessId"));
		
		List srGroupList = mainViewService.selectSrGroupList(param);
		
		map.put("tree", srGroupList);
		map.put("result", "ok");
		map.put("msg", "");
		
		//return "/dsdsm/main/jsonData";
		return "jsonView";
	}
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getDisSummary.json")
    public String getDisSummary(HttpSession session,ModelMap map) throws Exception{
    	Map userInfo = (Map)session.getAttribute("userInfo");
    	Map<String,Object> param = new HashMap<String,Object>();
    	
    	param.put("ROLES",session.getAttribute("ROLES"));
    	param.put("jobCd", userInfo.get("jobCd"));
    	param.put("busniseId", userInfo.get("businessId"));
    	
    	
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		while(info.hasNext()){
			String key =(String)info.next();
			if(key.equals("JsonList")){
			}
			System.out.println( "["+key+"] : "+ param.get(key) );
		}
		System.out.println("########################## Param End ###############################");
		
    	List disGroupList = mainViewService.selectDisGroup(param);
    	
    	map.put("tree", disGroupList);
    	map.put("result", "ok");
    	map.put("msg", "");
    	
    	return "/dsdsm/main/jsonData";
    	//return "jsonView";
    }
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getDisSummaryList.json")
	public String getDisSummaryList(HttpSession session,ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
		Map userInfo = (Map)session.getAttribute("userInfo");
		param.put("jobCd", userInfo.get("jobCd"));
		param.put("busniseId", userInfo.get("businessId"));
		
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		while(info.hasNext()){
			String key =(String)info.next();
			if(key.equals("JsonList")){
			}
			System.out.println( "["+key+"] : "+ param.get(key) );
		}
		System.out.println("########################## Param End ###############################");
		
		List disGroupList = mainViewService.selectDisGroupList(param);
		
		map.put("tree", disGroupList);
		map.put("result", "ok");
		map.put("msg", "");
		
		//return "/dsdsm/main/jsonData";
		return "jsonView";
	}
	

	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getNoSummary.json")
    public String getNoSummary(HttpSession session,ModelMap map) throws Exception{
    	Map userInfo = (Map)session.getAttribute("userInfo");
    	Map<String,Object> param = new HashMap<String,Object>();
    	
    	param.put("ROLES",session.getAttribute("ROLES"));
    	param.put("jobCd", userInfo.get("jobCd"));
    	param.put("busniseId", userInfo.get("businessId"));
    	
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		while(info.hasNext()){
			String key =(String)info.next();
			if(key.equals("JsonList")){
			}
			System.out.println( "["+key+"] : "+ param.get(key) );
		}
		System.out.println("########################## Param End ###############################");
		
    	List noGroupList = mainViewService.selectNoGroup(param);
    	
    	for(int i=0; i<noGroupList.size();i++) {
    		System.out.println(noGroupList.get(i));
    	}
    	
    	map.put("tree", noGroupList);
    	map.put("result", "ok");
    	map.put("msg", "");
    	
    	return "/dsdsm/main/jsonData";
    	//return "jsonView";
    }
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getNoSummaryPublic.json")
    public String getNoSummaryPublic(HttpSession session,ModelMap map) throws Exception{
    	Map<String,Object> param = new HashMap<String,Object>();
    	
    	//param.put("ROLES",session.getAttribute("ROLES"));
    	//param.put("jobCd", userInfo.get("jobCd"));
    	
    	param.put("openYn", "Y");
    	
    	
    	
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		while(info.hasNext()){
			String key =(String)info.next();
			if(key.equals("JsonList")){
			}
			System.out.println( "["+key+"] : "+ param.get(key) );
		}
		System.out.println("########################## Param End ###############################");
		
    	List noGroupList = mainViewService.selectNoGroup(param);
    	
    	map.put("tree", noGroupList);
    	map.put("result", "ok");
    	map.put("msg", "");
    	
    	return "/dsdsm/main/jsonData";
    	//return "jsonView";
    }
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getNoSummaryList.json")
	public String getNoSummaryList(HttpSession session,ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
		Map userInfo = (Map)session.getAttribute("userInfo");
		param.put("jobCd", userInfo.get("jobCd"));
		param.put("busniseId", userInfo.get("businessId"));
		
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		while(info.hasNext()){
			String key =(String)info.next();
			if(key.equals("JsonList")){
			}
			System.out.println( "["+key+"] : "+ param.get(key) );
		}
		System.out.println("########################## Param End ###############################");
		
		List noGroupList = mainViewService.selectNoGroupList(param);
		
		map.put("tree", noGroupList);
		map.put("result", "ok");
		map.put("msg", "");
		
		//return "/dsdsm/main/jsonData";
		return "jsonView";
	}
	

	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getScSummary.json")
    public String getScSummary(HttpSession session,ModelMap map) throws Exception{
    	Map userInfo = (Map)session.getAttribute("userInfo");
    	Map<String,Object> param = new HashMap<String,Object>();
    	
    	param.put("ROLES",session.getAttribute("ROLES"));
    	param.put("deptId", userInfo.get("deptId"));
    	param.put("userId", userInfo.get("userId"));
    	param.put("loginId", userInfo.get("loginId"));
    	param.put("busniseId", userInfo.get("businessId"));
    	
    	
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		while(info.hasNext()){
			String key =(String)info.next();
			if(key.equals("JsonList")){
			}
			System.out.println( "["+key+"] : "+ param.get(key) );
		}
		System.out.println("########################## Param End ###############################");
		
    	List scGroupList = mainViewService.selectScGroup(param);
    	
    	map.put("tree", scGroupList);
    	map.put("result", "ok");
    	map.put("msg", "");
    	
    	return "/dsdsm/main/jsonData";
    	//return "jsonView";
    }
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getScSummaryList.json")
	public String getScSummaryList(HttpSession session,ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
		Map userInfo = (Map)session.getAttribute("userInfo");

		param.put("ROLES",session.getAttribute("ROLES"));
    	param.put("deptId", userInfo.get("deptId"));
    	param.put("userId", userInfo.get("userId"));
    	param.put("loginId", userInfo.get("loginId"));
    	param.put("busniseId", userInfo.get("businessId"));
    	
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		while(info.hasNext()){
			String key =(String)info.next();
			if(key.equals("JsonList")){
			}
			System.out.println( "["+key+"] : "+ param.get(key) );
		}
		System.out.println("########################## Param End ###############################");
		
		List scGroupList = mainViewService.selectScGroupList(param);
		
		map.put("tree", scGroupList);
		map.put("result", "ok");
		map.put("msg", "");
		
		//return "/dsdsm/main/jsonData";
		return "jsonView";
	}
	
	
	@SuppressWarnings("rawtypes")
	@RequestMapping(value="/main/getCmmJsonList.json")
	public String selectCmmJsonList(HttpSession session,ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
		
		Map userInfo = (Map)session.getAttribute("userInfo");

		param.put("ROLES",		session.getAttribute("ROLES"));
    	param.put("deptId", 	userInfo.get("deptId"));
    	param.put("userId", 	userInfo.get("userId"));
    	param.put("loginId", 	userInfo.get("loginId"));
    	param.put("businessId", userInfo.get("businessId"));
    	param.put("jobCd", 		userInfo.get("jobCd"));
		 
    	String pageStart = param.get("pageStart")==null?"1":(String)param.get("pageStart");
		String pageEnd   = param.get("pageEnd")==null?"10":(String)param.get("pageEnd");;
		
		param.put("start", Integer.parseInt(pageStart));
		param.put("end",    Integer.parseInt(pageEnd));
    	
		
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		while(info.hasNext()){
			String key =(String)info.next();
			if(key.equals("JsonList")){
			}
			System.out.println( "["+key+"] : "+ param.get(key) );
		}
		System.out.println("########################## Param End ###############################");
		
    	List cmmJsonList = mainViewService.selectCmmJsonList(param);
		
		
		map.put("tree", cmmJsonList);
		map.put("result", "ok");
		map.put("msg", "");
		
		return "jsonView";
	}
    @RequestMapping(value="/main/mainConents.do")
    public String mainContents(HttpSession session, ModelMap map,@RequestParam Map<String,Object> param) throws Exception{
    	return "mainContents";
    }
    
}
