package egovframework.rte.dsdsm.product.web;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.util.FileCopyUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.product.service.ProductService;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Controller
public class ProductController {
	
	Logger log = Logger.getLogger(this.getClass());
	
	@Resource(name="DisFileMng")
	private  DisFileMng disFileMng;
   
	@Resource(name="ProductService")
	private ProductService proService;
	
    @RequestMapping(value="/product/productList.do")
    public String productList(HttpServletRequest request,  Model model, HttpSession session) throws Exception {
    	return "/dsdsm/product/productList";
    }
    @RequestMapping(value="/product/productReg.do")
    public String productReg(HttpServletRequest request, @RequestParam Map<String, Object> reqMap , Model model, HttpSession session) throws Exception {
    	model.addAttribute("productId", (String)reqMap.get("productId"));
    	return "/dsdsm/product/productReg";
    }
    @RequestMapping(value="/product/productRegist.json")
    public String productRegist(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> reqMap, HttpSession session) throws Exception {
    	
    		@SuppressWarnings("rawtypes")
    		Map userInfos = (Map)session.getAttribute("userInfo");
    		String loginId =  (String)userInfos.get("loginId"); 
    		
			String keyStr ="/"+(String)reqMap.get("productId")+"/DOC";
			
			// 산출물별로 저장 디렉토리 생성
			File saveDir = new File(EgovProperties.getProperty("Globals.fileStorePath")+"/"+(String)reqMap.get("productId"));
			if(!saveDir.exists()){
				saveDir.mkdir();
			}
			
			HashMap<Object, Object> map = (HashMap)reqMap;
			map.put("loginId", loginId);
			
			String _atchFileId = "";
			_atchFileId = disFileMng.fileUpload(keyStr,request);
			
			map.put("addFileId", _atchFileId);
			String productHisId = proService.insertProductHis(map);
		    
		    modelmap.put("productHisId",  productHisId);
		    //modelmap.put("tableNm", (String)reqMap.get("tableNm"));
		
			
		return "jsonView";
    }
    
    
    @RequestMapping(value="/product/deleteLastHis.do")
    public String deleteLastHis(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
    	
    		@SuppressWarnings("rawtypes")
    		Map userInfos = (Map)session.getAttribute("userInfo");
    		ArrayList roloes = (ArrayList)session.getAttribute("ROLES");
    		
    		boolean roleExist = false;
    		
    		for(Object role: roloes){
    			if(   ((String)role).equals("SYSMANAGER")  ||  ((String)role).equals("QAMANAGER0")  ){
    				roleExist = true;
    				break;
    			}
    		}
    		
    		String loginId   = (String)userInfos.get("loginId"); 
    		String lastRegId = (String)param.get("lastRegId");

    		if( loginId.equals(lastRegId)   &&   roleExist  ){
    			int cnt = proService.deleteLastHis((HashMap)param);
    			
    			System.out.println("cntcntcntcnt : "+cnt);
    			
    			modelmap.put("result","ok");
    			modelmap.put("cnt",cnt);
    		}else{
    			modelmap.put("result", "warning");
    			modelmap.put("warningMsg","삭제는 등록자, 시스템관리자, 품질관리자만 가능합니다.");
    		}
			//proService.deleteLastHis((HashMap)param);
		    
		    //modelmap.put("owner", (String)reqMap.get("owner"));
		    //modelmap.put("tableNm", (String)reqMap.get("tableNm"));
		
			
		return "jsonView";
    }
    
    
    @RequestMapping(value="/product/updateHis.do")
    public String updateHis(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
    	
    		@SuppressWarnings("rawtypes")
    		Map userInfos = (Map)session.getAttribute("userInfo");
    		ArrayList roloes = (ArrayList)session.getAttribute("ROLES");
    		
    		boolean roleExist = false;
    		
    		for(Object role: roloes){
    			if(   ((String)role).equals("SYSMANAGER")  ||  ((String)role).equals("QAMANAGER0")  ){
    				roleExist = true;
    				break;
    			}
    		}

    		if( roleExist  ){
    			int cnt = proService.updateHis((HashMap)param);
    			
    			modelmap.put("result","ok");
    			modelmap.put("cnt",cnt);
    		}else{
    			modelmap.put("result", "warning");
    			modelmap.put("warningMsg","시스템관리자, 품질관리자만 가능합니다.");
    		}
			//proService.deleteLastHis((HashMap)param);
		    
		    //modelmap.put("owner", (String)reqMap.get("owner"));
		    //modelmap.put("tableNm", (String)reqMap.get("tableNm"));
		
			
		return "jsonView";
    }
    
    
    
    @RequestMapping(value="/product/insertHis.do")
    public String insertHis(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
    	
    		@SuppressWarnings("rawtypes")
    		Map userInfos    = (Map)session.getAttribute("userInfo");
    		String loginId   = (String)userInfos.get("loginId");
    		
    		param.put("loginId", loginId);
    		
    		ArrayList roloes = (ArrayList)session.getAttribute("ROLES");
    		
    		boolean adminGbn = false;
    		
    		for(Object role: roloes){
    			if(   ((String)role).equals("SYSMANAGER")  ){
    				adminGbn = true;
    				break;
    			}
    		}

			String returnStr = proService.insertHis((HashMap)param);
			modelmap.put("result" , returnStr);
			
		return "jsonView";
    }
    
    
    @RequestMapping(value="/product/deleteHis.do")
    public String deleteHis(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
    	
    		@SuppressWarnings("rawtypes")
    		Map userInfos    = (Map)session.getAttribute("userInfo");
    		String loginId   = (String)userInfos.get("loginId");
    		
    		param.put("loginId", loginId);
    		
    		ArrayList roloes = (ArrayList)session.getAttribute("ROLES");
    		
    		boolean adminGbn = false;
    		
    		for(Object role: roloes){
    			if(   ((String)role).equals("SYSMANAGER")  ){
    				adminGbn = true;
    				break;
    			}
    		}

			int returnStr = proService.deleteHis((HashMap)param);
			modelmap.put("result" , returnStr);
			
		return "jsonView";
    }
    
    
	@RequestMapping(value = "/product/downloadFile.do")
	public void downloadFile(HttpServletRequest request, @RequestParam Map<String, Object> param, HttpServletResponse response) throws Exception {
 
		String uploadPath = EgovProperties.getProperty("Globals.fileStorePath");
		
		param.put("sqlGbn", "ProductDAO.downloadFileInfo");
		List list = (List)proService.selectHis((HashMap)param);
 
		if(list.size() > 0){
			EgovMap map = (EgovMap)list.get(0);
			
			String serverFileNm = (String)map.get("streFileNm");
			String filename     = (String)map.get("productNm")+"_"+(String)map.get("regrDttm")+"."+(String)map.get("fileExtsn");
			
			File uFile = new File(uploadPath, serverFileNm);
			int fSize = (int) uFile.length();
	 
			BufferedInputStream in = new BufferedInputStream(new FileInputStream(uFile));
			String mimetype = "text/html";
			
			response.setCharacterEncoding("UTF-8");
			response.setBufferSize(fSize);
			response.setContentType(mimetype);

			String header = request.getHeader("User-Agent");
			if (header.indexOf("edge") > -1 ) {
				filename = URLEncoder.encode(filename, "UTF-8").replace("+", "%20");
				response.setHeader("Content-Disposition", "attachment;filename=" + filename + ";filename*= UTF-8''" + filename);
			} else if (header.indexOf("hrome") > -1) {
				filename = URLEncoder.encode(filename, "UTF-8").replace("+", " ");
				response.setHeader("Content-Disposition","attachment; filename=\"" + filename + "\"");
			} else {
				filename = URLEncoder.encode(filename, "UTF-8");
				response.setHeader("Content-Disposition","attachment;filename=\"" + filename + "\"");
			}
			response.setContentLength(fSize);
			
			FileCopyUtils.copy(in, response.getOutputStream());
			in.close();
			response.getOutputStream().flush();
			response.getOutputStream().close();
			
		}
	}

}
