package egovframework.rte.dsdsm.projectSchedule.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import egovframework.rte.psl.dataaccess.util.EgovMap;
import egovframework.rte.dsdsm.projectSchedule.service.vo.group;
import egovframework.rte.dsdsm.projectSchedule.service.vo.project;
import egovframework.rte.dsdsm.projectSchedule.service.vo.resources;
import egovframework.rte.dsdsm.projectSchedule.service.vo.assigs;

public interface ProjScService {

	public List<project> projectTaskList(HashMap h) throws Exception;
	
	public List<group> getChargerList(HashMap h) throws Exception;
	
	public List getTaskChargerList(HashMap h) throws Exception;
	
	public List getUserList(HashMap h) throws Exception;
	
	public List projectChargerList(HashMap h) throws Exception;
	
	public List<assigs> projectAssigsList(HashMap h) throws Exception;
	
	/**
	 * 작업일정 수정
	 * @return int
	 * @exception Exception 
	*/
	public void updateTasks(HashMap h) throws Exception;
		
	/**
	 * 담당자 수정
	 * @return int
	 * @exception Exception 
	*/
	public void updateCharger(HashMap h) throws Exception;
	
	/**
	 * 작업번호 생성하기
	 * @return int
	 * @exception Exception 
	*/
	public int getTaskid(HashMap h) throws Exception;
	
	/**
	 * 작업별 담당자ID 생성하기
	 * @return int
	 * @exception Exception 
	*/
	public int getAssigsId(HashMap h) throws Exception;
	
	/**
	 * 신규작업 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> regTasks(HashMap h) throws Exception;
	
	/**
	 * 신규담당자 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> regCharger(HashMap h) throws Exception;
	
	/**
	 * 작업 삭제
	 * @exception Exception 
	*/
	public void deleteTasks(HashMap h) throws Exception;
	
	/**
	 * 프로젝트 총 갯수
	 * @return int
	 * @exception Exception 
	*/
	public int getProjectListCount(HashMap h) throws Exception;
    
	/**
	 * 프로젝트 목록을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 프로젝트 목록
	 * @exception Exception
	 */
    public List getProjectList(HashMap h) throws Exception;
    
    /**
	 * 유저 목록
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 유저 목록
	 * @exception Exception
	 */
    public List getProjectUser(HashMap h) throws Exception;
    
    /**
	 * 프로젝트 세부내용을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 프로젝트 세부내용
	 * @exception Exception
	 */
    public List getProjectView(HashMap h) throws Exception;
    
    /**
	 * 프로젝트ID 중복체크
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 프로젝트ID 중복체크
	 * @exception Exception
	 */
    public Map<String,Object> checkProjectid(Map<String, String> map) throws Exception;
    
    /**
	 * 담당자 등록 시 상위단계 체크
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 담당자 등록 시 상위단계 체크
	 * @exception Exception
	 */
    public List<HashMap> checkUpperTask(HashMap h) throws Exception;
    
    /**
	 * 담당자 삭제 시 하위단계 체크
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return 담당자 삭제 시 하위단계 체크
	 * @exception Exception
	 */
    public List<HashMap> checkLowerTask(HashMap h) throws Exception;
    
    /**
	 * 프로젝트 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> regProject(HashMap h) throws Exception;
	
	/**
	 * 프로젝트 수정
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> saveProject(HashMap h) throws Exception;
	
	/**
	 * 프로젝트 삭제
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> delProject(HashMap h) throws Exception;
	
	/**
	 * 담당자 그룹 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> addChargerGroup(HashMap h) throws Exception;
	
	/**
	 * 담당자 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> addCharger(HashMap h) throws Exception;
	
	/**
	 * 그룹,담당자 삭제
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> delCharger(HashMap h) throws Exception;
	
	/**
	 * 작업별 담당자 등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> addTaskCharger(HashMap h) throws Exception;
	
	/**
	 * 작업별 담당자 삭제
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> delTaskCharger(HashMap h) throws Exception;
	
	/**
	 * 프로젝트 등록자 ID 불러오기
	 * @return int
	 * @exception Exception 
	*/
	public String getProjectRegId(HashMap h) throws Exception;
	
	/**
	 * 프로젝트 작업 담당자 포함여부 불러오기
	 * @return String
	 * @exception Exception 
	*/
	public String getContainUserId(HashMap h) throws Exception;
}