package egovframework.rte.dsdsm.projectSchedule.service.impl;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;
import egovframework.rte.dsdsm.projectSchedule.service.vo.group;
import egovframework.rte.dsdsm.projectSchedule.service.vo.project;
import egovframework.rte.dsdsm.projectSchedule.service.vo.resources;
import egovframework.rte.dsdsm.projectSchedule.service.vo.assigs;


@Repository("ProjScServiceDAO")
public class ProjScServiceDAO extends EgovAbstractDAO {
	
	@SuppressWarnings("unchecked")
	public List<project> projectTaskList(HashMap h){
		return (List<project>) list("ProjScServiceDAO.projectTaskList", h);
	}
	
	@SuppressWarnings("unchecked")
	public List<group> getChargerList(HashMap h){
		return (List<group>) list("ProjScServiceDAO.getChargerList", h);
	}
	
	@SuppressWarnings("unchecked")
	public List getUserList(HashMap h){
		return (List) list("ProjScServiceDAO.getUserList", h);
	}
	
	@SuppressWarnings("unchecked")
	public List projectChargerList(HashMap h){
		return (List) list("ProjScServiceDAO.projectChargerList", h);
	}
	
	@SuppressWarnings("unchecked")
	public List getTaskChargerList(HashMap h){
		return (List) list("ProjScServiceDAO.getTaskChargerList", h);
	}
	
	@SuppressWarnings("unchecked")
	public List<assigs> projectAssigsList(HashMap h){
		return (List<assigs>) list("ProjScServiceDAO.projectAssigsList", h);
	}
	
	/**
	 * 
	 * @return 작업일정 수정
	 * @exception Exception 
	*/
	public void updateTasks(HashMap h) throws Exception {
		update("ProjScServiceDAO.updateTasks", h);
				
	}
	
	/**
	 * 
	 * @return 담당자 수정
	 * @exception Exception 
	*/
	public void updateCharger(HashMap h) throws Exception {
		update("ProjScServiceDAO.updateCharger", h);
				
	}
	
	/**
	 * 
	 * @return 작업번호 가져오기
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int getTaskid(HashMap h) throws Exception {
		return (Integer) select("ProjScServiceDAO.getTaskid", h);
				
	}	
	
	/**
	 * 
	 * @return 작업별 담당자ID 생성하기
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int getAssigsId(HashMap h) throws Exception {
		return (Integer) select("ProjScServiceDAO.getAssigsId", h);
				
	}	
	
	/**
	 * 
	 * @return 신규작업 등록
	 * @exception Exception 
	*/
	public Map<String,Object> regTasks(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ProjScServiceDAO.regTasks", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 신규담당자 등록
	 * @exception Exception 
	*/
	public Map<String,Object> regCharger(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ProjScServiceDAO.regCharger", h));
		return result;
	} 
	
	/**
	 * 작업 삭제
	 * @return void형 
	 * @exception Exception
	 */
    public void deleteTasks(HashMap h) throws Exception {
        update("ProjScServiceDAO.deleteTasks", h);
    }
    
    /**
	 * 
	 * @return 프로젝트 총 갯수
	 * @exception Exception 
	*/
	public int getProjectListCount(HashMap h) throws Exception {
		return (Integer) select("ProjScServiceDAO.getProjectListCount", h);		
	} 
	
	/**
	 * 
	 * @return 프로젝트 목록
	 * @exception Exception 
	*/
	public List getProjectList(HashMap h) throws Exception {
		return list("ProjScServiceDAO.getProjectList", h);
	}
	
	/**
	 * 
	 * @return 유저 목록
	 * @exception Exception 
	*/
	public List getProjectUser(HashMap h) throws Exception {
		return list("ProjScServiceDAO.getProjectUser", h);
	}
	
	/**
	 * 
	 * @return 프로젝트 세부내용
	 * @exception Exception 
	*/
	public List getProjectView(HashMap h) throws Exception {
		return list("ProjScServiceDAO.getProjectView", h);
	}
	
	/**
	 * 
	 * @return 프로젝트ID 중복체크
	 * @exception Exception 
	*/
	public Map<String,Object> checkProjectid(Map<String,String> map){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("ONE", select("ProjScServiceDAO.checkProjectid", map));
		return result;
	}
	
	/**
	 * 
	 * @return 담당자 등록 시 상위단계 체크
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<HashMap> checkUpperTask(HashMap h){
		return (List<HashMap>) list("ProjScServiceDAO.checkUpperTask", h);
	}
	
	/**
	 * 
	 * @return 담당자 삭제 시 하위단계 체크
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public List<HashMap> checkLowerTask(HashMap h){
		return (List<HashMap>) list("ProjScServiceDAO.checkLowerTask", h);
	}
	
	/**
	 * 
	 * @return 프로젝트 등록
	 * @exception Exception 
	*/
	public Map<String,Object> regProject(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ProjScServiceDAO.regProject", h));
		return result;
	}
	
	/**
	 * 
	 * @return 프로젝트 수정
	 * @exception Exception 
	*/
	public Map<String,Object> saveProject(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("ProjScServiceDAO.saveProject", h));
		return result;
	}
	
	/**
	 * 
	 * @return 프로젝트ID 변경시 관련 작업 프로젝트ID 수정
	 * @exception Exception 
	*/
	public Map<String,Object> saveProjectDt(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("ProjScServiceDAO.saveProjectDt", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 프로젝트 삭제
	 * @exception Exception 
	*/
	public Map<String,Object> delProject(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("ProjScServiceDAO.delProject", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 프로젝트 삭제시 관련 작업 삭제
	 * @exception Exception 
	*/
	public Map<String,Object> delProjectDt(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("ProjScServiceDAO.delProjectDt", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 담당자 그룹 등록
	 * @exception Exception 
	*/
	public Map<String,Object> addChargerGroup(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ProjScServiceDAO.addChargerGroup", h));
		return result;
	}
	
	/**
	 * 
	 * @return 담당자 등록
	 * @exception Exception 
	*/
	public Map<String,Object> addCharger(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ProjScServiceDAO.addCharger", h));
		return result;
	}
	
	/**
	 * 
	 * @return 그룹,담당자 삭제
	 * @exception Exception 
	*/
	public Map<String,Object> delCharger(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("ProjScServiceDAO.delCharger", h));
		return result;
	}
	
	/**
	 * 
	 * @return 작업별 담당자 등록
	 * @exception Exception 
	*/
	public Map<String,Object> addTaskCharger(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ProjScServiceDAO.addTaskCharger", h));
		return result;
	}
	
	/**
	 * 
	 * @return 작업별 담당자 삭제
	 * @exception Exception 
	*/
	public Map<String,Object> delTaskCharger(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("ProjScServiceDAO.delTaskCharger", h));
		return result;
	}
	
	/**
	 * 
	 * @return 프로젝트 등록자 ID 가져오기
	 * @exception Exception 
	*/
	public String getProjectRegId(HashMap h) throws Exception {
		return (String) select("ProjScServiceDAO.getProjectRegId", h);		
	} 
	
	/**
	 * 
	 * @return 프로젝트 작업담당자 포함여부 불러오기
	 * @exception Exception 
	*/
	public String getContainUserId(HashMap h) throws Exception {
		return (String) select("ProjScServiceDAO.getContainUserId", h);		
	} 
}
