package egovframework.rte.dsdsm.projectSchedule.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import egovframework.rte.dsdsm.projectSchedule.service.ProjScService;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;
import egovframework.rte.psl.dataaccess.util.EgovMap;
import egovframework.rte.dsdsm.projectSchedule.service.vo.group;
import egovframework.rte.dsdsm.projectSchedule.service.vo.project;
import egovframework.rte.dsdsm.projectSchedule.service.vo.resources;
import egovframework.rte.dsdsm.projectSchedule.service.vo.assigs;


@Service("ProjScService")
public class ProjScServiceImpl extends EgovAbstractServiceImpl implements ProjScService{
	
    @Resource(name="ProjScServiceDAO")
    private ProjScServiceDAO ProjScServiceDAO;

   
    @SuppressWarnings("unchecked")
	@Override
	public List<project> projectTaskList(HashMap h) throws Exception{
		
		return ProjScServiceDAO.projectTaskList(h);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List<group> getChargerList(HashMap h) throws Exception{
		
		return ProjScServiceDAO.getChargerList(h);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List getUserList(HashMap h) throws Exception{
		
		return ProjScServiceDAO.getUserList(h);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List projectChargerList(HashMap h) throws Exception{
		
		return ProjScServiceDAO.projectChargerList(h);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List getTaskChargerList(HashMap h) throws Exception{
		
		return ProjScServiceDAO.getTaskChargerList(h);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List<assigs> projectAssigsList(HashMap h) throws Exception{
		
		return ProjScServiceDAO.projectAssigsList(h);
	}
	
	/**
	 * 작업일정 수정
	 * @exception Exception 
	*/
    public void updateTasks(HashMap h) throws Exception {
    	ProjScServiceDAO.updateTasks(h);
	} 
    
    /**
	 * 담당자 수정
	 * @exception Exception 
	*/
    public void updateCharger(HashMap h) throws Exception {
    	ProjScServiceDAO.updateCharger(h);
	} 
    
    /**
	 * 작업번호 생성
	 * @exception Exception 
	*/
    public int getTaskid(HashMap h) throws Exception {
		return ProjScServiceDAO.getTaskid(h);
	}
    
    /**
	 * 작업별 담당자ID 생성
	 * @exception Exception 
	*/
    public int getAssigsId(HashMap h) throws Exception {
		return ProjScServiceDAO.getAssigsId(h);
	}
    
    /**
	 * 신규작업 등록
	 * @exception Exception 
	*/
    public Map<String, Object> regTasks(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.regTasks(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	} 
    
    /**
	 * 신규담당자 등록
	 * @exception Exception 
	*/
    public Map<String, Object> regCharger(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.regCharger(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	} 
    
    /**
	 * 작업 삭제
	 * @exception Exception 
	*/
	public void deleteTasks(HashMap h) throws Exception {
		ProjScServiceDAO.deleteTasks(h);
	}
	
	/**
	 * 프로젝트 총 갯수
	 * @exception Exception
	 */
    public int getProjectListCount(HashMap h) throws Exception {
		return ProjScServiceDAO.getProjectListCount(h);
	}
    
    /**
	 * 프로젝트 목록
	 * @exception Exception
	 */
    public List getProjectList(HashMap h) throws Exception {
        return ProjScServiceDAO.getProjectList(h);
    }
    
    /**
   	 * 프로젝트 목록
   	 * @exception Exception
   	 */
    public List getProjectUser(HashMap h) throws Exception {
        return ProjScServiceDAO.getProjectUser(h);
    }
       
    
    /**
	 * 프로젝트 세부내용
	 * @exception Exception
	 */
    public List getProjectView(HashMap h) throws Exception {
        return ProjScServiceDAO.getProjectView(h);
    }
    
    /**
   	 * 프로젝트ID 중복체크
   	 * @exception Exception
   	 */
    @Override
	public Map<String, Object> checkProjectid(Map<String, String> map) throws Exception {
		
		Map <String,Object> result = ProjScServiceDAO.checkProjectid(map);
		
		@SuppressWarnings("unchecked")
		Map<String, Object> one = (Map<String, Object>)result.get("ONE");
		
		if(one==null){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "프로젝트ID를 사용할 수 있습니다.");
		}else{
			result.put("SUCCESS", false);
			result.put("MESSAGE", "프로젝트ID가 중복되었습니다.<br>다른 ID를 입력해주세요.");
		}
		
		return result;
	}
    
    /**
   	 * 담당자 등록 시 상위단계 체크
   	 * @exception Exception
   	 */
    @SuppressWarnings("unchecked")
	@Override
	public List<HashMap> checkUpperTask(HashMap h) throws Exception{
		
		return ProjScServiceDAO.checkUpperTask(h);
	}
    
    /**
   	 * 담당자 삭제 시 하위단계 체크
   	 * @exception Exception
   	 */
    @SuppressWarnings("unchecked")
	@Override
	public List<HashMap> checkLowerTask(HashMap h) throws Exception{
		
		return ProjScServiceDAO.checkLowerTask(h);
	}
    
    /**
   	 * 프로젝트 등록
   	 * @exception Exception
   	 */
    public Map<String, Object> regProject(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.regProject(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
   	 * 담당자 그룹 등록
   	 * @exception Exception
   	 */
    public Map<String, Object> addChargerGroup(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.addChargerGroup(h);
		
		String cnt = (String) result.get("CNT");
		
		if(cnt != null){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "담당자 그룹 등록이 완료되었습니다.");
		}else{
			result.put("SUCCESS", false);
			result.put("MESSAGE", "담당자 그룹 등록이 실패하였습니다.<br>잠시 후 다시 시도해주세요.");
		}
		
		return result;
	}
    
    /**
   	 * 담당자 등록
   	 * @exception Exception
   	 */
    public Map<String, Object> addCharger(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.addCharger(h);
		
		String cnt = (String) result.get("CNT");
		
		if(cnt != null){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "담당자 등록이 완료되었습니다.");
		}else{
			result.put("SUCCESS", false);
			result.put("MESSAGE", "담당자 등록이 실패하였습니다.<br>잠시 후 다시 시도해주세요.");
		}
		
		return result;
	}
    
    /**
   	 * 프로젝트 수정
   	 * @exception Exception
   	 */
    public Map<String, Object> saveProject(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.saveProject(h); //대분류ID 수정
		
		if(!h.get("projectido").equals(h.get("projectid"))){
			Map <String,Object> result2 = ProjScServiceDAO.saveProjectDt(h); //소분류코드의 부모ID 수정
		}
		
		Integer cnt = (Integer)result.get("CNT");
		
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "프로젝트 수정이 완료되었습니다");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "프로젝트 수정에 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
   	 * 프로젝트 삭제
   	 * @exception Exception
   	 */
    public Map<String, Object> delProject(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.delProject(h); //대분류코드 삭제x
		Integer cnt = (Integer)result.get("CNT");
		
		Map <String,Object> result2 = ProjScServiceDAO.delProjectDt(h); //소분류코드 삭제
		
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "프로젝트 삭제가 완료되었습니다");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "프로젝트 삭제에 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
   	 * 그룹,담당자 삭제
   	 * @exception Exception
   	 */
    public Map<String, Object> delCharger(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.delCharger(h);
		Integer cnt = (Integer)result.get("CNT");
		
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "삭제가 완료되었습니다");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "삭제에 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
   	 * 작업별 담당자 등록
   	 * @exception Exception
   	 */
    public Map<String, Object> addTaskCharger(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.addTaskCharger(h);
		
		int cnt = (Integer) result.get("CNT");
		
		if(cnt > 0){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
   	 * 작업별 담당자 삭제
   	 * @exception Exception
   	 */
    public Map<String, Object> delTaskCharger(HashMap h) throws Exception {
		Map <String,Object> result = ProjScServiceDAO.delTaskCharger(h);
		Integer cnt = (Integer)result.get("CNT");
		
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
		} else {
			result.put("SUCCESS", false);
		}
		
		return result;
	}

    /**
	 * 프로젝트 등록자ID 가져오기
	 * @exception Exception
	 */
    public String getProjectRegId(HashMap h) throws Exception {
		return ProjScServiceDAO.getProjectRegId(h);
	}
    
    /**
	 * 프로젝트 작업담당자 포함여부 불러오기
	 * @exception Exception
	 */
    public String getContainUserId(HashMap h) throws Exception {
		return ProjScServiceDAO.getContainUserId(h);
	}
}
