package egovframework.rte.dsdsm.schedule.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import egovframework.rte.psl.dataaccess.util.EgovMap;

public interface ScService {
	
	/**
	 * 일정 목록을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return S/R 목록
	 * @exception Exception
	 */
    public List getScList(HashMap h) throws Exception;
    
    /**
	 * 일정 상세정보를 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return S/R 목록
	 * @exception Exception
	 */
    public List getScView(HashMap h) throws Exception;
    
    /**
	 * 일정등록
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> registSchedule(HashMap h) throws Exception;
	
	/**
	 * 일정수정
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> scEdit(HashMap h) throws Exception;
	

	/**
	 * 일정요청으로 변경
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> scComfirmUpdate(HashMap h) throws Exception;
	
	
	/**
	 * 일정승인
	 * @return int
	 * @exception Exception 
	*/
	public Map<String,Object> scAppr(HashMap h) throws Exception;
	
	/**
	 * 일정 번호 생성하기
	 * @return int
	 * @exception Exception 
	*/
	public int getScno(HashMap h) throws Exception;
	
	
	
	/**
	 * 일정 목록을 불러온다
	 * @param HashMap - 조회할 정보가 담긴 HashMap
	 * @return S/R 목록
	 * @exception Exception
	 */
    public List getScListExcel(HashMap h) throws Exception;
	
	
}