package egovframework.rte.dsdsm.schedule.service.impl;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Repository("ScServiceDAO")
public class ScServiceDAO extends EgovAbstractDAO {
	
	/**
	 * 
	 * @return 일정 목록
	 * @exception Exception 
	*/
	public List getScList(HashMap h) throws Exception {
		return list("ScServiceDAO.getScListA", h);
	}
	
	/**
	 * 
	 * @return 일정 상세정보
	 * @exception Exception 
	*/
	public List getScView(HashMap h) throws Exception {
		return list("ScServiceDAO.getScView", h);
	}
	
	/**
	 * 
	 * @return 일정등록
	 * @exception Exception 
	*/
	public Map<String,Object> registSchedule(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ScServiceDAO.registSchedule", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 일정등록
	 * @exception Exception 
	*/
	public Map<String,Object> scComfirmUpdate(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ScServiceDAO.scComfirmUpdate", h));
		return result;
	} 
	
	
	/**
	 * 
	 * @return 일정등록
	 * @exception Exception 
	*/
	public Map<String,Object> registConfirmSchedule(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ScServiceDAO.registConfirmSchedule", h));
		return result;
	}	
	
	
	/**
	 * 
	 * @return 일정수정
	 * @exception Exception 
	*/
	public Map<String,Object> scEdit(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("ScServiceDAO.scEdit", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 일정승인
	 * @exception Exception 
	*/
	public Map<String,Object> scAppr(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("ScServiceDAO.scAppr", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 일정승인여부 수정(MAIN 테이블)
	 * @exception Exception 
	*/
	public Map<String,Object> scApprYn(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("ScServiceDAO.scApprYn", h));
		return result;
	} 
	
	/**
	 * 
	 * @return 일정 번호 생성
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int getScno(HashMap h) throws Exception {
		return (Integer) select("ScServiceDAO.getScno", h);
				
	}	
	
    /**
	 * 일정 목록
	 * @exception Exception 
	*/
    public List getScListExcel(HashMap h) throws Exception {
		return list("ScServiceDAO.getScListExcel", h);
	}	
}
