package egovframework.rte.dsdsm.schedule.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jfree.util.Log;
import org.springframework.stereotype.Service;

import egovframework.rte.cmmn.util.StringUtil;
import egovframework.rte.dsdsm.schedule.service.ScService;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Service("ScService")
public class ScServiceImpl extends EgovAbstractServiceImpl implements ScService{
	
    @Resource(name="ScServiceDAO")
    private ScServiceDAO ScServiceDAO;
    
	private Logger log = LogManager.getLogger();

    /**
	 * 일정 목록
	 * @exception Exception 
	*/
    public List getScList(HashMap h) throws Exception {
        return ScServiceDAO.getScList(h);
    }
	
    /**
	 * 일정 상세정보
	 * @exception Exception 
	*/
    public List getScView(HashMap h) throws Exception {
        return ScServiceDAO.getScView(h);
    }
    
    /**
	 * 일정등록
	 * @exception Exception 
	*/
    public Map<String, Object> registSchedule(HashMap h) throws Exception {
		//Map <String,Object> result = ScServiceDAO.registSchedule(h);
		Map<String, Object> result = new HashMap<String,Object>();
		
	    String checkApprove = StringUtil.nullToEmpty((String)h.get("scApproval"));
	    
	    
	    log.debug(" ======  >>>>> "+checkApprove);
	    
	    if("S".equals(checkApprove)){
	    	result = ScServiceDAO.registSchedule(h);
	    } else {
	    	result = ScServiceDAO.registConfirmSchedule(h);
	    }
		
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
    
    /**
	 * 일정수정
	 * @exception Exception 
	*/
    public Map<String, Object> scEdit(HashMap h) throws Exception {
		Map <String,Object> result = ScServiceDAO.scEdit(h);
		
		Integer cnt = (Integer)result.get("CNT");
    	
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "일정수정이 완료되었습니다.");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "일정수정이 실패하였습니다. 잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
	 * 일정승인요청
	 * @exception Exception 
	*/
    public Map<String, Object> scComfirmUpdate(HashMap h) throws Exception {
		Map <String,Object> result = ScServiceDAO.scComfirmUpdate(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "일정 " + h.get("message") + "이(가) 완료되었습니다.");
		}else{
			result.put("SUCCESS", false);
			result.put("MESSAGE", "일정 " + h.get("message") + "이(가) 실패하였습니다. 잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}    
    
    
    /**
	 * 일정승인
	 * @exception Exception 
	*/
    public Map<String, Object> scAppr(HashMap h) throws Exception {
		Map <String,Object> result = ScServiceDAO.scAppr(h);
		Map <String,Object> result2 = ScServiceDAO.scApprYn(h);
		
		String cnt = (String)result.get("CNT");
		Integer cnt2 = (Integer)result2.get("CNT");
		
		if(cnt==null && cnt2.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "일정" + h.get("message") + "이(가) 완료되었습니다.");
		}else{
			result.put("SUCCESS", false);
			result.put("MESSAGE", "일정" + h.get("message") + "이(가) 실패하였습니다. 잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
	 * 일정 번호 생성
	 * @exception Exception 
	*/
    public int getScno(HashMap h) throws Exception {
		return ScServiceDAO.getScno(h);
	}
    
    
    /**
	 * 일정 목록
	 * @exception Exception 
	*/
    public List getScListExcel(HashMap h) throws Exception {
        return ScServiceDAO.getScListExcel(h);
    }    
}
