package egovframework.rte.dsdsm.schedule.web;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.poi.hssf.usermodel.HSSFDataFormat;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Row;

import org.jfree.util.Log;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.ibm.icu.text.SimpleDateFormat;

import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmmcheck.util.ParamInfoUtil;
import egovframework.rte.dsdsm.schedule.service.ScService;
import egovframework.rte.dsdsm.sr.service.SrService;

@Controller
public class ScController {
	
	@Resource(name = "ScService")
    private ScService ScService;
	
	@Resource(name = "SrService")
    private SrService SrService;
	
	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
	
	@Resource(name="ParamInfoUtil")
	private  ParamInfoUtil paramInfoUtil;	
	
	private Logger log = LogManager.getLogger();

	
	@RequestMapping(value="/schedule/scList.do")
    public String scList(ModelMap model) throws Exception {
		
		@SuppressWarnings("rawtypes")
		List deptCodes = commonDataService.getDeptCode();
		
   		model.put("DEPT_CODE", deptCodes);
   		
   		HashMap<Object, Object> map = new HashMap<Object, Object>();
   		
   		map.put("codeId", "SCCODE");
		
		model.addAttribute("scgbn",CmmService.getCmmDitcList(map));
		
    	return "/dsdsm/schedule/scList";
    }

    
  
	@RequestMapping(value="/dhtmlxGantt/gantt_data.json")
    public String ganttdata(ModelMap model) throws Exception {
		
		model.put("data","");
		model.put("links","");
   		
   		return "jsonView";
    }
	
	@RequestMapping(value="/schedule/calendarView.do")
    public String calendarView(@RequestParam HashMap<Object,Object> param, ModelMap model, HttpSession session) throws Exception { 
		
		List list = ScService.getScView(param);	
 	  	model.put("list",list);
		
 	  	param.put("status", "0");
 	  	param.put("sdgbn", "SC");
 	  	
 	  	String getRole = SrService.getRole(param);
 	  	log.debug("getRole = " + getRole);
 	  	@SuppressWarnings("rawtypes")
		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
 	  	log.debug("ROLE = " + ROLE);
 	  	
 	  	String modyn = "N";
 	  	
 	  	if(ROLE.contains(getRole)){
			modyn = "Y";
		}
 	  	log.debug("modyn = " + modyn);
 	  	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	map.put("codeId", "SCCODE");
		
		model.addAttribute("scgbn",CmmService.getCmmDitcList(map));
		model.addAttribute("modyn", modyn);
		
    	return "/dsdsm/schedule/scViewModal";
    }
	
	@RequestMapping(value="/schedule/calendarRegist.do")
    public String calendarRegist(@RequestParam HashMap<Object,Object> param, ModelMap model) throws Exception { 
		
		model.put("date", param.get("date"));
		
		HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	map.put("codeId", "SCCODE");
		
		model.addAttribute("scgbn",CmmService.getCmmDitcList(map));
		
		map.put("codeId", "SC2000");
		
		model.addAttribute("repeat",CmmService.getCmmDitcList(map));
		
    	return "/dsdsm/schedule/scRegistModal";
    }
	
	/**
     * 일정등록
     * @throws Exception 
     */
    @RequestMapping(value="/schedule/calendarRegist.json")
    public String edit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	log.debug("일정 등록 시작");
  
    	int getno = 0;
    	String scno = ""; 
    			 
    	getno = ScService.getScno(param);
    	scno = String.format("%04d", getno);
    		
    	scno = "SC" + DateUtil.toYYYYMMDDDate(DateUtil.getDate()) + scno;
    	
    	
    	param.put("scno",scno);
    	
    	
    	paramInfoUtil.mpaInfo_print(param);
    	
    	
    	Map<String, Object> result = ScService.registSchedule(param);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    /**
     * 일정수정
     * @throws Exception 
     */
    @RequestMapping(value="/schedule/scEdit.json")
    public String scEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	log.debug("일정 수정 시작");
    	
    	paramInfoUtil.mpaInfo_print(param);
    	    	
    	Map<String, Object> result = ScService.scEdit(param);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    /**
     * 일정수정
     * @throws Exception 
     */
    @RequestMapping(value="/schedule/scComfirmU.json")
    public String scComfirmUpdate(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	log.debug("일정 수정 시작");
    	
    	paramInfoUtil.mpaInfo_print(param);
    	
    	Map<String, Object> result = ScService.scComfirmUpdate(param);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }    
    
	
    /**
     * 일정 승인,반려
     * @throws Exception 
     */
    @RequestMapping(value="/schedule/scAppr.json")
    public String scAppr(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	log.debug("일정 승인 시작"); 
    	
    	Map<String, Object> result = ScService.scAppr(param);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
	
    
	/**
     * 일정 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/schedule/getScList.do")
	public String getScList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		log.debug("/schedule/getScList.do ==> 목록");
		
		param.put("status", "0");
 	  	param.put("sdgbn", "SC");
 	  	
		String getRole = SrService.getRole(param);
		log.debug("ROLE = " + getRole);
 	  	
 	  	@SuppressWarnings("rawtypes")
		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
 	  	
 	  	String modyn = "N";
 	  	
 	  	
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	//Map checkInfoG = paramInfoUtil.dutyCode(session, "0030010000000");
    	Map checkInfoG = paramInfoUtil.dutyUrlCode(session, "/schedule/scList.do");
    	
    	//String dutyCd      = (String)userInfos.get("dutyCd");
    	String lolCheck    = (String)checkInfoG.get("lolId");
    	String insertCheck = (String)checkInfoG.get("insertYn");
    	String readCheck   = (String)checkInfoG.get("readYn");
    	String updateCheck = (String)checkInfoG.get("updateYn");
    	String deleteCheck = (String)checkInfoG.get("deleteYn");  		
		/*****/
    	
    	modyn = ("Y".equals(updateCheck))?"Y":"N";
    	log.debug("modyn :: ["+modyn+"]");
    	log.debug("deptId :: ["+param.get("deptId")+"]");
    	log.debug("nowYM :: ["+param.get("nowYM")+"]");
/* 	  	
 	  	if(ROLE.contains(getRole)){
			modyn = "Y";
		}
*/ 	  	
 	  	Map userInfo = (Map)session.getAttribute("userInfo");
    	
 	  	if(param.get("deptId") == null){
 	  		//param.put("deptId", userInfo.get("deptId"));
 	  	}
 	  	
 	  	if (param.get("nowYM") == null) { 
 	  	   Date d = new Date();
 	  	   SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
 	  	   String nowYM = sdf.format(d);
 	  	   
 	  	   param.put("nowYM", nowYM);
		}
    	log.debug("nowYM after :: ["+param.get("nowYM")+"]");
 	  	
    	param.put("userid",userInfo.get("userId"));
    	param.put("modyn", modyn);
    	
		List list = ScService.getScList(param);	
 	  	model.put("list",list);
		
		return "jsonView";
	}
	
    @SuppressWarnings("deprecation")
	@RequestMapping(value="/schedule/scheduleExcelDown.json")
    public void scheduleExcelDown(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, HttpServletResponse response, ModelMap model, HttpSession session) throws Exception {    	
  	   
        log.debug(":::::::::: scheduleExcelDown");
        log.debug(":::::::::: param : " + param);
     	
  	   Date d = new Date();
  	   SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HHmmss");
  	   SimpleDateFormat sdf2 = new SimpleDateFormat("yyyy-MM");
  	   String dates = sdf.format(d);
         
  	   String projectId     = "";
  	   
	   param.put("status", "0");
 	   param.put("sdgbn", "SC");
 	  	
	   String getRole = SrService.getRole(param);
	   log.debug("ROLE = " + getRole);
 	  	
 	   @SuppressWarnings("rawtypes")
	   ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
 	  	
 	   String modyn = "N";
  	   
  	   
  	   HashMap<Object, Object> chgPrm = new HashMap<Object, Object>();
  	   String businessName       = (String)param.get("businessName");
  	   String taskOrderName      = (String)param.get("taskOrderName");
  	   String issuesTitle        = (String)param.get("issuesTitle");
  	   String issuesSeverasc     = (String)param.get("issuesSeverasc");
  	   String issuesImportanceSc = (String)param.get("issuesImportanceSc");
  	   String issuesStatusSc     = (String)param.get("issuesStatusSc");
  	   String isOcTime           = (String)param.get("isOcTime");
  	   String isEsime            = (String)param.get("isEsime");
  	   String isClTime           = (String)param.get("isClTime");


  	   Map userInfo = (Map)session.getAttribute("userInfo");
  	   param.put("userid",userInfo.get("userId"));
  	   param.put("modyn", modyn);


  	   log.debug("nowYM :: ["+param.get("nowYM")+"]");
	  	if ((param.get("nowYM") == null) || "".equals(param.get("nowYM"))) {  
	  	   String nowYM = sdf2.format(d);
	  	   param.put("nowYM", nowYM);
		}
    	log.debug("nowYM after :: ["+param.get("nowYM")+"]");
	  	
		List list = ScService.getScListExcel(param);	
  	   
 	   
  	   //String fileNm = "C:/dev/"+projectId+"Excel_"+dates+".xls";
  	   String fileNm = "schedule_Excel_"+dates+".xls";
  	   
  	   // Workbook 생성
  	   HSSFWorkbook  workbook = new HSSFWorkbook(); // Excel 2007 이전 버전 	   
  	   
 // *** Sheet-------------------------------------------------
         // Sheet 생성
         HSSFSheet sheet1 = workbook.createSheet("근태현황");
         
         // 셀 스타일
         CellStyle style = workbook.createCellStyle();
         style.setAlignment(CellStyle.ALIGN_CENTER);            //가운데 정렬
         style.setVerticalAlignment(CellStyle.VERTICAL_CENTER); //높이 가운데 정렬         
         
         // Data Format
         HSSFDataFormat df = workbook.createDataFormat();
      
         Row row = null;
         Cell cell = null;
         //----------------------------------------------------------
          
         // 첫 번째 줄
         //sheet1.setColumnWidth(2, (short)4000);// 기본값.
         
         row = sheet1.createRow(0);
         
         // 첫 번째 줄에 Cell 설정하기-------------
         cell = row.createCell(0);
         
         cell = row.createCell(1);
         cell.setCellValue("번호");
         cell.setCellStyle(style);
         
         cell = row.createCell(2);
         cell.setCellValue("휴가유형");
         cell.setCellStyle(style);   

         cell = row.createCell(3);
         cell.setCellValue("신청자정보");
         
         cell = row.createCell(4);
         cell.setCellValue("내용");

         cell = row.createCell(5);
         cell.setCellValue("시작날짜");
         cell.setCellStyle(style);
         
         cell = row.createCell(6);
         cell.setCellValue("종료일자");
         cell.setCellStyle(style);
         
         cell = row.createCell(7);
         cell.setCellValue(" 승인여부 ");
         cell.setCellStyle(style);
         
         cell = row.createCell(8);
         cell.setCellValue(" 승인자 ");
	     cell.setCellStyle(style);         
         
         cell = row.createCell(9);
         cell.setCellValue("승인날짜");
	     cell.setCellStyle(style);
         
         // 두 번째 줄에 Cell 설정하기-------------
         int rowIdx = 0;
         int sumNum = 1;

         //log.debug(">>> [arrayDepends]"+arrayDepends.length);

         for(int i=0;i<list.size();i++){
         	
         	@SuppressWarnings("unchecked")
             Map<Object,Object> listData = (Map<Object, Object>) list.get(i);
         	
         	//log.debug(listData.toString());
            row = sheet1.createRow(++rowIdx);
             
 	        cell = row.createCell(1);
 	        cell.setCellValue(sumNum);
 	        cell.setCellStyle(style);
 	       
 	        String hadoff_text  = (String)listData.get("hadoffText");
 	        
 	        cell = row.createCell(2);
 	        
 	        if("AA".equals(hadoff_text.trim())){
 	          cell.setCellValue((String)listData.get("schdulegbntext"));
 	        } else {
 	          cell.setCellValue((String)listData.get("schdulegbntext")+"("+hadoff_text+")");
 	        }
 	        cell.setCellStyle(style);


      	    
      	    cell = row.createCell(3);
 	        cell.setCellValue((String)listData.get("schedulename"));  
 	        
  	        cell = row.createCell(4);
 	        cell.setCellValue((String)listData.get("nttcn"));
 	        
 	        cell = row.createCell(5);
 	        cell.setCellValue((String)listData.get("sdate"));
 	        cell.setCellStyle(style);
 	        
 	        cell = row.createCell(6);
 	        cell.setCellValue((String)listData.get("edate"));
 	        cell.setCellStyle(style);
 	        
 	        cell = row.createCell(7);
 	        cell.setCellValue((String)listData.get("approvalYnText"));
 	        cell.setCellStyle(style);
 	       
 	        cell = row.createCell(8);
 	        cell.setCellValue((String)listData.get("appovalNm"));
 	        cell.setCellStyle(style);
 	         
 	        cell = row.createCell(9);
 	        cell.setCellValue((String)listData.get("appovalDthr"));
 	        cell.setCellStyle(style);
 	        
 	        sumNum++;
         }
         
         for(int kk=1;kk < 11;kk++){
        	 sheet1.autoSizeColumn(kk); 
         }
         
         

         // excel 파일 저장
         try {
      	   response.setContentType("Application/Msexcel");
      	   response.setHeader("Content-Disposition", "ATTachment; Filename="+fileNm+".xls");
      	   OutputStream fileOut  = response.getOutputStream();
             workbook.write(fileOut);
             fileOut.close();
         } catch (FileNotFoundException e) {
             e.printStackTrace();
         } catch (IOException e) {
             e.printStackTrace();
         }
          
     }	
	
	
	
	
	
}
