package egovframework.rte.dsdsm.sr.service.impl;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.util.StrUtil;
import egovframework.rte.psl.dataaccess.EgovAbstractDAO;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Repository("SrServiceDAO")
public class SrServiceDAO extends EgovAbstractDAO {
	
	org.apache.logging.log4j.Logger log = org.apache.logging.log4j.LogManager.getLogger();
	
	public Map<String,Object> regSrmain(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("SrServiceDAO.regSrmain", h));
		return result;
	} 
	
	public Map<String,Object> regHistory(HashMap h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("SrServiceDAO.regHistory", h));
		return result;
	} 
	
	public Map<String,Object> regJobHistory(Map<String,String> h){
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", insert("SrServiceDAO.regJobHistory", h));
		return result;
	} 
	
	@SuppressWarnings("unchecked")
	public int getSrno(HashMap h) throws Exception {
		return (Integer) select("SrServiceDAO.getSrno", h);
				
	}	
	
	/**
	 * 
	 * @return 마지막 단계 권한
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public String getRole(HashMap h) throws Exception {
		return (String) select("SrServiceDAO.getRole", h);	
	}
	
	/**
	 * 
	 * @return 관련공문명
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public String getRelText(HashMap h) throws Exception {
		return (String) select("SrServiceDAO.getRelText", h);	
	}
	
	/**
	 * 
	 * @return S/R HISTORY 순번 가져오기
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int getSrseq(HashMap h) throws Exception {
		return (Integer) select("SrServiceDAO.getSrseq", h);
				
	}	
	
	/**
	 * 
	 * @return S/R 업무변경 HISTORY 순번 가져오기
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public int getSrJobseq(Map<String,String> h) throws Exception {
		return (Integer) select("SrServiceDAO.getSrJobseq", h);
				
	}	
	
	/**
	 * 
	 * @return S/R 접수여부
	 * @exception Exception 
	*/
	@SuppressWarnings("unchecked")
	public String getReceiptYn(HashMap h) throws Exception {
		return (String) select("SrServiceDAO.getReceiptYn", h);
				
	}	
	
	public List getList(HashMap h) throws Exception {
		
		return list("SrServiceDAO.getList", h);
	}
	
	public List getView(HashMap h) throws Exception {
		return list("SrServiceDAO.getView", h);
	}
	
	public Map<String,Object> updateAccept(HashMap h) throws Exception {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("CNT", update("SrServiceDAO.updateAccept", h));
		return result;
	} 
	
	/**
	 * 
	 * @return S/R 최종단계등록
	 * @exception Exception 
	*/
	public int updateLaststa(HashMap h) throws Exception {
		return update("SrServiceDAO.updateLaststa", h);
				
	} 
	
	/**
	 * 
	 * @return S/R 최종단계 반려여부
	 * @exception Exception 
	*/
	public int updateSrReturnYn(HashMap h) throws Exception {
		return update("SrServiceDAO.updateSrReturnYn", h);
				
	} 
	
	/**
	 * 
	 * @return S/R 부서입력
	 * @exception Exception 
	*/
	public int updateSrDeptId(HashMap h) throws Exception {
		return update("SrServiceDAO.updateSrDeptId", h);
				
	}
	
	public List getLaststa(HashMap h) throws Exception {
		return list("SrServiceDAO.getLaststa", h);
	}
	
	public List getHistorysta(HashMap h) throws Exception {
		return list("SrServiceDAO.getHistorysta", h);
	}
	
	public List<EgovMap> getStatus(HashMap h) throws Exception {
		
		System.out.println("getStatus(HashMap h) >>>> "+h);
		
		return (List<EgovMap>) list("SrServiceDAO.getStatus", h);
	}
	
	public String insertContent(HashMap h) throws Exception {
		return (String)insert("SrServiceDAO.insertContent", h);
				
	} 
	
	/**
	 * 
	 * @return S/R 수정
	 * @exception Exception 
	*/
	public void updateContent(HashMap h) throws Exception {
		update("SrServiceDAO.updateContent", h);
				
	}
	
	/**
	 * 
	 * @return S/R HISTORY 수정
	 * @exception Exception 
	*/
	public void updateHistory(HashMap h) throws Exception {
		update("SrServiceDAO.updateHistory", h);
				
	}
	
	/**
	 * 
	 * @return S/R 총 갯수
	 * @exception Exception 
	*/
	public int getListCount(HashMap h) throws Exception {
		
		
		String databaseType = StrUtil.NVL(EgovProperties.getProperty("Globals.DatabaseType"),"postgres");
		
		// databaseType이 oracle인 경우 Clob 데이터 처리
		if("oracle".equals(databaseType)){
				
			if(h.get("jobCd")!=null){
				List temp = new ArrayList();
				for(String jobCd:(String[])(h.get("jobCd"))){
					temp.add(jobCd);
					//System.out.println(jobCd);
				}
				h.remove("jobCd");
				h.put("jobCd", temp);
			}
		}
		
		return (Integer) select("SrServiceDAO.getListCnt", h);
	} 
	
	public List<HashMap> getSRdetail(HashMap h) throws Exception {
		return (List<HashMap>) list("SrServiceDAO.getSRdetail", h);
	}
	
	/**
	 * 
	 * @return S/R 파일 업로드 리스트
	 * @exception Exception 
	*/
	public List<HashMap> getFileUploadList(HashMap h) throws Exception {
		return (List<HashMap>) list("SrServiceDAO.getFileUploadList", h);
	}
	
	/**
	 * 
	 * @return S/R 부서 구성원 목록
	 * @exception Exception 
	*/
	public List getUserCode(HashMap h) throws Exception {
    	log.debug("-----------------------------------------------");
    	log.debug("------- [[[ SrServiceDAO.getUserCode() ]]]");
    	log.debug("-----------------------------------------------");
    	log.debug("------- h : " + h);
    	log.debug("-----------------------------------------------");
    	
		return list("SrServiceDAO.getUserCode", h);
	}
	
	public List  selectAtchFileList(HashMap map) throws Exception {
		return  list("SrServiceDAO.selectAtchFileList", map);		
	}
	
	
	
	public List  selectSrProcStep() throws Exception {
		return  list("SrServiceDAO.selectSrProcStep");		
	}	
}
