package egovframework.rte.dsdsm.sr.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.jfree.util.Log;
import org.springframework.stereotype.Service;

import egovframework.rte.dsdsm.sr.service.SrService;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Service("SrService")
public class SrServiceImpl extends EgovAbstractServiceImpl implements SrService{
	
    @Resource(name="SrServiceDAO")
    private SrServiceDAO SrServiceDAO;

	org.apache.logging.log4j.Logger log = org.apache.logging.log4j.LogManager.getLogger();
	
	public Map<String, Object> regSrmain(HashMap h) throws Exception {
		Map <String,Object> result = SrServiceDAO.regSrmain(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	}
	
	public Map<String, Object> regHistory(HashMap h) throws Exception {
		Map <String,Object> result = SrServiceDAO.regHistory(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	} 
	
	public Map<String, Object> regJobHistory(Map<String,String> h) throws Exception {
		Map <String,Object> result = SrServiceDAO.regJobHistory(h);
		
		String cnt = (String)result.get("CNT");
		
		if(cnt==null){
			result.put("SUCCESS", true);
		}else{
			result.put("SUCCESS", false);
		}
		
		return result;
	} 
	
	public int getSrno(HashMap h) throws Exception {
		return SrServiceDAO.getSrno(h);
	}
	
	/**
	 * S/R 마지막단계 권한
	 * @exception Exception 
	*/
	public String getRole(HashMap h) throws Exception {
		return SrServiceDAO.getRole(h);
	}
	
	/**
	 * 문서에서 넘어오는 경우(관련공문명 가져오기)
	 * @exception Exception 
	*/
	public String getRelText(HashMap h) throws Exception {
		return SrServiceDAO.getRelText(h);
	}

	/**
	 * S/R HISTORY 순번 가져오기
	 * @exception Exception 
	*/
	public int getSrseq(HashMap h) throws Exception {
		return SrServiceDAO.getSrseq(h);
	}
	
	/**
	 * S/R 업무변경 HISTORY 순번 가져오기
	 * @exception Exception 
	*/
	public int getSrJobseq(Map<String,String> h) throws Exception {
		return SrServiceDAO.getSrJobseq(h);
	}
	
	/**
	 * S/R 접수여부
	 * @exception Exception 
	*/
	public String getReceiptYn(HashMap h) throws Exception {
		return SrServiceDAO.getReceiptYn(h);
	}
	
    public List getList(HashMap h) throws Exception {
        return SrServiceDAO.getList(h);
    }

    public List getView(HashMap h) throws Exception {
        return SrServiceDAO.getView(h);
    }
    
    public Map<String, Object> updateAccept(HashMap h) throws Exception {
    	
    	Map <String,Object> result = SrServiceDAO.updateAccept(h);
		
    	Integer cnt = (Integer)result.get("CNT");
    	
		if(cnt.intValue()>0){
			result.put("SUCCESS", true);
			result.put("MESSAGE", "접수되었습니다");
		} else {
			result.put("SUCCESS", false);
			result.put("MESSAGE", "접수가 실패하였습니다. 잠시 후 다시 시도바랍니다.");
		}
		
		return result;
	}
    
    /**
	 * S/R 최종단계등록
	 * @exception Exception 
	*/
    public int updateLaststa(HashMap h) throws Exception {
		return SrServiceDAO.updateLaststa(h);
	}
    
    /**
	 * S/R 최종단계 반려여부
	 * @exception Exception 
	*/
    public int updateSrReturnYn(HashMap h) throws Exception {
		return SrServiceDAO.updateSrReturnYn(h);
	}
    
    /**
	 * S/R 부서입력
	 * @exception Exception 
	*/
    public int updateSrDeptId(HashMap h) throws Exception {
		return SrServiceDAO.updateSrDeptId(h);
	}
    
    public List getLaststa(HashMap h) throws Exception {
        return SrServiceDAO.getLaststa(h);
    }
    
    public List getHistorysta(HashMap h) throws Exception {
        return SrServiceDAO.getHistorysta(h);
    }
    
    public List<EgovMap> getStatus(HashMap h) throws Exception {
        return SrServiceDAO.getStatus(h);
    }
    
    public String insertContent(HashMap h) throws Exception {
		return SrServiceDAO.insertContent(h);
	} 
    
    /**
	 * S/R 파일 업로드 리스트
	 * @exception Exception 
	*/
    public List<HashMap> getFileUploadList(HashMap h) throws Exception {
        return SrServiceDAO.getFileUploadList(h);
    }
    
    /**
	 * S/R 수정
	 * @exception Exception 
	*/
    public void updateContent(HashMap h) throws Exception {
		SrServiceDAO.updateContent(h);
	} 
    
    /**
	 * S/R HISTORY 수정
	 * @exception Exception 
	*/
    public void updateHistory(HashMap h) throws Exception {
		SrServiceDAO.updateHistory(h);
	} 
    
    /**
	 * S/R 상세내용을 불러온다
	 * @exception Exception
	 */
    public List<HashMap> getSRdetail(HashMap h) throws Exception {
        return SrServiceDAO.getSRdetail(h);
    }
    
    /**
	 * S/R 총 갯수
	 * @exception Exception
	 */
    public int getListCount(HashMap h) throws Exception {
		return SrServiceDAO.getListCount(h);
	}
    
    /**
	 * S/R 부서 구성원 목록
	 * @exception Exception
	 */
    public List getUserCode(HashMap h) throws Exception {
    	log.debug("-----------------------------------------------");
    	log.debug("------- [[[ SrServiceImpl.getUserCode() ]]]");
    	log.debug("-----------------------------------------------");
    	
        return SrServiceDAO.getUserCode(h);
    }
	
    public List selectAtchFileList(HashMap map) throws Exception {
		return SrServiceDAO.selectAtchFileList(map);
	}
    
    public List  selectSrProcStep() throws Exception {
    	return SrServiceDAO.selectSrProcStep();
    }
}
