package egovframework.rte.dsdsm.sr.web;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.codehaus.jackson.map.ObjectMapper;
import org.jfree.util.Log;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.JSONValue;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovFileMngService;
import egovframework.rte.cmmn.util.EgovFileMngUtil;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.cmm.util.StrUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;
import egovframework.rte.dsdsm.sr.service.SrService;
import egovframework.rte.psl.dataaccess.util.EgovMap;

@Controller
public class SrController {
	
	@Resource(name = "SrService")
    private SrService SrService;
	
	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	
	@Resource(name ="CodeService")
	private CodeService codeService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
	
	@Resource(name="EgovFileMngUtil")
	private EgovFileMngUtil fileUtil;	   
	
	@Resource(name="DisFileMng")
	private  DisFileMng disFileMng;
	  
	@Resource(name="EgovFileMngService")
	private EgovFileMngService fileMngService;	  

	org.apache.logging.log4j.Logger log = org.apache.logging.log4j.LogManager.getLogger();
	
	/**
     * S/R등록화면으로 들어간다.
	 * @throws Exception 
     */
    @RequestMapping(value="/sr/srRegist.do")
    public String SRregist(HttpServletRequest request, Model model) throws Exception {
		
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	map.put("codeId", "LN1100");
		
		model.addAttribute("work",CmmService.getCmmDitcList(map));
		
		map.put("codeId", "SRRCTP");
		
		model.addAttribute("rctype",CmmService.getCmmDitcList(map));
   		
		map.put("codeId", "DO1000");
		
		model.addAttribute("type",CmmService.getCmmDitcList(map));
		
    	@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();	    	
    	ObjectMapper mapper = new ObjectMapper();
   		String jobCdsJsonStr = mapper.writeValueAsString(jobCds);	   		
   		model.addAttribute("JOB_LIST", jobCdsJsonStr);
		model.addAttribute("docGbn", request.getParameter("docGbn"));
		model.addAttribute("docNo", request.getParameter("no"));
		map.put("docNo", request.getParameter("no"));
		model.addAttribute("relText", SrService.getRelText(map));
		
    	return "/dsdsm/sr/srReg";
    }
    
    /**
     * S/R등록화면으로 들어간다.
	 * @throws Exception 
     */
    @RequestMapping(value="/sr/upload.do")
    public String upload(HttpServletRequest request, Model model) throws Exception {

    	return "/dsdsm/sr/AXUpload5";
    }
    
    /**
     * 파일첨부를 한다.
	 * @throws Exception 
     */
    @SuppressWarnings("deprecation")
	@RequestMapping(value="/sr/fileUpload.do")
    public String fileUpload(HttpServletRequest request, ModelMap model) throws Exception {
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	String fileid = disFileMng.fileUpload("SRRQ_",request);
		System.out.println(fileid);
		model.put("name", "Chrysanthemum.jpg");
		model.put("savename", "SRRQ_201505141131477730");
		model.put("type", "jpg");
		model.put("fileSize", "879394");
		model.put("uploadedPath", "1");
		model.put("thumbUrl", "C:/Users/Public/Pictures/Sample Pictures/22.jpg");
    	
		
		return "jsonView";
    }
    
    /**
     * 파일 첨부 목록을 불러온다.
	 * @throws Exception 
     */
    @SuppressWarnings("deprecation")
	@RequestMapping(value="/sr/fileListLoad.do")
    public String fileListLoad(HttpServletRequest request, ModelMap model) throws Exception {
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
		    	    	
    	List<HashMap> list = SrService.getFileUploadList(map);
    	
		model.put("result",list);
		return "jsonView";
    }
    
    /**
	 * SR 이력 조회
	 * @param request
	 * @param model
	 * @param session
	 * @return
	 * @throws Exception
	 */
	@RequestMapping(value = "/sr/getSrHisList.do")
	public String getSrHisList(HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

    	log.debug("-----------------------------------------------");
    	log.debug("------- [[[ SrController.getSrHisList() ]]]");
    	log.debug("-----------------------------------------------");
    	
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		String srno = request.getParameter("srno");
		String addyn = request.getParameter("addyn");
		
		map.put("srno", srno);
		 
    	List mainlast = SrService.getLaststa(map); 
    	
		String ansStep = "";
		String ansGbn = "";

    	EgovMap mainlast_map = (EgovMap)mainlast.get(0);
		ansStep = (String) mainlast_map.get("prevstep");
		if("110".equals(ansStep)){
    		ansGbn = "002";
		} else {
			ansGbn = "001";
		}  
		
		map.put("ansGbn", ansGbn);
		map.put("addyn", "N");
		
		@SuppressWarnings("rawtypes")
		Map userInfo = (Map)session.getAttribute("userInfo");
		
		map.put("jobCd",userInfo.get("jobCd")); 
 
		List list = SrService.getStatus(map); 
		map.put("addyn", "Y");
 
		List list2 = SrService.getStatus(map); 
				
		model.put("list", list);
		model.put("list2", list2);
		return "jsonView";
	}
	
    /**
     * S/R상세보기화면으로 들어간다.
	 * @throws Exception 
     */
    @SuppressWarnings("unchecked")
	@RequestMapping(value="/sr/srView.do")
    public String SRview(HttpServletRequest request, Model model, HttpSession session) throws Exception {

    	log.debug("-----------------------------------------------");
    	log.debug("------- [[[ SrController.SRview() ]]]");
    	log.debug("-----------------------------------------------");
    	 
    	HashMap<Object, Object> h = new HashMap<Object, Object>();
    	HashMap<Object, Object> h2 = new HashMap<Object, Object>();
    	String srno = request.getParameter("srno");
    	String isModal = request.getParameter("isModal");
    	
    	/*if(null != request.getParameter("isModal")) {
    		isModal = request.getParameter("isModal");
    	}*/
    	
    	h.put("srno", srno);

    	List mainlast = SrService.getLaststa(h);
    	log.debug("------- mainlast : " + mainlast);
    	
    	List historysta = SrService.getHistorysta(h);
    	log.debug("------- historysta : " + historysta);
    	
    	String matchyn = "";

    	EgovMap mainlast_map = (EgovMap)mainlast.get(0);
    	EgovMap historysta_map = (EgovMap)historysta.get(0);
		  
	    if(mainlast_map.get("laststa").equals(historysta_map.get("status"))){
	    	matchyn = "Y";
	    } else {
	    	matchyn = "N";
	    }
 
	    String btn = "";
	    
	    if(mainlast_map.get("laststa").equals("100")){
	    	btn = "접수";
	    } else if(mainlast_map.get("laststa").equals("150") || mainlast_map.get("laststa").equals("180")){
	    	btn = "등록완료";
	    } else {
	    	btn = "검토완료";
	    }
	    
	    @SuppressWarnings("rawtypes")
		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
		
		String modyn = "N";
	
		String ansStep = "";
		String ansGbn = "";
		
		h.put("status", mainlast_map.get("laststa"));
		h.put("sdgbn", "SR");
		
		if(mainlast_map.get("laststa").equals("180")){
			ansStep = (String) mainlast_map.get("prevstep");
			
			if("110".equals(ansStep)){
	    		ansGbn = "002";
			} else {
				ansGbn = "001";
			} 
		}
		
		h.put("ansGbn", ansGbn);
		
		String getRole = SrService.getRole(h);
			
		if(ROLE.contains(getRole)){
			modyn = "Y";
		}
		
		h.put("addyn", "N");
		List history = SrService.getStatus(h);
		
		model.addAttribute("history",history);
    	model.addAttribute("srno",srno);
    	model.addAttribute("btn",btn);
    	model.addAttribute("laststa",mainlast_map.get("laststa"));
    	model.addAttribute("type",mainlast_map.get("type"));
    	model.addAttribute("matchyn",matchyn);
    	model.addAttribute("modyn",modyn);
    	model.addAttribute("userid",mainlast_map.get("userid"));
    	model.addAttribute("tbname",mainlast_map.get("tbname"));
    	model.addAttribute("title",mainlast_map.get("title"));
    	model.addAttribute("accyn",mainlast_map.get("accyn"));
    	
    	model.addAttribute("srProcStep", SrService.selectSrProcStep());

    	log.debug("------->>>>>>> isModal : " + isModal);
    	if(isModal != null && isModal.equals("Y")) {
    		System.out.println("MOdal");
    		return "/dsdsm/dis/popSrViewL";
    	} else {
    		return "/dsdsm/sr/srViewL";
    	}
    }
    
    /**
	 * SR 상세 화면 각 모듈 로드
	 * 
	 * @param response
	 *            , request, defaultVO, model
	 * @return dsacc/pas/pasList
	 * @exception Exception
	 */                      
	@RequestMapping(value = "/sr/srViewGetDetail.do")
	public ModelAndView srViewGetDetail(@RequestParam HashMap<String, Object> map, HttpServletResponse response, HttpServletRequest request, HttpSession session) throws Exception {

    	log.debug("-----------------------------------------------");
    	log.debug("------- [[[ SrController.srViewGetDetail() ]]]");
    	log.debug("-----------------------------------------------");
    	
    	log.debug("------->>>>>>> map : " + map);
    	log.debug("------->>>>>>> map-status : " + map.get("status"));
    	log.debug("------->>>>>>> map-jobCd : " + map.get("jobcd"));
		ModelAndView mv = new ModelAndView();
		String status = (String) map.get("status");
		String jobCd = (String) map.get("jobcd");
		map.put("jobCd", jobCd);
		map.put("first","N");
		
		if(status.equals("110")){
			map.put("codeId", "SR1000");
			
			mv.addObject("USER_CODE", SrService.getUserCode(map));
	    	
			mv.addObject("fileList", SrService.selectAtchFileList(map));
		} else if(status.equals("120")) {
			map.put("codeId", "SR1100");
		} else if(status.equals("130")) {
			map.put("codeId", "SR1200");
		} else if(status.equals("140")) {
			map.put("codeId", "SR1300");
		} else if(status.equals("150")) {
			mv.addObject("fileList", SrService.selectAtchFileList(map));
		} else if(status.equals("160")) {
			map.put("codeId", "SR1400");
		} else if(status.equals("170")) {
			map.put("codeId", "SR1500");
		}  else if(status.equals("180")) {
			mv.addObject("fileList", SrService.selectAtchFileList(map));
		} else if(status.equals("100")) {
			
			mv.addObject("fileList", SrService.selectAtchFileList(map));
	    	
	    	map.put("first","Y");
	    	
	    	map.put("codeId", "DO1000");			
	    	mv.addObject("type",CmmService.getCmmDitcList(map));
			
			map.put("codeId", "SRRCTP");			
			mv.addObject("rctype",CmmService.getCmmDitcList(map));

			map.put("codeId", "SR2000");			
			mv.addObject("openYn", CmmService.getCmmDitcList(map));
			
			map.put("codeId", "LN1100");
			
	    	@SuppressWarnings("rawtypes")
			List jobCds = codeService.getJobCdList();	    	
	    	ObjectMapper mapper = new ObjectMapper();
	   		String jobCdsJsonStr = mapper.writeValueAsString(jobCds);	   		
	   		mv.addObject("JOB_LIST", jobCdsJsonStr);				
		}
    	
		mv.addObject("srgbn", CmmService.getCmmDitcList(map));
		
		map.put("codeId", "SRSTAT");
		map.put("code", status);
		
		mv.addObject("steptitle",CmmService.getCmmDitcList(map));

		String ansStep = "";
		String ansGbn = "";
		map.put("sdgbn", "SR");	 
 
		if(status.equals("180")){ 
			//EgovMap mainlast = (EgovMap)SrService.getLaststa(map);
			List mainlast = SrService.getLaststa(map);
 
	    	EgovMap mainlast_map = (EgovMap)mainlast.get(0);
	    	ansStep = (String) mainlast_map.get("prevstep");			
			//ansStep = (String) mainlast.get(0).get("prevstep"); 
			if("110".equals(ansStep)){
	    		ansGbn = "002";
			} else {
				ansGbn = "001";
			} 
		}
		
		map.put("ansGbn", ansGbn);
		
		mv.addAllObjects(map);
		mv.addObject("list",SrService.getSRdetail(map));
		
		mv.setViewName((String) map.get("pageurl"));
		return mv;
	}
    
    /**
     * S/R 등록
     * @throws Exception 
     */
    @RequestMapping(value="/sr/srEdit.json")
    public String edit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	System.out.println("SR 등록 시작");

    	String _atchFileId = "";
		_atchFileId = disFileMng.fileUpload("SRRQ_",request);
		param.put("disAddFileId", _atchFileId);	 
		
    	int getno = 0;
    	String srno = ""; 
    			 
    	getno = SrService.getSrno(param);
    	srno = String.format("%04d", getno);
    		
    	srno = "SR" + DateUtil.toYYYYMMDDDate(DateUtil.getDate()) + srno;   
    	
    	param.put("srno",srno);
    	param.put("seq","1");
    	param.put("sta","100");
    	
    	if("Y".equals(param.get("openynd"))){
    		param.put("openyn", "N");
    	}else {
    		param.put("type", "000");
    	}
    	
    	Map<String, Object> result1 = SrService.regSrmain(param);
    	Map<String, Object> result2 = SrService.regHistory(param);
    	
    	map.put("result1", result1);
    	map.put("result2", result2);
    	map.put("srno",srno);
    	
    	return "jsonView";
    }
    
    /**
     * S/R등록화면으로 들어간다.
     * @throws Exception 
     */
    @RequestMapping(value="/sr/srList.do")
    public String SRlist(HttpServletRequest request, Model model) throws Exception {
    	
		HashMap<Object, Object> map = new HashMap<Object, Object>();
    	map.put("codeId", "SRSTAT");
		model.addAttribute("srStat", CmmService.getCmmDitcList(map));
/*		map.put("codeId", "LN1100");
		model.addAttribute("srgbn", CmmService.getCmmDitcList(map));*/
		model.addAttribute("statVal", request.getParameter("statVal"));
		model.addAttribute("sdate", request.getParameter("sdate"));
		model.addAttribute("edate", request.getParameter("edate"));
		model.addAttribute("sta", request.getParameter("sta"));
		model.addAttribute("returnYn", request.getParameter("returnYn"));
		
    	@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();	    	
    	ObjectMapper mapper1 = new ObjectMapper();
   		String jobCdsJsonStr = mapper1.writeValueAsString(jobCds);   		
		
   		//map.put("JOB_LIST", jobCdsJsonStr);
		model.addAttribute("JOB_LIST", jobCdsJsonStr);
		
    	return "/dsdsm/sr/srListL";
    }
    
    /**
     * S/R 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/sr/getList.do")
	public String getList(@RequestParam(value="jobCd",required=false) String[] jobCd,@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {
			
		param.put("jobCd",jobCd);
		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		int listCount = SrService.getListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = SrService.getList(param);
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}
	
	 /**
     * S/R 다음단계로
     * @throws Exception 
     */
    @SuppressWarnings("unchecked")
	@RequestMapping(value="/sr/srStep.json")
    public String step(HttpServletRequest request,ModelMap map) throws Exception {
    	
    	System.out.println(123123);
    	
    	HashMap<Object, Object> h = new HashMap<Object, Object>();
    	
    	String curr = request.getParameter("sta");
    	String srno = request.getParameter("srno");
    	String gbn = request.getParameter("gbn");
    	String accyn = request.getParameter("accyn");
    	String userid = request.getParameter("userId");
    	String type = request.getParameter("type");
    	
    	if(gbn == null || "".equals(gbn)){
    		gbn = "000/0";
    	}
    	
    	String[] spGbn = gbn.split("/");
    	
    	@SuppressWarnings("rawtypes")
		ArrayList list = new ArrayList();
    	
    	list.add(0, srno);
    	
    	h.put("srno", list);

    	h.put("userid", userid);
    	
    	if(accyn.equals("N")){
    		SrService.updateAccept(h);
    	}
    	
    	if(curr.equals("100")){
    		spGbn[0] = "000";
    		spGbn[1] = "0";
    	}
    	
    	String returnYn = "N";
    	
    	if(spGbn[1].contains("반려")){
    		returnYn = "Y";
    	}
    	
    	List<EgovMap> next = CmmService.getNextstep("SR",curr,spGbn[0]);
    	
    	h.put("srno", srno);
    	
    	String nextStep = "";
		nextStep = (String) next.get(0).get("next");
    	
    	h.put("next", nextStep);
    	h.put("sta", curr);
    	h.put("returnYn", returnYn);

    	System.out.println("단계★★★★ " + h.get("userid"));
    	if(!"000".equals(type) && "100".equals(curr)){
    		h.put("next", "130");
    	}
    	
    	if("180".equals(nextStep) && !"000".equals(type)){
    		h.put("next", "000");
    	}
    	
    	SrService.updateLaststa(h);
    	SrService.updateSrReturnYn(h);
    	
    	System.out.println("끝");
    	
    	if(!curr.equals("100")){    	
    		temp(request,"STEP",map,curr);
    	} else {
        	SrService.updateHistory(h);
    	}
    	
    	map.put("result", "SUCCESS");
    	
    	return "jsonView";
    }
    
    /**
     * S/R 리스트 일괄 접수
     * @throws Exception 
     */
    @RequestMapping(value="/sr/srAccept.json")
    public String SRaccept(HttpSession session,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	String[] acceptList = request.getParameterValues("acceptList");
    	
    	HashMap<Object, Object> h = new HashMap<Object, Object>();
    	Map userInfo = (Map)session.getAttribute("userInfo");
    	
    	h.put("srno",acceptList);
    	h.put("userid",userInfo.get("userId"));
    	
    	Map<String, Object> result = SrService.updateAccept(h);
    	
    	h.put("next", "110");
    	
    	for(int i=0;i<acceptList.length;i++){
    		h.put("srno", acceptList[i]);
    		
    		SrService.updateLaststa(h);
    	}
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    /**
     * S/R 저장
     * @throws Exception 
     */
    @SuppressWarnings("unchecked")
	@RequestMapping(value="/sr/srSave.json")
    public String temp(HttpServletRequest request,String step,ModelMap map,String curr) throws Exception {
    	
    	 HashMap<Object, Object> h = new HashMap<Object, Object>();
    	 Enumeration<?> enums = request.getParameterNames();
    	  
    	 while(enums.hasMoreElements()){
    	   String paramName = (String)enums.nextElement();
    	   String[] parameters = request.getParameterValues(paramName);
    	   
    	   // Parameter가 배열일 경우
    	   if(parameters.length > 1){
    	    h.put(paramName, parameters);
    	   // Parameter가 배열이 아닌 경우
    	   } else {
    	    h.put(paramName, parameters[0]);
    	   }
    	 }    	 	 
    	 
    	String[] spGbn = ((String) h.get("gbn")).split("/");
    	h.put("gbn", spGbn[0]);
    	
    	HttpSession session = request.getSession(false);
    	Map userInfo = (Map)session.getAttribute("userInfo");
    	
    	disFileMng.fileDelete(request);
    	
    	String _atchFileId = "";
 		_atchFileId = disFileMng.fileUpload("SRRQ_",request);
 		
 		if (_atchFileId != null) {
 			h.put("disAddFileId", _atchFileId);
		}
 		
    	h.put("userid", userInfo.get("userId"));
    	h.put("returnYn", "N");
    	int seq = SrService.getSrseq(h); 
    	
    	String status = "";
    	if(curr == null || "".equals(curr)){
    		status = (String) h.get("sta");
    	} else {
    		status = curr;
    	}
    	
    	String receiptYn = SrService.getReceiptYn(h); 
    	
    	if("100".equals(status) && "Y".equals(receiptYn)){
    		map.put("message", true);
    	} else {
    	
		    if("110".equals(status)){
		    	SrService.updateSrDeptId(h);
		    }
	    	
	    	if(h.get("matchyn").equals("N")){
	    		System.out.println("등록");
	    		h.put("seq", seq);
	    		
	    		SrService.regHistory(h);
		    	SrService.insertContent(h);
		    	
		    	if(!"STEP".equals(step)){
		    		SrService.updateSrReturnYn(h);
		    	}
		    } else {
		    	System.out.println("수정");
		    	SrService.updateContent(h);
		    }
	    	
	    	SrService.updateHistory(h);
	    	
	    	map.put("result", "SUCCESS");
	    	
    	}
    	
    	return "jsonView";
    }
    
    
    /**
     * S/R 프로세스 config
	 * @throws Exception 
     */
    @RequestMapping(value="/sr/srProcessConfig.do")
    public String srProcessConfig(HttpServletRequest request, Model model, @RequestParam Map<String, Object> param) throws Exception {
    	return "/dsdsm/sr/srProcessConfig";
    }
    /**
     * S/R 프로세스 addPage
	 * @throws Exception 
     */
    @RequestMapping(value="/sr/addSrPage.do")
    public String addSrPage(HttpServletRequest request, Model model,  @RequestParam Map<String, Object> param) throws Exception {
    	String processId = StrUtil.nvl( (String)param.get("processId"),"1");
    	
    	
    	System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
    	System.out.println(processId+"  :  "+(String)param.get("processName"));
    	System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
    	
    	String processName = StrUtil.nvl( (String)param.get("processName") ,"" );
    	
    	System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
    	System.out.println(processId+"  :  "+processName);
    	System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
    	
    	model.addAttribute("processId"   , processId);
    	model.addAttribute("processName" , processName);
    	return "/dsdsm/sr/srAddPage";
    }
    /**
     * S/R 프로세스 userAddForm
	 * @throws Exception 
     */
    @RequestMapping(value="/sr/userAddForm.do")
    public String userAddForm(HttpServletRequest request, Model model, @RequestParam Map<String, Object> param) throws Exception {
    	String processId = StrUtil.nvl( (String)param.get("processId"),"1");
    	model.addAttribute("processId"   , processId);
    	model.addAttribute("command"     , "addForm");
    	return "/dsdsm/sr/srUserAddForm";
    }
    
    
    /**
     * S/R 프로세스 userDetailForm
	 * @throws Exception 
     */
    @RequestMapping(value="/sr/userDetailForm.do")
    public String userDetailForm(HttpServletRequest request, Model model, @RequestParam Map<String, Object> param) throws Exception {
    	String processId = StrUtil.nvl( (String)param.get("processId"),"1");
    	model.addAttribute("processId"   , processId);
    	model.addAttribute("command"     , "detail");
    	model.addAttribute("srNo"        , (String)param.get("srNo"));
    	return "/dsdsm/sr/srUserAddForm";
    }
    
    /**
     * S/R 프로세스 userAddForm
	 * @throws Exception 
     */
    @RequestMapping(value="/sr/insertProcessDetail.do")
    public String insertProcessDetail(HttpServletRequest request,  Model model, ModelMap modelmap, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
		ArrayList roloes = (ArrayList)session.getAttribute("ROLES");
		
		boolean roleExist = true;
		/*
		boolean roleExist = false;
		
		for(Object role: roloes){
			if(   ((String)role).equals("SYSMANAGER")   ){
				roleExist = true;
				break;
			}
		}
		*/
		
		param.put("businessId", userInfos.get("businessId"));
		
		System.out.println("########################## Param Start ###############################");
		Set s = param.keySet();
		Iterator info = s.iterator();
		
		JSONArray josnList = new JSONArray();
		
		
		while(info.hasNext()){
			String key =(String)info.next();
			System.out.println( "["+key+"] : "+ param.get(key) );
			
			
			if(!key.equals("sqlGbn") && !key.equals("businessId") && !key.equals("processId") && !key.equals("srNo") ) {
				JSONObject jsonOjb = new JSONObject();
				jsonOjb.put("frmDataId", key);
				jsonOjb.put("frmDataVal", param.get(key));
				
				josnList.add(jsonOjb);
			}
			
		}
		System.out.println("########################## Param End   ###############################");
		
		if( ((String)param.get("processId")).equals("1")){
			String srNo = ""; 
	    	int getno = SrService.getSrno((HashMap)param);
	    	srNo = String.format("%04d", getno);
	    	srNo = "SR" + DateUtil.toYYYYMMDDDate(DateUtil.getDate()) + srNo;
	    	param.put("srNo", srNo);
		}
		

		param.put("JsonList", josnList);
		System.out.println(josnList.toJSONString());
		
		//JSONArray lstJson = null;
	    // if(jsonStr != null && !jsonStr.equals("")){
		//      
		//      try {
		//          Object obj = JSONValue.parseWithException(jsonStr);
		//          lstJson = (JSONArray)obj;
		//	
		//      } catch (Exception e) {
		//       e.printStackTrace();
		//      }
	    // }
	     
		
		if( roleExist  ){
			int cnt = CmmService.updateData((HashMap)param);
			modelmap.put("result","ok");
			//modelmap.put("cnt",cnt);
		}else{
			modelmap.put("result", "warning");
			modelmap.put("warningMsg","작성자, 수정권한이 있는 사람만 가능합니다.");
		}
		//proService.deleteLastHis((HashMap)param);
	    
	    //modelmap.put("owner", (String)reqMap.get("owner"));
	    //modelmap.put("tableNm", (String)reqMap.get("tableNm"));
	
		
		return "jsonView";
    }
    
    /**
     * S/R 프로세스 userAddForm
	 * @throws Exception 
     */
    @RequestMapping(value="/sr/selectServiceRequest.do")
    public String selectServiceRequest(HttpServletRequest request, Model model, @RequestParam Map<String, Object> param, HttpSession session) throws Exception {
		Map userInfos = (Map)session.getAttribute("userInfo");
		param.put("businessId", userInfos.get("businessId"));
    	String processId = StrUtil.nvl( (String)param.get("processId"),"1");
    	
    	return "/dsdsm/sr/srNewList";
    }
    
    
    private JSONArray toJson(String jsonStr){
		System.out.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
		System.out.println(jsonStr);
		System.out.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
	     JSONArray lstJson = null;
	     if(jsonStr != null && !jsonStr.equals("")){
		      
		      try {
	
		          Object obj = JSONValue.parseWithException(jsonStr);
		          lstJson = (JSONArray)obj;
	
		      } catch (Exception e) {
		       e.printStackTrace();
		      }
	     }
		
		return  lstJson;
    }
    
    
	@RequestMapping(value="/sr/selectServiceRequerData.do")
	public String selectServiceRequerData(HttpSession session, ModelMap model, @RequestParam Map<String,Object> param) throws Exception{
		
		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		int pageNo   = Integer.parseInt((String)param.get("pageNo"));
		System.out.println((String)param.get("pageNo"));;
		int pageSize = Integer.parseInt((String)param.get("pageSize"));
		System.out.println((String)param.get("pageSize"));;
		
		Map userInfos = (Map)session.getAttribute("userInfo");
		param.put("businessId", userInfos.get("businessId"));
		
		int listCount = CmmService.selectCmmJsonListCnt(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end"  , (int) pageNo*pageSize);
		param.put("listCount",listCount);
				
		
		System.out.println((pageNo-1)*pageSize+1);
		System.out.println(pageNo*pageSize);
		
		
		List list = CmmService.selectCmmJsonList(param);
		
		List newList = new ArrayList();
		EgovMap reMap = new EgovMap();
		
		int rowNum = 0;
		for(int i=0;i<list.size();i++){
			
			EgovMap map = (EgovMap)list.get(i); 
			
			
			Long cnt =  (Long)map.get("cnt");
			
			if( i%cnt==0){
				reMap = new EgovMap();
			}
			
			String srNo = (String)map.get("srNo");
			
			reMap.put("rowNum"   , rowNum);
			reMap.put("srNo"     , srNo);
			reMap.put("regDttm"  , (String)map.get("regDttm"));
			reMap.put((String)map.get("frmDataId"), (String)map.get("frmDataVal"));
			
			if(i%cnt==0){
				newList.add(reMap);
				rowNum++;
			}
		}
		
		System.out.println(newList);
		
		
		
 	  	model.put("list",newList);
 	  	model.put("page",pageinMap);
		return "jsonView";
	}
	
	
	@RequestMapping(value="/sr/selectServiceRequerDetail.do")
	public String selectServiceRequerDetail(HttpSession session, ModelMap model, @RequestParam Map<String,Object> param) throws Exception{
		
		Map userInfos = (Map)session.getAttribute("userInfo");
		param.put("businessId", userInfos.get("businessId"));
		
		List list = CmmService.selectCmmJsonList(param);
		List newList = new ArrayList();
		EgovMap reMap = new EgovMap();
		
		for(int i=0;i<list.size();i++){
			EgovMap map = (EgovMap)list.get(i); 
			String srNo = (String)map.get("srNo");
			reMap.put("srNo"     , srNo);
			reMap.put("regDttm"  , (String)map.get("regDttm"));
			reMap.put((String)map.get("frmDataId"), (String)map.get("frmDataVal"));
			
		}
		newList.add(reMap);
		System.out.println(newList);
		
 	  	model.put("list",newList);
		return "jsonView";
	}
}
