package egovframework.rte.dsdsm.stats.dis.web;

import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Date;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import com.ibm.icu.text.SimpleDateFormat;

import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovFileMngService;
import egovframework.rte.cmmn.util.EgovFileMngUtil;
import egovframework.rte.cmmn.vo.FileVO;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.service.vo.SearchVO;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.stats.dis.service.StatsDisService;

@Controller
public class StatsDisController {
	
	@Resource(name = "StatsDisService")
    private StatsDisService StatsDisService;
	
	@Resource(name = "CmmService")
    private CmmService CmmService; 
	
	/**
     * 통계 - 총괄표 화면으로 들어간다.
	 * @throws Exception 
     */
    @RequestMapping(value="/stats/disStats.do")
    public String disStats(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model) throws Exception {
    	
    	Date d = new Date();
    	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    	String date = sdf.format(d);
    	
    	if(param.get("sdate") == null || "undefined".equals(param.get("sdate"))){
    		param.put("sdate", date);
    	}
    	
    	if(param.get("edate") == null || "undefined".equals(param.get("edate"))){
    		param.put("edate", date);
    	}

    	List<HashMap> disSummary = StatsDisService.getDisSummary(param);
    	List<HashMap> disProcDept = StatsDisService.getDisProcByDept(param);
    	List<HashMap> disProcType = StatsDisService.getDisProcByType(param);
    	List<HashMap> disProcJob = StatsDisService.getDisProcByJob(param);
    	List<HashMap> disProcSrRc = StatsDisService.getDisProcBySrRc(param);
    	
    	
    	
    	/****/
    	List grdList  = StatsDisService.getDisProcByDeptList(param);
    	List grdList2 = StatsDisService.getDisProcByTypeList(param);
    	List grdList3 = StatsDisService.getDisProcByJobList(param);
    	List grdList4 = StatsDisService.getDisProcBySrRcList(param);
    	
    	 
    	
    	model.addAttribute("disSummary", disSummary);
    	model.addAttribute("disProcDept", disProcDept);
    	model.addAttribute("disProcType", disProcType);
    	model.addAttribute("disProcJob", disProcJob);
    	model.addAttribute("disProcSrRc", disProcSrRc);
    	
    	model.addAttribute("grdList", grdList);
    	model.addAttribute("grdList2", grdList2);
    	model.addAttribute("grdList3", grdList3);
    	model.addAttribute("grdList4", grdList4);
    	
    	
    	
    	model.addAttribute("sdate", param.get("sdate"));
    	model.addAttribute("edate", param.get("edate"));
    	model.addAttribute("gubun", param.get("gubun"));
    	
    	return "/dsdsm/stats/disStats";
    }
}
