package egovframework.rte.dsdsm.stats.sr.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import egovframework.rte.psl.dataaccess.util.EgovMap;

public interface StatsSrService {
	
	/**
	 * S/R 현황
	 * @return List
	 * @exception Exception 
	*/
	public List<HashMap> getSrCondition(HashMap h) throws Exception;
	
	/**
	 * S/R 부서별 처리율
	 * @return List
	 * @exception Exception 
	*/
	public List<HashMap> srDeptProcPer(HashMap h) throws Exception;
	
	/**
	 * S/R 유형별 처리율
	 * @return List
	 * @exception Exception 
	*/
	public List<HashMap> srTypePer(HashMap h) throws Exception;
	
	/**
	 * S/R 업무별 처리율
	 * @return List
	 * @exception Exception 
	*/
	public List<HashMap> srJobPer(HashMap h) throws Exception;
	
	/**
	 * S/R 접수유형별 처리율
	 * @return List
	 * @exception Exception 
	*/
	public List<HashMap> srRcTypePer(HashMap h) throws Exception;
	
	
	
//******************************************************************************//	
	
	
	/**
	 * S/R 접수유형별 처리율
	 * @return List
	 * @exception Exception 
	*/
	public List<HashMap> grdList(HashMap h) throws Exception;
	
	
	
	/**
	 * S/R 접수유형별 처리율
	 * @return List
	 * @exception Exception 
	*/
	public List<HashMap> srJobPerList(HashMap h) throws Exception;
	
	
	/**
	 * S/R 접수유형별 처리율
	 * @return List
	 * @exception Exception 
	*/
	public List<HashMap> srRcTypePerList(HashMap h) throws Exception;
	

	
	
	
	
	
}