package egovframework.rte.dsdsm.stats.sr.web;

import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Date;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import com.ibm.icu.text.SimpleDateFormat;

import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovFileMngService;
import egovframework.rte.cmmn.util.EgovFileMngUtil;
import egovframework.rte.cmmn.vo.FileVO;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmm.service.vo.SearchVO;
import egovframework.rte.dsdsm.cmm.util.DisFileMng;
import egovframework.rte.dsdsm.stats.sr.service.StatsSrService;

@Controller
public class StatsSrController {
	
	@Resource(name = "StatsSrService")
    private StatsSrService StatsSrService;
	
	@Resource(name = "CmmService")
    private CmmService CmmService; 
	
	/**
     * 통계 - 총괄표 화면으로 들어간다.
	 * @throws Exception 
     */
    @RequestMapping(value="/stats/srStats.do")
    public String totalStats(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model) throws Exception {
    	
    	Date d = new Date();
    	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    	String date = sdf.format(d);
    	
    	if(param.get("sdate") == null || "undefined".equals(param.get("sdate"))){
    		param.put("sdate", date);
    	}
    	
    	if(param.get("edate") == null || "undefined".equals(param.get("edate"))){
    		param.put("edate", date);
    	}
    	
    	List<HashMap> srCondition = StatsSrService.getSrCondition(param);
    	List<HashMap> srDeptProcPer = StatsSrService.srDeptProcPer(param);
    	List<HashMap> srTypePer = StatsSrService.srTypePer(param);
    	List<HashMap> srJobPer = StatsSrService.srJobPer(param);
    	List<HashMap> srRcTypePer = StatsSrService.srRcTypePer(param);
    	
    	/****/
    	List grdList = StatsSrService.grdList(param);
    	List grdList2 = StatsSrService.srJobPerList(param);
    	List grdList3 = StatsSrService.srRcTypePerList(param);
    	
    	model.addAttribute("srCondition", srCondition);
    	model.addAttribute("srDeptProcPer", srDeptProcPer);
    	model.addAttribute("srTypePer", srTypePer);
    	model.addAttribute("srJobPer", srJobPer);
    	model.addAttribute("srRcTypePer", srRcTypePer);
    	model.addAttribute("grdList", grdList);
    	model.addAttribute("grdList2", grdList2);
    	model.addAttribute("grdList3", grdList3);
    	model.addAttribute("sdate", param.get("sdate"));
    	model.addAttribute("edate", param.get("edate"));
    	model.addAttribute("gubun", param.get("gubun"));
    	model.addAttribute("form", param.get("form"));
    	
    	return "/dsdsm/stats/srStats";
    }
}
