package egovframework.rte.dsdsm.step.web;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import egovframework.rte.cmmn.helper.JsonView;
import egovframework.rte.dsdsm.step.service.StepService;
import egovframework.rte.dsdsm.step.vo.StepVO;

@Controller
public class StepController {
	
	@Resource(name="StepService")
	private StepService stepService;	
	
	/**
     * 업무 단계관리 화면으로 들어간다.
     * @throws Exception 
     */
    @RequestMapping(value="/step/stepList.do")
    public String stepList(HttpServletRequest request, Model model) throws Exception {
    	String tabValue = request.getParameter("tabValue");
    	if("".equals(tabValue) || tabValue == null) tabValue = "sr";
    	model.addAttribute("tabValue", tabValue);
    	return "/dsdsm/step/stepList";
    }
    
	@RequestMapping(value = "/step/getStepList.do")
	public ModelAndView getStepList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
		ModelAndView mv = new ModelAndView();
		HashMap<Object, Object> map = new HashMap<Object, Object>();
		String stepGbn = request.getParameter("stepGbn");
		map.put("stepGbn", stepGbn);
		
		List list = stepService.selectStepList(map);
		
		model.addAttribute("list",list);

        mv.setView(new JsonView());
		return mv;
	}		
	
	/**
     * 단계 변경
     * @throws Exception 
     */
    @RequestMapping(value="/step/stepEdit.json")
    public String stepEdit(StepVO stepVO,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = stepService.stepEdit(stepVO);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
}
