package egovframework.rte.dsdsm.taam.web;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFDataFormat;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.ibm.icu.text.SimpleDateFormat;

import egovframework.rte.cmmn.helper.JsonView;
import ch.qos.logback.core.net.SyslogOutputStream;

import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.taam.service.taamService;


import egovframework.rte.dsdsm.cmmcheck.util.ParamInfoUtil;
import egovframework.rte.cmmn.util.StringUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;


/** Time and attendance management **/
@Controller
public class taamController {
	
	@Resource(name="ParamInfoUtil")
	private  ParamInfoUtil paramInfoUtil;
	
	@Resource(name="StringUtil")
	private  StringUtil StringUtil;
	
	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
	
	@Resource(name ="CodeService")
	private CodeService codeService;
	
	@Resource(name = "taamService")
    private taamService taamService;
	
	private Logger log = LogManager.getLogger();
	
	
	/**
     * 사업 리스트
	 * @throws Exception 
     */
    @RequestMapping(value="/taam/taamList.do")
    public String taamList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	return "/dsdsm/taam/taamList";
    }
    
    
    /**
     * 과업정보 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/taam/getTaamList.do")
	public String getTaamList(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		
    	//paramInfoUtil.mpaInfo_print(param);
		
		int listCount = taamService.getTaamListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = taamService.getTaamList(param);	
		
		//log.debug(list.toString());
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}  	
	
	
    @RequestMapping(value="/taam/downExcel.json")
    public void downGantt(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session, HttpServletResponse response) throws Exception {
    	
    	log.debug("				 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> downGantt");
    	excelDown(param, request, response);
    	
    	
       //return "OK";
    }
    
/****/    
    
    @SuppressWarnings("static-access")
	public void excelDown(@RequestParam HashMap<Object,Object> param, HttpServletRequest request, HttpServletResponse response) throws Exception {
 	   
       log.debug(":::::::::: excelDown");
    	
 	   Date d = new Date();
 	   SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HHmmss");
 	   String dates = sdf.format(d);
        
 	   String projectId     = "";
 	   
 	   param.put("start", (int)1);
 	   param.put("end", (int)999);
 	   
 	   HashMap<Object, Object> chgPrm = new HashMap<Object, Object>();
 	   String usrName = (String)param.get("usrName");
 	   String usrDept = (String)param.get("usrDept");
 	   String sdate   = (String)param.get("sdate");
 	   String edate  = (String)param.get("edate");

 	   chgPrm.put("usrName", usrName);
 	   chgPrm.put("usrDept", usrDept);
 	   chgPrm.put("sdate",   sdate);
 	   chgPrm.put("edate",   edate);
 	   chgPrm.put("start", (int)1);
 	   chgPrm.put("end", (int)999);
 	   
	
 	   List list = taamService.getTaamList(chgPrm);
	   
	   //paramInfoUtil.mpaInfo_print(chgPrm);
	   //log.debug(list);
 	   
 	   //String fileNm = "C:/dev/"+projectId+"Excel_"+dates+".xls";
 	   String fileNm = ""+projectId+"Excel_"+dates+".xls";
 	   
 	   // 엑셀파일(샘플파일 위치)
 	   String storePathString = EgovProperties.getProperty("Globals.fileGanttPath");

 	   // Workbook 생성
 	   HSSFWorkbook  workbook = new HSSFWorkbook(); // Excel 2007 이전 버전 	   
 	   

// *** Sheet-------------------------------------------------
        // Sheet 생성
        HSSFSheet sheet1 = workbook.createSheet("근태현황");
        
        // Data Format
        HSSFDataFormat df = workbook.createDataFormat();
        
        //스타일 객체 생성
        //HSSFCellStyle styleCon 			  = workbook.createCellStyle(); //  내용 스타일
        HSSFCellStyle styleConRight       = workbook.createCellStyle(); // 내용 스타일
        HSSFCellStyle styleConRightNum 	  = workbook.createCellStyle(); // 내용 스타일 : 숫자 타입
        //HSSFCellStyle styleSumConRightNum = workbook.createCellStyle(); // 내용 스타일 : 숫자 타입
        
        //styleConRight.cloneStyleFrom(styleCon);
        styleConRight.setAlignment(HSSFCellStyle.ALIGN_RIGHT);
        styleConRightNum.cloneStyleFrom(styleConRight);
        //styleConRightNum.setDataFormat(df.getFormat("#,##0"));
     
        Row row = null;
        Cell cell = null;
        //----------------------------------------------------------
         
        // 첫 번째 줄
        row = sheet1.createRow(0);
         
        // 첫 번째 줄에 Cell 설정하기-------------
         
        cell = row.createCell(1);
        cell.setCellValue("번호");
        
        cell = row.createCell(2);
        cell.setCellValue("성명");        

        cell = row.createCell(3);
        cell.setCellValue("부서");

        
        cell = row.createCell(4);
        cell.setCellValue("회의");

        
        cell = row.createCell(5);
        cell.setCellValue("출장");

        
        cell = row.createCell(6);
        cell.setCellValue("연차");

        
        cell = row.createCell(7);
        cell.setCellValue("반차");

        
        cell = row.createCell(8);
        cell.setCellValue("병가");
        
        cell = row.createCell(9);
        cell.setCellValue("공가");


        // 두 번째 줄에 Cell 설정하기-------------
        int rowIdx = 0;
        int sumNum = 2;

        //log.debug(">>> [arrayDepends]"+arrayDepends.length);
        for(int i=0;i<list.size();i++){
        	
        	@SuppressWarnings("unchecked")
            Map<Object,Object> listData = (Map<Object, Object>) list.get(i);
            row = sheet1.createRow(++rowIdx); 
            
	        cell = row.createCell(1);
	        cell.setCellValue((String)listData.get("sno").toString());
	        
	        cell = row.createCell(2);
     	    cell.setCellValue((String)listData.get("usrNm"));
     	    
	        cell = row.createCell(3);
	        cell.setCellValue((String)listData.get("usrDeptnm"));  
	        
 	        cell = row.createCell(4);
	        cell.setCellType(cell.CELL_TYPE_NUMERIC);
	        cell.setCellValue((long)listData.get("hw1"));
	        cell.setCellStyle(styleConRightNum);
	        
	        cell = row.createCell(5);
	        cell.setCellType(cell.CELL_TYPE_NUMERIC);	        
	        cell.setCellValue((long)listData.get("cj1"));	        
	        cell.setCellStyle(styleConRightNum);
	        
	        cell = row.createCell(6);
	        cell.setCellType(cell.CELL_TYPE_NUMERIC);	        
	        cell.setCellValue((long)listData.get("yg1"));
	        cell.setCellStyle(styleConRightNum);
	        
	        cell = row.createCell(7);
	        cell.setCellType(cell.CELL_TYPE_NUMERIC);	        
	        cell.setCellValue((long)listData.get("bk1"));
	        cell.setCellStyle(styleConRightNum);
	        
	        cell = row.createCell(8);
	        cell.setCellType(cell.CELL_TYPE_NUMERIC);
	        cell.setCellValue((long)listData.get("bg1"));	        
	        cell.setCellStyle(styleConRightNum);
	        
	        cell = row.createCell(9);
	        cell.setCellType(cell.CELL_TYPE_NUMERIC);
	        cell.setCellValue((long)listData.get("gg1"));
	        cell.setCellStyle(styleConRightNum);
	        
	        
	        sumNum++;
        }
        

        // excel 파일 저장
        try {
     	   response.setContentType("Application/Msexcel");
     	   response.setHeader("Content-Disposition", "ATTachment; Filename="+fileNm+".xls");
     	   OutputStream fileOut  = response.getOutputStream();
            workbook.write(fileOut);
            fileOut.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
         
    }	 
    

}
