package egovframework.rte.dsdsm.taskOrder.web;

import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.ibm.icu.text.SimpleDateFormat;

import egovframework.rte.cmmn.helper.JsonView;
import ch.qos.logback.core.net.SyslogOutputStream;

import egovframework.rte.cmmn.util.DateUtil;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.taskOrder.service.taskOrderService;


import egovframework.rte.dsdsm.cmmcheck.util.ParamInfoUtil;
import egovframework.rte.cmmn.util.StringUtil;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;



@Controller
public class taskOrderController {
	
	@Resource(name="ParamInfoUtil")
	private  ParamInfoUtil paramInfoUtil;
	
	@Resource(name="StringUtil")
	private  StringUtil stringUtil;
	
	@Resource(name = "taskOrderService")
    private taskOrderService taskOrderService;

	@Resource(name = "CmmService")
    private CmmService CmmService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
	
	@Resource(name ="CodeService")
	private CodeService codeService;	
	
	private Logger log = LogManager.getLogger();
	
	
	/**
     * 사업 리스트
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/businessList.do")
    public String businessList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	map.put("roleId", "MANAGER000");
		model.addAttribute("authority", CmmService.getAuthority(map));
		
		map.put("roleId", "SYSMANAGER");
		model.addAttribute("authority2", CmmService.getAuthority(map));
		
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0130030000000");
    	//Map checkInfoG = paramInfoUtil.dutyCode(session, "0130000000000");
    	
    	//String dutyCd      = (String)userInfos.get("dutyCd");
    	
//    	String dutyCd      = StringUtil.nullToEmpty((String)userInfos.get("dutyCd"));
//    	String lolCheck    = StringUtil.nullToEmpty((String)checkInfoG.get("lolId"));
    	String insertCheck = StringUtil.nullToEmpty((String)checkInfoG.get("insertYn"));
//    	String readCheck   = StringUtil.nullToEmpty((String)checkInfoG.get("readYn"));
    	String updateCheck = StringUtil.nullToEmpty((String)checkInfoG.get("updateYn"));
    	String deleteCheck = StringUtil.nullToEmpty((String)checkInfoG.get("deleteYn"));
		/*****/
		
    	model.addAttribute("insertCheck", insertCheck);
    	model.addAttribute("updateCheck", updateCheck);
    	model.addAttribute("deleteCheck", deleteCheck);
		
    	return "/dsdsm/taskOrder/business_List";
    }
    
    
    /**
     * 과업정보 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/taskOrder/getBusinessist.do")
	public String getBusinessist(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		
    	//paramInfoUtil.mpaInfo_print(param);
		
		int listCount = taskOrderService.getBusinessListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = taskOrderService.getBusinessList(param);	
		
		log.debug(list.toString());
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}       
	
    
    /**
     * 사업 등록화면 호출
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/businessReg.do")
    public String bnsReg(@RequestParam Map<String,String> param, ModelMap map, Model model) throws Exception {
    	
    	map.put("codeId", "BS0100");
		model.addAttribute("bnsGbn", CmmService.getCmmDitcList(map));
    	
    	return "/dsdsm/taskOrder/businessInfo_reg";
    	                         
    }	
    
    
    /**
     * 사업아이디 확인 부분
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/checkBusiness.json")
    public String checkBnsId(@RequestParam Map<String,String> param, ModelMap map) throws Exception {
    	
    	
    	Map<String, Object> result = taskOrderService.checkBusinessid(param);  
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
	/**
     * 사업 상세페이지
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/businessView.do")
    public String businessInfoView(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	log.debug("");
    	log.debug("------------------------------");
    	log.debug(param.get("businessnm"));

    	String word = (String)param.get("businessnm");

    	//paramInfoUtil.mpaInfo_print(param);
    	HashMap<Object, Object> map = new HashMap<Object, Object>();

    	//List list = taskOrderService.getBusinessTaskView(param);
    	List list = taskOrderService.getBusinessView(param);
		model.addAttribute("list",list);
		
    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
    	
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0130030000000");
    	
    	String dutyCd      = StringUtil.nullToEmpty((String)userInfos.get("dutyCd"));
    	String lolCheck    = StringUtil.nullToEmpty((String)checkInfoG.get("lolId"));
    	String insertCheck = StringUtil.nullToEmpty((String)checkInfoG.get("insertYn"));
    	String readCheck   = StringUtil.nullToEmpty((String)checkInfoG.get("readYn"));
    	String updateCheck = StringUtil.nullToEmpty((String)checkInfoG.get("updateYn"));
    	String deleteCheck = StringUtil.nullToEmpty((String)checkInfoG.get("deleteYn"));   		
		/*****/
		
    	model.addAttribute("insertCheck", insertCheck);
    	model.addAttribute("updateCheck", updateCheck);
    	model.addAttribute("deleteCheck", deleteCheck);
    	
    	
    	String returnValue = "";
   		returnValue = "/dsdsm/taskOrder/businessInfo_view";
   		
   		log.debug(returnValue);
    	
    	
    	return returnValue;    	
		
    }   
    
    
    
    /**
     * 사업정보 수정화면 
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/businessEdit.do")
    public String bnsEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model,HttpSession session) throws Exception {
    	
    	log.debug("/taskOrder/businessEdit.do");
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	//paramInfoUtil.mpaInfo_print(param);
    	
    	//String business_sno = (String)param.get("businessSno");
    	//map.put("bnsiness_sno", business_sno);
    	
    	map.put("codeId", "BS0100");
		model.addAttribute("bnsGbn", CmmService.getCmmDitcList(map));
		
    	List list = taskOrderService.getBusinessView(param);
		model.addAttribute("list",list);
		
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0130030000000");
    	
    	String dutyCd      = StringUtil.nullToEmpty((String)userInfos.get("dutyCd"));
    	String lolCheck    = StringUtil.nullToEmpty((String)checkInfoG.get("lolId"));
    	String insertCheck = StringUtil.nullToEmpty((String)checkInfoG.get("insertYn"));
    	String readCheck   = StringUtil.nullToEmpty((String)checkInfoG.get("readYn"));
    	String updateCheck = StringUtil.nullToEmpty((String)checkInfoG.get("updateYn"));
    	String deleteCheck = StringUtil.nullToEmpty((String)checkInfoG.get("deleteYn"));  		
		/*****/
		
		
    	String returnValue = "";
   		returnValue = "/dsdsm/taskOrder/businessInfo_edit"; 
    	model.addAttribute("regYn","");
    	
    	return returnValue;   		
    }
        
    
    
    /**
     * 사업 등록 및 수정
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/editBusiness.json")
    public String addBnsReg(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	log.debug(param.get("gbn"));
    	
    	paramInfoUtil.mpaInfo_print(param);
  	
    	if("S".equals(param.get("gbn"))){
    		result = taskOrderService.regBusiness(param);
    	} else if("U".equals(param.get("gbn"))){
    		result = taskOrderService.editBusiness(param);
    	} 
    	
    	map.put("result", result);
    	map.put("businessid", param.get("businessid"));    	
    	
    	return "jsonView";
    }	
    
    
    @RequestMapping(value="/taskOrder/delBusiness.json")
    public String delBusiness(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	paramInfoUtil.mpaInfo_print(param);
  	
    	result = taskOrderService.delBusiness(param);
    	
    	map.put("result", result);
    	map.put("businessid", param.get("businessid"));    	
    	
    	return "jsonView";
    }
    
    
	
/*****/
    
    /**
     * 사업관리 목록화면 팝업창.
     * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/bnsListPop.do")
    public String docListPop(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
    	
    	String regYn = "N";
    	String manageYn = "N";
    	
    	model.addAttribute("regYn",regYn);
    	model.addAttribute("manageYn",manageYn);
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
		map.put("popYn","Y");
		
        Iterator iter = map.entrySet().iterator();
 
        while (iter.hasNext()) {

            Map.Entry entry = (Map.Entry) iter.next();

            String strKey  =  (String) entry.getKey(); //이게 contant 일때
            String strValue = (String) entry.getValue(); //이부분을 잘라낼수도 있습니다.

            log.debug("--" + strKey + "--------->[" +  strValue + "]");

        }

    	return "/dsdsm/taskOrder/bnsListPop";
    }
    
    @RequestMapping(value="/taskOrder/getBRListPop.do")
    public String getBRListPop(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {
    	
    	log.debug("taskOrder/getBRListPop");
    	
		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		String  checkInfo =  (request.getParameter("checkPangInfo") != null) ? request.getParameter("checkPangInfo") : "";
		String  popYn =  (request.getParameter("popYn") != null) ? request.getParameter("popYn") : "";
		
	    log.debug("");
		log.debug(">>>>> param "+param.toString());
		log.debug("");
		
		
		int listCount = taskOrderService.getPopupListCount(param);	
		
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = taskOrderService.getPopupList(param);
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);    	
    	
    	
      return "jsonView";	
    } 
    
    
    /**
     * 산출물 목록화면 팝업창.
     * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/scmListPop.do")
    public String scmListPop(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
    	
    	String regYn = "N";
    	String manageYn = "N";
    	
    	model.addAttribute("regYn",regYn);
    	model.addAttribute("manageYn",manageYn);
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
		map.put("popYn","Y");
		
        Iterator iter = map.entrySet().iterator();
 
        while (iter.hasNext()) {

            Map.Entry entry = (Map.Entry) iter.next();

            String strKey  =  (String) entry.getKey(); //이게 contant 일때
            String strValue = (String) entry.getValue(); //이부분을 잘라낼수도 있습니다.

            log.debug("--" + strKey + "--------->[" +  strValue + "]");

        }

    	return "/dsdsm/taskOrder/scmListPop";
    }
    
    
    
    /**
     *  산출물 목록정보 
	 * @throws Exception 
     */    
    @RequestMapping(value="/taskOrder/getScmListPop.do")
    public String getScmListPop(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {
    	
    	log.debug("taskOrder/getScmListPop");
    	
		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		String  checkInfo =  (request.getParameter("checkPangInfo") != null) ? request.getParameter("checkPangInfo") : "";
		String  popYn =  (request.getParameter("popYn") != null) ? request.getParameter("popYn") : "";
		
	    log.debug("");
		log.debug(">>>>> param "+param.toString());
		log.debug("");
		

		int listCount = 10; //taskOrderService.getPtListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = taskOrderService.getScmList(param);
		
		//log.debug(list.toString());
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);    	
    	
    	
      return "jsonView";	
    }      
    
    
    
    /**
     * 사업상세 페이지(POP)
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/viewBusiness.do")
    public String viewBusiness(@RequestParam HashMap<Object,Object> param, Model model) throws Exception {
    	
    	//paramInfoUtil.mpaInfo_print(param);
    	
    	List list = taskOrderService.getBusinessView(param);	
 	  	model.addAttribute("list",list);
    	
    	return "/dsdsm/taskOrder/businessEdit";
    }    
    
    
    /**
     * Project Task 목록화면 팝업창.
     * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/projectListPop.do")
    public String projectListPop(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
		map.put("popYn","Y");
		
        Iterator iter = map.entrySet().iterator();
 
        while (iter.hasNext()) {

            Map.Entry entry = (Map.Entry) iter.next();

            String strKey  =  (String) entry.getKey(); //이게 contant 일때
            String strValue = (String) entry.getValue(); //이부분을 잘라낼수도 있습니다.

            log.debug("--" + strKey + "--------->[" +  strValue + "]");

        }

    	return "/dsdsm/taskOrder/projectListPop";
    }   
    
    
    /**
     *  Project Task 목록 정보 
	 * @throws Exception 
     */    
    @RequestMapping(value="/taskOrder/getPtListPop.do")
    public String getPtListPop(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {
    	
    	log.debug("taskOrder/getPtListPop");
    	
		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		String  checkInfo =  (request.getParameter("checkPangInfo") != null) ? request.getParameter("checkPangInfo") : "";
		String  popYn =  (request.getParameter("popYn") != null) ? request.getParameter("popYn") : "";
		
	    log.debug("");
		log.debug(">>>>> param "+param.toString());
		log.debug("");
		

		int listCount = 10; //taskOrderService.getPtListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = taskOrderService.getPtList(param);
		
		//log.debug(list.toString());
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);    	
    	
    	
      return "jsonView";	
    }     
    
    
    /**
     * 요구사항  목록 정보(Popup)
     * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/taskOrderListPop.do")
    public String taskOrderListPop(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
		map.put("popYn","Y");
		
        Iterator iter = map.entrySet().iterator();
 
        while (iter.hasNext()) {

            Map.Entry entry = (Map.Entry) iter.next();

            String strKey  =  (String) entry.getKey(); //이게 contant 일때
            String strValue = (String) entry.getValue(); //이부분을 잘라낼수도 있습니다.

            log.debug("--" + strKey + "--------->[" +  strValue + "]");

        }

    	return "/dsdsm/taskOrder/taskOrderListPop";
    }
    
    /**
     *  요구사항  목록 정보(Popup) 
	 * @throws Exception 
     */    
    @RequestMapping(value="/taskOrder/getTskOdrListPop.do")
    public String getTskOdrListPop(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {
    	
    	log.debug("taskOrder/getTskOdrListPop");
    	
		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		String  checkInfo =  (request.getParameter("checkPangInfo") != null) ? request.getParameter("checkPangInfo") : "";
		String  popYn =  (request.getParameter("popYn") != null) ? request.getParameter("popYn") : "";
		
	    log.debug("");
		log.debug(">>>>> param "+param.toString());
		log.debug("");
		

		int listCount = taskOrderService.getTskOdrListPopCnt(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = taskOrderService.getTskOdrListPop(param);
		
		log.debug(list.toString());
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);    	
    	
    	
      return "jsonView";	
    }     
        
        
    
    
    
    
    
   
/*****/	
    
    
	/**
     * 과업정보 리스트화면
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/taskList.do")
    public String taskList(HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	map.put("roleId", "MANAGER000");
		model.addAttribute("authority", CmmService.getAuthority(map));
		
		map.put("roleId", "SYSMANAGER");
		model.addAttribute("authority2", CmmService.getAuthority(map));
		
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0130010000000");
    	
    	String dutyCd      = StringUtil.nullToEmpty((String)userInfos.get("dutyCd"));
    	String lolCheck    = StringUtil.nullToEmpty((String)checkInfoG.get("lolId"));
    	String insertCheck = StringUtil.nullToEmpty((String)checkInfoG.get("insertYn"));
    	String readCheck   = StringUtil.nullToEmpty((String)checkInfoG.get("readYn"));
    	String updateCheck = StringUtil.nullToEmpty((String)checkInfoG.get("updateYn"));
    	String deleteCheck = StringUtil.nullToEmpty((String)checkInfoG.get("deleteYn")); 		
		/*****/
		
    	model.addAttribute("insertCheck", insertCheck);
    	model.addAttribute("updateCheck", updateCheck);
    	model.addAttribute("deleteCheck", deleteCheck);
		
    	return "/dsdsm/taskOrder/takeorder_List";
    }    
    
    /**
     * 과업정보 목록을 불러온다.
     * @throws Exception 
     */
	@RequestMapping(value = "/taskOrder/getBnsTaskist.do")
	public String getBnsTaskist(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, ModelMap model, HttpSession session) throws Exception {

		HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt(request.getParameter("pageNo").toString());
		float pageSize = Integer.parseInt(request.getParameter("pageSize").toString());
		
		
    	//paramInfoUtil.mpaInfo_print(param);
		
		int listCount = taskOrderService.getTaskListCount(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount",listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		List list = taskOrderService.getTaskList(param);	
		
		//log.debug(list.toString());
		
 	  	model.put("list",list);
 	  	model.put("page",pageinMap);
 	  	
		return "jsonView";
	}   
	
	
	/**
     * 과업정보 상세페이지
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/taskview.do")
    public String taskview(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model, HttpSession session) throws Exception {
    	
    	log.debug("");
    	log.debug("------------------------------");
    	log.debug(param.get("businessnm"));

    	String word = (String)param.get("businessnm");

    	paramInfoUtil.mpaInfo_print(param);
    	HashMap<Object, Object> map = new HashMap<Object, Object>();

    	List list = taskOrderService.getBusinessTaskView(param);
		model.addAttribute("list",list);
		
		List list1 = taskOrderService.getSanchurmulView(param);
		model.addAttribute("sanchurmul", list1);		
		
		List list2 = taskOrderService.getProjectTaskView(param);
		model.addAttribute("project", list2);
		
		
/*		
		List<Map<String, Object>> listMap = list;
		String businessnm = listMap.get(0).get("businessnm").toString();
		model.addAttribute("bsnName",businessnm);
*/		
		model.addAttribute("bsnNames",new String(word.getBytes("iso-8859-1"), "utf-8"));
		
		
    	@SuppressWarnings("rawtypes")
 		ArrayList ROLE = (ArrayList)session.getAttribute("ROLES");
    	
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0130010000000");
    	
    	String dutyCd      = StringUtil.nullToEmpty((String)userInfos.get("dutyCd"));
    	String lolCheck    = StringUtil.nullToEmpty((String)checkInfoG.get("lolId"));
    	String insertCheck = StringUtil.nullToEmpty((String)checkInfoG.get("insertYn"));
    	String readCheck   = StringUtil.nullToEmpty((String)checkInfoG.get("readYn"));
    	String updateCheck = StringUtil.nullToEmpty((String)checkInfoG.get("updateYn"));
    	String deleteCheck = StringUtil.nullToEmpty((String)checkInfoG.get("deleteYn")); 		
		/*****/
		
    	model.addAttribute("insertCheck", insertCheck);
    	model.addAttribute("updateCheck", updateCheck);
    	model.addAttribute("deleteCheck", deleteCheck);
    	
    	
    	String returnValue = "";
   		returnValue = "/dsdsm/taskOrder/task_view";
    	
    	
    	return returnValue;    	
    	
		
    }
    
	/**
     * 과업정보 등록화면
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/taskReg.do")
    public String taskReg(HttpServletRequest request, Model model) throws Exception {
    	
    	HashMap<Object, Object> map = new HashMap<Object, Object>();
    	
    	map.put("roleId", "MANAGER000");
		model.addAttribute("authority", CmmService.getAuthority(map));
		
		map.put("roleId", "SYSMANAGER");
		model.addAttribute("authority2", CmmService.getAuthority(map));
		
    	map.put("codeId", "RAT010");
		model.addAttribute("taskGbn", CmmService.getCmmDitcList(map));
		
    	return "/dsdsm/taskOrder/task_reg";
    }    
    
    

    /**
     * 과업정보 등록
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/tskReg.json")
    public String tskReg(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	log.debug(param.get("gbn"));
    	
    	//paramInfoUtil.mpaInfo_print(param);
  	
    	result = taskOrderService.regTask(param);
    	
    	result.put("businessno", param.get("businessno"));
    	log.debug(result.toString());
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }	
    

    /**
     * 과업정보 수정화면 
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/taskEdit.do")
    public String taskEdit(@RequestParam HashMap<Object,Object> param,HttpServletRequest request, Model model,HttpSession session, ModelMap map) throws Exception {
    	
    	log.debug("/taskOrder/taskEdit.do");
    	
    	//paramInfoUtil.mpaInfo_print(param);
    	
    	map.put("codeId", "RAT010");
		model.addAttribute("taskGbn", CmmService.getCmmDitcList(map));
    	
    	List list = taskOrderService.getBusinessTaskView(param);
		model.addAttribute("list",list);
		
		List list1 = taskOrderService.getSanchurmulView(param);
		model.addAttribute("sanchurmul", list1);		
		
		List list2 = taskOrderService.getProjectTaskView(param);
		model.addAttribute("project", list2);
		
		/*****/
    	@SuppressWarnings("rawtypes")
		Map userInfos = (Map)session.getAttribute("userInfo");
    	
    	Map checkInfoG = paramInfoUtil.dutyCode(session, "0130010000000");
    	
    	String dutyCd      = StringUtil.nullToEmpty((String)userInfos.get("dutyCd"));
    	String lolCheck    = StringUtil.nullToEmpty((String)checkInfoG.get("lolId"));
    	String insertCheck = StringUtil.nullToEmpty((String)checkInfoG.get("insertYn"));
    	String readCheck   = StringUtil.nullToEmpty((String)checkInfoG.get("readYn"));
    	String updateCheck = StringUtil.nullToEmpty((String)checkInfoG.get("updateYn"));
    	String deleteCheck = StringUtil.nullToEmpty((String)checkInfoG.get("deleteYn"));   		
		/*****/
		
		
    	String returnValue = "";
   		returnValue = "/dsdsm/taskOrder/task_edit"; 
    	model.addAttribute("regYn","");
    	
    	return returnValue;   		
    }
    
    
    /**
     * 과업정보 수정
	 * @throws Exception 
     */
    @RequestMapping(value="/taskOrder/taskUpdate.json")
    public String taskUpdate(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	log.debug(param.get("taskSno"));
    	log.debug(param.get("businessno"));
    	
    	String  taskSno= (String)param.get("taskSno");
    	String  businessno= (String)param.get("businessno");
    	String  businessnm= (String)param.get("businessnm");
    	   int  chkSpIdCnt = Integer.parseInt((String)param.get("chkSpId"));
    	   int  chkSpIdTwo = Integer.parseInt((String)param.get("chkSpIdTwo"));
    	   
    	//paramInfoUtil.mpaInfo_print(param);
    	
    	result = taskOrderService.taskUpdate(param);
    	result.put("taskSno", taskSno);
    	result.put("businessno", businessno);
    	result.put("businessnm", businessnm);
    	map.put("result", result);
    	
    	if(chkSpIdCnt > 0){
    	
    		taskOrderService.taskSituationDelete(param);	
    	
	    	for(int zz=1;zz<chkSpIdCnt+1;zz++){
	    		
	    		HashMap<Object, Object> chgPrm = new HashMap<Object, Object>();
	    		
	    		String chekString = StringUtil.nullToEmptyChk((String)param.get("prjId"+zz+""));
	    		String chekCount = StringUtil.nullToEmptyOfTag((String)param.get("prjId"+zz+""));
	    		
	    		String prjId = (String)param.get("prjId"+zz+"");
	    		String tskId = (String)param.get("taskId"+zz+"");

	    		log.debug("---------------------- "+chekString +" ----------------------");	    		
	    		log.debug("---------------------- "+chekCount.length() +" ----------------------");	    		
	    		
	    		chgPrm.put("businessno", businessno);
	    		chgPrm.put("taskSno", taskSno); //과업 PK
	    		chgPrm.put("prjId",prjId);
	    		chgPrm.put("taskId",tskId);
	    		
	    		log.debug("----------------------   sub_param ----------------------");
	    		//paramInfoUtil.mpaInfo_print(chgPrm);

	    		if("N".equals(chekString) && chekCount.length() > 3){
	    			taskOrderService.taskSituation(chgPrm);
	    		}
	    	}    	
    	}
    	
    	
    	if(chkSpIdTwo > 0){
        	
    		taskOrderService.taskSituationScmDelete(param);	
    	
	    	for(int ss=1;ss<chkSpIdTwo+1;ss++){
	    		
	    		HashMap<Object, Object> chgShmPrm = new HashMap<Object, Object>();
	    		//sanchulId shmprentId
	    		String chekString = StringUtil.nullToEmptyChk((String)param.get("sanchulId"+ss+""));
	    		String chekCount = StringUtil.nullToEmptyOfTag((String)param.get("sanchulId"+ss+""));
	    		
	    		String sanchulId = (String)param.get("sanchulId"+ss+"");
	    		String shmprentId = (String)param.get("shmprentId"+ss+"");

	    		log.debug("---------------------- "+chekString +" ----------------------");	    		
	    		log.debug("---------------------- "+chekCount.length() +" ----------------------");	    		
	    		
	    		chgShmPrm.put("businessno", businessno);
	    		chgShmPrm.put("taskSno", taskSno); //과업 PK
	    		chgShmPrm.put("sanchulId",sanchulId);
	    		chgShmPrm.put("shmprentId",shmprentId);
	    		
	    		log.debug("----------------------   sub_param ----------------------");
	    		paramInfoUtil.mpaInfo_print(chgShmPrm);

	    		if("N".equals(chekString) && chekCount.length() > 3){
	    		    taskOrderService.taskSituationScm(chgShmPrm);
	    			//log.debug("---------------------- 등록 ----------------------");
	    		}
	    	}    	
    	}    	
    	
    	

    	
    	return "jsonView";
    }
    
    
    /**
     * 과업정보 삭제
	 * @throws Exception 
     */    
    @RequestMapping(value="/taskOrder/taskDelete.json")
    public String taskDelete(@RequestParam HashMap<Object,Object> param,HttpServletRequest request,ModelMap map) throws Exception {
    	
    	Map<String, Object> result = null;
    	log.debug(param.get("gbn"));
    	
    	//paramInfoUtil.mpaInfo_print(param);
  	
    	result = taskOrderService.taskDelete(param);
    	
    	map.put("result", result);
    	map.put("businessid", param.get("businessid"));    	
    	
    	return "jsonView";
    }    
    	
    
}
