package egovframework.rte.dsdsm.usermg.web;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpSession;

import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.CommonDataService;
import egovframework.rte.dsdsm.cmmcode.service.CodeService;
import egovframework.rte.dsdsm.usermg.service.UserMgService;

@Controller
public class UserMgController {
	
	org.apache.logging.log4j.Logger log = org.apache.logging.log4j.LogManager.getLogger();
	
	@Resource(name="UserMgService")
	private UserMgService userMgService;
	
	@Resource(name="CommonDataService")
	private CommonDataService commonDataService;
	
	@Resource(name ="CodeService")
	private CodeService codeService;	
	

    @RequestMapping(value="/usermg/modifyMyInfo.json")
    public String modifyMyInfoResult(@RequestParam("jobCd") String[] jobCd, @RequestParam Map<String,Object> param, HttpSession session,  ModelMap map) throws Exception{

    	//System.out.println(jobCd.toString());
    	param.put("jobCd",jobCd);
    	@SuppressWarnings("rawtypes")
		Map userInfo = (Map)session.getAttribute("userInfo");
    	param.put("modId", (String)userInfo.get("userId"));
    	
    	Map<String,Object> result = userMgService.modifyMyInfo(param);
    	
    	@SuppressWarnings("unchecked")
		Map<String,Object> oldUserInfo = (Map<String,Object>)session.getAttribute("userInfo");
    	Map<String,Object> newUserInfo = new HashMap<String,Object>();
    	
    	Iterator<String> oldUserInfoIt = oldUserInfo.keySet().iterator();
    	while(oldUserInfoIt.hasNext()){
    		String oldUserInfoKey = oldUserInfoIt.next();
    		if(param.containsKey(oldUserInfoKey)){
    			newUserInfo.put(oldUserInfoKey, param.get(oldUserInfoKey));
    		}else{
    			newUserInfo.put(oldUserInfoKey, oldUserInfo.get(oldUserInfoKey));
    		}
    	}
    	session.setAttribute("userInfo", newUserInfo);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    @RequestMapping(value="/usermg/modifyOtherInfo.json")
    public String modifyOtherInfoResult(@RequestParam("jobCd") String[] jobCd, @RequestParam Map<String,Object> param, HttpSession session,  ModelMap map) throws Exception{

    	param.put("jobCd",jobCd);
    	@SuppressWarnings("rawtypes")
		Map userInfo = (Map)session.getAttribute("userInfo");
    	param.put("modId", (String)userInfo.get("userId"));
    	
    	Map<String,Object> result = userMgService.modifyMyInfo(param);
    	
 
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    @RequestMapping(value="/usermg/modifyMyInfo.do")
    public String modifyMyInfo(HttpSession session,  ModelMap map) throws Exception{
    	String result = "/dsdsm/usermg/modifyMyInfo";
    	
    	Map<String, Object> param = null;
    	Map<String,Object> codeMap = null;
    	
    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1000");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
		List<Map<String,Object>> rankList = (List<Map<String,Object>>)codeMap.get("LIST");
    	
/*    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1100");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> jobList = (List<Map<String,Object>>)codeMap.get("LIST"); */
    	
    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1200");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> dutyList = (List<Map<String,Object>>)codeMap.get("LIST");
    	
    	@SuppressWarnings("rawtypes")
		List deptCodes = commonDataService.getDeptCode();    	
    	ObjectMapper mapper = new ObjectMapper();
   		String deptCodesJsonStr = mapper.writeValueAsString(deptCodes);
   		
   		
    	@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();	    	
    	ObjectMapper mapper1 = new ObjectMapper();
   		String jobCdsJsonStr = mapper1.writeValueAsString(jobCds);	   		
		map.put("JOB_LIST", jobCdsJsonStr);
   		
   		
    	
    	map.put("RANK_LIST", rankList);
    	//map.put("JOB_LIST", jobList);
    	map.put("DUTY_LIST", dutyList);
    	map.put("DEPT_CODE", deptCodesJsonStr);
    	
    	return result;
    }
    
    @RequestMapping(value="/usermg/modifyMyPassword.do")
    public String modifyMyPassword() throws Exception{
    	String result = "/dsdsm/usermg/modifyMyPassword";
    	
    	return result;
    }
    
    @RequestMapping(value="/usermg/modifyMyPassword.json")
    public String modifyMyPasswordResult(@RequestParam Map<String,String> param, HttpSession session,  ModelMap map) throws Exception{

    	@SuppressWarnings("rawtypes")
		Map userInfo = (Map)session.getAttribute("userInfo");
    	param.put("modId", (String)userInfo.get("userId"));
    	param.put("userId", (String)userInfo.get("userId"));
    	
    	log.debug(param.get("current"));
    	
    	Map<String,Object> result = userMgService.modifyMyPassword(param);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    
    
    @RequestMapping(value="/usermg/listUsers.do")
    public String listUsers(ModelMap map) throws Exception{
    	String result = "/dsdsm/usermg/listUsers";
    	
    	Map<String, Object> param = null;
    	Map<String,Object> codeMap = null;
    	
    	Map<String,Object> dumpMap = new HashMap<String,Object>();
    	dumpMap.put("optionText", "전체");
    	dumpMap.put("optionValue", "");
    	
    	ObjectMapper mapper = new ObjectMapper();
    	
    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1200");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> dutyList = (List<Map<String,Object>>)codeMap.get("LIST");
    	dutyList.add(0,dumpMap);
    	
   		String dutyListJsonStr = mapper.writeValueAsString(dutyList);
   		
   		param = new HashMap<String,Object>();
    	param.put("codeId", "UR1100");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> delList = (List<Map<String,Object>>)codeMap.get("LIST");
    	delList.add(0,dumpMap);
    	
   		String delListJsonStr = mapper.writeValueAsString(delList);
   		
   		param = new HashMap<String,Object>();
    	param.put("codeId", "UR1000");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> approvalList = (List<Map<String,Object>>)codeMap.get("LIST");
    	approvalList.add(0,dumpMap);
    	
   		String approvalListJsonStr = mapper.writeValueAsString(approvalList);
   		
    	map.put("DUTY_LIST", dutyListJsonStr);
    	map.put("DEL_LIST", delListJsonStr);
    	map.put("APPROVAL_LIST", approvalListJsonStr);
    	
    	return result;
    }
    
    @RequestMapping(value="/usermg/selectUsers.json")
    public String selectUsers(@RequestParam HashMap<String,Object> param,ModelMap map) throws Exception{
    	HashMap<Object, Object> pageinMap = new HashMap<Object, Object>();

		float pageNo = Integer.parseInt((String)param.get("pageNo"));
		float pageSize = Integer.parseInt((String)param.get("pageSize"));
		
		int listCount = userMgService.selectUsersCnt(param);	
		
		int pageCount = (int) Math.ceil(listCount / pageSize);
		
		pageinMap.put("pageNo",pageNo);
		pageinMap.put("pageSize",pageSize);
		pageinMap.put("pageCount",pageCount);
		pageinMap.put("listCount", listCount);
		
		param.put("start", (int) (pageNo-1)*pageSize+1);
		param.put("end", (int) pageNo*pageSize);
		
		@SuppressWarnings("rawtypes")
		List list = userMgService.selectUsers(param);
		
 	  	map.put("list",list);
 	  	map.put("page",pageinMap);
 	  	
    	return "jsonView";
    }
    
    @RequestMapping(value="/usermg/approveUser.json")
    public String approveUser(@RequestParam HashMap<String,Object> param,ModelMap map,HttpSession session) throws Exception{
    	@SuppressWarnings("rawtypes")
		Map userInfo = (Map)session.getAttribute("userInfo");
    	param.put("modId", (String)userInfo.get("userId"));
    	
    	Map<String, Object> result = userMgService.approveUser(param);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    @RequestMapping(value="/usermg/removeUser.json")
    public String removeUser(@RequestParam HashMap<String,String> param,ModelMap map,HttpSession session) throws Exception{
    	@SuppressWarnings("rawtypes")
		Map userInfo = (Map)session.getAttribute("userInfo");
    	param.put("modId", (String)userInfo.get("userId"));
    	
    	Map<String, Object> result = userMgService.removeUser(param);
    	
    	map.put("result", result);
    	
    	return "jsonView";
    }
    
    @RequestMapping(value="/usermg/modifyOtherInfo.do")
    public String modifyOtherInfo(@RequestParam HashMap<String,String> collectedParam,HttpSession session,  ModelMap map) throws Exception{
    	String result = "/dsdsm/usermg/modifyOtherInfo";
    	
    	Map<String, Object> param = null;
    	Map<String,Object> codeMap = null;
    	
    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1000");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
		List<Map<String,Object>> rankList = (List<Map<String,Object>>)codeMap.get("LIST");
    	
/*    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1100");
    	codeMap = commonDataService.getCode(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> jobList = (List<Map<String,Object>>)codeMap.get("LIST"); */
    	
    	param = new HashMap<String,Object>();
    	param.put("codeId", "LN1200");
    	codeMap = commonDataService.getCodeWithshtnm(param);
    	@SuppressWarnings("unchecked")
    	List<Map<String,Object>> dutyList = (List<Map<String,Object>>)codeMap.get("LIST");
    	
    	@SuppressWarnings("rawtypes")
		List deptCodes = commonDataService.getDeptCode();
    	
    	ObjectMapper mapper = new ObjectMapper();
   		String deptCodesJsonStr = mapper.writeValueAsString(deptCodes);
   		
   		Map<String,Object> userInfo = userMgService.selectUserInfo(collectedParam);
   		
    	@SuppressWarnings("rawtypes")
		List jobCds = codeService.getJobCdList();	    	
    	ObjectMapper mapper1 = new ObjectMapper();
   		String jobCdsJsonStr = mapper1.writeValueAsString(jobCds);	   		
		map.put("JOB_LIST", jobCdsJsonStr);   		
   		
    	map.put("RANK_LIST", rankList);
    	//map.put("JOB_LIST", jobList);
    	map.put("DUTY_LIST", dutyList);
    	map.put("DEPT_CODE", deptCodesJsonStr);
    	map.put("userInfo", userInfo);
    	
    	return result;
    }
    
    @RequestMapping(value="/usermg/viewTempPassword.do")
    public String viewTempPassword(@RequestParam HashMap<String,String> param,ModelMap map) throws Exception{
    	String result = "/dsdsm/usermg/viewTempPassword";
    	
    	Map<String,Object> userInfo = userMgService.selectUserResetPassword(param);
    	map.put("userInfo", userInfo);
    	
    	return result;
    }
    
    @RequestMapping(value="/usermg/emergencyContact.do")
    public String emergencyContact() throws Exception{
    	return "/dsdsm/usermg/emergencyContact";
    }
    
    @RequestMapping(value="/usermg/orgChart.do")
    public String orgChart(@RequestParam HashMap<String,String> param,ModelMap map) throws Exception{
    	String deptLineInfo = EgovProperties.getProperty("Globals.deptLineInfo");
    	map.put("deptLineInfo", deptLineInfo);
    	return "/dsdsm/usermg/orgChart";
    }
    
}
