package egovframework.rte.dsdsm.weeklyReport.web;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.util.FileCopyUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import egovframework.rte.cmmn.util.EgovProperties;
import egovframework.rte.dsdsm.cmm.service.CmmService;
import egovframework.rte.dsdsm.cmm.util.DataToHwpConverter;
import egovframework.rte.psl.dataaccess.util.EgovMap;


@Controller
public class WeeklyReportController {
	 
	@Resource(name="CmmService")
	private CmmService cmmService;	
	
	Logger log = Logger.getLogger(this.getClass());

    @RequestMapping(value="/weeklyReport/weeklyReportList.do")
    public String weeklyReportList(HttpServletRequest request,  Model model, HttpSession session) throws Exception {
    	return "/dsdsm/weeklyReport/weeklyReportList";
    }
    
    
    @RequestMapping(value="/weeklyReport/weeklyReportWriteReg.do")
    public String weeklyReportWriteReg(HttpServletRequest request,  Model model, HttpSession session) throws Exception {
    	return "/dsdsm/weeklyReport/weeklyReportWriteReg";
    }
    
    @RequestMapping(value="/weeklyReport/weeklyReportDetail.do")
    public String weeklyReportDetail(HttpServletRequest request,  Model model, HttpSession session, @RequestParam Map<String, Object> param) throws Exception {
    	model.addAttribute("weekRptId", param.get("weekRptId"));
    	model.addAttribute("jobName"  , param.get("jobName"));
    	return "/dsdsm/weeklyReport/weeklyReportDetail";
    }

    
    @RequestMapping(value="/weeklyReport/weeklyReportBeforeList.do")
    public String weeklyReportBeforeList(HttpServletRequest request,  Model model, HttpSession session) throws Exception {
    	return "/dsdsm/weeklyReport/weeklyReportBeforeList";
    }
    
    
    @RequestMapping(value = "/weeklyReport/downloadHwpFile.do")
	public void downloadHwpFile(HttpSession session, HttpServletRequest request, @RequestParam Map<String, Object> param, HttpServletResponse response) throws Exception {
    	
    	
    	
    	Map userInfo = (Map)session.getAttribute("userInfo");

		param.put("ROLES",session.getAttribute("ROLES"));
    	param.put("deptId", userInfo.get("deptId"));
    	param.put("userId", userInfo.get("userId"));
    	param.put("loginId", userInfo.get("loginId"));
		
		List cmmJsonList = cmmService.selectCmmJsonList(param);
		
			if( cmmJsonList.size() > 0){
	    	DataToHwpConverter converter = new DataToHwpConverter();
	    	String result = converter.dataTohwp(cmmJsonList);
	
	    	if(result.equals("ok")){
	    		String jobCd = (String)param.get("jobCd");
	    		String hwpPath   = EgovProperties.getProperty("Globals.hwpTemplatePath")+jobCd;
	    		String filename  = "WeeklyReport.hwp";
	
	    		
	    		File uFile = new File(hwpPath, filename);
	    		
	    		int fSize = (int) uFile.length();
	     
	    		BufferedInputStream in = new BufferedInputStream(new FileInputStream(uFile));
	    		String mimetype = "text/html";
	    		
	    		response.setCharacterEncoding("UTF-8");
	    		response.setBufferSize(fSize);
	    		response.setContentType(mimetype);
	
	    		String header = request.getHeader("User-Agent");
	    		if (header.indexOf("edge") > -1 ) {
	    			//filename = URLEncoder.encode(filename, "UTF-8").replace("+", "%20");
	    			System.out.println("edge: "+filename);
	    			response.setHeader("Content-Disposition", "attachment;filename=" + filename + ";filename*= UTF-8''" + filename);
	    		} else if (header.indexOf("hrome") > -1) {
	    			System.out.println("chrome: "+filename);
	    			//filename = URLEncoder.encode(filename, "UTF-8").replace("+", " ");
	    			response.setHeader("Content-Disposition","attachment; filename=\"" + filename + "\"");
	    		} else {
	    			System.out.println("etc : "+filename);
	    			//filename = URLEncoder.encode(filename, "UTF-8");
	    			response.setHeader("Content-Disposition","attachment;filename=\"" + filename + "\"");
	    		}
	    		
	    		
	    		response.setContentLength(fSize);
	    		
	    		
	    		FileCopyUtils.copy(in, response.getOutputStream());
	    		in.close();
	    		response.getOutputStream().flush();
	    		response.getOutputStream().close();
	    		
	    		
	    		
	    		
	    	}else{
	    		Writer out = response.getWriter();
	    		out.append("<script>");
	    		out.append("alert('"+result+"');");
	    		out.append("</script>");
	    	}
		}

	}
    
    
    @RequestMapping(value = "/weeklyReport/downloadWeekHwpFile.do")
	public void downloadWeekHwpFile(HttpSession session, HttpServletRequest request, @RequestParam Map<String, Object> param, HttpServletResponse response) throws Exception {
    	
    	
    	Map userInfo = (Map)session.getAttribute("userInfo");

		param.put("ROLES",session.getAttribute("ROLES"));
    	param.put("deptId", userInfo.get("deptId"));
    	param.put("userId", userInfo.get("userId"));
    	param.put("loginId", userInfo.get("loginId"));
		
		List cmmJsonList = cmmService.selectCmmJsonList(param);
		ArrayList joblist = new ArrayList();

		List dataList = new ArrayList();
		
		if( cmmJsonList.size() > 0){
			
			String work       = "";
			String beforeWork = "";
			String result     = "";
			
			DataToHwpConverter converter = new DataToHwpConverter();
			
			for(int i=0 ; i<  cmmJsonList.size(); i++){
				EgovMap map =  (EgovMap)cmmJsonList.get(i);
				work =  (String)map.get("jobCd");
				
				
				
				
				if(i==0){
					dataList.add(cmmJsonList.get(i));
					joblist.add(work);
				}else{
					 beforeWork = (String)((EgovMap)cmmJsonList.get(i-1)).get("jobCd");
					 if(!work.equals(beforeWork)){
						// dataList = new ArrayList();
						 dataList.add(cmmJsonList.get(i));
						 joblist.add(work);
						 result = converter.weekReportTohwp(dataList) ;
					 }else{
						 dataList.add(cmmJsonList.get(i));
					 }
				}
			}
			
	    	if(result.equals("ok")){
	    		
	    		String hwpPath   = EgovProperties.getProperty("Globals.hwpTemplatePath")+"WeekAll";
	    		
	    		String filename  = "WeeklyReportAll.hwp";
	    		
	    		File path = new File(hwpPath);
	    		
	    		if(!path.exists()){
	    			path.mkdir();
	    		}
	    		
	    		File uFile = new File(hwpPath, filename);
	    		
	    		int fSize = (int) uFile.length();
	     
	    		BufferedInputStream in = new BufferedInputStream(new FileInputStream(uFile));
	    		String mimetype = "text/html";
	    		
	    		response.setCharacterEncoding("UTF-8");
	    		response.setBufferSize(fSize);
	    		response.setContentType(mimetype);

	    		String header = request.getHeader("User-Agent");
	    		if (header.indexOf("edge") > -1 ) {
	    			//filename = URLEncoder.encode(filename, "UTF-8").replace("+", "%20");
	    			System.out.println("edge: "+filename);
	    			response.setHeader("Content-Disposition", "attachment;filename=" + filename + ";filename*= UTF-8''" + filename);
	    		} else if (header.indexOf("hrome") > -1) {
	    			System.out.println("chrome: "+filename);
	    			//filename = URLEncoder.encode(filename, "UTF-8").replace("+", " ");
	    			response.setHeader("Content-Disposition","attachment; filename=\"" + filename + "\"");
	    		} else {
	    			System.out.println("etc : "+filename);
	    			//filename = URLEncoder.encode(filename, "UTF-8");
	    			response.setHeader("Content-Disposition","attachment;filename=\"" + filename + "\"");
	    		}
	    		
	    		response.setContentLength(fSize);
	    		
	    		FileCopyUtils.copy(in, response.getOutputStream());
	    		in.close();
	    		response.getOutputStream().flush();
	    		response.getOutputStream().close();
	    	}else{
	    		Writer out = response.getWriter();
	    		out.append("<script>");
	    		out.append("alert('"+result+"');");
	    		out.append("</script>");
	    	}
			
			
		}
		
		
    	

	}
}
