<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="회의실 등록" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post">
                <input type="hidden" name="gbn" value="S"/>
                <input type="hidden" name="userid" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                	<ax:fields>
                		<ax:field label="회의실명">
                            <input type="text" name="cfname" id="cfname" title="회의실명" maxlength="255" class="AXInput W400 av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="회의실 위치">
                			<select name="cfplace1" id="cfplace1">
                				<option value="">선택</option>
                				<c:forEach var="gbn" items="${area}" varStatus="status">
                					<option value="${gbn.code}">${gbn.codeShtnm}</option>
                				</c:forEach>
                			</select>
                            <input type="text" name="cfplace2" id="cfplace2" title="위치" maxlength="500" class="AXInput W350 av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="개방시간">
                            <select name="sdatetime" id="sdatetime" onchange="changeTime();">
			                	<option value="">선택</option>
			                </select>&nbsp;~&nbsp;
			                <select name="edatetime" id="edatetime" onchange="changeTime();">
			                	<option value="">선택</option>
			                </select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="수용인원">
                            <input type="text" name="cfperson" id="cfperson" title="수용인원" class="AXInput W50 av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="첨부파일">
          		      		<input name="file_1" id="egovComFileUploader" type="file" />
          		      		<div id="egovComFileList"></div>  
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
				<div class="ax-button-group">
                	<div class="right">
		                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>등록</button>
		                <button class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
	               	<div class="ax-clear"></div>
	            </div>
	          
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
		
	    var maxFileNum = $("#posblAtchFileNumber").val();
    	if (maxFileNum == null || maxFileNum == "") {
    		maxFileNum = 3;
    	}	 
    	var multi_selector = new MultiSelector(document	.getElementById('egovComFileList'), maxFileNum);
    	multi_selector.addElement(document.getElementById('egovComFileUploader'));	 
    	
	    function changeTime(value){
	    	var sdatetime = $("#sdatetime").val();
	    	var edatetime = $("#edatetime").val();
	    	
	    	if(sdatetime != "" && edatetime != "" && sdatetime > edatetime){
	    		gfnDialog("<b>Warning</b> 시작시간이 종료시간보다 큽니다.\r\n시간을 다시 확인해주세요.","Warning","확인","Red");
	    		$("#sdatetime").bindSelectSetValue(0);
	    		$("#edatetime").bindSelectSetValue(0);
	    	}
	    }
	    
	    function hour(id){
	    	for(i=6;i<23;i++){
	    		var hour = i;
	    		if(hour.toString().length == 1){
	    			hour = "0"+hour;
	    		}
	    		var minute = "00";
	    		var time = hour + ":" + minute;
	    			
	    		$("#"+id).append("<option value='"+time+"'>"+time+"</option>");	
	    	}
	    }
	    
	    var pageID = "AXValidator";
		var myValidator = new AXValidator();
		var fnObj = {
			pageStart: function(){
				
				gfnRequire();
				
				myValidator.setConfig({
					targetFormName : "myForm"
				});
				
				hour("sdatetime");
				hour("edatetime");
				
				$("#sdatetime").bindSelect();
				$("#edatetime").bindSelect();
				$("#cfplace1").bindSelect();
				$("#cfperson").bindNumber({
					min:1
				});
								
			},
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				gfnConfirm("등록하시겠습니까?","fnObj.saveForm();");
			},
			saveForm: function(){
				
				 var form = document.myForm;
		         var formData = new FormData(form);
				
				 var url = "<c:url value='/cfroom/management/cfroomEdit.json'/>";
				 
		         jQuery.ajaxSettings.traditional = true;
		      
		         $.ajax({
	                    url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    dataType:"json",
			   			timeout: 5000,
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		gfnDialog("회의실 등록이 완료되었습니다","Alert","확인","Red","location.href='cfroomView.do?cfno="+res.cfno+"'");
                            } else {
                            	gfnDialog("<b>Warning</b>&nbsp;회의실 등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","location.href='cfroomList.do'");
                            }
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="cfroomList.do";
			},
            serialize: function(){
                var frm = document.myForm;
                prompt("$(frm).serialize()", $(frm).serialize() );
            }
		}
		
		//$(document).ready(fnObj.pageStart);
	    </script>
	</ax:div>
</ax:layout>