<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="공통코드(대분류) 목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
			<input type="hidden" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
				<div class="ax-search" id="page-search-box"></div>      
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="10">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>
				    <div class="right">
				    	<button type="button" class="AXButton" onclick="location.href='codeGenReg.do'" ><i class="axi axi-save"></i> 등록</button>
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var jobCd = "${sessionScope['userInfo']['jobCd']}";
	    
	    var page_menu_id = "m010301";
	    var myGrid = new AXGrid();
	    
	    var fnObj = {
	        pageStart: function(){

	            this.search.bind();
	            this.bindEvent();
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	            var gridHeight = fnObj.getWidgetHeight();
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    fitToWidth: false,
                    height:gridHeight,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"no", label:"번호", width:"70", align:"center"},
                        {key:"codeid", label:"공통코드ID", align:"center", width:"150"},
                        {key:"codectn", label:"공통코드명",align:"center", width:"300"},
                        {key:"codeuseexp", label:"공통코드사용내역", align:"center", width:"150"},
                        {key:"codeuseyn", label:"사용여부", width:"100", align:"center"},
                        {key:"regid", label:"등록자", width:"150", align:"center"},
                        {key:"regdttm", label:"등록일자", width:"150", align:"center"},
                        {key:"modid", label:"수정자", width:"150", align:"center"},
                        {key:"moddttm", label:"수정일자", width:"150", align:"center"}
                    ],
                    body : {
                        onclick: function(){
                        	location.href="codeGenView.do?codeid="+this.item.codeid;
                        }
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }
                });

	        	myGrid.setList({
                    ajaxUrl:"getCodeGenList.do", ajaxPars:"code=", 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
                
	        },
	        bindEvent: function(){
	            var _this = this;
	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
	                            {label:"대분류코드ID", labelWidth:"", type:"inputText", width:"200", key:"codeId", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            },
	                            {label:"대분류코드명", labelWidth:"", type:"inputText", width:"200", key:"codeNm", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            }
	                        ]}
	                    ]
	                });
	            },
	            submit: function(){
	                var pars = this.target.getParam();
                    myGrid.setList({
                        ajaxUrl:"getCodeGenList.do", ajaxPars:pars, 
                        onLoad:function(){
                            
                        }
                    });
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            },
    		getWidgetHeight : function(){
    			var windowHeight = $(window).height();
    			
    			return windowHeight-320;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            }
	    };
	    
	    
	    </script>
	</ax:div>
</ax:layout>