<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="공통코드(소분류) 등록" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post">
                <input type="hidden" name="gbn" id="gbn" value="S"/>
                <input type="hidden" id="maxlength" value="0"/>
                <input type="hidden" name="userid" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                	<ax:fields>
                		<ax:field label="대분류코드">
                		<input type="hidden" name="codeid" id="codeid"/>
                            <select name="codeM" id="codeM" title="대분류코드" class="AXSelect av-required" onchange="fnObj.selectChange(this.value)">
                            		<option value="">선택</option>
                            	<c:forEach var="result" items="${codeGenList}">
                            		<option value="${result.codeid}/${result.codelen}" <c:if test="${result.codeid eq codeid}">selected</c:if> >${result.codectn}(${result.codeid})</option>
                            	</c:forEach>
                            </select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="세부코드ID">
                            <input type="text" name="code" id="code" title="세부코드ID" class="AXInput av-required" />
                            <button type="button" id="checkId" class="AXButtonSmall Blue"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i> 공통코드ID 중복확인</button>
                    		<input type="hidden" name="isIdOverlapped" id="isIdOverlapped" value=""/>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="세부코드명">
                            <input type="text" name="codectn" id="codectn"  maxlength="1000" title="세부코드명" class="AXInput av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="세부코드단축명">
                            <input type="text" name="codeshtnm" id="codeshtnm" maxlength="50" title="세부코드단축명" class="AXInput av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="비고">
                            <input type="text" name="coderem" id="coderem" maxlength="20" title="비고" class="AXInput av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="사용여부">
                            <select name="codeuseyn" id="codeuseyn" title="사용여부" class="AXSelect av-required">
                            	<option value="">선택</option>
                            	<option value="Y">Y</option>
                            	<option value="N">N</option>
                            </select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="순서">
                            <input type="text" name="sortorder" id="sortorder" title="순서" class="AXInput W50 av-required" />
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
				<div class="ax-button-group">
                	<div class="right">
		                <button type="button" class="AXButton" onclick="fnObj.saveForm();"><i class="axi axi-save"></i>등록</button>
		                <button class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
	               	<div class="ax-clear"></div>
	            </div>
	            
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
		
	    var pageID = "AXValidator";
	    
		var myValidator = new AXValidator(); // Validator 선언
		var fnObj = {
			pageStart: function(){
				
				gfnRequire();
				
				myValidator.setConfig({
					targetFormName : "myForm"
				});
				
				$("#codeuseyn").bindSelect();
				$("#sortorder").bindNumber({
					min:1
				});
				$("#codeM").bindSelect();
				
				if("${codeid}" != "" || "${codeid}" != null){
					$("input").attr("disabled",false);
	                $("#codeuseyn").bindSelectDisabled(false);
	                
	                var code = $("#codeM option:selected").val().split("/");
	            	
	            	$("#codeid").val(code[0]);
	            	$("#code").attr("maxlength",code[1]);
	            	$("#maxlength").val(code[1]);
				} else {
					$("input").attr("disabled",true);
	                $("#codeuseyn").bindSelectDisabled(true);
				}
				
				$("#checkId").click(function(){
                	
					var codeid = $("#codeid").val();
                	var code = $("#code").val();
                	
                	if(code==""){
                		gfnDialog("<b>Warning</b>&nbsp;ID를 기입후 확인하세요.","Warning","확인","Red","");
                		return false;
                	}
                	
                	if(code.length < $("#maxlength").val()){
                		gfnDialog("<b>Warning</b>&nbsp;세부코드ID는 "+$("#maxlength").val()+"자리여야 합니다.","Warning","확인","Red","");
                		return false;
                	}
                	
                	var url = "<c:url value='/cmmcode/checkCode.json'/>";
                    var pars = {codeid:codeid,code:code};
                    
                    new AXReq(url, 
                        {
                            pars:pars, 
                            onsucc:function(res){
                            	
                                if(res.result.SUCCESS){
                                	gfnDialog(res.result.MESSAGE,"Alert","확인","Red","");
                                	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                                	$("input[name='isIdOverlapped']").val("false");
                                }else{
                                	gfnDialog("<b>Warning</b>&nbsp;"+res.result.MESSAGE,"Warning","확인","Red","");
                                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                                	$("input[name='isIdOverlapped']").val("true");
                                }
                                
                            },
                            onerr:null
                        }
                    );
                });
                $("input[name='code']").change(function(){
                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                	$("input[name='isIdOverlapped']").val("true");
                });
                
;			},
			saveForm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				var isIdOverlappedObj = $("#isIdOverlapped").val();
				
				if(isIdOverlappedObj==""){
					gfnDialog("<b>Warning</b>&nbsp;아이디 중복확인을 해야합니다.","Warning","확인","Red","");
                	$("#checkId").focus();
                	return false;
                }else if(isIdOverlappedObj=="true"){
                	gfnDialog("<b>Warning</b>&nbsp;다른 ID로 중복확인 후 등록바랍니다.","Warning","확인","Red","");
                	$("#code").focus();
                	return false;
                }
				
				if(!confirm("등록하시겠습니까?")){
					return false;
				}
				
				$("#gbn").val("S");
				
				 var form = document.myForm;
		         var formData = new FormData(form);
				
				 var url = "<c:url value='/cmmcode/codeEdit.json'/>";
				 
		         jQuery.ajaxSettings.traditional = true;
		      
		         $.ajax({
	                    url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    dataType:"json",
			   			timeout: 5000,
	                    success: function(res){
	                       if(res.result.SUCCESS){
	                    	   gfnDialog("공통코드(소분류) 등록이 완료되었습니다","Alert","확인","Red","location.href='codeView.do?codeid="+res.codeid+"&code="+res.code+"'");
                           } else {
                        	   gfnDialog("<b>Warning</b>&nbsp;공통코드(소분류) 등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","location.href='codeList.do'");
                           }
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="codeList.do";
			},
            serialize: function(){
                var frm = document.myForm;
                prompt("$(frm).serialize()", $(frm).serialize() );
            },
            selectChange: function(val){

            	$("input").attr("disabled",false);
                $("#codeuseyn").bindSelectDisabled(false);
                
            	var code = val.split("/");
            	
            	$("input").val("");
            	$("#codeuseyn").bindSelectSetValue(0);
            	
            	$("#codeid").val(code[0]);
            	$("#code").attr("maxlength",code[1]);
            	$("#maxlength").val(code[1]);
            	
            	if(val == "" || val == null){
            		$("input").attr("disabled",true);
                    $("#codeuseyn").bindSelectDisabled(true);
            	}
            }
		}
		
		//$(document).ready(fnObj.pageStart);
	    </script>
	    <style>
	    	.AXanchorSelect.disable .selectedTextBox {
			  display: block;
			  border: 1px solid #b6b6b6;
			  background: #eee;
			  color: #676767;
			  cursor: default;
			  text-shadow: 0px 1px #fff;
			  box-shadow: inset 0px 1px 2px #b1b1b1;
			  border-radius: 4px;
			}
			
			.AXInput[disabled] {
			  background: #eee;
			  color: #676767;
			  text-shadow: 0px 1px #fff;
			  box-shadow: inset 0px 1px 2px #b1b1b1;
			}
			
			.AXTextarea[disabled] {
			  background: #eee;
			  color: #676767;
			  text-shadow: 0px 1px #fff;
			  box-shadow: inset 0px 1px 2px #b1b1b1;
			}
	    </style>
	</ax:div>
</ax:layout>