<%@ page contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="ax" uri="http://axisj.com/axu4j"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<script type="text/javascript" src="<c:url value='/js/xls/xlsx.full.min.js'/>"                    ></script>
<style>
  body {
    overflow: auto;
  }
</style>
<ax:layout name="base.jsp">
	<ax:div name="header">
	        <h1>Excel Data Importer</h1>
	        <p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<input type="hidden" id="sheetName" name="sheetName" />
		<input type="hidden"  id="excelFileName" name="excelFileName" />
		<pre id="out" style="display:none;"></pre>
		<input type="hidden" name="accntId" id="accntId"/>	
		<input type="hidden" name="actionGbn" id="actionGbn" />
		<ax:row>
			<ax:col size="12" wrap="false">
				<div class="ax-search" id="page-search-box">
				<input type="file" name="excel" id="excel"  class="col" />
				</div>
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="5">5</option>
							<option value="10" selected="selected">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>				
				    <div class="right">
				    	<button type="button" class="AXButton" id="ax-search-btn-write" onclick="mergeData();"><i class="axi axi-pencil"></i>DB서버 INSERT</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
<div style="display:none;">
	<div id="dataLoding" style="height:200px;width:300px;background:linear-gradient(to bottom, #cccccc  , #ffffff  );">
		<center>
		<br><br>
		<img src="/kendo/css/Silver/loading_2x.gif" alt="로딩이미지" />
		<br><br>
		<br>대용량 데이터를 불러 오고 있어,
		<br>다소 시간이 소요됩니다.
		<br>잠시만 기다려 주세요..
		</center>
	</div>
</div>
<div id="selSheetView"  style="height:150px;width:800px;display:none;">
	<div id="sheetRow" style="height:150px;padding-top:30px;width:800px;"></div>
</div>


	</ax:div>
	<ax:div name="scripts">
<script>	
function excelFormat(){
	//location.href="/주문관리양식견본.xlsx";
	Util.fileDownLoad('excel00001'); 
}
function mergeData(){
	var param = {};
	
	param.workGbn='CmmDatatDAO';
	param.processId='scmOrderInsert';

	var grid = $("#grid").data("kendoGrid");
    
    var gridData = grid.dataSource.options.data;
    
	param.JsonList=JSON.stringify(gridData);
	
	$.ajax({
        url: "<c:url value="/cmm/updateData.do"/>",
        data: param,
        dataType:"json",
        type:"post",
        async:false,
        success: function(res, status, xhr){
    		Util.alert("DB 서버에 데이터가 입력되었습니다.<br>  목록에서 데이터를 확인해 주세요!!");
    		//goToPage('/order/orderManagermentSCM.do' , 'LIMSM0034', '주문관리(SCM)', '1');
        },
        error: function(xhr,status,error){
        	Util.alert(xhr.responseJSON.msg);
        },
    });
}


var selSheet  = "";
var sheets    = null;
var excelFile = null;
var file      = null;
var data      = null;

var enTitle    = ["joNo", "joYmd", "upDt", "upNm", "downDt", "downNm" , "orderTon", "reqCustNm" , "bussNo"];
var krTitle    = ["주문번호" , "주문일자", "상차일시", "상차지", "하차일시", "하차지", "주문중량", "화주명", "화주사업자번호"];
var excelTitle = [];


var excelJson = null;
var gridData  = null;

function getAraayIdx(cellTitle){
	for(var i=0; i < krTitle.length ; i++){
		if(cellTitle.trim() == krTitle[i]){
			//alert(i);
			return i;
			break;
		}
	}
}


// 엑셀시트가 여러개일 경우 엑셀 시트를 선택한다.
function selectSheet(files) {
	Util.divModal("dataLoding", "300", "200", "데이터 Import");
	file = null;
	file = files[0];
	
	
	
	var reader = new FileReader();
	
	reader.onload = function(e) {
		data   = null;
		data   = e.target.result;
		
		var arraydata = new Uint8Array(data);
		var result    = {};
		excelFile = XLSX.read(arraydata, {type: 'array'});
		
		//Util.jsonConsole(excelFile);
		//alert(excelFile.SheetNames);
		
		if((excelFile.SheetNames).length > 1){
			Util.divModalClose();
			Util.confirmOkOnly("Excel 시트가 여러개 입니다.<br>대상 시트를 선택해 주셔야 합니다.", "sheetView");
			sheets = excelFile.SheetNames;
			return;
		}else{
			excelFile.SheetNames.forEach(function(sheetName) {
				var roa = XLSX.utils.sheet_to_json(excelFile.Sheets[sheetName], {header:1});
				if(roa.length) result[sheetName] = roa;
				$("#sheetName").val(sheetName);
			});
			$("#out").text(JSON.stringify(result, 2, 2));
			
			excelJson = result;
			
			//Util.jsonAlert(result);
			
			// 엑셀을 Json 으로 변환 후대용량 데이터 호출 알림 끔
			Util.divModalClose();
			makeGridData();
		}
		
	};
	
	reader.readAsArrayBuffer(file);
	
}

function sheetView(){
	var fileName = $("#excelFileName").val();
	//alert(fileName);
	//Util.jsonAlert(sheets);
	var content ="<div style='width:750px;height:100px;'>";
	    content +="	<div style='height:50px;'><span class='k-icon k-i-excel'></span><span style='font-weight:600;'>&nbsp;&nbsp;『"+fileName+"』의 Sheet 목록</span></div>";
	    content +="		<span style=''>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>";
	for(var i=0;i<sheets.length;i++){
		content+="		<span class='tab' onClick='setSheetName(\""+sheets[i]+"\");' onMouseOver='this.style.color=\"blue\";' onMouseOut='this.style.color=\"#2f2f2f\";' >";
		content+=sheets[i];
		content+="		</span>";
	}
		content+="	<div style='border-bottom:2px solid #efefef;'></div>";
		content+="	<div style='height:20px;'>&nbsp;</div>";
		content+="</div>";
		
	$("#sheetRow").html(content);
	Util.divModal("sheetRow", "800", "200", "엑셀 시트 선택");
}


function setSheetName(sheetNm){
	Util.divModalClose(); // 엑셀 선택 시드 팝업 닫음.
	
	$("#sheetName").val(sheetNm);

	var reader = new FileReader();
	
	Util.divModal("dataLoding", "300", "200", "데이터 Import");
	reader.onload = function(e) {
		var arraydata = new Uint8Array(data);
		var result    = {};

			
		excelFile.SheetNames.forEach(function(sheetName) {
			if( sheetName != null && sheetName!="" && $("#sheetName").val() == sheetName  ){
				var roa = XLSX.utils.sheet_to_json(excelFile.Sheets[sheetName], {header:1});
				if(roa.length) {
					result[sheetName] = roa;
					
					Util.jsonConsole(roa);
				}
			}
		});
		
		$("#out").text(JSON.stringify(result, 2, 2));
		excelJson = result;
		
		makeGridData();
		// 엑셀을 Json 으로 변환 후대용량 데이터 호출 알림 끔
		Util.divModalClose();
	};
	reader.readAsArrayBuffer(file);
}

function makeGridData(){
	
	var data = excelJson[$("#sheetName").val()];
	var tempGridData = [];
	
	//lert(data.length);
	if(data.length > 1){
		excelTitle = data[0];
		
		for(var i=1; i < data.length;i++){
			
			// getAraayIdx 엑셀에서 사용자가 cell 위치를 변경했을 경우를 대비하여 
			// title로 비교하여 cell 인덱스를 구하여 값을 찾아온다.
			if( data[i][0] !=""){
				 tempGridData[i-1]= {
						  "joNo"       : data[i][getAraayIdx("주문번호")]
						, "joYmd"      : data[i][getAraayIdx("주문일자")]
						, "upDt"       : data[i][getAraayIdx("상차일시")]
						, "upNm"       : data[i][getAraayIdx("상차지")]
						, "downDt"     : data[i][getAraayIdx("하차일시")]
						, "downNm"     : data[i][getAraayIdx("하차지")]
				 		, "bussNo"     : data[i][getAraayIdx("화주사업자번호")]
						, "orderTon"   : data[i][getAraayIdx("주문중량")]
						, "reqCustNm"  : data[i][getAraayIdx("화주명")]
				}; 
			}

		}
	}else{
		Util.alert("Excel Sheet에 데이터가 누락되었습니다.<br>Excel 파일 및 Sheet를 확인해 주세요.");
	}

	
	this.gridData = tempGridData;
	getSelectData();
}

function getSelectData(){
	$("#grid").text("");
	$("#grid").kendoGrid({
		  columns    : [
				{
					field : "joNo",
					title : "주문번호"
				}	,
				{
					field : "joYmd",
					title : "주문일자" ,
				    template: function(dataItem) {
				    		var joYmd = dataItem.joYmd+"";
				    	   return Util.formatDate(joYmd); 
				    }
				}	,
				{
					field : "upDt",
					title : "상차일자",
				    template: function(dataItem) {
			    		var upDt = dataItem.upDt+"";
			    	   return Util.formatDate(upDt); 
			    	}
				}	,
				{
					field : "upNm",
					title : "상차지"
				}	,
				{
					field : "downDt",
					title : "하차일자" ,
					template: function(dataItem) {
			    		var upDt = dataItem.upDt+"";
			    	   return Util.formatDate(upDt); 
			    	}
				}	,
				{
					field : "downNm",
					title : "하차지"
				}	,
				{
					field : "orderTon",
					title : "주문중량"
				}	,
				{
					field : "reqCustNm",
					title : "화주명"
				}	,
				{
					field : "bussNo",
					title : "화주사업자번호",
					template: function(dataItem) {
			    		var bussNo = dataItem.bussNo+"";
			    	   return Util.formatBizNoData(bussNo); 
			    	}
				}
		  ]
		, dataSource : this.gridData
		, pageable:{
		  	pageSize : 50
		  }
	});
	
	//Util.confirmOkOnly("아래 목록에서 Import Data의 이상유무를 확인 후 <br><font color=red>『DB서버 INSERT』 버튼</font>을 클릭하여 서버에 적용해 주세요. ", "goList");
	Util.alert("아래 목록에서 Import Data의 이상유무를 확인 후 <br><font color=red>『DB서버 INSERT』 버튼</font>을 클릭하여 서버에 적용해 주세요. ");
}

//onLoad Event..
$(document).ready(function(){
	var myGrid = new AXGrid();	    
	
	
	 myGrid.setConfig({
         targetID : "page-grid-box",
         theme : "AXGrid",
         fitToWidth: true,
         height:500,
         emptyListMSG: "데이터가 존재하지 않습니다.",
         mediaQuery: {
             mx:{min:0, max:767}, dx:{min:767}
         },
         colGroup : [
             {key:"no", label:"번호", width:"50", align:"center"},
             {key:"sid", label:"sid", width:"130", align:"center" , display:false},
             {key:"ntSubj", label:"제목", width:"500", align:"left"},
             {key:"usrNm", label:"작성자(아이디)", align:"center", width:"160"},
             {key:"regrDttm", label:"등록일", width:"140", align:"center"}
         ],
         body : {
             onclick: function(){
             	//location.href="noticeView.do?sid="+this.item.sid;
         		 fnObj.modal.open("gridView", {
                     url:"<c:url value='/notice/noticeView.do'/>", pars:"sid="+this.item.sid                
                 }); 

             },
             
         },
         page:{
             paging:true,
             pageNo:1,
             pageSize:10,
             status:{formatter: null}
         }
     });

     myGrid.setList({
         ajaxUrl:"getNoticeList.do", ajaxPars:"inqUserNm=&inqTitle=", 
         onLoad:function(){
         	trace(this);
         },onsucc:function(){
             trace(this);
         },onError:function(){
         	trace(this);
         	console.log("onError!!");
         }
     });
	
	
	
	//$("#btnZone").hide();
	$("#excel").change(function(e){
		$("#excelFileName").val($("#excel").val());
		selectSheet(e.target.files);
		//$("#excel").val("");
	});
	
	//setTimeout(
	//	function(){$("#excel").click();}, 
	//	500
	//);
}); 
</script>
	</ax:div>
</ax:layout>

