<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="배포 목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
				<div class="ax-search" id="page-search-box"></div>
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="5">5</option>
							<option value="10" selected="selected">10</option>
							<option value="30">30</option> 
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>
					<div class="right">
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var date = new Date();
	    var vToday = gfnGetDate(date,"-");
	    var myGrid = new AXGrid();	    
	    var page_menu_id = "m010301";
	    var pStat = "${pStat}";
	    var pSDT = "${pSDT}";
	    var pEDT = "${pEDT}";
//	    var pReg = "${pReg}";
	    var fnObj = {
	        pageStart: function(){
	            this.search.bind();	            
	            this.modal.bind();
	            this.bindEvent();	            
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	            var gridHeight = fnObj.getWidgetHeight();
	            
	            myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    height:gridHeight,
                    fitToWidth: true,
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"disNo", label:"배포 번호", width:"130", align:"center"},
                        {key:"disUsrNm", label:"요청자명(아이디)", align:"center", width:"150"},
                        {key:"disAppCont", label:"제목", width:"400", align:"left"},
                        {key:"rqDttm", label:"등록일", width:"90", align:"center"},
                        {key:"disCauseNm", label:"배포원인", width:"90", align:"center"},
                        {key:"disTypeNm", label:"배포유형", width:"90", align:"center"},
                        {key:"disStat", label:"처리상태", width:"120", align:"center"},
                        {key:"lastModDttm", label:"최근처리일시", width:"140", align:"center"},
                        {key:"returnYn", label:"반려여부", width:"70", align:"center"},
                        {key:"disEndDttm", label:"배포종료일", width:"90", align:"center"}
                    ],
                    body : {
                        onclick: function(){
                            /*fnObj.modal.open("gridView", {
                            url:"disView.do", pars:"disNo=" + this.item.disNo +"&isModal=Y"
                        	});*/                        	
                        	location.href="disView.do?disNo="+this.item.disNo;
                            /* fnObj.modal.open("gridView", {
                                url:"SRregist.do", pars:"srno=" + this.item.srno
                            }); */
                        },
                        
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }
                });

	            
	            
	            myGrid.setList({
                    ajaxUrl:"getDisList.do", 
                    ajaxPars:"inqUserNm=&inqStat=&inqTitle=&inqFrom="+pSDT+"&inqTo="+pEDT+"&pStat="+pStat, 
                    //ajaxPars:"inqUserNm=&inqStat=&inqTitle=&inqFrom=&inqTo=&pStat=", 
                    onLoad:function(){
                    	//console.log("Load");
/*                         if(pReg.length > 1) {
                            fnObj.modal.open("gridView", {
                                url:"disView.do", pars:"disNo=" + pReg +"&isModal=Y"
                            });
                            pReg = "";
                        }   */                  	
                    	//trace(this);
                    },onsucc:function(){
                        //trace(this);
                        //console.log("Succ");

                    },onError:function(){
                    	//console.log("Err");
                    	//trace(this);
                    	//console.log("onError!!");
                    }
                });
                
	            
	            <c:if test="${pPage ne null}">
	            	//console.log("${pPage}");
	            	//myGrid.goPageMove("${pPage}");
	            </c:if>
	        	 
	        },
	        bindEvent: function(){
	            var _this = this;
   				/*	 $("#ax-grid-btn-regist").bind("click", function(){
                    fnObj.modal.open("gridView", {
                        url:"edit.do", pars:""
                    });
                });
                $("#ax-grid-btn-remove").bind("click", function(){
                    _this.grid.remove();
                }); */
	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	            
	            $("#AXInputDateED").bindTwinDate({handleLeft:25, align:"right", valign:"bottom", separator:"/", startTargetID:"AXInputDateST", onChange:function(){
	                //toast.push(Object.toJSON(this));
	            }});
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
   	                            {label:"요청자", labelWidth:"", type:"inputText", width:"200", key:"inqUserNm", addClass:"secondItem", valueBoxStyle:"", value:"",
   	                                onChange: function(changedValue){
   	                                    //toast.push(Object.toJSON(this));
   	                                }
   	                            },
   	                            {label:"처리상태", labelWidth:"", type:"selectBox", width:"200", key:"inqStat", addClass:"secondItem", valueBoxStyle:"", value:"",
   	                            	options:[
	                                         {optionValue:"", optionText:"전체"}
	                                 	     <c:forEach var="disStat" items="${disStat}" varStatus="status">	                                 	     	
	                                 	     	,{optionValue:"${disStat.code}", optionText:"${disStat.codeShtnm}"}
	                             	   	     </c:forEach> 
	                                        ],
		   	                        AXBind:{
		                                type:"select", config:{
		                                   onchange:function(){
		                                      //toast.push(Object.toJSON(this));
		                                   }
		                                }
		                            }   	                            
   	                            }
   	                        ]},
   							{display:true, addClass:"", style:"", list:[
   								{label:"제목", labelWidth:"", type:"inputText", width:"200", key:"inqTitle", addClass:"secondItem", valueBoxStyle:"", value:""	},
   								{label:"요청일", labelWidth:"", type:"inputText", width:"70", key:"inqFrom", addClass:"secondItem", valueBoxStyle:"", value:<c:if test="${pSDT eq null}">vToday</c:if><c:if test="${pSDT ne null}">pSDT.toString()</c:if>,
   									onChange: function(){}
   								},
   								{label:"", labelWidth:"", type:"inputText", width:"90", key:"inqTo", addClass:"secondItem", valueBoxStyle:"", value:<c:if test="${pEDT eq null}">vToday</c:if><c:if test="${pEDT ne null}">pEDT.toString()</c:if>,
   									AXBind:{
   										type:"twinDate", config:{
   											align:"right", valign:"top", startTargetID:"inqFrom", 
   											onChange:function(){
   												//toast.push(Object.toJSON(this));
   											}
   										}
   									}
   								}
     						]}	                          
	                       /*  {display:true, addClass:"", style:"", list:[
	                            {label:"검색어", labelWidth:"100", type:"selectBox", width:"", key:"selectbox", addClass:"", valueBoxStyle:"", value:"close",
	                                options:[
	                                         {optionValue:"all", optionText:"전체"}, 
	                                         {optionValue:"req", optionText:"요청자"}, 
	                                         {optionValue:"sta", optionText:"처리상태"}
	                                        ],
	                                AXBind:{
	                                    type:"select", config:{
	                                        onChange:function(){
	                                            toast.push(Object.toJSON(this));
	                                        }
	                                    }
	                                }
	                            },
	                            {label:"", labelWidth:"", type:"inputText", width:"150", key:"inputText", addClass:"secondItem", valueBoxStyle:"padding-left:0px;", value:"",
	                                onChange: function(changedValue){
	                                    toast.push(Object.toJSON(this));
	                                }
	                            }
	                        ]} */
	                    ]
	                });
	            },
	            submit: function(){
	                var pars = this.target.getParam();
	                //toast.push("콘솔창에 파라미터 정보를 출력하였습니다.");
	                //alert(pars);

                    myGrid.setList({
                        ajaxUrl:"getDisList.do", ajaxPars:pars, 
                        onLoad:function(){
                            
                        }
                    });
	            }
	        },
	      /*   grid: {
	            target: new AXGrid(),
	            get: function(){ return this.target },
	            bind: function(){
	
	                this.target.setConfig({
	                    targetID : "page-grid-box",
	                    theme : "AXGrid",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    colGroup : [
	                        {key:"disNo", label:"배포 번호", width:"120", align:"center"},
	                        {key:"disUsrNm", label:"요청자명(아이디)", align:"center", width:"120"},
	                        {key:"disAppCont", label:"제목", width:"*", align:"left"},
	                        {key:"disStat", label:"처리상태", width:"120", align:"center"},
	                        {key:"rqDttm", label:"등록일", width:"140", align:"center"}
	                    ],
	                    body : {
	                        onclick: function(){
	                        	location.href="disView.do?disNo="+this.item.disNo;
	                             fnObj.modal.open("gridView", {
	                                url:"SRregist.do", pars:"srno=" + this.item.srno
	                            });
	                        },
	                        
	                    },
	                    page:{
	                        paging:true,
	                        pageNo:1,
	                        pageSize:3,
	                        status:{formatter: null}
	                    }
	                });
	
	                this.target.setList({
	                    ajaxUrl:"getDisList.do", ajaxPars:"inqUserNm=&inqStat=&inqTitle=&inqFrom=&inqTo=", 
	                    onLoad:function(){
	                    	trace(this);
	                    },onsucc:function(){
	                        trace(this);
	                    },onError:function(){
	                    	trace(this);
	                    	console.log("onError!!");
	                    }
	                });
	            }
	        }, */
	        modal: {
	            target: new AXModal(),
	            get: function(){ return this.target },
	            bind: function(){
	                window.myModal = this.target;
	                
	                this.target.setConfig({
	                    windowID:"myModalContainer",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    displayLoading:true
	                });
	            },
	            open: function(type, http){
	                this.target.open({
	                    url: http.url,
	                    pars: http.pars.queryToObject(),
	                    top: ( (typeof http.top == "undefined") ? 100 : http.top ),
	                    width: ( (typeof http.width == "undefined") ? 900 : http.width ),
	                    closeByEscKey: true
	                });
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            },
    		getWidgetHeight : function(){
    			return windowHeight = $(window).height()-354;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            }         
	    };	    
   
	    </script>
	</ax:div>
</ax:layout>