<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" 
%>

<ax:layout name="base.jsp">
    <ax:set name="title" value="회의록 상세보기" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post" enctype="multipart/form-data">
                <c:forEach var="result" items="${list}" varStatus="status">
                <input type="hidden" name="no" id="no" value="${result.pno}" />
                <input type="hidden" name="status" id="status" value="${result.status}" />
                <input type="hidden" name="docGbn" id="docGbn" value="${result.docGbn}" />  
                <input type="hidden" name="type" id="type" value="R" />   
		            <ax:fields>
		                <ax:field label="제목">
		                	${result.title}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
                		<ax:field label="업무">
                			${result.jobName}
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="문서구분">
                			<c:forEach var="gbn" items="${docGbn}" varStatus="status">
                				<c:if test="${result.docGbn eq gbn.code}">${gbn.codeShtnm}</c:if>
                			</c:forEach>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
		                <ax:field label="작성자">
							<c:choose>
							    <c:when test="${result.charger eq '0000000000000'}">
							               기타(외부업체포함)
							    </c:when>
							    <c:otherwise>
							         ${result.chargerName}
							    </c:otherwise>
							</c:choose>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="문서번호">
		                	${result.docNo}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="회의일자">
		                	${result.date}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="회의소집처">
		                	${result.sendGd}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		            	<ax:field label="회의참석처">
		                	${result.receiveGd}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		            	<ax:field label="회의참석자">
		                	${result.conferenceAttendee}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		            	<ax:field label="회의장소">
		                	${result.conferenceArea}
		                </ax:field>
		            </ax:fields>
                	<ax:fields>
                		<ax:field label="내용">
				        	${result.content}
                        </ax:field>
                	</ax:fields>
<!-- 
                	<ax:fields>
                		<ax:field label="실행유무">
                			<c:forEach var="gbn" items="${operYn}" varStatus="status">
                				<c:if test="${result.operYn eq gbn.code}">${gbn.codeShtnm}</c:if>
                			</c:forEach>
                        </ax:field>
                	</ax:fields>
 -->                	                	
                	<ax:fields>
		                <ax:field label="관련공문">
		                	${result.relText}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="문서유형">
		                <table>
			                <c:forEach var="gbn" items="${docType}" varStatus="status">
			                <c:if test="${status.count%4 == 1}"><tr></c:if>
				                <td style="width:150px;">
				                	<input type="checkbox" name="doc_type" title="문서유형" value="${gbn.code}"
				                		<c:forEach var="docType2" items="${result.docType}">
				                			<c:if test="${docType2 eq gbn.code}">checked</c:if>
				                		</c:forEach>
				                   	 disabled /> &nbsp;&nbsp;${gbn.codeShtnm}&nbsp;&nbsp;
				                </td>
			                <c:if test="${status.count%4 == 0}"></tr></c:if>
			                </c:forEach>
			            </table>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
                		<ax:field label="비고">
				             ${result.notes}
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="첨부파일">
			               	<c:forEach var="fileList" items="${fileList}" varStatus="status">
				               	<a	href="#" onclick="window.open(encodeURI('<c:url value='/download/downloadFile.do?'/>requestedFile=${fileList.streFileNm}&oriFilenm=${fileList.orignlFileNm}'))">
		                		<c:out value="${fileList.orignlFileNm}" /></a>        
		                		<br>
	                		</c:forEach>
	                			<c:if test="${fileList.size() == 0}">없음</c:if>
                        </ax:field>
                	</ax:fields>
                
                 <c:set var="cnt" value="0"/>
                <c:forEach var="result2" items="${apprList}" varStatus="status">
                	<c:if test="${result2.complete eq '1'}">
                		<c:set var="cnt" value="1"/>
                	</c:if>
                </c:forEach>
                
               	<c:if test="${result.status eq '110' &&  manageYn eq 'Y'}">
	                <input type="hidden" name="userId" id="userId" value="${sessionScope['userInfo']['userId']}" />
	                <c:if test="${cnt eq '0'}">
		                <ax:fields>
	                		<ax:field label="문서승인">
	                			<input type="radio" name="gbn" title="승인구분" value="001" class="av-required"/>승인
	                			<input type="radio" name="gbn" title="승인구분" value="002" class="av-required"/>반려
	                        </ax:field>
	                	</ax:fields>
	                	<ax:fields>
	                		<ax:field label="내용">
	                        	<div style="padding:5px">
					                <label class="AXInputLabel fullWidth">
					                    <textarea id="nttCn" name="nttCn" maxlength="1000" cols="75" rows="10" class="AXTextarea av-required" title="내용"></textarea>
					                </label>
					            </div>
	                        </ax:field>
	                	</ax:fields>
	                </c:if>
<!-- 	                
	                <c:if test="${cnt eq '1'}">
	                	<c:forEach var="result3" items="${apprList}" varStatus="status">
	                	<c:if test="${status.count eq apprList.size()}">
	                	<input type="hidden" name="seq" value="${result3.seq}"/>
	                		<ax:fields>
		                		<ax:field label="문서승인">
		                			<input type="radio" name="gbn" title="승인구분" value="001" class="av-required" <c:if test="${result3.gbn eq '001'}">checked</c:if> />승인
		                			<input type="radio" name="gbn" title="승인구분" value="002" class="av-required" <c:if test="${result3.gbn eq '002'}">checked</c:if> />반려
		                        </ax:field>
		                	</ax:fields>
		                	<ax:fields>
		                		<ax:field label="내용">
		                        	<div style="padding:5px">
						                <label class="AXInputLabel fullWidth">
						                    <textarea id="nttCn" name="nttCn" maxlength="1000" cols="75" rows="10" class="AXTextarea av-required" title="내용"><c:out value="${result3.opi}"/></textarea>
						                </label>
						            </div>
		                        </ax:field>
		                	</ax:fields>
		                </c:if>
	                	</c:forEach>
	                </c:if>
 -->	                
	            </c:if>
                <br>
                <div style="text-align:right;">

                <!-- :if test="${result.userId eq sessionScope['userInfo']['userId'] && result.status eq '100'}"-->
                <c:if test="${result.userId eq sessionScope['userInfo']['userId'] }">
		            <button type="button" id="save" class="AXButton" onclick="fnObj.moveSave();"><i class="axi axi-save"></i>수정</button>
		            <button type="button" id="save" class="AXButton" onclick="fnObj.docDelete();"><i class="axi axi-save"></i>삭제</button>		            
		            <!-- button type="button" id="save" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>승인요청</button-->
		        </c:if>
		       	<c:forEach var="jobItem" items="${sessionScope['userInfo']['jobCd'] }" varStatus="status">
					<c:if test="${jobItem eq result.jobCd}">
						<c:set var="jobCdYn" value="Y"/>
					</c:if>
				</c:forEach>
			    <c:if test="${manageYn eq 'Y' && result.status eq '110' && jobCdYn eq 'Y'}">
		        	<button type="button" id="approval" class="AXButton" onclick="fnObj.saveConfirm();"><i class="axi axi-save"></i>임시저장</button>
		        	<!-- button type="button" id="approval" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>검토완료</button -->
		        </c:if>
		        <c:if test="${manageYn eq 'Z'}">
		            <!-- Y → Z -->
		        	<button type="button" id="operYn" class="AXButton" onclick="fnObj.modalOpen();"><i class="axi axi-save"></i>실행유무변경</button>		        	
		        </c:if>
		            <button type="button" id="list" class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	            </div>
	            
                </c:forEach>
                </ax:form>
                <br>
<!--                 
                <h1>승인내역</h1>
                <ax:form name="apprForm">
                	<c:forEach var="result" items="${apprList}" varStatus="status">
	                	<c:if test="${result.complete eq '0'}">
				        	<ax:fields>
				            	<ax:field label="문서승인구분">
				            		${result.gbnName}
				                </ax:field>
				                <ax:field label="내용">
				                	<c:out value="${result.opi}"/>
					            </ax:field>
					            <ax:field label="처리자">
				                	${result.regName}(${result.regId})
					            </ax:field>
					            <ax:field label="처리일자">
					            	${result.regDttm}
					            </ax:field>
				            </ax:fields>
				        </c:if>
		            </c:forEach>
                </ax:form>
-->                
                
                <br>
<!--                  
                <h1>실행유무 변경내역</h1>
                <ax:form name="operForm">
                	<c:forEach var="result" items="${operList}" varStatus="status">
				        <ax:fields>
				        	<ax:field label="실행유무">
				        		${result.gbnName}
				            </ax:field>
				            <ax:field label="내용">
				            	<c:out value="${result.opi}"/>
					        </ax:field>
					        <ax:field label="변경자">
				            	${result.regName}(${result.regId})
					        </ax:field>
					        <ax:field label="변경일자">
					        	${result.regDttm}
					        </ax:field>
				        </ax:fields>
		            </c:forEach>
                </ax:form>
-->                
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    
	    if("${cnt}" == "1"){
	    	$("#type").val("U");
	    } else {
	    	$("#type").val("R");	    	
	    }
	    
    	var myValidator = new AXValidator();
    	var myModal = new AXModal();
		var fnObj = {
			pageStart: function(){
				myValidator.setConfig({
					targetFormName : "myForm"
					,checkCrlf:true
				});
				
				myModal.setConfig({
					windowID:"myModalContainer",
					displayLoading:true,
	                mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    }
				});
				
				gfnRequire();
			},
			moveSave: function(){
				location.href="docEdit.do?docNo="+$("#no").val()+"&docGbn="+$("#docGbn").val();
			},
			docDelete: function(){
				 var form = document.myForm;
		         var formData = new FormData(form);
		         
		         var url = "<c:url value='/docManagement/docDelete.json'/>";
		         $.ajax({
		        	 url: url,
	                 processData: false,
	                 contentType: false,
	                 data: formData,   	                    
	                 type: 'POST',
	                 success: function(res){
	                 	if(res.result.SUCCESS){
	                 		gfnDialog("완료되었습니다","Alert","확인","Red","fnObj.listForm()");
                        } else {
                       	gfnDialog("<b>Warning</b>&nbsp;실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Alert","확인","Red","");
                        }
	                 },
	                 error : null
	             });
			},			
			listForm: function(){
				location.href="<c:url value='/docManagement/docList_cfrc.do'/>";
			},
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				gfnConfirm("승인요청 하시겠습니까?","fnObj.stepForm();");
			},
			stepForm: function(){
				 var form = document.myForm;
		         var formData = new FormData(form);
		         
				 var url = "<c:url value='/docManagement/docNextStep.json'/>";
		         $.ajax({
		        	 url: url,
	                 processData: false,
	                 contentType: false,
	                 data: formData,   	                    
	                 type: 'POST',
	                 success: function(res){
	                 	if(res.result.SUCCESS){
	                 		gfnDialog("완료되었습니다","Alert","확인","Red","location.href='docView.do?docNo="+$("#no").val()+"&docGbn="+$("#docGbn").val()+"'");
                         } else {
                        		gfnDialog("<b>Warning</b>&nbsp;실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Alert","확인","Red","location.href='docView.do?docNo="+$("#no").val()+"&docGbn="+$("#docGbn").val()+"'");
                         }
	                 },
	                 error : null
	             });
			},
			saveConfirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red","");
					myValidator.getErrorElement().focus();
					return false;
				}else{
					//alert(	validateResult );
				}
				
				gfnConfirm("저장 하시겠습니까?","fnObj.saveForm();");
			},
			saveForm: function(){
				 var form = document.myForm;
		         var formData = new FormData(form);
		         
				 var url = "<c:url value='/docManagement/docStep.json'/>";
		         $.ajax({
		        	 url: url,
	                 processData: false,
	                 contentType: false,
	                 data: formData,   	                    
	                 type: 'POST',
	                 success: function(res){
	                 	if(res.result.SUCCESS){
	                 		gfnDialog("완료되었습니다","Alert","확인","Red","location.href='docView.do?docNo="+$("#no").val()+"&docGbn="+$("#docGbn").val()+"'");
                         } else {
                        	gfnDialog("<b>Warning</b>&nbsp;실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Alert","확인","Red","location.href='docView.do?docNo="+$("#no").val()+"&docGbn="+$("#docGbn").val()+"'");
                         }
	                 },
	                 error : null
	             });
			},
			srRequest: function(){
				location.href="<c:url value='/sr/srRegist.do'/>?docGbn="+$("#docGbn").val();
			},
   		    modalOpen: function(){
   		    	myModal.open({
   		    		url: "<c:url value='/docManagement/changeOperYn.do'/>",
		            pars: "",
		            top: 100,
		            width: 1024,
		            closeByEscKey: true
   		    	});
   		    }
		}
	    </script>
	</ax:div>
</ax:layout> 