<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="modal.jsp">
    <ax:set name="title" value="문서 목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
			<input type="hidden" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
				<div class="ax-search" id="page-search-box"></div>
				<div class="ax-button-group">
					<div class="right" style=" float:left;text-align:left; padding:10px 0 10px 0;">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="10">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>
				    <div class="right" style="text-align:right;padding:10px 0 10px 0;">
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
				<div id="divJobCdTree" class="divJobCdTree">
					<span>※ 클릭하면 추가됩니다.</span><span style="position:absolute; right:0px; cursor:pointer;" onclick="$('#divJobCdTree').hide();">[닫기]</span>
					<div id="AXTreeJob" style="height:180px; width:238px;  border:1px solid #cecece"></div>
				</div>
				<div id="popMask" class="popMask" onclick="$('#divJobCdTree').hide(); $(this).hide();"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var jobCd = "";
	    var strJobCd = "";
       	<c:forEach var="jobItem" items="${sessionScope['userInfo']['jobCd'] }" varStatus="status">
       	strJobCd = "${jobItem}";
		jobCd += strJobCd.trim()+","
		</c:forEach>
	    
	    var page_menu_id = "m010301";
	    var myGrid = new AXGrid();
	    var mySearch = new AXSearch();
	    var _this;
	    var fnObj = {
	        pageStart: function(){
	            this.search.bind();
	            this.bindEvent();	            
	            setSearchJobCd();
	            setTree();
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    fitToWidth: true,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
        						{key:"no", label:"번호", width:"140", align:"center"},
                                {key:"docNo", label:"문서번호", width:"140", align:"center"},
                                {key:"sendGd", label:"발신처", align:"center", width:"150"},
                                {key:"title", label:"제목", width:"350", align:"left"},
                                {key:"charger", label:"담당자", align:"center", width:"100"},
                                {key:"regDttm", label:"접수일", align:"center", width:"140"},
                                {key:"docGbnName", label:"문서구분", width:"100", align:"center"}
                    ],
                    body : {
                        onclick: function(){
                       		parent.setDocNo(this.item.pno,"["+this.item.docNo+"] "+this.item.title);
                			parent.myModal.isInformChanged=true;
                			parent.myModal.close();
                        },
	                    addClass: function(){
                        }
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }
                });

	        	setSearchParamJobCd();	
	        	var pars = mySearch.getParam();
	        	//alert(pars);
	        	myGrid.setList({
                    ajaxUrl:"<c:url value='/docManagement/getPopupList.do'/>", ajaxPars:"popYn=Y&checkPangInfo=ExcludeInfo&cno="+parent.document.getElementById("no").value + "&" + pars, 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        	
	        	_this = myGrid;
	        },
	        bindEvent: function(){
	            var _this = this;
 	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });  
	        },
	        search: {
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                mySearch.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
							{display:true, addClass:"", style:"", list:[
            					{label:"문서번호", labelWidth:"90", type:"inputText", width:"200", key:"docNo", addClass:"secondItem", valueBoxStyle:"", value:""},
            					{label:"발신처", labelWidth:"90", type:"inputText", width:"200", key:"sendGd", addClass:"secondItem", valueBoxStyle:"", value:""	},
            					{label:"수신처", labelWidth:"90", type:"inputText", width:"200", key:"receiveGd", addClass:"secondItem", valueBoxStyle:"", value:""	},
            					
            				]},
            				{display:true, addClass:"", style:"", list:[
            					{label:"업무", labelWidth:"90", type:"inputText", width:"", key:"jobCdDummy", addClass:"secondItem", valueBoxStyle:"", value:"" 
            						//,options:[{ optionValue:"11", optionText:"11"},{ optionValue:"22", optionText:"22"}]
            				    }
            				]},
	                        {display:true, addClass:"", style:"", list:[
	                            {label:"담당자", labelWidth:"90", type:"selectBox", width:"210", key:"charger", addClass:"secondItem", valueBoxStyle:"", value:"${sta}",
   	                            	options:[
	                                         {optionValue:"", optionText:"전체"}
	                                 	     <c:forEach var="srStat" items="${srStat}" varStatus="status">	                                 	     	
	                                 	     	,{optionValue:"${srStat.optionvalue}", optionText:"${srStat.optiontext}"}
	                             	   	     </c:forEach> 
	                             	   	     <c:if test="${not empty srStat}">
	                             	   	 		,{optionValue:"0000000000000", optionText:"기타(외부업체포함)"}
	                             	   	     </c:if>
	                             	   	     
	                             	   	     
	                                        ],
	            							AXBind:{
	            								type:"select", config:{
	            									onchange:function(){
	            										//toast.push(Object.toJSON(this));
	            									}
	            								}
	            							}
   	                            },
   	                         	{label:"문서구분", labelWidth:"90", type:"selectBox", width:"210", key:"docGbn", addClass:"secondItem", valueBoxStyle:"", value:"",
   	                            	options:[
	                                         {optionValue:"", optionText:"전체"}
	                                         <c:forEach var="docGbn" items="${docGbn}" varStatus="status">	                                 	     	
	                                 	     	,{optionValue:"${docGbn.code}", optionText:"${docGbn.codeShtnm}"}
	                             	   	     </c:forEach>
	                                        ],
	            							AXBind:{
	            								type:"select", config:{
	            									onchange:function(){
	            										//toast.push(Object.toJSON(this));
	            									}
	            								}
	            							}
   	                            },
   	                         	
	                        ]},
							{display:true, addClass:"", style:"", list:[
								{label:"참석자", labelWidth:"90", type:"inputText", width:"200", key:"attendee", addClass:"secondItem", valueBoxStyle:"", value:""	},
								{label:"접수일", labelWidth:"90", type:"inputText", width:"80", key:"sdate", addClass:"secondItem", valueBoxStyle:"", value:"",
									onChange: function(){}
								},
								{label:"", labelWidth:"", type:"inputText", width:"90", key:"edate", addClass:"secondItem", valueBoxStyle:"", value:"",
									AXBind:{
										type:"twinDate", config:{
											align:"right", valign:"top", startTargetID:"sdate", buttonText: "선택",
											onChange:function(){
												//toast.push(Object.toJSON(this));
											}
										}
									}
								}
							]}
	                    ]
	                });
	            },
	            submit: function(){
	            	setJobCdParam();
	            	
	                var pars = mySearch.getParam();
                    myGrid.setList({
                        ajaxUrl:"<c:url value='/docManagement/getPopupList.do'/>", ajaxPars:pars+"&popYn=Y&no="+parent.document.getElementById("no").value, 
                        onLoad:function(){
                            
                        }
                    });
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            }
	    };
	    axdom(document.body).ready(function(){fnObj.pageStart()});
	    
	    function setSearchJobCd() {	 
	    	$("input[name='jobCdDummy']").hide();
	    	$("input[name='jobCdDummy']").parent().append("<div style='float:left; vertical-align:middle;'><div id='jobAddArea' class='jobAddArea'></div></div>");	    	
	    	$("input[name='jobCdDummy']").parent().append("<div style='float:left; vertical-align:middle;'><button id='popJobCdBtn' class='jobSetBtn' onclick='popJobCd(); return false;'>추가</button><button id='btnSetMyJob' class='jobSetBtn' onclick='setMyJob(); return false;'>내 업무</button><button id='btnRemoveAllJob' class='jobSetBtn' onclick='removeAllJob(); return false;'>전체(모두제거)</button></div></div>");
	    	$("input[name='jobCdDummy']").parent().append("<div id='jobCdParam' style='width:0px; height:0px;'></div>");
	    	//$("input[name='jobCd']").parent().append("<div style='float:left; vertical-align:middle;'><span style='color:red; cursor:pointer;' onclick='removeAllJob();'>모두 제거</span></div>");
	    }
	    
	    function popJobCd() {
	    	var o = $("#popJobCdBtn").offset();
	    	$("#divJobCdTree").css("left", (o.left+60));
	    	$("#divJobCdTree").css("top", (o.top-100));
	    	popMaskOn();
	    	$("#divJobCdTree").show();
	    	
	    }
	    
        var jobTree = new AXTree();	

        

        function setTree() {
         	jobTree.setConfig({
    				targetID : "AXTreeJob",
    				theme: "AXTree_none",
    				//height:"auto",
    				xscroll:true,
    				showConnectionLine:true,
    				relation:{
                     // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
    					parentKey:"upperJobCd",
    					childKey:"jobCd"
    				},				
    				colGroup: [
    					{key:"jobName", label:"제목", width:"100%", align:"left", indent:true,
    						getIconClass: function(){
    							//folder, AXfolder, movie, img, zip, file, fileTxt, fileTag
    							//var iconNames = "company, folder, AXfolder, movie, img, zip, file, fileTxt, fileTag".split(/, /g);
    							
    							//var iconName = "folder";
    							if(this.item.__subTreeLength == 0) {
    								return "fileTxt";	     								
    							} else {
    								return "folder";
    							}
    						},        						
    						formatter:function(){
    							if(this.item.__subTreeLength == 0) {
    								//return "<input type='checkbox' name='jobCd1' value='"+this.item.jobCd+"'/>"+this.item.jobName;	     								
    							} else {
    								//return this.item.jobName;
    							}        							
    							return this.item.jobName;        							
    						}
    					},
    				],
    				body: {
    					onclick:function(idx, item){
    						if(item.__subTreeLength == 0) {
    							addJobCd(item.jobCd, getJobCdFullPath(item.jobCd));
    						} else {
    							addJobCdLowLevel(item.jobCd);	
    						}
    				 	}    					
    				}
    			});
         	var JobCdList = ${JOB_LIST} 
         	//console.log(JobCdList);
    		jobTree.setList(JobCdList);
    		
     	}
        function addJobCd(pJobCd, pJobName) {            	
        	if($("#jobAddArea span[jobcd='"+pJobCd+"']").length == 0) {
            	$("#jobAddArea").append("<span class='jobBtn' jobcd='"+pJobCd+"' onclick='removeJobCd(this);'>"+pJobName+"</span>");
        	} else {
        		//toast.push("이미 추가된 업무입니다.");
        	}
        }
        function removeJobCd(j) {
        	$(j).remove();
        	$("#jobAddArea").focus();
        }
        function removeAllJob() {
        	$('#jobAddArea').empty();
        }        
        function addAllJobCf() {
        	addAllJob();            	
        }   
        function addAllJob() {
        	$(jobTree.list).each(function() {
        		if(this.__subTreeLength == 0) {					
        			addJobCd(this.jobCd, getJobCdFullPath(this.jobCd));
        		}
        	});
        }
        function addJobCdLowLevel(pJobCd) {
        	$(jobTree.list).each(function() {
        		if(this.upperJobCd == pJobCd) {
   					if(this.__subTreeLength == 0) { //업무면 추가
   						addJobCd(this.jobCd, getJobCdFullPath(this.jobCd));
   					} else { //업무폴더면 하위 탐색   						
   						addJobCdLowLevel(this.jobCd);
   					}
        		}
        	});
        }
        function setMyJob() {
        	$('#jobAddArea').empty();
    	    var arrJobCd = new Array();
           	<c:forEach var="jobItem" items="${sessionScope['userInfo']['jobCd'] }" varStatus="status">
           	arrJobCd.push("${jobItem}");    		
    		</c:forEach>
    		
    		for(var i=0; i<arrJobCd.length; i++) {
    			addJobCd(arrJobCd[i], getJobCdFullPath(arrJobCd[i]));
    		}
    		//ZZZZZ
    		
        }
        //저장전에 선택된 업무값으로 변환
        function setJobCdParam() {
        	$("#jobCdParam").empty();            	
        	$("#jobAddArea span").each(function() {
        		$("#jobCdParam").append("<input type='hidden' name='jobCd'value='"+$(this).attr("jobcd")+"'/>");
        		//arrJobCd.push($(this).attr("jobcd"));
        	});
        }
        
        function getJobCdFullPath(pJobCd) {
        	var fullpath = "";
        	$(jobTree.list).each(function() {
            	if(this.jobCd == pJobCd){
					for(var i=0;i<this.namePath.length;i++){
						fullpath = fullpath + this.namePath[i];
						if(i!=(this.namePath.length-1)){
							fullpath = fullpath + " > ";
						}
					}
				}
        	});
        	return fullpath;
        }
        function setSearchParamJobCd() {
           	$("#jobCdParam").empty();            	
           	$("#jobAddArea span").each(function() {
           		$("#jobCdParam").append("<input type='hidden' name='jobCd'value='"+$(this).attr("jobcd")+"'/>");           		
           	});     	
        }
        
        function setSearchParamJobCd2() {           	      	
            var arrParam = new Array();
           	$("#jobAddArea span").each(function() {
           		arrParam.push($(this).attr("jobcd"));
           		//$("#jobCdParam").append("<input type='hidden' name='jobCd'value='"+$(this).attr("jobcd")+"'/>");           		
           	});
        	if($("#jobCdParam input").length == 0) {
        		return null;
        	} else {
        		return arrParam;
        	}           	
           	
        }        
        
        function popMaskOn(){            
            var winHeight = $(document).height();  
            var winWidth = $(window).width();            
            $('#popMask').css({'width':winWidth,'height':winHeight});
            $('#popMask').show();
        }
       
	    </script>
        <style>
        	.divJobCdTree {z-index:9001; background-color:white; display:none; padding:2px 0px 0px 0px; margin:0px; width:240px; height:200px; border:1px solid gray; position:absolute;}
        	.jobAddArea {padding:2px 0px 2px 2px; text-align:left; width:500px; height:45px; border:1px solid #cecece; line-height:23px; overflow-y:scroll;}
        	.jobBtn {padding:2px; margin-right:4px; margin-bottom:2px; background-color:#FAFAFA; border:1px solid #B6B6B6; cursor:pointer;}
        	.jobSetBtn {margin-left:2px; padding:3px; border:1px solid #CECECE; color:#616161; background-color:#FAFAFA; border-radius: 2px; cursor:pointer;}
        	.popMask{position:absolute;left:0;  top:0;  z-index:9000; display:none;}        	
        </style>
	</ax:div>
	
	
</ax:layout>