<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="이슈관리 목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>

	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
			<input type="hidden" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
				<div class="ax-search" id="page-search-box"></div>      
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="10">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>
				    <div class="right">
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>				    
				        <!-- button type="button" class="AXButton" onclick="fnObj.downExcelIssues();"><i class="axi axi-download"></i> 엑셀다운로드</button-->				    
				        <button type="button" class="AXButton" onclick="execelDN2();"><i class="axi axi-download"></i> 엑셀다운로드</button>				    
				        <button type="button" class="AXButton" onclick="fnObj.regIssues();" ><i class="axi axi-save"></i> 이슈사항 등록</button>
				    </div>
				    <br><br><br>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
			<form name="popforms">
				<input type="hidden" name="businessName">
				<input type="hidden" name="taskOrderName">
				<input type="hidden" name="issuesTitle">
				<input type="hidden" name="issuesSeverasc">
				<input type="hidden" name="issuesImportanceSc">
				<input type="hidden" name="issuesStatusSc">
				<input type="hidden" name="isOcTime">
				<input type="hidden" name="isEsime">
				<input type="hidden" name="isClTime">
			</form>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">

		    function execelDN2() {
				var myform = document.popforms;
				var url = "<c:url value='/issues/issuesExcelDown.json'/>";
				myform.action = url;
				myform.method = "post";
				myform.businessName.value   	= $("input[name=businessName]").val();
				myform.taskOrderName.value   	= $("input[name=taskOrderName]").val();
				myform.issuesTitle.value   		= $("input[name=issuesTitle]").val();
				myform.issuesSeverasc.value   	= $("input[name=issuesSeverasc]").val();
				myform.issuesImportanceSc.value = $("input[name=issuesImportanceSc]").val();
				myform.issuesStatusSc.value   	= $("input[name=issuesStatusSc]").val();
				myform.isOcTime.value   		= $("input[name=isOcTime]").val();
				myform.isEsime.value   			= $("input[name=isEsime]").val();
				myform.isClTime.value   		= $("input[name=isClTime]").val();
				myform.submit();
			}	    
	    </script>	
	    <script type="text/javascript">
	    var date = new Date();
	    var vYear = date.getFullYear();
	    var vSdate = vYear+"-01-01"; 
	    var vEdate = vYear+"-12-31";
	    
	    
	    var page_menu_id = "m010301";
	    var myGrid = new AXGrid();
	    var myModal = new AXModal();
	    var fnObj = {
	        pageStart: function(){

	            this.search.bind();
	            this.bindEvent();
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	            var gridHeight = fnObj.getWidgetHeight();
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    
                    //sort:false, 정렬을 원하지 않을 경우 (tip)
                    //fitToWidth:true, // 너비에 자동 맞춤	        	

                    // mergeCells: true|false|Array -- 전체셀병합,병합안함,지정된 인덱스열만 병합
                    //mergeCells: true,  // 모든 셀을 병합합니다.
                    //mergeCells: [1],   // 인덱스 1의 셀을 병합합니다.  
                    //mergeCells: [7],   // 인덱스 3, 4 셀을 머지하지만 앞의 셀이 머지 되었을 때만 다음셀을 병합합니다.
                    
                    fitToWidth: false,
                    height:gridHeight,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                                {key:"sno", label:"번호", width:"70", align:"center", valign:"top"},
                                {key:"ftitle", label:"사업(요구사항)명칭", width:"400", align:"left", formatter:function(){
                                    return this.item.businessName + " (" + this.item.requirementsName + ")" ;
                                }},
                                {key:"issuesOccurrenceTime", label:"발생일자", width:"100", align:"center"},
                                {key:"issuesEstimatedTime", label:"종료예정일자", width:"100", align:"center"},
                                {key:"issuesClosingTime", label:"종료일자", width:"100", align:"center"},
                                {key:"issuesSeveralNm", label:"중요도", width:"70", align:"center"},
                                {key:"issuesImportanceNm", label:"긴급성", width:"70", align:"center"},
                                {key:"issuesStatusNm", label:"진행여부", width:"70", align:"center"},
                                {key:"issuesTitle", label:"이슈제목", width:"*", align:"left"}
                    ],
/*                    
                    colHead : {
    	                heights: [30,30],
                        rows: [
                            [
								{colSeq: 0, rowspan: 2},
								{colSeq: 1, rowspan: 2},
								{colSeq: 3, rowspan: 2},
								{colSeq: 4, rowspan: 2},
								{colSeq: 5, rowspan: 2},
								{colSeq: 6, rowspan: 2},
								{colSeq: 7, rowspan: 2},
								{colSeq: null, colspan: 4, label: "휴가", align: "center"},
                            ],
							[
								{colSeq: 8},
								{colSeq: 9},
							]
						]
					},
*/					
                    body : {
                        onclick: function(){
                        	// this.item.issuesSno
                        	//var issuesSno  = '702a9b1dcca337b4e166c4f136133fc1';
                        	var issuesSno  = this.item.issuesSno;
            				location.href="<c:url value='/issues/issuesView.do'/>?issuesSno="+issuesSno+"";                        	
                        }
                    }
                });

	        	myGrid.setList({
                    ajaxUrl:"<c:url value='/issues/getIssuesList.do' />", ajaxPars:"", 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        	
	        	myModal.setConfig({
					windowID:"myModalCT", width:740,
	                mediaQuery: {
	                    mx:{min:0, max:767}, dx:{min:767}
	                },
					displayLoading:true,
	                scrollLock: true,
					onclose: function(){
					}
				});
	        	
	        },
	        bindEvent: function(){
	            var _this = this;
	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
	                             {label:"사업명칭", labelWidth:"", type:"inputText", width:"200", key:"businessName", addClass:"secondItem", valueBoxStyle:"", value:"",
	                             	onChange: function(changedValue){
	                             		//toast.push(Object.toJSON(this));
	                             	}
	                             },
	                             {label:"사업명칭", labelWidth:"", type:"inputText", width:"200", key:"taskOrderName", addClass:"secondItem", valueBoxStyle:"", value:"",
	                             	onChange: function(changedValue){
	                             	//toast.push(Object.toJSON(this));
	                             	}
	                             },
	                             {label:"이슈제목", labelWidth:"", type:"inputText", width:"200", key:"issuesTitle", addClass:"secondItem", valueBoxStyle:"", value:"",
	                             	onChange: function(changedValue){
	                             	//toast.push(Object.toJSON(this));
	                             	}
	                             }  
	                        ]},
							{display:true, addClass:"", style:"", list:[
								{label:"중요도", labelWidth:"", type:"selectBox", width:"210", key:"issuesSeverasc", addClass:"secondItem", valueBoxStyle:"", value:"",
									options:[
				                                {optionValue:"", optionText:"전체"}
												<c:forEach var="charger" items="${isus01}" varStatus="status">	                           	     	
												 	,{optionValue:"${charger.code}", optionText:"${charger.codeShtnm}"}
												</c:forEach> 
				                            ],
									AXBind:{
										type:"select", config:{
											onchange:function(){/*toast.push(Object.toJSON(this));*/}
											}
									}
							    },
							 	{label:"긴급성", labelWidth:"", type:"selectBox", width:"210", key:"issuesImportanceSc", addClass:"secondItem", valueBoxStyle:"", value:"",
									options:[
				                                {optionValue:"", optionText:"전체"}
												<c:forEach var="charger" items="${isus02}" varStatus="status">	                           	     	
												 	,{optionValue:"${charger.code}", optionText:"${charger.codeShtnm}"}
												</c:forEach> 
				                            ],
									AXBind:{
										type:"select", config:{
											onchange:function(){/*toast.push(Object.toJSON(this));*/}
											}
									}
							    },
							 	{label:"진행유형", labelWidth:"", type:"selectBox", width:"200", key:"issuesStatusSc", addClass:"secondItem", valueBoxStyle:"", value:"",
									options:[
				                                {optionValue:"", optionText:"전체"}
												<c:forEach var="charger" items="${sts010}" varStatus="status">	                           	     	
												 	,{optionValue:"${charger.code}", optionText:"${charger.codeShtnm}"}
												</c:forEach> 
				                            ],
									AXBind:{
										type:"select", config:{
											onchange:function(){/*toast.push(Object.toJSON(this));*/}
										}
									}
							    },                                                   
							 ]},	                        
							{display:true, addClass:"", style:"", list:[
							   {label:"발생일자", labelWidth:"", type:"inputText", width:"200", key:"isOcTime", addClass:"secondItem", valueBoxStyle:"", value:"",
								   	AXBind:{
								   		type:"date", config:{
								   		align:"right", valign:"top", startTargetID:"", buttonText: "선택",
								   			onChange:function(){
								   			//toast.push(Object.toJSON(this));
								   			}
								   	}}
							   },
							   {label:"종료예정", labelWidth:"", type:"inputText", width:"200", key:"isEsime", addClass:"secondItem", valueBoxStyle:"", value:"",
								   	AXBind:{
								   		type:"date", config:{
								   		align:"right", valign:"top", startTargetID:"", buttonText: "선택",
								   			onChange:function(){
								   			//toast.push(Object.toJSON(this));
								   			}
								   	}}
							    },
							    {label:"완료일자", labelWidth:"", type:"inputText", width:"200", key:"isClTime", addClass:"secondItem", valueBoxStyle:"", value:"",
								   	AXBind:{
								   		type:"date", config:{
								   		align:"right", valign:"top", startTargetID:"", buttonText: "선택",
								   			onChange:function(){
								   			//toast.push(Object.toJSON(this));
								   			}
							      	    }  
							        }
							    }
							]},
	                    ]
	                });
	            },
	            submit: function(){
	                var pars = this.target.getParam();
                    myGrid.setList({
                        ajaxUrl:"<c:url value='/issues/getIssuesList.do' />", ajaxPars:pars, 
                        onLoad:function(){
                        }
                    });
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            },
            regIssues: function(){
                location.href="<c:url value='/issues/issuesReg.do'/>";
            },     
            execelDN: function(){
            	//alert("asdasdasd");
            	var url = "<c:url value='/taam/downExcel.json'/>";
			    window.open('','popForm','location=yes,scrollbars=yes,toolbar=yes,menubar=yes,resizable=yes,width=500,height=200,left=0,top=0');
            	
            },            
    		getWidgetHeight : function(){
    			var windowHeight = $(window).height();
    			
    			return windowHeight-320;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            }
            
	    };
	    
	    
	    </script>
	</ax:div>
</ax:layout>