<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"
%><ax:layout name="modal.jsp">

   <ax:set name="title" value="공문/법령 상세보기" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post" enctype="multipart/form-data">
                <c:forEach var="result" items="${list}" varStatus="status">
                <input type="hidden" name="no" id="no" value="${result.pno}" />
                <input type="hidden" name="status" id="status" value="${result.status}" />
                <input type="hidden" name="docGbn" id="docGbn" value="${result.docGbn}" />
                <input type="hidden" name="type" id="type" value="R" />
                <c:set var="relText" value="[${result.docNo}] ${result.title}"/>
		            <ax:fields>
		                <ax:field label="제목">
		                	${result.title}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
                		<ax:field label="업무">
                			${result.jobName}
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="문서구분">
                			<c:forEach var="gbn" items="${docGbn}" varStatus="status">
                				<c:if test="${result.docGbn eq gbn.code}">${gbn.codeShtnm}</c:if>
                			</c:forEach>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
		                <ax:field label="담당자">
		                	${result.chargerName}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="문서번호">
		                	${result.docNo}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="시행일자">
		                	${result.date}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="발신처">
		                	${result.sendGd}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		            	<ax:field label="수신처">
		                	${result.receiveGd}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="작성자">
		                	${result.regName}(${result.regId})
		                </ax:field>
		                <ax:field label="작성일자">
		                	${result.regDttm}
		                </ax:field>
		            </ax:fields>
                	<ax:fields>
                		<ax:field label="내용">
                			${result.content}
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="실행유무">
                			<c:forEach var="gbn" items="${operYn}" varStatus="status">
                				<c:if test="${result.operYn eq gbn.code}">${gbn.codeShtnm}</c:if>
                			</c:forEach>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
		                <ax:field label="관련공문">
		                	${result.relText}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="문서유형">
		                <table>
			                <c:forEach var="gbn" items="${docType}" varStatus="status">
			                <c:if test="${status.count%4 == 1}"><tr></c:if>
				                <td style="width:150px;">
				                	<input type="checkbox" name="doc_type" title="문서유형" value="${gbn.code}"
				                		<c:forEach var="docType2" items="${result.docType}">
				                			<c:if test="${docType2 eq gbn.code}">checked</c:if>
				                		</c:forEach>
				                   	 disabled /> &nbsp;&nbsp;${gbn.codeShtnm}&nbsp;&nbsp;
				                </td>
			                <c:if test="${status.count%4 == 0}"></tr></c:if>
			                </c:forEach>
			            </table>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
                		<ax:field label="비고">
				            ${result.notes}
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="첨부파일">
			               	<c:forEach var="fileList" items="${fileList}" varStatus="status">
				               	<a	href="#" onclick="window.open(encodeURI('<c:url value='/download/downloadFile.do?'/>requestedFile=${fileList.streFileNm}&oriFilenm=${fileList.orignlFileNm}'))">
		                		<c:out value="${fileList.orignlFileNm}" /></a>
		                		<br>
	                		</c:forEach>
	                			<c:if test="${fileList.size() == 0}">없음</c:if>
                        </ax:field>
                	</ax:fields>

                 <c:set var="cnt" value="0"/>
                <c:forEach var="result2" items="${apprList}" varStatus="status">
                	<c:if test="${result2.complete eq '1'}">
                		<c:set var="cnt" value="1"/>
                	</c:if>
                </c:forEach>

               	<c:if test="${result.status eq '110' &&  manageYn eq 'Y'}">
	                <input type="hidden" name="userId" id="userId" value="${sessionScope['userInfo']['userId']}" />
	                <c:if test="${cnt eq '0'}">
		                <ax:fields>
	                		<ax:field label="문서승인">
	                			<input type="radio" name="gbn" title="승인구분" value="001" class="av-required"/>승인
	                			<input type="radio" name="gbn" title="승인구분" value="002" class="av-required"/>반려
	                        </ax:field>
	                	</ax:fields>
	                	<ax:fields>
	                		<ax:field label="내용">
	                        	<div style="padding:5px">
					                <label class="AXInputLabel fullWidth">
					                    <textarea id="nttCn" name="nttCn" maxlength="1000" cols="75" rows="10" class="AXTextarea av-required" title="내용"></textarea>
					                </label>
					            </div>
	                        </ax:field>
	                	</ax:fields>
	                </c:if>
	                <c:if test="${cnt eq '1'}">
	                	<c:forEach var="result3" items="${apprList}" varStatus="status">
	                	<c:if test="${status.count eq apprList.size()}">
	                	<input type="hidden" name="seq" value="${result3.seq}"/>
	                		<ax:fields>
		                		<ax:field label="문서승인">
		                			<input type="radio" name="gbn" title="승인구분" value="001" class="av-required" <c:if test="${result3.gbn eq '001'}">checked</c:if> />승인
		                			<input type="radio" name="gbn" title="승인구분" value="002" class="av-required" <c:if test="${result3.gbn eq '002'}">checked</c:if> />반려
		                        </ax:field>
		                	</ax:fields>
		                	<ax:fields>
		                		<ax:field label="내용">
		                        	<div style="padding:5px">
						                <label class="AXInputLabel fullWidth">
						                    <textarea id="nttCn" name="nttCn" maxlength="1000" cols="75" rows="10" class="AXTextarea av-required" title="내용"><c:out value="${result3.opi}"/></textarea>
						                </label>
						            </div>
		                        </ax:field>
		                	</ax:fields>
		                </c:if>
	                	</c:forEach>
	                </c:if>
	            </c:if>
                <br>
                <div style="text-align:right;">
		            <button type="button" id="list" class="AXButton" onclick="parent.myModal.close();"><i class="axi axi-close"></i>닫기</button>
	            </div>

                </c:forEach>
                </ax:form>
                <br>
                <h1>승인내역</h1>
                <ax:form name="apprForm">
                	<c:forEach var="result" items="${apprList}" varStatus="status">
	                	<c:if test="${result.complete eq '0'}">
				        	<ax:fields>
				            	<ax:field label="문서승인구분">
				            		${result.gbnName}
				                </ax:field>
				                <ax:field label="내용">
				                	<c:out value="${result.opi}"/>
					            </ax:field>
					            <ax:field label="처리자">
				                	${result.regName}(${result.regId})
					            </ax:field>
					            <ax:field label="처리일자">
					            	${result.regDttm}
					            </ax:field>
				            </ax:fields>
				        </c:if>
		            </c:forEach>
                </ax:form>

                <br>
                <h1>실행유무 변경내역</h1>
                <ax:form name="operForm">
                	<c:forEach var="result" items="${operList}" varStatus="status">
				        <ax:fields>
				        	<ax:field label="실행유무">
				        		${result.gbnName}
				            </ax:field>
				            <ax:field label="내용">
				            	<c:out value="${result.opi}"/>
					        </ax:field>
					        <ax:field label="변경자">
				            	${result.regName}(${result.regId})
					        </ax:field>
					        <ax:field label="변경일자">
					        	${result.regDttm}
					        </ax:field>
				        </ax:fields>
		            </c:forEach>
                </ax:form>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="js">
		<script type="text/javascript" src="<c:url value='/axu/plugins/axisj/dist/AXValidator.js' />"></script>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">

	    if("${cnt}" == "1"){
	    	$("#type").val("U");
	    } else {
	    	$("#type").val("R");
	    }

    	var myValidator = new AXValidator();
    	var myModal = new AXModal();
		var fnObj = {
			pageStart: function(){
			},
			listForm: function(){
				location.href="<c:url value='/lmrc/lmrcList.do'/>";
			}
		}
	    </script>
	</ax:div>
</ax:layout>