<%@ page contentType="text/html; charset=UTF-8"
        %><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
        %><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
        %><ax:layout name="modal.jsp">
    <ax:div name="header">
        <h1>비밀번호 재설정</h1>
    </ax:div>
    <ax:div name="contents">
       	<ax:form name="resetPassword" method="post" action="<c:url value='/login/findId.json'/>">
            <ax:fields>
                <ax:field label="<font color='red'>*</font>성명" itemcss="fullWidth">
                    <input type="text" name="name" title="성명" placeholder="" value="" class="AXInput av-required W300" />
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="<font color='red'>*</font>E-Mail" itemcss="fullWidth">
                    <input type="text" name="email" title="E-Mail" placeholder="" value="" class="AXInput av-required W300" />
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="<font color='red'>*</font>ID" itemcss="fullWidth">
                	<input type="text" name="loginId" title="ID" placeholder="" value="" class="AXInput av-required W300" />
                </ax:field>
            </ax:fields>
        </ax:form>
        <div class="H20"></div>
        <ax:row>
            <ax:col size="12" wrap="true">
            	<span id="emailMessage"></span>
            	<!-- 
					<b>※ 시스템이 E-mail 서버와 연동되지 않았습니다. 재설정 된 비밀번호는 관리자에게 문의 하세요.</b>
            	 -->
            </ax:col>
        </ax:row>
    </ax:div>
    <ax:div name="buttons">
        <button type="button" class="AXButton" onclick="fnObj.form.save();">확인</button>
        <button type="button" class="AXButton" onclick="parent.myModal.close();">닫기</button>
    </ax:div>
    <ax:div name="scripts">
        <script type="text/javascript">
            if ("${message}") {
                dialog.push("${message}");
            }

            var fnObj = {
                pageStart: function(){
                    this.form.init();
                    this.bindEvent();
                },
                pageResize: function(){
                    parent.myModal.resize();
                },
                bindEvent:function (){
                    $("form input").keypress(function(event){
                    	if(event.which==13){
                    		fnObj.form.save();
                    	}
                    });
                },
                form:{
                    validator: new AXValidator(),
                    init: function(){
                        this.validator.setConfig({
                            targetFormName : "resetPassword"
                        });
                    },
                    save: function(){

                        var validateResult = this.validator.validate();
                        if (!validateResult) {
                            var msg = this.validator.getErrorMessage();
                            toast.push(msg);
                            this.validator.getErrorElement().focus();
                            return false;
                        }else{
                            // 통과
                        }
                        

                        var url = "<c:url value='/login/resetPassword.json'/>";
                        var pars = $(document.resetPassword).serialize();
                        
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                    if(res.result.SUCCESS){
                                    	if(res.result.EMAIL_SENDED){
                                    		$("#emailMessage").html("<b>※ 입력하신 E-mail 주소로 변경한 임시패스워드를 발송하였습니다.</b>");
                                    	}else{
                                    		$("#emailMessage").html("<b>※ 시스템이 E-mail 서버와 연동되지 않았습니다. 재설정 된 비밀번호는 관리자에게 문의 하세요.</b>");
                                    	}
                                    }
                                   	toast.push(res.result.MESSAGE);
                                    
                                },
                                onerr:null
                            }
                        );
                        
                        return false;
                    }                    
                }
            };
            axdom(document.body).ready(function(){fnObj.pageStart()});
            axdom(window).resize(fnObj.pageResize);
        </script>
    </ax:div>
</ax:layout>