<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="프로젝트 목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
			<input type="hidden" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
				<div class="ax-search" id="page-search-box"></div>      
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="10">10</option>
							<option value="30">30</option>
							<option value="50" selected>50</option>
							<option value="100">100</option>
						</select>
					</div>
				    <div class="right">
				    <c:if test="${authority eq 'Y'}">
				    	<button type="button" class="AXButton" onclick="fnObj.regProject();" ><i class="axi axi-save"></i> 등록</button>
				    </c:if>
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    
	    var page_menu_id = "m010301";
	    var myGrid = new AXGrid();
	    var myModal = new AXModal();
	    var fnObj = {
	        pageStart: function(){

	            this.search.bind();
	            this.bindEvent();
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	            
            	
	            var gridHeight = fnObj.getWidgetHeight();
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    fitToWidth: false,
                    height:gridHeight,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"no"          , label:"No."            , width:"70"      , align:"center"},
                        {key:"programName" , label:"Program Name"   , align:"center"  , width:"200"},
                        {key:"programUrl"  , label:"Program Url "   , align:"center"  , width:"250"}
                    ],
                    body : {
                        onclick: function(){
                        	location.href="psView.do?projectid="+this.item.projectid;
                        }
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:50,
                        status:{formatter: null}
                    },
                    contextMenu: {
                        theme:"AXContextMenu", // 선택항목
                        width:"150", // 선택항목
                        menu:[
                            {
                                userType:1, label:"추가하기", className:"plus", onclick:function(){
                                	if("${authority}" == "N" && "${authority2}" == "N"){
                                		gfnDialog("추가권한을 가지고있지않습니다.","Alert","확인","Red","");
                                		return false;
                                	}
                                	
                                	fnObj.regProject();
                                }
                            },
                            {
                                userType:1, label:"삭제하기", className:"minus", onclick:function(){
                                	if("${sessionScope['userInfo']['userId']}" != this.sendObj.item.userId){
                                		gfnDialog("삭제할 수 없습니다.","Alert","확인","Red","");
                                		return false;
                                	}
                                	
                                    if(this.sendObj){
                                        fnObj.deleteConfirm(this.sendObj.item.projectid); // 전달한 개체와 비교하여 일치하는 대상을 제거 합니다. 이때 고유한 값이 아닌 항목을 전달 할 때에는 에러가 발생 할 수 있습니다.
                                    }
                                }
                            },
                            {
                                userType:1, label:"수정하기", className:"edit", onclick:function(){
                                	if("${sessionScope['userInfo']['userId']}" != this.sendObj.item.userId){
                                		gfnDialog("수정할 수 없습니다.","Alert","확인","Red","");
                                		return false;
                                	}
                                	
                                    if(this.sendObj){
                                        fnObj.editProject(this.sendObj.item.projectid);
                                    }
                                }
                            }
                        ],
                        filter:function(id){
                            return true;
                        }
                    }
                });
				
	            myGrid.setList({
                    ajaxUrl:"<c:url value="/cmm/getCmmSelectList.do"/>", ajaxPars:"sqlGbn=Menu.selectProgram&pageSize="+myGrid.page.pageSize+"&pageNo"+myGrid.page.pageNo, 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        	
	        	
	        	myModal.setConfig({
					windowID:"myModalCT", width:740,
	                mediaQuery: {
	                    mx:{min:0, max:767}, dx:{min:767}
	                },
					displayLoading:true,
	                scrollLock: true,
					onclose: function(){
					}
				});
                
	        },
	        bindEvent: function(){
	            var _this = this;
	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
	                            {label:"프로그램명", labelWidth:"", type:"inputText", width:"300", key:"programName", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));

	                                }
	                            }
	                        ]}
	                    ]
	                });
	            },
	            submit: function(){
	                var pars = this.target.getParam();
                    myGrid.setList({
                        ajaxUrl:"<c:url value="/cmm/getCmmSelectList.do"/>", ajaxPars:pars+"&sqlGbn=Menu.selectProgram"		, 
                        onLoad:function(){
                            
                        }
                    });
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            },
            regProject: function(){
            	myModal.open({
    				url:"<c:url value='/project/psReg.do' />",
    				pars:"",
    				top:100,
    				closeByEscKey:true
    			});
            },
            deleteConfirm: function(id){
            	gfnConfirm("삭제하시겠습니까?","fnObj.deleteProject('" + id + "');");
            },
            deleteProject: function(id){
            	var url = "<c:url value='/project/editProject.json' />";
            	var gbn = "D";
            	var userId = "${sessionScope['userInfo']['userId']}";
            	
            	new AXReq(url, 
                        {
                            pars:{projectid:id,gbn:gbn,userId:userId}, 
                            onsucc:function(res){
                                if(res.result.SUCCESS){
                                	gfnDialog("완료되었습니다","Alert","확인","Red","myGrid.reloadList();");
                                }else{
                                   	toast.push(res.result.MESSAGE);
                                }
                                
                            },
                            onerr:null
                        }
                    );
            },
            editProject: function(id){
            	myModal.open({
    				url:"<c:url value='/project/psEdit.do' />",
    				pars:{projectid:id},
    				top:100,
    				closeByEscKey:true
    			});
            },
    		getWidgetHeight : function(){
    			var windowHeight = $(window).height();
    			
    			return windowHeight-320;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            }
            
	    };
	    

	    </script>
	</ax:div>
</ax:layout>