<%@ page contentType="text/html; charset=UTF-8"
        %><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
        %><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
        %><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"
     %><ax:layout name="modal.jsp">
    <ax:div name="header">
        <h1>프로젝트 수정</h1>
    </ax:div>
    <ax:div name="contents">
    	<ax:row>
    		<ax:col size="12" wrap="false">
		       	<ax:form name="myForm" method="post">
		       	<c:forEach var="result" items="${list}" varStatus="status">
		       	<input type="hidden" name="gbn" value="U"/>
		       	<input type="hidden" name="projectido" id="projectido" value="${result.projectid}"/>
		       	<input type="hidden" name="loginId" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
		            <ax:fields>
		                <ax:field label="프로젝트ID">
		                	<input type="text" name="projectid" id="projectid" title="프로젝트ID" value="${result.projectid}" maxlength="14" class="AXInput av-required" />
		                	<button type="button" id="checkId" class="AXButtonSmall Blue"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i> 프로젝트ID 중복확인</button>
                    		<input type="hidden" name="isIdOverlapped" id="isIdOverlapped" value="false"/> 
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="프로젝트명">
		                	<input type="text" name="name" title="프로젝트명" value="<c:out value='${result.name}'/>" class="AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="등록자" >
			                ${result.userName}
		                </ax:field>
		                <ax:field label="등록일" >
			                ${result.regdthr}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="수정자" >
			                ${result.modName}
		                </ax:field>
		                <ax:field label="수정일" >
			                ${result.moddttm}
		                </ax:field>
		            </ax:fields>
		        </c:forEach>
		        </ax:form>
		        <div class="ax-clear"></div>
		        <div class="H20"></div>
		        <div>
		        	<div style="float:right;">
				        <button type="button" class="AXButton" onclick="fnObj.form.confirm();"><i class="axi axi-save"></i>저장</button>
				        <button type="button" class="AXButton" onclick="parent.myModal.close();"><i class="axi axi-ion-close-circled"></i>닫기</button>
		        	</div>
               	</div>
			</ax:col>
    	</ax:row>
    </ax:div>
     <ax:div name="scripts">
        <script type="text/javascript">
        var isChange = false;
        $("input, select").change(function(){
        	isChange  = true;
        });
        
            var deptTree = new AXTree();

            var fnObj = {
                pageStart: function(){
                    this.form.init();
                    this.bindEvent();
                    $("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                    $("#checkId").click(function(){
                    	
                    	var projectid = $("#projectid").val();
                    	var projectido = $("#projectido").val();
                    	
                    	if(projectid == projectido){
                    		return false;
                    	}
                    	
                    	if(projectid == ""){
                    		mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;ID를 기입후 확인하세요.",
                    	        buttons:[
                    	                   {
                    	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                    	                    	   mask.close();
                    	                       }
                    	                   }
                    	                ]
                    	        });
                    		return false;
                    	}
                    	
                    	var url = "<c:url value='/project/checkProjectid.json'/>";
                        var pars = {projectid:projectid};
                        
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                	mask.open();
                            		dialog.push({type:"Alert",top:100,body:res.result.MESSAGE,
                            	        buttons:[
                            	                   {
                            	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                            	                    	   mask.close();
                            	                       }
                            	                   }
                            	                ]
                            	        });
                                    if(res.result.SUCCESS){
                                    	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                                    	$("input[name='isIdOverlapped']").val("false");
                                    }else{
                                    	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                                    	$("input[name='isIdOverlapped']").val("true");
                                    }
                                    
                                },
                                onerr:null
                            }
                        );
                    });
                    $("input[name='projectid']").change(function(){
                    	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                    	$("input[name='isIdOverlapped']").val("true");
                    });
                },
                pageResize: function(){
                    parent.myModal.resize();
                },
                bindEvent:function (){
                    
                },
                form:{
                    validator: new AXValidator(),
                    init: function(){
                        this.validator.setConfig({
                            targetFormName : "myForm"
                        });
                    },
                    confirm:function(){

                        var validateResult = this.validator.validate();
                        if (!validateResult) {
                            var msg = this.validator.getErrorMessage();
                            toast.push(msg);
                            this.validator.getErrorElement().focus();
                            return false;
                        }else{
                            // 통과
                        }
                                                
                    	var isIdOverlappedObj = $("#isIdOverlapped").val();
        				
        				if(isIdOverlappedObj==""){
        					mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;아이디 중복확인을 해야합니다.",
                    	        buttons:[
                    	                   {
                    	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                    	                    	   mask.close();
                    	                       }
                    	                   }
                    	                ]
                    	        });
                        	$("#projectid").focus();
                        	return false;
                        }else if(isIdOverlappedObj=="true"){
                        	mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;다른 ID로 중복확인 후 등록바랍니다.",
                    	        buttons:[
                    	                   {
                    	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                    	                    	   mask.close();
                    	                       }
                    	                   }
                    	                ]
                    	        });
                        	$("#projectid").focus();
                        	return false;
                        }
        				
        				if(!isChange){
        					mask.open();
                        	dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;변경된 값이 없습니다.",
                    	        buttons:[
                    	                   {
                    	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                    	                    	   mask.close();
                    	                       }
                    	                   }
                    	                ]
                    	    });

	                    	return false;
    					}
        				
        				mask.open();
        				dialog.push({type:"Alert",top:100,body:"수정하시겠습니까?",
        			        buttons:[
        			                   {
        			                       buttonValue:"승인",buttonClass:"Green",onClick:function(){  mask.close(); fnObj.form.save();}
        			                   },
        			                   {
        			                	   buttonValue:"취소",buttonClass:"Red",onClick:function(){ mask.close(); }
        			                   }
        			                ]
        			        });
                    },
                    save: function(){
                    	
                    	var pars = $(document.myForm).serialize();
       		    		var url = "<c:url value='/project/editProject.json'/>";
       		    	 
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                    if(res.result.SUCCESS){
                                    	mask.open();
                                    	dialog.push({type:"Alert",top:100,body:"저장되었습니다.",
                                	        buttons:[
                                	                   {
                                	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                                	                    	   mask.close();
                                	                    	   parent.myGrid.reloadList();
                                	                    	   parent.myModal.close();
                                	                       }
                                	                   }
                                	                ]
                                	        });
                                    }else{
	                                   	toast.push(res.result.MESSAGE);
                                    }
                                    
                                },
                                onerr:null
                            }
                        );
                        
                        return false;
                    },
                    close: function(){
                        if(opener){
                            window.close();
                        }
                        else
                        if(parent){
                            if(parent.myModal) parent.myModal.close();
                        }
                        else
                        {
                            window.close();
                        }
                    }                    
                }
            };
            axdom(document.body).ready(function(){fnObj.pageStart()});
            //axdom(window).resize(fnObj.pageResize);
        </script>
    </ax:div>
</ax:layout>