<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="S/R 현황" />
     <ax:div name="css">
        <style type="text/css">
            .cell-title-top    {display:table-cell;width:50%;vertical-align:middle;text-align:center;font-size:16px;background-color:#F4F6FA;border-radius:10px 0 0 0;border:1px solid #F4F6FA; }
            .cell-title-middle {display:table-cell;width:50%;vertical-align:middle;text-align:center;font-size:16px;background-color:#F4F6FA;border:1px solid #F4F6FA; }
            .cell-title-bottom {display:table-cell;width:50%;vertical-align:middle;text-align:center;font-size:16px;background-color:#F4F6FA;border-radius:0 0 0 10;border:1px solid #F4F6FA; }
            
            .cell-top    {display:table-cell;width:50%;vertical-align:middle;text-align:right;font-size:16px;padding-right:10px;border-radius:0 10px 0 0;border:1px solid #efefef; }
            .cell-middle {display:table-cell;width:50%;vertical-align:middle;text-align:right;font-size:16px;padding-right:10px;border:1px solid #efefef; }
            .cell-bottom {display:table-cell;width:50%;vertical-align:middle;text-align:right;font-size:16px;padding-right:10px;border-radius:0 0 10 0;border:1px solid #efefef; }
        </style>
    </ax:div>
    <ax:div name="js">
    <script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jquery.jqplot.js'/>"></script>
    <script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.donutRenderer.min.js'/>"></script>    
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.highlighter.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.barRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.categoryAxisRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.canvasAxisTickRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.canvasAxisLabelRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.logAxisRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.canvasTextRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.pointLabels.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/js/charts/apexcharts.js' />"></script>
    </ax:div>
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
			<!-- table border="1" bordercolor="red" width="100%"-->
  		    <table width="100%">
			<tr valign="top">
			  	<td>
					<h1><i class="axi axi-ion-arrow-right-b"></i>&nbsp;S/R 현황</h1>
					<div style="margin-bottom:15px; margin-top:20px;">
						<button class="AXButton" onclick="fnSetDate(0);">일</button>
						<button class="AXButton" onclick="fnSetDate(-7);">주</button>
						<button class="AXButton" onclick="fnSetDate(-1,'m');">1개월</button>
						<button class="AXButton" onclick="fnSetDate(-3, 'm');">3개월</button>
					</div> 
					<div style="margin-bottom:25px;">
						<input type="text" name="sdate" id="AXInputDateST" value="<c:out value='${sdate}'/>" class="AXInput W80" /> ~ <input type="text" name="edate" id="AXInputDateED" value="<c:out value='${edate}'/>" class="AXInput W100" />
					</div>
					<div style="width:240px;height:300px;display:table;border-radius:10px;border:1px solid #CECECE;" >
					<c:forEach var="result" items="${srCondition}" varStatus="status">
                        <div style="display:table-row">
                            <div class='cell-title-top' >총 건 수</div>
                            <div class='cell-top'><a href="#" onclick="srlist('T');">${result.total}건</a></div>
                        </div>
                        <div style="display:table-row">
                            <div class='cell-title-middle' >처 리 중</div>
                            <div class='cell-middle'>
                                <a href="#" onclick="srlist('P');">${result.proc}건</a>
                            </div>
                        </div>
                        <div style="display:table-row">
                            <div class='cell-title-middle' >반 려 건</div>
                            <div class='cell-middle'>
                                <a href="#" onclick="srlist('R');">${result.returnc}건</a>
                            </div>
                        </div>
                        <div style="display:table-row">
                            <div class='cell-title-middle' >완 료</div>
                            <div class='cell-middle'>
                                <a href="#" onclick="srlist('C');">${result.complete}건</a>
                            </div>
                        </div>
                        <div style="display:table-row">
                            <div class='cell-title-bottom'>처 리 율</div>
                            <div class='cell-middle'>
                                ${result.procper}%
                            </div>
                        </div>
                    </c:forEach>
                </div>  
				</td>
	            <td style="padding-left:10px;">
					<div>
						<h1><i class="axi axi-bar-graph"></i>&nbsp; 챠트&nbsp;&nbsp; 
						<select name="gubun" id="gubun" class="AXSelect" onchange="changeChart2();">
							<option value="1" <c:if test="${gubun eq '1'}">selected</c:if> >부서별</option>
							<!-- option value="2" <c:if test="${gubun eq '2'}">selected</c:if> >유형별</option-->
							<option value="3" <c:if test="${gubun eq '3'}">selected</c:if> >업무별</option>
							<option value="4" <c:if test="${gubun eq '4'}">selected</c:if> >접수유형별</option>
						</select>&nbsp;
						<select name="form" id="form" class="AXSelect" onchange="changeChart();">
							<option value="1" <c:if test="${form eq '1'}">selected</c:if> >원형 그래프</option>
							<option value="2" <c:if test="${form eq '2'}">selected</c:if> >막대 그래프</option>
						</select>	
						</h1>
					</div>
					<div id="chartArea" style="border:1px solid #969696;border-radius:10px;width:760px;height:500px;">
		                <div id="newChart"  ></div>
	                </div>
	                <!-- //신 그래프가 잘 보이지는 확정될때까지  graphPad 유지하고 display:none; 처리. -->
					<div id="graphPad" class="graphPad" style="width:700px;display:none;">
						<div id="chart" style="width:700px; height:500px;" class="jqplot-target">
					    </div>
				    </div>
                </td>
            </tr>
            <tr>
            	<td colspan="2">
		             <br><br><br>
		             <h1><i class="axi axi-th-list"></i>&nbsp;조회결과 리스트</h1>
		             <div id="AXGridTarget"></div>            	
            	</td>
            </tr>
            </table>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	   
	    var oldStart = "${sdate}";
	    var oldEnd = "${edate}";
	    
	    	function srlist(val){
	    		var returnYn = "";
	    		var sta = "000";
	    		
	    		if(val == "C"){
	    			returnYn = "N";
	    		} else if(val == "R"){
	    			returnYn = "Y";
	    		} else if(val == "P"){
	    			returnYn = "";
	    			sta = "proc";
	    		} else {
	    			returnYn = "";
	    			sta = "";
	    		}
	    		
	    		location.href="<c:url value='/sr/srList.do'/>?sdate="+$("#AXInputDateST").val()+"&edate="+$("#AXInputDateED").val()+"&sta="+sta+"&returnYn="+returnYn;
	    	}
	    
	    	$("#gubun").bindSelect();
	    	$("#form").bindSelect();
	    
		    $("#AXInputDateED").bindTwinDate({
	            startTargetID: "AXInputDateST",
	            handleLeft: 25,
	            align: "right",
	            valign: "bottom",
	            separator: "",
	            buttonText: "선택",
	            onChange: function () {
	            	if(oldStart == $("#AXInputDateST").val() && oldEnd == $("#AXInputDateED").val()) return false;
	                location.href="<c:url value='/stats/srStats.do'/>?sdate="+$("#AXInputDateST").val()+"&edate="+$("#AXInputDateED").val()+"&gubun="+$("#gubun").val()+"&form="+$("#form").val();
	            }
	        });
		    
		    //★★★★ 부서별 ★★★★ 
		    var data1 = [
						<c:forEach var="result" items="${srDeptProcPer}" varStatus="status">	  
		                ["${result.deptname}(${result.cnt}건)",${result.cnt}],
		                </c:forEach>
		                <c:if test="${srDeptProcPer.size() eq 0}">
			               ['없음', 0]
			            </c:if>
		               ];
		    var data1tooltip = new Array();
		    <c:forEach var="result" items="${srDeptProcPer}" varStatus="status">
		    data1tooltip.push("${result.deptname}(${result.cnt}건) ${result.complete}%");   
	        </c:forEach>
	        
	        var data1barX = [
							<c:forEach var="result" items="${srDeptProcPer}" varStatus="status">	  
							"${result.deptname}",
				            </c:forEach>
							<c:if test="${srDeptProcPer.size() eq 0}">
				               ['없음', 0]
				            </c:if>
				            ]; 
	        
	        var data1barY = new Array();
							<c:forEach var="result" items="${srDeptProcPer}" varStatus="status">	  
			                data1barY.push(${result.cnt});
			                </c:forEach>
			                <c:if test="${srDeptProcPer.size() eq 0}">
			                data1barY.push(0);
				            </c:if>
	        
	        
	        //★★★★ 유형별 ★★★★
	        var data2 = [
							<c:forEach var="result" items="${srTypePer}" varStatus="status">	  
			                ["단순답변건(${result.answercnt}건)",${result.answercnt}],
			                ["개발필요건(${result.devcnt}건)",${result.devcnt}],
			                ["DB핸들링건(${result.dbcontrolcnt}건)",${result.dbcontrolcnt}]
			                </c:forEach>
			               ];
			var data2tooltip = new Array();
			<c:forEach var="result" items="${srTypePer}" varStatus="status">
			data2tooltip.push("단순답변건(${result.answercnt}건) ${result.answer}%");   
			data2tooltip.push("개발필요건(${result.devcnt}건) ${result.dev}%");   
			data2tooltip.push("DB핸들링건(${result.dbcontrolcnt}건) ${result.dbcontrol}%");   
		    </c:forEach>
		    
		    var data2barX = ["단순답변건","개발필요건","DB핸들링건"]; 
		        
		    var data2barY = [
								<c:forEach var="result" items="${srTypePer}" varStatus="status">	  
				                ${result.answercnt},${result.devcnt},${result.dbcontrolcnt}
				                </c:forEach>
				            ];
		    
		    //★★★★ 업무별 ★★★★
		    var data3 = [
							<c:forEach var="result" items="${srJobPer}" varStatus="status">	  
			                ["${result.jobname}(${result.cnt}건)",${result.cnt}],
			                </c:forEach>
			                <c:if test="${srJobPer.size() eq 0}">
				               ['없음', 0]
				            </c:if>
			               ];
			var data3tooltip = new Array();
			<c:forEach var="result" items="${srJobPer}" varStatus="status">
			data3tooltip.push("${result.jobfullname}(${result.cnt}건) ${result.complete}%");   
			</c:forEach>
			
			var data3barX = [
								<c:forEach var="result" items="${srJobPer}" varStatus="status">	  
								"${result.jobname}",
					            </c:forEach>
								<c:if test="${srJobPer.size() eq 0}">
					            "없음"
					            </c:if>
					            ]; 
		        
		   var data3barY = [
								<c:forEach var="result" items="${srJobPer}" varStatus="status">	  
				                ${result.cnt},
				                </c:forEach>
				                <c:if test="${srJobPer.size() eq 0}">
					            0
					            </c:if>
				           ]; 
	        
			//★★★★ 접수유형별 ★★★★
	        var data4 = [
							<c:forEach var="result" items="${srRcTypePer}" varStatus="status">	  
			                ["${result.typename}(${result.cnt}건)",${result.cnt}],
			                </c:forEach>
			                <c:if test="${srRcTypePer.size() eq 0}">
				               ['없음', 0]
				            </c:if>
			               ];
			var data4tooltip = new Array();
			<c:forEach var="result" items="${srRcTypePer}" varStatus="status">
			data4tooltip.push("${result.typename}(${result.cnt}건) ${result.complete}%");   
			</c:forEach> 
			
			var data4barX = [
								<c:forEach var="result" items="${srRcTypePer}" varStatus="status">	  
								"${result.typename}",
					            </c:forEach>
								<c:if test="${srRcTypePer.size() eq 0}">
					            "없음"
					            </c:if>
					            ]; 
		        
		    var data4barY = [
								<c:forEach var="result" items="${srRcTypePer}" varStatus="status">	  
				                ${result.cnt},
				                </c:forEach>
				                <c:if test="${srRcTypePer.size() eq 0}">
					            0
					            </c:if>
				            ]; 
	        
		    
		    
		    
		    var barCahrtData  = null;
    		var barChartTitle = null;
    		var chart = null;
    		
			var dashChart ={
		    		
            		
	            	view:function(){
	            		//alert("d");
	            		
	            		//alert($("#selGraph :selected").val());
	            		if(data1.length>1){
	            			//ion value="dept" selected>부서별 배포 처리건</option>
		                	//<option value="type" >유형별 배포 처리건</option>
		                	//<option value="job" >업무별 배포 처리건</option>
		                	//<option value="rcty" >S/R 접수유형별 배포 처리건</option>    
		                	barChartTitle = [];
		                	barCahrtData  = [];
		            		if($("#form :selected").val()=="1"){  // 원그래프
		            			
		            			if($("#gubun").val()=="1"){
		            				for(var i =0 ; i< data1.length;i++){
				            			barChartTitle[i]=data1[i][0];
				            			barCahrtData[i]=data1[i][1];
				            		}	
		            			}
		            			if($("#gubun").val()=="2"){
		            				for(var i =0 ; i< data2.length;i++){
				            			barChartTitle[i]=data2[i][0];
				            			barCahrtData[i]=data2[i][1];
				            		}	
		            			}
		            			if($("#gubun").val()=="3"){
		            				for(var i =0 ; i< data3.length;i++){
				            			barChartTitle[i]=data3[i][0];
				            			barCahrtData[i]=data3[i][1];
				            		}	
		            			}
		            			if($("#gubun").val()=="4"){
		            				for(var i =0 ; i< data4.length;i++){
				            			barChartTitle[i]=data4[i][0];
				            			barCahrtData[i]=data4[i][1];
				            		}	
		            			}
		            			
		            			
		            			$("#newChart").css("padding-left","100px");
		            			if(chart!=null){
		            				chart.destroy();
		            			}
		            			
		            			setTimeout("dashChart.donutChart()","600");
		            		}else if($("#form :selected").val()=="2"){
			            		
		            			
		            			if($("#gubun").val()=="1"){
		            				
				            			barChartTitle=data1barX;
				            			barCahrtData=data1barY;
				            			
		            			}
		            			if($("#gubun").val()=="2"){
		            				barChartTitle=data2barX;
			            			barCahrtData=data2barY;
		            			}
		            			if($("#gubun").val()=="3"){
		            				barChartTitle=data3barX;
			            			barCahrtData=data3barY;
		            			}
		            			if($("#gubun").val()=="4"){
		            				barChartTitle=data4barX;
			            			barCahrtData=data4barY;
		            			}
		            			
		            			$("#newChart").css("padding-left","20px");
		            			//$("#newChartBar").remvoe
		            			if(chart!=null){
		            				chart.destroy();
		            			}
		            			
		            			setTimeout("dashChart.barChart()","600");
		            			
		            			
		            		}
	            		}
	            		
	            		if(data1.length==1 ){
            				//$("#newChart").html("조회된 데이터가 없습니다.");
	            			$("#newChart").html("<center><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><font style='font-size:20px;'>조회 된 데이터가 없습니다.</font></center>");
            			}
	            		
            			
	            	},
	            	barChart:function(){
	            	        var options = {
            	        		title: {
	         		                text: "▣ "+$("#gubun :selected").text(),
	         		                offsetX: 0,
	         		                offsetY: 15,
	         		                style: {
	         		                    fontSize:  '18px',
	         		                    color:  '#969696'
	         		                  },
	         		            },
	            	            chart: {
	            	                height: 500,
	            	                type: 'bar',
	            	                events: {
	            	                    click: function(chart, w, e) {
	            	                        console.log(chart, w, e )
	            	                    }
	            	                },
	            	            },
	            	            //colors: colors,
	            	            plotOptions: {
	            	                bar: {
	            	                    columnWidth: '45%',
	            	                    distributed: true
	            	                }
	            	            },
	            	            dataLabels: {
	            	                enabled: true,
	            	            },
	            	            series: [{
	            	                data: barCahrtData
	            	            }],
	            	            xaxis: {
            		                categories: barChartTitle,
            		            },
            		            
	            	            tooltip: {
	        		                theme: 'light',
	        		                x: {
	        		                    show: true
	        		                },
	        		                y: {
	        		                    title: {
	        		                        formatter: function() {
	        		                            return '';
	        		                        }
	        		                    }
	        		                }
	        		            },
            		            legend: {
            		                show: true
            		            }
	            	        }

	            	        chart = new ApexCharts(
	            	            document.querySelector("#newChart"),
	            	            options
	            	        );
	            	        chart.render();
	            	},
	            	donutChart:function(){

	            		 var options = {
		                            title: {
		         		                text: "▣ "+$("#gubun :selected").text(),
		         		                offsetX: 0,
		         		                offsetY: 15,
		         		                style: {
		         		                    fontSize:  '18px',
		         		                    color:  '#969696'
		         		                  },
		         		            },
	            		            chart: {
	            		            	width:600,
	            		                type: 'donut',
	            		            },
	            		            legend:{
	            		            	fontSize:'14px',
	            		                itemMargin: {
	            		                    horizontal: 3,
	            		                    vertical: 3
	            		                }
	            		            },
	            		            series: barCahrtData,
	            		            labels:barChartTitle,
	            		            responsive: [{
	            		                breakpoint: 480,
	            		                options: {
	            		                }
	            		            }],
	            		        }

	            		       chart = new ApexCharts(
	            		            document.querySelector("#newChart"),
	            		            options
	            		        );
	            		        
	            		        chart.render();
	            	}
	        };
		    
		    
		    
		    
		    
		    
		    
			function drawChart(divId, data, tooltipData) {        
				//dashChart.view();
			    var plot = $.jqplot(divId, [data], {
			      //title:'업무별',
			      //seriesColors: ['#CE2020','#CE7620','#CEB320','#B7CE20','#69CE20','#FF4000','#20CE7A','#20CEB3','#20A7CE','#2072CE'], 
			      seriesDefaults: {
			        // make this a donut chart.
			       
			        renderer:$.jqplot.DonutRenderer,
			        rendererOptions:{
			          // Donut's can be cut into slices like pies.
			          sliceMargin: 2,
			          // Pies and donuts can start at any arbitrary angle.
			          startAngle: -90,
			          showDataLabels: true,   
			          dataLabels: 'label',
			          shadow: false
			        }        
			      }, 
			      grid:{
			    	  drawGridLines:false,
			          background: '#ffffff',      // CSS color spec for background color of grid.		          
			          borderWidth: 0,           // pixel width of border around grid.
			          shadow: false                // draw a shadow for grid
			      }, 
			      legend: {
			    	  fontSize:'10pt',
			          show: true,  
			          location: 'ne',     // compass direction, nw, n, ne, e, se, s, sw, w.
			          xoffset: 12,        // pixel offset of the legend box from the x (or x2) axis.
			          yoffset: 12,        // pixel offset of the legend box from the y (or y2) axis.
			      },
	 	          highlighter: {  
		        	  show: true,  
		        	  showMarker:true,
		        	  formatString:"%d",
		        	  tooltipLocation:'n', 
		        	  useAxesFormatters:false, 
		        	  tooltipContentEditor: function(str, seriesIndex, pointIndex, plot){
	                      return tooltipData[pointIndex];
	                  }        // pixels to add to the size of filled markers when drawing highlight.                  
		          }     
			    }); 
			}
			
			function drawChartBar(divId,data,ticks,tooltipData,label){
				
				  var pBarWidth = null;
				  var pAngle = null;
				  if(data.length >= 10) pAngle = -30;
				  var divWidth = $("#chart").width();
				  var datalength = data.length;
				  var widthX = Math.floor(( divWidth / datalength ) * 0.2);
				  
				  var maxNum = 0;
				  for(var i = 0; i<data.length; i++) {
					  if(maxNum < data[i][1]) maxNum = data[i][1];
				  }
				  var yInterval = 10;
				  var vPadMax = 1.2;
				  if(maxNum > 10) {
					  vPadMax = 1.1;
					  yInterval = Math.ceil((maxNum*vPadMax)/9);
				  }
				
				var plot1 = $.jqplot(divId, [data], {
			        seriesDefaults:{
			        	pointLabels: { show: true, location: 'n', edgeTolerance: -15 },
			            renderer:$.jqplot.BarRenderer,
			            rendererOptions: {
			            	fillToZero: true,
			            	varyBarColor: true,
			            	barMargin: widthX
			            }
			        },
			        series:[
							{pointLabels:{
							      show: true,				              
							      location:'s',
							      fontColor:'#ffffff'
							    }}]
			        ,
			        axes: {
			        	xaxis:{
			        		  ticks: ticks,
					    	  label:label,
					    	  renderer:$.jqplot.CategoryAxisRenderer  
	 				          ,tickOptions:{
					              angle: pAngle,
					              labelPosition: 'middle', 
					              fontSize:'10pt',
					              showGridline: false
					           } 
					          ,tickRenderer:$.jqplot.CanvasAxisTickRenderer      
					    	},
					      yaxis:{padMax:vPadMax,     
					    	  	min:0,
					    	  	tickInterval: yInterval,
					    	  	tickOptions: {
					    	  		formatString: '   %d',
					    	  		fontSize:'8pt',
					    	  		showGridline: true
					    	  	}, 
					    	  	label:'건수'
					    	  	
					        }
			        },
		 	        highlighter: {  
			        	show: true,  
			        	showMarker:false,
			        	formatString:"%s",
			        	tooltipLocation:'ne', 
			        	useAxesFormatters:false, 
			        	tooltipContentEditor: function(str, seriesIndex, pointIndex, plot){
		                    return tooltipData[pointIndex];
		                }        // pixels to add to the size of filled markers when drawing highlight.                  
			        } , 
					grid:{ 
					 	drawGridLines:false,
					    background: '#ffffff',      // CSS color spec for background color of grid.		          
					    borderWidth: 0,           // pixel width of border around grid.
					    shadow: false                // draw a shadow for grid.
					} 
			    });
			}
			
			function changeChart(){
				
				dashChart.view();
				
				var gubun = $("#gubun").val();
				var formval = $("#form").val();
				
				var dataX = "";
				var dataY = "";
				var datatooltip = "";
		        var title = "";
		        var label = "";
		        
		        if(gubun == "1"){
		        	data = data1;
					dataX = data1barX;
					dataY = data1barY;
					datatooltip = data1tooltip;
					title="부서별 S/R 처리건";
					label="부서";
				} else if(gubun == "2"){
					data = data2;
					dataX = data2barX;
					dataY = data2barY;
					datatooltip = data2tooltip;
					title = "유형별 S/R 처리건";
					label = "유형";
				} else if(gubun == "3"){
					data = data3;
					dataX = data3barX;
					dataY = data3barY;
					datatooltip = data3tooltip;
					title = "업무별 S/R 처리건";
					label = "업무";
				} else if(gubun == "4"){
					data = data4;
					dataX = data4barX;
					dataY = data4barY;
					datatooltip = data4tooltip;
					title = "접수유형별 S/R 처리건";
					label = "접수유형";
				}
		        
				$("#title").html("<i class=\"axi axi-circle\"></i>&nbsp;" + title);
		        $("#chart").empty();
				if(formval == "1"){
					drawChart("chart",data,datatooltip); 
				} else if(formval == "2"){
					drawChartBar("chart", dataY,dataX,datatooltip,label); 
				}
			}
			
			changeChart();
			
			/*조회기간 세팅*/
			function fnSetDate(num, str) {
				if(typeof num != "number") num = 0;
				if(typeof str != "string") str = "";
				var from;
				var to;				
				var date1 = new Date();
				var date = new Date();
				to = gfnGetDate(date1,"-");
				
				if(str == "m") {
					date1 = new Date("".date().add(num, "m"));
				} else {
					date1 = new Date("".date().add(num));
				}
				from = gfnGetDate(date1,"-");		

				$("#AXInputDateST").val(from);
				$("#AXInputDateED").val(to);
				location.href="<c:url value='/stats/srStats.do'/>?sdate="+$("#AXInputDateST").val()+"&edate="+$("#AXInputDateED").val()+"&gubun="+$("#gubun").val()+"&form="+$("#form").val();
			 }
			/******************************************************************************************************************************************************/
			   function changeChart2(){
				   changeChart();
				   
					var gubun = $("#gubun").val();
					var formval = $("#form").val();
			        if(gubun == "1"){
			        	fnObj.pageStart();
					} else if(gubun == "3"){
						fnObj2.pageStart();
					} else if(gubun == "4"){
						fnObj3.pageStart();
					}
				   
				   
				   
			   }
			/******************************************************************************************************************************************************/
			    var pageID = "autoHeight";
			    var fnObj = {
			        pageStart: function(){
			            fnObj.grid.bind();
			        },
			        grid: {
			            target: new AXGrid(),
			            bind: function(){
			                window.myGrid = fnObj.grid.target;
			
			                var getColGroup = function(){
			                    return [
			                        {key:"sno", label:"번호", width:"50", align:"center"},
			                        {key:"regDate", label:"작성일", width:"100", align:"center",
				                        formatter:function(){
				                            return this.value.left(8).date().print("yyyy-mm-dd");
				                        }
				                    },			                        
			                        {key:"deptName", label:"부서명", width:"300", tooltip:function(){
			                                return this.value;
			                            },
			                            sort: false
			                        },
			                        {key:"dCnt", label:"총건수", width:"100", align:"right", formatter:"money"},
			                        {key:"proc", label:"처리중", width:"100", align:"right", formatter:"money"},
			                        {key:"returnc", label:"반려", width:"100", align:"right", formatter:"money"},			                        
			                        {key:"complete", label:"완료", width:"100", align:"right", formatter:"money"},
			                        {key:"beego", label:"비고", width:"*", align:"center"}
			                    ];
			                };
			
			                myGrid.setConfig({
			                    targetID : "AXGridTarget",
			                    sort:false, //정렬을 원하지 않을 경우 (tip
			                    fitToWidth:true, // 너비에 자동 맞춤
			                    height:"auto",
			                    colGroup : getColGroup(),
			                    colHeadAlign: "center", // 헤드의 기본 정렬 값 ( colHeadAlign 을 지정하면 colGroup 에서 정의한 정렬이 무시되고 colHeadAlign : false 이거나 없으면 colGroup 에서 정의한 속성이 적용됩니다.
			                    body : {
			                        onclick: function(){
			                            ///toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
			                        },
			                        /* ondblclick 선언하면 onclick 이벤트가 0.25 초 지연 발생 됩니다. 주의 하시기 바람니다. */
			                        ondblclick: function(){
			                            //toast.push("더블클릭");
			                            //toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
			                        },
			                        addClass: function(){
			                            // red, green, blue, yellow, white, gray
			                            if(this.index % 2 == 0){
			                                return "blue";
			                            }else{
			                                return "gray";
			                            }
			
			                        }
			                    },
			                    foot : {
			                        rows: [
			                            [
			                                {colSeq:null, colspan:3, formatter:function(){
			                                    return "계";
			                                }, align:"center"},
			                                {colSeq:3, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.dCnt;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},
			                                {colSeq:4, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.proc;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},			                                
			                                {colSeq:5, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.returnc;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},
			                                {colSeq:6, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.complete;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},			                                
			                                {colSeq:7}
			                            ]
			                        ]
			                    },
			                    page: {
			                        display: false,
			                        paging: false
			                    }
			                });			                
			                var list = [

			                   <c:forEach var="result" items="${grdList}" varStatus="status">	  
					           {deptName:"${result.dept_name}", regDate:"${result.dis_dttm_rq}", dCnt:${result.dcnt}, proc:${result.proc}, complete:${result.complete}, returnc:${result.returnc}, beego:"${result.beego}",sno:${result.sno}}, 				                     
							   </c:forEach>
			                ];
			                myGrid.setList(list);
			                myGrid.setDataSet({});
			                trace(myGrid.getSortParam());
			
			            },
			            getExcel: function(type){
			                var obj = myGrid.getExcelFormat(type);
			                trace(obj);
			                $("#printout").html(Object.toJSON(obj));
			            }
			        }
			    };
			    jQuery(document.body).ready(function() {
			        fnObj.pageStart();
			    }); 			
		  /******************************************************************************************************************************************************/
			    var fnObj2 = {
			        pageStart: function(){
			            fnObj2.grid.bind();
			        },
			        grid: {
			            target: new AXGrid(),
			            bind: function(){
			                window.myGrid = fnObj2.grid.target;
			
			                var getColGroup = function(){
			                    return [
			                        {key:"sno", label:"번호", width:"50", align:"center"},
			                        {key:"deptName", label:"전체부서", width:"300", tooltip:function(){
			                                return this.value;
			                            },
			                            sort: false
			                        },
			                        {key:"jobName", label:"부서명", width:"100", align:"center"},
			                        {key:"dCnt", label:"총건수", width:"100", align:"right", formatter:"money"},
			                        {key:"proc", label:"처리중", width:"100", align:"right", formatter:"money"},
			                        {key:"returnc", label:"반려", width:"100", align:"right", formatter:"money"},			                        
			                        {key:"complete", label:"완료", width:"100", align:"right", formatter:"money"},
			                        {key:"beego", label:"비고", width:"*", align:"center"}
			                    ];
			                };
			
			                myGrid.setConfig({
			                    targetID : "AXGridTarget",
			                    sort:false, //정렬을 원하지 않을 경우 (tip
			                    fitToWidth:true, // 너비에 자동 맞춤
			                    height:"auto",
			                    colGroup : getColGroup(),
			                    colHeadAlign: "center", // 헤드의 기본 정렬 값 ( colHeadAlign 을 지정하면 colGroup 에서 정의한 정렬이 무시되고 colHeadAlign : false 이거나 없으면 colGroup 에서 정의한 속성이 적용됩니다.
			                    body : {
			                        onclick: function(){
			                            ///toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
			                        },
			                        /* ondblclick 선언하면 onclick 이벤트가 0.25 초 지연 발생 됩니다. 주의 하시기 바람니다. */
			                        ondblclick: function(){
			                            //toast.push("더블클릭");
			                            //toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
			                        },
			                        addClass: function(){
			                            // red, green, blue, yellow, white, gray
			                            if(this.index % 2 == 0){
			                                return "blue";
			                            }else{
			                                return "gray";
			                            }
			
			                        }
			                    },
			                    foot : {
			                        rows: [
			                            [
			                                {colSeq:null, colspan:3, formatter:function(){
			                                    return "계";
			                                }, align:"center"},
			                                {colSeq:3, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.dCnt;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},
			                                {colSeq:4, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.proc;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},			                                
			                                {colSeq:5, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.returnc;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},
			                                {colSeq:6, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.complete;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},			                                
			                                {colSeq:7}
			                            ]
			                        ]
			                    },
			                    page: {
			                        display: false,
			                        paging: false
			                    }
			                });			                
			                var list = [
			                   
			                   <c:forEach var="result" items="${grdList2}" varStatus="status">	  			                            
			                   {deptName:"${result.jobfullname}", jobName:"${result.jobname}", dCnt:${result.cnt}, proc:${result.proc}, complete:${result.complete}, returnc:${result.returnc}, beego:"",sno:${result.sno}},
			                   </c:forEach>
			                   
			                ];
			                myGrid.setList(list);
			                myGrid.setDataSet({});
			                trace(myGrid.getSortParam());
			
			            },
			            getExcel: function(type){
			                var obj = myGrid.getExcelFormat(type);
			                trace(obj);
			                $("#printout").html(Object.toJSON(obj));
			            }
			        }
			    };
		  /******************************************************************************************************************************************************/	
			    var fnObj3 = {
			        pageStart: function(){
			            fnObj3.grid.bind();
			        },
			        grid: {
			            target: new AXGrid(),
			            bind: function(){
			                window.myGrid = fnObj3.grid.target;
			
			                var getColGroup = function(){
			                    return [
			                        {key:"sno", label:"번호", width:"50", align:"center"},
			                        {key:"deptName", label:"접수유형별", width:"300", tooltip:function(){
			                                return this.value;
			                            },
			                            sort: false
			                        },
			                        {key:"dCnt", label:"총건수", width:"100", align:"right", formatter:"money"},
			                        {key:"proc", label:"처리중", width:"100", align:"right", formatter:"money"},
			                        {key:"returnc", label:"반려", width:"100", align:"right", formatter:"money"},			                        
			                        {key:"complete", label:"완료", width:"100", align:"right", formatter:"money"},
			                        {key:"beego", label:"비고", width:"*", align:"center"}
			                    ];
			                };
			
			                myGrid.setConfig({
			                    targetID : "AXGridTarget",
			                    sort:false, //정렬을 원하지 않을 경우 (tip
			                    fitToWidth:true, // 너비에 자동 맞춤
			                    height:"auto",
			                    colGroup : getColGroup(),
			                    colHeadAlign: "center", // 헤드의 기본 정렬 값 ( colHeadAlign 을 지정하면 colGroup 에서 정의한 정렬이 무시되고 colHeadAlign : false 이거나 없으면 colGroup 에서 정의한 속성이 적용됩니다.
			                    body : {
			                        onclick: function(){
			                            ///toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
			                        },
			                        /* ondblclick 선언하면 onclick 이벤트가 0.25 초 지연 발생 됩니다. 주의 하시기 바람니다. */
			                        ondblclick: function(){
			                            //toast.push("더블클릭");
			                            //toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
			                        },
			                        addClass: function(){
			                            // red, green, blue, yellow, white, gray
			                            if(this.index % 2 == 0){
			                                return "blue";
			                            }else{
			                                return "gray";
			                            }
			
			                        }
			                    },
			                    foot : {
			                        rows: [
			                            [
			                                {colSeq:null, colspan:2, formatter:function(){
			                                    return "계";
			                                }, align:"center"},
			                                {colSeq:2, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.dCnt;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},
			                                {colSeq:3, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.proc;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},			                                
			                                {colSeq:4, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.returnc;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},
			                                {colSeq:5, formatter:function(){
			                                    var sum = 0;
			                                    $.each(this.list, function(){
			                                        sum += this.complete;
			                                    });
			                                    return sum.money();
			                                }, align:"right"},			                                
			                                {colSeq:6}
			                            ]
			                        ]
			                    },
			                    page: {
			                        display: false,
			                        paging: false
			                    }
			                });			                
			                var list = [
						        <c:forEach var="result" items="${grdList3}" varStatus="status">	  			                            
						          {deptName:"${result.typename}", jobName:"", dCnt:${result.cnt}, proc:${result.proc}, complete:${result.complete}, returnc:${result.returnc}, beego:"",sno:${result.sno}},
						        </c:forEach>
			                ];
			                myGrid.setList(list);
			                myGrid.setDataSet({});
			                trace(myGrid.getSortParam());
			
			            },
			            getExcel: function(type){
			                var obj = myGrid.getExcelFormat(type);
			                trace(obj);
			                $("#printout").html(Object.toJSON(obj));
			            }
			        }
			    };
		  /******************************************************************************************************************************************************/		 		  
			
			
	    </script>
	    <style>
		    .jqplot-point-label{font-size:9pt; color:#242424;}
		    .jqplot-donut-series{font-size:9pt; color:#242424;}
		    .tbSummary th {width:120px; height:54px; font-weight:normal; font-size:18px; background:#F5F5F5;}  
		    .tbSummary td {text-align:right;font-size:16px;}
		    .graphPad {margin-top:20px; padding:20px 40px 20px 20px; text-align:center; border:1px solid gray;}
		    .jqplot-yaxis-label {width:35px;}
	    </style>
	</ax:div>
</ax:layout>