<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="단계 관리" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
				<div id="envTab"></div>
				<h3><font color="red">※ process를 클릭하거나 grid의 사용구분을 선택하여 업무 단계를 관리 할 수 있습니다.</font></h3>
				<div id="srTab" class="ax-rwd-table tabContent">
		           	<ax:fields>
		           		   <ax:field label="S/R process" style2="vertical-align:middle;"> 
								<table id="srStep">
									<tr>
										<td>&nbsp;</td>
										<td>
											<span class="preStep" stepId="160">개발진행검토</span> 
											<span class="preStep" stepId="170">최종개발검토</span>									
										</td>
										<td>&nbsp;</td>
									</tr>
									<tr>
										<td>
											<span stepId="100">S/R 등록</span>
										 	<span stepId="110">서비스요청검토</span>	
										 	<span stepId="130">개발검토</span> 								
										</td>
										<td>
										</td>
										<td>
											<span stepId="180">답변등록</span> <span stepId="000">처리완료</span>
										</td>
									</tr>
									<tr>
										<td>&nbsp;</td>
										<td>
											<span class="preStep" stepId="140">DB핸들링검토</span> 
											<span class="preStep" stepId="150">DB핸들링<br/>결과 등록</span> 									
										</td>
										<td>&nbsp;</td>
									</tr>
								</table>
		                   </ax:field>      
		   			</ax:fields>
			   	</div>
				<div id="disTab" class="ax-rwd-table tabContent">			   			
		   			<ax:fields>
		   			 	   <ax:field label="배포 process" style2="vertical-align:middle;"> 
								<table id="disStep">
									<tr>
										<td>
											<span stepId="100">배포요청</span>
											<span class="preStep" stepId="110">테스트적용 팀장검토</span>
											<span class="preStep" stepId="120">테스트적용 검토</span>
											<span class="preStep" stepId="130">테스트적용결과 확인</span>
											<span class="preStep" stepId="140">시험배포 팀장검토</span>
											<span class="preStep" stepId="150">품질검토 요청</span>
											<span class="preStep" stepId="160">품질검토</span>
											<span class="preStep" stepId="170">시험배포 최종검토</span>
											<span class="preStep" stepId="180">시험배포적용 검토</span>
											<span class="preStep" stepId="190">시험배포결과 확인</span>
											<span class="preStep" stepId="200">최종배포 팀장검토</span>
											<span class="preStep" stepId="210">최종배포적용 검토</span>
											<span stepId="220">최종배포결과 확인</span>
											<span stepId="230">배포 종료</span>
										</td>
									</tr>
								</table>
		                   </ax:field>  
		   			</ax:fields>
	             </div>
				<div style="text-align:right;width:100%;margin-top:10px;">
	                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>저장</button>
               	</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var myGrid = new AXGrid();	    
	    var fnObj = {
	        pageStart: function(){
	            var gridHeight = fnObj.getWidgetHeight();
	            myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    height:gridHeight,
                    fitToWidth: true,
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"no", label:"번호", width:"50", align:"center"},
                        {key:"sdgbnName", label:"업무구분", align:"center", width:"100"},
                        {key:"code", label:"단계코드", width:"100", align:"center"},
                        {key:"codeCtn", label:"단계명", width:"300", align:"left"},
                        {key:"useGbn", label:"사용구분", width:"100", align:"center",
                        	editor: {
                                type: "checkbox",
                                beforeUpdate: function (val) {
                                    return (val == true) ? "Y" : "N";
                                }
                            }}
                    ],
                    body : {
                        onclick: function(){
                        },
                    },
                    page:{
                        paging:false,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }
                });
	            
	    	    bindOnclick();
	    	    bindNotEditStep();
	    	    $("#envTab").setValueTab("${tabValue}");
	        },
    		getWidgetHeight : function(){
    			return windowHeight = $(window).height()-320;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            },
            confirm: function(){
				if(myGrid.getList("U").length == 0){
            		gfnDialog("<b>Waring</b>&nbsp; 변경된 내용이 없습니다.","Warning","확인","Red","");
					return false;
				}
				
				gfnConfirm("저장하시겠습니까?","fnObj.save();");
			},
			save: function(){
				 var data = myGrid.getList("U");
		         
				 var formData = gfnGridToFoamData(data,"stepVOes");
				 
				 var url = "<c:url value='/step/stepEdit.json'/>";
		         $.ajax({
		        	 url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		gfnDialog("단계 변경이 완료되었습니다","Alert","확인","Red","location.href='stepList.do?tabValue="+tabValue+"'");
                           } else {
                           		gfnDialog("<b>Warning</b>&nbsp;단계 변경에 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","location.href='stepList.do'");
                           }
	                    },
	                    error : null
	                });
			},
			saveStep: function(event){
				var url = "<c:url value='/step/stepEdit.json'/>";
				var list = stepList[event.data.no];
				if(list.useGbn == "Y")      list.useGbn = "N";
				else if(list.useGbn == "N") list.useGbn = "Y";
				
				$.ajax({
		        	url: url,
	                data: list,
	                type: 'post',
	                dataType:'json',
	                success: function(res){
	                	if(res.result.SUCCESS){
		                	if(list.useGbn == "Y"){
		                		$("#" + list.sdgbn.toLowerCase() + "Step span[stepId=" + list.code + "]").attr("class","nextStep");
		                	} else if(list.useGbn == "N"){
		                		$("#" + list.sdgbn.toLowerCase() + "Step span[stepId=" + list.code + "]").attr("class","preStep");
		                	}
	                	} else {
                       		gfnDialog("<b>Warning</b>&nbsp;단계 변경에 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","location.href='stepList.do'");
                        }
	                	myGrid.reloadList();
	                },
	                error : null
	            });
			}
	    };
	    
    	var stepList;
	    function bindOnclick(){
	    	
	    	$.ajax({
	        	   url: "<c:url value='/step/getStepList.do'/>",
                   processData: false,
                   contentType: false,
                   data: '',
                   type: 'POST',
                   async: false,
                   success: function(res){
                	   stepList = res.list;
                   },
                   error : null
               });
	    	
	    	var sdgbn = ["sr","dis"];
	    	
	    	for(k=0;k<sdgbn.length;k++){
				$("#" + sdgbn[k] + "Step span").each(function(index){
					var stepId = $(this).attr("stepId");
					for(i=0;i<stepList.length;i++){
						if(stepId == stepList[i].code && stepList[i].sdgbn == sdgbn[k].toUpperCase()){
							if(stepList[i].useGbn == "Y")      $(this).attr("class","nextStep").css("cursor","pointer");
							else if(stepList[i].useGbn == "N") $(this).attr("class","preStep").css("cursor","pointer");
							
							$(this).bind("click",{no:i},fnObj.saveStep);
						} 
					}
				});
	    	}
	    }
	    
	    function bindNotEditStep(){
	    	var sr = [["100","start"],["110","center"],["130","center"],["180","center"],["000","end"]];
	    	var dis = [["100","start"],["220","center"],["230","end"]];
	    	
			var sdgbn = ["sr","dis"];
	    	
	    	for(k=0;k<sdgbn.length;k++){
	    		$("#" + sdgbn[k] + "Step span").each(function(index){
		    		var stepId = $(this).attr("stepId");
		    		
		    		var data;
		    		if(sdgbn[k] == "sr")       data = sr;
		    		else if(sdgbn[k] == "dis") data = dis;
		    		
		    		for(i=0;i<data.length;i++){
		    			var cls;
		    			if(data[i][0] == stepId){
		    				if(data[i][1] == "start")       cls = "noEditStart"; 
		    				else if(data[i][1] == "center") cls = "noEdit"; 
		    				else if(data[i][1] == "end")    cls = "noEditEnd"; 
		    				
		    				$(this).attr("class",cls);
		    			}
		    		}
		    	});
	    	}
	    }
	    
	    var tabValue;
	    $("#envTab").bindTab({
			theme : "AXTabs",
			value:"",
			overflow:"scroll", /* "visible" */
			options:[
				{optionValue:"sr", optionText:"S/R"}, 
				{optionValue:"dis", optionText:"배포"}
			],
			onchange: function(selectedObject, value){
				tabValue = selectedObject.optionValue;
				var selectedValue = selectedObject.optionValue;
				if(selectedValue == "sr") {
					$("#srTab").css("display","block");
					$("#disTab").css("display","none");
				} else if(selectedValue == "dis") {
					$("#disTab").css("display","block");
					$("#srTab").css("display","none");
				}

				myGrid.setList({
                    ajaxUrl:"getStepList.do", ajaxPars:{"stepGbn":selectedValue.toUpperCase()} 
                });
			}
		});
	    </script>
	    <style>
	    	.AXanchorSelect.disable .selectedTextBox {
			  display: block;
			  border: 1px solid #b6b6b6;
			  background: #eee;
			  color: #676767;
			  cursor: default;
			  text-shadow: 0px 1px #fff;
			  box-shadow: inset 0px 1px 2px #b1b1b1;
			  border-radius: 4px;
			}
			
			.AXInput[disabled] {
			  background: #eee;
			  color: #676767;
			  text-shadow: 0px 1px #fff;
			  box-shadow: inset 0px 1px 2px #b1b1b1;
			}
			
			.AXTextarea[disabled] {
			  background: #eee;
			  color: #676767;
			  text-shadow: 0px 1px #fff;
			  box-shadow: inset 0px 1px 2px #b1b1b1;
			}
			
			.closeBtn {
			  position: absolute;
			  right: 1px;
			  top: 1px;
			  display: block;
			  width: 20px;
			  height: 20px;
			  background: url("<c:url value='/axu/plugins/axisj/ui/cocker/images/dx-modal-close.png'/>") no-repeat;
			  background-size: 20px 20px;
			  border: 1px solid #a6a6a6;
			  overflow: hidden;
			  text-indent: -1000px;
			}
			
			#viewProcStep {line-height:22px; nobr}
			.currStep{display:inline-block; background:url("<c:url value='/images/currbox.png'/>") no-repeat ; width:125px; height:20px; text-align:center; color:#666666;}
			.nextStep{display:inline-block; background:url("<c:url value='/images/arrow-next.png'/>") no-repeat ; width:125px; height:20px; text-align:center; color:#666666;}
			.nextStepEnd{display:inline-block; background:url("<c:url value='/images/arrow-next-end.png'/>") no-repeat ; width:125px; height:20px; text-align:center; color:#666666}
			.preStep{ display:inline-block; background:url("<c:url value='/images/process_arrow2.png'/>") no-repeat ; width:125px; height:20px; text-align:center; color:#eaeaea; }
			.preStepStart{ display:inline-block; background:url("<c:url value='/images/arrow-start-grey.png'/>") no-repeat ; width:125px; height:20px; text-align:center; color:#eaeaea; }
			
			.noEditStart{display:inline-block; background:url("<c:url value='/images/process_arrow5.png'/>") no-repeat ; width:125px; height:20px; text-align:center; color:#666666;}
			.noEdit{display:inline-block; background:url("<c:url value='/images/process_arrow4.png'/>") no-repeat ; width:125px; height:20px; text-align:center; color:#666666;}
			.noEditEnd{display:inline-block; background:url("<c:url value='/images/process_arrow6.png'/>") no-repeat ; width:125px; height:20px; text-align:center; color:#666666;}
        	.tabContent{
        	   display:none;
        	}
	    </style>
	</ax:div>
</ax:layout>