<%@ page contentType="text/html; charset=UTF-8"
        %><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
        %><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
        %><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"
     %><ax:layout name="modal.jsp">
    <ax:div name="header">
        <h1>사업등록</h1>
    </ax:div>
    <ax:div name="contents">
    	<ax:row>
    		<ax:col size="12" wrap="false">
		       	<ax:form name="myForm" method="post">
		       	<input type="hidden" name="gbn" value="S"/>
		            <ax:fields>
		                <ax:field label="등록자" >
			                ${userInfo['name']}(${userInfo['loginId'] })
			                <input type="hidden" name="userId" value="${userInfo['userId'] }"/>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="사업ID">
		                    <input type="text" name="businessYid" id="businessYid" title="사업년도" placeholder="" maxlength="4" class="AXInput W60" numberOnly/> -
		                	<input type="text" name="businessTid" id="businessTid" title="사업ID" placeholder="" maxlength="10" class="AXInput W100" englishNumbrtOnly/>
		                	<button type="button" id="checkId" class="AXButtonSmall Blue"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i> 사업ID 중복확인</button>
		                    <spen style="color:#cc3333;">&nbsp; 예) *사업년도4자리-영문10자리</spen>
                    		<input type="hidden" name="isIdOverlapped" id="isIdOverlapped" value=""/> 
                    		<input type="hidden" name="businessid" id="businessid" value=""/> 
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="사업명칭">
		                	<input type="text" name="bns_name" title="사업명칭" placeholder="" class="AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="사업기간">
		                	<input type="text" name="bns_startYmd" id="AXInputDateST"  title="사업시작일자" class="AXInput W80" /> ~ <input type="text" name="bns_endYmd" id="AXInputDateED" class="AXInput W100" />
		                </ax:field>
		            </ax:fields>
		        </ax:form>
		        <div class="ax-clear"></div>
		        <div class="H20"></div>
		        <div>
		        	<div style="float:right;">
				        <button type="button" class="AXButton" onclick="fnObj.form.confirm();"><i class="axi axi-save"></i>저장</button>
				        <button type="button" class="AXButton" onclick="parent.myModal.close();"><i class="axi axi-ion-close-circled"></i>닫기</button>
		        	</div>
               	</div>
			</ax:col>
    	</ax:row>
    </ax:div>
     <ax:div name="scripts">
        <script type="text/javascript">
            var deptTree = new AXTree();
		    $("#AXInputDateED").bindTwinDate({
	            startTargetID: "AXInputDateST",
	            handleLeft: 25,
	            align: "right",
	            valign: "bottom",
	            separator: "",
	            buttonText: "선택",
	            onChange: function () {
	            	//if(oldStart == $("#AXInputDateST").val() && oldEnd == $("#AXInputDateED").val()) return false;
	            }
	        });	            

            var fnObj = {
                pageStart: function(){
                    this.form.init();
                    this.bindEvent();

					$("input:text[numberOnly]").on("keyup", function() {
					    $(this).val($(this).val().replace(/[^0-9]/g,""));
					});
					
					$("input:text[englishNumbrtOnly]").on("keyup", function() {
					    $(this).val($(this).val().replace(/[^a-z|^A-Z|^0-9]/g,""));
					});					


                    $("#checkId").click(function(){
                    	
                    	var businessYid = $("#businessYid").val();
                    	var businessTid = $("#businessTid").val();
                    	var businessId  = businessYid+"-"+businessTid;
                    	
                    	if(businessId == ""){
                    		mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;사업ID를 기입후 확인하세요.",
                    	        buttons:[
                    	                   {
                    	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                    	                    	   mask.close();
                    	                       }
                    	                   }
                    	                ]
                    	        });
                    		return false;
                    	}else if(businessYid.length < 4){
                    		mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;사업ID부분에 년도를 기입후 확인하세요.(4자리)",
                    	        buttons:[
                  	                   {
                  	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                  	                    	   mask.close();
                  	                       }
                  	                   }
                  	                ]
                  	        });
 	                 		return false;
                    	}else if(businessTid.length < 10){
                    		mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;사업ID부분에 영문를 기입후 확인하세요.(10자리)",
                    	        buttons:[
                  	                   {
                  	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                  	                    	   mask.close();
                  	                       }
                  	                   }
                  	                ]
                  	        });
 	                 		return false;
                    	}
                    	
                    	var url = "<c:url value='/taskOrder/checkBusiness.json'/>";
                        var pars = {businessid:businessId};
                        
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                	mask.open();
                            		dialog.push({type:"Alert",top:100,body:res.result.MESSAGE,
                            	        buttons:[
                            	                   {
                            	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                            	                    	   mask.close();
                            	                       }
                            	                   }
                            	                ]
                            	        });
                                    if(res.result.SUCCESS){
                                    	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                                    	$("input[name='isIdOverlapped']").val("false");
                                    }else{
                                    	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                                    	$("input[name='isIdOverlapped']").val("true");
                                    }
                                    
                                },
                                onerr:null
                            }
                        );
                    });
                    $("input[name='businessYid']").change(function(){
                    	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                    	$("input[name='isIdOverlapped']").val("true");
                    });
                    $("input[name='businessTid']").change(function(){
                    	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                    	$("input[name='isIdOverlapped']").val("true");
                    });                    
                },
                pageResize: function(){
                    parent.myModal.resize();
                },
                bindEvent:function (){
                    
                },
                form:{
                    validator: new AXValidator(),
                    init: function(){
                        this.validator.setConfig({
                            targetFormName : "myForm"
                        });
                    },
                    confirm:function(){

                        var validateResult = this.validator.validate();
                        if (!validateResult) {
                            var msg = this.validator.getErrorMessage();
                            toast.push(msg);
                            this.validator.getErrorElement().focus();
                            return false;
                        }else{
                            // 통과
                        }
                        
                        var strYmd = $("#AXInputDateST").val();
                        if(strYmd.length < 10){
                        	mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;사업기간에서 시작일자는 필수 입니다.",
                    	        buttons:[
                  	                   {
                  	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                  	                    	   mask.close();
                  	                       }
                  	                   }
                  	                ]
                  	        });
	                      $("#AXInputDateST").focus();
	                      return false;                    		
                        }
                                                
                    	var isIdOverlappedObj = $("#isIdOverlapped").val();
        				
        				if(isIdOverlappedObj==""){
        					mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;아이디 중복확인을 해야합니다.",
                    	        buttons:[
                    	                   {
                    	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                    	                    	   mask.close();
                    	                       }
                    	                   }
                    	                ]
                    	        });
                        	$("#projectid").focus();
                        	return false;
                        }else if(isIdOverlappedObj=="true"){
                        	mask.open();
                    		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;다른 ID로 중복확인 후 등록바랍니다.",
                    	        buttons:[
                    	                   {
                    	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                    	                    	   mask.close();
                    	                       }
                    	                   }
                    	                ]
                    	        });
                        	$("#projectid").focus();
                        	return false;
                        }
        				
                    	var businessYid = $("#businessYid").val();
                    	var businessTid = $("#businessTid").val();
                    	var businessId  = businessYid+"-"+businessTid;        				
        				$("#businessid").val(businessId);
        				
        				mask.open();
        				dialog.push({type:"Alert",top:100,body:"등록하시겠습니까?",
        			        buttons:[
        			                   {
        			                       buttonValue:"승인",buttonClass:"Green",onClick:function(){  mask.close(); fnObj.form.save();}
        			                   },
        			                   {
        			                	   buttonValue:"취소",buttonClass:"Red",onClick:function(){ mask.close(); }
        			                   }
        			                ]
        			        });
                    },
                    save: function(){
                    	
                    	var pars = $(document.myForm).serialize();
       		    		var url = "<c:url value='/taskOrder/editBusiness.json'/>";
       		    	 
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                    if(res.result.SUCCESS){
                                    	dialog.push({type:"Alert",top:100,body:"저장되었습니다.",
                                	        buttons:[
                                	                   {
                                	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                                	                    	   mask.close();
                                	                    	   parent.myModal.close();
                                	                       }
                                	                   }
                                	                ]
                                	        });
                                    }else{
	                                   	toast.push(res.result.MESSAGE);
                                    }
                                    
                                },
                                onerr:null
                            }
                        );
                        
                        return false;
                    },
                    close: function(){
                        if(opener){
                            window.close();
                        }
                        else
                        if(parent){
                            if(parent.myModal) parent.myModal.close();
                        }
                        else
                        {
                            window.close();
                        }
                    }                    
                }
            };
            axdom(document.body).ready(function(){fnObj.pageStart()});
            //axdom(window).resize(fnObj.pageResize);
        </script>
    </ax:div>
</ax:layout>