<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%>
<style>
 .idHidden{
 	background-color:red;
  }
</style>
<ax:layout name="base.jsp">
    <ax:set name="title" value="사업관리 목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>

	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
			<input type="hidden" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
				<div class="ax-search" id="page-search-box"></div>      
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="10">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>
				    <div class="right">
				       <c:if test="${insertCheck eq 'Y'}">
				    	<button type="button" class="AXButton" onclick="fnObj.regBusiness();" ><i class="axi axi-save"></i>사업등록</button>
				        <!-- utton type="button" class="AXButton" onclick="fnObj.regTask();" ><i class="axi axi-ion-compose"></i> 과업등록</button-->
                       </c:if>				        
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    
	    var page_menu_id = "m010301";
	    var myGrid = new AXGrid();
	    var myModal = new AXModal();
	    var fnObj = {
	        pageStart: function(){

	            this.search.bind();
	            this.bindEvent();
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	            var gridHeight = fnObj.getWidgetHeight();
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    fitToWidth: false,
                    height:gridHeight,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"no", label:"번호", width:"70", align:"center"},
                        {key:"bnsGubun", label:"사업구분", width:"100", align:"center"},
                        {key:"businessnm", label:"사업명칭", align:"center", width:"250",align:"left"},
                        {key:"businessid", label:"사업ID",align:"center", width:"200",align:"left", display:false},
                        {key:"bnsOrder", label:"발주처", width:"130", align:"center"},                        
                        {key:"bnsStartymd", label:"시작일자", align:"center", width:"100", align:"center"},
                        {key:"bnsEndymd", label:"종료일자", width:"100", align:"center"},
                        {key:"bnsBeego", label:"비고", width:"*", align:"left"}
                    ],
                    body : {
                        onclick: function(){
                        	location.href="<c:url value='/taskOrder/businessView.do'/>?business_sno="+this.item.businessSno+"&kol=";
                        	//location.href="taskview.do?taskSno="+this.item.busineSno+"&businessnm="+this.item.businessnm;
                        }
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }

                });

	        	myGrid.setList({
                    ajaxUrl:"getBusinessist.do", ajaxPars:"businessid=", 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        	
	        	myModal.setConfig({
					windowID:"myModalCT", width:740,
	                mediaQuery: {
	                    mx:{min:0, max:767}, dx:{min:767}
	                },
					displayLoading:true,
	                scrollLock: true,
					onclose: function(){
					}
				});
                
	        },
	        bindEvent: function(){
	            var _this = this;
	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
	                            {label:"사업명ID", labelWidth:"", type:"inputText", width:"200", key:"businessId", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            },
	                            {label:"사업명칭", labelWidth:"", type:"inputText", width:"200", key:"businessName", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            },
								{label:" 사업기관 ", labelWidth:"100", type:"inputText", width:"80", key:"sdate", addClass:"secondItem", valueBoxStyle:"", value:"",
									onChange: function(){}
								},
								{label:"", labelWidth:"", type:"inputText", width:"90", key:"edate", addClass:"secondItem", valueBoxStyle:"", value:"",
									AXBind:{
										type:"twinDate", config:{
											align:"right", valign:"top", startTargetID:"sdate", buttonText: "선택",
											onChange:function(){
												//toast.push(Object.toJSON(this));
											}
										}
									}
								}                            
	                        ]}
	                    ]
	                });
	            },
	            submit: function(){
	                var pars = this.target.getParam();
                    myGrid.setList({
                        ajaxUrl:"getBusinessist.do", ajaxPars:pars, 
                        onLoad:function(){
                        }
                    });
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            },
            regBusiness: function(){
            	location.href="businessReg.do";
            },             
            editProject: function(id){
            	myModal.open({
    				url:"<c:url value='/taskOrder/viewBusiness.do' />",
    				pars:{bnsiness_sno:id},
    				top:100,
    				closeByEscKey:true
    			});
            },            
            deleteConfirm: function(id){
            	gfnConfirm("삭제하시겠습니까?","fnObj.deleteTaskOrder('" + id + "');");
            },
            deleteTaskOrder: function(id){
            	var url = "<c:url value='/taskOrder/delBusiness.json' />";
            	var gbn = "D";
            	var userId = "${sessionScope['userInfo']['userId']}";
            	
            	new AXReq(url, 
                        {
                            pars:{businesSno:id,gbn:gbn,userId:userId}, 
                            onsucc:function(res){
                                if(res.result.SUCCESS){
                                	gfnDialog("완료되었습니다","Alert","확인","Red","myGrid.reloadList();");
                                }else{
                                   	toast.push(res.result.MESSAGE);
                                }
                                
                            },
                            onerr:null
                        }
                    );
            },

    		getWidgetHeight : function(){
    			var windowHeight = $(window).height();
    			
    			return windowHeight-320;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            }
            
	    };
	    
	    
	    </script>
	</ax:div>
</ax:layout>