<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="회원관리" />
    <ax:set name="page_desc" value="회원가입을 승인하고 role을 부여, 회수할 수 있습니다. " />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
				<div class="ax-search" id="page-search-box"></div>
				<div class="ax-button-group">
				    <div class="left">
				    	<select id="pageS" name="pageS" class="AXSelect">
							<option value="5">5</option>
							<option value="10" selected>10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
				    </div>
				    <div class="right">
				        <button type="button" class="AXButton Blue" id="ax-grid-btn-regist"><i class="axi axi-plus-circle"></i> 승 인 </button>
				        <button type="button" class="AXButton Red" id="ax-grid-btn-remove"><i class="axi axi-minus-circle"></i> 삭 제 </button>
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var page_menu_id = "m010301";
       	
	    var gridAboveHeight = 333;
	    var searchExtendedHeight = 41;
	    
	    var fnObj = {
	        pageStart: function(){
	        	
	        	var windowHeight = $(window).height();
	        	var gridHeight = windowHeight - gridAboveHeight;
	        	
	            this.search.bind();
	            this.grid.bind(gridHeight);
	            this.modal.bind();
	            this.bindEvent();
	            
	            $("#page-search-box_AX_expandHandle").bind("click",function(){
	            	//toast.push("fnObj.search.target.expanded:"+fnObj.search.target.expanded);
	            	
	            	fnObj.gridResizeCalulate();
	            	
	            })
	            
	        },
	        bindEvent: function(){
	            var _this = this;
                $("#ax-grid-btn-regist").bind("click", function(){
                	_this.grid.approveConfirm();
                });
                $("#ax-grid-btn-remove").bind("click", function(){
                    _this.grid.removeConfirm();
                });
	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		fnObj.grid.target.page.pageSize = this.value;
	            		fnObj.grid.target.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
	                            {label:"ID", labelWidth:"", type:"inputText", width:"150", key:"id", addClass:"", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //아래 2개의 값을 사용 하실 수 있습니다.
	                                    //toast.push(Object.toJSON(this));
	                                    //dialog.push(changedValue);
	                                    //_this.submit();
	                                }
	                            },
	                            {label:"성명", labelWidth:"", type:"inputText", width:"150", key:"name", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //아래 2개의 값을 사용 하실 수 있습니다.
	                                    //toast.push(Object.toJSON(this));
	                                    //dialog.push(changedValue);
	                                    //_this.submit();
	                                }
	                            },
	                            {label:"직책", labelWidth:"", type:"selectBox", width:"", key:"dutyCd", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                options:${DUTY_LIST},
	                                AXBind:{
	                                    type:"select", config:{
	                                        onChange:function(){
	                                            //toast.push(Object.toJSON(this));
	
	                                        }
	                                    }
	                                }
	                            }
	                        ]},
	                        {display:false, addClass:"",style:"",list:[
								{label:"탈퇴여부", labelWidth:"", type:"selectBox", width:"160", key:"delYn", addClass:"", valueBoxStyle:"", value:"N",
								    options:${DEL_LIST},
								    AXBind:{
								        type:"select", config:{
								            onChange:function(){
								                //toast.push(Object.toJSON(this));
								
								            }
								        }
								    }
								},
								{label:"가입신청", labelWidth:"", type:"selectBox", width:"", key:"approveYn", addClass:"secondItem", valueBoxStyle:"", value:"",
								    options:${APPROVAL_LIST},
								    AXBind:{
								        type:"select", config:{
								            onChange:function(){
								                //toast.push(Object.toJSON(this));
								
								            }
								        }
								    }
								}
	                        ]}
	                    ]
	                });
	            },
	            submit: function(){
	                var pars = this.target.getParam();
	                //toast.push("콘솔창에 파라미터 정보를 출력하였습니다.");
	                //trace(pars);
					
                    fnObj.grid.target.setList({
                        ajaxUrl:"<c:url value='/usermg/selectUsers.json' />", ajaxPars:pars, onLoad:function(){
                            //trace(this);
                        }
                    });
                    fnObj.grid.target.checkedColSeq(0,false);
	            }
	        },
	        grid: {
	            target: new AXGrid(),
	            get: function(){ return this.target },
	            bind: function(height){
	
	                this.target.setConfig({
	                    targetID : "page-grid-box",
	                    theme : "AXGrid",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    height:height,
	                    colGroup : [
                            {key:"userId", label:"", width:"40", align:"center", formatter:"checkbox"},
	                        {key:"rowNumber", label:"번호", width:"40", align:"center", formatter:"money"},
	                        {key:"name", label:"성명", width:"90", align:"center"},
	                        {key:"loginId", label:"ID", width:"90", align:"center"},
	                        {key:"deptName", label:"부서명", width:"90", align:"center"},
	                        {key:"dutyName", label:"직책", width:"120", align:"center"},
	                        {key:"jobNames", label:"업무", width:"200", align:"left"},
	                        {key:"joinDate", label:"가입일", width:"140", align:"center"},
	                        {key:"approveName", label:"가입신청", width:"90", align:"center"},
	                        {key:"delName", label:"탈퇴여부", width:"90", align:"center"},
	                        {key:"isTempPassword", label:"임시비밀번호", width:"150", align:"center", formatter:function(){
	                        	if(this.value=="Y"){
	                        		return "<button class=\"AXButtonSmall Blue\" onclick=\"fnObj.viewTempPassword('"+this.item.userId+"')\"><i class=\"axi axi-lock2\">임시비밀번호보기</i></button>";
	                        	}else{
	                        		return "";
	                        	}
	                        }}
	                    ],
	                    body : {
	                        onclick: function(){
	                            //toast.push(Object.toJSON({index:this.index, item:this.item}));
	                            //alert(this.list);
	                            //alert(this.page);
                                if (this.item.useAt === "N") {
                                    toast.push("삭제된 글은 조회할 수 없습니다.");
                                    return;
                                }
	                            fnObj.modal.open("gridView", {
	                                url:"<c:url value='/usermg/modifyOtherInfo.do' />", pars:"userId=" + this.item.userId
//	                                url:"edit-non-axu4j.do", pars:"nttId=" + this.item.nttId
	                            });
	                        },
		                    addClass: function(){
	                            // red, green, blue, yellow, white, gray
	                            //console.log(this.item);
	                            if(this.item.approveYn == 'N' && (this.item.delYn=='F'||this.item.delYn=='Y')){
	                                return "gray";
	                            }else if(this.item.approveYn == 'N'){
	                                return "blue";
	                            }else if(this.item.delYn=='F'||this.item.delYn=='Y'){
	                                return "red";
	                            }else{
	                                return "white";
	                            }

	                        }
	                    },
	                    page:{
	                        paging:true,
	                        pageNo:1,
	                        pageSize:10,
	                        status:{formatter: null}
	                    }
	                });
	                var pars = fnObj.search.target.getParam();
	                this.target.setList({
	                    ajaxUrl:"<c:url value='/usermg/selectUsers.json' />", ajaxPars:pars, onLoad:function(){
	                        //trace(this);
	                    }
	                });
	            },
	            approveConfirm: function(){
	            	var select = this.target.getCheckedList(0);
                    if(select.length == 0){
                    	gfnDialog("승인할 항목을 선택하세요");
                        return false;
                    }
                    
                    gfnConfirm("승인처리를 진행 하시겠습니까?","fnObj.grid.approveUser();");
	            },
                approveUser: function(){
                	var select = this.target.getCheckedList(0);
                	var errors = new Array();
                	var isApprovalInvalidated = false;
                    
                    for(var idx=0;idx<select.length;idx++){
                    	console.log(select[idx]);
                   		console.log(select[idx].delYn+","+select[idx].approveYn);
                   		if(select[idx].delYn!="N" || select[idx].approveYn!="N"){
                   			this.target.checkedColSeq(0,false,idx);
                   			isApprovalInvalidated = true;
                   		}
                   	}
                    
                    if(isApprovalInvalidated){
                    	gfnDialog("미승인/가입신청 상태가 아닙니다. (탈퇴,강퇴회원 제외)");
                    	return false;
                    }

                    var myProgress = new AXProgress();
                    myProgress.setConfig({
                        theme:"AXCircleProgress"
                        , duration:50
                    });
                    
                    

                    mask.open();
                    myProgress.start(function(){
                        //trace(this);
                        if(this.isEnd){
                            myProgress.close();
                            mask.close();
                            console.log(errors.length);
                            if(errors.length>0){
                            	var msg = "";
                            	for(var idx=0 ; idx<errors.length; idx++){
                            		if(idx!=0){
                            			msg +=",";
                            		}
                            		msg += errors[idx];
                            	}
                            	gfnDialog(msg);
                            }else{
                            	gfnDialog("승인처리 및 메신저에 등록이 되었습니다.<br>메신저서버에서 소속을 결정해 주세요<br><b>[ 메신저서버관리 > Login > User/Groups > Groups ]</b><br><b>- 메신저초기암호는 『123456』입니다 -");
                            }                                                         
                            fnObj.search.submit();
                        }else{
                            // 무언가 처리를 해줍니다.	대부분 비동기 AJAX 통신 처리 구문을 수행합니다.

                            var item = select.shift();
                            
                            alert(Object.toJSON(item));
                            
                            //alert(item.loginId+"   "+item.name);
                            addUserOpenfire(item.loginId, item.name);
                            
                            if(item) {
                                var url = "<c:url value='/usermg/approveUser.json' />";
                                var pars = "userId=" + item.userId+"&dutyCd="+item.dutyCd;
                                new AXReq(url, {
                                    pars    : pars, onsucc: function (res) {
                                        myProgress.update(); // 프로그레스의 다음 카운트를 시작합니다.
                                        console.log("succ");
                                    	console.log(res);
                                    	if(res.result.SUCCESS){
                                    		
                                    	}else{
                                    		errors.push(res.result.MESSAGE);
                                    	}
                                    }, onerr: null
                                });
                            }else{
                                myProgress.close();
                                mask.close();
                                if(errors.length>0){
                                	var msg = "";
                                	for(var idx=0 ; idx<errors.length; idx++){
                                		if(idx!=0){
                                			msg +=",";
                                		}
                                		msg += errors[idx];
                                	}
                                	
                                	gfnDialog(msg);
                                }else{
                                	gfnDialog("승인처리 및 메신저에 등록이 되었습니다.<br>메신저서버에서 소속을 결정해 주세요<br><b>[ 메신저서버관리 > Login > User/Groups > Groups ]</b><br><b>- 메신저초기암호는 『123456』입니다 -");
                                }
                                fnObj.search.submit();
                            }                            
                        }
                    },{
                        totalCount:select.length,
                        top:200,
                        width:400,
                        title:"회원 승인처리"
                    });
                },
                removeConfirm: function(){
                	var select = this.target.getCheckedList(0);
                    if(select.length == 0){
                    	gfnDialog("강퇴처리할 항목을 선택하세요.");
                        return false;
                    }
                    
                    gfnConfirm("강퇴처리를 진행 하시겠습니까?","fnObj.grid.removeUser();");
                },
                removeUser: function(){
                	var select = this.target.getCheckedList(0);
                	var errors = new Array();
                	var isRemovalInvalidated = false;
                    
                    for(var idx=0;idx<select.length;idx++){
                    	console.log(select[idx]);
                   		console.log(select[idx].delYn+","+select[idx].approveYn);
                   		if(select[idx].delYn!="N"){
                   			this.target.checkedColSeq(0,false,idx);
                   			isRemovalInvalidated = true;
                   		}
                   	}
                    if(isRemovalInvalidated){
                    	gfnDialog("탈퇴,강퇴중인 회원은 처리할 수 없습니다.");
                    	return false;
                    }

                    var myProgress = new AXProgress();
                    myProgress.setConfig({
                        theme:"AXCircleProgress"
                        , duration:50
                    });

                    mask.open();
                    myProgress.start(function(){
                        //trace(this);
                        if(this.isEnd){
                            myProgress.close();
                            mask.close();
                            if(errors.length>0){
                            	var msg = "";
                            	for(var idx=0 ; idx<errors.length; idx++){
                            		if(idx!=0){
                            			msg +=",";
                            		}
                            		msg += errors[idx];
                            	}
                            	gfnDialog(msg);
                            }else{
                            	toast.push("강퇴처리 완료 되었습니다.");
                            }
                            fnObj.search.submit();
                        }else{
                            // 무언가 처리를 해줍니다.	대부분 비동기 AJAX 통신 처리 구문을 수행합니다.

                            var item = select.shift();
                            if(item) {
                                var url = "<c:url value='/usermg/removeUser.json' />";
                                var pars = {"userId" : item.userId,"delYn" : "F"}; 
                                new AXReq(url, {
                                    pars    : pars, onsucc: function (res) {
                                    	if(res.result.SUCCESS){
                                    		
                                    	}else{
                                    		errors.push(res.result.MESSAGE);
                                    	}
                                        myProgress.update(); // 프로그레스의 다음 카운트를 시작합니다.
                                    }, onerr: null
                                });
                            }else{
                                myProgress.close();
                                mask.close();
                                toast.push("강퇴처리 완료 되었습니다.");
                                fnObj.search.submit();
                            }                            
                        }
                    },{
                        totalCount:select.length,
                        top:200,
                        width:400,
                        title:"회원 강퇴처리"
                    });
                }
	        },
	        modal: {
	            target: new AXModal(),
	            get: function(){ return this.target },
	            isInformChanged : false,
	            bind: function(){
	                window.myModal = this.target;
	                var _this = this;
	                this.target.setConfig({
	                    windowID:"myModalContainer",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    displayLoading:true,
	                    onclose:function(){
	                    	//toast.push(""+_this.isInformChanged);
	                    	if(_this.isInformChanged){
		                    	fnObj.reloadList();
	                    	}
	                    }
	                });
	            },
	            open: function(type, http){
	            	//toast.push(""+this.isInformChanged);
	            	this.isInformChanged=false;
	                this.target.open({
	                    url: http.url,
	                    pars: http.pars.queryToObject(),
	                    top: ( (typeof http.top == "undefined") ? 100 : http.top ),
	                    width: ( (typeof http.width == "undefined") ? 900 : http.width ),
	                    closeByEscKey: true
	                });
	            }
	        },
	        reloadList: function(){
                fnObj.grid.target.reloadList();
            },
            viewTempPassword: function(userId){
            	fnObj.modal.open("gridView", {
                    url:"<c:url value='/usermg/viewTempPassword.do' />", pars:"userId="+userId
                });	
            },
            pageResize : function(){
            	if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                	
                	fnObj.gridResizeCalulate();
                    
                }, 300);
            },
            gridResizeCalulate: function (){
            	var windowHeight = $(window).height();
	        	var gridHeight = windowHeight - gridAboveHeight;
            	
            	
            	if(windowHeight<=503){
            		gridHeight = 503 - gridAboveHeight;
            	}
            	
            	if(fnObj.search.target.expanded){
            		gridHeight =  gridHeight-searchExtendedHeight;	
            	}
	        	
                fnObj.grid.target.setHeight(gridHeight);
            }
	    };
	    </script>
	</ax:div>
</ax:layout>