<%@ page contentType="text/html; charset=UTF-8"
        %><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
        %><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
        %><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"
     %><ax:layout name="base.jsp">
    <ax:div name="header">
        <h1>비밀번호변경</h1>
    </ax:div>
    <ax:div name="contents">
    	<ax:row>
    		<ax:col size="12" wrap="true">
		       	<ax:form name="modifyMyPassword" method="post" action="<c:url value='/usermg/modifyMyPassword.json'/>">
		            <ax:fields>
		                <ax:field label="현재비밀번호" >
			                <input type="password" name="current" title="현재비밀번호" placeholder="" value="" maxlength="100" class="AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="변경비밀번호">
			                <input type="password" name="modified" title="변경비밀번호" placeholder="" value="" maxlength="100" class="AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="변경비밀번호확인">
		                	<input type="password" name="comfirm" title="변경비밀번호확인" placeholder="" value="" maxlength="100" class="AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		        </ax:form>
               	<div class="ax-button-group">
				    <div class="right">
				        <button type="button" class="AXButton" onclick="fnObj.form.save();"><i class="axi axi-save"></i>저장</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
			</ax:col>
    	</ax:row>
    </ax:div>
    <ax:div name="scripts">
        <script type="text/javascript">
            if ("${message}") {
                dialog.push("${message}");
            }
            
            var fnObj = {
                pageStart: function(){
                    this.form.init();
                    this.bindEvent();
                  	//toast.push(Object.toJSON(deptTree.list.length));
                  	//toast.push("${sessionScope['userInfo']['deptId']}");
                    //toast.push({type:"Caution",body:Object.toJSON(deptTree.list)});
                },
                bindEvent:function (){
                    $("form input").keypress(function(event){
                    	if(event.which==13){
                    		fnObj.form.save();
                    	}
                    });
                    
                },
                form:{
                    validator: new AXValidator(),
                    init: function(){
                        this.validator.setConfig({
                            targetFormName : "modifyMyPassword"
                        });
                    },
                    save: function(){

                        var validateResult = this.validator.validate();
                        if (!validateResult) {
                            var msg = this.validator.getErrorMessage();
                            var errorElement = this.validator.getErrorElement();
                            gfnDialog(msg,"","","",function(){
                            	errorElement.focus();
                            });
                            return false;
                        }else{
                            // 통과
                        	var passwordObj = $("form[name='"+this.validator.config.targetFormName+"']").find("input[name='modified']");
                            var passwordComfirmObj = $("form[name='"+this.validator.config.targetFormName+"']").find("input[name='comfirm']");
                            
                            if(passwordObj.val()!=passwordComfirmObj.val()){
                            	gfnDialog("변경비밀번호확인 항목이 변경비밀번호와 일치하지 않습니다.","","","",function(){
	                            	passwordComfirmObj.focus();
                            	});
	                            return false;
                            }
                            
                        }
                        

                        var url = "<c:url value='/usermg/modifyMyPassword.json'/>";
                        var pars = $(document.modifyMyPassword).serialize();
                        
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                    if(res.result.SUCCESS){
                                    	gfnDialog(res.result.MESSAGE);
                                    }else{
                                    	gfnDialog(res.result.MESSAGE);
                                    }
                                    
                                },
                                onerr:null
                            }
                        );
                        
                        return false;
                    }                    
                }
            };
        </script>
    </ax:div>
</ax:layout>