<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="modal.jsp">
    <ax:set name="title" value="이전 보고 목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col wrap="true" style="padding-top:15px;">
				<div class="ax-grid" id="page-grid-box" ></div>
			</ax:col>
		</ax:row>
		<div align="right" style="padding:3px;">업무에 등록 된 이전 목록을 10개까지 보여줍니다.  </div>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var myGrid  = new AXGrid();
	    
	    var fnObj = {
	        pageStart: function(){
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    fitToWidth: true,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
        						{key:"no"            , label:"번호"         , width:"50"  , align:"center"},
                                {key:"currSubj"      , label:"보고 제목"    , width:"150" , align:"left"},
                                {key:"rqOrg"         , label:"요청처"       , width:"100" , align:"center"},
                                {key:"reportDay"     , label:"주간보고일"   , width:"100" , align:"center"},
                                {key:"currCont "     , label:"금주실적"     , width:"100" , display:false},
                                {key:"currProgress"  , label:"금주 진행률"  , width:"100" , display:false},
                                {key:"nextSubj"      , label:"차주보고제목" , width:"100" , display:false},
                                {key:"nextCont"      , label:"차주실적"     , width:"100" , display:false},
                                {key:"nextProgress"  , label:"차주진행률"   , width:"100" , display:false},
                                {key:"compDttm "     , label:"완료예정일"   , width:"100" , display:false},
                    ],
                    body : {
                        onclick: function(){
                       		
                       		$("#currSubj"      , parent.document).val(this.item.currSubj);
                       		$("#rgOrg"         , parent.document).val(this.item.rqOrg);
                       		$("#reportDay"     , parent.document).val(this.item.reportDay);
                       		$("#currCont"      , parent.document).val(this.item.currCont);
                       		$("#currProgress"  , parent.document).val(this.item.currProgress);
                       		$("#nextSubj"      , parent.document).val(this.item.nextSubj);
                       		$("#nextCont"      , parent.document).val(this.item.nextCont);
                       		$("#nextProgress"  , parent.document).val(this.item.nextProgress);
                       		$("#compDttm"      , parent.document).val(this.item.compDttm);
                       		
                			parent.myModal.isInformChanged=true;
                			parent.myModal.close();
                        },
	                    addClass: function(){
                        }
                    }
                });

	        	myGrid.setList({
                    ajaxUrl:"<c:url value='/cmm/getCmmSelectList.do'/>", ajaxPars:"sqlGbn=weekly.selectBeforeList&jobCd="+parent.myForm.jobCd.value,
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        },
            reloadList: function(){
                myGrid.reloadList();
            }
   		   
	    };
	    $.ready(fnObj.pageStart());
        
       
	    </script>
	</ax:div>
	
	
</ax:layout>