<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="회의실 상세보기" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <c:forEach var="result" items="${list}" varStatus="status">
                <ax:form name="myForm" method="post">
                <input type="hidden" name="gbn" value="D"/>
                <input type="hidden" name="cfno" id="cfno" value="${result.cfNo}"/>                
                <input type="hidden" name="userid" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                	<ax:fields>
                		<ax:field label="회의실명">
                            ${result.cfName}
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="위치">
                            ${result.cfPlace1Name}
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="개방시간">
                            ${result.openStime} ~ ${result.openEtime} 
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="수용인원">
                            ${result.cfPerson}
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="첨부파일">
			               	<c:forEach var="fileList" items="${fileList}" varStatus="status">
				               	<a	href="#" onclick="window.open(encodeURI('<c:url value='/download/downloadFile.do?'/>requestedFile=${fileList.streFileNm}&oriFilenm=${fileList.orignlFileNm}'))">
		                		<c:out value="${fileList.orignlFileNm}" /></a>        
		                		<br>
	                		</c:forEach>
	                			<c:if test="${fileList.size() == 0}">없음</c:if>
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
				<div class="ax-button-group">
                	<div class="right">
		                <button type="button" class="AXButton" onclick="fnObj.confirm('U');"><i class="axi axi-save"></i>수정</button>
		                <button type="button" class="AXButton" onclick="fnObj.confirm('D');"><i class="axi axi-save"></i>삭제</button>
		                <button class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
	               	<div class="ax-clear"></div>
	            </div>
                </c:forEach>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
		
	    function changeTime(value){
	    	var sdatetime = $("#sdatetime").val();
	    	var edatetime = $("#edatetime").val();
	    	
	    	if(sdatetime != "" && edatetime != "" && sdatetime > edatetime){
	    		gfnDialog("<b>Warning</b> 시작시간이 종료시간보다 큽니다.\r\n시간을 다시 확인해주세요.","Warning","확인","Red");
	    		$("#sdatetime").bindSelectSetValue(0);
	    		$("#edatetime").bindSelectSetValue(0);
	    	}
	    }
	    
	    function hour(id){
	    	for(i=8;i<22;i++){
	    		var hour = i;
	    		if(hour.toString().length == 1){
	    			hour = "0"+hour;
	    		}
	    		for(j=0;j<60;j=j+10){
	    			var minute = j;
	    			if(minute == 0){
	    				minute = "00";
	    			}
	    			
	    			var time = hour + ":" + minute;
	    			
	    			$("#"+id).append("<option value='"+time+"'>"+time+"</option>");	
	    		}
	    	}
	    }
	    
		var fnObj = {
			pageStart: function(){
				
			},
			confirm: function(gbn){
				var msg;
				var callback;
				
				if(gbn == "U"){
					fnObj.moveEdit();
				} else if(gbn == "D"){
					msg = "삭제하시겠습니까?";
					callback = "fnObj.delForm();";
					gfnConfirm(msg,callback);
				}
				
			},
			moveEdit: function(){
				location.href="<c:url value='/cfroom/management/cfroomEdit.do'/>?cfno="+$("#cfno").val();
			},
			delForm: function(){
				
				 var form = document.myForm;
		         var formData = new FormData(form);
				
				 var url = "<c:url value='/cfroom/management/cfroomEdit.json'/>";
				 
		         jQuery.ajaxSettings.traditional = true;
		      
		         $.ajax({
	                    url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    dataType:"json",
			   			timeout: 5000,
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		gfnDialog("회의실 삭제가 완료되었습니다","Alert","확인","Red","location.href='cfroomList.do'");
                            } else {
                            	gfnDialog("<b>Warning</b>&nbsp;회의실 삭제가 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","location.href='cfroomView.do?cfno="+res.cfno+"'");
                            }
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="cfroomList.do";
			},
            serialize: function(){
                var frm = document.myForm;
                prompt("$(frm).serialize()", $(frm).serialize() );
            }
		}
		
		//$(document).ready(fnObj.pageStart);
	    </script>
	</ax:div>
</ax:layout>