<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="modal.jsp">
    <ax:set name="title" value="회의실 예약등록" />
    <ax:div name="header">
    <br>
        <h1>${title}</h1>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post" enctype="multipart/form-data">
                <input type="hidden" name="userid" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                	<ax:fields>
                		<ax:field label="제목">
                            <input type="text" name="title" id="title" maxlength="255" size="40" class="AXInput av-required" title="제목" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="회의실">
                			<select id="cfplace" class="AXSelect av-required" title="회의실" onchange="changePlace(this.value);">
                				<option value="">선택</option>
                				<c:forEach var="gbn" items="${place}" varStatus="status">
                					<option value="${gbn.cfNo}/${gbn.place}/${gbn.cfPerson}/${gbn.openStime}/${gbn.openEtime}">${gbn.cfName}</option>
                				</c:forEach>
                			</select>
                			<input type="hidden" name="cfplace" title="회의실"/>
                			<input type="hidden" name="openStime"/>
                			<input type="hidden" name="openEtime"/>
                			&nbsp;&nbsp;<font color="red">* 회의실을 먼저 선택해주세요.</font>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="회의실 위치">
                			<div id="place"></div>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="반복구분">
                			<select name="repeat" id="repeat" title="반복구분" onchange="repeatChange(this.value);" class="AXSelect av-required">
                				<c:forEach var="gbn" items="${repeat}" varStatus="status">
                					<option value="${gbn.code}">${gbn.codeShtnm}</option>
                				</c:forEach>
                			</select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="예약자">
                			<input type="hidden" name="userId" id="userId" value="${sessionScope['userInfo']['userId']}"/>
                            <input type="text" name="user" id="user" value="${sessionScope['userInfo']['name']}(${sessionScope['userInfo']['loginId']})" class="AXInput" readonly />
                        </ax:field>
                	</ax:fields>
                	<div id="detail">
	                	<div id="100">
	                	<ax:fields>
			                <ax:field label="<font color='red' size='4'>*</font> 기간설정">	
				                <input type="text" name="sdate" value="${date}" id="AXInputDateTimeST" class="AXInput W100" title="예약일"/>&nbsp;
				                <input type="text" name="sdatetime" id="sdatetime" class="AXInput W40" onfocusout="focusout('A')">&nbsp;~&nbsp;
				                <input type="text" name="edatetime" id="edatetime" class="AXInput W40" onfocusout="focusout('A')">
				                <br><span id="opentime"></span>
			                </ax:field>
			            </ax:fields>
			            </div>
			            <div id="200" style="display:none;">
	                	<ax:fields>
			                <ax:field label="<font color='red' size='4'>*</font> 기간설정">
				                <input type="text" name="sdate1" value="${date}" id="AXInputDateTimeST1" class="AXInput W100" title="예약시작일"/> ~ <input type="text" name="edate1" value="${date}" id="AXInputDateTimeED1" class="AXInput W100" title="예약종료일"/>
				                <input type="text" name="sdatetime1" id="sdatetime1" class="AXInput W40" onfocusout="focusout('B')">&nbsp;~&nbsp;
				                <input type="text" name="edatetime1" id="edatetime1" class="AXInput W40" onfocusout="focusout('B')">
				                <br><span id="opentime1"></span>
			                </ax:field>
			            </ax:fields>
			            </div>
                	</div>
		            <ax:fields>
                		<ax:field label="참석인원">
                            <input type="text" name="attend" id="attend" class="AXInput W50 av-required" title="참석인원" />
                            &nbsp;&nbsp;<span id="maxattend"></span>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="회의내용">
                           <div style="padding:5px">
				                <label class="AXInputLabel fullWidth">
				                    <textarea id="nttCn" name="nttCn"  cols="60" rows="10" class="AXTextarea av-required" title="회의내용"></textarea>
				                </label>
				            </div>
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
                	<div style="text-align:right;">
		                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>예약등록</button>
		                <button class="AXButton" onclick="parent.myModal.close();"><i class="axi axi-close"></i>닫기</button>
	               	</div>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    
	    function focusout(gbn){
	    	var openStime = $("input[name=openStime]").val();
	    	var openEtime = $("input[name=openEtime]").val();
	    	var stime,etime,chk;
	    	
	    	if(gbn == "A"){
	    		stime = $("#sdatetime");
	    		etime = $("#edatetime");
	    	} else {
	    		stime = $("#sdatetime1");
	    		etime = $("#edatetime1");
	    	}
	    	
	    	if(stime.val() != "" && etime.val() != ""){
	    		if(stime.val() > etime.val()){
		    		gfnDialog("<b>Warning</b> 시작시간이 종료시간보다 큽니다.\r\n시간을 다시 확인해주세요.","Warning","확인","Red");
		    		stime.val("");
					etime.val("");
		    		return false;
		    	}
	    		
		    	if(stime.val().replace(":","") < openStime.replace(":","") || etime.val().replace(":","") > openEtime.replace(":","")){
					chk = "N";
				} else {
					chk = "Y";
				}
	    	}
			
			if(chk == "N"){
				gfnDialog("<b>Warning</b> 개방시간에 들어가지않습니다\r\n개방시간을 확인해주세요.","Warning","확인","Red");	
				stime.val("");
				etime.val("");
			}
	    }
	    
	    function inittime(chk){
	    	$("#detail input").attr("disabled",chk);
	    	
	    	$("#detail input").val("");
	    }
	    
	    var changeValue;
	    function changePlace(value){
	    	changeValue = value;
	    	if(value == ""){
	    		$("#attend").attr("disabled",true);
	    		$("#attend").val("");
	    		inittime(true);
	    		$("#repeat").bindSelectDisabled(true);
	    		$("#repeat").bindSelectSetValue(0);
	    		$("#AXInputDateTimeST").bindDate({align:"right", valign:"top", separator:"-", startTargetID:"AXInputDateTimeST", onChange:function(){
	                //toast.push(Object.toJSON(this));
	            }});
	    		
	    		$("#attend").unbindInput();
	    		$("#maxattend").html("");
	    		$("#opentime").html("");
	    		$("#opentime1").html("");
	    	} else {
	    		$("#attend").attr("disabled",false);
	    		inittime(false);
	    		$("#repeat").bindSelectDisabled(false);
	    		
		    	var split = value.split("/");
		    	
		    	$("input[name=cfplace]").val(split[0]);
		    	$("input[name=openStime]").val(split[3]);
		    	$("input[name=openEtime]").val(split[4]);
		    	$("#place").text(split[1]);
		    	
		    	$("#attend").bindNumber({
					min:1
				});
		    	
		    	$("#maxattend").html(" 최대수용인원(<font color='red'>"+split[2]+"명</font>)");
		    	$("#opentime").html(" 개방시간(<font color='red'>"+split[3]+" ~ "+split[4]+"</font>)");
		    	$("#opentime1").html(" 개방시간(<font color='red'>"+split[3]+" ~ "+split[4]+"</font>)");
		    	
		    	hour("sdatetime");
			    hour("edatetime");	
	    	}
	    	
	    	$("input[name=sdate]").val("${date}");
	    	$("input[name=sdate1]").val("${date}");
	    	$("input[name=edate1]").val("${date}");
	    }
	    
	    function repeatChange(value){
	    	if(value == "100"){
	    		$("#100").css({"display":"block"});
	    		$("#200").css({"display":"none"});
	    		hour("sdatetime");
			    hour("edatetime");
			    $("#sdatetime").val("");
			    $("#edatetime").val("");
	    		$("#AXInputDateTimeST").bindDate({align:"right", valign:"top", separator:"-", startTargetID:"AXInputDateTimeST", onChange:function(){
	                //toast.push(Object.toJSON(this));
	            }});
	    	} else {
	    		$("#200").css({"display":"block"});
	    		$("#100").css({"display":"none"});
	    		hour("sdatetime1");
			    hour("edatetime1");
			    $("#sdatetime1").val("");
			    $("#edatetime1").val("");
	    		$("#AXInputDateTimeED1").bindTwinDate({align:"right", valign:"top", separator:"-", startTargetID:"AXInputDateTimeST1", onChange:function(){
	                //toast.push(Object.toJSON(this));
	            }});
	    	}

	    }
	    
	    function hour(id){
			$("#"+id).bindPattern({pattern: "time"});
			$("#"+id).bindPattern({pattern: "time"});
	    }
	    
	    function overlapCheck(){
	    	var sdate;
	    	var edate;
	    	var sdatetime;
	    	var edatetime;
	    	var value = $("#repeat").val();
	    	
	    	if(value == "100"){
	    		sdate = $("input[name=sdate]").val();
	    		edate = $("input[name=sdate]").val();
	    		sdatetime = $("#sdatetime").val();
	    		edatetime = $("#edatetime").val();
	    	} else {
	    		sdate = $("input[name=sdate1]").val();
	    		edate = $("input[name=edate1]").val();
	    		sdatetime = $("#sdatetime1").val();
	    		edatetime = $("#edatetime1").val();
	    	}
	    	
	        var formData = new FormData();
	        formData.append("repeat",value);
	        formData.append("sdate",sdate);
	        formData.append("edate",edate);
	        formData.append("sdatetime",sdatetime);
	        formData.append("edatetime",edatetime);
	        formData.append("cfno",$("input[name=cfplace]").val());
	        
	    	var url = "<c:url value='/cfroom/reserve/overlapCheck.json'/>";
	    	var returnValue;
	        $.ajax({
                   url: url,
                   processData: false,
                   contentType: false,
                   data: formData, 
                   type: 'POST',
                   dataType:"json",
                   async: false,
		   		   timeout: 5000,
                   success: function(res){
                	   returnValue = res.result;
                   },
                   error : null
               });
	        return returnValue;
	    }
	    
	    var pageID = "AXValidator";

		var myValidator = new AXValidator(); // Validator 선언
		var fnObj = {
			pageStart: function(){

				myValidator.setConfig({
					targetFormName : "myForm"
					,checkCrlf:true
				});
				
				$("#repeat").bindSelect();
				$("#cfplace").bindSelect();
				
				changePlace("");
				
				gfnRequire();
			},
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				var split = changeValue.split("/");

				if(parseInt($("#attend").val()) > parseInt(split[2])){
					gfnDialog("<b>Warning</b> 최대수용인원을 초과하였습니다.\r\n참석인원을 확인해주세요.","Warning","확인","Red",function(){
						$("#attend").focus();
					});
					return false;
				}
				
				if($("#repeat").val() == "100"){
					if($("input[name=sdate]").val() == ""){
						gfnDialog("<b>Waring</b>&nbsp;일자를 입력해주세요.","Warning","확인","Red",function(){
							$("input[name=sdate]").focus();
						});
						return false;
					}
					
					if($("#sdatetime").val() == ""){
						gfnDialog("<b>Waring</b>&nbsp;예약시작시간을 입력해주세요.","Warning","확인","Red",function(){
							$("input[name=sdatetime]").focus();
						});
						return false;
					} else if($("#edatetime").val() == ""){
						gfnDialog("<b>Waring</b>&nbsp;예약종료시간을 입력해주세요.","Warning","확인","Red",function(){
							$("input[name=edatetime]").focus();
						});
						return false;
					}
				} else {
					if($("input[name=sdate1]").val() == ""){
						gfnDialog("<b>Waring</b>&nbsp;반복예약시작일를 입력해주세요.","Warning","확인","Red",function(){
							$("input[name=sdate1]").focus();
						});
						return false;
					} else if($("input[name=edate1]").val() == ""){
						gfnDialog("<b>Waring</b>&nbsp;반복예약종료일를 입력해주세요.","Warning","확인","Red",function(){
							$("input[name=edate1]").focus();
						});
						return false;
					}
					
					if($("#sdatetime1").val() == ""){
						gfnDialog("<b>Waring</b>&nbsp;예약시작시간을 입력해주세요.","Warning","확인","Red",function(){
							$("input[name=sdatetime1]").focus();
						});
						return false;
					} else if($("#edatetime1").val() == ""){
						gfnDialog("<b>Waring</b>&nbsp;예약종료시간을 입력해주세요.","Warning","확인","Red",function(){
							$("input[name=edatetime1]").focus();
						});
						return false;
					}
				}
				
				var cnt = overlapCheck();
				
				if(cnt > 0){
					gfnDialog("<b>Waring</b>&nbsp;다른 예약일정과 시간이 중복됩니다\r\n다른시간을 선택해주세요.","Warning","확인","Red","");
					return false;
				}
				
				gfnConfirm("예약등록하시겠습니까?","fnObj.saveForm();","","저장");
			},
			saveForm: function(){
				
				 var form = document.myForm;
		         var formData = new FormData(form);
				
				 var url = "<c:url value='/cfroom/reserve/reserveRegist.json'/>";
				 
		         $.ajaxSettings.traditional = true;
		      
		         $.ajax({
	                    url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    dataType:"json",
			   			timeout: 5000,
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		gfnDialog("예약등록이 완료되었습니다","Alert","확인","Red","parent.fnObj.calendar.load(); parent.location.reload();");
                            } else {
                            	gfnDialog("<b>Warning</b>예약등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","parent.location.reload();");
                            }
	                    },
	                    error : null
	                });
			},
		}
		
		$(document).ready(fnObj.pageStart);
	    </script>
	</ax:div>
</ax:layout>