<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="공통코드(대분류) 등록" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post">
                <input type="hidden" name="gbn" value="S"/>
                <input type="hidden" name="userid" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                	<ax:fields>
                		<ax:field label="공통코드ID">
                            <input type="text" name="codeid" id="codeid" title="공통코드ID" class="AXInput av-required" maxlength="6" />&nbsp;
                            <button type="button" id="checkId" class="AXButtonSmall Blue"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i> 공통코드ID 중복확인</button>
                    		<input type="hidden" name="isIdOverlapped" id="isIdOverlapped" value=""/> 
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="공통코드명">
                            <input type="text" name="codenm" id="codenm" title="공통코드명" maxlength="60" class="AXInput av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="공통코드<br>사용내역">
                            <input type="text" name="codeuseexp" id="codeuseexp" title="공통코드사용내역" maxlength="100" class="AXInput" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="사용여부">
                            <select name="codeuseyn" id="codeuseyn" title="사용여부" class="AXSelect av-required">
                            	<option value="">선택</option>
                            	<option value="Y">Y</option>
                            	<option value="N">N</option>
                            </select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="코드길이">
                            <input type="text" name="codelen" id="codelen" title="코드길이" class="AXInput W50 av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="세부코드<br>변경가능여부">
                            <select name="noeditat" id="noeditat" title="세부코드 변경가능여부" class="AXSelect">
                            	<option value="Y" selected>Y</option>
                            	<option value="N">N</option>
                            </select>
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
				<div class="ax-button-group">
                	<div class="right">
		                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>등록</button>
		                <button class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
	               	<div class="ax-clear"></div>
	            </div>
	          
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
		
	    var pageID = "AXValidator";
	    		var myValidator = new AXValidator(); // Validator 선언
		var fnObj = {
			pageStart: function(){
				
				gfnRequire();
				
				myValidator.setConfig({
					targetFormName : "myForm"
				});
				
				jQuery("#codeuseyn").bindSelect();
				jQuery("#noeditat").bindSelect();
				$("#codelen").bindNumber({
					min:1
				});
				
				$("#checkId").click(function(){
                	
                	var codeid = $("#codeid").val();
                	
                	if(codeid==""){
                		gfnDialog("<b>Warning</b>&nbsp;ID를 기입후 확인하세요.","Warning","확인","Red","");
                		return false;
                	}
                	
                	if(codeid.length < 6){
                		gfnDialog("<b>Warning</b>&nbsp;공통코드ID는 6자리여야 합니다.","Warning","확인","Red","");
                		return false;
                	}
                	
                	var url = "<c:url value='/cmmcode/checkCodeId.json'/>";
                    var pars = {codeid:codeid};
                    
                    new AXReq(url, 
                        {
                            pars:pars, 
                            onsucc:function(res){
                            	gfnDialog(res.result.MESSAGE,"Alert","확인","Red","");
                                if(res.result.SUCCESS){
                                	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                                	$("input[name='isIdOverlapped']").val("false");
                                }else{
                                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                                	$("input[name='isIdOverlapped']").val("true");
                                }
                                
                            },
                            onerr:null
                        }
                    );
                });
				
                $("input[name='codeid']").change(function(){
                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                	$("input[name='isIdOverlapped']").val("");
                });
				
			},
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				var isIdOverlappedObj = $("#isIdOverlapped").val();
				
				if(isIdOverlappedObj==""){
					gfnDialog("<b>Warning</b>&nbsp;아이디 중복확인을 해야합니다.","Warning","확인","Red","");
                	$("#checkId").focus();
                	return false;
                }else if(isIdOverlappedObj=="true"){
                	gfnDialog("<b>Warning</b>&nbsp;다른 ID로 중복확인 후 등록바랍니다.","Warning","확인","Red","");
                	$("#codeid").focus();
                	return false;
                }
				
				gfnConfirm("등록하시겠습니까?","fnObj.saveForm();");
			},
			saveForm: function(){
				
				 var form = document.myForm;
		         var formData = new FormData(form);
				
				 var url = "<c:url value='/cmmcode/codeGenEdit.json'/>";
				 
		         jQuery.ajaxSettings.traditional = true;
		      
		         $.ajax({
	                    url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    dataType:"json",
			   			timeout: 5000,
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		gfnDialog("공통코드(대분류) 등록이 완료되었습니다","Alert","확인","Red","location.href='codeGenView.do?codeid="+res.codeid+"'");
                            } else {
                            	gfnDialog("<b>Warning</b>&nbsp;공통코드(대분류) 등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","location.href='codeGenList.do'");
                            }
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="codeGenList.do";
			},
            serialize: function(){
                var frm = document.myForm;
                prompt("$(frm).serialize()", $(frm).serialize() );
            }
		}
		
		//$(document).ready(fnObj.pageStart);
	    </script>
	</ax:div>
</ax:layout>