<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="공통코드(대분류) 상세보기" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post">
                <c:forEach var="result" items="${list}" varStatus="status">
                <input type="hidden" name="gbn" id="gbn" value="U"/>
                <input type="hidden" name="codeido"	id="codeido" value="${result.codeid}" />
                <input type="hidden" name="userid" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                	<ax:fields>
                		<ax:field label="공통코드ID">
                            <input type="text" name="codeid" id="codeid" title="공통코드ID" value="<c:out value='${result.codeid}'/>" class="AXInput" maxlength="6" readonly />&nbsp;
<!--                             <button type="button" id="checkId" class="AXButtonSmall Blue"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i> 공통코드ID 중복확인</button> -->
                    		<input type="hidden" name="isIdOverlapped" id="isIdOverlapped" value="false"/> 
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="공통코드명">
                            <input type="text" name="codenm" id="codenm" title="공통코드명" maxlength="60" value="<c:out value='${result.codectn}'/>" class="AXInput av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="공통코드<br>사용내역">
                            <input type="text" name="codeuseexp" id="codeuseexp" title="공통코드사용내역" maxlength="100" value="<c:out value='${result.codeuseexp}'/>" class="AXInput" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="사용여부">
                            <select name="codeuseyn" id="codeuseyn" title="사용여부" class="AXSelect av-required">
                            	<option value="">선택</option>
                            	<option value="Y" <c:if test="${result.codeuseyn eq 'Y'}">selected</c:if> >Y</option>
                            	<option value="N" <c:if test="${result.codeuseyn eq 'N'}">selected</c:if> >N</option>
                            </select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="코드길이">
                            <input type="text" name="codelen" id="codelen" title="코드길이" value="${result.codelen}" class="AXInput W50 av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="세부코드<br>변경가능여부">
                            <select name="noeditat" id="noeditat" title="세부코드 변경가능여부" class="AXSelect">
                            	<option value="Y" <c:if test="${result.noeditat eq 'Y'}">selected</c:if> >Y</option>
                            	<option value="N" <c:if test="${result.noeditat eq 'N'}">selected</c:if> >N</option>
                            </select>
                        </ax:field>
                	</ax:fields>
                </c:forEach>
                </ax:form>
                <br>
				<div class="ax-button-group">
                	<div class="right">
		                <button type="button" class="AXButton" onclick="fnObj.saveConfirm('U');"><i class="axi axi-save"></i> 수정</button>
		                <button type="button" class="AXButton" onclick="fnObj.saveConfirm('D');"><i class="axi axi-delete2"></i> 삭제</button>
		                <button class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i> 목록</button>
	               	</div>
	               	<div class="ax-clear"></div>
	            </div>
	            
		            <h1>세부코드 목록</h1>
	                <div class="ax-button-group">
	                	<div class="left">
							<select id="pageS" name="pageS" class="AXSelect">
								<option value="10">10</option>
								<option value="30">30</option>
								<option value="50">50</option>
								<option value="100">100</option>
							</select>
						</div>
						<div class="right">
			                <button type="button" class="AXButton" id="codeReg" onclick="fnObj.codeReg();"><i class="axi axi-save"></i> 세부코드 등록</button>
		               	</div>
						<div class="ax-clear"></div>
					</div>
		            <div class="ax-grid" id="page-grid-box"></div>  
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
		var isChange = false;
        $("input, select").change(function(){
        	isChange  = true;
        });
	    
	    var pageID = "AXValidator";
	    
	    var myGrid = new AXGrid();
	    
		var myValidator = new AXValidator(); // Validator 선언
		var fnObj = {
			pageStart: function(){
				
				gfnRequire();
				
				myValidator.setConfig({
					targetFormName : "myForm"
				});
				
				$("#codeuseyn").bindSelect();
				$("#noeditat").bindSelect();
				$("#pageS").bindSelect();
				$("#codelen").bindNumber({
					min:1
				});
				
// 				$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
				
// 				$("#checkId").click(function(){
                	
//                 	var codeid = $("#codeid").val();
//                 	var codeido = $("#codeido").val();
                	
//                 	if(codeid == codeido){
//                 		return false;
//                 	}
                	
//                 	if(codeid==""){
//                 		gfnDialog("<b>Warning</b>&nbsp;ID를 기입후 확인하세요.","Warning","확인","Red","");
//                 		return false;
//                 	}
                	
//                 	if(codeid.length < 6){
//                 		gfnDialog("<b>Warning</b>&nbsp;공통코드ID는 6자리여야 합니다.","Warning","확인","Red","");
//                 		return false;
//                 	}
                	
//                 	var url = "<c:url value='/cmmcode/checkCodeId.json'/>";
//                     var pars = {codeid:codeid};
                    
//                     new AXReq(url, 
//                         {
//                             pars:pars, 
//                             onsucc:function(res){
//                             	gfnDialog(res.result.MESSAGE,"Alert","확인","Red","");
//                                 if(res.result.SUCCESS){
//                                 	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
//                                 	$("input[name='isIdOverlapped']").val("false");
//                                 }else{
//                                 	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
//                                 	$("input[name='isIdOverlapped']").val("true");
//                                 }
                                
//                             },
//                             onerr:null
//                         }
//                     );
//                 });
				
//                 $("input[name='codeid']").change(function(){
//                 	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
//                 	$("input[name='isIdOverlapped']").val("");
//                 });
                                
				myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    fitToWidth: false,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"no", label:"번호", width: "70", align:"center"},
                        {key:"detailcode", label:"세부코드", align:"center", width:"100"},
                        {key:"detailnm", label:"세부코드명", align:"center", width:"250"},
                        {key:"dtailfullnm", label:"세부코드설명", align:"center", width:"250"},
                        {key:"detailuseyn", label:"사용여부", align:"center", width:"100"},
                        {key:"detailrem", label:"비고", align:"center", width:"200"},
                        {key:"detailregid", label:"등록자", width:"150", align:"center"},
                        {key:"detailregdttm", label:"등록일자", width:"150", align:"center"},
                        {key:"detailmodid", label:"수정자", width:"150", align:"center"},
                        {key:"detailmoddttm", label:"수정일자", width:"150", align:"center"}
                    ],
                    body : {
                        onclick: function(){
                        	location.href="codeView.do?code="+this.item.detailcode+"&codeid="+$("#codeid").val();
                        }
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }
                });

	        	myGrid.setList({
                    ajaxUrl:"getCodeGenDetailList.do", ajaxPars:"codeid="+$("#codeid").val(), 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        	
	        	if($("#noeditat").val() == "N") $("#codeReg").remove();
			},
			saveConfirm: function(val){
				var msg = (val == "U") ? "수정" : "삭제";
				gfnConfirm(msg + "하시겠습니까?","fnObj.saveForm('"+val+"');");
			},
			saveForm: function(val){
				
				if(val == "U"){
					var validateResult = myValidator.validate();
					if (!validateResult) {
						var msg = myValidator.getErrorMessage();
						gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
							myValidator.getErrorElement().focus();
						});
						return false;
					}else{
						//alert(	validateResult );
					}
					
// 					var isIdOverlappedObj = $("#isIdOverlapped").val();
					
// 					if(isIdOverlappedObj==""){
// 						gfnDialog("<b>Warning</b>&nbsp;아이디 중복확인을 해야합니다.","Warning","확인","Red","");
// 	                	$("#checkId").focus();
// 	                	return false;
// 	                }else if(isIdOverlappedObj=="true"){
// 	                	gfnDialog("<b>Warning</b>&nbsp;다른 ID로 중복확인 후 등록바랍니다.","Warning","확인","Red","");
// 	                	$("#codeid").focus();
// 	                	return false;
// 	                }
					
					if(!isChange){
						gfnDialog("<b>Warning</b>&nbsp;변경된 값이 없습니다.","Warning","확인","Red","");
						return false;
					}
					
					$("#gbn").val("U");
				} else {
					$("#gbn").val("D");
				}
				
				var form = document.myForm;
		        var formData = new FormData(form);
				
				var url = "<c:url value='/cmmcode/codeGenEdit.json'/>";
				 
		        jQuery.ajaxSettings.traditional = true;
		      
		         $.ajax({
	                    url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    dataType:"json",
			   			timeout: 5000,
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		if($("#gbn").val() == "U"){
	                    			gfnDialog(res.result.MESSAGE,"Alert","확인","Red","location.href='codeGenView.do?codeid="+res.codeid+"'");	
	                    		} else if($("#gbn").val() == "D"){
	                    			gfnDialog(res.result.MESSAGE,"Alert","확인","Red","location.href='codeGenList.do'");
	                    		}
                            } else {
                            	gfnDialog("<b>Warning</b>&nbsp;"+res.result.MESSAGE,"Alert","확인","Red","location.href='codeGenList.do'");
                            }
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="codeGenList.do";
			},
            serialize: function(){
                var frm = document.myForm;
                prompt("$(frm).serialize()", $(frm).serialize() );
            },
            codeReg: function(){
            	location.href='codeReg.do?codeid='+$("#codeid").val();
            }
		}
		
		//$(document).ready(fnObj.pageStart);
	    </script>
	</ax:div>
</ax:layout>