<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="공통코드(소분류) 상세보기" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post">
                <input type="hidden" name="gbn" id="gbn" value="U"/>
                <input type="hidden" name="userid" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                <c:forEach var="result" items="${list}" varStatus="status">
                <input type="hidden" id="maxlength" value="${result.codelen}"/>
                <input type="hidden" name="codeo" id="codeo" value="${result.code}" />
                <input type="hidden" name="noEditAt" id="noEditAt" value="${result.noeditat}"/>
                	<ax:fields>
                		<ax:field label="대분류코드ID">
                            <input type="text" name="codeid" id="codeid" title="대분류코드ID" value="<c:out value='${result.codeid}'/>" class="AXInput" readonly />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="대분류코드명">
                            <input type="text" name="codenm" id="codenm" title="대분류코드명" value="<c:out value='${result.codenm}'/>" class="AXInput" readonly />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="세부코드ID">
                            <input type="text" name="code" id="code" title="세부코드ID" value="<c:out value='${result.code}'/>" class="AXInput av-required" />
                            <button type="button" id="checkId" class="AXButtonSmall Blue"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i> 공통코드ID 중복확인</button>
                    		<input type="hidden" name="isIdOverlapped" id="isIdOverlapped" value="false"/> 
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="세부코드명">
                            <input type="text" name="codectn" id="codectn" title="세부코드명" value="<c:out value='${result.codectn}'/>" class="AXInput av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="세부코드단축명">
                            <input type="text" name="codeshtnm" id="codeshtnm" title="세부코드단축명" value="<c:out value='${result.codeshtnm}'/>" class="AXInput av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="비고">
                            <input type="text" name="coderem" id="coderem" title="비고" value="<c:out value='${result.coderem}'/>" class="AXInput" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="사용여부">
                            <select name="codeuseyn" id="codeuseyn" title="사용여부" class="AXSelect av-required">
                            	<option value="">선택</option>
                            	<option value="Y" <c:if test="${result.codeuseyn eq 'Y'}">selected</c:if> >Y</option>
                            	<option value="N" <c:if test="${result.codeuseyn eq 'N'}">selected</c:if> >N</option>
                            </select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="순서">
                            <input type="text" name="sortorder" id="sortorder" title="순서" value="${result.sortorder}" class="AXInput W50 av-required" />
                        </ax:field>
                	</ax:fields>
                </c:forEach>
                </ax:form>
                <br>
				<div class="ax-button-group">
                	<div class="right">
		                <button type="button" class="AXButton" onclick="fnObj.genDetailView();"><i class="axi axi-pageview"></i>대분류코드 상세보기</button>
		                <button type="button" class="AXButton" onclick="fnObj.saveConfirm('U');"><i class="axi axi-save"></i>수정</button>
		                <button type="button" class="AXButton" onclick="fnObj.saveConfirm('D');"><i class="axi axi-delete2"></i> 삭제</button>
		                <button class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
	               	<div class="ax-clear"></div>
	            </div>
	            
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var isChange = false;
        $("input, select").change(function(){
        	isChange  = true;
        });
        
	    var pageID = "AXValidator";
	    
		var myValidator = new AXValidator(); // Validator 선언
		var fnObj = {
			pageStart: function(){
				
				gfnRequire();
				
				myValidator.setConfig({
					targetFormName : "myForm"
				});
				
				$("#codeuseyn").bindSelect();
				$("#sortorder").bindNumber({
					min:1
				});
				$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
				$("#code").attr("maxlength",$("#maxlength").val());
				
				$("#checkId").click(function(){
                	
					var codeid = $("#codeid").val();
                	var code = $("#code").val();
                	var codeo = $("#codeo").val();
                	
                	if(code == codeo){
                		return false;
                	}
                	
                	if(code==""){
                		gfnDialog("<b>Warning</b>&nbsp;ID를 기입후 확인하세요.","Warning","확인","Red","");
                		return false;
                	}
                	
                	if(code.length < $("#maxlength").val()){
                		gfnDialog("<b>Warning</b>&nbsp;세부코드ID는 "+$("#maxlength").val()+"자리여야 합니다.","Warning","확인","Red","");
                		return false;
                	}
                	
                	var url = "<c:url value='/cmmcode/checkCode.json'/>";
                    var pars = {codeid:codeid,code:code};
                    
                    new AXReq(url, 
                        {
                            pars:pars, 
                            onsucc:function(res){
                                if(res.result.SUCCESS){
                                	gfnDialog(res.result.MESSAGE,"Alert","확인","Red","");
                                	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                                	$("input[name='isIdOverlapped']").val("false");
                                }else{
                                	gfnDialog("<b>Warning</b>&nbsp;"+res.result.MESSAGE,"Warning","확인","Red","");
                                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                                	$("input[name='isIdOverlapped']").val("true");
                                }
                                
                            },
                            onerr:null
                        }
                    );
                });
				
                $("input[name='code']").change(function(){
                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                	$("input[name='isIdOverlapped']").val("true");
                });
                
                if($("#noEditAt").val() == "N"){
	        		$("input").attr("readonly",true);
	        				
	        		$("button").each(function(){
	        			if($(this).find("i").attr("class").indexOf("list") < 0 && 
	        			   $(this).find("i").attr("class").indexOf("pageview") < 0		
	        			){
	        				$(this).remove();
	        			}
	        		});
	        	}
			},
			saveConfirm: function(val){
				var msg = (val == "U") ? "수정" : "삭제";
				gfnConfirm(msg + "하시겠습니까?","fnObj.saveForm('"+val+"');");
			},
			saveForm: function(val){
				if(val == "U"){
					var validateResult = myValidator.validate();
					if (!validateResult) {
						var msg = myValidator.getErrorMessage();
						gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
							myValidator.getErrorElement().focus();
						});
						return false;
					}else{
						//alert(	validateResult );
					}
					
					var isIdOverlappedObj = $("#isIdOverlapped").val();
					
					if(isIdOverlappedObj==""){
						gfnDialog("<b>Warning</b>&nbsp;아이디 중복확인을 해야합니다.","Warning","확인","Red","");
	                	$("#checkId").focus();
	                	return false;
	                }else if(isIdOverlappedObj=="true"){
	                	gfnDialog("<b>Warning</b>&nbsp;다른 ID로 중복확인 후 등록바랍니다.","Warning","확인","Red","");
	                	$("#code").focus();
	                	return false;
	                }
					
					if(!isChange){
						gfnDialog("<b>Warning</b>&nbsp;변경된 값이 없습니다.","Warning","확인","Red","");
						return false;
					}
					
					$("#gbn").val("U");
				} else if(val == "D") {
					$("#gbn").val("D");
				}
				
				 var form = document.myForm;
		         var formData = new FormData(form);
				
				 var url = "<c:url value='/cmmcode/codeEdit.json'/>";
				 
		         jQuery.ajaxSettings.traditional = true;
		      
		         $.ajax({
	                    url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    dataType:"json",
			   			timeout: 5000,
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		if($("#gbn").val() == "U"){
	                    			gfnDialog(res.result.MESSAGE,"Alert","확인","Red","location.href='codeView.do?codeid="+res.codeid+"&code="+res.code+"'");
	                    		} else if($("#gbn").val() == "D"){
	                    			gfnDialog(res.result.MESSAGE,"Alert","확인","Red","location.href='codeList.do'");
	                    		}
                            } else {
                            	gfnDialog("<b>Warning</b>&nbsp;공통코드(소분류) 수정에 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Alert","확인","Red","location.href='codeList.do'");
                            }
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="codeList.do";
			},
            serialize: function(){
                var frm = document.myForm;
                prompt("$(frm).serialize()", $(frm).serialize() );
            },
            genDetailView: function(){
            	location.href="codeGenView.do?codeid="+$("#codeid").val();
            }
		}
		
		//$(document).ready(fnObj.pageStart);
	    </script>
	</ax:div>
</ax:layout>