<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib prefix="ui" uri="http://egovframework.gov/ctl/ui"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<c:if test="${sessionScope.usrId == null}">
	<script>
		window.alert("로그인을 해주세요");
		location.href="<c:url value='/'/>";
	</script>
</c:if>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>분배요청 목록</title>
<script src="http://code.jquery.com/jquery-2.1.0.min.js"></script>
<script src="/dsdsm/js/main/common.js"></script>
<script src="/dsdsm/js/EgovMultiFile.js"></script>

<link rel="stylesheet" type="text/css"
	href="/dsdsm/css/egovframework/main/global.css" />
<link rel="stylesheet" type="text/css"
	href="/dsdsm/css/egovframework/main/layout.css"/>  
<link rel="stylesheet" type="text/css"
	href="/dsdsm/css/egovframework/main/common.css"/>
<link rel="stylesheet" type="text/css"
	href="/dsdsm/css/egovframework/main/login.css"/> 
<link rel="stylesheet" type="text/css"
	href="/dsdsm/css/egovframework/main/dis.css" />
<!-- <link rel="stylesheet" type="text/css" href="/css/egovframework/main/base.css"> -->
 <link rel="stylesheet" type="text/css"
	href="/dsdsm/css/egovframework/sample.css" />

<script type="text/javascript">
	function fnDtlOpen(disId) {
		$('#disId').val(disId);
		document.frm.action = "<c:url value='/dis/disRequestDetail.do'/>";
		document.frm.submit();
	}

	/* 글 수정 화면 function */
	function fn_egov_select(id) {
		document.frm.selectedId.value = id;
		document.frm.action = "<c:url value='/updateSampleView.do'/>";
		document.frm.submit();
	}

	/* 글 등록 화면 function */
	function fn_egov_addView() {
		document.frm.action = "<c:url value='/addSample.do'/>";
		document.frm.submit();
	}

	/* 글 목록 화면 function */
	function fn_egov_selectList() {
		document.frm.action = "<c:url value='/egovSampleList.do'/>";
		document.frm.submit();
	}

	/* pagination 페이지 링크 function */
	function fn_egov_link_page(pageNo) {
		document.frm.pageIndex.value = pageNo;
		document.frm.action = "<c:url value='/dis/disRequestList.do'/>";
		document.frm.submit();
	}
</script>


</head>
<body>
	<!--wrap-->
	<form:form name="frm" method="post" commandName="searchVO">
		<input type="hidden" name="disId" id="disId" value="" />

		<div id="wrap">
			<%@ include file="./import/disHeader.jsp"%>
			<%@ include file="./import/disLeftMenu.jsp"%>
			<!--body_container-->
			<div id="body_container">  
				<div id="history"></div>
				<div class="disSubTitle">
					<h3>분배 요청 목록</h3>
				</div>
				<div class="div_disSearch">
					<table width="600px;">
						<tr>
							<td>요청일자</td>
							<td><input type="text" size="8" name="disRqDtFr" /> ~ <input type="text"
								size="8" name="disRqDtTo"/></td>
							<td>요청자</td>
							<td><input type="text" size="10" name="disRqUsrNm"/></td>
							<td></td>
						</tr>
						<tr>
							<td>진행상태</td>
							<td><select name="disRqStep">
									<option value="">전체</option>
									<c:forEach var="result" items="${disStep}" varStatus="status">
										<option value="${result.ditcCd}" <c:if test="${result.ditcCd == searchVO.disRqStep}">selected</c:if> >${result.ditcNm}</option>
									</c:forEach>
							</select></td>
							<td>분배유형</td>
							<td><select name="disRqType">
									<option value="">전체</option>
									<c:forEach var="result" items="${disType}" varStatus="status">
										<option value="${result.ditcCd}">${result.ditcNm}</option>
									</c:forEach>
							</select></td>
							<td><button>검색</button></td>
						</tr>
					</table>
					<br>
					<h4>검색결과</h4>
					<table class="disList">
						<tr align="center">
							<th>NO</th>
							<th>요청<br>일자
							</th>
							<th>최종<br>승인(반려)일자
							</th>
							<th>분배유형</th>
							<th>진행상태</th>
							<th>요청자</th>
							<th>적용분야</th>
						</tr>
						<c:forEach var="result" items="${disList}" varStatus="status">
							<tr class="disListLink" onClick="fnDtlOpen('${result.disId}'); ">
								<td>${result.rn}</td>
								<td>${result.disDttmCr}</td>
								<td>${result.disDttmFc}</td>
								<td>${result.disTypeNm}</td>
								<td>${result.disStepNm}</td>
								<td>${result.disUserNm}</td>
								<td>${result.disAppNm}</td>
							</tr>
						</c:forEach>
					</table>
				</div>

				<div id="paging" style="padding-top: 8px;">
					<ui:pagination paginationInfo="${paginationInfo}" type="image"
						jsFunction="fn_egov_link_page" />
					<form:hidden path="pageIndex" />
				</div>
			</div>
	</form:form>
	<!-- body_container END -->

	<%@ include file="./import/disFooter.jsp"%>

	</div>
	<!-- //wrap -->

</body>
</html>