<%@ page import="java.util.*"%>
<%@ page contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="ax" uri="http://axisj.com/axu4j"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<% %>

<ax:layout name="base.jsp">
    <ax:set name="title" value="공문/법령 등록" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post" enctype="multipart/form-data">
                <input type="hidden" name="userId"value="${sessionScope['userInfo']['userId']}" />
                <input type="hidden" name="posblAtchFileNumber"	id="posblAtchFileNumber" value="3" />
                <input type="hidden" name="no"	id="no"/>
                <input type="hidden" name="nttCn" id="nttCn" value="" />
                <input type="hidden" name="nttCn2" id="nttCn2" value="" />
		            <ax:fields>
		                <ax:field label="제목">
		                	<input type="text" name="title" id="title" maxlength="255" style="width:507px;" title="제목" class="AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
                		<ax:field label="업무">
		                	<input type="text" name="jobCdDisplay" title="업무" value="" placeholder="아래에서 선택하세요.." class="AXInput" readonly/>
		                	<input type="hidden" name="job_cd" id="job_cd"  value="" title="업무" class="AXInput av-required"/>
		                	<div id="AXTreeTarget" style="height:200px;width: inherit;  border:1px solid #cecece"></div>                			
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="문서구분">
                			<select id="doc_gbn" name="doc_gbn" title="문서구분" class="AXSelect av-required">
                				<option value="">선택</option>
                				<c:forEach var="gbn" items="${docGbn}" varStatus="status">
                				<c:if test="${gbn.code eq '100' || gbn.code eq '200'}">
                					<option value="${gbn.code}" <c:if test="${result.rctype eq gbn.code}">selected</c:if>>${gbn.codeShtnm}</option>
                				</c:if>
                				</c:forEach>
                			</select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
		                <ax:field label="담당자">
		                	<select id="charger" name="charger">
		                		<option value="1">선택</option>
		                	</select>
		                	<font color="red">&nbsp;&nbsp;* 업무를 선택 후 해당 작성자 하시면됩니다.</font>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="문서번호">
		                	<input type="text" name="doc_no" id="doc_no" maxlength="30" style="width:507px;" maxlength="30" title="문서번호" class="AXInput av-required" />
		                	<button type="button" id="checkId" class="AXButtonSmall Blue"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i>문서번호 중복체크</button>
                    		<input type="hidden" name="isIdOverlapped" id="isIdOverlapped" value=""/> 
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="시행일자">
		                	<input type="text" name="date" id="AXInputDate" title="시행일자" class="AXInput W100 av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="발신처">
		                	<input type="text" name="send_gd" id="send_gd" maxlength="100" style="width:507px;" title="발신처" class="AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		            	<ax:field label="수신처">
		                	<input type="text" name="receive_gd" id="receive_gd" maxlength="100" style="width:507px;" title="수신처" class="AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="작성자">
		                	${sessionScope['userInfo']['name']}
		                </ax:field>
		            </ax:fields>
                	<ax:fields>
                		<ax:field label="내용">
                			<div id="AXEditorTarget"></div>
                			<div id="editContent" style="display:none;"></div>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
		                <ax:field label="관련공문">
		                	<button class="AXButton" onclick="fnObj.modalOpen(); return false;">공문선택</button>
		                	&nbsp;&nbsp;<input type="text" id="rel_no" class="AXInput W400" readonly />
		                	<input type="hidden" name="rel_no"/>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="문서유형">
		                <table>
			                <c:forEach var="gbn" items="${docType}" varStatus="status">
			                <c:if test="${status.count%4 == 1}"><tr></c:if>
				                <td style="width:150px;">
				                	<input type="checkbox" name="doc_type" title="문서유형" value="${gbn.code}" class="AXInput av-required" /> &nbsp;&nbsp;${gbn.codeShtnm}&nbsp;&nbsp;
				                </td>
			                <c:if test="${status.count%4 == 0}"></tr></c:if>
			                </c:forEach>
			            </table>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
                		<ax:field label="비고">
                           <div id="AXEditorTarget2"></div>
                			<div id="editContent2" style="display:none;"></div>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="첨부파일">
          		      		<input name="file_1" id="egovComFileUploader" type="file" />
          		      		<div id="egovComFileList"></div>  
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
                	<div style="text-align:right;">
		                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>등록</button>
		                <button type="button" class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var page_menu_id = "m0101";
        
    	var maxFileNum = $("#posblAtchFileNumber").val();
    	if (maxFileNum == null || maxFileNum == "") {
    		maxFileNum = 3;
    	}	 
    	var multi_selector = new MultiSelector(document	.getElementById('egovComFileList'), maxFileNum);
    	multi_selector.addElement(document.getElementById('egovComFileUploader'));	 
		
    	function setDocNo(no,relText) {
    		$("#rel_no").val(relText); 
    		$("input[name='rel_no']").val(no);
    	} 
    	
    	function selectCharger(obj){
    		var url = "<c:url value='/docManagement/getCharger.json'/>";
    		var pars = "jobCd="+obj;
    		
    		jQuery("#charger").bindSelect({
    			reserveKeys: {
                     optionValue: "optionvalue",
                     optionText: "optiontext"
                 },
    			ajaxUrl: url,
                 ajaxPars: pars,
                 isspace: true,
                 isspaceTitle: "선택",
                 setValue: "1"
             });	
    	}	
    	
    	var myValidator = new AXValidator();
    	var myModal = new AXModal();
    	var myEditor = new AXEditor();
    	var myEditor2 = new AXEditor();
    	
		var fnObj = {
			pageStart: function(){

				myValidator.setConfig({
					targetFormName : "myForm"
					,checkCrlf:true
				});
				
				myModal.setConfig({
					windowID:"myModalContainer",
					displayLoading:true,
					onclose: function(){
					}
				});
				
				myEditor.setConfig({
					targetID: "AXEditorTarget",
					lang: "kr",
					height:150,
					frameSrc: "<c:url value='/axu/lib/AXEditor.html'/>",
					editorFontFamily: "Nanum Gothic",
					fonts:["Nanum Gothic","Malgun Gothic","Gulim","Dotum","궁서"],
					onReady: function(){
						myEditor.setContent($("#editContent"));
					}
				}); 
				
				myEditor2.setConfig({
					targetID: "AXEditorTarget2",
					lang: "kr",
					height:150,
					frameSrc: "<c:url value='/axu/lib/AXEditor2.html'/>",
					editorFontFamily: "Nanum Gothic",
					fonts:["Nanum Gothic","Malgun Gothic","Gulim","Dotum","궁서"],
					onReady: function(){
						myEditor2.setContent($("#editContent2"));
					}
				});
				
				$("#AXInputDate").bindDate({align:"right", valign:"bottom", separator:"-", defaultSelectType:"m", onchange:function(){
		            //toast.push(Object.toJSON(this));
		        }});

		    	$("#doc_gbn").bindSelect();
		    	$("#charger").bindSelect();
		    	$('input[type=checkbox]').bindChecked();
		    	
		    	gfnRequire();
		    	
				$("#checkId").click(function(){
                	
                	var doc_no = $("#doc_no").val();
                	
                	if(doc_no==""){
                		gfnDialog("<b>Warning</b>&nbsp;문서번호를 입력해주세요","Warning","확인","Red","");
                		return false;
                	}
                	
                	var url = "<c:url value='/docManagement/checkDocNo.json'/>";
                    var pars = {doc_no:doc_no};
                    
                    new AXReq(url, 
                        {
                            pars:pars, 
                            onsucc:function(res){
                            	gfnDialog(res.result.MESSAGE,"Alert","확인","Red","");
                                if(res.result.SUCCESS){
                                	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                                	$("input[name='isIdOverlapped']").val("false");
                                }else{
                                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                                	$("input[name='isIdOverlapped']").val("true");
                                }
                                
                            },
                            onerr:null
                        }
                    );
                });
                $("input[name='doc_no']").change(function(){
                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                	$("input[name='isIdOverlapped']").val("true");
                });
				
			},
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				var isIdOverlappedObj = $("#isIdOverlapped").val();
				
				if(isIdOverlappedObj==""){
					gfnDialog("<b>Warning</b>&nbsp;아이디 중복확인을 해야합니다.","Warning","확인","Red","");
                	$("#checkId").focus();
                	return false;
                }else if(isIdOverlappedObj=="true"){
                	gfnDialog("<b>Warning</b>&nbsp;다른 ID로 중복확인 후 등록바랍니다.","Warning","확인","Red","");
                	$("#doc_no").focus();
                	return false;
                }
				
				var myContent = myEditor.getContent();
				var myContent2 = myEditor2.getContent();
				var content = [];
				var content2 = [];
				if(myContent.length > 4000) {
					gfnDialog("내용은 4,000자 미만으로 작성해야 합니다.","Warning","확인","Red");
					return false;
				}
				while(myContent.length > 0){
					content.push(myContent.substr(0, 102399));
					myContent = myContent.substr(102399);
				}
				$("#nttCn").val(content);
				while(myContent2.length > 0){
					content2.push(myContent2.substr(0, 102399));
					myContent2 = myContent2.substr(102399);
				}
				$("#nttCn2").val(content2);
				
				gfnConfirm("등록하시겠습니까?","fnObj.saveForm();");
			},
			saveForm: function(){
				 var form = document.myForm;
		         var formData = new FormData(form);
		         
				 var url = "<c:url value='/docManagement/docReg.json'/>";
		         $.ajax({
		        	 url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,   	                    
	                    type: 'POST',
	                    success: function(res){
	                    	if(res.result.SUCCESS){
		                    	   gfnDialog("공문/법령 등록이 완료되었습니다","Alert","확인","Red","location.href='docView.do?docNo="+res.docNo+"&docGbn="+res.docGbn+"'");
	                        } else {
	                        	   gfnDialog("<b>Warning</b>&nbsp;공문/법령 등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","location.href='codeList.do'");
	                        }
	                    	
	                    },
	                    error : null
	                });
			},
   		    modalOpen: function(){
   		    	myModal.open({
   		    		url: "<c:url value='/docManagement/docListPop.do'/>",
		            pars: "",
		            top: 500,
		            width: 1024,
		            closeByEscKey: true
   		    	});
   		    },
			listForm: function(){
				location.href="<c:url value='/docManagement/docList.do'/>";
			}
		}
		
		var jobTree = new AXTree();	
		setTree();
        function setTree() {
         	jobTree.setConfig({
    				targetID : "AXTreeTarget",
    				theme: "AXTree_none",
    				//height:"auto",
    				xscroll:true,
    				showConnectionLine:true,
    				relation:{
                     // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
    					parentKey:"upperJobCd",
    					childKey:"jobCd"
    				},				
    				colGroup: [
    					{key:"jobName", label:"제목", width:"100%", align:"left", indent:true,
    						getIconClass: function(){
    							//folder, AXfolder, movie, img, zip, file, fileTxt, fileTag
    							//var iconNames = "company, folder, AXfolder, movie, img, zip, file, fileTxt, fileTag".split(/, /g);
    							
    							//var iconName = "folder";
    							if(this.item.__subTreeLength == 0) {
    								return "fileTxt";	     								
    							} else {
    								return "folder";
    							}
    						},        						
    						formatter:function(){
    							if(this.item.__subTreeLength == 0) {
    								//return "<input type='checkbox' name='jobCd1' value='"+this.item.jobCd+"'/>"+this.item.jobName;	     								
    							} else {
    								//return this.item.jobName;
    							}        							
    							return this.item.jobName;        							
    						}
    					},
    				],
    				body: {
    					onclick:function(idx, item){
     						if(item.__subTreeLength == 0) {	     							 	     						
     							var fullpath = "";
	     						if(item.namePath){
	     							for(var i=0;i<item.namePath.length;i++){
	     								fullpath = fullpath + item.namePath[i];
	     								if(i!=(item.namePath.length-1)){
	     									fullpath = fullpath + " > ";
	     								}
	     							}
	     						}	     							
	     						$("input[name='jobCdDisplay']").val(fullpath);
	     						$("input[name='job_cd']").val(item.jobCd);
	     						selectCharger(item.jobCd);
     						} else {
	     						$("input[name='jobCdDisplay']").val("");
	     						$("input[name='job_cd']").val("");
     						}
    				 	}     					
    				}
    			});
         	var JobCdList = ${JOB_LIST} 
    		jobTree.setList(JobCdList);
     	}		
	    </script>
	</ax:div>
</ax:layout>