<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="FP 수정-간이법 " />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
			<div style="margin:5px;">
                <ax:form name="myForm" method="post" >
                	<input type="hidden" name="reqId" id="reqId"  value="${reqId}"/>
                	<input type="hidden" name="fpId" id="fpId"  value="${fpId}"/>
					<ax:fields>
		                <ax:field label="어플레케이션명">
		                    <input type="text" name="appName" id="appName" title="어플리케이션명" placeholder=""     maxLength="150" class="W400 AXInput av-required"/>
		                </ax:field>
		            </ax:fields>
					<ax:fields>
		                <ax:field label="세부 업무명">
		                    <input type="text" name="detailWorkName" id="detailWorkName"    title="세부업무명"        maxLength="100" class="W400 AXInput av-required"/>
		                </ax:field>
		            </ax:fields>
					<ax:fields>
		                <ax:field label="단위프로세스명">
		                    <input type="text" name="taskProcessName" id="taskProcessName" title="단위프로세스명"    maxLength="100" class="W400 AXInput av-required"/>
		                </ax:field>
		            </ax:fields>
					<ax:fields>
		                <ax:field label="단위프로세스 설명">
		                    <input type="text" name="taskProcessInfo" id="taskProcessInfo" title="단위프로세스 설명" maxLength="500" class="W500 AXInput av-required" style="width:600px;"/>
		                </ax:field>
		            </ax:fields>
					<ax:fields>
		                <ax:field label="FP 유형">
							<div class="left">
								<select id="fpType" name="fpType" class="AXSelect W50" onchange="fnObj.setWeightPoint(this.value);">
									<option value="ILF" > ILF</option>
									<option value="EIF" > EIF</option>
									<option value="EI"  > EI </option>
									<option value="EO"  > EO </option>
									<option value="EQ"  > EQ </option>
								</select>
							</div>
		                </ax:field>
		            </ax:fields>
					<ax:fields>
		                <ax:field label="가중치">
		                    <input type="text" name="weightPoint" id="weightPoint" title="가중치" placeholder="" readonly class="W300 AXInput av-required"/>
		                </ax:field>
		            </ax:fields>
		        </ax:form>
			    <div style="text-align:right;padding-top:5px;"> 
				     <button class="AXButton" onclick="fnObj.update();"><i class="axi axi-save"></i>수정</button>
				     <!-- <button class="AXButton" onclick="fnObj.deleteData();"><i class="axi axi-delete"></i>삭제</button> -->
				     <button class="AXButton" onclick="parent.myModal.remove();"><i class="axi axi-ion-close-circled"></i>닫기</button>
			    </div>
		    </div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">

			var fnObj = {
				pageStart: function(){
					fnObj.getFpDate();
				},
				getFpDate:function(){
					
		        	var url = "<c:url value="/main/getCmmJsonList.json"/>";
                    var pars = "sqlGbn=fnPoint.simpleDetailInfo&fpId=${fpId}";
                    new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
                        if(res.result == "ok"){
                        	var datalist = res.tree[0];
                        	//alert(Object.toJSON(datalist));
                        	fnObj.pageSetValue(datalist);
                        }else{
                            //console.log("실패입니다.");
                        }
                    }, onerr:null});
				},
				pageSetValue:function(json){
				    $.each(json, function(key, value){
				    	// 대상 객체가 존재하면..
				    	if($("#"+key).length > 0){
				    		$("#"+key).val(value);
				    	}
					});
				},
				setWeightPoint:function(fpType){
					var point ="";
					switch (fpType) {
					case "ILF":
						point="7.5";
						break;
					case "EIF":
						point="5.4";
						break;
					case "EI":
						point="4";
						break;
					case "EO":
						point="5.2";
						break;
					case "EQ":
						point="3.9";
						break;
					default:df
						break;
					}
					
					$("#weightPoint").val(point);
				},
				update:function(){
					
					var url = "<c:url value="/cmm/updateData.do"/>";
					var frm = document.myForm;
					var pars = $(frm).serialize()+"&sqlGbn=fnPoint.simpleMethodUpdate"
   	                
                    new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
                    	gfnDialog("수정 되었습니다.","Alert","확인","Green","parent.fnObj.getApplist(); parent.myModal.remove();");
                    }, onerr:null});
				},
				deleteData:function(){
					
					var url = "<c:url value="/cmm/updateData.do"/>";
					var frm = document.myForm;
					var pars = $(frm).serialize()+"&sqlGbn=fnPoint.simpleMethodDelete"
   	                
                    new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
                    	gfnDialog("삭제 되었습니다.","Alert","확인","Green","parent.fnObj.getApplist(); parent.myModal.remove();");
                    }, onerr:null});
				}
			};
			
			$(document.body).ready(function(){
				setTimeout(fnObj.pageStart, 1);
			});
	    </script>
	</ax:div>
</ax:layout>