<%@ page contentType="text/html; charset=UTF-8"
        %><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
        %><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
        %><ax:layout name="modal.jsp">
    <ax:div name="header">
        <h1>회원가입</h1>
    </ax:div>
    <ax:div name="contents">
       	<ax:form name="signin" method="post" action="<c:url value='/login/signin.json'/>">
            <ax:fields>
                <ax:field label="ID" >
                    <input type="text" name="id" title="ID" placeholder="" value="" maxlength="20" class="AXInput av-required" />
                    <button type="button" id="checkId" class="AXButtonSmall Blue"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i> 아이디 중복확인</button>
                    <input type="hidden" name="isIdOverlapped" value=""/> 
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="성명">
                    <input type="text" name="name" title="성명" placeholder="" value="" maxlength="50" class="AXInput av-required" />
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="생년월일">
                    <input type="text" id="birthYmd" name="birthYmd" title="생년월일" value="" class="AXInput W100 av-required" />
                    <input type="hidden" name="birthCalendar" value="" />
                    <input type="text" value="" id="birthCalendarDisplay" class="AXInput" style="width:50px;" />
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="비밀번호">
                    <input type="password" name="password" title="비밀번호" placeholder="" value="" maxlength="100" class="AXInput av-required" />
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="비밀번호확인">
                	<input type="password" name="passwordComfirm" title="비밀번호확인" placeholder="" value="" maxlength="100" class="AXInput av-required" />
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="담당업무">
                	<span>※ 클릭하면 아래에 추가됩니다.</span>&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:green; cursor:pointer;" onclick="addAllJobCf();">모두 추가</span>
                	<input type="hidden" name="jobCdValidate"  id="jobCdValidate" value="" title="업무" class="AXInput av-required"/>
                	<div id="AXTreeJob" style="height:120px;width: inherit;  border:1px solid #cecece"></div>		                	
                	<span>※ 클릭하면 제거됩니다.</span>&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:red; cursor:pointer;" onclick="removeAllJob();">모두 제거</span>
                	<div id="jobAddArea" class="jobAddArea"></div>
                	<div id="jobCdParam" style="width:0px; height:0px;"></div>	
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="소속부서" itemcss="fullWidth">
                	<input type="text" name="deptIdDisplay" title="소속부서" value="" placeholder="아래에서 선택하세요.." class="AXInput av-required" readonly/>
                	<input type="hidden" name="deptId"  value="" class="AXInput av-required"/>
                	<div id="AXTreeTarget" style="height:200px;width: inherit;  border:1px solid #cecece"></div>
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="직급" css="av-required">
                	<ax:custom customid="select" id="rankCd" name="rankCd" css="AXSelect" options="${RANK_LIST}"/>
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="직책" css="av-required">
                	<ax:custom customid="select" id="dutyCd"  name="dutyCd" css="AXSelect" options="${DUTY_LIST}"/>
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="전화번호">
                	<input type="text" name="tel" title="전화번호" placeholder="02-000-0000" value="" class="AXInput  av-phone" />
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="핸드폰">
                	<input type="text" name="hp" title="핸드폰" placeholder="010-000-0000" value="" class="AXInput av-required av-phone" />
                </ax:field>
            </ax:fields>
            <ax:fields>
                <ax:field label="이메일">
                	<input type="text" name="email" title="이메일" placeholder="" value="" maxlength="100" class="AXInput av-required av-email" />
                </ax:field>
            </ax:fields>
        </ax:form>
    </ax:div>
    <ax:div name="buttons">
        <button type="button" class="AXButton" onclick="fnObj.form.save();">신청</button>
        <button type="button" class="AXButton" onclick="parent.myModal.close();">닫기</button>
    </ax:div>
    <ax:div name="scripts">
        <script type="text/javascript">
            if ("${message}") {
                dialog.push("${message}");
            }
            
            var deptTree = new AXTree();

            var fnObj = {
                pageStart: function(){
                    this.form.init();
                    this.bindEvent();
                    this.tree1();
                    //deptTree.click(2,"open",false);
                    gfnRequire();
                },
                pageResize: function(){
                    parent.myModal.resize();
                },
                bindEvent:function (){
                    $("form input").keypress(function(event){
                    	if(event.which==13){
                    		fnObj.form.save();
                    	}
                    });
                    $("#checkId").click(function(){
                    	
                    	var loginIdval = document.signin.id.value;
                    	
                    	if(loginIdval==""){
                    		//toast.push("아이디를 기입후 확인하세요");
                    		gfnDialog("<b>알림</b><br>아이디를 기입후 확인하세요.","Alert","확인","red");
                    		
                    		return false;
                    	}
                    	
                    	var url = "<c:url value='/login/checkLoginId.json'/>";
                        var pars = {loginId:document.signin.id.value};
                        
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                   	//toast.push(res.result.MESSAGE);
                                   	
                                   	gfnDialog("<b>알림</b><br>"+res.result.MESSAGE,"Alert","확인","Green");
                                   	
                                    if(res.result.SUCCESS){
                                    	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                                    	$("input[name='isIdOverlapped']").val("false");
                                    }else{
                                    	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                                    	$("input[name='isIdOverlapped']").val("true");
                                    }
                                    
                                },
                                onerr:null
                            }
                        );
                    });
                    $("input[name='id']").change(function(){
                    	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                    	$("input[name='isIdOverlapped']").val("true");
                    });
                    $("#rankCd").bindSelect();
                    $("#dutyCd").bindSelect();
                    $("#birthYmd").bindDate({align:"right", valign:"bottom", separator:"-", defaultSelectType:"y",defaultDate:"1980-01-01", onchange:function(){
                        //toast.push(Object.toJSON(this));
                    }});
                    $("#birthCalendarDisplay").bindSwitch({off:"양력", on:"음력", onChange:function(){
        				//toast.push(Object.toJSON({targetID:this.targetID, on:this.on, off:this.off, value:this.value}));
        				switch(this.value){
	        				case "양력":
	        					$("input[name='birthCalendar']").val(0);
	        					break;
	        				case "음력":
	        					$("input[name='birthCalendar']").val(1);
	        					break;
        				}
        			}});
                    
                },
                form:{
                    validator: new AXValidator(),
                    init: function(){
                        this.validator.setConfig({
                            targetFormName : "signin"
                        });
                    },
                    save: function(){
                    	setJobCdParam();
                        var validateResult = this.validator.validate();
                        if (!validateResult) {
                            var msg = this.validator.getErrorMessage();
                            
                            //toast.push();
                            gfnDialog("<b>알림</b><br>"+msg,"Alert","확인","Red");
                            
                            this.validator.getErrorElement().focus();
                            return false;
                        }else{
                            // 통과
                            var passwordObj = $("form[name='"+this.validator.config.targetFormName+"']").find("input[name='password']");
                            var passwordComfirmObj = $("form[name='"+this.validator.config.targetFormName+"']").find("input[name='passwordComfirm']");
                            var isIdOverlappedObj = $("form[name='"+this.validator.config.targetFormName+"']").find("input[name='isIdOverlapped']");
                            var jobCdObj = $("form[name='"+this.validator.config.targetFormName+"']").find("input[name='jobCd']:checked");
                            
                            if(passwordObj.val()!=passwordComfirmObj.val()){
                            	//toast.push("비밀번호확인 항목이 비밀번호와 일치하지 않습니다.");
                            	gfnDialog("<b>알림</b><br>비밀번호확인 항목이 비밀번호와 일치하지 않습니다.","Alert","확인","red");
                            	passwordComfirmObj.focus();
	                            return false;
                            }
                            
                            if(isIdOverlappedObj.val()==""){
                            	//toast.push("아이디 중복확인을 해야합니다.");
                            	gfnDialog("<b>알림</b><br>아이디 중복확인을 해야합니다.","Alert","확인","red");
                            	$("#checkId").focus();
                            	return false;
                            }else if(isIdOverlappedObj.val()=="true"){
                            	//toast.push("다른 아이디로 중복확인 후 가입바랍니다.");
                            	gfnDialog("<b>알림</b><br>다른 아이디로 중복확인 후 가입바랍니다.","Alert","확인","red");
                            	
                            	$("form[name='"+this.validator.config.targetFormName+"']").find("input[name='id']").focus();
                            	return false;
                            }
                        }

                        var url = "<c:url value='/login/signin.json'/>";
                        var pars = $(document.signin).serialize();
                        
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                    if(res.result.SUCCESS){
                                    	alert("s");
	                                   	parent.toast.push(res.result.MESSAGE);
	                                   	//gfnDialog("<b>알림</b><br>"+res.result.MESSAGE,"Alert","확인","green");
	                                   	parent.myModal.close();
                                    	//dialog.push({
            							//    body:"<b>Success Msg</b><br>"+res.result.MESSAGE, top:(AXUtil.clientHeight()/2)-120, type:'Caution', buttons:[
            							//		{buttonValue:'확인'    , buttonClass:'Green W100'  , onClick:"parent.myModal.close();", data:null}
            							//	]});
                                    	
                                    }else{
                                    	alert("e");
	                                   	//toast.push(res.result.MESSAGE);
	                                   	gfnDialog("<b>알림</b><br>"+res.result.MESSAGE,"Alert","확인","red");
                                    }
                                    
                                },
                                onerr:null
                            }
                        );
                        
                        return false;
                    }                    
                },
                tree1: function(){

                	deptTree.setConfig({
        				targetID : "AXTreeTarget",
        				theme: "AXTree_none",
        				//height:"auto",
        				xscroll:true,
        				showConnectionLine:true,
        				relation:{
                            // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
        					parentKey:"upperDeptId",
        					childKey:"deptId"
        				},				
        				colGroup: [
        					{key:"deptName", label:"제목", width:"100%", align:"left", indent:true,
        						getIconClass: function(){
        							//folder, AXfolder, movie, img, zip, file, fileTxt, fileTag
        							//var iconNames = "company, folder, AXfolder, movie, img, zip, file, fileTxt, fileTag".split(/, /g);
        							var iconName = "company";
        							return iconName;
        						},
        						formsatter:function(){
        							//return "<b>"+this.item.no.setDigit(2) + "</b> : " + this.item.nodeName + " (" + this.item.writer + ")";
        							return this.item.deptName;
        						}
        					},
        				],
        				body: {
        					onclick:function(idx, item){
        						var fullpath = "";
        						if(item.namePath){
        							for(var i=0;i<item.namePath.length;i++){
        								fullpath = fullpath + item.namePath[i];
        								if(i!=(item.namePath.length-1)){
        									fullpath = fullpath + " > ";
        								}
        							} 
        								
        						}
        						$("input[name='deptIdDisplay']").val(fullpath);
        						$("input[name='deptId']").val(item.deptId);
        						//toast.push(Object.toJSON(item));
        						//toast.push(Object.toJSON(item));
        						//myTree.setEditor(this.item, this.index);
        						
        					}
        				}
        			});
        			

        			var List = ${DEPT_CODE};
        			deptTree.setList(List);
        		}
                
            };
            
            var jobTree = new AXTree();	
            setTree();
            displayJobCd();

            function setTree() {
             	jobTree.setConfig({
        				targetID : "AXTreeJob",
        				theme: "AXTree_none",
        				//height:"auto",
        				xscroll:true,
        				showConnectionLine:true,
        				relation:{
                         // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
        					parentKey:"upperJobCd",
        					childKey:"jobCd"
        				},				
        				colGroup: [
        					{key:"jobName", label:"제목", width:"100%", align:"left", indent:true,
        						getIconClass: function(){
        							//folder, AXfolder, movie, img, zip, file, fileTxt, fileTag
        							//var iconNames = "company, folder, AXfolder, movie, img, zip, file, fileTxt, fileTag".split(/, /g);
        							
        							//var iconName = "folder";
        							if(this.item.__subTreeLength == 0) {
        								return "fileTxt";	     								
        							} else {
        								return "folder";
        							}
        						},        						
        						formatter:function(){
        							if(this.item.__subTreeLength == 0) {
        								//return "<input type='checkbox' name='jobCd1' value='"+this.item.jobCd+"'/>"+this.item.jobName;	     								
        							} else {
        								//return this.item.jobName;
        							}        							
        							return this.item.jobName;        							
        						}
        					},
        				],
        				body: {
        					onclick:function(idx, item){
        						if(item.__subTreeLength == 0) {	  
        				 			//toast.push(Object.toJSON(item));
        							var fullpath = "";
             						if(item.namePath){
             							for(var i=0;i<item.namePath.length;i++){
             								fullpath = fullpath + item.namePath[i];
             								if(i!=(item.namePath.length-1)){
             									fullpath = fullpath + " > ";
             								}
             							}
             						}	   
        							addJobCd(item.jobCd, fullpath);
        						}
        				 	}     					
        				}
        			});
             	var JobCdList = ${JOB_LIST} 
             	//console.log(JobCdList);
        		jobTree.setList(JobCdList);
         	}
            function addJobCd(pJobCd, pJobName) {            	
            	if($("#jobAddArea span[jobcd='"+pJobCd+"']").length == 0) {
	            	$("#jobAddArea").append("<span class='jobBtn' jobcd='"+pJobCd+"' onclick='removeJobCd(this);'>"+pJobName+"</span>");
            	} else {
            		//toast.push("이미 추가된 업무입니다.");
            	}
            }
            function removeJobCd(j) {
            	$(j).remove();
            }
            function removeAllJob() {
            	gfnConfirm("모든 업무를 제거하시겠습니까?","$('#jobAddArea').empty();");
            }
            function addAllJobCf() {
            	gfnConfirm("모든 업무를 추가하시겠습니까?","addAllJob();");            	
            }   
            function addAllJob() {
            	$(jobTree.list).each(function() {
            		if(this.__subTreeLength == 0) {
						var fullpath = "";
 						if(this.namePath){
 							for(var i=0;i<this.namePath.length;i++){
 								fullpath = fullpath + this.namePath[i];
 								if(i!=(this.namePath.length-1)){
 									fullpath = fullpath + " > ";
 								}
 							}
 						}
            			addJobCd(this.jobCd, fullpath);
            		}
            	});
            }
            //저장전에 선택된 업무값으로 변환
            function setJobCdParam() {
            	$("#jobCdParam").empty();            	
            	$("#jobAddArea span").each(function() {
            		$("#jobCdParam").append("<input type='hidden' name='jobCd'value='"+$(this).attr("jobcd")+"'/>");
            		//arrJobCd.push($(this).attr("jobcd"));
            	});            	
            	if($("#jobCdParam input").length == 0) {
            		$("#jobCdValidate").val("");
            	} else {
            		$("#jobCdValidate").val("1");
            	}
            }
            
            function getJobCdFullPath(pJobCd) {
            	var fullpath = "";
            	$(jobTree.list).each(function() {
	            	if(this.jobCd == pJobCd){
						for(var i=0;i<this.namePath.length;i++){
							fullpath = fullpath + this.namePath[i];
							if(i!=(this.namePath.length-1)){
								fullpath = fullpath + " > ";
							}
						}
					}
            	});
            	return fullpath;
            }
            
             	
           function displayJobCd() {
              	var arrJobCd = new Array();
          		<c:forEach var="jobItem" items="${sessionScope['userInfo']['jobCd'] }">			                	
           	arrJobCd.push('${jobItem}');
      			</c:forEach>
      			
      			for(var i=0; i<arrJobCd.length; i++) {
      				addJobCd(arrJobCd[i], getJobCdFullPath(arrJobCd[i]));
      			}
           }
            
            axdom(document.body).ready(function(){fnObj.pageStart()});
            axdom(window).resize(fnObj.pageResize);
        </script>
        <style>
        	.jobAddArea {padding:2px 0px 2px 2px; width:500px; height:60px; border:1px solid #cecece; line-height:23px; overflow-y:scroll;}
        	.jobBtn {padding:2px; margin-right:4px; margin-bottom:2px; background-color:#FCF8F8; border:1px solid #AD8686; cursor:pointer; display:inline-block;}        	
        </style>            
    </ax:div>
</ax:layout>