<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="modal.jsp">
    <ax:set name="title" value="담당자 추가" />
    <ax:div name="header">
    <br>
        <h1>${title}</h1>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <form name="myForm" method="post" enctype="multipart/form-data">
	                <input type="hidden" id="userid" value="${sessionScope['userInfo']['userId']}"/>
		            <input type="hidden" name="deptId"  value="" class="AXInput av-required"/>
	         	    <div class="H10"></div>
		            <div id="AXTreeTarget2" style="height:190px; border:1px solid #cecece"></div>
		            <div class="H10"></div>
                </form>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
		
	    var userList;
	    var pageID = "TreeControl";
		var myTree = new AXTree();
		var deptTree = new AXTree();
		var myModal = new AXModal();
		var deptItem;
		
	    var fnObj = {
	    		pageStart: function(){

	    			fnObj.tree2();
	    			
	    			var url = "<c:url value='/project/getUserList.json'/>";
	    			
	    			new AXReq(url, 
                            {
                                pars:{projectid:"${projectid}"}, 
                                onsucc:function(res){
                                    userList = res.userList;
                                    
                                    for (var i=0; i<userList.length; i++) {
                	    				var userObj = null;
                	    				
                	    				var selectedIdx=-1;
                	    				var selectedListItem=null;
                	    				
                	    				for(var idx in deptTree.list){
                	    					if(deptTree.list[idx].deptId==userList[i].deptId){
                	    		    			selectedIdx=idx
                	    						break;
                	    					}
                	    				}
                	    				
                	    				if(selectedIdx>-1){
                	    					selectedListItem=deptTree.list[selectedIdx];
                	    				}
                	    				deptTree.appendTree(selectedIdx,selectedListItem,[
                	    					{"deptId":userList[i].userId, "deptName":userList[i].name,"type":"P", "upperDeptId":userList[i].deptId}
                	    					]);
                	    			}
                                },
                                onerr:null
                            }
                        );
	    			
	    		},
	    		tree2: function(){

                	deptTree.setConfig({
        				targetID : "AXTreeTarget2",
        				theme: "AXTree_none",
//         				height:"180px",
        				xscroll:true,
        				showConnectionLine:true,
        				relation:{
                            // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
        					parentKey:"upperDeptId",
        					childKey:"deptId"
        				},				
        				colGroup: [
        					{key:"deptName", label:"제목", width:"100%", align:"left", indent:true,
        						formatter:function(){
	    							var iconName;
	    							if(this.item.type == "D"){
	                                	iconName = "<i class='axi axi-group-work'></i>";
	                                }else{
	                                	iconName = "<i class='axi axi-person'></i>";
	                                }
	    							return iconName + this.item.deptName;
	    						}
        					},
        				],
        				body: {
        					onclick:function(idx, item){
        						deptItem = item;
        						if(item.type == "P"){
        							gfnConfirm("담당자를 등록하시겠습니까?","fnObj.chargerConfirm()");
        						}
        					}
        				}
        			});
        			

        			var List = ${DEPT_CODE}
        			;
        			deptTree.setList(List);
                },
	    		chargerConfirm: function(){
	    			var myTree;
	    			$.ajax({
	                    url: thisSiteContextName + "main/getCmmJsonList.json",
	                    data: {sqlGbn:"ProjScServiceDAO.getChargerList",projectid:"${projectid}"},
	                    type: 'POST',
	                    dataType:"json",
			   			async:false,
	                    success: function(data){
	                    	myTree = data.tree;
	                    },
	                    error : null
	                });
	    			
	    			
	    			for(i=0;i<myTree.length;i++){
    					if(myTree[i].userId==deptItem.deptId){
    						gfnDialog("이미 등록된 담당자입니다.");
    		    			return false;
    					}
    				}

	    			var obj = $(parent.document).find("#treeData").val();

					var url = "<c:url value='/project/addChargerGroup.json'/>";
					
                    new AXReq(url, 
                        {
                            pars:{type:"P",nodeName:deptItem.deptName,nodeId:obj,userid:deptItem.deptId,regid:$("#userid").val(),projectid:"${projectid}"}, 
                            onsucc:function(res){
                            	if(res.result.SUCCESS){
                                   	gfnDialog(res.result.MESSAGE,"","","",function(){
										parent.myModal.close();
	                            		parent.location.reload();
                                   	});
                                }else{
                                   	gfnDialog(res.result.MESSAGE);
                                }
                            },
                            onerr:null
                        }
                    );
	    		}
	    	};
	    

		
	    jQuery(document.body).ready(function(){fnObj.pageStart()});
	    </script>
	</ax:div>
</ax:layout>