<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="modal.jsp">
    <ax:set name="title" value="담당자 관리" />
    <ax:div name="header">
    <br>
        <h1>${title}</h1>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <form name="myForm" method="post" enctype="multipart/form-data">
                <input type="hidden" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                <input type="hidden" id="treeData" value=""/>
          	      <div class="H10"></div>
                	<div id="AXTreeTarget" style="height:250px;border:1px solid #cecece;"></div>
                	<div class="H10"></div>
		            <div>
		                <input type="button" id="add" value="그룹추가" class="AXButton" onclick="fnObj.openModal('group');" />
		                <input type="button" id="addChild" value="담당자추가" class="AXButton" onclick="fnObj.openModal('charger');" />
		                <input type="button" value="선택삭제" class="AXButton" onclick="fnObj.delConfirm();" />
		            </div>
                </form>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
		
	    var userList;
	    var pageID = "TreeControl";
		var myTree = new AXTree();
		var myModal = new AXModal();
		
	    var fnObj = {
	    		pageStart: function(){
	    			fnObj.tree1();		
	    		},
	    		tree1: function(){

	    			myTree.setConfig({
	    				targetID : "AXTreeTarget",
	    				theme: "AXTree_none",
	    				//height:"auto",
	    				xscroll:true,
        				showConnectionLine:true,
        				relation:{
                            // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
        					parentKey:"upperNodeId",
        					childKey:"nodeId"
        				},	
	                    emptyListMSG:"<i class='fa fa-spinner'></i> 데이터가 없습니다",
	    				colGroup: [
	    					{key:"nodeName", label:"그룹명", width:"*", align:"left", indent:true,
	    						formatter:function(){
	    							var iconName;
	    							var cnt;
	    							if(this.item.upperNodeId == '000'){
	                                	iconName = "<i class='axi axi-group-work'></i>";
	                                	cnt = "<font color='red'>(" + this.item.__subTreeLength + ")</font>";
	                                }else{
	                                	iconName = "<i class='axi axi-person'></i>";
	                                	cnt = "";
	                                }
	    							return iconName + this.item.nodeName + cnt;
	    						}
	    					}
	    				],
	    				body: {
	    					onclick:function(idx, item){
	    						if(this.item.upperNodeId == '000'){
	    							$("#addChild").attr("disabled",false);
	    							$("#add").attr("disabled",false);
	    						}else {
	    							$("#add").attr("disabled",true);
	    							$("#addChild").attr("disabled",true);
	    						}
	    					},
	    					addClass: function(){
	    						// this.index, this.item, this.list 으로 프로그램 구문 작성 가능
	    						return "myClass";	
	    					}
	    				}
	    			});
 		
	    			var List = ${NODE_LIST}
        			;
        			myTree.setList(List);	
	    		},
	    		delConfirm: function(){
	    			var obj = myTree.getSelectedList();
	    			if(obj.error){
	    				gfnDialog("개체를 선택해 주세요");
	    				return;
	    			}
	    			
	    			if(obj.item.__subTreeLength > 0){
	    				gfnDialog("담당자를 삭제 후 시도해주세요");
	    				return;
	    			}
	    			
	    			gfnConfirm("삭제하시겠습니까?","fnObj.delTree();")
	    			
	    		},
	    		delTree: function(){
	    			
	    			var obj = myTree.getSelectedList();
	    			var url = "<c:url value='/project/addChargerGroup.json'/>";

                    new AXReq(url, 
                        {
                    	pars:{type:"D",nodeId:obj.item.nodeId,projectid:"${projectid}"},
                            onsucc:function(res){
                                if(res.result.SUCCESS){
                                	location.reload();
                                }else{
                                	gfnDialog(res.result.MESSAGE);
                                }
                                
                            },
                            onerr:null
                        }
                    );
	    		},
	    		openModal:function(gbn){
	    			var url = "";
	    			var width,height,top;
	    			
	    			if(gbn == "group"){
	    				url = "<c:url value='/project/psAddGroup.do'/>";
	    				width = "350";
	    				height = "60";
	    				top = "80";
	    			}
	    			
	    			if(gbn == "charger"){ 
	    				var obj = myTree.getSelectedList();
		    			if(obj.error){
		    				gfnDialog("그룹을 선택해 주세요");
		    				return false;
		    			}
	    				$("#treeData").val(obj.item.nodeId);
	    				url = "<c:url value='/project/psAddCharger.do'/>"; 
	    				width = "770";
	    				height = "140";
	    				top = "40";
	    			}
	    			
	    			myModal.open({
	    				url: url,
	    				pars: {projectid:"${projectid}"},
	    				width: width,
	    				height: height,
	    				top: top
	    			});
	    		}
	    		
	    	};
		
	    jQuery(document.body).ready(function(){fnObj.pageStart()});
	    </script>
	</ax:div>
</ax:layout>