<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="modal.jsp">
    <ax:set name="title" value="일정등록" />
    <ax:div name="header">
    <br>
        <h1>${title}</h1>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post" enctype="multipart/form-data">
                	<ax:fields>
                		<ax:field label="일정명">
                            <input type="text" name="scTit" id="scTit" maxlength="255" size="40" class="AXInput av-required" title="일정명" />
                            <input type="hidden" name="scApproval" id="scApproval" maxlength="255" size="1" class="AXInput" title="등록구분" value="A"/>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="일정구분">
                			<select name="scGbn" id="scGbn" title="일정구분" class="AXSelect av-required" onchange="fnObj.checkBancha()">
                					<option value ="">선택</option>
                				<c:forEach var="gbn" items="${scgbn}" varStatus="status">
                					<option value="${gbn.code}">${gbn.codeShtnm}</option>
                				</c:forEach>
                			</select>
                        </ax:field>
                	</ax:fields>
                <div id="bcl" style="display:none">
                	<ax:fields>
                		<ax:field label="일정구분">
                			<input type="radio" name="aftbfe" id="aftbfe" value="A1" />오전반차&nbsp;
                			<input type="radio" name="aftbfe" id="aftbfe" value="A2" />오후반자&nbsp;
                		</ax:field>
                	</ax:fields>
                </div>
                	<ax:fields>
                		<ax:field label="등록자">
                			<input type="hidden" name="userId" id="userId" value="${sessionScope['userInfo']['userId']}"/>
                            <input type="text" name="user" id="user" value="${sessionScope['userInfo']['name']}(${sessionScope['userInfo']['loginId']})" class="AXInput" readonly />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
		                <ax:field label="기간설정">
		                	<input type="text" name="sdate" id="AXInputDateTimeST" value="${date} 09:00" class="AXInput W140" title="일정시작일"/> ~ 
		                	<input type="text" name="edate" id="AXInputDateTimeED" value="${date} 18:00" class="AXInput W140" title="일정종료일"/>
		                </ax:field>
		            </ax:fields>
                	<ax:fields>
                		<ax:field label="내용">
                           <div style="padding:5px">
				                <label class="AXInputLabel fullWidth">
				                    <textarea id="nttCn" name="nttCn"  cols="60" rows="10" class="AXTextarea av-required" title="내용"></textarea>
				                </label>
				            </div>
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
                	<div style="text-align:right;">
		                <button class="AXButton" onclick="fnObj.save();"><i class="axi axi-ion-android-note"></i>저장</button>
		                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>승인요청</button>
		                <button class="AXButton" onclick="parent.myModal.close();"><i class="axi axi-close"></i>닫기</button>
	               	</div>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var date = new Date();
	    var vToday = '${date}'; // gfnGetDate(date,"-");
	    var vYear = date.getFullYear();
	    
	    var vSdate = vYear+"-01-01"; 
	    var vEdate = vYear+"-12-31";	    
	    
	    var pageID = "AXValidator";

		var myValidator = new AXValidator(); // Validator 선언
		var fnObj = {
			pageStart: function(){

				myValidator.setConfig({
					targetFormName : "myForm"
					,checkCrlf:true
				});
				
				$("#AXInputDateTimeED").bindTwinDateTime({align:"right", valign:"top", separator:"-", startTargetID:"AXInputDateTimeST", onChange:function(){
	                //toast.push(Object.toJSON(this));
	            }});
				
				$("#scGbn").bindSelect();

				gfnRequire();
			},
			checkBancha: function(){
				var valInfo = $("#scGbn option:selected").val();
				parent.myModal.resize();
				
				//alert(valInfo+"   "+$("#scGbn :selected").text());
				//alert(valInfo);
				if(valInfo=="006"){
					jQuery('#bcl').show(); 
					$("input[name=sdate]").val(vToday+" 09:00");
					$("input[name=edate]").val(vToday+" 13:00");					
				} else {
					jQuery('#bcl').hide();  
					$("input[name=sdate]").val(vToday+" 09:00");
					$("input[name=edate]").val(vToday+" 18:00");
				    $("input:radio[name='aftbfe']").prop("checked", false);
				}
				


				
			},
			save: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				var animal = $(':input[name=aftbfe]:radio:checked').val();
				var valInfo = $("#scGbn option:selected").val();
				if(valInfo == "006"){
					if($(":radio[name='aftbfe']:checked").length == 0) {
						var msg2 = "반차인 경우 오전, 오후 여부를 선택주세요.";
						gfnDialog("<b>Waring</b>&nbsp;"+msg2,"Warning","확인","Red");	
						return false;
					}
				}
				
				$("input[name=scApproval]").val("S");
				gfnConfirm("일정을 등록하시겠습니까?","fnObj.saveForm();");
			},			
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				var animal = $(':input[name=aftbfe]:radio:checked').val();
				var valInfo = $("#scGbn option:selected").val();
				if(valInfo == "006"){
					if($(":radio[name='aftbfe']:checked").length == 0) {
						var msg2 = "반차인 경우 오전, 오후 여부를 선택주세요.";
						gfnDialog("<b>Waring</b>&nbsp;"+msg2,"Warning","확인","Red");	
						return false;
					}
				}
				
				$("input[name=scApproval]").val("C");
				gfnConfirm("등록 처리 후  승인요청 하시겠습니까?","fnObj.saveForm();");
			},
			saveForm: function(){
				
				 var form = document.myForm;
		         var formData = new FormData(form);
				
				 var url = "<c:url value='/schedule/calendarRegist.json'/>";
				 
		         jQuery.ajaxSettings.traditional = true;
		      
		         $.ajax({
	                    url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,
	                    type: 'POST',
	                    dataType:"json",
			   			timeout: 5000,
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		gfnDialog("등록이 완료되었습니다","Alert","확인","Red","parent.fnObj.calendar.load(); parent.location.reload();");
                            } else {
                            	//gfnDialog("<b>Warning</b>*일정 등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","parent.location.reload();");
                            	gfnDialog("<b>Warning</b> *일정 등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","");
                            }
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="srList.do";
			},
            serialize: function(){
                var frm = document.myForm;
                prompt("$(frm).serialize()", $(frm).serialize() );
            }
		}
		
	    $("input[name=aftbfe]").change(function() {			
			//var valInfo = $(":radio[name='aftbfe']:checked").val();
			//var valInfo = $("input[name=aftbfe]").val();
			var valInfo = $(this).val();
			
			if("A1" == valInfo){
				$("input[name=sdate]").val(vToday+" 09:00");
				$("input[name=edate]").val(vToday+" 13:00");
			} else {
				$("input[name=sdate]").val(vToday+" 13:00");
				$("input[name=edate]").val(vToday+" 18:00");
			}

			//alert($("#AXInputDateTimeST").val());
			//alert($("#AXInputDateTimeED").val());
		});
		

		
		$(document).ready(fnObj.pageStart);
	    </script>
	</ax:div>
</ax:layout>