<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="서비스요청" />
	<ax:div name="header">
		<h1>서비스요청</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
				<div class="ax-search" id="page-search-box"></div>
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="5">5</option>
							<option value="10" selected="selected">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>				
				    <div class="right">
				    	<button type="button" class="AXButton" id="ax-search-btn-write" onclick="fcObj.menuMove('0070200000000','/dsdsm/sr/userAddForm.do');"><i class="axi axi-pencil"></i> 등록</button>
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var date = new Date();
	    var vToday = date.getFullYear()+"-"+(10 > (date.getMonth()+1) ? "0"+(date.getMonth()+1) : (date.getMonth()+1))+"-"+date.getDate();
	    var myGrid = new AXGrid();	    
	    
	    //var page_menu_id = "m010301";
	    
	    var fnObj = {
	        pageStart: function(){
	        	//alert("d");
	        	
	            this.search.bind();	            
	            this.modal.bind();
	            this.bindEvent();
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            var gridHeight = fnObj.getWidgetHeight();
	            myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    fitToWidth: true,
                    height:gridHeight,
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"rowNum"  , label:"순번"       , width:"130", align:"center" },
                        {key:"srNo"    , label:"요청번호"   , width:"130", align:"center" },
                        {key:"title"   , label:"제목"       , width:"500", align:"left"},
                        {key:"regDttm" , label:"작성일시"   , align:"center", width:"160"},
                        
                    ],
                    body : {
                        onclick: function(){
                        	//location.href="noticeView.do?sid="+this.item.sid;
                    		 fnObj.modal.open("gridView", {
                                url:"<c:url value='/sr/userDetailForm.do'/>", pars:"srNo="+this.item.srNo                
                            }); 

                        },
                        
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }
                });

	            myGrid.setList({
                    //ajaxUrl:"getNoticeList.do", ajaxPars:"inqUserNm=&inqTitle=", 
                    ajaxUrl:"<c:url value="/sr/selectServiceRequerData.do"/>", ajaxPars:"sqlGbn=SrServiceDAO.selectSeiveRequest&pageSize="+myGrid.page.pageSize+"&pageNo"+myGrid.page.pageNo,
                    onLoad:function(){
                    	trace(this);
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
                
	            //alert("d");
	        	 
	        },
	        bindEvent: function(){
	            var _this = this;

	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	            
	            $("#AXInputDateED").bindTwinDate({handleLeft:25, align:"right", valign:"bottom", separator:"/", startTargetID:"AXInputDateST", onChange:function(){
	                toast.push(Object.toJSON(this));
	            }});
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
   	                        	{label:"제목", labelWidth:"", type:"inputText", width:"200", key:"inqTitle", addClass:"secondItem", valueBoxStyle:"", value:""	}	
   	                        ]}
	                    ]
	                });
	            },
	            submit: function(){
	                var pars = this.target.getParam();
	                //toast.push("콘솔창에 파라미터 정보를 출력하였습니다.");
	                //alert(pars);
	                myGrid.setList({
                    //ajaxUrl:"getNoticeList.do", ajaxPars:"inqUserNm=&inqTitle=", 
                    ajaxUrl:"<c:url value="/cmm/getCmmSelectList.do"/>", ajaxPars:"sqlGbn=SrServiceDAO.selectSeiveRequest&pageSize="+myGrid.page.pageSize+"&pageNo="+myGrid.page.pageNo+"&"+pars,
                    onLoad:function(){
                    	trace(this);
                    },onsucc:function(){
                        trace(this);
                        
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	            }
	        },
	        modal: {
	            target: new AXModal(),
	        	get: function(){ return this.target },
	            bind: function(){
	                window.myModal = this.target;
	                this.target.setConfig({
	                    windowID:"myModalContainer",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    displayLoading:true
	                });
	            },
	            open: function(type, http){
	                this.target.open({
	                    url: http.url,
	                    pars: http.pars.queryToObject(),
	                    top: ( (typeof http.top == "undefined") ? 150 : http.top ),
	                    width: ( (typeof http.width == "undefined") ? 900 : http.width ),
	                    closeByEscKey: true
	                });
	            },
	            close:function(){
	            	this.target.close("gridView");
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            },
    		getWidgetHeight : function(){
    			return windowHeight = $(window).height()-320;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            },
            regNotice : function() {
       		 fnObj.modal.open("gridView", {
                 url:"<c:url value='/education/eduNoticeReg.do'/>", pars:""            
             }); 
            },
            regMsg:function(sid){
            	gfnDialog("등록되었습니다.","Alert","확인","Green","fnObj.reloadList();fnObj.goDetail('"+sid+"');");
            },
            goDetail:function(sid){
            	fnObj.modal.open("gridView", {
                    url:"<c:url value='/education/eduNoticeView.do'/>", pars:"sid="+sid                
                });
            },
            modMsg:function(sid){
            	gfnDialog("수정되었습니다.","Alert","확인","Green","fnObj.reloadList();fnObj.goDetail('"+sid+"');");
            }
            
	    };

	    </script>
	</ax:div>
</ax:layout>