<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" 
%><ax:layout name="base.jsp">
    <ax:set name="title" value="S/R 절차 설정" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
				<input type="hidden" id="loginId" value="${sessionScope['userInfo']['userId']}"/>
				<input type="hidden"   id="newProcId" value=""/>
				<div class="ax-search" id="page-search-box"></div>      
				<div class="ax-button-group">
				    <div class="right">
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-plus-square"></i> 절차추가</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box" ></div>
			</ax:col>
		</ax:row>
		
		

	</ax:div>

	<ax:div name="scripts">
	    <script type="text/javascript">
	

	    var date = new Date();
	    var vToday = date.getFullYear()+"-"+(10 > (date.getMonth()+1) ? "0"+(date.getMonth()+1) : (date.getMonth()+1))+"-"+date.getDate();
	    var myGrid = new AXGrid();	    
	    var page_menu_id = "m010301";
	    var fnObj = {
	        pageStart: function(){
	        	
	        	
	            this.search.bind();	            
	            this.modal.bind();
	            this.bindEvent();
	            this.getSrProcList();
	            
	        },
	        bindEvent: function(){
	            var _this = this;

	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	            
	            $("#AXInputDateED").bindTwinDate({handleLeft:25, align:"right", valign:"bottom", separator:"/", startTargetID:"AXInputDateST", onChange:function(){
	                toast.push(Object.toJSON(this));
	            }});
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
   	                            {label:"절차명", labelWidth:"", type:"inputText", width:"200", key:"processName", addClass:"secondItem", valueBoxStyle:"", value:"",
   	                                onChange: function(changedValue){
   	                                    //toast.push(Object.toJSON(this));
   	                                }
   	                            }
   	                        ]}
	                    ]
	                });
	            },
	            submit: function(){
	                var param = this.target.getParam();
	                    param+="&sqlGbn=SrServiceDAO.insertProcConfig";
	                    param+="&newProcId="+$("#newProcId").val();
	                
					 var url= "<c:url value="/cmm/insertData.do"/>";
					 
					 new AXReq(  url, 
	                		    {debug:false, pars:param, onsucc:function(res){
	                		    	gfnDialog("<b>Success Msg</b><br>절차가 추가되었습니다!!!","Alert","확인","Green");
						            fnObj.getSrProcList()
						            $("#processName").val("");
	    			             }, onerr:null}
	                 );
	            }
	        },
	        modal: {
	            target: new AXModal(),
	            get: function(){ return this.target },
	            bind: function(){
	                window.myModal = this.target;
	                this.target.setConfig({
	                    windowID:"myModalContainer",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    displayLoading:true
	                });
	            },
	            open: function(type, http){
	                this.target.open({
	                    url: http.url,
	                    pars: http.pars.queryToObject(),
	                    top: ( (typeof http.top == "undefined") ? 150 : http.top ),
	                    width: ( (typeof http.width == "undefined") ? 900 : http.width ),
	                    closeByEscKey: true
	                });
	            },
	            close:function(){
	            	this.target.close("gridView");
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            },
    		getWidgetHeight : function(){
    			return windowHeight = $(window).height()-320;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            },
            regNotice : function() {
       		 fnObj.modal.open("gridView", {
                 url:"<c:url value='/notice/noticeWrite.do'/>", pars:""            
             }); 
            },
            regMsg:function(sid){
            	gfnDialog("등록되었습니다.","Alert","확인","Green","fnObj.reloadList();fnObj.goDetail('"+sid+"');");
            },
            goDetail:function(sid){
            	fnObj.modal.open("gridView", {
                    url:"<c:url value='/notice/noticeView.do'/>", pars:"sid="+sid                
                });
            },
            getSrProcList:function(){
            	var url = "<c:url value="/main/getCmmJsonList.json"/>";
                var pars = "sqlGbn=SrServiceDAO.selectProcConfig";
                new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
                    if(res.result == "ok"){
                    	
                    	
                    	var list = res.tree;
                    	
                    	var content="<div id='procList'  style='padding:30px;background:linear-gradient( #ffffff , #eeeeee);' align='center'>";
                    	for(var i=0;i<list.length;i++){
                    		
                    		if(i==list.length-1){
                    			content+="<div id='{\"processId\":\""+list[i].processId +"\"}' style='display:table-row;' >";
                        		content+="	<table cellpadding=5 cellspacing=0 width='400px' border=0>";
                        		content+="		<tr '>";
                        		content+="			<td align='center' width='50%' style='border:1px solid #969696;'>"+list[i].processName+"</td>";
                        		content+="			<td width='50%'>";
                        		content+="				<button type='button' class='AXButtonSmall Classic' onClick='fnObj.addPage(\""+list[i].processId+"\",\""+list[i].processName+"\");'><i class='axi axi-plus-square'></i> 화면설정</button>";
                        		content+="				<button type='button' class='AXButtonSmall Classic' onClick='fnObj.preView(\""+list[i].processId+"\");'><i class='axi axi-plus-square'></i> 화면보기</button>";
                        		content+="			</td>";
                        		content+="		</tr>";
                        		content+="	</table>";
                        		content+="</div>";
                    		}else{
                    			content+="<div id='{\"processId\":\""+list[i].processId +"\"}' style='display:table-row;' >";
                        		//content+="	<div style='border:1px solid #999999;height:30px;font-size:14px;text-align:center;line-height:30px;display:table-cell;width:200px;'>"+list[i].processName+"</div>";
                        		//content+="	<div style='border:1px solid #999999;height:30px;font-size:14px;text-align:center;line-height:30px;display:table-cell;width:200px;'><button type='button' class='AXButtonSmall Classic' onClick='fnObj.addPage(\""+list[i].processId+"\");'><i class='axi axi-plus-square'></i> 화면설정</button></div>";
                        		//content+="	<div style='text-align:center;'><i class='axi axi-ion-arrow-down-a' style='font-size:30px;'></i></div>";
                        		
                        		
                        		content+="	<table cellpadding=5 cellspacing=0 width='400px' border=0>";
                        		content+="		<tr '>";
                        		content+="			<td align='center' width='50%' style='border:1px solid #969696;'>"+list[i].processName+"</td>";
                        		content+="			<td width='50%'>";
                        		content+="				<button type='button' class='AXButtonSmall Classic' onClick='fnObj.addPage(\""+list[i].processId+"\",\""+list[i].processName+"\");'><i class='axi axi-plus-square'></i> 화면설정</button>";
                        		content+="				<button type='button' class='AXButtonSmall Classic' onClick='fnObj.preView(\""+list[i].processId+"\");'><i class='axi axi-plus-square'></i> 화면보기</button>";
                        		content+="			</td>";
                        		content+="		</tr>";
                        		content+="		<tr>";
                        		content+="			<td align='center'><i class='axi axi-ion-arrow-down-a' style='font-size:30px;'></i></td>";
                        		content+="			<td align='center'></td>";
                        		content+="		</tr>";
                        		content+="	</table>";
                        		content+="</div>";
                    		}
                    	}
                    	
                    	content+="</div>";
                		
                		
                    	$("#page-grid-box").html(content);
                    	$("#newProcId").val(list.length+1);
                    	
                    	
                    	$("#procList").sortable({
               	            update: function(event, ui) {    
               	               var productOrder = "["+$(this).sortable('toArray').toString()+"]";
            	               
               	               
               	            var param="sqlGbn=SrServiceDAO.updateProcConfigIdx";
    	                    param+="&JsonList="+productOrder;

    					 var url= "<c:url value="/cmm/updateData.do"/>";
    					 
    					 new AXReq(  url, 
    	                		    {debug:false, pars:param, onsucc:function(res){
    		                		    	gfnDialog("<b>Success Msg</b><br>절차 순서가 변경되었습니다!!!","Alert","확인","Green");
    							            setTimeout(function(){fnObj.getSrProcList()},"1000");
    	    			             }, onerr:null}
                                    );
               	            }
                    	 });
                    	      
                    
                    }else{
                        //console.log("실패입니다.");
                    }
                }, onerr:null});
            },
            addPage:function(processId,processName){
            	
            	fcObj.menuMove('0070190000000','/dsdsm/sr/addSrPage.do?processId='+processId+'&processName='+processName);
            },
            preView:function(processId){
            	fnObj.modal.open("preView", {
                    url:"<c:url value='/sr/userAddForm.do'/>", pars:"command=addForm&processId="+processId
                });
            }
            
	    };
       
       
	    </script>
	</ax:div>
</ax:layout>