<%@ page import="java.util.*"%>
<%@ page contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="ax" uri="http://axisj.com/axu4j"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<% %>

<ax:layout name="base.jsp">
    <ax:set name="title" value="서비스요청 등록" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post" enctype="multipart/form-data">
                <input type="hidden" name="posblAtchFileNumber"	id="posblAtchFileNumber" value="3" />
                	<ax:fields>
                		<ax:field label="요청 제목">
                            <input type="text" name="title" id="title" maxlength="255" style="width:507px;" title="S/R제목" class="AXInput av-required" />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="요청자">
                			<input type="hidden" name="userid" id="userid" value="${sessionScope['userInfo']['userId']}"/>
                            <input type="text" name="user" id="user" value="${sessionScope['userInfo']['name']}(${sessionScope['userInfo']['loginId']})" class="AXInput" readonly />
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
		                <ax:field label="전화번호">
		                	<input type="text" name="phone" title="전화번호" placeholder="02-000-0000" value="${sessionScope['userInfo']['tel']}" class="AXInput av-required av-phone" />
		                </ax:field>
		            </ax:fields>
		            <c:if test="${fn:contains(sessionScope['ROLES'],'DEVELOPER0')}">
		            <ax:fields>
                		<ax:field label="요청경로">
                			<select name="type" id="type" title="요청경로" class="AXSelect av-required" onchange="changeType(this.value);">
                				<option value="">선택</option>
                				<c:forEach var="gbn" items="${type}" varStatus="status">
                				<c:if test="${gbn.code ne '300'}">
                					<option value="${gbn.code}">${gbn.codeShtnm}</option>
                				</c:if>
                				</c:forEach>
                			</select>
                        </ax:field>
                	</ax:fields>
                	<div id="rel_div" style="display:none;">
                	<input type="hidden" name="no"	id="no"/>
                		<ax:fields>
			                <ax:field label="관련공문">
			                	<input type="text" id="rel_no" class="AXInput W400" readonly />
			                	<input type="hidden" name="rel_no"/>
			                	<button class="AXButton" onclick="fnObj.modalOpen(); return false;">공문선택</button>
			                </ax:field>
			            </ax:fields>
                	</div>
                	</c:if>
                	<ax:fields>
                		<ax:field label="접수유형">
                			<select name="rctype" id="rctype" title="접수유형" class="AXSelect av-required">
                					<option value = "">선택</option>
                				<c:forEach var="gbn" items="${rctype}" varStatus="status">
                					<option value="${gbn.code}">${gbn.codeShtnm}</option>
                				</c:forEach>
                			</select>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="업무">
<%--                 			<select name="work" id="work" title="업무" class="AXSelect av-required">
                					<option value ="">선택</option>
                				<c:forEach var="gbn" items="${work}" varStatus="status">
                					<option value="${gbn.code}" <c:if test="${gbn.code eq sessionScope['userInfo']['jobCd']}">selected</c:if> >${gbn.codeShtnm}</option>
                				</c:forEach>
                			</select> --%>
		                	<input type="text" name="jobCdDisplay" title="업무" value="" placeholder="아래에서 선택하세요.." class="AXInput" readonly/>
		                	<input type="hidden" name="work"  value="" title="업무" class="AXInput av-required"/>
		                	<div id="AXTreeTarget" style="height:200px;width: inherit;  border:1px solid #cecece"></div>                			
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="첨부파일">
          		      		<input name="file_1" id="egovComFileUploader" type="file" />
          		      		<div id="egovComFileList"></div>  
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="요청 내용">
                           <div style="padding:5px">
				                <label class="AXInputLabel fullWidth">
				                    <textarea id="nttCn" name="nttCn" maxlength="1000" cols="75" rows="20" class="AXTextarea av-required" title="S/R내용"><c:out value="${result.nttCn}" escapeXml="false" /></textarea>
				                </label>
				            </div>
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="공개여부">
                			<input type="radio" name="openyn" value="Y" class="av-required"  title="공개여부" />공개
                			<input type="radio" name="openyn" value="N" class="av-required"  title="공개여부" />비공개
                			&nbsp;&nbsp;&nbsp;※ 요청사항에 다른 사용자가 보면 안되는 내용이 포함되어 있다면 비공개로 선택
                			<input type="hidden" name="openynd" id="openynd" value="N"/>
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
                	<div style="text-align:right;">
		                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>저장</button>
		                <button class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var page_menu_id = "m0101";
        
    	var maxFileNum = $("#posblAtchFileNumber").val();
    	if (maxFileNum == null || maxFileNum == "") {
    		maxFileNum = 3;
    	}	 
    	var multi_selector = new MultiSelector(document	.getElementById('egovComFileList'), maxFileNum);
    	multi_selector.addElement(document.getElementById('egovComFileUploader'));	 
		
		
		if("${sessionScope['ROLES']}".indexOf("DEVELOPER0") > -1){
			 $("input[name=openyn]").attr("disabled",true);
			 $('input:radio[name=openyn]:input[value=N]').attr("checked", true);
			 $("#openynd").val("Y");
		}
		
		 
		function changeType(value){
			if(value == "100" || value == "200"){
				$("#rel_div").show();
			} else {
				$("#rel_div").hide();
			}
			
			$("#rel_no").val("");
			$("input[name=rel_no]").val("");
		}
		
		function setDocNo(no,relText) {
    		$("#rel_no").val(relText); 
    		$("input[name='rel_no']").val(no);
    	}
		
	    var pageID = "AXValidator";
	    
	    var deptTree = new AXTree();
	    var myModal = new AXModal();
	    
		var myValidator = new AXValidator(); // Validator 선언
		var fnObj = {
			pageStart: function(){

				myValidator.setConfig({
					targetFormName : "myForm"
					,checkCrlf:true
				});
				
				myModal.setConfig({
					windowID:"myModalContainer",
					displayLoading:true,
					onclose: function(){
					}
				});
				
				$("#work").bindSelect();
				$("#type").bindSelect();
				$("#rctype").bindSelect();
				
				gfnRequire();
				

				var docGbn = "${docGbn}";
				
				if(docGbn != ""){
					$("#type").bindSelectSetValue(docGbn);
					$("#rel_div").show();
					$("#rel_no").val("${relText}"); 
		    		$("input[name='rel_no']").val("${docNo}");
				} 
			},
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				gfnConfirm("저장하시겠습니까?","fnObj.saveForm();");
			},
			saveForm: function(){
				 var form = document.myForm;
		         var formData = new FormData(form);
		         
				 var url = "<c:url value='/sr/srEdit.json'/>";
		         $.ajax({
		        	 url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,   	                    
	                    type: 'POST',
	                    success: function(res){
	                    	if(res.result1.SUCCESS && res.result2.SUCCESS){
	                    		gfnDialog("S/R 등록이 완료되었습니다","Alert","확인","Red","location.href='srView.do?srno="+res.srno+"'");
                            } else {
                            	gfnDialog("<b>Warning</b>&nbsp;S/R 등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Alert","확인","Red","location.href='srList.do'");
                            }
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="srList.do";
			},
            serialize: function(){
                var frm = document.myForm;
                prompt("$(frm).serialize()", $(frm).serialize() );
            },
   		    modalOpen: function(){
   		    	myModal.open({
   		    		url: "<c:url value='/docManagement/docListPop.do'/>",
		            pars: "",
		            top: 100,
		            width: 1024,
		            closeByEscKey: true
   		    	});
   		    }
		}
		
		
        var jobTree = new AXTree();	
		setTree();
        function setTree() {
         	jobTree.setConfig({
    				targetID : "AXTreeTarget",
    				theme: "AXTree_none",
    				//height:"auto",
    				xscroll:true,
    				showConnectionLine:true,
    				relation:{
                     // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
    					parentKey:"upperJobCd",
    					childKey:"jobCd"
    				},				
    				colGroup: [
    					{key:"jobName", label:"제목", width:"100%", align:"left", indent:true,
    						getIconClass: function(){
    							//folder, AXfolder, movie, img, zip, file, fileTxt, fileTag
    							//var iconNames = "company, folder, AXfolder, movie, img, zip, file, fileTxt, fileTag".split(/, /g);
    							
    							//var iconName = "folder";
    							if(this.item.__subTreeLength == 0) {
    								return "fileTxt";	     								
    							} else {
    								return "folder";
    							}
    						},        						
    						formatter:function(){
    							if(this.item.__subTreeLength == 0) {
    								//return "<input type='checkbox' name='jobCd1' value='"+this.item.jobCd+"'/>"+this.item.jobName;	     								
    							} else {
    								//return this.item.jobName;
    							}        							
    							return this.item.jobName;        							
    						}
    					},
    				],
    				body: {
    					onclick:function(idx, item){
     						if(item.__subTreeLength == 0) {	     							 	     						
     							var fullpath = "";
	     						if(item.namePath){
	     							for(var i=0;i<item.namePath.length;i++){
	     								fullpath = fullpath + item.namePath[i];
	     								if(i!=(item.namePath.length-1)){
	     									fullpath = fullpath + " > ";
	     								}
	     							}
	     						}	     							
	     						$("input[name='jobCdDisplay']").val(fullpath);
	     						$("input[name='work']").val(item.jobCd);
	     						
	     						
	     						//alert(Object.toJSON(item));
	     						
	     						
	     						
         						if(item.namePaths){ // oracle일  경우
         							 //alert(item.namePaths);
         							$("input[name='jobCdDisplay']").val(item.namePaths);
         							
         						}
	     						
     						} else {
     							
	     						$("input[name='jobCdDisplay']").val("");
	     						$("input[name='work']").val("");
	     						
     						}
    				 	}      					
    				}
    			});
         	var JobCdList = ${JOB_LIST} 
    		jobTree.setList(JobCdList);
     	}		
	    </script>
	</ax:div>
</ax:layout>