<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="배포 현황" />
     <ax:div name="css">
        <style type="text/css">
            .cell-title-top    {display:table-cell;width:50%;vertical-align:middle;text-align:center;font-size:16px;background-color:#F4F6FA;border-radius:10px 0 0 0;border:1px solid #F4F6FA; }
            .cell-title-middle {display:table-cell;width:50%;vertical-align:middle;text-align:center;font-size:16px;background-color:#F4F6FA;border:1px solid #F4F6FA; }
            .cell-title-bottom {display:table-cell;width:50%;vertical-align:middle;text-align:center;font-size:16px;background-color:#F4F6FA;border-radius:0 0 0 10;border:1px solid #F4F6FA; }
            
            .cell-top    {display:table-cell;width:50%;vertical-align:middle;text-align:right;font-size:16px;padding-right:10px;border-radius:0 10px 0 0;border:1px solid #efefef; }
            .cell-middle {display:table-cell;width:50%;vertical-align:middle;text-align:right;font-size:16px;padding-right:10px;border:1px solid #efefef; }
            .cell-bottom {display:table-cell;width:50%;vertical-align:middle;text-align:right;font-size:16px;padding-right:10px;border-radius:0 0 10 0;border:1px solid #efefef; }
        </style>
    </ax:div>
    <ax:div name="js">
    <script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jquery.jqplot.js'/>"></script>
    <script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.donutRenderer.min.js'/>"></script>    
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.highlighter.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.barRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.categoryAxisRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.canvasAxisTickRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.canvasAxisLabelRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.logAxisRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.canvasTextRenderer.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/axu/plugins/chartjs/jqplot.pointLabels.min.js'/>"></script>
	<script type="text/javascript" src="<c:url value='/js/charts/apexcharts.js' />"></script>
    </ax:div>
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div> 

	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
		    <!-- table border="1" bordercolor="red" width="100%"-->
			<!-- table width="100%"--> 
			<table> 
			  <tr>
				 <td style="vertical-align:top; padding-right:10px;">
				<h1><i class="axi axi-ion-arrow-right-b"></i>&nbsp;배포 현황</h1>
				<div style="margin-bottom:10px; margin-top:20px;">
					<button class="AXButton" onclick="fnSetDate(0);">일</button>
					<button class="AXButton" onclick="fnSetDate(-7);">주</button>
					<button class="AXButton" onclick="fnSetDate(-1,'m');">1개월</button>
					<button class="AXButton" onclick="fnSetDate(-3, 'm');">3개월</button>
				</div>  
				<div style="margin-bottom:10px;">
					<input type="text" name="sdate" id="AXInputDateST" value="${sdate}" class="AXInput W80" /> ~ <input type="text" name="edate" id="AXInputDateED" value="${edate}" class="AXInput W100" />
				</div>
                
                <div style="width:240px;height:300px;display:table;border-radius:10px;border:1px solid #CECECE;" >
					<c:forEach var="result" items="${disSummary}" varStatus="status">
                        <div style="display:table-row">
                            <div class='cell-title-top' >총건수</div> 
                            <div class='cell-middle'>
                            	<a href="javascript:fnMoveList(1);">${result.total}건</a>
                            </div> 
                        </div> 
                        <div style="display:table-row">
                            <div class='cell-title-top' >처리중</div> 
                            <div class='cell-middle'>
                                <a href="javascript:fnMoveList(2);">${result.proc}건</a>
                            </div> 
                        </div> 
                        <div style="display:table-row">
                            <div class='cell-title-top' >완료</div> 
                            <div class='cell-middle'>
                                <a href="javascript:fnMoveList(3);">${result.complete}건</a>
                            </div> 
                        </div> 
                        <div style="display:table-row">
                            <div class='cell-title-top' >처리율</div> 
                            <div class='cell-middle'>
                                ${result.procper}%
                            </div> 
                        </div> 
                    </c:forEach>
                </td>
                <td style="padding-left:10px;">
                	<div style="margin-left:30px;">
	                    <h1><i class="axi axi-bar-graph"></i>&nbsp; 챠트&nbsp;&nbsp; 
		                <!-- select name="selStats" id="selStats"  class="AXSelect" onchange="fnDrawGraph();"-->
						<select name="selStats" id="selStats"  class="AXSelect" onchange="changeChart2();">	                
		                	<option value="dept" <c:if test="${gubun eq 'dept'}">selected</c:if>>부서별 배포 처리건</option>
		                	<option value="type" <c:if test="${gubun eq 'type'}">selected</c:if>>유형별 배포 처리건</option>
		                	<option value="job"  <c:if test="${gubun eq 'job' }">selected</c:if>>업무별 배포 처리건</option>
		                	<option value="rcty" <c:if test="${gubun eq 'rcty'}">selected</c:if>>S/R 접수유형별 배포 처리건</option>                	
		                </select>&nbsp;
		                <select name="selGraph" id="selGraph"  class="AXSelect" onchange="fnDrawGraph();" style="width:80px;">
		                	<option value="pie">원</option>
		                	<option value="bar">막대</option>
		                </select>
	                </div>
	                <div id="chartArea" style="border:1px solid #969696;border-radius:10px;width:760px;height:500px;margin-left:30px;">
		                <div id="newChart" style="width:700px;"></div>
	                </div>
					<div id="graphPad" class="graphPad" style="width:700px;display:none;">
						<div id="graphArea" style="width:700px; height:500px;" class="jqplot-target">
					    </div>
				    </div>	                
                </td>
                </tr>
		            <tr>
		            	<td colspan="2">
							 <br><br><br>
				             <h1><i class="axi axi-th-list"></i>&nbsp;조회결과 리스트</h1>
				             <div id="AXGridTarget"></div>            	
		            	</td>
		            </tr>                
				 </table>
                
<!--                 	<table style="">  
                		<tr valign="top"> 
                			<td>
			                	<h1><i class="axi axi-ion-arrow-right-b"></i>&nbsp;부서별 배포 처리건</h1>
			                	<div id="chartDept" style="width:450px; height:300px;" class="jqplot-target"></div>
			                </td>
	                		<td>
	                			<h1><i class="axi axi-ion-arrow-right-b"></i>&nbsp;유형별 배포 처리건</h1>
	                			<div id="chartType" style="width:450px; height:300px;" class="jqplot-target"></div> 
	                		</td>
	                		<td>
	                			<h1><i class="axi axi-ion-arrow-right-b"></i>&nbsp;업무별 배포 처리건</h1>
	                			<div id="chartJob" style="width:450px; height:300px;" class="jqplot-target"></div>
	                		</td>
	                		<td>  
	                			<h1><i class="axi axi-ion-arrow-right-b"></i>&nbsp;S/R 접수유형별 배포 처리건</h1>
	                			<div id="chartSrRc" style="width:450px; height:300px;" class="jqplot-target"></div>   
	                		</td>	                		
	                	</tr>
	                </table> -->
	                
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    
	    var oldStart = "${sdate}";
	    var oldEnd = "${edate}";
		    $("#AXInputDateED").bindTwinDate({
	            startTargetID: "AXInputDateST",
	            handleLeft: 25,
	            align: "right",
	            valign: "bottom",
	            separator: "",
	            buttonText: "선택",
	            onChange: function () {
	            	if(oldStart == $("#AXInputDateST").val() && oldEnd == $("#AXInputDateED").val()) return false;
	                location.href="<c:url value='/stats/disStats.do'/>?sdate="+$("#AXInputDateST").val()+"&edate="+$("#AXInputDateED").val()+"&gubun="+$("#selStats").val();
	            }
	        });
		    
		     
		 //   var a2 = ['#CE2020','#CE7620','#CEB320','#B7CE20','#69CE20','#FF4000','#20CE7A','#20CEB3','#20A7CE','#2072CE'];
		     
		     /* 통계 데이터 세팅 */
		    var data1 = [ 
		               <c:forEach var="result" items="${disProcDept}" varStatus="status">
		               ['${result.deptname} [${result.cnt}건]', ${result.cnt}],   
		               </c:forEach>
		               <c:if test="${disProcDept.size() eq 0}">
		               ['없음', 0]
		               </c:if>
		              ];
		    var data1tooltip = new Array();
		    <c:forEach var="result" items="${disProcDept}" varStatus="status">
		    data1tooltip.push("${result.deptname}(${result.cnt}건) ${result.complete}%");   
	        </c:forEach>
	        
		    var data2 = [ 
		               <c:forEach var="result" items="${disProcType}" varStatus="status">
		               ['${result.distypenm}(${result.cnt}건)}', ${result.cnt}],   
		               </c:forEach>
		               <c:if test="${disProcType.size() eq 0}">
		               ['없음', 0]
		               </c:if>		               
		              ];
		    var data2tooltip = new Array();
		    <c:forEach var="result" items="${disProcType}" varStatus="status">
		    data2tooltip.push("${result.distypenm}(${result.cnt}건) ${result.complete}%");   
	        </c:forEach>
	        
		    var data3 = [ 
		               <c:forEach var="result" items="${disProcJob}" varStatus="status">
		               ['${result.disjobnm}(${result.cnt}건)', ${result.cnt}],   
		               </c:forEach>
		               <c:if test="${disProcJob.size() eq 0}">
		               ['없음', 0]
		               </c:if>			               
		              ]; 
		    var data3tooltip = new Array();
		    <c:forEach var="result" items="${disProcJob}" varStatus="status">
		    data3tooltip.push("${result.disfulljobnm}(${result.cnt}건) ${result.complete}%");   
	        </c:forEach>
	        
		    var data4 = [ 
		               <c:forEach var="result" items="${disProcSrRc}" varStatus="status">
		               ['${result.srrctypenm}(${result.cnt}건)', ${result.cnt}],   
		               </c:forEach>
		               <c:if test="${disProcSrRc.size() eq 0}">
		               ['없음', 0]
		               </c:if>			               
		              ]; 
		    var data4tooltip = new Array();
		    <c:forEach var="result" items="${disProcSrRc}" varStatus="status">
		    data4tooltip.push("${result.srrctypenm}(${result.cnt}건) ${result.complete}%");   
	        </c:forEach>
	        
	        
	    
			
		    var data1bar = [ 
			               <c:forEach var="result" items="${disProcDept}" varStatus="status">
			               ['${result.deptname}', ${result.cnt}],   
			               </c:forEach>
			               <c:if test="${disProcDept.size() eq 0}">
			               ['없음', 0]
			               </c:if>
			              ];
		    
		    var data1num = [<c:forEach var="result" items="${disProcDept}" varStatus="status">
							'${result.cnt}',   
							</c:forEach>
							<c:if test="${disProcDept.size() eq 0}">
							'0'
							</c:if>];	    
		    
		    var data2bar = [ 
			               <c:forEach var="result" items="${disProcType}" varStatus="status">
			               ['${result.distypenm}', ${result.cnt}],   
			               </c:forEach>
			               <c:if test="${disProcType.size() eq 0}">
			               ['없음', 0]
			               </c:if>
			              ];
		    
		    var data2num = [<c:forEach var="result" items="${disProcType}" varStatus="status">
							'${result.cnt}',   
							</c:forEach>
							<c:if test="${disProcType.size() eq 0}">
							'0'
							</c:if>];	   
		    
		    var data3bar = [ 
			               <c:forEach var="result" items="${disProcJob}" varStatus="status">
			               ['${result.disjobnm}', ${result.cnt}],   
			               </c:forEach>
			               <c:if test="${disProcJob.size() eq 0}">
			               ['없음', 0]
			               </c:if>
			              ];
		    
		    var data3num = [<c:forEach var="result" items="${disProcJob}" varStatus="status">
							'${result.cnt}',   
							</c:forEach>
							<c:if test="${disProcJob.size() eq 0}">
							'0'
							</c:if>];	  
		    
		    var data4bar = [ 
			               <c:forEach var="result" items="${disProcSrRc}" varStatus="status">
			               ['${result.srrctypenm}', ${result.cnt}],   
			               </c:forEach>
			               <c:if test="${disProcSrRc.size() eq 0}">
			               ['없음', 0]
			               </c:if>
			              ];
		    
		    var data4num = [<c:forEach var="result" items="${disProcSrRc}" varStatus="status">
							'${result.cnt}',   
							</c:forEach>
							<c:if test="${disProcSrRc.size() eq 0}">
							'0'
							</c:if>];
		     
		    
		    var barCahrtData  = null;
    		var barChartTitle = null;
    		var chart = null;
    		
		    var dashChart ={
		    		
		    		
		    		
	            	view:function(){
	            		//alert($("#selGraph :selected").val());
	            		if(data1bar.length>1){

	            			
	            			//ion value="dept" selected>부서별 배포 처리건</option>
		                	//<option value="type" >유형별 배포 처리건</option>
		                	//<option value="job" >업무별 배포 처리건</option>
		                	//<option value="rcty" >S/R 접수유형별 배포 처리건</option>    
		                	barChartTitle = [];
		                	barCahrtData  = [];
		            		if($("#selGraph :selected").val()=="pie"){
		            			
		            			if($("#selStats").val()=="dept"){
		            				for(var i =0 ; i< data1.length;i++){
				            			barChartTitle[i]=data1[i][0];
				            			barCahrtData[i]=data1[i][1];
				            		}	
		            			}
		            			if($("#selStats").val()=="type"){
		            				for(var i =0 ; i< data2.length;i++){
				            			barChartTitle[i]=data2[i][0];
				            			barCahrtData[i]=data2[i][1];
				            		}	
		            			}
		            			if($("#selStats").val()=="job"){
		            				for(var i =0 ; i< data3.length;i++){
				            			barChartTitle[i]=data3[i][0];
				            			barCahrtData[i]=data3[i][1];
				            		}	
		            			}
		            			if($("#selStats").val()=="rcty"){
		            				for(var i =0 ; i< data4.length;i++){
				            			barChartTitle[i]=data4[i][0];
				            			barCahrtData[i]=data4[i][1];
				            		}	
		            			}
		            			
		            			
		            			$("#newChart").css("padding-left","100px");
		            			if(chart!=null){
		            				chart.destroy();
		            			}
		            			
		            			setTimeout("dashChart.donutChart()","600");
		            		}else if($("#selGraph :selected").val()=="bar"){
			            		
		            			
		            			if($("#selStats").val()=="dept"){
		            				for(var i =0 ; i< data1barlength;i++){
				            			barChartTitle[i]=data1bar[i][0];
				            			barCahrtData[i]=data1bar[i][1];
				            		}	
		            			}
		            			if($("#selStats").val()=="type"){
		            				for(var i =0 ; i< data2bar.length;i++){
				            			barChartTitle[i]=data2bar[i][0];
				            			barCahrtData[i]=data2bar[i][1];
				            		}	
		            			}
		            			if($("#selStats").val()=="job"){
		            				for(var i =0 ; i< data3bar.length;i++){
				            			barChartTitle[i]=data3bar[i][0];
				            			barCahrtData[i]=data3bar[i][1];
				            		}	
		            			}
		            			if($("#selStats").val()=="rcty"){
		            				for(var i =0 ; i< data4bar.length;i++){
				            			barChartTitle[i]=data4bar[i][0];
				            			barCahrtData[i]=data4bar[i][1];
				            		}	
		            			}
		            			
		            			$("#newChart").css("padding-left","20px");
		            			//$("#newChartBar").remvoe
		            			if(chart!=null){
		            				chart.destroy();
		            			}
		            			
		            			setTimeout("dashChart.barChart()","600");
		            		}
			            		
		            		//this.barChart();	
		            		
		            		//this.barChart2();
	            		}
	            		
            			if(data1bar.length==1 && data1bar[0][0]=="없음"){
            				//$("#newChart").html("조회된 데이터가 없습니다.");
	            			$("#newChart").html("<center><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><font style='font-size:20px;'>조회 된 데이터가 없습니다.</font></center>");
            			}
	            	},
	            	barChart:function(){
	            	        var options = {
	            	            chart: {
	            	                height: 500,
	            	                type: 'bar',
	            	                events: {
	            	                    click: function(chart, w, e) {
	            	                        console.log(chart, w, e )
	            	                    }
	            	                },
	            	            },
	            	            //colors: colors,
	            	            plotOptions: {
	            	                bar: {
	            	                    columnWidth: '45%',
	            	                    distributed: true
	            	                }
	            	            },
	            	            dataLabels: {
	            	                enabled: true,
	            	            },
	            	            series: [{
	            	                data: barCahrtData
	            	            }],
	            	            xaxis: {
            		                categories: barChartTitle,
            		            },
            		            
	            	            tooltip: {
	        		                theme: 'light',
	        		                x: {
	        		                    show: true
	        		                },
	        		                y: {
	        		                    title: {
	        		                        formatter: function() {
	        		                            return '';
	        		                        }
	        		                    }
	        		                }
	        		            },
            		            legend: {
            		                show: true
            		            }
	            	        }

	            	        chart = new ApexCharts(
	            	            document.querySelector("#newChart"),
	            	            options
	            	        );
	            	        chart.render();
	            	},
	            	donutChart:function(){

	            		 var options = {
	            		            chart: {
	            		            	width:600,
	            		                type: 'donut',
	            		            },
	            		            series: barCahrtData,
	            		            labels:barChartTitle,
	            		            responsive: [{
	            		                breakpoint: 480,
	            		                options: {
	            		                }
	            		            }]
	            		        }

	            		       chart = new ApexCharts(
	            		            document.querySelector("#newChart"),
	            		            options
	            		        );
	            		        
	            		        chart.render();
	            	},
	            	barChart2:function(){
	            		 var options = {
	            		            chart: {
	            		                height: 300,
	            		                type: 'bar'
	            		            },
	            		            plotOptions: {
	            		                bar: {
	            		                    barHeight: '100%',
	            		                    distributed: true,
	            		                    horizontal: true,
	            		                    dataLabels: {
	            		                        position: 'bottom'
	            		                    },
	            		                }
	            		            },
	            		            colors: ['#008FFB', '#00E396', '#FEB019', '#FF4560', '#775DD0', '#546E7A', '#26a69a', '#D10CE8'],
	            		            dataLabels: {
	            		                enabled: true,
	            		                textAnchor: 'start',
	            		                style: {
	            		                    colors: ['#fff']
	            		                },
	            		                formatter: function(val, opt) {
	            		                    return opt.w.globals.labels[opt.dataPointIndex] + ":  " + val
	            		                },
	            		                offsetX: 0,
	            		                dropShadow: {
	            		                  enabled: true
	            		                }
	            		            },
	            		            series: [{
	            		                data: [400, 430, 448, 470, 540, 580, 690, 1100 ]
	            		            }],
	            		            stroke: {
	            		                width: 1,
	            		              colors: ['#fff']
	            		            },
	            		            xaxis: {
	            		                categories: ['사업관리팀', '1팀', '2팀', '3팀', '4팀', '기술팀', '공통팀', '기획팀'],
	            		            },
	            		            yaxis: {
	            		                labels: {
	            		                    show: false
	            		                }
	            		            },
	            		            title: {
	            		                text: '주간 요청처리 응대',
	            		                align: 'center',
	            		                offsetX: 0,
	            		                offsetY: 30,
	            		                style: {
	            		                    fontSize:  '16px',
	            		                    color:  '#263238'
	            		                  },
	            		            },
	            		            subtitle: {
	            		                text: '팀별 업무처리사항 처리 진행건수',
	            		                align: 'center',
	            		                offsetX: 0,
	            		                offsetY: 50,
	            		            },
	            		            tooltip: {
	            		                theme: 'dark',
	            		                x: {
	            		                    show: false
	            		                },
	            		                y: {
	            		                    title: {
	            		                        formatter: function() {
	            		                            return '';
	            		                        }
	            		                    }
	            		                }
	            		            }
	            		        }

	            		       chart = new ApexCharts(
	            		            document.querySelector("#dashCahrt03"),
	            		            options
	            		        );
	            		        
	            		        chart.render();
	            		    
	            	}
	            };
		    
		    /* 도넛 그래프 그리기 */
			function drawChart(strTitle, data, tooltipData) {        
			    var plot = $.jqplot("graphArea", [data], {
			      //title:strTitle,
			      //seriesColors: ['#CE2020','#CE7620','#CEB320','#B7CE20','#69CE20','#FF4000','#20CE7A','#20CEB3','#20A7CE','#2072CE'], 
			      seriesDefaults: {
			        // make this a donut chart.
			       
			        renderer:$.jqplot.DonutRenderer,
			        rendererOptions:{
			          // Donut's can be cut into slices like pies.
			          sliceMargin: 2,
			          // Pies and donuts can start at any arbitrary angle.
			          startAngle: -90,
			          showDataLabels: true,   
			          // By default, data labels show the percenta																																																																																ge of the donut/pie.
			          // You can show the data 'value' or data 'label' instead.
			          //dataLabels: 'label',
			          dataLabels: 'label',
			          shadow: false
	
			        }        
			      }, 
			      grid:{
			    	  drawGridLines:false,
			          background: '#ffffff',      // CSS color spec for background color of grid.		          
			          borderWidth: 0,           // pixel width of border around grid.
			          shadow: false                // draw a shadow for grid.
	
			      }, 
			      legend: {
			    	  fontSize:'10pt',
			          show: true,  
			          location: 'ne',     // compass direction, nw, n, ne, e, se, s, sw, w.
			          xoffset: 12,        // pixel offset of the legend box from the x (or x2) axis.
			          yoffset: 12,        // pixel offset of the legend box from the y (or y2) axis.
			      },
	 	          highlighter: {  
		        	  show: true,   
		        	  showMarker:true,
		        	  formatString:"%s",
		        	  tooltipLocation:'n', 
		        	  useAxesFormatters:false, 
		        	  tooltipContentEditor: function(str, seriesIndex, pointIndex, plot){
	                      return tooltipData[pointIndex];
	                  }        // pixels to add to the size of filled markers when drawing highlight.                  
		          }     
			    }); 
			}
			
			
 			/* 막대 그래프 그리기 */
			function drawChartBar(strTitle, data, dataNum, xlabel, tooltipData) {
				  var pBarWidth = null;
				  var pAngle = null;
				  if(data.length >= 10) pAngle = -30;
				  var divWidth = $("#graphArea").width();
				  var datalength = data.length;
				  var widthX = Math.floor(( divWidth / datalength ) * 0.2);
				  
				  var maxNum = 0;
				  for(var i = 0; i<data.length; i++) {
					  if(maxNum < data[i][1]) maxNum = data[i][1];
				  }
				  var yInterval = 1;
				  var vPadMax = 1.2;
				  if(maxNum > 10) {
					  vPadMax = 1.1;
					  yInterval = Math.ceil((maxNum*vPadMax)/9);
				  }				  
				  
				  var plot3 = $.jqplot('graphArea', [data], {  
				    //title: strTitle,
				    seriesDefaults: {renderer: $.jqplot.BarRenderer, 
				    	rendererOptions: {
			                // Set the varyBarColor option to true to use different colors for each bar.
			                // The default series colors are used.	
			                varyBarColor: true
			                ,shadow:false
			                ,barMargin:widthX
			                //,barMargin:8
			            }
				  		//,pointLabels: {show: false}
				    },
				    series:[
				            {pointLabels:{
				              show: true,				              
				              location:'s',
				              fontColor:'#ffffff'
				            }}],
/* 				    series:[
 				            {pointLabels:{
				               show: true
				               //,formatString:"<span style='border:1px solid red; color:red;'>%d</span>" 
				               //,labels: data5num}}  
				    ], */
				    axes: {
				      xaxis:{
				    	  label:xlabel,
				    	  renderer:$.jqplot.CategoryAxisRenderer  
 				          ,tickOptions:{
				              angle: pAngle,
				              labelPosition: 'middle', 
				              fontSize:'10pt',
				              showGridline: false
				           } 
				          ,tickRenderer:$.jqplot.CanvasAxisTickRenderer      
				    	},
				      yaxis:{padMax:vPadMax,     
				    	  	min:0,
				    	  	tickInterval: yInterval,
				    	  	tickOptions: {
				    	  		formatString: '   %d',
				    	  		fontSize:'8pt',
				    	  		showGridline: true
				    	  	}, 
				    	  	label:'건수'
				    	  	
				        } 
				    }, 
					grid:{ 
					 	drawGridLines:false,
					    background: '#ffffff',      // CSS color spec for background color of grid.		          
					    borderWidth: 0,           // pixel width of border around grid.
					    shadow: false                // draw a shadow for grid.
					},
		 	          highlighter: {  
			        	  show: true,   
			        	  showMarker:false,
			        	  formatString:"%s",
			        	  tooltipLocation:'n', 
			        	  useAxesFormatters:false, 
			        	  tooltipContentEditor: function(str, seriesIndex, pointIndex, plot){
		                      return tooltipData[pointIndex];
		                  }        // pixels to add to the size of filled markers when drawing highlight.                  
			          }   
				  });
			}
			
			/* 그래프 호출 */
			function fnDrawGraph() {
				dashChart.view();
				
				$("#graphArea").empty();
				var statsType = $("#selStats").val();
				var graphType = $("#selGraph").val();
				var graphTitle = $("#selStats option:selected").text();
				
				if(graphType == "pie") {
					switch(statsType) {
						case "dept" : drawChart(graphTitle,data1, data1tooltip); break; 
						case "type" : drawChart(graphTitle,data2, data2tooltip); break; 
						case "job" : drawChart(graphTitle,data3, data3tooltip); break; 
						case "rcty" : drawChart(graphTitle,data4, data4tooltip); break;
					}
				} else {
					switch(statsType) {
						case "dept" : drawChartBar(graphTitle, data1bar, data1num, "부서", data1tooltip); break; 
						case "type" : drawChartBar(graphTitle, data2bar, data2num, "유형", data2tooltip); break; 
						case "job" : drawChartBar(graphTitle, data3bar, data3num, "업무", data3tooltip); break; 
						case "rcty" : drawChartBar(graphTitle, data4bar, data4num, "접수유형", data4tooltip); break;						
					}
				}
			}
			
			fnDrawGraph();
			
			/* 배포 목록으로 이동*/
			function fnMoveList(param){
				var sDate = $("#AXInputDateST").val();
				var eDate = $("#AXInputDateED").val();
				switch(param) {
					case 1 : location.href="<c:url value='/dis/disList.do'/>?pStat=ALL&pSDT="+sDate+"&pEDT="+eDate; break;
					case 2 : location.href="<c:url value='/dis/disList.do'/>?pStat=PRC&pSDT="+sDate+"&pEDT="+eDate; break;
					case 3 : location.href="<c:url value='/dis/disList.do'/>?pStat=CPL&pSDT="+sDate+"&pEDT="+eDate; break;
				}
			}
			
			/*조회기간 세팅*/
			function fnSetDate(num, str) {
				if(typeof num != "number") num = 0;
				if(typeof str != "string") str = "";
				var from;
				var to;				
				var date1 = new Date();
				var date = new Date();
				to = gfnGetDate(date1,"-");
				
				if(str == "m") {
					//console.log("".date().add(num, "m"));
					date1 = new Date("".date().add(num, "m"));
				} else {
					//console.log("".date().add(num));
					date1 = new Date("".date().add(num));
				}
				//console.log(date.toString());
				//date.setDate(date.getDate()+num);
				from = gfnGetDate(date1,"-");

				$("#AXInputDateST").val(from);
				$("#AXInputDateED").val(to);
				
				location.href="<c:url value='/stats/disStats.do'/>?sdate="+$("#AXInputDateST").val()+"&edate="+$("#AXInputDateED").val()+"&gubun="+$("#selStats").val();
			}
			
/******************************************************************************************************************************************************/
			   function changeChart2(){
				   //dashChart.view();
				   
				   
					var gubun = $("#selStats").val();
					//var formval = $("#form").val();
			        if(gubun == "dept"){
			        	fnObj.pageStart();
					} else if(gubun == "type"){
						fnObj2.pageStart();
					} else if(gubun == "job"){
						fnObj3.pageStart();
					} else if(gubun == "rcty"){
						fnObj4.pageStart();
					}
			        fnDrawGraph();
/*				   
                	<option value="dept" <c:if test="${gubun eq 'dept'}">selected</c:if>>부서별 배포 처리건</option>
                	<option value="type" <c:if test="${gubun eq 'type'}">selected</c:if>>유형별 배포 처리건</option>
                	<option value="job" <c:if test="${gubun eq 'job'}">selected</c:if>>업무별 배포 처리건</option>
                	<option value="rcty" <c:if test="${gubun eq 'rcty'}">selected</c:if>>S/R 접수유형별 배포 처리건</option>           
*/                	
				   
			   }
/******************************************************************************************************************************************************/
		    var pageID = "autoHeight";
		    var fnObj = {
		        pageStart: function(){
		            fnObj.grid.bind();
		        },
		        grid: {
		            target: new AXGrid(),
		            bind: function(){
		                window.myGrid = fnObj.grid.target;
		
		                var getColGroup = function(){
		                    return [
		                        {key:"sno", label:"번호", width:"50", align:"center"},
		                        {key:"regDate", label:"작성일", width:"100", align:"center",
			                        formatter:function(){
			                            return this.value.left(8).date().print("yyyy-mm-dd");
			                        }
			                    },			                        
		                        {key:"deptName", label:"부서명", width:"300", tooltip:function(){
		                                return this.value;
		                            },
		                            sort: false
		                        },
		                        {key:"dCnt", label:"총건수", width:"100", align:"right", formatter:"money"},
		                        {key:"proc", label:"처리중", width:"100", align:"right", formatter:"money"},
		                        {key:"complete", label:"완료", width:"100", align:"right", formatter:"money"},
		                        {key:"beego", label:"비고", width:"*", align:"center"}
		                    ];
		                };
		
		                myGrid.setConfig({
		                    targetID : "AXGridTarget",
		                    sort:false, //정렬을 원하지 않을 경우 (tip
		                    fitToWidth:true, // 너비에 자동 맞춤
		                    height:"auto",
		                    colGroup : getColGroup(),
		                    colHeadAlign: "center", // 헤드의 기본 정렬 값 ( colHeadAlign 을 지정하면 colGroup 에서 정의한 정렬이 무시되고 colHeadAlign : false 이거나 없으면 colGroup 에서 정의한 속성이 적용됩니다.
		                    body : {
		                        onclick: function(){
		                            ///toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
		                        },
		                        /* ondblclick 선언하면 onclick 이벤트가 0.25 초 지연 발생 됩니다. 주의 하시기 바람니다. */
		                        ondblclick: function(){
		                            //toast.push("더블클릭");
		                            //toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
		                        },
		                        addClass: function(){
		                            // red, green, blue, yellow, white, gray
		                            if(this.index % 2 == 0){
		                                return "blue";
		                            }else{
		                                return "gray";
		                            }
		
		                        }
		                    },
		                    foot : {
		                        rows: [
		                            [
		                                {colSeq:null, colspan:3, formatter:function(){
		                                    return "계";
		                                }, align:"center"},
		                                {colSeq:3, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.dCnt;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},
		                                {colSeq:4, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.proc;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},			                                
		                                {colSeq:5, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.complete;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},			                                
		                                {colSeq:6}
		                            ]
		                        ]
		                    },
		                    page: {
		                        display: false,
		                        paging: false
		                    }
		                });			                
		                var list = [
							//total=14, sno=1, complete=1, distypename=정기배포 , dept_name=업무2부, proc=13, re_dttm=2015-07-21		                             
		  		           <c:forEach var="result" items="${grdList}" varStatus="status">
		  		           	{ deptName:"${result.dept_name}", regDate:"${result.re_dttm}", dCnt:${result.total}, proc:${result.proc}, complete:${result.complete}, beego:"", sno:${result.sno}},
						   </c:forEach>
		                ];
		                // total=14, complete=1, dept_name=업무2부, proc=13, re_dttm=2015-07-21
		                myGrid.setList(list);
		                myGrid.setDataSet({});
		                trace(myGrid.getSortParam());
		
		            },
		            getExcel: function(type){
		                var obj = myGrid.getExcelFormat(type);
		                trace(obj);
		                $("#printout").html(Object.toJSON(obj));
		            }
		        }
		    };
		    jQuery(document.body).ready(function() {
		        fnObj.pageStart();
		    }); 
		    
 /**[2]****************************************************************************************************************************************************/
		    var fnObj2 = {
		        pageStart: function(){
		            fnObj2.grid.bind();
		        },
		        grid: {
		            target: new AXGrid(),
		            bind: function(){
		                window.myGrid = fnObj2.grid.target;
		
		                var getColGroup = function(){
		                    return [
			                        {key:"sno", label:"번호", width:"50", align:"center"},
			                        {key:"regDate", label:"작성일", width:"100", align:"center",
				                        formatter:function(){
				                            return this.value.left(8).date().print("yyyy-mm-dd");
				                        }
				                    },				                        
			                        {key:"deptName", label:"부서명", width:"300", tooltip:function(){
			                                return this.value;
			                            },
			                            sort: false
			                        },
			                        {key:"dCnt", label:"총건수", width:"100", align:"right", formatter:"money"},
			                        {key:"proc", label:"처리중", width:"100", align:"right", formatter:"money"},
			                        {key:"complete", label:"완료", width:"100", align:"right", formatter:"money"},
			                        {key:"beego", label:"비고", width:"*", align:"center"}
		                    ];
		                };
		
		                myGrid.setConfig({
		                    targetID : "AXGridTarget",
		                    sort:false, //정렬을 원하지 않을 경우 (tip
		                    fitToWidth:true, // 너비에 자동 맞춤
		                    height:"auto",
		                    colGroup : getColGroup(),
		                    colHeadAlign: "center", // 헤드의 기본 정렬 값 ( colHeadAlign 을 지정하면 colGroup 에서 정의한 정렬이 무시되고 colHeadAlign : false 이거나 없으면 colGroup 에서 정의한 속성이 적용됩니다.
		                    body : {
		                        onclick: function(){
		                            ///toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
		                        },
		                        /* ondblclick 선언하면 onclick 이벤트가 0.25 초 지연 발생 됩니다. 주의 하시기 바람니다. */
		                        ondblclick: function(){
		                            //toast.push("더블클릭");
		                            //toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
		                        },
		                        addClass: function(){
		                            // red, green, blue, yellow, white, gray
		                            if(this.index % 2 == 0){
		                                return "blue";
		                            }else{
		                                return "gray";
		                            }
		
		                        }
		                    },
		                    foot : {
		                        rows: [
		                            [
		                                {colSeq:null, colspan:3, formatter:function(){
		                                    return "계";
		                                }, align:"center"},
		                                {colSeq:3, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.dCnt;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},
		                                {colSeq:4, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.proc;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},			                                
		                                {colSeq:5, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.complete;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},			                                
		                                {colSeq:6}
		                            ]
		                        ]
		                    },
		                    page: {
		                        display: false,
		                        paging: false
		                    }
		                });			                
		                var list = [

		  		           <c:forEach var="result" items="${grdList2}" varStatus="status">
		  		           	{ deptName:"${result.distypenm}", regDate:"${result.frist_reg_dttm}", dCnt:${result.cnt}, proc:${result.scnt1}, complete:${result.scnt2}, beego:"", sno:${result.sno}},
						   </c:forEach>		                   
		                   
		                ];
		                myGrid.setList(list);
		                myGrid.setDataSet({});
		                trace(myGrid.getSortParam());
		
		            },
		            getExcel: function(type){
		                var obj = myGrid.getExcelFormat(type);
		                trace(obj);
		                $("#printout").html(Object.toJSON(obj));
		            }
		        }
		    };
 /**[3]****************************************************************************************************************************************************/
		    var fnObj3 = {
		        pageStart: function(){
		            fnObj3.grid.bind();
		        },
		        grid: {
		            target: new AXGrid(),
		            bind: function(){
		                window.myGrid = fnObj2.grid.target;
		
		                var getColGroup = function(){
		                    return [
			                        {key:"sno", label:"번호", width:"50", align:"center"},
			                        {key:"regDate", label:"작성일", width:"100", align:"center",
				                        formatter:function(){
				                            return this.value.left(8).date().print("yyyy-mm-dd");
				                        }
				                    },				                        
			                        {key:"deptName", label:"부서명", width:"300", tooltip:function(){
			                                return this.value;
			                            },
			                            sort: false
			                        },
			                        {key:"dCnt", label:"총건수", width:"100", align:"right", formatter:"money"},
			                        {key:"proc", label:"처리중", width:"100", align:"right", formatter:"money"},
			                        {key:"complete", label:"완료", width:"100", align:"right", formatter:"money"},
			                        {key:"beego", label:"비고", width:"*", align:"center"}
		                    ];
		                };
		
		                myGrid.setConfig({
		                    targetID : "AXGridTarget",
		                    sort:false, //정렬을 원하지 않을 경우 (tip
		                    fitToWidth:true, // 너비에 자동 맞춤
		                    height:"auto",
		                    colGroup : getColGroup(),
		                    colHeadAlign: "center", // 헤드의 기본 정렬 값 ( colHeadAlign 을 지정하면 colGroup 에서 정의한 정렬이 무시되고 colHeadAlign : false 이거나 없으면 colGroup 에서 정의한 속성이 적용됩니다.
		                    body : {
		                        onclick: function(){
		                            ///toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
		                        },
		                        /* ondblclick 선언하면 onclick 이벤트가 0.25 초 지연 발생 됩니다. 주의 하시기 바람니다. */
		                        ondblclick: function(){
		                            //toast.push("더블클릭");
		                            //toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
		                        },
		                        addClass: function(){
		                            // red, green, blue, yellow, white, gray
		                            if(this.index % 2 == 0){
		                                return "blue";
		                            }else{
		                                return "gray";
		                            }
		
		                        }
		                    },
		                    foot : {
		                        rows: [
		                            [
		                                {colSeq:null, colspan:3, formatter:function(){
		                                    return "계";
		                                }, align:"center"},
		                                {colSeq:3, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.dCnt;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},
		                                {colSeq:4, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.proc;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},			                                
		                                {colSeq:5, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.complete;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},			                                
		                                {colSeq:6}
		                            ]
		                        ]
		                    },
		                    page: {
		                        display: false,
		                        paging: false
		                    }
		                });			                
		                var list = [

		  		           <c:forEach var="result" items="${grdList3}" varStatus="status">
		  		           	{ deptName:"${result.disjobnm}", regDate:"${result.frist_reg_dttm}", dCnt:${result.cnt}, proc:${result.scnt1}, complete:${result.scnt2}, beego:"", sno:${result.sno}},
						   </c:forEach>		                   
		                   
		                ];
		                myGrid.setList(list);
		                myGrid.setDataSet({});
		                trace(myGrid.getSortParam());
		
		            },
		            getExcel: function(type){
		                var obj = myGrid.getExcelFormat(type);
		                trace(obj);
		                $("#printout").html(Object.toJSON(obj));
		            }
		        }
		    }; 
/**[4]****************************************************************************************************************************************************/	
		    var fnObj4 = {
		        pageStart: function(){
		            fnObj4.grid.bind();
		        },
		        grid: {
		            target: new AXGrid(),
		            bind: function(){
		                window.myGrid = fnObj4.grid.target;
		
		                var getColGroup = function(){
		                    return [
			                        {key:"sno", label:"번호", width:"50", align:"center"},
			                        {key:"regDate", label:"작성일", width:"100", align:"center",
				                        formatter:function(){
				                            return this.value.left(8).date().print("yyyy-mm-dd");
				                        }
				                    },			                        
			                        {key:"deptName", label:"부서명", width:"300", tooltip:function(){
			                                return this.value;
			                            },
			                            sort: false
			                        },
			                        {key:"dCnt", label:"총건수", width:"100", align:"right", formatter:"money"},
			                        {key:"proc", label:"처리중", width:"100", align:"right", formatter:"money"},
			                        {key:"complete", label:"완료", width:"100", align:"right", formatter:"money"},
			                        {key:"beego", label:"비고", width:"*", align:"center"}
		                    ];
		                };
		
		                myGrid.setConfig({
		                    targetID : "AXGridTarget",
		                    sort:false, //정렬을 원하지 않을 경우 (tip
		                    fitToWidth:true, // 너비에 자동 맞춤
		                    height:"auto",
		                    colGroup : getColGroup(),
		                    colHeadAlign: "center", // 헤드의 기본 정렬 값 ( colHeadAlign 을 지정하면 colGroup 에서 정의한 정렬이 무시되고 colHeadAlign : false 이거나 없으면 colGroup 에서 정의한 속성이 적용됩니다.
		                    body : {
		                        onclick: function(){
		                            ///toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
		                        },
		                        /* ondblclick 선언하면 onclick 이벤트가 0.25 초 지연 발생 됩니다. 주의 하시기 바람니다. */
		                        ondblclick: function(){
		                            //toast.push("더블클릭");
		                            //toast.push(Object.toJSON({index:this.index, r:this.r, c:this.c, item:this.item}));
		                        },
		                        addClass: function(){
		                            // red, green, blue, yellow, white, gray
		                            if(this.index % 2 == 0){
		                                return "blue";
		                            }else{
		                                return "gray";
		                            }
		
		                        }
		                    },
		                    foot : {
		                        rows: [
		                            [
		                                {colSeq:null, colspan:3, formatter:function(){
		                                    return "계";
		                                }, align:"center"},
		                                {colSeq:3, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.dCnt;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},
		                                {colSeq:4, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.proc;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},			                                
		                                {colSeq:5, formatter:function(){
		                                    var sum = 0;
		                                    $.each(this.list, function(){
		                                        sum += this.complete;
		                                    });
		                                    return sum.money();
		                                }, align:"right"},			                                
		                                {colSeq:6}
		                            ]
		                        ]
		                    },
		                    page: {
		                        display: false,
		                        paging: false
		                    }
		                });			                
		                var list = [

		  		           <c:forEach var="result" items="${grdList4}" varStatus="status">
		  		           	{ deptName:"${result.srrctypenm}", regDate:"${result.rq_dttm}", dCnt:${result.cnt}, proc:${result.cnt1}, complete:${result.cnt2}, beego:"", sno:${result.sno}},
						   </c:forEach>		                   
		                   
		                ];
		                myGrid.setList(list);
		                myGrid.setDataSet({});
		                trace(myGrid.getSortParam());
		
		            },
		            getExcel: function(type){
		                var obj = myGrid.getExcelFormat(type);
		                trace(obj);
		                $("#printout").html(Object.toJSON(obj));
		            }
		        }
		    };
		    
		    
		    
		   //dashChart.view();
/******************************************************************************************************************************************************/				
			
	    </script>
	    <style>  
		    .jqplot-point-label{font-size:9pt; color:#242424;}
		    .jqplot-donut-series{font-size:9pt; color:#242424;}
		    .tbSummary th {width:120px; height:54px; font-weight:normal; font-size:18px; background:#F5F5F5;}  
		    .tbSummary td {text-align:right; font-size:16px;}
		    .graphPad {margin-top:20px; padding:20px 40px 20px 20px; text-align:center; border:1px solid gray;}
		    .jqplot-yaxis-label {width:35px;}
	    </style>	    
	</ax:div>
</ax:layout>