<%@ page import="java.util.*"%>
<%@ page contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="ax" uri="http://axisj.com/axu4j"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<% %>

<ax:layout name="base.jsp">
    <ax:set name="title" value="사업정보관리(등록)" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post" enctype="multipart/form-data">
                <input type="hidden" name="userId" value="${sessionScope['userInfo']['userId']}" />
                <input type="hidden" name="gbn" value="S" />
                <input type="hidden" name="posblAtchFileNumber"	id="posblAtchFileNumber" value="3" />
                <input type="hidden" name="nttCn" id="nttCn" value="" />
                	<ax:fields>
		                <ax:field label="사업ID">
		                    <input type="text" name="businessYid" id="businessYid" title="사업년도" placeholder="" maxlength="4" class="W60 AXInput av-required" numberOnly/> -
		                	<input type="text" name="businessTid" id="businessTid" title="사업ID" placeholder="" maxlength="10" class="W100 AXInput av-required" englishNumbrtOnly/>
		                	<button type="button" name="checkId"  id="checkId" class="AXButtonSmall Red"><i id="checkIdIcon" class="axi axi-check-box-outline-blank"></i> 사업ID 중복확인</button>
		                    <button type="button" id="createId" class="AXButtonSmall Green"><i class="axi axi-autorenew"></i> 사업ID 자동생성</button>	
		                    <spen style="color:#cc3333;">&nbsp; 예) * 2019-AabcDefGhi(사업년도4자리-영문 5자리 이상)</spen>	                    
                    		<input type="hidden" name="isIdOverlapped" id="isIdOverlapped" class="AXInput" value=""/> 
                    		<input type="hidden" name="businessid" id="businessid" value=""/> 
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="사업분류">
                			<select id="chkGbn" class="AXSelect av-required" title="사업분류">
                				<option value="">선택</option>
                				<c:forEach var="bnsGbn" items="${bnsGbn}" varStatus="status">
                					<option value="${bnsGbn.code}">${bnsGbn.codeShtnm}</option>
                				</c:forEach>
                			</select>
                			<input type="hidden" name="bnsGbn" id="bnsGbn" value=""/>
		                </ax:field>
		            </ax:fields>    
		            <ax:fields>
		                <ax:field label="사업명칭">
		                	<input type="text" name="bns_name" title="사업명칭" placeholder="" class="W400 AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="사업기간">
		                	<input type="text" name="bns_startYmd" id="AXInputDateST"  title="사업시작일자" class="AXInput av-required W80" /> ~ 
		                	<input type="text" name="bns_endYmd" id="AXInputDateED" class="AXInput av-required W100" />
		                </ax:field>
		            </ax:fields>		            
		            <ax:fields>
		                <ax:field label="발주처">
		                	<input type="text" name="bns_order" title="사업명칭" placeholder="" class="W400 AXInput" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="담당자 성명">
		                	<input type="text" name="bns_managerNm" title="담당자성명" placeholder="" class="W400 AXInput" />
		                </ax:field>
		            </ax:fields>
                    <ax:fields>
		                <ax:field label="담당자 연락처">
		                	<input type="text" name="bns_contactUs" title="담당자연락처" placeholder="" class="W400 AXInput" />
		                </ax:field>
		            </ax:fields>
                	<ax:fields>
                		<ax:field label="비고">
                           <div id="AXEditorTarget"></div>
                		   <div id="editContent" style="display:none;"></div>
                		   <intput type="hidden" name="oper_yn" id="oper_yn"  value="N">
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
                	<div style="text-align:right;">
		                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>등록</button>
		                <button type="button" class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var page_menu_id = "m0101";
	    var date = new Date();
	    var vYear = date.getFullYear();
	    var vSdate = vYear+"-01-01"; 
	    var vEdate = vYear+"-12-31";	    
	    var chekBusiness = "";
	    
    	function setDocNo(no,relText,bnsId,bnsNm) {
    		//alert(no);
    		//alert(relText);
    		$("#bnsNameid").html(relText);
    		$("input[name='businessno']").val(no);
    		chekBusiness = bnsNm;
    	} 
    	
	    $("#AXInputDateED").bindTwinDate({
            startTargetID: "AXInputDateST",
            handleLeft: 25,
            align: "right",
            valign: "bottom",
            separator: "",
            buttonText: "선택",
            onChange: function () {
            	//if(oldStart == $("#AXInputDateST").val() && oldEnd == $("#AXInputDateED").val()) return false;
            }
        });	    	
    	
    	var myValidator = new AXValidator();
    	var myModal = new AXModal();
    	var myEditor = new AXEditor();
    	
    	
    	
		var fnObj = {
			pageStart: function(){
				
				$("input:text[numberOnly]").on("keyup", function() {
				    $(this).val($(this).val().replace(/[^0-9]/g,""));
				});
				
				$("input:text[englishNumbrtOnly]").on("keyup", function() {
				    $(this).val($(this).val().replace(/[^a-z|^A-Z|^0-9]/g,""));
				});					

				myValidator.setConfig({
					targetFormName : "myForm"
					,checkCrlf:true
				});
				
				myModal.setConfig({
					windowID:"myModalContainer",
					displayLoading:true,
					onclose: function(){
					}
				});
				
				myEditor.setConfig({
					targetID: "AXEditorTarget",
					lang: "kr",
					height:350,
					frameSrc: "<c:url value='/axu/lib/AXEditor.html'/>",
					editorFontFamily: "Nanum Gothic",
					fonts:["Nanum Gothic","Malgun Gothic","Gulim","Dotum","궁서"],
					onReady: function(){
						myEditor.setContent($("#editContent"));
					}
				}); 
				
		    	gfnRequire();
		    	
                $("#checkId").click(function(){
                	
                	var businessYid = $("#businessYid").val();
                	var businessTid = $("#businessTid").val();
                	var businessId  = businessYid+"-"+businessTid;
                	
                	if(businessId == ""){
                		mask.open();
                		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;사업ID를 기입후 확인하세요.",
                	        buttons:[
                	                   {
                	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                	                    	   mask.close();
                	                       }
                	                   }
                	                ]
                	        });
                		return false;
                	}else if(businessYid.length < 4){
                		mask.open();
                		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;사업ID부분에 년도를 기입후 확인하세요.(4자리)",
                	        buttons:[
              	                   {
              	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
              	                    	   mask.close();
              	                       }
              	                   }
              	                ]
              	        });
	                 		return false;
                	}else if(businessTid.length < 5){
                		mask.open();
                		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;사업ID부분에 영문를 기입후 확인하세요.ss(최대 10자리)",
                	        buttons:[
              	                   {
              	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
              	                    	   mask.close();
              	                       }
              	                   }
              	                ]
              	        });
	                 		return false;
                	}
                	
                	var url = "<c:url value='/taskOrder/checkBusiness.json'/>";
                    var pars = {businessid:businessId};
                    
                    new AXReq(url, 
                        {
                            pars:pars, 
                            onsucc:function(res){
                            	mask.open();
                        		dialog.push({type:"Alert",top:100,body:res.result.MESSAGE,
                        	        buttons:[
                        	                   {
                        	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                        	                    	   mask.close();
                        	                       }
                        	                   }
                        	                ]
                        	        });
                                if(res.result.SUCCESS){
                                	$("#checkIdIcon").attr("class","axi axi-bmg-value-fit");
                                	$("input[name='isIdOverlapped']").val("false");
                                }else{
                                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                                	$("input[name='isIdOverlapped']").val("true");
                                }
                                
                            },
                            onerr:null
                        }
                    );
                });		    	
		    	
                $("input[name='businessYid']").change(function(){
                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                	$("input[name='isIdOverlapped']").val("true");
                });
                $("input[name='businessTid']").change(function(){
                	$("#checkIdIcon").attr("class","axi axi-check-box-outline-blank");
                	$("input[name='isIdOverlapped']").val("true");
                });	
                
                
                $("#createId").click(function(){
                	var url = "<c:url value='/cmmUtil/CreateBnsId.json'/>";
                    var pars= "";
                    
                    new AXReq(url, 
                        {
                            pars:pars, 
                            onsucc:function(res){

                                if(res.result.SUCCESS){
                                	$("#businessYid").val(vYear);
                                	$("#businessTid").val(res.result.crtId);
                                	$("#businessFid").val(res.result.crtId);
                                	$("#checkId").click();
                                }
                                else{
                            		mask.open();
                            		dialog.push({type:"Warning",top:100,body:"<b>Warning</b>&nbsp;사업ID 생성이 실패하였습니다.\n 다시 클릭해 주세요.",
                            	        buttons:[
                          	                   {
                          	                       buttonValue:"확인",buttonClass:"Red",onClick:function(){
                          	                    	   mask.close();
                          	                       }
                          	                   }
                          	                ]
                          	        });
            	                 	return false;                                	
                                }
                            },
                            onerr:null
                        }
                    );						
                });                
                
		    	
		    	
			},
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				var myContent = myEditor.getContent();
				var content = [];
 
 				text = myContent.replace(/<(\/)?([a-zA-Z]*)(\s[a-zA-Z]*=[^>]*)?(\s)*(\/)?>/ig, "");

				if(text.length > 500) {
					gfnDialog("내용은 200자 미만으로 작성해야 합니다.","Warning","확인","Red");
					return false;
				}
				
				while(myContent.length > 0){
					content.push(myContent.substr(0, 102399));
					myContent = myContent.substr(102399);
				}
				$("#nttCn").val(content);
				
				
            	var businessYid = $("#businessYid").val();
            	var businessTid = $("#businessTid").val();
            	var businessId  = businessYid+"-"+businessTid;        				
				$("#businessid").val(businessId);
				
				var cfnGbn = $("#chkGbn").val()
				$("#bnsGbn").val(cfnGbn);
				
				gfnConfirm("등록하시겠습니까?","fnObj.saveForm();");
			},
			saveForm: function(){
				 var form = document.myForm;
		         var formData = new FormData(form);
		         
				 var url = "<c:url value='/taskOrder/editBusiness.json'/>";
		         $.ajax({
		        	 url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,   	                    
	                    type: 'POST',
	                    success: function(res){
	                    	if(res.result.SUCCESS){
	                    		   //alert(res.result.businessSno);
		                    	   gfnDialog("사업정보 등록이 완료되었습니다","Alert","확인","Red","location.href='<c:url value='/taskOrder/businessView.do'/>?business_sno="+res.result.businessSno+"'");
		                    	   //gfnDialog("회의록 등록이 완료되었습니다","Alert","확인","Red","");
		                    	   //alert("taskSno="+res.result.taskSno+"&businessno="+res.result.businessno);
	                        } else {
	                        	   gfnDialog("<b>Warning</b>&nbsp;등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","");
	                        }
	                    	
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="<c:url value='/taskOrder/businessList.do'/>";
			},
   		    modalOpen: function(){
		    		//url: "<c:url value='/taskOrder/bnsListPop.do'/>",
   		    	myModal.open({
   		    		url: "<c:url value='/taskOrder/bnsListPop.do'/>",
		            pars: "",
		            top: 100,
		            width: 1024,
		            closeByEscKey: true
   		    	});
   		    }
		}
		
		$(".th").css("width","200px");
		$(".td inputText ").css("width","800px");
		$(".th").css("text-align","left");
		$(".th").css("padding-left","15px");
	    </script>
	</ax:div>
</ax:layout>