<%@ page contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="ax" uri="http://axisj.com/axu4j"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<ax:layout name="base.jsp">
<style>
 .item-label span.th {
   width:300px;
 }
</style>

    <ax:set name="title" value="사업정보 상세보기" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
              <ax:form name="myForm" method="post" enctype="multipart/form-data">
                <c:forEach var="result" items="${list}" varStatus="status">
                <input type="hidden" name="no" id="no" value="${result.pno}" />
                <input type="hidden" name="type" id="type" value="R" />   
                <input type="hidden" name="business_sno" id="business_sno" value="${result.businessSno}" />  
                <input type="hidden" name="businesSno" id="businesSno" value="${result.busineSno}" />  
		            <ax:fields>
		                <ax:field label="사업명칭(사업아이디)">
		                	${result.businessnm}(${result.businessid})
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
                		<ax:field label="사업기간">
                			${result.bnsStartymd} ~ ${result.bnsEndymd}
                        </ax:field>
                	</ax:fields>
		            <ax:fields>
		                <ax:field label="사업구분">
		                	${result.businessgubun}
		                </ax:field>
		            </ax:fields>                	
		            <ax:fields>
		                <ax:field label="발주처">
		                	${result.businessorder}
		                </ax:field>
		            </ax:fields>                	
		            <ax:fields>
		                <ax:field label="담당자 성명">
		                	${result.businessmanagernm}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="담당자 연락처">
		                	${result.businesscontactus}
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="비고">
		                	${result.businessbeego}
		                </ax:field>
		            </ax:fields>
                <br>
                <div style="text-align:right;">
                <!-- :if test="${result.userId eq sessionScope['userInfo']['userId'] && result.status eq '100'}"-->
                <c:if test="${result.regUserId eq sessionScope['userInfo']['userId'] && updateCheck eq 'Y'}">
		            <button type="button" id="save" class="AXButton" onclick="fnObj.goBnsEdit();"><i class="axi axi-edit2"></i>사업정보 수정</button>
                </c:if>		            
                <c:if test="${result.regUserId eq sessionScope['userInfo']['userId'] && deleteCheck eq 'Y'}">		        
		            <button type="button" id="save" class="AXButton" onclick="fnObj.docDelete();"><i class="axi axi-trash-o"></i>사업정보 삭제</button>	
				</c:if>		            	            
		            <button type="button" id="list" class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	            </div>
	            
                </c:forEach>
                </ax:form>
                <br>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    
	    if("${cnt}" == "1"){
	    	$("#type").val("U");
	    } else {
	    	$("#type").val("R");	    	
	    }
	    
    	var myValidator = new AXValidator();
    	var myModal = new AXModal();
		var fnObj = {
			pageStart: function(){
				myValidator.setConfig({
					targetFormName : "myForm"
					,checkCrlf:true
				});
				
				myModal.setConfig({
					windowID:"myModalContainer",
					displayLoading:true,
	                mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    }
				});
				
				gfnRequire();
			},
			goBnsEdit: function(){
				//location.href="taskview.do?businessSno="+this.item.busineSno+"&taskSno="+this.item.taskSno+"&businessnm="+this.item.businessnm;
				var businessSno = $("#business_sno").val();
				location.href="<c:url value='/taskOrder/businessEdit.do'/>?business_sno="+businessSno+"";
			},
			docDelete: function(){
				 var form = document.myForm;
		         var formData = new FormData(form);
		         
		         var url = "<c:url value='/taskOrder/delBusiness.json'/>";
		         $.ajax({
		        	 url: url,
	                 processData: false,
	                 contentType: false,
	                 data: formData,   	                    
	                 type: 'POST',
	                 success: function(res){
	                 	if(res.result.SUCCESS){
	                 		gfnDialog("삭제완료되었습니다","Alert","확인","Red","fnObj.listForm()");
                        } else {
                       	gfnDialog("<b>Warning</b>&nbsp;실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Alert","확인","Red","");
                        }
	                 },
	                 error : null
	             });
			},			
			listForm: function(){
				location.href="<c:url value='/taskOrder/businessList.do'/>";
			},
   		    modalOpen: function(){
   		    	myModal.open({
   		    		url: "<c:url value='/docManagement/changeOperYn.do'/>",
		            pars: "",
		            top: 100,
		            width: 1024,
		            closeByEscKey: true
   		    	});
   		    }
		}
		
		$(".th").css("width","200px");
		$(".td inputText ").css("width","800px");
		$(".th").css("text-align","left");
		$(".th").css("padding-left","15px");
	    </script>
	</ax:div>
</ax:layout> 