<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="modal.jsp">
    <ax:set name="title" value="프로젝트세부일정목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
			<input type="hidden" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
				<div class="ax-search" id="page-search-box"></div>
				<div class="ax-button-group">
				 <!-- 
					<div class="right" style=" float:left;text-align:left; padding:10px 0 10px 0;">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="10">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>
				 -->
				    <div class="right" style="text-align:right;padding:10px 0 10px 0;">
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
				<div id="divJobCdTree" class="divJobCdTree">
					<span>※ 클릭하면 추가됩니다.</span><span style="position:absolute; right:0px; cursor:pointer;" onclick="$('#divJobCdTree').hide();">[닫기]</span>
					<div id="AXTreeJob" style="height:180px; width:238px;  border:1px solid #cecece"></div>
				</div>
				<div id="popMask" class="popMask" onclick="$('#divJobCdTree').hide(); $(this).hide();"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var jobCd = "";
	    var strJobCd = "";
       	<c:forEach var="jobItem" items="${sessionScope['userInfo']['jobCd'] }" varStatus="status">
       	strJobCd = "${jobItem}";
		jobCd += strJobCd.trim()+","
		</c:forEach>
	    
	    var page_menu_id = "m010301";
	    var myGrid = new AXGrid();
	    var mySearch = new AXSearch();
	    var _this;
	    var fnObj = {
	        pageStart: function(){
	            this.search.bind();
	            this.bindEvent();	            
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    fitToWidth: true,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
        						{key:"no", label:"번호", width:"50", align:"center"},
                                {key:"projectName", label:"프로젝트명", width:"100", align:"center"},
                                {key:"taskName", label:"세부작업명", width:"*", align:"left"},
                                {key:"progress", label:"일정진행률", width:"100", align:"right",
                                	formatter: function(){
                                		return  this.item.progress.number()+" %";
                                	}
                                },
                                {key:"startTime", label:"일정시작일자", align:"center", width:"100"},
                                {key:"endTime", label:"일정종료일자", align:"center", width:"100"}

                    ],
                    body : {
                        onclick: function(){
                        	var chkVals = this.item.projectid+this.item.taskid;
                       		parent.setPjtTask(chkVals,this.item.projectName+" ["+this.item.taskName+"] ",this.item.projectid,this.item.taskid);
                			parent.myModal.isInformChanged=true;
                			parent.myModal.close();
                        },
	                    addClass: function(){
                        }
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }
                });

	        	var pars = mySearch.getParam();
	        	myGrid.setList({
                    ajaxUrl:"<c:url value='/taskOrder/getPtListPop.do'/>", ajaxPars:"popYn=Y&no=&" + pars, 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        	
	        	_this = myGrid;
	        },
	        bindEvent: function(){
	            var _this = this;
 	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });  
	        },
	        search: {
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                mySearch.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
							{display:true, addClass:"", style:"", list:[
            					{label:"프로젝트명", labelWidth:"90", type:"inputText", width:"200", key:"businessName", addClass:"secondItem", valueBoxStyle:"", value:""},
            					{label:"프로젝트ID", labelWidth:"90", type:"inputText", width:"150", key:"businessId", addClass:"secondItem", valueBoxStyle:"", value:""	},
            					{label:"작업명", labelWidth:"90", type:"inputText", width:"200", key:"taskName", addClass:"secondItem", valueBoxStyle:"", value:""	},
            				]}
	                    ]
	                });
	            },
	            submit: function(){

	            	var pars = mySearch.getParam();
                    myGrid.setList({
                        ajaxUrl:"<c:url value='/taskOrder/getPtListPop.do'/>", ajaxPars:pars+"&popYn=Y&no=", 
                        onLoad:function(){
                            
                        }
                    });
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            }
	    };
	    axdom(document.body).ready(function(){fnObj.pageStart()});
	    
	        
        
        function popMaskOn(){            
            var winHeight = $(document).height();  
            var winWidth = $(window).width();            
            $('#popMask').css({'width':winWidth,'height':winHeight});
            $('#popMask').show();
        }
       
	    </script>
        <style>
        	.divJobCdTree {z-index:9001; background-color:white; display:none; padding:2px 0px 0px 0px; margin:0px; width:240px; height:200px; border:1px solid gray; position:absolute;}
        	.jobAddArea {padding:2px 0px 2px 2px; text-align:left; width:500px; height:45px; border:1px solid #cecece; line-height:23px; overflow-y:scroll;}
        	.jobBtn {padding:2px; margin-right:4px; margin-bottom:2px; background-color:#FAFAFA; border:1px solid #B6B6B6; cursor:pointer;}
        	.jobSetBtn {margin-left:2px; padding:3px; border:1px solid #CECECE; color:#616161; background-color:#FAFAFA; border-radius: 2px; cursor:pointer;}
        	.popMask{position:absolute;left:0;  top:0;  z-index:9000; display:none;}        	
        </style>
	</ax:div>
	
	
</ax:layout>