<%@ page contentType="text/html; charset=UTF-8"
%><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
%><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
%><ax:layout name="base.jsp">
    <ax:set name="title" value="요구사항관리 목록" />
	<ax:div name="header">
		<h1>${title}</h1>
		<p class="desc">${page_desc}</p>

	</ax:div>
				${list}
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
			<input type="hidden" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
				<div class="ax-search" id="page-search-box"></div>      
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="10">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>
				    <div class="right">
				       <c:if test="${insertCheck eq 'Y'}">
				        <button type="button" class="AXButton" onclick="fnObj.regTask();" ><i class="axi axi-ion-compose"></i> 요구사항 등록</button>
                       </c:if>				        
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    
	    var page_menu_id = "m010301";
	    var myGrid = new AXGrid();
	    var myModal = new AXModal();
	    var fnObj = {
	        pageStart: function(){
	        	
				<c:if test="${ sessionScope['userInfo']['businessId'] ne null}" >
				//alert("${ sessionScope['userInfo']['businessId']}");
				 var url = "/dsdsm/main/getCmmJsonList.json";
                 var pars = "sqlGbn=taskOrderDAO.getTskBasicInfo&businessId=${ sessionScope['userInfo']['businessId']}";
                 new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
                     if(res.result == "ok"){
                     	var list = res.tree[0];
                     	//alert(Object.toJSON(res.tree));
                     	$("input[name='businessName']").val(list.businessName);
                     	$("input[name='businessId']").val("${sessionScope['userInfo']['businessId']}");
                     }
                 }, onerr:null});
				</c:if>
			
	            this.search.bind();
	            this.bindEvent();
	            
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	            var gridHeight = fnObj.getWidgetHeight();
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "데이터가 존재하지 않습니다.",
                    fitToWidth: false,
                    height:gridHeight,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"no", label:"번호", width:"70", align:"center"},
                        {key:"businessgubun", label:"사업구분", width:"100", align:"center"},
                        {key:"businessnm", label:"사업명칭", align:"left", width:"300"},
                        {key:"reqClassification", label:"요구사항 분류",align:"center", width:"150"},
                        {key:"reqUniqueNumber", label:"요구사항 고유번호",align:"center", width:"150"},
                        {key:"reqName", label:"요구사항 명칭",align:"left", width:"300"},
                        {key:"taskaccptnm", label:"수용영부",align:"center", width:"100"},
                        {key:"reqProgress", label:"진행률", width:"*", align:"center", formatter:function(){
                        		//return ""+this.item.requirementsProgress+" %";
                        		return persentText(this.item.reqProgress,this.item.reqProgressLength);
                        }}                        

                    ],
                    body : {
                        onclick: function(){
                        	location.href="taskview.do?businessSno="+this.item.businessSno+"&taskSno="+this.item.taskSno+"&businessnm="+this.item.businessnm;
                        	//location.href="taskview.do?taskSno="+this.item.busineSno+"&businessnm="+this.item.businessnm;
                        }
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }
                    
                });
	        	
	            function persentText(str,strLgt){
	               var rtnVal = "";
	               
	               if(typeof str == null || str == "" || str == "undefined")
	            	   return "";
	               else if(str == "NO DATA")
	            	   return "";
	               else if(strLgt < 1)
	            	   return "";
	               else
	            	   return str+" %";

	            }

	        	myGrid.setList({
                    ajaxUrl:"getBnsTaskist.do", ajaxPars:"businessId=${sessionScope['userInfo']['businessId']}", 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        	
	        	myModal.setConfig({
					windowID:"myModalCT", width:740,
	                mediaQuery: {
	                    mx:{min:0, max:767}, dx:{min:767}
	                },
					displayLoading:true,
	                scrollLock: true,
					onclose: function(){
					}
				});
                
	        },
	        bindEvent: function(){
	            var _this = this;
	            $("#ax-search-btn-search").bind("click", function(){
	                _this.search.submit();
	            });
	        },
	        search: {
	            target: new AXSearch(),
	            get: function(){ return this.target },
	            bind: function(){
	                var _this = this;
	                this.target.setConfig({
	                    targetID:"page-search-box",
	                    theme : "AXSearch",
	                    mediaQuery: {
	                        mx:{min:0, max:767}, dx:{min:767}
	                    },
	                    onsubmit: function(){
	                        // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
	                    },
	                    rows:[
	                        {display:true, addClass:"", style:"", list:[
	                            {label:"사업명ID", labelWidth:"", type:"inputText", width:"200", key:"businessId", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            },
	                            {label:"사업명칭", labelWidth:"", type:"inputText", width:"200", key:"businessName", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            },
								{label:" 사업기간 ", labelWidth:"100", type:"inputText", width:"80", key:"sdate", addClass:"secondItem", valueBoxStyle:"", value:"",
									onChange: function(){}
								},
								{label:"", labelWidth:"", type:"inputText", width:"90", key:"edate", addClass:"secondItem", valueBoxStyle:"", value:"",
									AXBind:{
										type:"twinDate", config:{
											align:"right", valign:"top", startTargetID:"sdate", buttonText: "선택",
											onChange:function(){
												//toast.push(Object.toJSON(this));
											}
										}
									}
								}                            
	                        ]},
	                        {display:true, addClass:"", style:"", list:[
	                            {label:"요구사항분류", labelWidth:"", type:"inputText", width:"200", key:"taskSclass", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            },
	                            {label:"요구사항고유번호", labelWidth:"", type:"inputText", width:"200", key:"taskSuniNumber", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            },
	                            {label:"요구사항명칭", labelWidth:"", type:"inputText", width:"200", key:"taskSreqName", addClass:"secondItem", valueBoxStyle:"", value:"",
	                                onChange: function(changedValue){
	                                    //toast.push(Object.toJSON(this));
	                                }
	                            }	                            
							]}
	                    ]
	                });
	            },
	            submit: function(){
	                var pars = this.target.getParam();
                    myGrid.setList({
                        ajaxUrl:"getBnsTaskist.do", ajaxPars:pars, 
                        onLoad:function(){
                        }
                    });
	            }
	        },
            reloadList: function(){
                myGrid.reloadList();
            },
            regTask: function(){
            	location.href="taskReg.do";
            },             



    		getWidgetHeight : function(){
    			var windowHeight = $(window).height();
    			
    			return windowHeight-320;
    		},
            pageResize: function(){
                if(fnObj.resizeTimer) clearTimeout(fnObj.resizeTimer);
                fnObj.resizeTimer = setTimeout(function(){
                    myGrid.setConfig({height:fnObj.getWidgetHeight()});
                });
            }
            
	    };
	    
	    
	    </script>
	</ax:div>
</ax:layout>