<%@ page import="java.util.*"%>
<%@ page contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="ax" uri="http://axisj.com/axu4j"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<% %>

<ax:layout name="base.jsp">
    <ax:set name="title" value="요구사항관리(등록)" />
    <ax:div name="header">
        <h1>${title}</h1>
        <p class="desc">${page_desc}</p>
    </ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="true">
                <ax:form name="myForm" method="post" enctype="multipart/form-data">
                <input type="hidden" name="userId" value="${sessionScope['userInfo']['userId']}" />
                <input type="hidden" name="posblAtchFileNumber"	id="posblAtchFileNumber" value="3" />
                <input type="hidden" name="nttCn" id="nttCn" value="" />
                <input type="hidden" name="nttCn2" id="nttCn2" value="" />
		            <ax:fields>
		                <ax:field label="사업명칭(사업아이디)" >
		                    <span id="bnsNameid">사업선택 버튼으로 선색하세요.</span>
		                	<button class="AXButton" onclick="fnObj.modalOpen(); return false;">사업선택</button>
		                    <input type="hidden" name="businessno" id="businessno" title="사업아이디" placeholder="" class="W300 AXInput av-required"/>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="요구사항 분류">
		                	<input type="text" name="requirementsClassification" id="requirementsClassification" title="요구사항 분류" placeholder="" class="W400 AXInput av-required"/>
		                </ax:field>
		            </ax:fields>    
		            <ax:fields>
		                <ax:field label="요구사항 고유번호">
		                	<input type="text" name="requirementsUniqueNumber" id="requirementsUniqueNumber" title="요구사항 고유번호" placeholder="" class="W400 AXInput av-required"/>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="요구사항 명칭">
		                	<input type="text" name="requirementsName" id="requirementsName" title="요구사항 분류" placeholder="" class="W400 AXInput av-required"/>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="요구사항상세설명 정의">
		                	<input type="text" name="requirementsDetailsDefinition" id="requirementsDetailsDefinition" title="요구사항 정의" placeholder="" class="W400 AXInput av-required"/>		                	
		                </ax:field>
		            </ax:fields>
                	<ax:fields>
                		<ax:field label="요구사항 세부사항">
                           <div id="AXEditorTarget"></div>
                		   <div id="editContent" style="display:none;" title="요구사항 세부사항" class="av-required"></div>
                		   <intput type="hidden" name="oper_yn" id="oper_yn"  value="N">
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="수용여부">
                			<select id="requirementsAcceptYn" name="requirementsAcceptYn" title="수용여부" class="AXSelect av-required">
                				<c:forEach var="gbn" items="${taskGbn}" varStatus="status">
                					<option value="${gbn.code}">${gbn.codeShtnm}</option>
                				</c:forEach>
                			</select>                			
                        </ax:field>
                	</ax:fields>
                	<ax:fields>
                		<ax:field label="근거사항">
                            <div id="AXEditorTarget2"></div>
                			<div id="editContent2" style="display:none;"></div>
                        </ax:field>
                	</ax:fields>                	
                	<ax:fields>
		            	<ax:field label="산출정보(정의서)">
		                	<input type="text" name="taskOutput" id="taskOutput" title="산출정보" placeholder="" class="W400 AXInput"/>	
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		            	<ax:field label="관련 요구사항">
		                	<input type="text" name="relatedRequirements" id="relatedRequirements" title="관련 요구사항" placeholder="" class="W400 AXInput"/>	
		                </ax:field>
		            </ax:fields>
                	<ax:fields>
                		<ax:field label="요구사항 출처">
				        	<input type="text" name="requirementsSource" id="requirementsSource" title="요구사항 출처" placeholder="" class="W400 AXInput"/>
                        </ax:field>
                	</ax:fields>
                </ax:form>
                <br>
                	<div style="text-align:right;">
		                <button type="button" class="AXButton" onclick="fnObj.confirm();"><i class="axi axi-save"></i>등록</button>
		                <button type="button" class="AXButton" onclick="fnObj.listForm();"><i class="axi axi-list"></i>목록</button>
	               	</div>
            </ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    var page_menu_id = "m0101";
	    var chekBusiness = "";
	    
    	function setDocNo(no,relText,bnsId,bnsNm) {
    		//alert(no);
    		//alert(relText);
    		$("#bnsNameid").html(relText);
    		$("input[name='businessno']").val(no);
    		chekBusiness = bnsNm;
    	} 
    	
    	var myValidator = new AXValidator();
    	var myModal = new AXModal();
    	var myEditor = new AXEditor();
    	var myEditor2 = new AXEditor();
    	
		var fnObj = {
			pageStart: function(){
				
				<c:if test="${ sessionScope['userInfo']['businessId'] ne null}" >
					//alert("${ sessionScope['userInfo']['businessId']}");
					 var url = "/dsdsm/main/getCmmJsonList.json";
                     var pars = "sqlGbn=taskOrderDAO.getTskBasicInfo&businessId=${ sessionScope['userInfo']['businessId']}";
                     new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
                         if(res.result == "ok"){
                         	var list = res.tree[0];
                         	//alert(Object.toJSON(res.tree));
                        	setDocNo(list.businessSno , list.businessName+" [${ sessionScope['userInfo']['businessId']}] ","${ sessionScope['userInfo']['businessId']}",list.businessName) ;
                         }
                     }, onerr:null});
				</c:if>

				myValidator.setConfig({
					targetFormName : "myForm"
					,checkCrlf:true
				});
				
				myModal.setConfig({
					windowID:"myModalContainer",
					displayLoading:true,
					onclose: function(){
					}
				});
				
				myEditor.setConfig({
					targetID: "AXEditorTarget",
					lang: "kr",
					height:350,
					frameSrc: "<c:url value='/axu/lib/AXEditor.html'/>",
					editorFontFamily: "Nanum Gothic",
					fonts:["Nanum Gothic","Malgun Gothic","Gulim","Dotum","궁서"],
					onReady: function(){
						myEditor.setContent($("#editContent"));
					}
				}); 
				
				myEditor2.setConfig({
					targetID: "AXEditorTarget2",
					lang: "kr",
					height:150,
					width:500,
					frameSrc: "<c:url value='/axu/lib/AXEditor2.html'/>",
					editorFontFamily: "Nanum Gothic",
					fonts:["Nanum Gothic","Malgun Gothic","Gulim","Dotum","궁서"],
					onReady: function(){
						myEditor2.setContent($("#editContent2"));
					}
				});				
				
		    	gfnRequire();
		    	
				
			},
			confirm: function(){
				var validateResult = myValidator.validate();
				if (!validateResult) {
					var msg = myValidator.getErrorMessage();
					gfnDialog("<b>Waring</b>&nbsp;"+msg,"Warning","확인","Red",function(){
						myValidator.getErrorElement().focus();
					});
					return false;
				}else{
					//alert(	validateResult );
				}
				
				var myContent = myEditor.getContent();
				var myContent2 = myEditor2.getContent();
				var content = [];
				var content2 = [];
				var acceptYn = $("#requirementsAcceptYn").val();
				var acceptTt = $("#requirementsAcceptYn option:checked").text();
				
 				var text  = myContent.replace(/<(\/)?([a-zA-Z]*)(\s[a-zA-Z]*=[^>]*)?(\s)*(\/)?>/ig, "");
 				var text2 = myContent2.replace(/<(\/)?([a-zA-Z]*)(\s[a-zA-Z]*=[^>]*)?(\s)*(\/)?>/ig, "");
				
				
				if(text.length < 1) {
				   gfnDialog("요구사항 세부사항  필수사항입니다.","Warning","확인","Red");
				   return false;
				}
				
				if(acceptYn != "RAT0101"){ 
					if(text2.length < 1) {
						   gfnDialog("["+acceptTt+"]인 경우  근거사항은 필수입력 사항입니다.","Warning","확인","Red");
						   return false;
					}
				}
 				
/*
				if(text.length > 4000) {
					gfnDialog("내용은 4,000자 미만으로 작성해야 합니다.","Warning","확인","Red");
					return false;
				}
*/				
				while(myContent.length > 0){
					content.push(myContent.substr(0, 102399));
					myContent = myContent.substr(102399);
				}
				$("#nttCn").val(content);
				
				
				while(myContent2.length > 0){
					content2.push(myContent2.substr(0, 102399));
					myContent2 = myContent2.substr(102399);
				}
				$("#nttCn2").val(content2);
				
				gfnConfirm("등록하시겠습니까?","fnObj.saveForm();");
			},
			saveForm: function(){
				 var form = document.myForm;
		         var formData = new FormData(form);
		         
				 var url = "<c:url value='/taskOrder/tskReg.json'/>";
		         $.ajax({
		        	 url: url,
	                    processData: false,
	                    contentType: false,
	                    data: formData,   	                    
	                    type: 'POST',
	                    success: function(res){
	                    	if(res.result.SUCCESS){
		                    	   gfnDialog("과업정보 등록이 완료되었습니다","Alert","확인","Red","location.href='<c:url value='/taskOrder/taskview.do'/>?taskSno="+res.result.taskSno+"&businessSno="+res.result.businessno+"&businessnm="+chekBusiness+"'");
		                    	   //gfnDialog("회의록 등록이 완료되었습니다","Alert","확인","Red","");
		                    	   //alert("taskSno="+res.result.taskSno+"&businessno="+res.result.businessno);
	                        } else {
	                        	   gfnDialog("<b>Warning</b>&nbsp;등록이 실패하였습니다.\r\n잠시 후 다시 시도바랍니다.","Warning","확인","Red","");
	                        }
	                    	
	                    },
	                    error : null
	                });
			},
			listForm: function(){
				location.href="<c:url value='/taskOrder/taskList.do'/>";
			},
   		    modalOpen: function(){
		    		//url: "<c:url value='/taskOrder/bnsListPop.do'/>",
   		    	myModal.open({
   		    		url: "<c:url value='/taskOrder/bnsListPop.do'/>",
		            pars: "",
		            top: 100,
		            width: 1024,
		            closeByEscKey: true
   		    	});
   		    }
		}
		
		$(".th").css("width","200px");
		$(".td inputText ").css("width","800px");
		$(".th").css("text-align","left");
		$(".th").css("padding-left","15px");
	    </script>
	</ax:div>
</ax:layout>