<%@ page contentType="text/html; charset=UTF-8"
        %><%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"
        %><%@ taglib prefix="ax" uri="http://axisj.com/axu4j"
        %><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"
     %><ax:layout name="base.jsp">
    <ax:div name="header">
        <h1>개인정보수정</h1>
    </ax:div>
    <ax:div name="contents">
    	<ax:row>
    		<ax:col size="12" wrap="true">
		       	<ax:form name="modifyMyInfo" method="post" action="<c:url value='/usermg/modifyMyInfo.json'/>">
		            <ax:fields>
		                <ax:field label="ID" >
			                ${sessionScope["userInfo"]["loginId"] }
			                <input type="hidden" name="userId" value="${sessionScope['userInfo']['userId']}"/>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="성명">
			                <input type="text" name="name" title="성명" placeholder="" value="<c:out value="${sessionScope['userInfo']['name']}"/>" maxlength="50" class="W200 AXInput av-required" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="생년월일">
		                    <input type="text" id="birthYmd" name="birthYmd" title="생년월일" value="${sessionScope['userInfo']['birthYmd']}" class="AXInput W100 av-required" />
		                    <input type="hidden" name="birthCalendar" value="${sessionScope['userInfo']['birthCalendar']}" />
		                    <input type="text" name="birthCalendarNm" value="${sessionScope['userInfo']['birthCalendarNm']}" id="birthCalendarDisplay" class="AXInput" style="width:50px;" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="소속 사업" >
		                    <span id="bnsNameid">사업선택 버튼으로 선색하세요.</span>
		                	<button class="AXButton" onclick="fnObj.modalOpen(); return false;">사업선택</button>
		                    <input type="hidden" name="businessno" id="businessno" />
		                    <input type="hidden" name="businessId" id="businessId" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="담당업무" css="av-required">
							<%-- 		                	
							<c:forEach var="item" items="${JOB_LIST}">
		                		<label>
			                		<input type="checkbox" name="jobCd" value="${item.optionValue}"
			                		<c:forEach var="jobItem" items="${sessionScope['userInfo']['jobCd'] }">
			                		<c:if test="${jobItem eq item.optionValue}">checked</c:if>
		                			</c:forEach>
			                		/>${item.optionText}
		                		</label>
		                	</c:forEach> 
		                	--%>
		                	<span>※ 클릭하면 아래에 추가됩니다.</span>&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:green; cursor:pointer;" onclick="addAllJobCf();">모두 추가</span>
		                	<input type="hidden" name="jobCdValidate"  id="jobCdValidate" value="" title="업무" class="AXInput av-required"/>
		                	<div id="AXTreeJob" style="height:120px;width: inherit;  border:1px solid #cecece"></div>		                	
		                	<span>※ 클릭하면 제거됩니다.</span>&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:red; cursor:pointer;" onclick="removeAllJob();">모두 제거</span>
		                	<div id="jobAddArea" class="jobAddArea"></div>
		                	<div id="jobCdParam" style="width:0px; height:0px;"></div>		                	
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="소속부서" itemcss="fullWidth">
		                	<input type="text" name="deptIdDisplay" title="소속부서" value="" placeholder="아래에서 선택하세요.." class="AXInput av-required" readonly/>
		                	<input type="hidden" name="deptId"  value="" class="AXInput av-required"/>
		                	<div id="AXTreeTarget" style="height:200px;width: inherit;  border:1px solid #cecece"></div>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="직급" css="av-required">
		                	<ax:custom customid="select" id="rankCd" name="rankCd" css="AXSelect" options="${RANK_LIST}" emptyName="정보없음"/>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="직책" css="av-required">
		                	<ax:custom customid="select" id="dutyCd" name="dutyCd" css="AXSelect" options="${DUTY_LIST}" emptyName="정보없음"/>
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="전화번호">
		                	<input type="text" name="tel" title="전화번호" placeholder="02-000-0000" value="${sessionScope['userInfo']['tel']}" class="AXInput av-required av-phone" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="핸드폰">
		                	<input type="text" name="hp" title="핸드폰" placeholder="010-0000-0000" value="${sessionScope['userInfo']['hp']}" class="AXInput av-phone" />
		                </ax:field>
		            </ax:fields>
		            <ax:fields>
		                <ax:field label="이메일">
		                	<input type="text" name="email" title="이메일" placeholder="" value="<c:out value="${sessionScope['userInfo']['email']}"/>" maxlength="100" class="AXInput W200 av-required av-email" />
		                </ax:field>
		            </ax:fields>
		        </ax:form>
		        <div class="ax-button-group">
				    <div class="left">
				        <button type="button" class="AXButton" onclick="fnObj.confirmRemove();"><i class="axi axi-sign-out"></i>탈퇴</button>
				    </div>
				    <div class="right">
				        <button type="button" class="AXButton" onclick="fnObj.form.confirmSave();"><i class="axi axi-save"></i>저장</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
			</ax:col>
    	</ax:row>
    </ax:div>
    <ax:div name="scripts">
        <script type="text/javascript">
            if ("${message}") {
                dialog.push("${message}");
            }
            
            var deptTree = new AXTree();
            var myModal = new AXModal();

            var fnObj = {
                pageStart: function(){
                    this.form.init();
                    this.bindEvent();
                    this.tree1();
                  	//toast.push(Object.toJSON(deptTree.list.length));
                  	//toast.push("${sessionScope['userInfo']['deptId']}");
                    for(var i=0;i<deptTree.list.length;i++){
                    	if(deptTree.list[i].deptId=="${sessionScope['userInfo']['deptId']}"){
                    		deptTree.click(deptTree.list[i].__index,"open",false);
                    		break;
                    	}
                    }
                    //toast.push({type:"Caution",body:Object.toJSON(deptTree.list)});
                    gfnRequire();
                },
                bindEvent:function (){
                    $("form input").keypress(function(event){
                    	if(event.which==13){
                    		fnObj.form.save();
                    	}
                    });
                    $("#rankCd").val("${sessionScope['userInfo']['rankCd']}").bindSelect();
                    $("#dutyCd").val("${sessionScope['userInfo']['dutyCd']}").bindSelect().bindSelectDisabled();
                    $("#birthYmd").bindDate({align:"right", valign:"bottom", separator:"-", defaultSelectType:"y",defaultDate:"1980-01-01", onchange:function(){
                        //toast.push(Object.toJSON(this));
                    }});
                    $("#birthCalendarDisplay").bindSwitch({off:"양력", on:"음력", onChange:function(){
        				//toast.push(Object.toJSON({targetID:this.targetID, on:this.on, off:this.off, value:this.value}));
        				switch(this.value){
	        				case "양력":
	        					$("input[name='birthCalendar']").val(0);
	        					break;
	        				case "음력":
	        					$("input[name='birthCalendar']").val(1);
	        					break;
        				}
        			}});
                    
                    
                },
                form:{
                    validator: new AXValidator(),
                    init: function(){
                        this.validator.setConfig({
                            targetFormName : "modifyMyInfo"
                        });
                    },
                    confirmSave: function(){
                    	gfnConfirm("회원정보를 변경하시겠습니까?","fnObj.form.save();");
                    },
                    save: function(){
                    	setJobCdParam();
                    	//return false;
                        var validateResult = this.validator.validate();
                        if (!validateResult) {
                            var msg = this.validator.getErrorMessage();
                            gfnDialog(msg,"Warning","확인","Red","fnObj.form.validator.getErrorElement().focus();");
                            return false;
                        }else{
                            // 통과
                        }
                        
                        var url = "<c:url value='/usermg/modifyMyInfo.json'/>";
                        var pars = $(document.modifyMyInfo).serialize();
                        
                        new AXReq(url, 
                            {
                                pars:pars, 
                                onsucc:function(res){
                                    if(res.result.SUCCESS){
                                    	gfnDialog(res.result.MESSAGE,"Alert","확인","Red");
                                    }else{
                                    	gfnDialog("<b>Warning</b>&nbsp;" + res.result.MESSAGE,"Warning","확인","Red");
                                    }
                                },
                                onerr:null
                            }
                        );
                        
                        return false;
                    }                    
                },
                tree1: function(){

                	deptTree.setConfig({
        				targetID : "AXTreeTarget",
        				theme: "AXTree_none",
        				//height:"auto",
        				xscroll:true,
        				showConnectionLine:true,
        				relation:{
                            // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
        					parentKey:"upperDeptId",
        					childKey:"deptId"
        				},				
        				colGroup: [
        					{key:"deptName", label:"제목", width:"100%", align:"left", indent:true,
        						getIconClass: function(){
        							//folder, AXfolder, movie, img, zip, file, fileTxt, fileTag
        							//var iconNames = "company, folder, AXfolder, movie, img, zip, file, fileTxt, fileTag".split(/, /g);
        							var iconName = "company";
        							return iconName;
        						},
        						formsatter:function(){
        							//return "<b>"+this.item.no.setDigit(2) + "</b> : " + this.item.nodeName + " (" + this.item.writer + ")";
        							return this.item.deptName;
        						}
        					},
        				],
        				body: {
        					onclick:function(idx, item){
        						var fullpath = "";
        						if(item.namePath){
        							for(var i=0;i<item.namePath.length;i++){
        								fullpath = fullpath + item.namePath[i];
        								if(i!=(item.namePath.length-1)){
        									fullpath = fullpath + " > ";
        								}
        							} 
        								
        						}
        						$("input[name='deptIdDisplay']").val(fullpath);
        						$("input[name='deptId']").val(item.deptId);
        						//toast.push(Object.toJSON(item));
        						//toast.push(Object.toJSON(item));
        						//myTree.setEditor(this.item, this.index);
        						
        						if(item.namePaths){ // oracle 일 경우
        							$("input[name='deptIdDisplay']").val(item.namePaths);
            						$("input[name='deptId']").val(item.deptId);
        						}
        					}
        				}
        			});
        			

        			var List = ${DEPT_CODE}
        			//[
        				//{"deptId":"1","deptName":"업무1부", "parentDeptId":"0", "path":["업무1부"] }, 
        				//{"deptId":"2","deptName":"업무2부", "parentDeptId":"0", "path":["업무2부"] }, 
        				//{"deptId":"3","deptName":"업무3부", "parentDeptId":"0", "path":["업무3부"] }, 
        				//{"deptId":"4","deptName":"업무4부", "parentDeptId":"0", "path":["업무4부"] }, 
        				//{"deptId":"5","deptName":"생산팀", "parentDeptId":"1", "path":["업무1부","생산팀"] }, 
        				//{"deptId":"6","deptName":"전기팀", "parentDeptId":"1", "path":["업무1부","전기팀"] }, 
        				//{"deptId":"7","deptName":"영업팀", "parentDeptId":"2", "path":["업무1부","영업팀"] }, 
        				//{"deptId":"8","deptName":"기획팀", "parentDeptId":"2", "path":["업무1부","기획팀"] }, 
        				//{"deptId":"9","deptName":"법무팀", "parentDeptId":"3", "path":["업무1부","법무팀"] }, 
        				//{"deptId":"10","deptName":"회계팀", "parentDeptId":"3", "path":["업무1부","회계팀"] }, 
        				//{"deptId":"11","deptName":"기계팀", "parentDeptId":"4", "path":["업무1부","기계팀"] }, 
        				//{"deptId":"12","deptName":"화학팀", "parentDeptId":"4", "path":["업무1부","화학팀"] }, 
        				//{"deptId":"13","deptName":"지원파트", "parentDeptId":"5", "path":["업무1부","생산팀","지원파트"]}
        				//{"no":"c0a800273ef91207813ef984ac790002", "nodeCode":"9010", "nodeName":"시스템관리", "open":"1", "type":"computer", "lvl":2, "pno":"c0a800273ef5128c813ef572e64f0001", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":2},
        				//{"no":"c0a800273ef91a46813ef98c59520003", "nodeCode":"9020", "nodeName":"웹폼관리", "open":"1", "type":"desktop", "lvl":2, "pno":"c0a800273ef5128c813ef572e64f0001", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":3}, 
        				//{"no":"c0a800273ef91207813ef988821d0003", "nodeCode":"901011", "nodeName":"분류코드관리", "open":"1", "type":"tree", "lvl":3, "pno":"c0a800273ef91207813ef984ac790002", "path":"/asm/mgrCodeCate.jsp", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":4},
        				//{"no":"c0a800273ef91a46813ef98e123f0004", "nodeCode":"902010", "nodeName":"마스타관리", "open":"1", "type":"folder", "lvl":3, "pno":"c0a800273ef91a46813ef98c59520003", "path":"/cm/mgrWfmMaster.ts", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":5}, 
        				//{"no":"c0a800273ef91a46813ef98ae4130001", "nodeCode":"901012", "nodeName":"공통코드관리", "open":"1", "type":"AXfolder", "lvl":3, "pno":"c0a800273ef91207813ef984ac790002", "path":"/asm/mgrCode.jsp", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":6},
        				//{"no":"c0a800273ef91a46813ef98f2b4c0005", "nodeCode":"902020", "nodeName":"컨텐츠관리", "open":"1", "type":"img", "lvl":3, "pno":"c0a800273ef91a46813ef98c59520003", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":7}, 
    	    			//{"no":"c0a800273ef91f70813ef9e0f9870007", "nodeCode":"901013", "nodeName":"권한코드관리", "open":"1", "type":"zip", "lvl":3, "pno":"c0a800273ef91207813ef984ac790002", "path":"/asm/mgrRole.jsp", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":8},
    	    			//{"no":"c0a800273ef91a46813ef98b9d9b0002", "nodeCode":"901014", "nodeName":"메뉴관리", "open":"1", "type":"file", "lvl":3, "pno":"c0a800273ef91207813ef984ac790002", "path":"/asm/mgrMenu.jsp", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":9},
        				//{"no":"c0a800273ef91f70813ef9db88260006", "nodeCode":"902021", "nodeName":"도움말", "open":"1", "type":"fileTxt", "lvl":4, "pno":"c0a800273ef91a46813ef98f2b4c0005", "useYn":"Y", "roleGid":"c0a800273efa1c76813efa6a9d630003", "rowseq":10}
        			//]
        			;
        			deptTree.setList(List);
                },
                confirmRemove: function(){
                	gfnConfirm("회원탈퇴하시겠습니까?","fnObj.removeUser();");
                },
                removeUser: function(){
                	var url = "<c:url value='/usermg/removeUser.json' />";
                    var pars = {"userId" : "${sessionScope['userInfo']['userId']}","delYn" : "Y"}; 
                    new AXReq(url, {
                        pars    : pars, onsucc: function (res) {
                        	if(res.result.SUCCESS){
                        		gfnDialog("탈퇴 처리에 성공하였습니다.", null, null, null, function(){
                        			window.location.href="<c:url value='/login/logout.do' />";
                        		});
                        	}else{
	                        	toast.push(res.result.MESSAGE);
                        	}
                        }, onerr: null
                    });
                },
       		    modalOpen: function(){
		    		//url: "<c:url value='/taskOrder/bnsListPop.do'/>",
	   		    	myModal.open({
	   		    		url: "<c:url value='/taskOrder/bnsListPop.do'/>",
			            pars: "",
			            top: 100,
			            width: 1024,
			            closeByEscKey: true
	   		    	});
   		    	}
            };
            
            var jobTree = new AXTree();	
            setTree();
            displayJobCd();

            
    	    var chekBusiness = "";
    	    
        	function setDocNo(no,relText,bnsId,bnsNm) {
        		//alert(no);
        		//alert(relText);
        		$("#bnsNameid").html(relText);
        		$("input[name='businessno']").val(no);
        		$("input[name='businessId']").val(bnsId);
        		chekBusiness = bnsNm;
        	} 
        	
            function setTree() {
             	jobTree.setConfig({
        				targetID : "AXTreeJob",
        				theme: "AXTree_none",
        				//height:"auto",
        				xscroll:true,
        				showConnectionLine:true,
        				relation:{
                         // rootID:"0", // 부모가 없는 최상위 아이템의 parentKey value (필요한 경우에만 사용)
        					parentKey:"upperJobCd",
        					childKey:"jobCd"
        				},				
        				colGroup: [
        					{key:"jobName", label:"제목", width:"100%", align:"left", indent:true,
        						getIconClass: function(){
        							//folder, AXfolder, movie, img, zip, file, fileTxt, fileTag
        							//var iconNames = "company, folder, AXfolder, movie, img, zip, file, fileTxt, fileTag".split(/, /g);
        							
        							//var iconName = "folder";
        							if(this.item.__subTreeLength == 0) {
        								return "fileTxt";	     								
        							} else {
        								return "folder";
        							}
        						},        						
        						formatter:function(){
        							if(this.item.__subTreeLength == 0) {
        								//return "<input type='checkbox' name='jobCd1' value='"+this.item.jobCd+"'/>"+this.item.jobName;	     								
        							} else {
        								//return this.item.jobName;
        							}        							
        							return this.item.jobName;        							
        						}
        					},
        				],
        				body: {
        					onclick:function(idx, item){
        						if(item.__subTreeLength == 0) {	  
        				 			//toast.push(Object.toJSON(item));
        							var fullpath = "";
             						if(item.namePath){
             							for(var i=0;i<item.namePath.length;i++){
             								fullpath = fullpath + item.namePath[i];
             								if(i!=(item.namePath.length-1)){
             									fullpath = fullpath + " > ";
             								}
             							}
             						}	   
        							addJobCd(item.jobCd, fullpath);
        						}
        				 	}
        					//onclick:function(idx, item){
        						//alert(idx);
        						/* if(item.__subTreeLength == 0) {	     							 	     						
        							var fullpath = "";
         						if(item.namePath){
         							for(var i=0;i<item.namePath.length;i++){
         								fullpath = fullpath + item.namePath[i];
         								if(i!=(item.namePath.length-1)){
         									fullpath = fullpath + " > ";
         								}
         							}
         						}	     							
         						$("input[name='jobCdDisplay']").val(fullpath);
         						$("input[name='disJob']").val(item.jobCd);
        						} else {
         						$("input[name='jobCdDisplay']").val("");
         						$("input[name='disJob']").val("");
        						}	     					 */	
        						//toast.push(Object.toJSON(item));
        						//toast.push(Object.toJSON(item));
        						//myTree.setEditor(this.item, this.index);
        					//}        					
        				}
        			});
             	var JobCdList = ${JOB_LIST} 
             	//console.log(JobCdList);
        		jobTree.setList(JobCdList);
         	}
            function addJobCd(pJobCd, pJobName) {            	
            	if($("#jobAddArea span[jobcd='"+pJobCd+"']").length == 0) {
	            	$("#jobAddArea").append("<span class='jobBtn' jobcd='"+pJobCd+"' onclick='removeJobCd(this);'>"+pJobName+"</span>");
            	} else {
            		//toast.push("이미 추가된 업무입니다.");
            	}
            }
            function removeJobCd(j) {
            	$(j).remove();
            }
            function removeAllJob() {
            	gfnConfirm("모든 업무를 제거하시겠습니까?","$('#jobAddArea').empty();");
            }
            function addAllJobCf() {
            	gfnConfirm("모든 업무를 추가하시겠습니까?","addAllJob();");            	
            }   
            function addAllJob() {
            	$(jobTree.list).each(function() {
            		if(this.__subTreeLength == 0) {
						var fullpath = "";
 						if(this.namePath){
 							for(var i=0;i<this.namePath.length;i++){
 								fullpath = fullpath + this.namePath[i];
 								if(i!=(this.namePath.length-1)){
 									fullpath = fullpath + " > ";
 								}
 							}
 						}
            			addJobCd(this.jobCd, fullpath);
            		}
            	});
            }
            //저장전에 선택된 업무값으로 변환
            function setJobCdParam() {
            	$("#jobCdParam").empty();            	
            	$("#jobAddArea span").each(function() {
            		$("#jobCdParam").append("<input type='hidden' name='jobCd'value='"+$(this).attr("jobcd")+"'/>");
            		//arrJobCd.push($(this).attr("jobcd"));
            	});            	
            	if($("#jobCdParam input").length == 0) {
            		$("#jobCdValidate").val("");
            	} else {
            		$("#jobCdValidate").val("1");
            	}
            }
            
            function getJobCdFullPath(pJobCd) {
            	var fullpath = "";
            	
	            <c:if test="${sessionScope['databaseType'] eq 'postgres'}">
	            	$(jobTree.list).each(function() {
		            	if(this.jobCd == pJobCd){
							for(var i=0;i<this.namePath.length;i++){
								fullpath = fullpath + this.namePath[i];
								if(i!=(this.namePath.length-1)){
									fullpath = fullpath + " > ";
								}
							}
						}
	            	});
	            	return fullpath;
	        	</c:if>
	        	
	        	<c:if test="${sessionScope['databaseType'] eq 'oracle'}">
	            	$(jobTree.list).each(function() {
		            	if(this.jobCd == pJobCd){
							fullpath = this.namePaths;
						}
	            	});
	            	return fullpath;
	        	</c:if>
            }
            
             	
           function displayJobCd() {
              	var arrJobCd = new Array();
              	
          		<c:forEach var="jobItem" items="${sessionScope['userInfo']['jobCd'] }">			                	
           			arrJobCd.push('${jobItem}');
      			</c:forEach>
      			
      			for(var i=0; i<arrJobCd.length; i++) {
      				addJobCd(arrJobCd[i], getJobCdFullPath(arrJobCd[i]));
      			}
           }
            
            
        </script>
        <style>
        	.jobAddArea {padding:2px 0px 2px 2px; width:500px; height:60px; border:1px solid #cecece; line-height:23px; overflow-y:scroll;}
        	.jobBtn {padding:2px; margin-right:4px; margin-bottom:2px; background-color:#FCF8F8; border:1px solid #AD8686; cursor:pointer; display:inline-block;}        	
        </style>
    </ax:div>
</ax:layout>