<%@ page contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="ax" uri="http://axisj.com/axu4j"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<style>
	body {
		overflow: auto;
	}
</style>
<ax:layout name="base.jsp">
	<ax:div name="header">
	        <h1>주간업무보고서</h1>
	        <p class="desc">업무별 주간보고서 작성 및 관리</p>
	</ax:div>
	<ax:div name="contents">
		<ax:row>
			<ax:col size="12" wrap="false">
				<input type="hidden" id="loginId" value="${sessionScope['userInfo']['loginId']}"/>
				<div id="dateView" style=" margin-left:10px;padding:10px; font-size:18px;vertical-align:top;"> </div>
				<div class="ax-search" id="page-search-box"></div>      
				<div class="ax-button-group">
					<div class="left">
						<select id="pageS" name="pageS" class="AXSelect">
							<option value="10">10</option>
							<option value="30">30</option>
							<option value="50">50</option>
							<option value="100">100</option>
						</select>
					</div>
				    <div class="right">
				    	<button type="button" class="AXButton" onclick="fnObj.hwpDownload();" ><i class="axi axi-file-download"></i>한글다운로드</button>
				    	<button type="button" class="AXButton" onclick="fnObj.wirteForm();" ><i class="axi axi-save"></i>등록</button>
				        <button type="button" class="AXButton" id="ax-search-btn-search"><i class="axi axi-ion-android-search"></i> 검색</button>
				    </div>
				    <div class="ax-clear"></div>
				</div>
				<div class="ax-grid" id="page-grid-box"></div>
				<div id="printPreView">
					<section class="pagePrint" id="pagePrint" style="display:none;">
						<div class="subpage" id="subpage" ></div>
					</section>
				</div>
				<div><iframe id="downFrame" src="" height=0 ></iframe></div>
			</ax:col>
		</ax:row>
	</ax:div>
	<ax:div name="scripts">
	    <script type="text/javascript">
	    
	    var myGrid  = new AXGrid();
	    var mySearch = new AXSearch();
	    
	    var jobSelectViewOption = null;
	    
	    var fnObj = {
	        pageStart: function(){
	        	
	        	
	        	var teamList  =  this.getTeamList();

	            //this.search.bind();
	            this.bindEvent();
	            this.modal.bind();
	           	
	            $("#pageS").bindSelect({
	            	onChange: function(){
	            		myGrid.page.pageSize = this.value;
	            		myGrid.page.pageNo = 1;
	            		fnObj.reloadList();
	            		//toast.push(Object.toJSON(this));
	            	}
	            });
	            
	            var gridHeight = fnObj.getWidgetHeight();
	            
	        	myGrid.setConfig({
                    targetID : "page-grid-box",
                    theme : "AXGrid",
                    emptyListMSG: "이전주 금주 차주에 등록된 주간 업무 보고서가 없습니다.",
                    fitToWidth: false,
                    height:gridHeight,
                    colHeadAlign: "center",
                    mediaQuery: {
                        mx:{min:0, max:767}, dx:{min:767}
                    },
                    colGroup : [
                        {key:"no"          , label:"번호"           , width:"70"  , align:"center" },
                        {key:"weekYear"    , label:"주차"           , width:"150" , align:"center" },
                        {key:"reportDay"   , label:"주간보고일자"    , width:"150" , align:"center" },
                        {key:"deptName"    , label:"업무팀"         , width:"150" , align:"center" },
                        {key:"jobName"     , label:"업무"           , width:"150" , align:"center" },
                        {key:"userName"    , label:"작성자"         , width:"100" , align:"center" },
                        {key:"weekRptId"   , label:"weekRptId"      , width:"200" , align:"center" , display:false},
                        {key:"jobIndex"    , label:"jobIndex"       , width:"200" , align:"center" , display:false}
                    ],
                    body : {
                        onclick: function(){
                        	//alert("작업중"+this.item.weekRptId);
                        	fnObj.modal.open("detailView", {
                                url:"<c:url value='/weeklyReport/weeklyReportDetail.do'/>"
                                , pars:"weekRptId="+ this.item.weekRptId+"&jobName="+this.item.jobName
                                , top:$(document).scrollTop()+50
                            });
                        }
                    },
                    page:{
                        paging:true,
                        pageNo:1,
                        pageSize:10,
                        status:{formatter: null}
                    }

                });
				//SELECT EXTRACT(WEEK FROM NOW());
	        	myGrid.setList({
                    ajaxUrl:"<c:url value='/cmm/getCmmSelectList.do'/>", ajaxPars:"sqlGbn=weekly.selectWeeklyList", 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
	        	//document.all.weekSeq.readonly="readonly";
	        	
	        	
	        	$("#dateView").html("<i class='axi axi-today' style='font-size:20px;'></i> 오늘은 "+((new Date()).date().print(' yyyy년 mm월 dd일 (dw)')+"     ["+getWeekNum()+" 주차] 입니다." ));
	        	
	        	setTimeout("fnObj.getJobSelectBox();","100");
	        },
	        bindEvent: function(){
	            $("#ax-search-btn-search").bind("click", function(){
	                fnObj.submit();
	            });
	        },
	        
            reloadList: function(){
                myGrid.reloadList();
            },
    		getWidgetHeight : function(){
    			var windowHeight = $(window).height();
    			
    			return windowHeight-320;
    		},
            wirteForm: function(){
            	location.href="<c:url value='/weeklyReport/weeklyReportWriteReg.do'/>";
            },
            modal: {
            	target: new AXModal(),
                get: function(){ return this.target },
                bind: function(){
                	window.myModal = this.target;
                    this.target.setConfig({
                        windowID:"myModalContainer",
                        mediaQuery: {
                            mx:{min:0, max:767}, dx:{min:767}
                        },
                        displayLoading:true
                    });
                },
                open: function(type, http){
                    this.target.open({
                        url: http.url,
                        pars: http.pars.queryToObject(),
                        top: ( (typeof http.top == "undefined") ? 100 : http.top ),
                        width: ( (typeof http.width == "undefined") ? 950 : http.width ),
                        closeByEscKey: true
                    });
                },
                disViewopen: function(type, http){
                    this.target.open({
                        url: http.url,
                        pars: http.pars.queryToObject(),
                        top: ( (typeof http.top == "undefined") ? 20 : http.top ),
                        width: ( (typeof http.width == "undefined") ? 1000 : http.width ),
                        closeByEscKey: true
                    });
                },
                close: function(){
                	this.target.remove();
                }
                
                
            },
            submit:function(){
            	//alert("submit");
            	var pars = mySearch.getParam();
            	myGrid.setList({
                    ajaxUrl:"<c:url value='/cmm/getCmmSelectList.do'/>", ajaxPars:"sqlGbn=weekly.selectWeeklyList&"+pars, 
                    onLoad:function(){
                    },onsucc:function(){
                        trace(this);
                    },onError:function(){
                    	trace(this);
                    	console.log("onError!!");
                    }
                });
                
            },
            getJobSelectBox: function() {
        	    var arrJobCd = new Array();
        		var url = "<c:url value='/cmm/getJobList.json'/>";
        		var jobOption = [];
        		
        		jobOption[0]={optionValue:"", optionText:"전체"};
        		
                new AXReq(  url, 
                		    {
                				debug:false, 
                				pars:"", 
                				onsucc:function(res){               
    			                	//alert(Object.toJSON(res.JOB_LIST));
    			                	var jobList = res.JOB_LIST;
    			                	for(var i=0;i<jobList.length;i++){
    			                		jobOption[i+1]={optionValue:jobList[i].jobCd, optionText:jobList[i].jobName}
    			                	}
    			                	mySearch.setConfig({
    			                        targetID:"page-search-box",
    			                        theme : "AXSearch",
    			                        mediaQuery: {
    			                            mx:{min:0, max:767}, dx:{min:767}
    			                        },
    			                        onsubmit: function(){
    			                            // 버튼이 선언되지 않았거나 submit 개체가 있는 경우 발동 합니다.
    			                        },
    			                        rows:[
    			                              
    			                            {display:true, addClass:"", style:"", list:[
 	    			    						{label:"보고 년", labelWidth:"", type:"inputText", width:"50", key:"weekYear", addClass:"secondItem", valueBoxStyle:"", value:"", 
 	    			                                onChange: function(changedValue){
 	    			                                	//toast.push(changedValue);
 	    			                                }
 	    			                            },
	    			    						{label:"보고 주차", labelWidth:"", type:"inputText", width:"50", key:"weekSeq", addClass:"secondItem", valueBoxStyle:"", value:"", 
	    			                                onChange: function(changedValue){
	    			                                	//toast.push(changedValue);
	    			                                }
	    			                            },
	    			                            {label:"업무", labelWidth:"", type:"selectBox", width:"150", key:"jobCd", addClass:"secondItem", valueBoxStyle:"", value:"",
	    			                            	options:jobOption,
	    			                            	AXBind:{
	    			    								type:"select", config:{
	    			    									onchange:function(){
	    			    										//toast.push(Object.toJSON(this.value));
	    			    									}
	    			    								}
	    			    							}
	    			                            },
	    			                            {label:"업무팀", labelWidth:"", type:"selectBox", width:"150", key:"deptId", addClass:"secondItem", valueBoxStyle:"", value:"",
	    			                            	options:teamList,
	    			                            	AXBind:{
	    			    								type:"select", config:{
	    			    									onchange:function(){
	    			    										//toast.push(Object.toJSON(this.value));
	    			    									}
	    			    								}
	    			    							}
	    			                            }
    			                            ]}
    			                        ]
    			                    });
    			                	
    			                	
			    	        		var date = new Date();
    	                            var yyyy = date.getFullYear();
    			    	        	
    			                	$("[name=weekYear]").bindNumber(
    			    	    				{
    			    	    					min:2010, 
    			    	    					max:yyyy,
    			    	    					onchange : function(){
    			    	    						//toast.push(this);
    			    	    						fnObj.submit();
    			    	    					}
    			    	    				}
    			    	    		);
    			                	
    			    	        	if($("[name=weekYear]").val()==""){
        			    	        	$("[name=weekYear]").val(yyyy);
    			    	        	}
    			    	        	
    			    	        	$("[name=weekSeq]").val(getWeekNum());
    			    	        	
    			                	$("[name=weekSeq]").bindNumber(
    			    	    				{
    			    	    					min:1, 
    			    	    					max:52,
    			    	    					onchange : function(){
    			    	    						//toast.push(this);
    			    	    						fnObj.submit();
    			    	    					}
    			    	    				}
    			    	    		);
    			    	        	
    			    	        	
    			    	        	
    			    	        	//$("[name=weekSeq]").on("focus",function(){
    			    	        	//	this.value="";
    			    	        	//});
    			    	        	
    			    	        	$("[name=weekSeq]").keyup(function(){
    			    	        		if((this.value).length>1){
    			    	        			fnObj.submit();
    			    	        		}
    			    	        	});
    			    	        	
    			    	        	

    			    	        	   	                            
    			    	        	
    			                }, 
    			                onerr:null
    			             }
                          );
            },
            getTeamList:function(){
            	var url = "<c:url value='/cmm/getCmmJsonDetail.do'/>";
				var param ="sqlGbn=weekly.selectTeamList";
				 
				 new AXReq(  url, 
                   		    {debug:false, pars:param, onsucc:function(res){
	       			                	if(res.detail != null && res.detail != "" ){
	       			                		teamList = res.detail;
	       			                	}
       			             }, onerr:null}
                  );
            },
            hwpDownload:function(){
            	
            	//alert($("[name=weekSeq]").val());
            	//alert(Object.toJSON(myGrid.list.length));
            	
            	//return;
				if( myGrid.list.length > 0){
					// 브라우저별 다운로드 
					var agent = navigator.userAgent.toLowerCase();
	
					if ( (navigator.appName == 'Netscape' && navigator.userAgent.search('Trident') != -1) || (agent.indexOf("msie") != -1) ) {
					    /* fnObj.modal.open("FileDownloads",
								{url:"/dsdsm/weeklyReport/downloadWeekHwpFile.do", pars:"sqlGbn=weekly.selectWeekReportWeekAll&weekSeq="+$("[name=weekSeq]").val()}
						);
					    myModal.close("myModalContainer");
						setTimeout("parent.fnObj.modal.close()","500"); */
						
						$("#downFrame").attr("src","/dsdsm/weeklyReport/downloadWeekHwpFile.do?sqlGbn=weekly.selectWeekReportWeekAll&weekSeq="+$("[name=weekSeq]").val());
					} 
					if (agent.indexOf("hrome") != -1) {
						/* fnObj.modal.open("FileDownloads",
								{url:"/dsdsm/weeklyReport/downloadWeekHwpFile.do", pars:"sqlGbn=weekly.selectWeekReportWeekAll&weekSeq="+$("[name=weekSeq]").val()}
						);
						myModal.close('myModalContainer');
						setTimeout("parent.fnObj.modal.close()","500"); */
						
						$("#downFrame").attr("src","/dsdsm/weeklyReport/downloadWeekHwpFile.do?sqlGbn=weekly.selectWeekReportWeekAll&weekSeq="+$("[name=weekSeq]").val());
					}
				}else{
           		 	gfnDialog("<b>알림</b><br>"+$("[name=weekSeq]").val()+"주차에 등록된 보고서가 없습니다!!!" ,"Alert","확인","Red");
				}
            }
	    };
	    
		function printByJquery(options){
			$('.pagePrint').show();
			$('.pagePrint').printElement(options); //팝업으로 띄울 영역 Div 아이디
			$('.pagePrint').hide();
		}
		
		function print(){
			printByJquery({
				   printMode: 'popup', //팝업설정 popup = 팝업창 , iframe = iframe
				   overrideElementCSS:[ 
				                        '<c:url value="/axu/ui/cocker-dark-red/print.css"/>', { href:'<c:url value="/axu/ui/cocker-dark-red/print.css"/>', media:'print' },
				                        '<c:url value="/axu/plugins/axicon/axicon.min.css"/>', { href:'<c:url value="/axu/plugins/axicon/axicon.min.css"/>', media:'print' },
				                        '<c:url value="/css/dssdm/printInfo.css"/>', { href:'<c:url value="/css/dssdm/printInfo.css"/>', media:'print' }
				   						], //css경로
				   pageTitle:'DSPMS Print', //인쇄 타이틀
				   leaveOpen:false //false = 인쇄후 창닫기
			});
		}
	    //alert("${sessionScope['userInfo']}");
	    	    </script>
	</ax:div>
</ax:layout>

