<%@ page language="java" contentType="text/html; charset=UTF-8"    pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<!DOCTYPE html>
<head>
<meta charset="UTF-8">
<title></title>
    <link rel="shortcut icon" href="<c:url value='/resources/img/favicon_16.ico'/>" />
    <link rel="bookmark" href="<c:url value='/resources/img/favicon_16.ico'/>" />
    <!-- site css -->
    <link rel="stylesheet" href="<c:url value='/resources/css/site.min.css'/>">
    <link href="http://fonts.googleapis.com/css?family=Open+Sans:400,300,600,800,700,400italic,600italic,700italic,800italic,300italic" rel="stylesheet" type="text/css">
    <link href="<c:url value='/resources/css/font.css'/>" rel="stylesheet" type="text/css">
    <script type="text/javascript" src="<c:url value='/resources/js/site.min.js'/>"></script>
    <script type="text/javascript" src="<c:url value='/resources/js/jquery-3.4.1.min.js' />" ></script>
     
	<script type="text/javascript" src="<c:url value='/resources/js/pot/pot.js' />" ></script> 
   <script type="text/javascript" src="<c:url value='/js/charts/apexcharts.js' />"></script>
</head>

<script>
	
	var dashChart ={
		view:function(){
			this.barChart();
			this.donutChart();
			this.barChart2();
		},
		barChart:function(){ 
			var url = "<c:url value="/main/getCmmJsonList.json"/>";
	        var pars = "sqlGbn=DashBoard.1stGraph";
	        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
	            if(res.result == "ok"){
	            	var list = res.tree; 
	            	 
	            	var viewX = [];
	            	var viewY = [];

	            	for(var i=0; i< list.length;i++){ 
	            		viewX[i]=list[i].team;
	            		viewY[i]=list[i].cnt;
	            	}
	            	 
	       		 	var colors = ['#008FFB', '#00E396', '#FEB019', '#FF4560', '#775DD0', '#546E7A', '#26a69a', '#D10CE8'];
	    	        var options = {
	    	            chart: {
	    	                height: 300,
	    	                type: 'bar',
	    	                events: {
	    	                    click: function(chart, w, e) {
	    	                        console.log(chart, w, e )
	    	                    }
	    	                },
	    	            },
	    	            colors: colors,
	    	            plotOptions: {
	    	                bar: {
	    	                    columnWidth: '45%',
	    	                    distributed: true
	    	                }
	    	            },
	    	            dataLabels: {
	    	                enabled: false,
	    	            },
	    	            title: {
			                text: "개발 진행도 ",
			                align: 'center',
			                offsetX: 0,
			                offsetY: 30,
			                style: {
			                    fontSize:  '16px',
			                    color:  '#263238'
			                  },
			            },
			            subtitle: {
			                text: '팀별 진척률',
	    		            align: 'center',
	    		            	offsetX: 0,
	    		                offsetY: 50,
			            },
	    	            series: [{
	    	                data: viewY
	    	            }],
	    	            xaxis: {
	    	                categories: viewX,
	    	                labels: {
	    	                    style: {
	    	                        colors: colors,
	    	                        fontSize: '14px'
	    	                    }
	    	                }
	    	            },
	
	    	            tooltip: {
			                theme: 'light',
			                x: {
			                    show: true
			                },
			                y: {
			                    title: {
			                        formatter: function() {
			                            return ''
			                        }
			                    }
			                }
			            }
	    	        } 
	    	        
	    	        var chart = new ApexCharts(document.querySelector("#dashCahrt01"), options); 
	    	        chart.render();

	            }else{
	                //console.log("실패입니다.");
	            }
	        }, onerr:null});
	        
		},
		donutChart:function(){ 
	    	var url = "<c:url value="/main/getCmmJsonList.json"/>";
	        var pars = "sqlGbn=DashBoard.2ndGraph";
	        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
	            if(res.result == "ok"){ 
	        		var options = {
	        				title: {
	    		                text: '2019년 DSPMS 개발사업',
	    		                align: 'center',
	    		                offsetX: 0,
	    		                offsetY: 30,
	    		                style: {
	    		                    fontSize:  '16px',
	    		                    color:  '#263238'
	    		                  },
	    		            },
	    		            subtitle: {
	    		                text: '전체 사업 진행률',
	    		                align: 'center',
	    		                offsetX: 0,
	    		                offsetY: 50,
	    		            },
	        	            chart: {
	        	            	height: 300,
	        	                type: 'radialBar',
	        	            },
	        	            plotOptions: {
	        	                radialBar: {
	        	                    track: {
	        	                        background: "#e7e7e7",
	        	                        strokeWidth: '97%',
	        	                        margin: 5, // margin is in pixels
	        	                        shadow: {
	        	                            enabled: true,
	        	                            top: 2,
	        	                            left: 0,
	        	                            color: '#999',
	        	                            opacity: 1,
	        	                            blur: 2
	        	                        }
	        	                    }
	        	                }
	        	            },
	        	            fill: {
	        	                type: 'gradient',
	        	                gradient: {
	        	                    shade: 'light',
	        	                    shadeIntensity: 0.9,
	        	                    inverseColors: false,
	        	                    opacityFrom: 1,
	        	                    opacityTo: 1,
	        	                    stops: [0, 50, 53, 91]
	        	                },
	        	            },
	        	            series: [res.tree[0]],
	        	            labels: ['사업진행도'],
	        	           
	        	        }
	        	    
	            	var chart = new ApexCharts(document.querySelector("#dashCahrt02"), options);
	            	chart.render();
	            }else{
	                //console.log("실패입니다.");
	            }
	        }, onerr:null});
		},
		barChart2:function(){ 
	        var url = "<c:url value="/main/getCmmJsonList.json"/>";
            var pars = "sqlGbn=DashBoard.3rdGraph";
            new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
                if(res.result == "ok"){
                	var list = res.tree;
                	var viewData = [];
                	
                	for(var i=0; i< list.length;i++){
                		viewData[i]={x:list[i].team , y:list[i].cnt};
                	}
                	
                	 var options = {
         		            chart: {
         		                height: 300,
         		                type: 'bar'
         		            },
         		            plotOptions: {
         		                bar: {
         		                    barHeight: '100%',
         		                    distributed: true,
         		                    horizontal: true,
         		                    dataLabels: {
         		                        position: 'bottom'
         		                    },
         		                }
         		            },
         		            colors: ['#008FFB', '#00E396', '#FEB019', '#FF4560', '#775DD0', '#546E7A', '#26a69a', '#D10CE8'],
         		            dataLabels: {
         		                enabled: true,
         		                textAnchor: 'start',
         		                style: {
         		                    colors: ['#fff']
         		                },
         		                formatter: function(val, opt) {
         		                    return opt.w.globals.labels[opt.dataPointIndex] + ":  " + val
         		                },
         		                offsetX: 0,
         		                dropShadow: {
         		                  enabled: true
         		                }
         		            },
         		            series: [{
         		                data: viewData
         		            }],
         		            stroke: {
         		                width: 1,
         		              colors: ['#fff']
         		            },
         		            xaxis: {
         		                categories: [],
         		            },
         		            yaxis: {
         		                labels: {
         		                    show: false
         		                }
         		            },
         		            title: {
         		                text: '주간 요청처리 응대',
         		                align: 'center',
         		                offsetX: 0,
         		                offsetY: 30,
         		                style: {
         		                    fontSize:  '16px',
         		                    color:  '#263238'
         		                  },
         		            },
         		            subtitle: {
         		                text: '팀별 업무처리사항 처리 진행건수',
         		                align: 'center',
         		                offsetX: 0,
         		                offsetY: 50,
         		            },
         		            tooltip: {
         		                theme: 'light',
         		                x: {
         		                    show: true
         		                },
         		                y: {
         		                    title: {
         		                        formatter: function(str) {
         		                        	//alert(str);
         		                            return '';
         		                        }
         		                    }
         		                }
         		            }
         		   };
                	 
     		       var chart = new ApexCharts(document.querySelector("#dashCahrt03"), options);
       		       chart.render();
       		         
                }else{
                    //console.log("실패입니다.");
                }
            }, onerr:null}); 
		}
	};

	//--------------------------------
    // 공지사항의 Data를 가져온다.
	//--------------------------------
    function getNoticeList(){ 
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.selectNoGroup";
        var pars = "sqlGbn="+sqlId; 
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
                var noticeJson = res.tree;
                noticeListMaker(noticeJson);
                
            }else{
                //console.log("실패입니다.");
            }
        }, onerr:null});
    }
	//--------------------------------
    
    // 공지사항 리스트를 내용을 만든다.
    function noticeListMaker(json){
        var tempContent="";
        var len =json.length;
        
        if(json.length>5){
            len=5;
        }
         
        tempContent = "<table class='table table-hover' style='margin-bottom:0px;'><tbody>";
		 
        for(var i=0;i<len;i++){
            var newIcon="";
            var newGbn = (json[i].regrDttm).date().diff(getToday().date() );
            if(newGbn <= 3){
                newIcon="<span style='border:1px solid #969696;color:#ffffff;background-color:#969696;vertical-align:bottom;font-weight:600;font-size:11px;border-radius:4px;color:#ffff00;'>&nbsp;New&nbsp;</span>";
                //newIcon="<i class='axi axi-newspaper-o' style='font-size:17px;'></i>";
            } 
            
            var addStyle = "";
			if (i == 0) {
				addStyle = "style='border-top:0px;'";
				
			} else { 
				addStyle = "";
			}
			
            tempContent += "<tr onClick='goNoticeDetailModal(\"" + i + "\",\"" + json[i].sid + "\");'>";
            tempContent += "<td " + addStyle + "><i class='fa fa-caret-square-o-right'></i> " + json[i].ntSubj + "&nbsp;&nbsp;" + newIcon + "</td>";
            tempContent += "</tr>"; 
        }
        
        tempContent += "</tbody></table>"; 
        
        $("#noticeList").html(tempContent);
        $("#ltUnprocessedList").css("height",$("#noticeList").height()); 
    }

	// 공지사항 리스트 - 상세보기 팝업
    function goNoticeDetailModal(idx, sid){ 
    	CmmUtil.popUpUrl($("#noticeDetailUrl").val(), {"sid":sid}, "800");
    }

	//--------------------------------
	// 1 주일이상 접수 후 미처리 목록
	//--------------------------------
    function getSrListExceedData(){
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.selectSrLimitExceed";
        var pars = "sqlGbn="+sqlId; 
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
            	getSrListExceedListMaker(res.tree);
            }else{
                console.log("실패입니다.");
            }
        }, onerr:null});
    }
	//--------------------------------

    // 1 주일이상 접수 후 미처리 목록을 만든다.
    function getSrListExceedListMaker(json){
		var tempContent="";

      	if(json.length>0){
      		$("#srListExceedCnt").html("<strong><font color=red>("+json.length+")</font></strong>");
      	}

        tempContent = "<table class='table table-hover' style='margin-bottom:0px;'><tbody>";
		 
        for(var i=0;i<json.length;i++){
            var addStyle = "";
			if (i == 0) {
				addStyle = "style='border-top:0px;'";
				
			} else { 
				addStyle = "";
			}
			
            tempContent += "<tr onClick='goSrPageDetailModal(\""+json[i].srNo+"\");'>";
            tempContent += "<td " + addStyle + "><i class='fa fa-caret-square-o-right'></i> " + json[i].lastStaName + " <font color=red>(" + json[i].exceedday + "일) 초과</font></td>";
            tempContent += "</tr>"; 
        }

        tempContent += "</tbody></table>"; 
        
        $("#ltUnprocessedList").html(tempContent);
        $("#ltUnprocessedList").css("height",$("#noticeList").height()); 
    }

	// 1 주일이상 접수 후 미처리 목록 - 상세보기 팝업
    function goSrPageDetailModal(srNo){  
    	CmmUtil.popUpUrl($("#ltupDetailUrl").val(), {"srno":srNo}, "1090");
    }
	
	//--------------------------------
	// S/R 할일목록 - List
	//--------------------------------
    function getSrToDoList() { 
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.selectSrGroup";
        var pars = "sqlGbn="+sqlId;   
	    new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
	        if(res.result == "ok"){
	            var srToDoJson = res.tree;
	            srToDoListMaker(srToDoJson);
	        }else{
	            //console.log("실패입니다.");
	        }
	    }, onerr:null});
	     
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.selectDisGroup";
        var pars = "sqlGbn="+sqlId;  
	    new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
	        if(res.result == "ok"){
	            disToDoListMaker(res.tree);
	        }else{
	            //console.log("실패입니다.");
	        }
	    }, onerr:null});    	
    }
	//--------------------------------

    // 1. 화면을 작을경우 SR 리스트 를 가져온다.
    // 2. Tab카운트(전체갯수)를 가져와 hidden(srTabCnt)에 넣으둔다.
    function srToDoListMaker(json){
        var len =json.length;
        var tempContent = "";
        var srAllcnt = 0;
        
        if(json.length>5){
            len=5;
        }

        tempContent = "<div id='srMainSubList' style='height:100%;overFlow-y:scroll;'><table class='table table-hover' style='margin-bottom:0px;'><tbody>"; 
        for(var i=0;i<len;i++){ 
            var addStyle = "";
			if (i == 0) {
				addStyle = "style='border-top:0px;'";
				
			} else { 
				addStyle = "";
			}
			
            tempContent += "<tr id='mainSrSelect"+json[i].lastSta+"' onClick='subListLayoutSet(\"#disMainSubList\","+json[i].lastSta+",\"SR\");'>";
            tempContent += "<td " + addStyle + "><span id='mainSrIcon"+json[i].lastSta+"'><i class='fa fa-square-o' ></i></span>&nbsp;&nbsp;"+json[i].lastStaName+"("+json[i].cnt+")</td>";
            tempContent += "</tr>";
            //tempContent+="<div  id='mainSrSelect"+json[i].lastSta+"' style='height:30px;border-bottom:1px solid #969696;vertical-align:bottom;' onClick='subListLayoutSet(\"#disMainSubList\","+json[i].lastSta+",\"SR\");'><span id='mainSrIcon"+json[i].lastSta+"'><i class='axi axi-check-box-outline-blank' ></i></span>&nbsp;&nbsp;"+json[i].lastStaName+"("+json[i].cnt+")</div>";

            srAllcnt+=parseInt(json[i].cnt);
            $("#srStepId_"+json[i].lastSta).html(json[i].cnt+" 건");
             
            $("#srStepId_"+json[i].lastSta).css("font-weight","600");
            $("#srStepId_"+json[i].lastSta).css("color","red");
        }         
        tempContent += "</tbody></table></div>"; 
        
        $("#srToDoListCnt").html("<font style='600;color:red;'><strong>("+srAllcnt+")</strong></font>");
        //$("#toDoMainSrCtn").html("<font style='600;color:red;'><strong>("+srAllcnt+")</strong></font>");

        //$("#srTabCnt").val("<font style='600;color:red;'><strong>("+srAllcnt+")</strong></font>");  // hidden에 넣어둔다.
        $("#srToDoList").html(tempContent);
        $("#srToDoList").css("border-bottom , border-right , border-left , width , height","1px solid #B9BABC , 1px solid #B9BABC , px solid #B9BABC , 100% , 210px;");
    }

    // 1. 화면이 작을경우 배포(dis) 목록을 가져온다.
    // 2. Tab카운트(전제갯수)를 가져와 hiddden(disTabCnt)에 넣어둔다.
    function disToDoListMaker(json){
        var len =json.length;
        var tempContent = "";
        var srAllcnt = 0;

        tempContent = "<div id='disMainSubList' style='height:100%;overFlow-y:scroll;'><table class='table table-hover' style='margin-bottom:0px;'><tbody>";         
        for(var i=0;i<len;i++){
            var addStyle = "";
			if (i == 0) {
				addStyle = "style='border-top:0px;'";
				
			} else { 
				addStyle = "";
			}

            tempContent += "<tr id='mainDisSelect"+json[i].lastSta+"' onClick='subListLayoutSet(\"#srMainSubList\","+json[i].lastSta+",\"DIS\");'>";
            tempContent += "<td " + addStyle + "><span id='mainDisIcon"+json[i].lastSta+"'><i class='fa fa-square-o' ></i></span>&nbsp;&nbsp;"+json[i].lastStaName+"("+json[i].cnt+")</td>";
            tempContent += "</tr>";
            //tempContent+="<div id='mainDisSelect"+json[i].lastSta+"' style='height:30px;vertical-align:bottom;border-bottom:1px solid #969696;' onClick='subListLayoutSet(\"#srMainSubList\","+json[i].lastSta+",\"DIS\");'><span id='mainDisIcon"+json[i].lastSta+"'><i class='axi axi-check-box-outline-blank' ></i></span>&nbsp;&nbsp;"+json[i].lastStaName+"("+json[i].cnt+")</div>";

        	srAllcnt+=parseInt(json[i].cnt);
            $("#disStepId_"+json[i].lastSta).html(json[i].cnt+" 건");
            $("#disStepId_"+json[i].lastSta).css("font-weight","600");
            $("#disStepId_"+json[i].lastSta).css("color","red");
        }
        tempContent += "</tbody></table></div>";  
        
        $("#disToDoListCnt").html("<font style='600;color:red;'><strong>("+srAllcnt+")</strong></font>");
        //$("#toDoMainDisCtn").html("<font style='600;color:red;'><strong>("+srAllcnt+")</strong></font>");

        //$("#disTabCnt").val("<font style='600;color:red;'><strong>("+srAllcnt+")</strong></font>");  // hidden에 넣어둔다.
        $("#disToDoList").html(tempContent);
        $("#disToDoList").css("border-bottom , border-right , border-left , width , height","1px solid #B9BABC , 1px solid #B9BABC , px solid #B9BABC , 100% , 210px;");
    }
    
    function subListLayoutSet(target, lastSta, workGbn){ 
       $(target).css("border","3px solid #C91F37");
       $(target).css("border-radius","10px");
       $(target).css("height","100%");
       $(target).css("width","100%");
       $(target).html("<div id='mainSubListView'></div>");
       
       if(workGbn=="SR"){
    	   setTimeout("getSrSummarySubList("+lastSta+", '#mainSubListView')", "100");   
    	   srMainSubListIconChange(lastSta);
       }else if(workGbn=="DIS"){
    	   setTimeout("getDisSummarySubList("+lastSta+", '#mainSubListView')", "100");
    	   disMainSubListIconChange(lastSta);
       } 
    }
    
    function getSrSummarySubList(lastSta, target){ 
        $("#subListTarget").val(target);
        
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.selectSrGroupList";
        var pars = "lastSta="+lastSta + "&sqlGbn="+sqlId;
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
                srSummarySubListMaker(res.tree);
            }else{
                //console.log("실패입니다.");
            }
        }, onerr:null});
    }
    
    function srSummarySubListMaker(json){
        var tempContent ="<div style='padding-left:10px;'>";
        var target = $("#subListTarget").val();
        for(var i=0;i<json.length;i++){
			tempContent+="<div onClick=\"goToSrPage('"+json[i].srNo+"');\"   onMouseOver='this.style.background=\"#969696\";this.style.color=\"#efefef\";' onMouseOut='this.style.background=\"#ffffff\";this.style.color=\"#969696\";'  style='height:30px;border-bottom:1px solid #969696;text-vertical:bottom;padding:5px;width:98%;'><i class='fa fa-arrow-circle-o-right'></i>&nbsp;"+json[i].lastStaName+" </div>";
        }
        tempContent+="</div>";
        $(target).html(tempContent);
    }
    
    function srMainSubListIconChange(index){
        var icon =$("[id^=mainSrIcon]");
        var srSelect =$("[id^=mainSrSelect]");
        for (i = 0; i < icon.length; i++) {
            $(icon[i]).html("<i class='fa fa-square-o'></i>");
            $(srSelect[i]).css("background","#ffffff");
        }
        $("#mainSrIcon"+index).html("<i class='fa fa-check-square-o'></i>");
        $("#mainSrSelect"+index).css("background","#efefef");
    }
    
    function goToSrPage(srNo){
		CmmUtil.popUpUrl($("#srTodoDetailUrl").val(), {"srno":srNo}, "1090");
    }
    
    function getDisSummarySubList(lastSta,target){
        $("#subListTarget").val(target);
        
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.selectDisGroupList";
        var pars = "lastSta="+lastSta + "&sqlGbn="+sqlId;
         
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
                disSummarySubListMaker(res.tree);
            }else{
                //console.log("실패입니다.");
            }
        }, onerr:null});
    }
    
    function disSummarySubListMaker(json){
        var tempContent ="<div style='padding-left:10px;'>";
        var target = $("#subListTarget").val();
        for(var i=0;i<json.length;i++){
			tempContent+="<div onClick=\"goToDisPage('"+json[i].srNo+"','"+json[i].jobCd+"');\" onMouseOver='this.style.background=\"#969696\";this.style.color=\"#efefef\";' onMouseOut='this.style.background=\"#ffffff\";this.style.color=\"#969696\";'  style='height:30px;border-bottom:1px solid #969696;text-vertical:bottom;padding:5px;width:98%;'><i class='fa fa-arrow-circle-o-right'></i>&nbsp;"+json[i].lastStaName+" </div>";
        } 
        tempContent+="</div>";
        
        $(target).html(tempContent);
    }
    
    function disMainSubListIconChange(index){
        var icon =$("[id^=mainDisIcon]");
        var srSelect =$("[id^=mainDisSelect]");
        for (i = 0; i < icon.length; i++) {
            $(icon[i]).html("<i class='fa fa-square-o'></i>");
            $(srSelect[i]).css("background","#ffffff");
        }
        $("#mainDisIcon"+index).html("<i class='fa fa-check-square-o'></i>");
        $("#mainDisSelect"+index).css("background","#efefef");
    }
    
    function goToDisPage(srNo,jobCd){ 
        if(srNo!=null && srNo !=""){ 
        	//console.log("---------- srNo!=null && srNo !='' -----------11");
        	setTimeout("$(document).scrollTop(AXUtil.scrollHeight())","900");
    		CmmUtil.popUpUrl($("#disTodoDetailUrl_Nosrno").val(), {"disNo":srNo}, "940");
        	
        }else{ 
        	//console.log("---------- srNo not null -----------22"); 
    		CmmUtil.popUpUrl($("#disTodoDetailUrl_srno").val(), {"srNo":srNo,"jobCd":jobCd}, "940");
        }
    }
 
	//--------------------------------
	// S/R 할일목록 - 진행단계 도형 그리기
	//--------------------------------
	function getSrToDoStepView() {
		// S/R 할일목록 - 진행단계 도형 그리기
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "CodeServiceDAO.getCodeGenDetailList";
        var pars = "codeid=SRSTAT&sqlGbn="+sqlId;
         
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
            	showSrToDoProcessMaker(res.tree);
            }else{
                //console.log("실패입니다.");
            }
        }, onerr:null}); 

    	// 배표 할일목록 - 진행단계 도형 그리기
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "CodeServiceDAO.getCodeGenDetailList";
        var pars = "codeid=DSSTAT&pageEnd=100&sqlGbn="+sqlId;
         
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
            	showDisToDoProcessMaker(res.tree);
            }else{
                //console.log("실패입니다.");
            }
        }, onerr:null}); 
	}
	
	function showSrToDoProcessMaker(json) {
		var iconList = {
				"100":"glyphicon glyphicon-edit",	// S/R 등록
				"110":"glyphicon glyphicon-edit",	// 서비스요청검토
				"130":"glyphicon glyphicon-edit",	// 개발검토
				"140":"glyphicon glyphicon-edit",	// DB핸들링검토
				"150":"glyphicon glyphicon-edit",	// DB핸들링 결과 등록
				"160":"glyphicon glyphicon-edit",	// 개발진행검토
				"170":"glyphicon glyphicon-edit",	// 최종개발검토
				"180":"glyphicon glyphicon-edit",	// 답변등록
				"000":"glyphicon glyphicon-edit",	// 처리완료
		};
		var circleCnt = json.length;
		var startColor = Math.round(180/circleCnt);
		var tempContent = "<div style='display:table;vertical-align:middle;padding:70px;'><div style='display:table-row;width:100%;height:100%;'>";
		var stepArrow = "<div style='display:table-cell;width:40px;height:100px;padding-left:4px;vertical-align:middle;'><div style='width:30px;height:30px;border-radius:30px;border:3px solid #ECF0F1 ;display:table-cell;text-align:center;vertical-align:middle;background:#BDC3C7;color:#F2F1EF;'><i class='glyphicon glyphicon-forward'></i></div></div>"; 

		for(var i=0; i<circleCnt; i++){
			//console.log("json "+i+" : " + JSON.stringify(json[i]));
			if(json[i].detailcode != "000") {
				if(i != 0) {
					tempContent += stepArrow;
				}
				tempContent += "<div style='display:table-cell;border-radius:50px;width:100px;height:100px;cursor:pointer;background:rgb("+(230-(i*startColor))+","+(230-(i*startColor))+","+(230-(i*startColor))+");text-align:center;vertical-align:middle;border:3px solid #ABB7B7; text-shadow:-1px 0px #5D8CAE,1px 0px #5D8CAE,0px -1px #5D8CAE,0px 1px #5D8CAE;color:#fff' onclick='workDetailListSeq("+json[i].detailcode+",\"SR\");'>"+json[i].detailnm+"<div id='srStepId_"+json[i].detailcode+"'>0 건</div></div>";
			}
		}

		tempContent += stepArrow;
		tempContent += "<div style='display:table-cell;border-radius:50px;width:100px;height:100px;background:rgb(50,50,50);text-align:center;vertical-align:middle;border:3px solid #ABB7B7; text-shadow:-1px 0px #5D8CAE,1px 0px #5D8CAE,0px -1px #5D8CAE,0px 1px #5D8CAE;color:#fff'>처리완료</div></div></div>";
 
		$("#SR_ToDoStepView").html(tempContent);
		getSrToDoList();
	}
 
	function showDisToDoProcessMaker(json) {
		var iconList = {
				"100":"glyphicon glyphicon-edit",	//배포요청
				"110":"glyphicon glyphicon-edit",	//테스트적용 팀장검토
				"120":"glyphicon glyphicon-edit",	//테스트적용 검토     
				"130":"glyphicon glyphicon-edit",	//테스트적용 결과확인 
				"140":"glyphicon glyphicon-edit",	//시험배포 팀장검토   
				"150":"glyphicon glyphicon-edit",	//품질검토 요청       
				"160":"glyphicon glyphicon-edit",	//품질검토            
				"170":"glyphicon glyphicon-edit",	//시험배포 최종검토   
				"180":"glyphicon glyphicon-edit",	//시험배포 적용검토   
				"190":"glyphicon glyphicon-edit",	//시험배포 결과 확인  
				"200":"glyphicon glyphicon-edit",	//최종배포 팀장검토   
				"210":"glyphicon glyphicon-edit",	//최종배포 적용 검토  
				"220":"glyphicon glyphicon-edit",	//최종배포 결과확인   
				"230":"glyphicon glyphicon-edit",	//배포 종료           
		};
		
		var circleCnt = json.length; 
		var startColor = Math.round( (210/circleCnt)/1.5); 
		
		var tempContent = "<div style='display:table;vertical-align:middle;padding:10px 10px 10px 70px;'><div style='display:table-row;width:100%;height:100%;'>";
		var stepArrow = "<div style='display:table-cell;width:40px;height:100px;padding-left:4px;vertical-align:middle;'><div style='width:30px;height:30px;border-radius:30px;border:3px solid #D9DCDC ;display:table-cell;text-align:center;vertical-align:middle;background:#BDC3C7;color:#F2F1EF;'><i class='glyphicon glyphicon-forward'></i></div></div>"; 

		for(var i=0; i<circleCnt; i++){
			//console.log("json "+i+" : " + JSON.stringify(json[i]));
			var stepName = json[i].detailnm;
			if(i != 0) {
				tempContent += stepArrow;
			} 
			if(i == 9) {tempContent += "</div>&nbsp;<div style='display:table-row;width:100%;height:100%;padding-top:10px;border:1px solid red;'>"}
			if(stepName.length >= 9) {
				stepName = stepName.replace(" ","<br>")
			}
			
			var cntView = "<div id='disStepId_"+json[i].detailcode+"'>0 건</div>";
			if(json[i].detailcode == "230") {
				cntView = "";
			}
			tempContent += "<div style='display:table-cell;border-radius:50px;width:100px;height:100px;cursor:pointer;background:rgb("+(230-((i*startColor)*1.3))+","+(230-(i*startColor))+","+(230-(i*startColor))+");text-align:center;vertical-align:middle;border:3px solid #98AAAA; text-shadow:-1px 0px #044F67   ,1px 0px #044F67   ,0px -1px #044F67   ,0px 1px #044F67   ;color:#fff' onclick='workDetailListSeq("+json[i].detailcode+",\"DIS\");'>"+stepName+cntView+"</div>";
			
		} 
		//tempContent += "</div></div>";
		
		$("#DIS_ToDoStepView").html(tempContent);
		getSrToDoList();
	}
    
    function workCountCheck(obj, workGbn){
        var cnt = "";
        
        if(workGbn=="SR"){
            cnt = ($("#srStepId_"+obj).html()).trim();
        }else if(workGbn=="DIS"){
            cnt = ($("#disStepId_"+obj).html()).trim();
        }
        
        if(cnt ==" " ||cnt =="" || cnt=="0 건"|| cnt==null){
            gfnDialog('<b>알림</b>\n 선택하신 항목은 대상 데이터가 조회되지 않습니다!');
            return false;
        }
        
        return true;
    }
    
    //그림에서 바로 클릭할경우 에러가 발생하여 지연을 두고 호출한다.
    function workDetailListSeq(index, workGbn){
    	if(workCountCheck(index, workGbn)){
        	$("#toDoList").show();
        	$("#toDoStepView").hide();
        	
        	if(workGbn=="SR"){
        		subListLayoutSet("#disMainSubList", index, workGbn);
        		
        		//setTimeout("srMainSubListIconChange("+index+");","100");
        		//getSrSummarryList();
        		//getSrSummarySubList(index,"#mainSubListView");
        		
        	}else{
        		subListLayoutSet("#srMainSubList", index, workGbn);
        		
        		//setTimeout("disMainSubListIconChange("+index+");","100");
        		//getDisSummarryList();
        		//getDisSummarySubList(index,"#mainSubListView");
        	}
    	} 
    }
    
	//--------------------------------
	// 사업진행 Issue
	//--------------------------------
	function getIssueList(){ 
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.issueList";
        var pars = "sqlGbn="+sqlId; 
	    new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
	    	var list = res.tree;
	    	var content ="";
 
	    	if(list.length==0){ 
	    	} else {
	    		content = "<table class='table table-hover' style='margin-bottom:0px;'><thead><tr><th width='45%'><i class='fa fa-bullseye'></i> 대상요구사항</th><th width='25%'><i class='fa fa-pencil-square-o'></i> 이슈명</th><th width='15%'><i class='fa fa-level-up'></i> 중요도</th><th width='15%'><i class='fa fa-play-circle-o'></i> 진행상태</th></tr></thead><tbody>";
	    		
	        	for(var i=0;i<list.length;i++){
	        		content += "<tr onClick='goIssueDetailModal(\""+list[i].issuesSno+"\")'>";
	        		content += "<td>[ " + list[i].businessIdName + " ] " + list[i].reName + "</td><td>"+list[i].issuesTitle + "</td><td>" + list[i].issuesSeveralNm + "</td><td>" + list[i].issuesStatusNm + "</td>";
	        		content += "</tr>"; 
	        	}
	        	
	        	content+="</tbody></table>";
	        	
	        	$("#issueList").html(content);
	    	}
	    		    	
	    	if(list.length>3){
	    		//alert("3");
	            $("#issueList").css("overflow-y","scroll");
	        }
	    	
	    }, onerr:null});
	}
	//--------------------------------
	
	// 사업진행 Issue - 상세보기 팝업
    function goIssueDetailModal(id){ 
    	CmmUtil.popUpUrl($("#issueDetailUrl").val(), {"issuesSno":id}, "1000");
    }

	// WBS 진척률
    function getWbsProgressRate(){
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.projectProgress";
        var pars = "sqlGbn="+sqlId;
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
            	wbsProgressRateViewMaker(res.tree);
            }else{
                //console.log("실패입니다.");
            }
        }, onerr:null});
    }
	
    function wbsProgressRateViewMaker(json){
    	var lineContent ="";

    	if((AXUtil.clientWidth())>1650){
	    	if(json.length>10){
	    		lineContent+="<div style='vertical-align:top;width:99%;height:320px;padding:5px;overFlow-y:scroll;'>"; 
	    	}else{
	    		lineContent+="<div style='vertical-align:top;width:99%;padding:5px;'>";
	    	}
    	}else{
	    	if(json.length>8){
	    		lineContent+="<div style='vertical-align:top;width:99%;height:320px;padding:5px;overFlow-y:scroll;'>"; 
	    	}else{
	    		lineContent+="<div style='vertical-align:top;width:99%;padding:5px;'>";
	    	}
    	}
       	 
    	for(var i=0; i < json.length;i++){
    		var name = json[i].name+"";
    		if(name.length>12){
    			name=json[i].name.substring(0,10)+"...";
    		}
    		
    		// #ff6633 // 주황         			##99cccc // 초록         			#969696 // 시작
			var progressColor ="#969696";
    		
    		if(parseInt(json[i].avg) < 30){
    			progressColor ="#969696";
    		}else if( parseInt(json[i].avg) >= 30 && parseInt(json[i].avg) < 80 ){
    			progressColor ="#ff6633";
    		}else if(parseInt(json[i].avg)  >= 80 && parseInt(json[i].avg) < 100){
    			progressColor ="#99cccc";
    		}else if(parseInt(json[i].avg) == 100){
    			progressColor ="#BF55EC";
    		}
    		
    		var dDay =((json[i].endDate).date()).diff(getToday().date()) ;
    		
    		var comment ="";
    		var fontColor ="black;";
    		
    		if( (dDay > -3  && dDay <= 0 ) && parseInt(json[i].progress) != 100){
    			//progressColor = "#ff0080";
    			comment =" ["+dDay+"일 후 종료]";
    			fontColor="red;font-weight:400;";
    		}else if(dDay > 0 && parseInt(json[i].progress) != 100){
    			//progressColor = "#ff0080";
    			comment =" ["+dDay+"일 초과]";
    			fontColor="red;font-weight:400;";
    		}
    		
    		var psNamealign ="right";
    		if((AXUtil.clientWidth())<1650){
    			var psNamealign ="left";
    		}
    		lineContent+="<div style='margin-bottom:5px;' onClick='getWbsProgressRateDetail(\""+json[i].projectid+"\");'  onMouseOver='this.style.background=\"#f2f9f9\";this.style.cursor=\"pointer\"' onMouseOut='this.style.background=\"#ffffff\";'>";
    		lineContent+="     <div id='barAlign"+i+"' style='display:inline-block;width:150px;text-align:"+psNamealign+";' onMouseOver='titleComment(\""+json[i].name+"\")' >"+name+"&nbsp;</div>";  // 제목
    		lineContent+="     <div style='border:1px solid #efefef;background:#efefef;border-radius:3px;display:inline-block;vertical-align:middle;width:500px;height:25px;text-align:left;'>";
    		lineContent+="         <div style='position:relative;top:0px;left:0px;width:100%;height:100%;z-index:2;text-align:center;padding-top:7px;color:"+fontColor+";'>"+json[i].avg+"%"+comment+"</div>";
    		lineContent+="         <div style='position:relative;top:-23px;left:0px;border-radius:3px;background:"+progressColor+";width:"+json[i].avg+"%;height:100%;z-index:1;' id='progressbar"+i+"'></div>";
    		lineContent+="     </div>";
    		lineContent+="</div>"; 
    	}
    	
    	lineContent+="</div>";

    	if(json.length>10){
    		$("#wbsProgressRate").css("height","320px");
    	}
    	$("#wbsProgressRate").html(lineContent);

    	for(var j=0; j < json.length;j++){
    		//progressAction("#progressbar"+j, json[j].avg , 0);
    	}
 
    	if(json.length>0){
    		getWbsProgressRateDetail(json[0].projectid);
    	}
    } 
    
    function getWbsProgressRateDetail(id){
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "ProjScServiceDAO.projectTaskList";
        var pars = "taskId=" + id + "&sqlGbn=" + sqlId;
         
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
            	wbsProgressRateDetailViewMaker(res.tree);
            }else{
                //console.log("실패입니다.");
            }
        }, onerr:null}); 
    }
    
    function wbsProgressRateDetailViewMaker(json){ 
    	var tempContent ="";
    	
    	if((AXUtil.clientWidth())>1650){
    		if(json.length>10){
	       		tempContent+="<div style='height:320px;overFlow-y:scroll;padding:5px;'>"; 
	       	}else{
	       		tempContent+="<div style='padding:5px;'>"
	       	}
       	}else{
       		if(json.length>8){
        		 tempContent+="<div style='height:320px;overFlow-y:scroll;padding:5px;'>"; 
        	}else{
        		 tempContent+="<div style='padding:5px;'>"
        	}
       	}
    	 
    	for(var i=0; i<json.length;i++){
    		var name = json[i].name+"";
    		if(name.length>12){
    			name=json[i].name.substring(0,10)+"...";
    		}
    		
    		// #ff6633 // 주황         			##99cccc // 초록         			#969696 // 시작
			var progressColor ="#969696";
    		
			if(parseInt(json[i].progress) < 30){
    			progressColor ="#969696";
			}else if(parseInt(json[i].progress) >= 30 && parseInt(json[i].progress) < 80  ){
    			progressColor ="#ffcc99";
    		}else if(parseInt(json[i].progress) >= 80 && parseInt(json[i].progress) < 100){
    			progressColor ="#99cccc";
    		}else if(parseInt(json[i].progress) == 100){
    			progressColor ="#d7d7ff";
    		}
    		
    		var dDay =((json[i].endtime).date()).diff(getToday().date()) ;
    		
    		var comment ="";
    		var fontColor ="black;";
    		
    		if( (dDay > -3  && dDay <= 0 ) && parseInt(json[i].progress) != 100){
    			//progressColor = "#ff0080";
    			comment =" ["+dDay+"일 후 종료]";
    			fontColor="red;font-weight:400;";
    		}else if(dDay > 0 && parseInt(json[i].progress) != 100){
    			//progressColor = "#ff0080";
    			comment =" ["+dDay+"일 초과]";
    			fontColor="red;font-weight:400;";
    		}
    		 
    		var psNamealign ="right";
    		if((AXUtil.clientWidth())<1650){
    			var psNamealign ="left";
    		}
    		
    		tempContent+="<div style='margin-bottom:5px;' >";
    		tempContent+="     <div style='display:inline-block;width:150px;font-size:12px;text-align:"+psNamealign+";'>"+name+"&nbsp;</div>";  // 제목
    		tempContent+="     <div style='border:1px solid #efefef;background:#efefef;border-radius:3px;display:inline-block;vertical-align:middle;width:480px;height:25px;text-align:left;'>";
    		tempContent+="         <div style='position:relative;top:0px;left:0px;width:100%;height:100%;font-size:12px;z-index:2;text-align:center;padding-top:7px;color:"+fontColor+"'>"+json[i].progress+"%"+comment+"</div>";
    		tempContent+="         <div style='position:relative;top:-23px;left:0px;border-radius:3px;background:"+progressColor+";width:%;height:100%;z-index:1;' id='taskProgressbar"+i+"'></div>";
    		tempContent+="     </div>";
    		tempContent+="</div>";
    	}
    	
    	tempContent+="</div>"
    	
    	$("#wbsProgressRateDetail").html(tempContent);
    	
    	for(var j=0; j < json.length;j++){
    		progressAction("#taskProgressbar"+j, json[j].progress , 0);
    	} 
    }
    
    function titleComment(content){
    	//alert(content.length);
		if(content.length>12){
        	AXPopOver.close({id:"titlePop"});
        	
        	AXPopOver.setConfig({responsiveMobile:640}); /* mobile modal 모달 적용 너비 지정 지정하지 않으면 모바일 모드가 작동 되지 않습니다. */
            AXPopOver.bind({
                id:"titlePop",
                theme:"AXPopOverTooltip", // 선택항목
                width:"300", // 선택항목
                body:content
            });
            AXPopOver.open({id:"titlePop", sendObj:{}}, event);
        }
	}
    
	//set my schedule date 
	function weekSchdContentSet(date){
		//console.log("weekSchdContentSet >>> date : " + date);
		var weekSchdTag = "<div class='form-control' id='task_" + date + "' style='text-align:left;height:100px;font-size:12px;'>";
		var weekSchdContent = "";
			
		weekSchdTag = weekSchdTag + weekSchdContent + "</div>";
		return weekSchdTag;
	}  
	
    function getScheduleSummary(){
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.selectScGroup";
        var pars = "sqlGbn="+sqlId;
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){  
                scSummaryViewMaker(res.tree);
                
            }else{
                //console.log("실패입니다.");
            }
        }, onerr:null});
    }
    
    function scSummaryViewMaker(json){
        var htmlContent ="";
        var cntCheck = 0;
        date = new Date();
        
    	//console.log("date.getDay = "+date.getDay());
    	date.setDate(date.getDate()-date.getDay());	
 
        for(var i =0;i<json.length;i++){ 
		//for(let i = 0 ; i < 1 ; i++){
			if(i==0) {
				let cloneDate = new Date(date);
				cloneDate.setDate(cloneDate.getDate()+7);
				//cloneDate.getFullYear()+"-"+editMonth(new String(cloneDate.getMonth()+1))+"-"+editDay(new String(cloneDate.getDate()));
				var weekSchdTitle = cloneDate.getFullYear()+"-"+editMonth(new String(cloneDate.getMonth()+1))+"-"+editDay(new String(cloneDate.getDate()))+'('+daysKo[i]+')';
				var weekSchdContent = weekSchdContentSet(cloneDate.getFullYear()+"-"+editMonth(new String(cloneDate.getMonth()+1))+"-"+editDay(new String(cloneDate.getDate())));
				//document.getElementById("div"+days[cloneDate.getDay()]).innerHTML = "";
				document.getElementById("div"+days[cloneDate.getDay()]).innerHTML = weekSchdTitle;
				//document.getElementById("div"+days[cloneDate.getDay()]).insertAdjacentHTML('afterend', weekSchdContent);
				
				//console.log(cloneDate.getDate()+"//"+date.getDate());
				$("#div"+days[cloneDate.getDay()]).html(weekSchdTitle);
				$("#div"+days[cloneDate.getDay()]+"_schedule").empty();
				$("#div"+days[cloneDate.getDay()]+"_schedule").append(weekSchdContent);
				//console.log("weekSchdContent "+i+" : " + weekSchdContent);
				
			} else{
				var weekSchdTitle = date.getFullYear()+"-"+editMonth(new String(date.getMonth()+1))+"-"+editDay(new String(date.getDate()))+'('+daysKo[i]+')';
				var weekSchdContent = weekSchdContentSet(date.getFullYear()+"-"+editMonth(new String(date.getMonth()+1))+"-"+editDay(new String(date.getDate())));
				//document.getElementById("div"+days[date.getDay()]).innerHTML = "";
				//document.getElementById("div"+days[date.getDay()]).innerHTML = weekSchdTitle
				//document.getElementById("div"+days[date.getDay()]).insertAdjacentHTML('afterend', weekSchdContent);
				/* "<div class='divSchedule' style='text-align:left;padding:3px 0 0 3px;height:80%'> <ul><li>내용2</li></ul></div>" */
				 
				$("#div"+days[date.getDay()]).html(weekSchdTitle);
				$("#div"+days[date.getDay()]+"_schedule").empty();
				$("#div"+days[date.getDay()]+"_schedule").append(weekSchdContent);
				//console.log("weekSchdContent "+i+" : " + weekSchdContent);
			}
			date.setDate(date.getDate()+1);
        }
        
        for(var i =0;i<json.length;i++){ 
            if(json[i].cnt>0){
                sbSummarySublistMaker(json[i].lastSta, (getToday()==json[i].lastSta)  );
            }
        }
    }
    
    function sbSummarySublistMaker(lastSta, todayGbn){ 
        // 날짜별 데이터를 가져온다. 
		var url = "/dsdsm/main/getCmmJsonList.json";
		var sqlId = "MainView.selectScGroupList"; 
        var pars = "sqlGbn="+sqlId + "&today="+lastSta;
        new AXReq(url, {debug:false, pars:pars, onsucc:function(res){
            if(res.result == "ok"){
                var sublist = res.tree;
                var tempStr ="";
 
                for(var j=0;j<sublist.length;j++){ 
                    if(todayGbn){
                        tempStr  +="<div id=scList"+sublist.length+" style='width:99%;' onMouseOver='this.style.background=\"#efef55\";'   onMouseOut='this.style.background=\"#ffffff\";'  onClick='scSummaryModal(\""+sublist[j].srNo+"\");'><i class='axi axi-bmg-value-fit'></i> ["+sublist[j].lastStaName+"] </div>";
                    }else{
                        tempStr  +="<div id=scList"+sublist.length+" style='width:99%;' onMouseOver='this.style.background=\"#c8c8c8\";'   onMouseOut='this.style.background=\"#ffffff\";'  onClick='scSummaryModal(\""+sublist[j].srNo+"\");'><i class='axi axi-bmg-value-fit'></i> ["+sublist[j].lastStaName+"] </div>";
                    } 
                }
                //console.log("tempStr : " + tempStr);
                //console.log("-------------------------------->>> task_" + lastSta);
                document.getElementById("task_"+lastSta).innerHTML = "";
                //$("#task_"+lastSta).remove();
                if(sublist.length<6){
                    document.getElementById("task_"+lastSta).innerHTML=tempStr;
                }else{
                    document.getElementById("task_"+lastSta).innerHTML=tempStr;
                    $("#task_"+lastSta).css("overflow-y","scroll");
                }
                
            }else{
                console.log("실패입니다.");
            }
        }, onerr:null});
        
        // 날짜별 데이터를 가져온다.END
    }
    
    // 주간일정 - 상세보기 팝업
    function scSummaryModal(srNo){ 
		CmmUtil.popUpUrl($("#scheduleDetailUrl").val(), {"schduleid":srNo}, "600");
    }

    function getToday() { // 오늘 날짜를 구한다.
        var sDay  = new Date();
        var Year  = sDay.getFullYear();
        var Month = sDay.getMonth()+1;
        var Day   = sDay.getDate();
        
        if(Month<10){
            Month="0"+Month; 
         }
        
        if(Day<10){
        	Day="0"+Day; 
         }
        var ToDay = Year +"-"+ Month +"-"+ Day;
        return ToDay;
    }
    
 	window.onload = function(){ 
		var rolesPermissions = "${permission}";
		var rolesPermission  =rolesPermissions.split("|");
		
		for(var i=0;i<rolesPermission.length;i++) { 
			//Dashboard의 Bar Chart를 드로잉 한다.
			if(rolesPermission[i].indexOf("DASHB")>-1){
				// Dashboard
				$("#Dashboard").show();
				dashChart.view();
			}
			
			// 공지사항의 DB를 가져온다.
            if(rolesPermission[i].indexOf("NT")>-1){ 
				$("#Notice").show(); 
				
				// 공지사항 
				getNoticeList();
				
				// 1 주일이상 접수 후 미처리 목록
				getSrListExceedData();
			}
			
			// S/R 할일목록 / 배포 할일목록
			if(rolesPermission[i].indexOf("SR")>-1){
				if((AXUtil.clientWidth())<1650){
					// S/R 할일목록 / 배포 할일목록 - List
					getSrToDoList();
					$("#toDoList").show();
					$("#toDoStepView").hide();
				} else { 
					// S/R 할일목록 / 배포 할일목록 - 진행단계 도형 그리기
					getSrToDoStepView();
					$("#toDoList").hide();
					$("#toDoStepView").show();
				}
			}

			// 사업진행 Issue
            if(rolesPermission[i].indexOf("ISSUE")>-1){
            	// 사업진행 Issue
				$("#Issue").show();
        		getIssueList(); 
            }
			
    		// 프로젝트 진행현황을 가져온다.
            if(rolesPermission[i].indexOf("PBAR")>-1){ 
        		// WBS 진척률
				$("#WbsProgress").show();
        		getWbsProgressRate();
            }
    		
			// 스케쥴이 DB내용을 가져온다.
            if(rolesPermission[i].indexOf("SC")>-1){
        		// 주간일정
				$("#Schedule").show();
        		getScheduleSummary();
        		
        		// 오늘날짜에 하이라이트
        		$("#div"+days[new Date().getDay()]).parent().addClass("has-warning"); 
            }
		}
	}
 	
 	// 리스트에서 진행상태 도형으로 전환
 	function changeSrToDoStepView(gubun) { 
    	getSrToDoStepView();
    	$("#toDoStepView").show();
    	$("#toDoList").hide(); 
 	} 
 	// 창크기 감지
 	$(window).resize(function(){
    	if((AXUtil.clientWidth())<1650){
        	// S/R 할일목록 / 배포 할일목록 - List
        	getSrToDoList();
        	$("#toDoList").show();
        	$("#toDoStepView").hide();
    	} else { 
        	// S/R 할일목록 / 배포 할일목록 - 진행단계 도형 그리기
        	getSrToDoStepView();
        	$("#toDoStepView").show();
        	$("#toDoList").hide();
    	}
 	});
</script>
<body>

	
	
	<div class="panel panel-default">
		<div class="panel-heading">
			<h3 class="panel-title">
				<a class="toggle-sidebar" href="javascript:void(0);"><span title="Maximize Panel" class="fa fa-angle-double-left" data-toggle="offcanvas"></span></a>
				<strong>Portal</strong>
			</h3>
		</div>
		<div class="panel-body">
	
			<!-- Dashboard Start...!!! -->
			<div id="Dashboard" style="display:none;">  
				<div class="panel panel-default">
					<div class="panel-heading">
						<h3 class="panel-title"><i class="fa fa-pie-chart"></i>&nbsp;Dashboard</h3> 
					</div>
					<div class="panel-body">
						<div style="display:table;width:100%;">
							<div style="display:table-row;">
								<div id="dashCahrt01" style="display:table-cell;width:33%;border:1px solid #efefef;"></div> 
								<div id="dashCahrt02" style="display:table-cell;width:34%;border:1px solid #efefef;padding:0 10px 0 10px;"></div> 
								<div id="dashCahrt03" style="display:table-cell;width:33%;border:1px solid #efefef;"></div> 
							</div>		  
						</div>   
					</div>
				</div>				
			</div> 		
			<!-- Dashboard End...!!! -->
						
			<!-- 공지사항 / 접수 후 장기 미처리 목록- 1주일 이상 Start...!!! -->
			<div id="Notice" style="display:none;">  
				<div style="display:table;width:100%;">
					<div style="display:table-row;">
						<!-- 공지사항 Start...!!! -->
						<input type="hidden" id="noticeDetailUrl" name="noticeDetailUrl" value="<c:url value='/notice/noticeView.do'/>"/>
						<div style="display:table-cell;width:47%">  
							<div class="panel panel-default">
								<div class="panel-heading">
									<h3 class="panel-title"><i class="fa fa-volume-up"></i>&nbsp;공지사항
										<span style="float:right;">
											<a href="javascript:getNoticeList();"><i class="fa fa-repeat"></i></a>&nbsp;
											<a href="javascript:fcObj.menuMove('0060010000000','/dsdsm/notice/noticeList.do');"><i class="fa fa-external-link-square"></i></a>
										</span>
									</h3>
								</div>
								<div class="panel-body">
									<div id="noticeList">공지사항</div> 
								</div>
							</div>				
						</div> 	  
						<!-- 공지사항 End...!!! -->
						<!-- 접수 후 장기 미처리 목록- 1주일 이상 Start...!!! -->
						<input type="hidden" id="ltupDetailUrl" name="ltupDetailUrl" value="<c:url value='/sr/srView.do'/>"/>
						<div style="display:table-cell;width:48%;padding:0 0 0 10px;">
							<div class="panel panel-default">
								<div class="panel-heading">
									<h3 class="panel-title"><i class="fa fa-volume-up"></i>&nbsp;접수 후 장기 미처리 목록 - 1주일 이상&nbsp;<span id='srListExceedCnt'></span>
										<span style="float:right;"><a href="javascript:getSrListExceedData();"><i class="fa fa-repeat"></i></a></span>
									</h3>
								</div>
								<div class="panel-body">
									<div id="ltUnprocessedList" style="overFlow-y:scroll;">접수 후 장기 미처리 목록 - 1주일 이상</div> 
								</div>
							</div>				
						</div> 		
						<!-- 접수 후 장기 미처리 목록- 1주일 이상 End...!!! -->		
					</div> 				
				</div> 				
			</div> 		
			<!-- 공지사항 / 접수 후 장기 미처리 목록- 1주일 이상 End...!!! -->
			
			<!-- S/R 할일목록 / 배포 할일목록 Start...!!! -->
		    <input type="hidden" id="todayTask" >
		    <input type="hidden" id="srTabCnt" >
		    <input type="hidden" id="disTabCnt" >
		    <input type="hidden" id="subListTarget" >
			<div id="toDoList" style="display:none;">
				<div style="display:table;width:100%;">
					<div style="display:table-row;">
						<!-- S/R 할일목록 Start...!!! --> 
						<input type="hidden" id="srTodoDetailUrl" name="srTodoDetailUrl" value="<c:url value='/sr/srView.do'/>"/>
						<div style="display:table-cell;width:47%;">  
							<div class="panel panel-default">
								<div class="panel-heading" onClick='getSrToDoList();'>
									<h3 class="panel-title"><i class="fa fa-clipboard"></i>&nbsp;S/R 할일목록&nbsp;<span id='srToDoListCnt'></span>
										<span style="float:right;">
											<a href="javascript:changeSrToDoStepView('SR');"><i class="fa fa-exchange"></i></a>
										</span>
									</h3>
								</div>
								<div class="panel-body">
									<div id="srToDoList" style="height:200px;">S/R 할일목록</div> 
								</div>
							</div>				
						</div> 	  
						<!-- S/R 할일목록 End...!!! -->
						<!-- 배포 할일목록 Start...!!! --> 
						<input type="hidden" id="disTodoDetailUrl_Nosrno" name="disTodoDetailUrl_Nosrno" value="<c:url value='/dis/disView.do'/>"/>
						<input type="hidden" id="disTodoDetailUrl_srno" name="disTodoDetailUrl_srno" value="<c:url value='/dis/disRequest.do'/>"/>
						<div style="display:table-cell;width:48%;padding:0 0 0 10px;">
							<div class="panel panel-default">
								<div class="panel-heading" onClick='getSrToDoList();'>
									<h3 class="panel-title"><i class="fa fa-cloud-download"></i>&nbsp;배포 할일목록&nbsp;<span id='disToDoListCnt'></span>
										<span style="float:right;">
											<a href="javascript:changeSrToDoStepView('DIS');"><i class="fa fa-exchange"></i></a>
										</span>
									</h3>
								</div>
								<div class="panel-body">
									<div id="disToDoList" style="height:200px;">배포 할일목록</div> 
								</div>
							</div>				
						</div> 		
						<!-- 배포 할일목록 End...!!! -->		
					</div> 				
				</div> 				
			</div> 

			<div id="toDoStepView" style="display:none;width:100%;"> 
				<div class="panel" style="height:300px;border:1px solid #efefef;">
					<ul id="myTab1" class="nav nav-tabs nav-justified">
						<li class="active"><a href="#SR_ToDoStepView" data-toggle="tab"><i class="fa fa-clipboard"></i>&nbsp;S/R 할일목록</a></li>
						<li class=""><a href="#DIS_ToDoStepView" data-toggle="tab"><i class="fa fa-cloud-download"></i>&nbsp;배포 할일목록</a></li> 
					</ul>
					<div id="myTabContent" class="tab-content">
						<div class="tab-pane fade active in" id="SR_ToDoStepView" style="width:100%;height:240px;">
							S/R 할일목록
						</div>
						<div class="tab-pane fade" id="DIS_ToDoStepView" style="width:100%;height:240px;">
							배포 할일목록
						</div> 
					</div>
				</div>	 
			</div>
			<!-- S/R 할일목록 / 배포 할일목록 End...!!! -->
					
			<!-- 사업진행 Issue Start...!!! -->
			<div id="Issue" style="display:none;"> 
				<input type="hidden" id="issueDetailUrl" name="issueDetailUrl" value="<c:url value='/issues/issuesView.do'/>"/>
				<div class="panel panel-warning">
					<div class="panel-heading">
						<h3 class="panel-title"><i class="fa fa-warning"></i>&nbsp;사업진행 ISSUE&nbsp;-
						<span style="font-size:10px;">이슈 목록 중 중요도가&nbsp;&nbsp;<span style="color:#DA4453;">(최상/상)</span>인&nbsp;&nbsp;상태 목록</span></h3> 
					</div>
					<div class="panel-body">
						<div id="issueList"></div>
					</div>
				</div>				
			</div> 		
			<!-- 사업진행 Issue End...!!! -->
					
			<!-- WBS 진척률 Start...!!! -->	
			<div id="WbsProgress" style="display:none;"> 
				<div class="panel panel-default">
					<div class="panel-heading">
						<h3 class="panel-title"><i class="fa fa-bar-chart-o"></i>&nbsp;WBS 진척률&nbsp;&nbsp;&nbsp;
						<span style="font-size:10px"><font color="#969696">■:30%미만</font>&nbsp;&nbsp;&nbsp;<font color="#ff6633">■:30%~80%</font>&nbsp;&nbsp;&nbsp;<font color="#99cccc">■:80%~99%</font>&nbsp;&nbsp;&nbsp;<font color="BF55EC">■:완료</font></span></h3> 
					</div>
					<div class="panel-body"> 
						<div style="display:table;width:100%;">
							<div style="display:table-row;">
								<div style="display:table-cell;width:48%;"> 
									<div id="wbsProgressRate"></div>
								</div>
								<div class="form-control" style="display:table-cell;width:48%;height:320px;padding:0 10px 0 10px;">
									<div id="wbsProgressRateDetail" style="width:99%"></div>
								</div>
							</div>		  
						</div>  
					</div>
				</div>	 
			</div>
			<!-- WBS 진척률 End...!!! -->

			<!-- 주간일정 Start...!!! -->
			<input type="hidden" id="scheduleDetailUrl" name="scheduleDetailUrl" value="<c:url value='/schedule/calendarView.do'/>"/> 
			<div id="Schedule" style="display:none;"> 
				<fieldset>
					<div class="panel panel-success">
						<div class="panel-heading">
							<h3 class="panel-title"><i class="fa fa-calendar"></i>&nbsp;주간 일정 
								<span style="float:right;">
									<a href="javascript:getScheduleSummary();"><i class="fa fa-repeat"></i></a>&nbsp;
									<a href="javascript:fcObj.menuMove('0030010000000','/dsdsm/schedule/scList.do');"><i class="fa fa-external-link-square"></i></a>
								</span>
							</h3>
						</div>
						<div class="panel-body" >
							<div style="display:table;width:100%;">
								<div style="display:table-row;">
									<div class="form-group " style="display:table-cell;padding:0 5px 0 5px;">
										<label class="control-label" for="inputSuccess2" id="divMon">Input with success</label>
										<div id="divMon_schedule"></div>
									</div>
									
									<div class="form-group " style="display:table-cell;padding:0 5px 0 5px;">
										<label class="control-label" for="inputSuccess2" id="divTue">Input with success</label>
										<div id="divTue_schedule"></div>
									</div>
									
									<div class="form-group " style="display:table-cell;padding:0 5px 0 5px;">
										<label class="control-label" for="inputSuccess2" id="divWed">Input with success</label>
										<div id="divWed_schedule"></div>
									</div>
									
									<div class="form-group " style="display:table-cell;padding:0 5px 0 5px;">
										<label class="control-label" for="inputSuccess2" id="divThu">Input with success</label>
										<div id="divThu_schedule"></div>
									</div>
									
									<div class="form-group " style="display:table-cell;padding:0 5px 0 5px;">
										<label class="control-label" for="inputSuccess2" id="divFri">Input with success</label>
										<div id="divFri_schedule"></div>
									</div>
									
									<div class="form-group has-success " style="display:table-cell;padding:0 5px 0 5px;">
										<label class="control-label" for="inputSuccess2" id="divSat">Input with success</label>
										<div id="divSat_schedule"></div>
									</div>
									
									<div class="form-group has-error " style="display:table-cell;padding:0 5px 0 5px;">
										<label class="control-label" for="inputSuccess2" id="divSun">Input with success</label>
										<div id="divSun_schedule"></div>
									</div>
								</div>
							</div>
						</div>  
					</div>  
				</fieldset> 
			</div>  
			<!-- 주간일정 End...!!! -->
			
			<div style="display:table;width:100%;">
				<div style="display:table-row;">
					<div style="display:table-cell;width:25%;">
						<div class="panel panel-primary">
							<div class="panel-heading">
								<h3 class="panel-title"><i class="fa fa-check-square-o"></i>&nbsp;근태 현황</h3>
							</div>
							<div class="panel-body">
								<div class="divUl">
									<ul>
										<li><b>연  차 :</b> 0일 </li>
										<li><b>조  퇴 :</b> 0일 </li>
										<li><b>지  각 :</b> 0일 </li>
									</ul> 
								</div>
							</div>
						</div>
					</div>
					<div  style="display: table-cell;width:45%;padding:0 10px 0 10px;">
						<div class="panel panel-primary">
							<div class="panel-heading">
								<h3 class="panel-title"><i class="fa fa-clock-o"></i>&nbsp;오늘의 일정</h3>
							</div>
							<div class="panel-body">
								<div class="divUl">
									<ul>
									
									</ul>
								</div>
							</div>
						</div>
					</div>
					<div  style="display: table-cell;width:25%;">
						<div class="panel panel-primary">
							<div class="panel-heading">
								<h3 class="panel-title"><i class="fa fa-users"></i>&nbsp;우리 부서원 생일</h3>
							</div>
							<div class="panel-body">
								<div class="divUl">
									<ul>
									
									</ul>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
			
			<!-- 우리 부서 일정 Start...!!! -->
			<fieldset class ="field">
				<div class="panel panel-info">
					<div class="panel-heading">
						<h3 class="panel-title"><i class="fa fa-edit"></i>&nbsp;우리 부서 일정</h3>
					</div>
					<div class="panel-body"> 
						<div id="bbsGrid"></div>
					</div>
				</div>
			</fieldset>
			<!-- 우리 부서 일정 Start...!!! -->
			
			</div>			
		</div>
	</div>
</body>
</html>



