function calendarLoad(dataset, loginMemberId) {
    var calendarEl = document.getElementById('calendar');

    var calendar = new FullCalendar.Calendar(
        calendarEl, {

            plugins: ['interaction', 'dayGrid', 'list', 'googleCalendar'],

            selectable: true,

            header: {
                left: 'prev,next today',
                center: 'title',
                right: 'dayGridMonth,listYear'
            },

            displayEventTime: true,

            loading: function (bool) {
                document.getElementById('loading').style.display = bool ? 'block' :
                    'none';
            },

            eventClick: function (e) {
            	$('html, body').animate({
                    scrollTop : $(document).height()
                }, 600)
                $(window).scroll(function(){
                    $(window).scrollTop($(document).height());
                })
                $("#backOver").show();
                $("#eventInfo").show();
                $("#eventInfo > form > ul > li > input").val("");
                $("#eventInfo input.calId").val(e.event.id);
                $("#eventInfo .eventName").val(e.event.title);
                eventInfo(e.event.id);
            },

            dateClick: function (info) {
                $('html, body').animate({
                    scrollTop : $(document).height()
                },600);
                $(window).scroll(function(){
                    $(window).scrollTop($(document).height());
                })
                $("#backOver").show();
                $("#inputEvent").show();
                $("#inputEvent > form > ul > li > input").val("");
                $("#inputEvent .eventStart").val(info.dateStr);
                $("#inputEvent .eventEnd").attr("min", info.dateStr);
                $("#inputEvent .writerId").val(loginMemberId);
            },

            timeZone: 'UTC',
            events: dataset
        });
    calendar.render();
};

function eventInsert(){
    var url = "/inet/calendarInsert.do";
    var param = {
            "sqlId": "CalendarData.CalendarInsertEvent",
            "calTitle": $("#inputEvent .eventName").val(),
            "calDescript": $("#inputEvent .eventDescr").val(),
            "calDt": $("#inputEvent .eventStart").val(),
            "calDtEnd": $("#inputEvent .eventEnd").val(),
            "beginTime": $("#inputEvent .beginTime").val(),
            "endTime": $("#inputEvent .endTime").val(),
            "writerId": $("#inputEvent .writerId").val()
        };
    $.ajax({
        url: url,
        type: "post",
        data: param,
        success: function(){
            $("#inputEvent").hide();
            $(window).off('scroll');
            alert("일정을 등록하였습니다.");
            location.reload();
        },
        error: function(xhr, status, error){
            alert("일정등록에 실패하였습니다. 다시시도해주세요")
        }
    })
}

function eventInfo(ev){
	for(var i = 0; i < dataset.length; i++){
        if(dataset[i].id == ev)
            break;
    }
    $("#eventInfo .eventDescr").val(dataset[i].calDescript);
    $("#eventInfo .eventStart").val(dataset[i].calDt);
    $("#eventInfo .beginTime").val(dataset[i].beginTime);
    $("#eventInfo .eventEnd").val(dataset[i].calDtEnd);
    $("#eventInfo .endTime").val(dataset[i].closeTime);
    $("#eventInfo span.writerId").text(dataset[i].writerId);
}

$(document).ready(function(){
    $("#regClose").click(function(){
        $("#inputEvent").hide();
        $("#backOver").hide();
        $(window).off('scroll');
    })
    $("#modiClose").click(function(){
        $("#eventInfo").hide();
        $("#backOver").hide();
        $(window).off('scroll');
    })
})