function memInfoCall(pageNum, idx){
	var param = {'pageNum' : pageNum, 'sort' : idx};
    $.ajax({
        url: "/inet/allMemberInfo.do",
        type: "post",
        data: param,
        dataType: "json",
        success: function(result){
            var member = result.member;
            var dept = result.dept;
            var auth = result.auth;
            var content='';
            JSON.stringify(member);
            JSON.stringify(dept);
            JSON.stringify(auth);
            for(var i=0; i < member.length; i++){
                content+='<tr>';
                content+='	<td class="memId">'+member[i].memberId+'</td>';
                content+='	<td class="memberName">'+member[i].memberName+'</td>';
                if(member[i].deptName != null)
                	content+='	<td class="deptName">'+member[i].deptName+'</td>';
                else
                	content+='	<td class="deptName">부서 미 배치</td>';
                content+='	<td>';
                content+='		<select class="memDept">';
                content+='			<option value="">선택</option>';
                for(var j=0; j < dept.length; j++){
                	if(member[i].deptId == dept[j].deptId)
                		content+='			<option value="'+dept[j].deptId+'" selected="selected">'+dept[j].deptName+'</option>';
                	else
                		content+='			<option value="'+dept[j].deptId+'">'+dept[j].deptName+'</option>';
                }
                content+='		</select>';
                content+='		<input type="hidden" name="deptId" value="'+ member[i].deptId +'">';
                content+='</td>';
                if(member[i].roleName != null)
                	content+='	<td class="roleName">'+member[i].roleName+'</td>';
                else
                	content+='	<td class="roleName">권한 미 부여</td>';
                content+='	<td>';
                content+='		<select class="memAuth">';
                content+='			<option value="">선택</option>';
                for(j=0; j < auth.length; j++){
                	if(member[i].memberRole == auth[j].roleId)
                		content+='			<option value="'+auth[j].roleId+'" selected="selected">'+auth[j].roleName+'</option>';
                	else
                		content+='			<option value="'+auth[j].roleId+'">'+auth[j].roleName+'</option>';
                }
                content+='		</select>';
                content+='		<input type="hidden" name="memberRole" value="'+ member[i].memberRole +'">';
                content+='	</td>';
                content+='</tr>';
            }
            $("#memIdx").html(content);
            memDeptChange();
            memAuthChange();
        },
        error: function(xhr, status, error){
            alert("실패");
        }
    });
}

function memAuthChange(){
    $(".memAuth").change(function(){
    	var memId = $(this).parent("td").siblings("td.memId").text();
        var memberName = $(this).parent("td").siblings("td.memberName").text();
        var the = $(this);
        var authNm = '권한 미부여';
        if($(this).val() != '')
        	authNm = $(this).children("option[value="+$(this).val()+"]").text();
        
        if(confirm("ID : " + memId +"\n성명 : " + memberName +"\n의 권한을 \""+authNm+"\" (으)로 변경하시겠습니까?")){
            var param = {"memberId" : memId, "memberRole" : $(this).val()};
            $.ajax({
                url: "/inet/memberRole.do",
                type: "post",
                data: param,
                success: function(){
                	if(the.val() == '')
                    	the.parent("td").siblings("td.roleName").text('권한 미 부여');
                    else
                    	the.parent("td").siblings("td.roleName").text(
                    		the.find("option[value="+the.val()+"]").text()
                    	);
                    the.siblings("input[name=memberRole]").val(the.val());
                    alert("변경하였습니다.")
                },
                error: function(xhr, status, error){
                    alert("실패");
                }
            });
        }
        else{
        	if($(this).next("input[name=memberRole]").val() == 'null')
        		$(this).val('').attr("selected", "selected");
        	else
        		$(this).val($(this).next("input[name=memberRole]").val()).attr("selected", "selected");
        }
    })
}

function memDeptChange(){
    $(".memDept").change(function(){
    	var memId = $(this).parent("td").siblings("td.memId").text();
        var memberName = $(this).parent("td").siblings("td.memberName").text();
        var particular = $(this);
        var deptName = '부서 미 배치';
        if($(this).val() != '')
        	deptName = $(this).children("option[value="+$(this).val()+"]").text();
        
        if(confirm("ID : " + memId +"\n성명 : " + memberName +"\n의 권한을 \""+deptName+"\" (으)로 변경하시겠습니까?")){
            var param = {"memberId" : memId, "deptId" : $(this).val()};
            $.ajax({
                url: "/inet/memberDept.do",
                type: "post",
                data: param,
                success: function(){
                	if(particular.val() == '')
                    	particular.parent("td").siblings("td.deptName").text('부서 미 배치');
                    else
                    	particular.parent("td").siblings("td.deptName").text(
                    		particular.find("option[value="+particular.val()+"]").text()
                    	);
                    particular.siblings("input[name=deptId]").val(particular.val());
                    alert("변경하였습니다.")
                },
                error: function(xhr, status, error){
                    alert("실패");
                }
            });
        }
        else{
        	if($(this).next("input[name=deptId]").val() == 'null')
        		$(this).val('').attr("selected", "selected");
        	else
        		$(this).val($(this).next("input[name=deptId]").val()).attr("selected", "selected");
        }
    })
}

function sorting(){
    $(".sortBtn").click(function(){
        var pageNum = 1;
        var idx = $(this).siblings("input").val() * -1;
        memInfoCall(pageNum, idx);
        $(this).siblings("input").val(idx);
        $(".sortBtn").each(function(){
            $(this).children("span.glyphicon").attr("class", "glyphicon glyphicon-sort");
        });
        if(idx > 0)
            $(this).children("span.glyphicon").attr("class", "glyphicon glyphicon-sort-by-attributes-alt");
        else
            $(this).children("span.glyphicon").attr("class", "glyphicon glyphicon-sort-by-attributes");
        $("input[name=sort]").val(idx);
        prevNext(pageNum);
    });
}

function memPaging(allCnt){
    var lastPageNum;
    var paging='';
    
    if(allCnt == 0)
        lastPageNum = 1
    else
        lastPageNum = Math.ceil(allCnt/5);
    for(var i=1; i <= lastPageNum; i++){
        if(i == $("input[name=pageNum]").val())
            paging+='<li class="active pageNm"><a href="javascript:void(0)">'+i+'</a></li>';
        else
            paging+='<li class="pageNm"><a href="javascript:void(0)">'+ i +'</a></li>';
    }
    paging+='<li><a href="javascript:void(0)">NEXT</a></li>';
    $(".pagination").append(paging);
}

function pagingFunc(){
    $("ul.pagination > li.pageNm").click(function(){
        var pageNum = $(this).children('a').text();
        var idx = 0;
        if($("input[name=sort]").val() != '')
        	idx = $("input[name=sort]").val();
        memInfoCall(pageNum, idx);
        prevNext(pageNum);
    })
    $(".pagination > li").first().click(function(){
    	if($(this).attr("class") != 'disabled'){
    		var pageNum = parseInt($("input[name=pageNum]").val()) - 1;
            var idx = 0;
            if($("input[name=sort]").val() != '')
            	idx = $("input[name=sort]").val();
            memInfoCall(pageNum, idx);
            prevNext(pageNum);
    	}
    })
    $(".pagination > li").last().click(function(){
    	if($(this).attr("class") != 'disabled'){
    		var pageNum = parseInt($("input[name=pageNum]").val()) + 1;
            var idx = 0;
            if($("input[name=sort]").val() != '')
            	idx = $("input[name=sort]").val();
            memInfoCall(pageNum, idx);
            prevNext(pageNum);
    	}
    })
}

function prevNext(pageNum){
    $("input[name=pageNum]").val(pageNum);
    $("ul.pagination > li.active").removeClass("active");
    $("ul.pagination > li").eq(pageNum).addClass("active");
    if(pageNum == 1){
    	if($(".pagination > li").length-2 == 1)
    		$("ul.pagination > li").last().addClass("disabled");
    	else
    		$("ul.pagination > li").last().removeClass("disabled");
    	$("ul.pagination > li").first().addClass("disabled");
    }
    else if(pageNum == $(".pagination > li").length-2){
    	$("ul.pagination > li").first().removeClass("disabled");
    	$("ul.pagination > li").last().addClass("disabled");
    }
    else{
        $("ul.pagination > li").first().removeClass("disabled");
        $("ul.pagination > li").last().removeClass("disabled");
    }
}